;By Barry Kauler 2001, 2002
;EVE.ASM --> EVE.EXE
;adapted from goosee.asm, May 16, 2001
;c:\2001\goosee_development\goosee_dev\, EVE is now in
;c:\2002\eve_dev\
;Win32 application written for masm 6.14
;links with eve_c.c.

;NOTES ON GCC--MASM
;------------------
;just to show how to call from gnu gcc ...
;here is an asm procedure...
;
;ASMPROC PROC PUBLIC USES eax ebx ecx edx esi edi ebp
; LOCAL dummy:DWORD
;
; ret
;ASMPROC ENDP
;
;it is by default STDCALL.
;in the c file, define this:
;
;extern void STDCALL ASMPROC(void);
;
;to call c function from asm file ...
; invoke demo1
;and define a prototype in eve.inc ...
; demo1 PROTO STDCALL

;put this into c file...
;
;void STDCALL demo1(void) {
;
; return;
; }
;
;for data in eve.asm, declare it public...
; PUBLIC highlightedindex
;
;In the .c file, declare it external...
; extern unsigned int highlightedindex;
;
;Note, both .c and .asm will export as "_highlightedindex",
;so they match.
;-----------------------------------

.486
.MODEL FLAT,STDCALL
		  option casemap :none	 ; case sensitive
UNICODE = 0
INCLUDE WIN32ML.INC

INCLUDE EVE.INC
INCLUDE ..\masm32\inc\winmm.inc
;include eve2.asm is at end of file.

.DATA
  BYTE 32 DUP(?)
DATASTART LABEL PTR NEAR

;these are the methods for each type of object...
;note "*" comment at end of row fully implemented ***NOTE***
ptrs   LABEL DWORD
pnode  DWORD paint_node,delete_any,drag_node,on_node,wipeslaves_node,snap_tonode ;*
; ...ellipse-element.
pact   DWORD paint_label,delete_any,drag_label, on_cmt,wipeslaves_node,snap_tonode ;*
; ...label-element
parc   DWORD paint_arc, delete_any, drag_arc , on_arc,	wipeslaves_gen , snap_toarc ;*
; ...open-elements (wires)
pexec  DWORD paint_info, delete_any,drag_node, on_any, wipeslaves_node, snap_tores
;  ; ...execution-icon	*NOTE1* old exec icons.
pinfo  DWORD paint_info, delete_any,drag_node, on_any, wipeslaves_node, snap_tores ;*
; ...all icons **NOTE** **NOW FOR ALL ICONS**
pres   DWORD paint_node,delete_any,drag_node,on_res,wipeslaves_node,snap_tores ;*
; ...rectangle-element, rounded-rectangle
ppoly	DWORD paint_node,delete_any,drag_poly,on_poly,wipeslaves_node,snap_topoly
; ...polygon
peve  DWORD paint_info, delete_any,drag_node, on_any, wipeslaves_node, snap_tores
;  ; ...eve-icon  *NOTE1* old eve icons.
pgrid  DWORD paint_grid, delete_any,drag_node, on_any, wipeslaves_node, snap_tonode ;v1.28.
; ...paper grid.
pani   DWORD paint_ani,delete_any,drag_node, on_any,wipeslaves_node,snap_tores ;*
; ...animation activator.
paxes  DWORD paint_axes, delete_any,drag_node, on_axes, wipeslaves_node, snap_tonode ;v1.97.
; ...alignment axes.
;*NOTE1* -- I'm not using these two rows, as have amalgamated all icons into
;"pinfo". however, cannot delete these lines, as it messes up the existing eve files.
;v1.29 ...careful, cannot delete or insert any lines, must add at end.

;these are the polymorphic method names...
pdisplay		EQU 0	; / paint current object.
pdelete 		EQU 4	; / delete current object.
pdrag			EQU 8	; / drag current object.
ponobject		EQU 12	; / test if mouse on current object.
pwipeslaves EQU 16		; / for white-out of current object.
psnap			EQU 20	;/		for snapping wire-end to current object.

instantiatedOBJECT		  OBJECT		<>		;instantiated single object, to copy.
instantiatedTERSEDATA TERSEDATA <>				;instantiate structure here, for
																								;copying to mem block.

pTERSEDATA		DWORD	0		;when a file is loaded, this will point to it.
		;(when i allocate memory and load a file, must store ptr to here).
		;(see wmcreate() and opendatafile() functions)
		;(also, when starting new default datafile, above TERSEDATA is
		; copied to memory block, and pTERSEDATA will point to it)
		;TERSEDATA.rpobjects has start OBJECTS database, relative to TERSEDATA.
		;The first ten objects are actually inside TERSEDATA, at end.
		;  ... i.e. OBJECTS is inside TERSEDATA.
		;All pointers in OBJECT are relative to start of OBJECTS.
		;The total size (TERSEDATA + extra objects) is tracked by g_ndatabasesize.


;--------------------------------------------------------------------------

g_hinst   DWORD 0
mainhwnd  DWORD 0
s1        WNDCLASS		 <?>
s2        MSG	 <?>
IFE fDEVELOPER
szTitleName  DB " EVE",0,0,0,0 ;Embedded Vector Editor",0  v3.01 2x32bits.
ELSE
szTitleName  DB " EVE Web Edition",0,0,0,0
ENDIF
szClassName  DB "EVE",0
sziconname	 DB "ICON_1",0,0			;name of icon in .RC file.

ALIGN 4 ;v3.24
g_hwnd	  DWORD 0				;handle for main window.

g_fhaschanged	BYTE 0	;=1 if datafile has changed. IDM_OPEN checks this.
g_nstate				DB 0					;0=normal start-up and running state.
g_nstateprev	BYTE 0	;previous state.
g_fclrhighlighted BYTE 0

;warning, these are absolute pointers. are invalid if GlobalRealloc().
;note also pointers in updates & wipeouts lists are invalid.
ALIGN 4 ;v3.24
g_pmovingobject   DWORD 0								;pts to moving object.
g_pselectedobjnew DWORD 0	;		calling GlobalRealloc() )
g_pselectedobject DWORD 0
;g_phighlightedobjectprev DWORD 0 ;previous highlighted, if any.
;see object.fconfig2/bit7, add2highlightedobject(), for multiple
;highlighted objects. this flag clears them all...
g_perrorobject	  DWORD 0
poldmovingobject DWORD 0 ;pmovingobject saved here. used to delete last
												;object, even though not selected.

g_nknee 		BYTE 0	;set by on_arc(), =1 mid, =2 knee2, =3 knee3 selected.
g_fredrawdiag			BYTE  0 		;flags for redrawing diagram.
;g2_fredrawdiag BYTE 0	;paint_*() funcs-->wmpaint() to reload g_fredrawdiag
WIPEOUTobjs EQU 1						; /
UPDATEobjs				   EQU 2				; /
ENTIRE			EQU 3			; /
META			EQU 4							; /

;for printing...
fprinting BYTE 0 ;=1 if outputing to printer, =2 emf, =3 clipboard, =0 screen
fnoprinter BYTE 0 ;=1 if no printer driver installed.
;szport 				BYTE 8	DUP(0)			  ;port (LPT1) <<<PROBABLY WON'T USE
;szdriver				 BYTE 16 DUP(0) 		   ;printer-driver name
;szname 				BYTE 32 DUP(0)			  ;printer name
ALIGN 4 ;v3.24
myprintdlg PRINTDLGA <(SIZEOF PRINTDLGA),0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0>

ctrlkey   DB 0					;=1 if control-key down when a node is selected.
g_fhack1   BYTE 0								;see WM_SYSCOMMAND and wmdestroy().
 BYTE 0,0

ALIGN 4 ;v3.24
g_naccelx		SDWORD 0		;higher magnitude (+ or -), faster scrolling.
g_naccely		 SDWORD 0		;/
clientrect RECT <>				 ;scrolling (actual region of diagram in window)
clientrectold RECT <>	;/(top,left always =0,0 bot,right =height,width)
  ;note, clientrect width/height will always track clientrectold.right/bot.
 ;i.e. the width/height always the same, but clientrect has varying top/left.
windowrect RECT <>		;used to clip cursor.

szascii1 DB 4 DUP(0)
szascii2 DB 4 DUP(0)
szascii3 DB 4 DUP(0)
sznull	DB 0,0
 BYTE 0,0

ALIGN 4 ;v3.24
g_nmousex SDWORD 0						   ;mouse coords, corrected for origin-shift.
g_nmousey SDWORD 0						   ;/
iiwparammouse SDWORD 0			;only valid when scrolling.
iilparammouse SDWORD 0	;/
g_xdiff   SDWORD 0				;when lbuttondown, difference between mouse pos.
g_ydiff   SDWORD 0				; and object coords.
g_fprintingnow	DB FALSE				;fixes a win95 printing problem
ftail BYTE 0
  BYTE 0,0

ALIGN 4 ;v3.24
g_hcrosshair  DWORD 0 ;handle for cross-hair cursor.
g_hnormcursor DWORD 0	 ;normal cursor.
g_hbusycursor DWORD 0 ;busy cursor.
g_hfingercursor DWORD 0 ;hand with finger cursor.
g_nring  DWORD 0		;on_node() returns which ring mousex/y is on.
g_nsnapring DWORD 0   ;non-0, snap_tonode() force mousex/y snap to ring.
g_xdiffnorm  SDWORD 0	;set by snap_ method, used for drawing arrows.
g_ydiffnorm  SDWORD 0	;/
g_hfontx1 DWORD 0
g_hfontcode DWORD 0 ;v3.25

g_hwhitebrush DWORD 0	;must be in this order...
g_hblackbrush DWORD 0	;/
g_hgraybrush  DWORD 0	;/
g_hstandardbrush DWORD 0 ;/

g_cstandardbrush DWORD 0 ;RGB color, not a handle, for standard window background.
;g_hcurrentbackbrush DWORD 0

xaccum	DWORD 0  ;v1.40 used in updateduplicates(),updatemove(), for "snap" drag.
yaccum	DWORD 0  ;/

szcommandline DB 256 DUP(0) ;used by WM_LBUTTONDBLCLK, to launch editor.

;.................
;ipicture interface...
IID_IPicture	DWORD 07bf80980h  ;unsigned long.
								WORD  0bf32h ;unsigned short.
								WORD  0101ah ;unsigned short
								BYTE 08bh,0bbh,0,0aah,0,030h,0ch,0abh ;unsigned char Data4[8];
;0x7bf80980,0xbf32,0x101a,0x8b,0xbb,0,0xaa,0,0x30,0xc,0xab

gpPicture		DWORD 0
E_POINTER		EQU 080000005h
E_NOINTERFACE  EQU 080000004h
E_OUTOFMEMORY  EQU 080000002h

;v2.90 methods for ipicture interface....
GPget_Handle              EQU 12
GPget_hPal                EQU 16
GPget_Type                EQU 20
GPget_Width               EQU 24
GPget_Height              EQU 28
GPRender                  EQU 32
GPset_hPal                EQU 36
GPget_CurDC               EQU 40
GPSelectPicture           EQU 44
GPget_KeepOriginalFormat  EQU 48
GPput_KeepOriginalFormat  EQU 52
GPPictureChanged          EQU 56
GPSaveAsFile              EQU 60
GPget_Attributes          EQU 64
;...............

eipsg DWORD 0
ncrashes DWORD 0
g_errorapi DWORD 0   ;v3.23

.CODE
;..................................................................
;v3.01 moved from .CONST...
;painting stuff...
szcouriernew					  DB "Courier New",0
;szcouriernewbold			  DB  "Courier New Bold",0
;szcouriernewitalic 	  DB  "Courier New Italic",0
;szcouriernewbolditalic DB  "Courier New Bold Italic",0
sztimesnewroman 				DB "Times New Roman",0
;sztimesnewromanbold    DB "Times New Roman Bold",0
;sztimesnewromanitalic	DB "Times New Roman Italic",0
;sztimesnewromanbolditalic	DB "Times New Roman Bold Italic",0
szarial 				        DB "Arial",0
szarialbold 	          DB "Arial Bold",0
;szarialitalic	        BYTE "Arial Italic",0
;szarialbolditalic		  DB "Arial Bold Italic",0

;v300b moved from data segment...
;....ERROR MESSAGES........(leave commented here)
;szer113 BYTE "The composite-object library member "
;        BYTE "that you have just selected has something wrong with it. EVE has "
;        BYTE "determined that the pointer to the object is invalid, and has aborted "
;        BYTE "the operation. It is recommended that you send this file to "
;        BYTE "the EVE developer. To recover from this situation, either go "
;        BYTE "back to a previously saved version that does not have this particular "
;        BYTE "library member, or go into the Toolbox and delete the entry from "
;        BYTE "the object library. COMMENT: There is a small possibility "
;        BYTE "that this error is somehow related to a particular version of Windows. "
;        BYTE "It is important to report this error to the EVE developer, with "
;        BYTE "the PC/system specifications.",0
szer114 BYTE "EVE was unable to read the clipboard. The context is that a menuitem "
  BYTE "in ""Control/Bind interface"" has been used to read a string from the "
  BYTE "clipboard, however it appears that another application, such as the "
  BYTE "one that posted the information to the clipboard, still has it open "
  BYTE "(for example, Multimedia Builder).",0
szer110  BYTE "Failed to import the graphic file.",0
szerprn  BYTE "The printer is not working. Exit EVE, fix the printer or the "
				 BYTE "printer driver, then restart EVE.",0
szerhi1 		BYTE "You have got to highlight some elements first. "
				BYTE "You highlight elements "
				BYTE "from the menu ""Control/Selection rectangle"" or "
				BYTE "manually by holding down the <shift> key and left-clicking "
				BYTE "on elements, or simply press the left button on a blank spot "
				BYTE "on the diagram and drag a selection rectangle.",0 ;error code =003, 004, 014
szer109 BYTE "You have tried to open either a file that is not a valid .EVE file, "
        BYTE "or an uncompressed .EVE file -- in the latter case, only an "
        BYTE "uncompressed file with database version of 11 can be opened, and "
        BYTE "this does not checkout. So, cannot open the file.",0
szer100 BYTE "Error opening file. Probably it doesn't exist.",0
;szer204 BYTE "Oh dear. EVE failed to resize a RAM block. Exiting from EVE.",0
szer207 BYTE "The .EVE data file you have just opened has failed EVE's "
        BYTE "integrity check. [1] Try save-as to a "
        BYTE "different name (EVE will run an integrity check and fixup when "
        BYTE "saving), or [2] tick the checkbox ""Save uncompressed"" in"
        BYTE " ""Control/EVE preferences..."" then save and reopen. [3] If EVE "
        BYTE "still gives this error "
        BYTE "message, only then hit the YES button below to send a bug report to me.",0
szerrget DB "You haven't opened a file. Keeping "
				DB "previously-opened file.",0
;        DB "(If extended error non-zero then this is a real error condition: "
;        DB "report to author and send file if possible)",0Dh,0Ah
;        DB "Extended error code: "
;szer005 DB "0           ",0         ;005
szerrnogoo DB "The file you have tried to open does not have the correct "
				DB "extension.",0				;error code =002
szer102 BYTE "The file you have opened is for a later version of EVE. Some "
        BYTE "features may be ignored.",0
szer200 BYTE "The file you have just opened cannot be read from. Closing file.",0
;szer202 BYTE "Oh dear. EVE Has opened data file, but cannot resize a RAM block "
;        BYTE "to hold it. Closing file. Recommend that you exit from EVE.",0
;szer205 BYTE "Oh dear. EVE failed to allocate a RAM block. Aborting operation.",0
;szer218 BYTE "EVE.EXE has an embedded EVE graphic file, however unable to read "
;        BYTE "it. Recommend exit from program.",0
;szer208 BYTE "EVE was unable to free a RAM memory block. Don't know the cause, "
;        BYTE "but it isn't good.",0
szer103 BYTE "Oops! The diagram that you are trying"
        BYTE "to import is too big to move. Please look at the User Manual for "
        BYTE "the limit on number of elements that can be highlighted (selected) "
        BYTE "-- note that the limit is an arbitrary restriction designed into "
        BYTE "EVE and can be increased if there is a demand by users to import "
        BYTE "larger diagrams. The import operation will go ahead, however "
        BYTE "not all of the imported diagram will be highlighted, meaning that "
        BYTE "you will not be able to move/duplicate/delete all of it. Right-click "
        BYTE "to cancel highlighting.",0
;szer203 BYTE "Oh dear. EVE cannot allocate a RAM block. "
;        BYTE "Exiting from EVE.",0
;szer217 BYTE "Error reading from EVE.EXE. Recommend exit from program.",0
;szer209 BYTE "EVE cannot add another element to database, as RAM block cannot be resized.",0
szer104 BYTE "Printer-to-screen scaling cannot be set properly. Printed output "
        BYTE "will be incorrect size.",0
szer210 BYTE "Cannot save datafile. Aborting Save.",0
;szer211 BYTE "EVE program error. Suggest exit.",0
szer9501 BYTE "The current version of EVE treats an EVE diagram "
				 BYTE "embedded inside an .EVE.EXE file as read-only. So, "
				 BYTE "you cannot save. You will have to choose ""Save as..."" "
				 BYTE "to save as a separate .EVE file, or ""Export as "
				 BYTE "EMBEDDED..."" to create a new .EVE.EXE embedded file.",0
;szer212 BYTE "EVE was unable to save the diagram.",0
szerrsave DB "WARNING ONLY. You haven't saved-as the file. Keeping "
				DB "previously-opened file.",0	  ;006
szer215 BYTE "Cannot find EVE.EXE on the hard disk. "
        BYTE "Where have you put it? What you need to do to fix this problem, "
        BYTE "is place a copy of EVE.EXE into C:\WINDOWS folder. Open Windows "
        BYTE "Explorer, find EVE.EXE, hold down the CONTROL key and drag a copy "
        BYTE "of EVE.EXE to C:\WINDOWS. "
        BYTE "An alternative to this is that you add the folder containing "
        BYTE "EVE.EXE in the PATH statement inside AUTOEXEC.BAT.",0
szer216 BYTE "Was unable to create the new ""filename.EVE.EXE"" embedded file.",0
szerremf BYTE "Selected save-as to .EMF/.WMF/.SVG file operation "
				DB "not completed. "
;        DB "(If extended error non-zero then this is a real error condition: "
;        DB "report to author and send file if possible)",0Dh,0Ah
;        DB "Extended error code: "
;szer007 DB "0           ",0         ;007
;szer213 BYTE "Failure to create the .EMF/.WMF file.",0
;szer214 BYTE "You have saved the .EMF/.WMF file ok, but somehow EVE has stuffed "
;        BYTE "up the current .EVE file. If already on disk, don't save -- save-as "
;        BYTE "if you must keep it. Try running ""Control/Database integrity "
;        BYTE "check"".",0
;szer225 BYTE "The .EMF/.WMF file was not saved. Also, EVE has stuffed up the "
;        BYTE "current .EVE file. Don't save the file -- save-as if you must "
;        BYTE "keep it. Try running ""Control/Database integrity check"".",0
szer008 BYTE "Sorry, you are not allowed to delete a ring if it has wires on it. "
        BYTE "Delete or move the wires first.",0
szer009 BYTE "You have entered a number that is too large. You can insert a ring "
        BYTE "after any existing ring, or delete any existing ring. The innermost "
        BYTE "ring is number 1, increasing outward.",0
szer010 BYTE "You are not allowed to delete ring number one. This is the innermost ring.",0
szer024  BYTE "Could not open external editor",0
szerimgs BYTE "Sorry, the picture is too big. Reduce it to under 64K",0
szer012  BYTE "You have not yet specified an external editor. Go to menu "
         BYTE """Control/EVE preferences..."" to choose the editor.",0
szer105  BYTE "Error opening text-file.",0
szer106  BYTE "Text buffer size exceeded. Label elements can only store a text "
         BYTE "string of 65,535 characters. You have entered more than this in "
         BYTE "the external editor. EVE is now forced to truncate the extra text. "
         BYTE "However, it is not lost -- at least not immediately -- "
         BYTE "open ""temp.txt"" immediately with your editor and save the extra "
         BYTE "text somewhere else.",0
szer026  BYTE "Bug when transferring file to EVE database. Please delete it (label/picture/etc).",0
szer025  BYTE "Picture imported early version of EVE, cannot open external paint editor.",0
szer018 BYTE "A composite-object must have a element of a closed type, that is, "
        BYTE "a ellipse, rectangle, polygon, or an open polyline (multi-segmented "
        BYTE "line) as the ""boss"" element. Your composite-object has an icon "
        BYTE "or sticky wire as boss element. One way to solve this problem "
        BYTE "is to substitute the wire for a polyline, or add an invisible "
        BYTE "rectangle or ellipse as boss. Refer to User Manual for further "
        BYTE "notes on this.",0
;szer013  BYTE "The database integrity check on the "
;         BYTE "currently open .EVE file has found one or more elements have "
;         BYTE "incorrect ""element number"" fields. EVE has now corrected "
;         BYTE "all the element numbers and it is recommended that you save the "
;         BYTE ".EVE file.",0
;szer107  BYTE "EVE has performed an ""integrity check"" of your diagram and has "
;         BYTE "found an ""unattached data-element"". What this means is that there "
;         BYTE "is some text/data stored in the diagram database, that does not "
;         BYTE "appear to have any purpose. This indicates a fault in EVE. "
;         BYTE "EVE has deleted the unattached data/text, so you can keep working, "
;         BYTE "however it is requested that you send the PREVIOUSLY SAVED version "
;         BYTE "of the .EVE data file along with a description of the fault, to "
;         BYTE "the EVE developer.",0
;szer108  BYTE "The problem is similar to error 107 above. EVE has verified all "
;         BYTE "address pointers in the .EVE data file and found one or more that "
;         BYTE "do not point to valid destinations. These pointers have been zeroised, "
;         BYTE "so you can keep working, however it indicates an error in the "
;         BYTE "EVE program. Action as per 107.",0
;szer112  BYTE "EVE has performed an ""integrity "
;         BYTE "check"" of your diagram and has found one or more corrupted "
;         BYTE "embedded files (such as a bitmap file). It has (or they have) been "
;         BYTE "deleted, which means that the numbering of embedded files in the "
;         BYTE "database has been compromised -- some icons for example may now "
;         BYTE "be displaying the wrong bitmap, or may do so in the future. Go into "
;         BYTE "all icon dialog boxes and press ""Apply"" button to verify "
;         BYTE "correct bitmap is attached to the icon. Otherwise, abandon this "
;         BYTE "EVE data file and go to a previously saved version. COMMENT "
;         BYTE "1: It is likely that EVE objected to the last or recent bitmap "
;         BYTE "file that you loaded for some reason. If you know which file it "
;         BYTE "was, don't use it -- send it to me. COMMENT 2: Future versions "
;         BYTE "of EVE may support embedded sound and/or text document files. This "
;         BYTE "error report does not determine which sort is corrupted.",0
;szer116 BYTE "EVE was experiencing problems with some "
;        BYTE "bitmap files getting corrupted when imported, for some versions "
;        BYTE "of Windows. EVE v1.23 has an extra integrity check, that verifies "
;        BYTE "the imported graphic is identical to the original file. If you get "
;        BYTE "this error, it means that the graphic image stored in the database "
;        BYTE "is corrupted somehow. Do not save the EVE data file, and send the "
;        BYTE "author an email, identifying the Windows version.<br> NOTE: this "
;        BYTE "problem seems to have been fixed, but I've left the verification "
;        BYTE "code in there as an extra precaution.",0
;szer219 BYTE "Picture error. Recommend discard current diagram",0
;szer226 BYTE "Failed to compact the database prior to saving. The current EVE "
;        BYTE "datafile is suspect; do not use it any more.",0
szer011 BYTE "You have selected an invalid owner element-number. Please enter a "
        BYTE "valid number in the ""Who owns me?"" edit box.",0
szer118 BYTE "Error exporting a bitmap file.",0    ;eve2.asm
szer002 BYTE "The file does not have the correct extension.",0  ;eve2.asm

;...SIMPLIFIED ERROR MESSAGES....
szer300 BYTE "Internal program error. Recommend discard current diagram.",0
szer301 BYTE "Internal program error. Recommend exit from EVE, do not save diagram.",0
szer302 BYTE "Error in current diagram. Recommend discard diagram, do not save.",0
szer304 BYTE "Internal program error. EVE will terminate.",0
szer305 BYTE "A database Integrity Check found and corrected errors.",0
szer306 BYTE "A database Integrity Check found errors. Recommend discard current diagram.",0
szer307 BYTE "File not saved.",0
szer212 EQU <szer307>
szer213 EQU <szer307>
szer107 EQU <szer305>
szer108 EQU <szer305>
szer013 EQU <szer305>
szer112 EQU <szer306>
szer116 EQU <szer306>
szer204 EQU <szer304>
szer203 EQU <szer304>
szer113 EQU <szer302>
szer225 EQU <szer302>
szer214 EQU <szer302>
szer219 EQU <szer302>
szer226 EQU <szer302>
szer202 EQU <szer301>
szer208 EQU <szer301>
szer217 EQU <szer301>
szer209 EQU <szer301>
szer211 EQU <szer301>
szer218 EQU <szer301>
szer205 EQU <szer300>
szfatalmess BYTE "A fatal error has occurred in the program. It will now terminate.",0

;..................................................................

start:

  ;v2.99
  ;i want to hook the fatal close of app...
  lea eax,final_handler
  ;mov g_errorapi,0A01h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23
  invoke SetUnhandledExceptionFilter,eax ;note, final_handler below.

  ;mov g_errorapi,0A02h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23
  invoke  GetModuleHandle, NULL
  mov			g_hinst, eax

  ;mov g_errorapi,0A03h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
  invoke GetCommandLine
  invoke lstrcpyn,ADDR szcommandline,eax,256

; initialize the WndClass structure
				mov s1.w_style, CS_HREDRAW OR CS_VREDRAW OR CS_DBLCLKS
				mov s1.w_lpfnWndProc, offset ASMWNDPROC
				mov s1.w_cbClsExtra, 0
				mov s1.w_cbWndExtra, 0

				mov eax, g_hinst
				mov s1.w_hInstance, eax

;  call LoadIcon, NULL, IDI_APPLICATION   ;loads default icon.
;let's load a custom icon....
				;mov eax,470 	;icon id in eve.rc
  ;mov g_errorapi,0A04h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
				invoke	LoadIcon, g_hinst, 470	;OFFSET sziconname
				mov s1.w_hIcon, eax

;; 191100
;;to be able to change cursors, think need to set this param to 0...
;;(also see further down)
  ;mov g_errorapi,0A05h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
				invoke	LoadCursor,NULL, IDC_ARROW
				mov s1.w_hCursor, eax
;				mov s1.w_hCursor,NULL
				mov g_hnormcursor,eax

  ;mov g_errorapi,0A06h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
				invoke GetSysColor,COLOR_WINDOW ;returns RGB for window background
				mov g_cstandardbrush,eax
  ;mov g_errorapi,0A07h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
				invoke GetSysColorBrush,COLOR_WINDOW ;returns brush for window background.
				mov g_hstandardbrush,eax
				;...note, not allowed to use a brush for a systems color to register
				;a window class, but can use the color-index, ex COLOR_WINDOW
				;(refer SetClassLongA() func)
  ;mov g_errorapi,0A08h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
				invoke GetStockObject, BLACK_BRUSH
				mov g_hblackbrush,eax
				invoke GetStockObject, LTGRAY_BRUSH   ;light grey.
				mov g_hgraybrush,eax
				invoke GetStockObject, WHITE_BRUSH
				mov g_hwhitebrush,eax
				mov s1.w_hbrBackground,eax ;COLOR_WINDOW + 1
				;...refer also to xpaint_wipeout() where I choose wipeout color,
				;and prefsproc() where I can change window background color.

				mov s1.w_lpszMenuName, OFFSET szClassName
				mov s1.w_lpszClassName, OFFSET szClassName

  ;mov g_errorapi,0A09h ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke RegisterClass, OFFSET s1
		test  eax,eax
		jz		  end_loop		;exit if eax=0.

  ;mov g_errorapi,0A0Ah ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke CreateWindowEx,0,OFFSET szClassName,OFFSET szTitleName, \
				WS_OVERLAPPEDWINDOW,5,5, \
				790,560, 0, 0, g_hinst, 0
				;note i had x/y = CW_USEDEFAULT & width/height =CW_USEDEFAULT,
				;i now have 5,5,790,560, was: 5,10,630,440
				test eax,eax
				jz		 end_loop				;exit if eax=0.
				mov mainhwnd, eax

  ;mov g_errorapi,0A0Bh ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke ShowWindow, mainhwnd,SW_SHOWNORMAL
  ;mov g_errorapi,0A0Ch ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke UpdateWindow, mainhwnd


; 191100
;load this also, for use later...
  ;mov g_errorapi,0A0Dh ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke LoadCursor, NULL,IDC_CROSS		;cross-hair.
		mov g_hcrosshair,eax
		invoke LoadCursor, NULL,IDC_WAIT	   ;hour-glass cursor.
		mov g_hbusycursor,eax
		;mov eax,473
		invoke LoadCursor,g_hinst,473 ;eax ;473 ;finger.cur in eve.rc IDC_HAND ;v2.82.
		mov g_hfingercursor,eax


msg_loop:
  ;mov g_errorapi,0A0Dh ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke GetMessage, OFFSET s2, 0,0,0
				or eax,eax ;cmp eax, 0
				je				end_loop
  ;mov g_errorapi,0A0Eh ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke TranslateMessage, OFFSET s2
		invoke DispatchMessage, OFFSET s2
				jmp msg_loop

end_loop:
  ;mov g_errorapi,0A0Fh ;for crash outside EVE, error codes range Axxh-Bxxh. v3.23.
		invoke ExitProcess, s2.ms_wParam

;-----------------------------------------------------------------------------
final_handler PROC STDCALL USES ebx esi edi, pexcept:DWORD ;v2.99 fatal error in app, comes here.
  ;LOCAL eaxs:DWORD,ebxs:DWORD,ecxs:DWORD,edxs:DWORD
  ;LOCAL esis:DWORD,edis:DWORD
  LOCAL errcode:DWORD
; "final_handler"
;note, must preserve ebx, esi edi.
  .IF ncrashes != 0 ;prevent multiple crash reports.
    jmp SHORT exh1
  .ENDIF
  inc ncrashes
    ;want to get registers out of pexcept structure...
    mov ebx,pexcept
    mov esi,(EXCEPTION_POINTERS PTR [ebx]).pExceptionRecord
    mov eax,(EXCEPTION_RECORD PTR [esi]).ExceptionCode
    add eax,0E00h ;myalertbox() needs high value for error code.
    and eax,0FFFh ;remove any high part. v3.23
    mov errcode,eax  ;note, errorcode may be 0-1FFh range, so adding E00h gives
        ;range of E00-FFFh.
      mov esi,(EXCEPTION_POINTERS PTR [ebx]).pContextRecord
      mov eax,(CONTEXT PTR [esi]).cx_Eip
      mov eipsg,eax ;global, read in myalertbox().
        ;have a problem with crashing outside EVE, in a win32 API func. v3.23
        ;i will assign the error code range A00h-BFFh for these...
        .IF DWORD PTR eipsg>430000h ;EVE code starts at 400000h
          mov eax,g_errorapi ;these have range A00-BFFh. v3.23
          mov errcode,eax
        .ENDIF
      ;these regs read inside myalertbox()...
      mov eax,(CONTEXT PTR [esi]).cx_Eax
      mov ebx,(CONTEXT PTR [esi]).cx_Ebx
      mov ecx,(CONTEXT PTR [esi]).cx_Ecx
      mov edx,(CONTEXT PTR [esi]).cx_Edx
      mov edi,(CONTEXT PTR [esi]).cx_Edi
      mov esi,(CONTEXT PTR [esi]).cx_Esi
  invoke myalertbox,ADDR szfatalmess,errcode ;pass exception code.
;  invoke MessageBox,0,ADDR szfatalmess,0,MB_OK
;  invoke ExitProcess,0
exh1:
  mov eax,1               ;=1 terminate process without showing system message box
  ret
final_handler ENDP

;-----------------------------------------------------------------------------
;created v1.18, but not using...
;.DATA
;szfinished BYTE "zyxwvutsrqponm",0 ;used to signal MMB finished painting.
;fsyncpaint BYTE 0										 ;/

.CODE
		PUBLIC ASMWNDPROC
ALIGN 4 ;v3.29
ASMWNDPROC PROC USES ebx edi esi,hwnd:DWORD,wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL fnobut:DWORD ;BYTE v3.29
		LOCAL ebxsave:DWORD ;v3.29

    mov ebxsave,ebx ;v3.29
    
		mov eax,hwnd					;useful to make this static.
		mov g_hwnd,eax
		mov fnobut,0
		mov ebx,pTERSEDATA
		or ebx,ebx ;cmp ebx,0				;pTERSEDATA initially 0. loaded by wmcreate().
		je notyet1
		mov eax,(TERSEDATA PTR [ebx]).feveprefs
		and al,010000b ;bit4=1, disable mouse buttons, except dbl-clk.
		.IF al==010000b
		  mov fnobut,1
		.ENDIF
notyet1:

				xor eax,eax
				mov ax,WORD PTR wmsg
				.IF ax==WM_DESTROY				;DestroyWindow() generates this.
          ;mov g_errorapi,0A11h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke wmdestroy, wmsg,wparam,lparam
				.ELSEIF ax==WM_SYSCOMMAND
				  ;i want to do default handling of this, except get an error
				  ;when closing the mem block when user selects close-box.
				  mov eax,wparam
				  and eax,0FFF0h								;see win32api docs.
				  .IF eax==SC_CLOSE
						;it seems that Windows has already destroyed the mem block
						;by time get to my wmdestroy() func.
						;therefore, set a flag...
						mov g_fhack1,1
						jmp def1
				  .ELSE
						jmp def1
				  .ENDIF
				.ELSEIF ax==WM_RBUTTONDOWN
				  .IF fnobut==0
						invoke wmrbuttondown, wmsg,wparam,lparam
				  .ENDIF
				.ELSEIF ax==WM_SIZE
				  invoke wmsize, wmsg,wparam,lparam
				.ELSEIF ax==WM_CREATE
				  invoke wmcreate, wmsg,wparam,lparam
				.ELSEIF ax==WM_LBUTTONDOWN
						invoke wmlbuttondown, wmsg,wparam,lparam
				.ELSEIF ax==WM_LBUTTONUP
						invoke wmlbuttonup, wmsg,wparam,lparam
				.ELSEIF ax==WM_MOUSEMOVE
						invoke wmmousemove, wmsg,wparam,lparam
				.ELSEIF ax==WM_RBUTTONUP
				  invoke wmrbuttonup
				.ELSEIF ax==WM_PAINT
				  invoke wmpaint, wmsg,wparam,lparam
;created v1.18, but not using...
;				   ;for signalling completion to MMB...
;				   .IF fsyncpaint==1 ;set by some IDM_BIND_ messages.
;						 invoke sendsignal2clip
;						 mov fsyncpaint,0
;				   .ENDIF
				.ELSEIF ax==WM_COMMAND
				  invoke wmcommand, wmsg,wparam,lparam
				.ELSEIF ax==(WM_USER+100h)
				  invoke xuser, wmsg,wparam,lparam
				.ELSEIF ax==(WM_USER+1+100h)
				  invoke xuser1, wmsg,wparam,lparam
				.ELSEIF ax==(WM_USER+2+100h)
				  invoke xuser2, wmsg,wparam,lparam
				.ELSEIF ax==(WM_USER+4+100h)
				  invoke xuser4, wmsg,wparam,lparam
				  
				.ELSEIF ax==WM_MENUSELECT ;v3.43
				  ;WORKS!!!
				  ;i was plagued, select pull down a menu, move to next, leaves wiped-out diag.
				  ;select a menu item, or mkae no selection (click elsewhere) leaves big hole
				  ;in diag. Now repaints...
				  ;problem though, this message arrives every time mouse goes onto a new menu
				  ;item. need to constrain... hi-word wparam=FFFFh and lparam=0 then have
				  ;clicked outside menu or pressed esc...
				  mov eax,wparam
				  shr eax,16
				  .IF eax==0FFFFh
				    .IF lparam==0
				      invoke InvalidateRgn, g_hwnd,0,FALSE
				      mov g_fredrawdiag,ENTIRE						   ;redraw entire window.
				    .ENDIF
				  .ENDIF
				  ;v3.43 allow windows to do default processing...
				  jmp SHORT def1  ;/
				  
				.ELSEIF ax==WM_SETFOCUS    ;this window has just got input focus.
          ;mov g_errorapi,0B5Ah ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				  invoke InvalidateRgn, g_hwnd,0,FALSE
				  mov g_fredrawdiag,ENTIRE						   ;redraw entire window.
				  ;;v3.43 allow windows to do default processing...
				  ;jmp SHORT def1  ;/
				.ELSEIF ax==WM_TIMER
				  invoke xtimer, wmsg,wparam,lparam				
				.ELSEIF ax==WM_LBUTTONDBLCLK
				  invoke xdblclk, wmsg,wparam,lparam
				.ELSEIF ax==WM_KEYDOWN
				  invoke  xkeydown, wmsg,wparam,lparam
				.ELSEIF ax==WM_KEYUP
				  invoke xkeyup, wmsg,wparam,lparam

				.ELSE
def1:
          ;mov g_errorapi,0A12h ;for crash outside EVE, error codes range Axxh. v3.23
          mov ebx,ebxsave ;v3.29
	        invoke DefWindowProc, hwnd,wmsg,wparam,lparam
				  jmp SHORT npo1 ;ret
				.ENDIF
				xor eax,eax
npo1:		ret
ASMWNDPROC ENDP
;-----------------------------------------------------------------------------
;-----------------------------------------------------------------------------
.DATA?
ALIGN 4 ;v3.24
szpathspeceveini BYTE 256 DUP(?) ;path/filename eve.ini.
szhomefolder     BYTE 256 DUP(?) ;path of currently opened eve file.
newpoint POINT <?,?>
szlastopen BYTE 256 DUP(?)

.DATA
ALIGN 4 ;v3.24
g_pshadowmem DWORD 0
fmovinghighlighted BYTE 0
fvartype		 BYTE 0
fdrawmargins BYTE 0
fsaving BYTE 0	;i'm using this as a generic flag, non0 xtimer() won't animate anything.
nnewwiretype WORD 0
  WORD 0
szeve	BYTE "EVE",0
ALIGN 4 ;v3.24
g_xdiagdelta DWORD 0
g_ydiagdelta DWORD 0
g_nx			 SDWORD 0 ;cords read from clipboard. also using for goto link.
g_ny			 SDWORD 0 ;/                            /
g_nh  SDWORD 0 ;coords, change from current position, used by goto link.  v3.10
g_nv  SDWORD 0 ;/
g_nt  DWORD  0 ;time for transition, used by goto link.(see parsegotolink())
g_xchange DWORD 0 ;v3.42
g_ychange DWORD 0 ;v3.42

.CODE
;v3.01 moved from .DATA...
szchanged  DB "The current diagram has changed. Do you want to save it?",0
szfsave1	 BYTE "Save of the current diagram was aborted. Do you want to "
			     BYTE "continue with opening a new .EVE file?",0
szfsave2	 BYTE "Save of the current diagram was aborted. Do you want to "
			     BYTE "continue with starting a new EVE diagram?",0
;....			
wmcommand PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL xobj:SDWORD,yobj:SDWORD
		LOCAL xdiagmid:DWORD,ydiagmid:DWORD,pobj:DWORD
		LOCAL hclip:DWORD,fyvalue:DWORD,pclip:DWORD
		LOCAL scrollrect:RECT, zoom:SDWORD
		LOCAL xfine:SDWORD,yfine:SDWORD
		LOCAL fhoriz:BYTE
;		 LOCAL hdc:DWORD,hpenwhite:DWORD,hpensaved:DWORD

    ;mov g_errorapi,0B5Dh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
    ;...not in front of an win32api func, but may come in here and return without
    ;calling an api, then die back in windows.
    
				mov ax,WORD PTR lparam
				.IF ax==0
				
				  ;;v3.43 try to fix diag not repainting when choose menu...
				  ;invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
				  ;mov g_fredrawdiag,ENTIRE								;redraw entire window.
				
				  mov  ax,WORD PTR wparam
				  .IF ax==IDM_QUIT
						mov fsaving,10 ;non0, stop animation. see xtimer().
  ;mov g_errorapi,0A13h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke DestroyWindow, g_hwnd			  ;exit EVE
						;NOTE this will post WM_DESTROY msg, which calls wmdestroy()
						;which closes things down and posts PostQuitMessage().

				  .ELSEIF ax==IDM_ABOUT
;						invoke MessageBox, g_hwnd, OFFSET szaboutstr, OFFSET sztitlestr, MB_OK
						  lea ecx,aboutproc
						  mov eax,100					 ;resource number in eve.rc
						  invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==IDM_ABOUTWE
;						invoke MessageBox, g_hwnd, OFFSET szaboutstr, OFFSET sztitlestr, MB_OK
						  lea ecx,aboutweproc
						  mov eax,404					 ;resource number in eve.rc
						  invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==IDM_OPEN
						mov fsaving,11 ;non0, stop animation. see xtimer().
						;first, save diagram if it has changed...
						.IF  g_fhaschanged==1
						  invoke myalertbox,ADDR szchanged,2
						  ;invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
						  .IF ax==IDYES
								invoke savedatafile
								.IF eax==1		;aborted save.
ww8:					    invoke myalertbox,ADDR szfsave1,2
                  ;invoke MessageBox,g_hwnd,ADDR szfsave1,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
								  .IF ax==IDYES
								  .ELSE
									jmp SHORT hr1	 ;ret ;abort opening file.
								  .ENDIF
								.ELSEIF eax==2 ;cancel save.
								  jmp ww8
								.ENDIF
						  .ENDIF
						.ENDIF
;						 mov szcommandline,0 ;cos wmcreate calls it with commandline tail
						invoke opendatafile ;/
						mov g_fhaschanged,0
hr1:					mov fsaving,0

				  .ELSEIF ax==IDM_LASTOPEN ;v1.39. see opendatafile(),wmcreate().
						mov fsaving,12 ;non0, stop animation. see xtimer().
						;first, save diagram if it has changed...
						.IF  g_fhaschanged==1
						  invoke myalertbox,ADDR szchanged,2
              ;invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
						  .IF ax==IDYES
								invoke savedatafile
								.IF eax==1		;aborted save.
mw8:					    invoke myalertbox,ADDR szfsave1,2
                  ;invoke MessageBox,g_hwnd,ADDR szfsave1,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
								  .IF ax==IDYES
								  .ELSE
									jmp hr2    ;ret ;abort opening file.
								  .ENDIF
								.ELSEIF eax==2 ;cancel save.
								  jmp mw8
								.ENDIF
						  .ENDIF
						.ENDIF
					  lea ebx,szfile
					  invoke lstrcpy,ebx,ADDR szlastopen
					  mov ftail,2 ;opendatafile() recognises filespec already in szfile.
						invoke opendatafile
						mov g_fhaschanged,0
						mov ftail,0
hr2:				  mov fsaving,0

				  .ELSEIF ax==IDM_SAVE
						mov fsaving,1 ;referenced in xtimer() to disable animation.
						invoke savedatafile
						mov g_fhaschanged,0
						mov fsaving,0
					  ;v1.72 diag blank after save...
            ;mov g_errorapi,0A14h ;for crash outside EVE, error codes range Axxh. v3.23
					  invoke InvalidateRgn,g_hwnd,0,FALSE ;don't redraw background.
					  mov g_fredrawdiag,ENTIRE			;redraw entire window.
				  .ELSEIF ax==IDM_SAVEAS
						mov fsaving,2
						invoke saveasdatafile
						mov g_fhaschanged,0
						mov fsaving,0

				  .ELSEIF ax==IDM_NEW
					mov fsaving,6 ;non0, prevent xtimer() from doing animations.
					invoke add2anilist,0 ;wipe all entries.
					;first, save diagram if it has changed...
					.IF  g_fhaschanged==1
					  invoke myalertbox,ADDR szchanged,2
            ;invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
					  .IF ax==IDYES
						  invoke savedatafile
						  .IF eax==1		;aborted save.
ww8x:					  invoke myalertbox,ADDR szfsave2,2
                ;invoke MessageBox,g_hwnd,ADDR szfsave2,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
						    .IF ax==IDYES
						    .ELSE
							    jmp SHORT hr3 ;ret ;abort opening file.
						    .ENDIF
						  .ELSEIF eax==2 ;cancel save.
						    jmp ww8x
						  .ENDIF
					  .ENDIF
					.ENDIF
;						 mov szcommandline,0 ;cos wmcreate calls it with commandline tail
					invoke newdatafile
					mov g_fhaschanged,0
hr3:			mov fsaving,0


				  .ELSEIF ax==IDM_EMBEDDED ;save as embedded inside eve.exe.
						mov fsaving,3 ;referenced in xtimer().
						invoke saveasembedded
						mov g_fhaschanged,0
						mov fsaving,0

				  .ELSEIF ax==IDM_SAVEASS		;save-as selected elements.
						;duplicate part of a diagram...
						.IF highlightedindex==0
								;error...
								invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,004
						.ELSE
						  mov fsaving,4
						  invoke selectedsaveasdatafile
						  mov fsaving,0
						.ENDIF

				  .ELSEIF ax==IDM_SAVEASS_EMF	;save-as selected elements to EMF.
						mov eax,0
w11:					.IF highlightedindex==0
								;error...
								invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,004
						.ELSE
						  mov fprinting,2 ;=0 screen, =1 printer, =2 emf, =3 clipboard
						  ;note non0 also disables animation in xtimer() (also fsaving).
						  invoke selectedsaveasemf,eax ;=0 emf, =1 wmf.
						  mov fprinting,0
						.ENDIF

          ;v2.65 have dosabled this menu choice...
				  ;.ELSEIF ax==IDM_SAVEASS_WMF  ;save selected elements as WMF file.
					;	mov eax,1
					;	jmp w11

				  .ELSEIF ax==IDM_SAVEASS_SVG
						.IF highlightedindex==0
						  invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,004
						.ELSE
						  IFE fDEVELOPER
				   ;invoke MessageBox,g_hwnd,ADDR sznotDE,ADDR szeve,MB_OK+MB_ICONEXCLAMATION
						  ELSE
							  mov fsaving,5 ;note other exports use fprinting non-0. see xtimer().
							  ;put up "svg configuration" dialog box...
ss1:					  lea ecx,svgproc 		;eve2.asm
							  mov eax,400 			;resource number in eve.rc
							  invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
							  .IF eax==0 ;svgproc() clrs this if ok.
							    invoke selectedsaveassvg,3 ;eve2.asm
							    ;here also, if cancelled save, need to...
							    .IF eax==0 ;cancelled.
								    jmp do5
							    .ENDIF
							  .ELSE
							    ;cancelled save, but still need to truncate
							    ;elements that were copied to end database...
do5:						  invoke selectedsaveassvg,5
							  .ENDIF
							  mov fdontmoveduplicates,0 ;set inside selectedsaveassvg().
							  ;(=1 used in wmmousemove() to ignore highlighlightednewlist contents).
							  mov fsaving,0
						  ENDIF
						.ENDIF

          .ELSEIF ax==IDM_SAVEASALLSVG ;v3.07 export all to SVG.
            ;export the entire diagram...
						IFE fDEVELOPER
						ELSE
						  mov fsaving,19 ;reference this in selectedsaveassvg().
						  ;select all elements...
              invoke zeroabsoluteptrs,1 ;wipes all ptrs, state=0.
              mov n1stx,-15000 ;selection rectangle over all of diagram.
              mov n1sty,-15000 ;/
              mov n2ndx,15000  ;/
              mov n2ndy,15000  ;/
              invoke highlightinsiderect ;every element into highlighted list.
              invoke calcboundingrecthi  ;calc actual bounding rectangle.	
						  jmp ss1
            ENDIF
          
				  .ELSEIF ax==IDM_NODE			   ;*EVE* ellipse.
				    mov fvartype,0
					  ;v1.23
					  ;note, createnewobject() will just return if state<>0.
nx1:			  invoke createnewobject,0 ;1 ;returns eax=0 no obj created
								;param =1 means always create at end of database.
					  .IF eax==0
					  .ELSE
					    ;createnewobject() clears all pointers, except in these lists,
					    ;so do it here as precaution...
					    mov highlightedindex,0
					    mov highlightedindexnewlist,0
								;eax points to the new object.
								mov g_pmovingobject,eax ;used for placing the object.
								;customise to a node...
								invoke defaultnewnode, eax
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								mov g_nstate,4					;placing new object, first end.
					  .ENDIF
					
					.ELSEIF ax==IDM_NODEP ;ellipse, partial. v2.96.
					  mov fvartype,255
					  jmp nx1
					
          .ELSEIF ax==IDM_LINK ;link activator v2.76.
            mov fvartype,41
            jmp SHORT e66
					
          .ELSEIF ax==IDM_INLINE ;inline SVG code. v3.25.
            mov fvartype,42
            jmp SHORT e66

				  .ELSEIF ax==IDM_COMMANDICON	;execution icon *EVE*
						jmp SHORT e66

				  .ELSEIF ax==IDM_INFOICON				;text-file icon  *EVE*
e66:				;v1.23
					;note, createnewobject() will just return if state<>0.
					invoke createnewobject,0		;returns eax=0 no obj created
					.IF eax==0
					.ELSE
					  ;createnewobject() clears all pointers, except in these lists,
					  ;so do it here as precaution...
					  mov highlightedindex,0
					  mov highlightedindexnewlist,0
								;eax points to the new object.
								mov esi,eax
								;EVE... need data-element to hold the text...
								  ;v1.23 ptr in esi may get invalidated...
								  sub esi,pTERSEDATA ;convert to relative ptr.
								invoke createnewobject,0
								  add esi,pTERSEDATA
								.IF eax==0
								  mov (OBJECT PTR [esi]).fstatus,0
								.ELSE
								  mov ebx,eax											 ;tell data-element
								  mov eax,esi											 ; /where parent
								  sub eax,pTERSEDATA							 ; /is
								  mov (OBJECT PTR [ebx]).rpowner1,eax ; /
								  xor eax,eax
								  mov (OBJECT PTR [ebx]).number,eax ;cos createnewobject setit.
								  mov (OBJECT PTR [ebx]).rpowner2,eax  ;precaution.
								  mov (OBJECT PTR [ebx]).ximage,eax   ;/
								  mov (OBJECT PTR [ebx]).rpmethods,eax ;/ start of data area.
								  mov (OBJECT PTR [ebx]).nrings,eax ;=1 in instantiatedOBJECT.
								  mov (OBJECT PTR [ebx]).nbeginring,eax ;/
								  mov (OBJECT PTR [ebx]).nendring,eax ;/
								  mov (OBJECT PTR [ebx]).nexttype,-1 ;data-element.
								  mov eax,ebx											 ;tell parent
								  sub eax,pTERSEDATA							 ; /where data-element
								  mov (OBJECT PTR [esi]).rpdata,eax  ; /is.
								  ;type of attached data....
								  mov (OBJECT PTR [esi]).xdata,0		 ;(I'm not using this info).
								  ;customise ...
								  mov g_pmovingobject,esi				;used for placing the object.
								  .IF WORD PTR wparam==IDM_INFOICON
def1:								invoke defaultnewinfo,esi
								  .ELSEIF WORD PTR wparam==IDM_EVEICON
										invoke defaultneweve,esi
								  .ELSEIF WORD PTR wparam==IDM_COMMANDICON
										invoke defaultnewcommand,esi
								  .ELSEIF WORD PTR wparam==IDM_GENERICICON
										invoke defaultnewgeneric,esi
								  .ELSEIF WORD PTR wparam==IDM_SOUNDICON
										invoke defaultnewsound,esi
								  .ELSEIF WORD PTR wparam==IDM_WWWICON
										invoke defaultnewwww,esi
									.ELSEIF WORD PTR wparam==IDM_LINK ;v2.76.
                    invoke defaultnewres,esi	
									.ELSEIF WORD PTR wparam==IDM_INLINE ;v3.25
                    invoke defaultnewres,esi	
								  .ELSE
										jmp def1
								  .ENDIF
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,4								;placing new object, first end.
								.ENDIF
					.ENDIF

				  .ELSEIF ax==IDM_EVEICON		   ;EVE icon.
						jmp e66
				  .ELSEIF ax==IDM_GENERICICON  ;generic icon.
						jmp e66
				  .ELSEIF ax==IDM_SOUNDICON    ;sound icon.
						jmp e66
				  .ELSEIF ax==IDM_WWWICON	 ;WWW icon.
						jmp e66

				  .ELSEIF ax==IDM_BITMAP ;choose a bitmap and load into "bitmap library".
						invoke insertbitmap
						mov g_fhaschanged,1
						.IF eax==0
						  invoke myalertbox,ADDR szer110,4 ;invoke myerrorhandler,110
						.ENDIF

				  ;*EVE* now rectangle-element...
				  .ELSEIF ax==IDM_RES
					mov fvartype,3	;.nexttype=3
uu1:				;v1.23
					;note, createnewobject() will just return if state<>0.
					invoke createnewobject,0		;returns eax=0 no obj created
					;param=0 means can create anywhere in databse vacant place.
					.IF eax==0
					.ELSE
					  ;createnewobject() clears all pointers, except in these lists,
					  ;so do it here as precaution...
					  mov highlightedindex,0
					  mov highlightedindexnewlist,0
						  ;eax points to the new object.
						  mov g_pmovingobject,eax ;used for placing the object.
						  mov esi,eax

						  ;v2.02
						  .IF fvartype==5 ;polygon.
tee5:						;create an attached data-element, to hold control-points...
								sub esi,pTERSEDATA ;ptr in esi may get invalidated.
								invoke createnewobject,0
								add esi,pTERSEDATA
								mov g_pmovingobject,esi ;fixed.
								.IF eax==0
								.ELSE
								  mov ebx,eax			   ;tell data-element
								  mov eax,esi			   ; /where parent
								  sub eax,pTERSEDATA	   ; /is
								  mov (OBJECT PTR [ebx]).rpowner1,eax ; /
								  xor eax,eax
								  mov (OBJECT PTR [ebx]).rpowner2,eax ;precaution.
								  mov (OBJECT PTR [ebx]).ximage,eax  ;/
								  mov (OBJECT PTR [ebx]).number,eax ;cos createnewobject setit.
								  mov (OBJECT PTR [ebx]).rpmethods,eax ;/start of data area.
								  mov (OBJECT PTR [ebx]).nrings,eax ;=1 in instantiatedOBJECT.
								  mov (OBJECT PTR [ebx]).nbeginring,eax ;/
								  mov (OBJECT PTR [ebx]).nendring,eax ;/
								  mov (OBJECT PTR [ebx]).nexttype,-1 ;data-element.
								  mov eax,ebx			   ;tell parent
								  sub eax,pTERSEDATA	   ; /where data-element
								  mov (OBJECT PTR [esi]).rpdata,eax  ; /is.
								  ;type of attached data...
								  mov (OBJECT PTR [esi]).xdata,0		 ;not used here.
								.ENDIF
						  .ELSEIF fvartype==6 ;polyline, multisegment.
							jmp tee5
						  .ELSEIF fvartype==7 ;polyline, bezier.
							jmp tee5
						  .ENDIF

						  ;customise to a resource...
						  invoke defaultnewres, esi
						  mov al,g_nstate		   ;/
						  mov g_nstateprev,al  ;/
						  mov g_nstate,4				  ;placing new object, first end.
					.ENDIF

				  .ELSEIF ax==IDM_RESR			;*EVE* rectangle,rounded.
						mov fvartype,4
						jmp uu1

				  .ELSEIF ax==IDM_MULTI ;polyline,multi-segment.
						;type=6 temporarily. becomes =5 inside defaultnewres().
						mov fvartype,6
						jmp uu1

				  .ELSEIF ax==IDM_POLY	;polygon
						mov fvartype,5
						jmp uu1

				  .ELSEIF ax==IDM_BEZIER ;polyline,bezier multi-segment.
						;type=7 temporarily. becomes =5 inside defaultnewres().
						mov fvartype,7
						jmp uu1

				  .ELSEIF ax==IDM_ACTIVA ;v1.59 animation activator.
						mov fvartype,40
						jmp uu1

				  .ELSEIF ax==IDM_label ;*EVE* label-element.
					;v1.23
					;note, createnewobject() will just return if state<>0.
					invoke createnewobject,0 ;1 ;returns eax=0 no obj created
						  ;param=1 always create at end of databse.
					.IF eax==0
					.ELSE
					  ;createnewobject() clears all pointers, except in these lists,
					  ;so do it here as precaution...
					  mov highlightedindex,0
					  mov highlightedindexnewlist,0
								;eax points to the new object.
								mov esi,eax
								;EVE... need data-element to hold the text...
								  sub esi,pTERSEDATA ;v1.23 ptr in esi may get invalidated.
								invoke createnewobject,0
								  add esi,pTERSEDATA
								.IF eax==0
								  mov (OBJECT PTR [esi]).fstatus,0
								.ELSE
								  mov ebx,eax						 ;tell data-element
								  mov eax,esi						 ; /where parent
								  sub eax,pTERSEDATA				 ; /is
								  mov (OBJECT PTR [ebx]).rpowner1,eax ; /
								  xor eax,eax
								  mov (OBJECT PTR [ebx]).number,eax ;cos createnewobject setit.
								  mov (OBJECT PTR [ebx]).rpowner2,eax ;precaution.
								  mov (OBJECT PTR [ebx]).ximage,eax  ;/
								  mov (OBJECT PTR [ebx]).rpmethods,eax ;/ start of data area.
								  mov (OBJECT PTR [ebx]).nrings,eax ;=1 in instantiatedOBJECT.
								  mov (OBJECT PTR [ebx]).nbeginring,eax ;/
								  mov (OBJECT PTR [ebx]).nendring,eax ;/
								  mov (OBJECT PTR [ebx]).nexttype,-1 ;data-element.
								  mov eax,ebx											 ;tell parent
								  sub eax,pTERSEDATA							 ; /where data-element
								  mov (OBJECT PTR [esi]).rpdata,eax  ; /is.
								  ;type of attached data...
								  mov (OBJECT PTR [esi]).xdata,0		 ;(I'm not using this).
								  ;customise ...
								  mov g_pmovingobject,esi				;used for placing the object.
								  invoke defaultnewlabel,esi
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,4								;placing new object, first end.
								.ENDIF
					.ENDIF

				  .ELSEIF ax==IDM_UVECTOR ;disabled auto-stickiness, straight line. v2.27.
						mov nnewwiretype,130 ;temp, really 13.
						jmp SHORT w10
				  .ELSEIF ax==IDM_VECTOR  ;straight line.
						mov nnewwiretype,13
						jmp SHORT w10
				  .ELSEIF ax==IDM_WIRE			;segmented line.
						mov nnewwiretype,12
						jmp SHORT w10
				  .ELSEIF ax==IDM_SYNC2 				;*EVE*
						mov nnewwiretype,11 	;curved line.
w10:				;v1.23
					;note, createnewobject() will just return if state<>0.
					invoke createnewobject,0 ;1 ;returns eax=0 no obj created
						 ;...param=1 create at end database.
					.IF eax==0
					.ELSE
					  ;createnewobject() clears all pointers, except in these lists,
					  ;so do it here as precaution...
					  mov highlightedindex,0
					  mov highlightedindexnewlist,0
								;eax points to the new object.
								mov g_pmovingobject,eax ;used for placing the object.
								;customise to a resource...
								invoke defaultnewwire, eax
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								mov g_nstate,4					;placing new object, first end.
					.ENDIF

				  .ELSEIF ax==IDM_ERASEDIA		;erase diagram.
						mov fsaving,7 ;non0 prevents xtimer() from doing animations.
						invoke erasediagram
						mov fsaving,0
				  .ELSEIF ax==IDM_TEMPLATE
						mov fsaving,8 ;non0 prevents xtimer() from doing animations.
						invoke opentemplate   ;apply a template to current database.
						mov fsaving,0
				  .ELSEIF ax==IDM_MERGE
						mov fsaving,9 ;non0 prevents xtimer() from doing animations.
						invoke openmerge		;merge another diagram.
						mov fsaving,0
				  .ELSEIF ax==IDM_ORIGIN  ;restore origin to top/left client area.
hz5:				invoke xorigin
				  .ELSEIF ax==IDM_ZOOMOUT
hz8:					mov esi,pTERSEDATA
						mov eax,(TERSEDATA PTR [esi]).nzoom
						.IF al==6				;max zoom out.
						.ELSE
						  mov edx,(TERSEDATA PTR [esi]).nzoom
						  invoke calcdiagmidwindow,edx ;returns coords in eax/ecx.
						  mov xobj,eax
						  mov yobj,ecx
						  inc (TERSEDATA PTR [esi]).nzoom
zoo1:					  ;keep current centre of diag in centre...
						  mov edx,(TERSEDATA PTR [esi]).nzoom
						  invoke centralizeobj,xobj,yobj,edx,1 ;1=always keep in middle.
  ;mov g_errorapi,0A15h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn,g_hwnd,0,TRUE ;invalidate entire window.
						  mov g_fredrawdiag,ENTIRE			 ;redraw entire window.
						.ENDIF
				  .ELSEIF ax==IDM_ZOOMNORM
hz7:					  mov esi,pTERSEDATA
						  mov edx,(TERSEDATA PTR [esi]).nzoom
						  invoke calcdiagmidwindow,edx ;returns coords in eax/ecx.
						  mov xobj,eax
						  mov yobj,ecx
						mov (TERSEDATA PTR [esi]).nzoom,0
						jmp zoo1
				  .ELSEIF ax==IDM_ZOOMIN
hz9:					mov esi,pTERSEDATA
						mov edx,(TERSEDATA PTR [esi]).nzoom
						.IF dl==-4 ;max zoom-in.  v1.39
						.ELSE
						  invoke calcdiagmidwindow,edx ;returns coords in eax/ecx.
						  mov xobj,eax
						  mov yobj,ecx
						  dec (TERSEDATA PTR [esi]).nzoom
						  jmp zoo1
						.ENDIF

				  .ELSEIF ax==IDM_PSET	;printer setup.
						;just display a printer setup dialog box...
						invoke myprintersetup

				  .ELSEIF ax==IDM_PRA	;print
;						mov g_fprintdiag,3
;						invoke InvalidateRgn, g_hwnd,0,FALSE
						.IF fnoprinter==0

								;v1.38
								mov esi,pTERSEDATA
								mov eax,(TERSEDATA PTR [esi]).xfineprn
								mov xfine,eax
								mov eax,(TERSEDATA PTR [esi]).yfineprn
								mov yfine,eax
						  ;v1.30
						  ;if grid-element highlighted, scroll diagram so bottom/right
						  ;of grid-element (top/left of actual grid) is in top/left
						  ;of window, and normal zoom...
						  .IF g_nstate==2 ;an element is highlighted.
							  mov ebx,g_pselectedobject
							  .IF ebx != 0
							    mov eax,(OBJECT PTR [ebx]).nexttype
							    .IF eax==20 ;grid element.
								    mov esi,pTERSEDATA
								    mov eax,(OBJECT PTR [ebx]).fconfig3
								    and al,0111000b ;bits 3/4/5. zoom calibration.
								    .IF al==0 ;normal zoom.
								      mov ecx,0
								    .ELSEIF al==001000b ;out1.
								      mov ecx,1
								    .ELSEIF al==010000b ;out2.
								      mov ecx,2
								    .ELSEIF al==011000b ;in1.
								      mov ecx,-1
								    .ELSE ;in2.
								      mov ecx,-2
								    .ENDIF
								    mov (TERSEDATA PTR [esi]).nzoom,ecx ;0
								    mov zoom,ecx

								    mov eax,(OBJECT PTR [ebx]).xtopleft
								    add eax,(OBJECT PTR [ebx]).wwidth
								    mov ecx,(OBJECT PTR [ebx]).ytopleft
								    add ecx,(OBJECT PTR [ebx]).height
								    mov edx,clientrect.rc_right
								    sub edx,clientrect.rc_left ;width.
								    mov clientrect.rc_left,eax
								    mov clientrect.rc_right,eax
								    add clientrect.rc_right,edx
								    mov edx,clientrect.rc_bottom
								    sub edx,clientrect.rc_top ;height.
								    mov clientrect.rc_top,ecx
								    mov clientrect.rc_bottom,ecx
								    add clientrect.rc_bottom,edx

								    ;wmpaint(0 and xpaint_print() don't align rc_left/
								    ;rc_top with top corner of window when zoomed in or out.
								    ;(cos of very peculiar use of SetViewPortOrgEx()).
								    ;so, let's try and fix it here...
								    mov eax,clientrect.rc_left
								    mov edx,clientrect.rc_top
								    mov ecx,zoom
								    .IF SDWORD PTR ecx<0
								      neg ecx
								      sal eax,cl
								      sal edx,cl
								    .ELSE
								      sar eax,cl
								      sar edx,cl
								    .ENDIF
								    mov ecx,eax
								    sub ecx,clientrect.rc_left
								    add clientrect.rc_left,ecx
								    add clientrect.rc_right,ecx
								    mov ecx,edx
								    sub ecx,clientrect.rc_top
								    add clientrect.rc_top,ecx
								    add clientrect.rc_bottom,ecx
								    ;...amazing, this works!

								    ;v1.38
								    mov eax,(OBJECT PTR [ebx]).bez2x ;"xfineprn" fine-tune.
								    mov (TERSEDATA PTR [esi]).xfineprn,eax
								    mov eax,(OBJECT PTR [ebx]).bez2y ;"yfineprn" fine-tune.
								    mov (TERSEDATA PTR [esi]).yfineprn,eax

							    .ENDIF
							  .ENDIF
						  .ENDIF

						  mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0
						    ;mov g_fprintingnow,TRUE  ;tested at entry to wmpaint(), non0; ret.
						    ;...this is in wrong place. v3.34
						    ;v3.34 bug, yes/no msgbox invisible when diag has an animation activ.
						    ;in it. xpaint_print() first puts up a yes/no box, but ani.activ.
						    ;needs to paint immediately via updatewindow(), but it gets blocked.
						    ;so, "mov g_fprintingnow,TRUE" into xpaint_print()...
;						  mov			g_fredrawdiag,ENTIRE
						  mov fprinting,1 ;=0 screen, =1 printer, =2 emf, =3 clipboard
						  ;note, also stops animation in xtimer() (also fsaving non0).
						  invoke xpaint_print
						  mov fprinting,0
              ;mov g_errorapi,0A16h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke PostMessage, g_hwnd,WM_USER+4+100h,0,0 		;delay repaint.
						  mov g_fredrawdiag,0
						  ;mov g_fprintdiag,0
						  mov g_fprintingnow,FALSE
								;v1.38
								mov eax,xfine
								mov (TERSEDATA PTR [esi]).xfineprn,eax
								mov eax,yfine
								mov (TERSEDATA PTR [esi]).yfineprn,eax

						.ELSE
						  ;wmcreate()-->printeranalysis() determined no printer driver
						  ;or printer misfunctional.
						  invoke myalertbox,ADDR szerprn,4 ;invoke myerrorhandler,020
						.ENDIF

				  .ELSEIF ax==IDM_CPY	;copy diagram to clipboard.
						mov fprinting,3 ;=0 screen, =1 printer, =2 emf, =3 clipboard
						;...>0 tells paint_ methods not to display any handles.
						;..and stops animation in xtimer().
						mov g_fredrawdiag,ENTIRE
  ;mov g_errorapi,0A17h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn,g_hwnd,0,TRUE ;invalidate entire window.
  ;mov g_errorapi,0A18h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke UpdateWindow,g_hwnd ;do it now, no handles.
						mov fprinting,0
						invoke shoot

				  .ELSEIF ax==IDM_PROJECT ;Project management dialog.
						lea ecx,PROJECTproc
						mov eax,201 ;resource number of PROJECT dialog in eve.rc.
						invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==IDM_PREFS ;EVE preferences dialog.
						lea ecx,PREFSproc
						mov eax,212 ;resource number of PREFS dialog in eve.rc.
						invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==IDM_TOOLBOX ;low-level database tools dialog.
            invoke SetCurrentDirectory,ADDR szhomefolder ;v3.48
            ;...as may load BMP checkmark files, same folder as currently open .eve.
						lea ecx,toolboxproc
						mov eax,213 ;resource number of PREFS dialog in eve.rc.
						invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==IDM_INTEGRITY
						;check integrity of entire current .eve database.
						invoke checkintegrity,0 ;param=0 display all msgs.

				  .ELSEIF ax==IDM_DUP
						;duplicate part of a diagram...
						.IF highlightedindex==0
								.IF g_pselectedobject==0
								  ;error...
								  invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,003
								.ELSE
								  ;note when highlight elements with <shift> held down,
								  ;they go into higlightedlist. but if click on one
								  ;element without <shift> held down it goes into
								  ;g_pselectedobject. so, here we shift it into
								  ;highlightedlist...
								  invoke add2highlightedlist,g_pselectedobject
								  mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,0 ;needed by wmmousemove which calls
								  jmp doit1  ; updateduplicates().
								.ENDIF
						.ELSE
doit1:			  ;need to move the mouse-cursor...
						  mov eax,highlightedlist  ;1st highlighted element
						  invoke repositioncursor,eax
						  ;duplicate and track mouse...
						  xor eax,eax
						  mov xaccum,eax ;v1.40 updateduplicates/updatemove use this.
						  mov yaccum,eax ;/
						  invoke duplicatehighlighted,0
					   ;...actual tracking occurs in wmmousemove(),using highlightednewlist.
						.ENDIF

				  .ELSEIF ax==IDM_RESIZESEL ;resize selected elements.
						.IF highlightedindex==0
								.IF g_pselectedobject==0
								  ;error...
								  invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,003
								.ELSE
								  ;puts slaves as well into list...
								  invoke add2highlightedlist,g_pselectedobject
								  mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,0 ;needed by wmmousemove which calls
								  jmp xdoit1  ; updateduplicates().
								.ENDIF
						.ELSE
xdoit1: 				  .IF g_pshadowmem==0 ;so can't do it more than once.
it00:						invoke shadowhighlighted
							;...creates a mem block and copies highlighted elements toit.
							;DON'T FORGET TO REMOVE IT LATER!!!!
							.IF eax==0 ;failed to copy anything.
							  mov highlightedindex,0
							  jmp xgo1x
							.ELSE ;eax=addr of mem block.
							  mov g_pshadowmem,eax
							.ENDIF
						  .ELSE
							;this is a precaution. it already exists, but just in case it's a
							;shadow of some other elements, or maybe a snapshot of earlier
							;arrangement of same elements...
  ;mov g_errorapi,0A19h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke GlobalHandle,g_pshadowmem
  ;mov g_errorapi,0A1Ah ;for crash outside EVE, error codes range Axxh. v3.23
								invoke GlobalFree,eax
								mov g_pshadowmem,0
								jmp it00
						  .ENDIF
						  invoke calcboundingrecthi ;calcs bdngrect of highlightedelems.
						  ;...global coords n1stx,n1sty,n2ndx,n2ndy.
						  ;save originals...
						  mov eax,n2ndx
						  mov n2ndx0,eax ;original values.
						  mov eax,n2ndy
						  mov n2ndy0,eax
						  ;set this flag to tell xpaint_entire/_wipeout
						  ;to paint the rectangle specified by n1stx,n1sty,n2ndx,n2ndy
						  ;(calc'd in calcboundingrecthi())...
						  mov ebx,pTERSEDATA
						  or (TERSEDATA PTR [ebx]).fviewprefs,0100000b ;set bit5.
						  ;note, we're in state0 now (xgo1: also mmakes sure of that)
						  ;but when drag a resize handle will go into state30.
xgo1x:					  mov g_nknee,0
  ;mov g_errorapi,0A1Bh ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn,g_hwnd,0,FALSE ;don't redraw background.
						  mov g_fredrawdiag,ENTIRE			  ;redraw entire window.
						  jmp xgo1
						.ENDIF


				  .ELSEIF ax==IDM_FLIPH ;flip selected elements horizontally. v2.16.
					mov fhoriz,1 ;flip horizontally.
it2:					.IF highlightedindex==0
								.IF g_pselectedobject==0
								  ;error...
								  invoke myalertbox,ADDR szerhi1,004 ;invoke myerrorhandler,003
								.ELSE
								  ;puts slaves as well into list...
								  invoke add2highlightedlist,g_pselectedobject
								  mov g_pselectedobject,0
								  jmp it1
								.ENDIF
						.ELSE
it1:					  invoke calcboundingrecthi ;calcs bdngrect of highlightedelems.
						  ;...global coords n1stx,n1sty,n2ndx,n2ndy.
						  ;save originals...
						  mov eax,n2ndx
						  mov n2ndx0,eax ;original values.
						  mov eax,n2ndy
						  mov n2ndy0,eax
						  ;set this flag to tell xpaint_entire/_wipeout
						  ;to paint the rectangle specified by n1stx,n1sty,n2ndx,n2ndy
						  ;(calc'd in calcboundingrecthi())...
						  mov ebx,pTERSEDATA
						  or (TERSEDATA PTR [ebx]).fviewprefs,0100000b ;set bit5.
						  ;note, we're in state0 now (xgo1: also mmakes sure of that)
						  ;but when drag a resize handle will go into state30.
							mov al,g_nstate
							mov g_nstateprev,al
							mov g_nstate,0
							mov g_nknee,0
							  ;wipe original positions...
							  ;need to copy contents of highlightedlist to wipeoutlist...
							  invoke copyhi2wipe
  ;mov g_errorapi,0A1Bh ;for crash outside EVE, error codes range Axxh. v3.23
							  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
							  mov g_fredrawdiag,WIPEOUTobjs
							  push g_nmousex
							  push g_nmousey
  ;mov g_errorapi,0A1Ch ;for crash outside EVE, error codes range Axxh. v3.23
							  invoke UpdateWindow, g_hwnd	  ;wipe immediately.
							  pop g_nmousey
							  pop g_nmousex
							;ok, have bounding rect coords in n1stx,n1sty,n2ndx,n2ndy (global).
							.IF fhoriz==3 ;rotate. (came from idm_rot90).
							  invoke rot90hi
							.ELSE
							  ;now flip everything inside highlightedlist...
							  invoke fliphighlighted,fhoriz ;fhoriz=1 flip horizontally, =0 vertical.
							.ENDIF
							  ;bounding rect has side handles. if going to be able to use these
							  ;after flipping, need the shadow-memory...
							  .IF g_pshadowmem==0 ;haven't already done this.
newshadow1: 					invoke shadowhighlighted
								;...creates a mem block and copies highlighted elements toit.
								;DON'T FORGET TO REMOVE IT LATER!!!! (yes, done).
								.IF eax==0 ;failed to copy anything.
								  mov highlightedindex,0
								  jmp xgo1x
								.ELSE ;eax=addr of mem block.
								  mov g_pshadowmem,eax
								.ENDIF
							  .ELSE
								;so that resizing will also work consistently, need a new shadowmem
								;after every flip...
  ;mov g_errorapi,0A1Dh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke GlobalHandle,g_pshadowmem
  ;mov g_errorapi,0A1Eh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke GlobalFree,eax
								mov g_pshadowmem,0
								jmp newshadow1
							  .ENDIF
						  invoke calcboundingrecthi ;calcs bdngrect of highlightedelems.
						  mov eax,n2ndx  ;save top-left corner.
						  mov n2ndx0,eax ;/
						  mov eax,n2ndy  ;/
						  mov n2ndy0,eax ;/
  ;mov g_errorapi,0A1Fh ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn,g_hwnd,0,FALSE ;don't redraw background.
						  mov g_fredrawdiag,ENTIRE			  ;redraw entire window.
						.ENDIF

				  .ELSEIF ax==IDM_FLIPV ;flip selected elements vertically. v2.16.
					mov fhoriz,0 ;flip vertically.
					jmp it2

				  .ELSEIF ax==IDM_ROT90 ;rotate selected elements by 90degrees. v2.21.
					mov fhoriz,3 ;flag to rotate.
					jmp it2


				  .ELSEIF ax==IDM_STRETCHSEL ;align/stretch selected elements. v1.98.
					.IF highlightedindex==0
dot3:				  .IF g_pselectedobject==0
						;error...
						invoke myalertbox,ADDR szerhi1,004 ;invoke myerrorhandler,003
					  .ELSE
						;puts slaves as well into list...
						invoke add2highlightedlist,g_pselectedobject
						mov g_pselectedobject,0
							   mov al,g_nstate
							   mov g_nstateprev,al
						mov g_nstate,0
						jmp dot1
					  .ENDIF
					.ELSE
						;v2.00 bug...
						;may have some selected elements, then click on something else
						;which will go into g_pselectedobject, then come in here in state2,
						;but createnewobject() only works in state0...
						.IF g_nstate==2
							mov highlightedindex,0
							jmp dot3
						.ENDIF
dot1:				  ;now create an alignment-axes-element...
					  mov edi,pTERSEDATA
					  invoke createnewobject,1 ;returns eax=0 no obj created
					  ;param =1 means always create at end of database.
					  .IF eax==0
					  .ELSE
						mov g_pmovingobject,eax ;used for placing the object.
						mov highlightedindexnewlist,0 ;precaution.
						mov eax,pTERSEDATA ;may be new value if dbase moved.
						sub eax,edi ;find change in dbase position.
						invoke fixhighlightedlistptrs,eax ;correct ptrs.
						;...even though created obj at end database, all ptrs got clrd inside
						;createnewobject() except highlighted list and highlightedindexnewlist.
						  invoke defaultnewaxes,g_pmovingobject
						  mov g_nstateprev,0
						  mov g_nstate,4			   ;placing new object, first end.
					  .ENDIF
					.ENDIF

				  .ELSEIF ax==IDM_RECT	;draw a selection-rectangle.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,20
						;need a cross-hair cursor...
  ;mov g_errorapi,0A20h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hcrosshair ;NULL
						  ;...remove class cursor, allows a replacement.
						  ;invoke SetCursor,g_hcrosshair
						;wherever press left-button, start corner,
						;release button, end corner...
						
					.ELSEIF ax==IDM_SELALL ;v3.07 highlight all elements in diagram.
            invoke zeroabsoluteptrs,1 ;wipes all ptrs, state=0.
            mov n1stx,-15000 ;selection rectangle over all of diagram.
            mov n1sty,-15000 ;/
            mov n2ndx,15000  ;/
            mov n2ndy,15000  ;/
            mov g_nknee,0 ;precaution. v3.15
            mov g_fclrhighlighted,0 ;=1, paint_() methods clr highlighting bit. v3.15
            invoke highlightinsiderect ;every element into highlighted list.
            invoke calcboundingrecthi  ;calc actual bounding rectangle.	
  ;mov g_errorapi,0A21h ;for crash outside EVE, error codes range Axxh. v3.23
					  invoke InvalidateRgn,g_hwnd,0,FALSE ;don't redraw background.
					  mov g_fredrawdiag,ENTIRE			  ;redraw entire window.

				  .ELSEIF ax==IDM_DELS ;delete selected elements.
						.IF highlightedindex==0
								.IF g_pselectedobject==0
								  ;error...
								  invoke myalertbox,ADDR szerhi1,004 ;invoke myerrorhandler,003
								.ELSE
								  ;note when highlight elements with <shift> held down,
								  ;they go into higlightedlist. but if click on one
								  ;element without <shift> held down it goes into
								  ;g_pselectedobject. so, here we shift it into
								  ;highlightedlist...
								  invoke add2highlightedlist,g_pselectedobject
								  mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,0
								  jmp xit1
								.ENDIF
						.ELSE
xit1:					  invoke deleteelements   ;deletes everything in highlighted list+children.
						  ;mov highlightedindex,0
						  mov g_fredrawdiag,ENTIRE
  ;mov g_errorapi,0A22h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE
xgo1:									push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0 ;precaution.
						  mov g_nknee,0  ;/
						  ;invoke UpdateWindow,g_hwnd
						.ENDIF


				  .ELSEIF ax==IDM_MOVE ;move highlighted elements.
						;duplicatehighlighted() above, calls updateduplicates()
						;when there is a mousemove.
						;we can have a similar thing here, called updatemove().
						.IF highlightedindex==0
								.IF g_pselectedobject==0
								  ;error...
								  invoke myalertbox,ADDR szerhi1,4 ;invoke myerrorhandler,003
								.ELSE
								  ;note when highlight elements with <shift> held down,
								  ;they go into higlightedlist. but if click on one
								  ;element without <shift> held down it goes into
								  ;g_pselectedobject. so, here we shift it into
								  ;highlightedlist...
								  invoke add2highlightedlist,g_pselectedobject
								  mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,0 ;=0 needed by wmmousemove which calls
								  jmp edoit1	 ; updateduplicates().
								.ENDIF
						.ELSE
edoit1: 				  ;need to move the mouse-cursor...
						  mov eax,highlightedlist  ;1st highlighted element
						  invoke repositioncursor,eax
						  mov fmovinghighlighted,1 ;use in wmmousemove/wmlbuttonup.
						  xor eax,eax
						  mov xaccum,eax ;v1.40 updateduplicates/updatemove use this.
						  mov yaccum,eax ;/
						.ENDIF


				  .ELSEIF ax==IDM_NFIND ;element# find.
						lea ecx,NFINDproc
						mov eax,220 ;resource number of NFIND dialog in eve.rc.
						invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
h02:			.IF xg_perrorobject==0
						.ELSE
						  mov eax,xg_perrorobject
						  mov g_perrorobject,eax
						  mov highlightedindex,0  ;attempt fix.
						  mov g_fclrhighlighted,1 ;/
						  mov g_pselectedobject,0 ;/
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0						;/
  ;mov g_errorapi,0A23h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ENDIF

				  .ELSEIF ax==IDM_TFIND ;text find.
						lea ecx,TFINDproc
						mov eax,221 ;resource number of TFIND dialog in eve.rc.
						invoke DialogBoxParam, g_hinst,eax,0,ecx,0		 ;NO OWNER WINDOW!
h01:			  mov highlightedindex,0  ;don't think these necessary.
						  mov g_fclrhighlighted,1 ;/
						  mov g_pselectedobject,0 ;/
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0						;/
  ;mov g_errorapi,0A24h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE


				  .ELSEIF ax==IDM_BIND_LEFT ;scroll left (one window width).
						  mov  eax,clientrect.rc_left
						  sub  eax,xclientpixels
						  mov  clientrect.rc_left,eax
						  mov  eax,clientrect.rc_right
						  sub  eax,xclientpixels
						  mov  clientrect.rc_right,eax
hx3:
;created v1.18, but not using...
;						   ;we need code to signal that job is completed...
;						   ;i suggest, set a flag here, wmpaint() will clear it, then
;						   ;write some text to clipboard...
;						   mov fsyncpaint,1
;						   ;...when wmpaint() completes, it can see if this flag is set,
;						   ;and if so, clr it and write szfinished string to clipboard.
;						   ;...done by sendsignal2clip(), called from wmpaint().
  ;mov g_errorapi,0A25h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE

				  .ELSEIF ax==IDM_BIND_RIGHT ;scroll right.
						  mov  eax,clientrect.rc_left
						  add  eax,xclientpixels						;width of client area.
						  mov  clientrect.rc_left,eax
						  mov  eax,clientrect.rc_right
						  add  eax,xclientpixels
						  mov  clientrect.rc_right,eax
						  ;invoke InvalidateRgn, g_hwnd,0,TRUE
						  ;mov g_fredrawdiag,ENTIRE
						  jmp hx3

				  .ELSEIF ax==IDM_BIND_UP ;scroll up.
						  mov  eax,clientrect.rc_top
						  sub  eax,yclientpixels
						  mov  clientrect.rc_top,eax
						  mov  eax,clientrect.rc_bottom
						  sub  eax,yclientpixels
						  mov  clientrect.rc_bottom,eax
						  ;invoke InvalidateRgn, g_hwnd,0,TRUE
						  ;mov g_fredrawdiag,ENTIRE
						  jmp hx3

				  .ELSEIF ax==IDM_BIND_DOWN ;scroll down.
						  mov  eax,clientrect.rc_top
						  add  eax,yclientpixels						;height of client area.
						  mov  clientrect.rc_top,eax
						  mov  eax,clientrect.rc_bottom
						  add  eax,yclientpixels
						  mov  clientrect.rc_bottom,eax
						  ;invoke InvalidateRgn, g_hwnd,0,TRUE
						  ;mov g_fredrawdiag,ENTIRE
						  jmp hx3

				  .ELSEIF ax==IDM_BIND_X ;read x-string from clipboard.
						mov fyvalue,0
						mov g_nx,0
x01:			invoke OpenClipboard,g_hwnd
						.IF eax != 0
						  invoke GetClipboardData,CF_TEXT ;returns handle to data.
						  .IF eax != 0
								mov hclip,eax
								invoke GlobalLock,hclip ;returns eax=pointer to a ascii string.
								mov pclip,eax
								invoke str2longint, eax  ;--> eax.
								.IF fyvalue==0
								  mov g_nx,eax
								  lea ebx,sztfind ;64-char buffer.
								  invoke lstrcpy, ebx,pclip ;save string from clipboard also.
								.ELSE
								  mov g_ny,eax
								.ENDIF
								invoke GlobalFree,hclip
						  .ENDIF
;						   invoke EmptyClipboard
						  invoke CloseClipboard
;created v1.18, but not using...
;						   invoke sendsignal2clip ;completion-string sent to clipboard.
						.ELSE
						  invoke myalertbox,ADDR szer114,4 ;invoke myerrorhandler,114
						.ENDIF

				  .ELSEIF ax==IDM_BIND_Y ;read y-string from clipboard.
						mov g_ny,0
						mov fyvalue,1
						jmp x01

				  .ELSEIF ax==IDM_BIND_CENTRE ;set g_nx/g_ny in centre of window.
x02:			  mov ebx,pTERSEDATA
						  mov edx,(TERSEDATA PTR [ebx]).nzoom
						  invoke centralizeobj,g_nx,g_ny,edx,1 ;1=always keep in middle.
						  ;invoke InvalidateRgn,g_hwnd,0,TRUE ;invalidate entire window.
						  ;mov g_fredrawdiag,ENTIRE 			 ;redraw entire window.
						;a problem with this is a flicker, as background wiped.
						;suggest IDM_BIND_OFFSET to scroll without flicker...
						  jmp hx3

				  .ELSEIF ax==IDM_BIND_OFFSET
						;g_nx/g_ny have offsets to scroll... (in screen pixels)
;v1.2 have fixed zoom<0 scrolling flicker...unless zoom<-2...
						  mov ebx,pTERSEDATA
						  mov edx,(TERSEDATA PTR [ebx]).nzoom
						 .IF SDWORD PTR edx<-2 ;0
							   ;ScrollWindow() isn't working properly when zoomed-in.
							   ;so, use original code...
							   invoke calcdiagmidwindow,edx ;zoom
							   ;...ret eax=xdiagmid, ecx=ydiagmid.
							   add g_nx,eax ;new absolute xmid.
							   add g_ny,ecx ;/ ymid.
							   jmp x02
						.ENDIF
						 mov edx,g_nx
						 add clientrect.rc_left,edx
						 add clientrect.rc_right,edx
						 add g_nmousex,edx		   ;so mouse coords also keep track
						 mov ebx,g_ny
						 add clientrect.rc_top,ebx
						 add clientrect.rc_bottom,ebx
						 add g_nmousey,ebx
						mov ecx,g_nx ;g_naccelx
						neg ecx
						mov edx,g_ny ;g_naccely
						neg edx

						  ;v1.2 if margins displayed, they will scroll too. prevent...
						  pushad
						  mov ebx,pTERSEDATA
						  mov eax,(TERSEDATA PTR [ebx]).fviewprefs
						  test eax,01 ;bit0
						  jz no1
							mov wipeoutsindex,0 ;make sure nothing in wipeout list.
							mov fdrawmargins,1	;flag tell xpaint_wipeout() to draw margins,
									;by calling drawprintmargins().
								mov g_nknee,0 ;paint_arc uses this.
								invoke InvalidateRgn, g_hwnd,0,FALSE
								mov  g_fredrawdiag,WIPEOUTobjs
								push g_nmousex
								push g_nmousey
								invoke UpdateWindow, g_hwnd 			;wipe immediately.
								pop  g_nmousey
								pop  g_nmousex
;							 mov fdrawmargins,0
no1:					  popad
;note that xkeyup() and wmlbuttonup() detect fdrawmargins=1 and redraw diag, to overwrite
;the vertical white lines.

						invoke ScrollWindowEx,g_hwnd,ecx,edx,0,0,0,ADDR scrollrect,0 ;SW_ERASE
						invoke InvalidateRect, g_hwnd,ADDR scrollrect,TRUE		 ;invalidate.
;created v1.18, but not using...
;						 mov fsyncpaint,1 ;see note above. wmpaint() clrs this, writes to clipboard.
						mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
						push g_nmousex
						push g_nmousey
						invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
						pop  g_nmousey
						pop  g_nmousex

				  .ELSEIF ax==IDM_BIND_TFIND
						;the text to be found has already been read from the clipboard into sztfind,
						;by IDM_BIND_X
						;TFINDproc() is callback for "Control/Find text string..." dialog box,
						;but we are going right into it here...
						invoke TFINDproc,g_hwnd,WM_COMMAND,IDOK,-1 ;finds string in sztfind, highlights.
						;jmp h01 ;up to IDM_TFIND.
						;...no don't jmp h01, as IDM_TFIND stays inside dialog box for repeat searches.

				  .ELSEIF ax==IDM_BIND_TDONE ;have finished searching, clean up.
						jmp h01

				  .ELSEIF ax==IDM_BIND_NFIND
						;element number to be found is already in g_nx, by IDM_BIND_X.
						;NFINDproc() is callback for "Control/Find element#..." dialog box,
						;but we are going right into it here...
						invoke NFINDproc,g_hwnd,WM_COMMAND,IDOK,-1 ;finds element# in g_nx, highlights.
						jmp h02 ;up to IDM_NFIND

				  .ELSEIF ax==IDM_BIND_ZOOMNORM
;created v1.18, but not using...
;						 mov fsyncpaint,1 ;see note above.
						jmp hz7
				  .ELSEIF ax==IDM_BIND_ZOOMOUT
;created v1.18, but not using...
;						 mov fsyncpaint,1 ;see note above.
						jmp hz8
				  .ELSEIF ax==IDM_BIND_ZOOMIN
;created v1.18, but not using...
;						 mov fsyncpaint,1 ;see note above.
						jmp hz9
				  .ELSEIF ax==IDM_BIND_ORIGIN
;created v1.18, but not using...
;						 mov fsyncpaint,1 ;see note above.
						jmp hz5

				  .ELSEIF ax==IDM_GRID			   ;paper grid. v1.28
					;note, createnewobject() will just return if state<>0.
					invoke createnewobject,eax ;1 ;returns eax=0 no obj created
						   ;param =1 means always create at end of database.
					.IF eax==0
					.ELSE
					  ;createnewobject() clears all pointers, except in these lists,
					  ;so do it here as precaution...
					  mov highlightedindex,0
					  mov highlightedindexnewlist,0
								;eax points to the new object.
								mov g_pmovingobject,eax ;used for placing the object.
								invoke defaultnewgrid,eax
										mov al,g_nstate
										mov g_nstateprev,al
								mov g_nstate,4				 ;placing new object, first end.
					.ENDIF

IFE fDEVELOPER
ELSE
				  .ELSEIF ax==IDM_IMPORT_SVG
					;need a func to open an SVG file, (similar to IDM_BITMAP)
					;translate its elements to highlighed elements at end of
					;eve database...
					mov fsaving,13 ;disable animations.
					invoke insertsvg ;open file, translate/insert at end of dbase.
					.IF eax==0 ;error
					.ELSE
						;v2.15
						;it seems g_ndatabasesize isn't getting loaded correctly, so calc it here...
						invoke calcdatabasesize
						mov g_ndatabasesize,eax
					  ;code to reposition cursor at the highlighted elements,
					  ;and highlighted elements to track mouse, is already
					  ;above...
						;move diagram so highlighted objs in centre of window...
						mov ebx,pTERSEDATA
						mov edx,(TERSEDATA PTR [ebx]).nzoom
						mov ebx,highlightedlist
						.IF ebx != 0 ;precaution.
						  mov eax,(OBJECT PTR [ebx]).xtopleft
						  mov ecx,(OBJECT PTR [ebx]).ytopleft
						  invoke centralizeobj,eax,ecx,edx,0 ;only if not inside window.
							;need to move the mouse-cursor...
							jmp edoit1
						.ENDIF
					.ENDIF
					mov fsaving,0
ENDIF


;				   .ELSEIF ax==IDM_ALIGNAXES ;alignment axes.
;					 xor eax,eax
;					 mov highlightedindex,eax
;					 mov highlightedindexnewlist,eax
;					 invoke createnewobject,1 ;returns eax=0 no obj created
;							;param =1 means always create at end of database.
;						 .IF eax==0
;						 .ELSE
;								 ;eax points to the new object.
;								 mov g_pmovingobject,eax ;used for placing the object.
;								   invoke defaultnewaxes,eax
;										 mov al,g_nstate
;										 mov g_nstateprev,al
;								 mov g_nstate,4 			  ;placing new object, first end.
;						 .ENDIF




				  .ELSEIF ax>4000 ;a composite-object library member.
						xor ecx,ecx
						mov cx,ax
						  ;menu identifier converts to an element#...
						  sub ecx,4000 ;now have element#.
						  mov ebx,pTERSEDATA
						  mov eax,(TERSEDATA PTR [ebx]).nsizeobject
						  mul ecx
						  mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
						  add edx,ebx ;starting address of OBJECTS.
						  add eax,edx ;eax->element
						  mov ecx,eax
						  sub ecx,pTERSEDATA ;convert to rel.ptr.
						invoke ispointerok,ecx ;rel.ptr.
						.IF eax==0 ;fail.
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
						  invoke myalertbox,ADDR szer113,0800h ;eax ;invoke myerrorhandler,113
						  jmp x91
						.ENDIF
						add ecx,pTERSEDATA
						mov pobj,ecx
						;this should be pointing directly to a library object
						;to be inserted into the diagram...
						mov highlightedindex,0 ;clr list first.
						invoke add2highlightedlist,ecx
						;...calls addlocked2highlighted(), gets entire object.
						;...note, also gets them in the correct order in database.

						 ;;v1.41 now returns eax-->top element in comp-obj...
						 ;mov ptop,eax ;(v1.41 expects this to be same as pobj, but not
						 ;			   ;necessarily for earlier comp-objs).
						 ;...not using this for now.

										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0

						  ;need to place new object in centre of window...
						  mov ebx,pTERSEDATA
						  mov eax,(TERSEDATA PTR [ebx]).nzoom
						  invoke calcdiagmidwindow,eax
						  ;...ret eax=xdiagmid, ecx=ydiagmid.
						  and al,fdragmask ;v1.40 drag coarseness.
						  and cl,fdragmask ;v1.40 drag coarseness.
						  mov xdiagmid,eax
						  mov ebx,pobj
						  sub eax,(OBJECT PTR [ebx]).xtopleft
						  mov g_xdiagdelta,eax ;correction to locate new object.
						  mov ydiagmid,ecx
						  sub ecx,(OBJECT PTR [ebx]).ytopleft
						  mov g_ydiagdelta,ecx

						  ;need to move the mouse-cursor...
								;temp relocate element...
								mov eax,g_xdiagdelta
								add (OBJECT PTR [ebx]).xtopleft,eax
								add (OBJECT PTR [ebx]).xmid,eax
								mov eax,g_ydiagdelta
								add (OBJECT PTR [ebx]).ytopleft,eax
								add (OBJECT PTR [ebx]).ymid,eax
						  invoke repositioncursor,ebx
						  ;...places cursor at element.
								;restore...
								mov eax,g_xdiagdelta
								sub (OBJECT PTR [ebx]).xtopleft,eax
								sub (OBJECT PTR [ebx]).xmid,eax
								mov eax,g_ydiagdelta
								sub (OBJECT PTR [ebx]).ytopleft,eax
								sub (OBJECT PTR [ebx]).ymid,eax

						  ;duplicate and track mouse...
						  xor eax,eax
						  mov xaccum,eax ;v1.40 updateduplicates/updatemove use this.
						  mov yaccum,eax ;/
						  invoke duplicatehighlighted,0
						  ;...also clrs .nextype/bits15-31, making elements visible.
						  ;...if a library element, corrects the coords by
						  ; g_xdiagdelta/g_ydiagdelta.
						  ;...actual tracking occurs in wmmousemove(), using
						  ;highlightednewlist, calls updateduplicates().
							;v1.41
							;the tracking of the comp-obj via wmmousemove() has a lot
							;of screen flicker, so add this code...
							  ;a problem. i want to find top element (boss) in obj...
							  ;actually, i don't think it is really necessary, but do it,
							  ;as any old element out of the obj will be ok, but just
							  ;to be careful...
							  mov ebx,highlightedindexnewlist
								or ebx,ebx ;cmp ebx,0 ;precaution.
								je x91	  ;/
							  shl ebx,1   ;convert to offset (4 bytes per entry).
							  shl ebx,1   ;/
							  sub ebx,4   ;get last entry.
							  lea eax,highlightednewlist
							  add ebx,eax
							  mov ecx,[ebx] ;last entry in list. not necessarily boss.
							  mov highlightedindex,0 ;precaution. duplicatehighlighted()
								  ;has already done this.
								sub ecx,pTERSEDATA ;convert to rel.ptr.
								invoke ispointerok,ecx ;rel.ptr.
								.IF eax==0 ;fail.
x91x:
;							call nxtinstr
;nxtinstr:         pop eax ;return eip.						
                  invoke myalertbox,ADDR szer113,0801h ;eax ;invoke myerrorhandler,117
								  jmp x91
								.ENDIF
								add ecx,pTERSEDATA
;		 .IF ecx==pTERSEDATA
;		   invoke myerrorhandler,ecx
;		 .ENDIF
							  invoke add2highlightedlist,ecx ;returns boss in eax.
								  mov ebx,eax
								  sub eax,pTERSEDATA ;convert to rel.ptr.
								  invoke ispointerok,eax ;rel.ptr.
								  .IF eax==0 ;fail.
									jmp x91x
								  .ENDIF

							  mov g_pmovingobject,ebx
							  mov highlightedindex,0 ;remove list.
							;this is how an existing obj is dragged...
							mov g_nstate,8
							mov g_nknee,0 ;seems like a good precaution.
							mov g_xdiff,0 ;drag_ methods use this to prevent initial jump.
							mov g_ydiff,0 ;/ (but i think pointer set right on above)
							;...so, now we are using the normal wmmousemove/state8
							;to drag the new object.
x91:					 mov highlightedindexnewlist,0 ;remove list of new elements.
							 ;...wmmousemove will no longer track the obj.
						 mov g_xdiagdelta,0
						 mov g_ydiagdelta,0



				  .ENDIF
				.ENDIF
		ret
wmcommand ENDP
;------------------------------------------------------------------------
centralizeobj PROC STDCALL USES ebx ecx edx esi edi, \
						  xdiagobj:DWORD,ydiagobj:DWORD,zoom:DWORD,falways:DWORD
		LOCAL xobjfixed:SDWORD,yobjfixed:SDWORD
		LOCAL xradius:DWORD,yradius:DWORD
; "centralizeobj"
;xobj/yobj is an element that is to be placed in the centre of the
;window (at any zoom factor).
;return eax=0 didn't move, =1 if moved diagram.
;agh! --be careful, called from wmpaint() and zoom is only signed 8-bit.

				;i got this out of isobjectinwindow()...
				mov eax,xdiagobj
				mov edx,ydiagobj
				mov  ecx,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF SBYTE PTR cl>0
				  sar  eax,cl
				  sar edx,cl
				.ELSEIF SBYTE PTR cl<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				.ENDIF									;0=normal size.
				mov xobjfixed,eax
				mov yobjfixed,edx

				cmp falways,0
				jne e55
				mov eax,xobjfixed
				mov ecx,clientrect.rc_left
				.IF SDWORD PTR eax>ecx	;in left side?
				  mov ecx,clientrect.rc_right
				  .IF SDWORD PTR eax<ecx ;in right side?
						mov eax,yobjfixed
						mov ecx,clientrect.rc_top
						.IF SDWORD PTR eax>ecx			;in top side?
						  mov ecx,clientrect.rc_bottom
						  .IF SDWORD PTR eax<ecx
								;success! object is inside window client area
								jmp SHORT oke
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF

;fall out here, fail...
e55:			mov eax,clientrect.rc_right
				sub eax,clientrect.rc_left
				sar eax,1 ;always +ve anyway.
				mov xradius,eax
				mov eax,clientrect.rc_bottom
				sub eax,clientrect.rc_top
				sar eax,1
				mov yradius,eax
				;now set client area so error-object right in middle...
				mov eax,xobjfixed
				sub eax,xradius
				mov clientrect.rc_left,eax
				mov eax,xobjfixed
				add eax,xradius
				mov clientrect.rc_right,eax
				mov eax,yobjfixed
				sub eax,yradius
				mov clientrect.rc_top,eax
				mov eax,yobjfixed
				add eax,yradius
				mov clientrect.rc_bottom,eax

		mov eax,1
		ret
oke: xor eax,eax ;didn't move diagram.
		ret
centralizeobj ENDP
;------------------------------------------------------------------------
calcdiagmidwindow PROC STDCALL USES ebx edx esi edi,zoom:SDWORD
		LOCAL xradius:DWORD,yradius:DWORD
		LOCAL xobjfixed:SDWORD,yobjfixed:SDWORD
		LOCAL xdiagmid:SDWORD,ydiagmid:SDWORD
; "calcdiagmidwindow"
;wmcreate()/g_perrorobject>0, places the error-obj in middle of window.
;i want to keep the mid-point at middle of window when zoom in/out.
;this procedure calcs the diagram-coords of a mythical obj at centre...
;return eax=xdiagmid, ecx=ydiagmid.

;find middle of window, unzoomed...
				mov eax,clientrect.rc_right
				sub eax,clientrect.rc_left
				sar eax,1 ;always +ve anyway.
				mov xradius,eax
				mov eax,clientrect.rc_bottom
				sub eax,clientrect.rc_top
				sar eax,1
				mov yradius,eax

				  mov eax,clientrect.rc_left
				  add eax,xradius
				  mov xobjfixed,eax
				  mov eax,clientrect.rc_top
				  add eax,yradius
				  mov yobjfixed,eax

;now apply zoom factor to get actual diagram coords...
				mov eax,xobjfixed
				mov edx,yobjfixed
				mov ebx,pTERSEDATA
				mov ecx,zoom ;(TERSEDATA PTR [ebx]).nzoom
				.IF SBYTE PTR cl>0
				  sal eax,cl
				  sal edx,cl
				.ELSEIF SBYTE PTR cl<0
				  neg cl
				  sar eax,cl
				  sar edx,cl
				.ENDIF
				mov xdiagmid,eax
				mov ydiagmid,edx

				mov ecx,edx



		ret
calcdiagmidwindow ENDP
;------------------------------------------------------------------------
myprintersetup PROC STDCALL USES ebx ecx edx esi edi
		LOCAL fresult:DWORD
; "myprintersetup" *EVE*
;called from File/Printer setup->idm_pset
;*NOTE* PrintDlg() API func is superceded by PageSetupDlg(),
;for doing the setup, so replace the following...

		mov myprintdlg.pr_Flags,PD_PRINTSETUP
  ;mov g_errorapi,0A26h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke PrintDlgA, ADDR myprintdlg
		mov fresult,eax
				.IF eax==0 ;error
				  ;hmmm, don't think any of this req'd, as only a setup dlg...
				  mov eax,myprintdlg.pr_hDC
				  .IF eax==0
				  .ELSE
  ;mov g_errorapi,0A27h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke DeleteDC,eax
				  .ENDIF
				  ;free global memory objects...
				  mov eax,myprintdlg.pr_hDevMode
				  .IF eax==0
				  .ELSE
  ;mov g_errorapi,0A28h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke GlobalFree,eax
				  .ENDIF
				  mov eax,myprintdlg.pr_hDevNames
				  .IF eax==0
				  .ELSE
  ;mov g_errorapi,0A29h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke GlobalFree,eax
				  .ENDIF
				.ENDIF
		.IF fresult==0 ;cancelled or an error.
		.ELSE
						invoke printeranalysis,1  ;also called in wmcreate().
						;...updates the paper width/height, screen/paper scaling.
		.ENDIF

		ret
myprintersetup ENDP
;------------------------------------------------------------------------
repositioncursor PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
		LOCAL zoom:SBYTE
		LOCAL ncurx:SDWORD,ncury:SDWORD
; "repositioncursor"
;called from IDM_DUP and IDM_MOVE and IDM_IMPORT_SVG.

				mov eax,pobj
;						   lea ebx,highlightedlist ;1st highlighted element.
;						   mov eax,[ebx]				 ;/
						  .IF eax==0
						  .ELSE
								mov ebx,eax
								mov eax,(OBJECT PTR [ebx]).fconfig1
								and al,01
								.IF al==1				;wire.
								  ;position cursor at midpoint of wire...
								  mov eax,(OBJECT PTR [ebx]).xmid
								  mov ncurx,eax
								  mov eax,(OBJECT PTR [ebx]).ymid
								  mov ncury,eax
								.ELSE
								  ;position cursor top/left of element...
								  mov eax,(OBJECT PTR [ebx]).xtopleft
								  mov ncurx,eax
								  mov eax,(OBJECT PTR [ebx]).ytopleft
								  mov ncury,eax
								.ENDIF
								;...these are in logical coords, want screen coords.
								  mov esi,pTERSEDATA
								  mov eax,(TERSEDATA PTR [esi]).nzoom
								  mov zoom,al
								  ;correct for zoom-factor...
								  .IF zoom==0
								  .ELSEIF zoom>0
										mov cl,zoom
										sar ncurx,cl
										sar ncury,cl
								  .ELSEIF zoom<0
										mov cl,zoom
										neg cl
										sal ncurx,cl
										sal ncury,cl
								  .ENDIF

										;correct for origin shift...
										mov eax,clientrect.rc_left
										sub ncurx,eax
										mov eax,clientrect.rc_top
										sub ncury,eax

								  ;...now have client coords.
								  mov eax,ncurx
								  mov newpoint.pt_x,eax
								  mov eax,ncury
								  mov newpoint.pt_y,eax
  ;mov g_errorapi,0A2Ah ;for crash outside EVE, error codes range Axxh. v3.23
								  invoke ClientToScreen, g_hwnd,ADDR newpoint
								  .IF eax==0	;failed.
								  .ELSE
										;...now have screen coords.
										mov eax,newpoint.pt_x
										mov ecx,newpoint.pt_y
  ;mov g_errorapi,0A2Bh ;for crash outside EVE, error codes range Axxh. v3.23
										invoke SetCursorPos, eax,ecx
								  .ENDIF
										mov nmxold,0  ;track prev mouse pos.
										mov nmyold,0  ;/
										;...wmmousemove() sets deltax/deltay, =0 if
										;if these vars are zero.
						  .ENDIF


		ret
repositioncursor ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
g_hpengrey		DWORD 0 		;1-pixel wide grey pen.
g_hpengreydashed DWORD 0
g_hpendefault DWORD 0     ;default pen before create any. black, 1 pixel. v3.31
;g_hpenwhite5 DWORD 0
g_hbrushred DWORD 0 ;global red brush.
g_hbrushpurple DWORD 0 ;global purple brush.

.CODE
wmpaint PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
				LOCAL hdc:DWORD
				LOCAL s3:PAINTSTRUCT
				LOCAL xradius:SDWORD, yradius:SDWORD
				LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
				LOCAL xobjfixed:SDWORD,yobjfixed:SDWORD
				LOCAL zoom:SBYTE
;called from WM_PAINT  "wmpaint"
				mov hdc,0
				mov zoom,0
				;mov g2_fredrawdiag,0

				.IF g_fprintingnow==TRUE
				  ret
				.ENDIF


;check if paint to printer...
;(i'm now printing direct from IDM_PRA -> xpaint_print())
		;.IF g_fprintdiag==0
		;.ELSE
		;  ret
		;.ENDIF

;normal paint to screen...
  ;mov g_errorapi,0A2Ch ;for crash outside EVE, error codes range Axxh. v3.23
		invoke BeginPaint, g_hwnd,ADDR s3
				mov hdc, eax

;make WinNT compatible...
  ;mov g_errorapi,0A2Dh ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GetGraphicsMode,eax
		.IF eax==GM_COMPATIBLE
		.ELSE
  ;mov g_errorapi,0A2Eh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke SetGraphicsMode,hdc,GM_COMPATIBLE
		.ENDIF


				mov esi,pTERSEDATA
				mov eax,(TERSEDATA PTR [esi]).nzoom
				mov zoom,al


;v1.19...
        ;mov g_errorapi,0A2Fh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetMapMode,hdc
				.IF eax==MM_ANISOTROPIC
				.ELSE
          ;mov g_errorapi,0A30h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke SetMapMode, hdc,MM_ANISOTROPIC
				.ENDIF
;						 mov  eax,clientrect.rc_right					; scalable mapping.
;						 mov  ebx,clientrect.rc_bottom
				  ;mov eax,0100h ;set bit8. this number will scale up 6 times to bit14 set,
				  ;and zoom in 6 times to bit2 set.(note coords are 16bit system).
				  ;no, use 11001000b=200d, for easier finetuning scaling...
				  mov eax,011001000b
				  mov ebx,eax
						  mov cl,zoom
						  .IF cl==0
						  .ELSEIF SBYTE PTR cl>0
								sal eax,cl
								sal ebx,cl
						  .ELSE
								neg cl	  ;only cl part need get changed to +ve.
								sar eax,cl
								sar ebx,cl
						  .ENDIF
            ;mov g_errorapi,0A31h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetWindowExtEx, hdc,eax,ebx,0  ;new window extent.
;						 invoke SetViewportExtEx, hdc,clientrect.rc_right,clientrect.rc_bottom,0
						mov eax,011001000b ;0100h
						mov ebx,eax
						;.xfinescrn/.yfinescrn are 1% adjustments...
						mov ecx,(TERSEDATA PTR [esi]).xfinescrn
						sal ecx,1 ;up to 2, as 011001000b=200d
						add eax,ecx
						mov ecx,(TERSEDATA PTR [esi]).yfinescrn
						sal ecx,1
						add ebx,ecx
            ;mov g_errorapi,0A32h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetViewportExtEx, hdc,eax,ebx,0

;shift coordinate origin... uses clientrect as current region...
;(clientrectold is the original region-- and is the physical client coords
; top,left always=0,0 bot,right always = height,width of client)
		mov eax,clientrect.rc_left
				neg eax 									;aah... weird, but necessary
		mov ebx,clientrect.rc_top
				neg ebx 										  ;/
    ;mov g_errorapi,0A33h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetViewportOrgEx, hdc,eax,ebx,0	;0,0 is now top/left of client.

		;v1.30
		;have found above doesn't work properly. if clientrect.rcleft/.rc_top =4,110,
		;and zoom=-1 (in1), top/left of window is 2,55.
		;discovered this problem when tried to print with a highlighted page grid
		; -- idm_pra code tries to align top/left of grid with top/left of window.
		;if i replace setviewportorg with setwindoworg, it does work, however upsets
		;zoom in and out.
		;so, let's not try and "fix" this here. I'll modify idm_pra code to take
		;scaling into account.
		;...this is complicated. above code seems to keep mid x/y of clientrect
		;in the centre when zoom in or out.

;if g_perrorobject is non-zero, i want to be sure it's always visible in
;the window...
		  mov ebx,g_perrorobject
		  or ebx,ebx ;cmp ebx,0
		  je oke
				mov eax,(OBJECT PTR [ebx]).xmid
				mov ecx,(OBJECT PTR [ebx]).ymid
				xor edx,edx
				mov dl,zoom
				invoke centralizeobj,eax,ecx,edx,0 ;=0 only centralize if obj
														 ;not inside window.
				or eax,eax ;cmp eax,0 ;=0 didn't do any centralizing.
				je oke
				mov g_fredrawdiag,ENTIRE
		  mov eax,clientrect.rc_left
				neg eax 										  ;aah... weird, but necessary
		  mov ebx,clientrect.rc_top
				neg ebx 										  ;/
    ;mov g_errorapi,0A34h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetViewportOrgEx, hdc,eax,ebx,0
oke:

f12:
;let's also create a grey pen...
      ;mov g_errorapi,0A35h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CreatePen, PS_SOLID,0,0C0C0C0h 		;want 1-wide,grey.
		  mov g_hpengrey,eax
		  ;...*NOTE* width param =0 gives 1-pixel on display
		  ;regardless of zoom factor. *NOTE* <<<<<<<<<<<<<<<<<<<<<
		  invoke CreatePen, PS_DASH,0,0C0C0C0h ;1-wide light grey.
		  mov g_hpengreydashed,eax
;when an object is highlighted, want the handles to be red-filled...
    ;mov g_errorapi,0A36h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke CreateSolidBrush,255 ;red.
		mov g_hbrushred,eax
;use purple-fill for highlighted object...
;v2.24 i'm using this for showing poly handles when drag wire-end over it...
		invoke CreateSolidBrush,0FFC0FFh ;very light purple.
		mov g_hbrushpurple,eax
;and a global font...
		  mov eax,12
		  neg eax
  ;mov g_errorapi,0A37h ;for crash outside EVE, error codes range Axxh. v3.23
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,0,ADDR szarialbold
		  mov  g_hfontx1,eax			;11-point Arial Bold.

;and a global small code font... v3.25
		  mov eax,-11
		  ;neg eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,0,ADDR szcouriernew
		  mov  g_hfontcode,eax			;11-point courier new.


;  invoke TESTDISPLAY, hdc				;***TEST***

;now for the specific cases...
				;.IF g_fprintdiag==0 			;non-0 if want to print.
						  .IF g_fredrawdiag==WIPEOUTobjs
								invoke xpaint_wipeout, hdc
						  .ELSEIF g_fredrawdiag==UPDATEobjs
								invoke xpaint_update, hdc
						  .ELSEIF g_fredrawdiag==ENTIRE
							invoke xpaint_entire, hdc
							invoke xpaint_extras, hdc ;common stuff.
						  .ENDIF
				;.ELSE	 ;NO LONGER PRINT FROM HERE!!!!!!  ***NOTE***<<<<<
				;  mov g_fprintingnow,TRUE
				;  mov  g_fredrawdiag,ENTIRE
				;  invoke xpaint_print
		    ;  invoke PostMessage, g_hwnd,WM_USER+4+100h,0,0  ;delay repaint.
				;  mov g_fprintingnow,FALSE
				;.ENDIF

;;delete the pen created at start of this proc...
        ;mov g_errorapi,0A38h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke DeleteObject,g_hpengrey
				mov g_hpengrey,0
				invoke DeleteObject,g_hpengreydashed
				mov g_hpengreydashed,0
;and the red brush...
				invoke DeleteObject,g_hbrushred
				mov g_hbrushred,0
;and the purple brush...
				invoke DeleteObject,g_hbrushpurple
				mov g_hbrushpurple,0
;and the global font...
		invoke DeleteObject,g_hfontx1
		mov g_hfontx1,0
		invoke DeleteObject,g_hfontcode ;v3.25
		mov g_hfontcode,0

    ;mov g_errorapi,0A39h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke EndPaint, g_hwnd,ADDR s3

		;mov al,g2_fredrawdiag
		;.IF al==0
		  mov g_fredrawdiag,0
		;.ELSE
		;  mov g_fredrawdiag,al  ;some paint_*() funcs want to redraw certain
		;  invoke InvalidateRgn, g_hwnd,0,FALSE
		;		 ;elements.
		;.ENDIF

		ret
wmpaint ENDP
;------------------------------------------------------------------------
xpaint_wipeout PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
				LOCAL hbrushold:DWORD
				LOCAL hbrushgreen:DWORD,hbrushredsaved:DWORD
				LOCAL hpencolor:DWORD
;				LOCAL hpenold:DWORD
				LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
				LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
				LOCAL nwipecolor:DWORD,fresize:BYTE
; *EVE*
;redraws all objects in wipeouts objects database.		 "xpaint_wipeout"
;basically, same as xpaint_update(), except draws pen/text/brush white.
				xor eax,eax
				mov hbrushold,eax
				mov hbrushgreen,eax
				mov hpencolor,eax
;				mov hpenold,eax
				mov fresize,al

;v1.27 can have different background colors...(this version, these are only system
;brushes, that do not have to be deleted later)...
		  mov ebx,pTERSEDATA
		  mov eax,(TERSEDATA PTR [ebx]).nbackground
		  shl eax,1 ;dword
		  shl eax,1 ;/
		  lea ebx,g_hwhitebrush
		  add ebx,eax ;address of brush.
		  mov eax,[ebx] ;get brush.
;				   ;colour for filling polygons....
;						 invoke GetStockObject, WHITE_BRUSH
				   mov hbrushgreen,eax
				   mov ebx,g_hbrushred
				   mov hbrushredsaved,ebx
				   mov g_hbrushred,eax
            ;mov g_errorapi,0A3Ah ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SelectObject, hdc,hbrushgreen
				   mov hbrushold,eax

        ;mov g_errorapi,0A3Bh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetBkMode, hdc, TRANSPARENT		 ;leave background showing.

				;v1.27
				;*UNSATISFACTORY* I really need to convert the above brush to RGB ..how?
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nbackground
				.IF cl==0
				  mov eax,00FFFFFFh 	 ;white.
				.ELSEIF cl==1
				  mov eax,0 ;black
				.ELSEIF cl==2
				  ;invoke GetSysColor,COLOR_GRAYTEXT
				  mov eax,0C0C0C0h ;=lightgrey. 0808080=darkgrey. A0A0A0=midgrey.
				.ELSE
				  ;v1.28 done in winmain()...invoke GetSysColor,COLOR_WINDOW
				  mov eax,g_cstandardbrush
				.ENDIF
				mov nwipecolor,eax

        ;mov g_errorapi,0A3Ch ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetTextColor, hdc,eax ;00FFFFFFh 	 ;white.


						  ;191100
						  ;draw selection-rectangle...
						  mov ebx,pTERSEDATA
						  mov eax,(TERSEDATA PTR [ebx]).fviewprefs ;show bounding rect. bit5.
						  and al,0100000b						;/
						  .IF g_nstate==22		;mousemove while drawing rectangle.
							;(won't display resize handles).
dis1:							;find which corner is top-left, which bot-right...
								mov eax,n1stx
								mov ebx,n2ndx
								.IF SDWORD PTR eax<ebx
								  mov xleft,eax
								  mov eax,n2ndx
								  mov xright,eax
								.ELSE
								  mov xright,eax
								  mov eax,n2ndx
								  mov xleft,eax
								.ENDIF
								mov eax,n1sty
								mov ebx,n2ndy
								.IF SDWORD PTR eax<ebx
								  mov ytop,eax
								  mov eax,n2ndy
								  mov ybot,eax
								.ELSE
								  mov ybot,eax
								  mov eax,n2ndy
								  mov ytop,eax
								.ENDIF
                ;mov g_errorapi,0A3Dh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke CreatePen, PS_SOLID,2,nwipecolor ;0FFFFFFh ;2pixel,white.
								mov hpencolor,eax
                ;mov g_errorapi,0A3Eh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke SelectObject,hdc,eax
								mov g_hpendefault,eax ;v3.31 mov hpenold,eax
                ;mov g_errorapi,0A3Fh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke Rectangle, hdc,xleft,ytop,xright,ybot
								  .IF fresize==1
									;need drag handles on side, bottom...
									mov eax,xright
									dec eax
									dec eax
									mov ebx,ybot
									sub ebx,ytop
									shr ebx,1
									add ebx,ytop
									dec ebx
									dec ebx
									mov ecx,eax
									add ecx,4
									mov edx,ebx
									add edx,4
                  ;mov g_errorapi,0A40h ;for crash outside EVE, error codes range Axxh. v3.23
									invoke Ellipse,hdc,eax,ebx,ecx,edx
									;now for bottom...
									mov eax,ybot
									dec eax
									dec eax
									mov ebx,xright
									sub ebx,xleft
									shr ebx,1
									add ebx,xleft
									dec ebx
									dec ebx
									mov ecx,eax
									add ecx,4
									mov edx,ebx
									add edx,4
									invoke Ellipse,hdc,ebx,eax,edx,ecx
								  .ENDIF
								invoke SelectObject,hdc,g_hpendefault ;hpenold				;restore old pen.
								invoke DeleteObject, hpencolor
						  .ELSEIF al==0100000b
							  mov fresize,1
							  jmp dis1
						  .ENDIF

;v1.2
;xtimer() and IDM_BIND_SCROLL call ScrollWindow(), but this also scrolls page margins,
;if they're turned on. So they set fdrawmargins=1 and g_fredrawdiag=WIPEOUTobjs
;and call UpdateWindow().
;need to wipeout current margins...
			.IF fdrawmargins==1
        ;mov g_errorapi,0A41h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke CreatePen, PS_SOLID,0,nwipecolor ;0FFFFFFh ;1pixel,white.
				;...,0, means always 1pixel, regardless of zoom factor.
				mov hpencolor,eax
				invoke SelectObject,hdc,eax
				mov g_hpendefault,eax ;v3.31 mov hpenold,eax
			  invoke drawprintmargins,hdc ;also called from xpaint_extras().
				invoke SelectObject,hdc,g_hpendefault ;hpenold				;restore old pen.
				invoke DeleteObject, hpencolor
			.ENDIF


;redraw only from wipeouts list...
				mov ebx,wipeoutsindex	  ;pts to next free entry.
				lea esi,wipeouts
				shl ebx,1								 ;convert index to relative-offset
				shl ebx,1							  ; / 4 bytes per entry
end2:			or ebx,ebx ;cmp ebx,0
				je		end1							;nothing/nothing-more to wipeout, get out.
				dec ebx
				dec ebx
				  dec ebx
				  dec ebx
				mov edi,[esi+ebx]				   ;get an object
				or edi,edi ;cmp edi,0												;precaution.
				je		end2							;invalid object
				  ;drop here if found an object, edi->object.

nextobj:
;here down to "end common code" is *almost* same in xpaint_entire().
;(and pretty much same in xpaint_print())
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov ebxsave,ebx
				;code in here uses esi->object, so...
				mov esi,edi
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01				;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
				  .ELSE 						  ;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)

								;create a pen...
								mov ebx,(OBJECT PTR [esi]).npenwidth
								add ebx,3 ;2 v3.41
								;...ellipse with morphingwidth and skew, edge not wiping.
                ;mov g_errorapi,0A42h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke CreatePen, PS_SOLID,ebx,nwipecolor ;0FFFFFFh ;white.
								mov hpencolor,eax
								invoke SelectObject,hdc,eax
								mov g_hpendefault,eax ;v3.31 mov hpenold,eax

					  ;finally, call the method to display object...
					  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
					  ;(relative to "ptrs", which is start of the methods table)
					  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

					invoke SelectObject,hdc,g_hpendefault ;hpenold				;restore old pen.
					invoke DeleteObject, hpencolor

				  .ENDIF
				.ENDIF
				mov ebx,ebxsave
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
;end common code.


		  jmp end2										;get next object from updates database.
end1: mov wipeoutsindex,0		   ;buffer now empty.

				invoke SelectObject, hdc, hbrushold ;restore old brush.
;v1.27			invoke DeleteObject, hbrushgreen
		  mov eax,hbrushredsaved
		  mov g_hbrushred,eax

				ret
xpaint_wipeout ENDP
;------------------------------------------------------------------------
xpaint_update PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
				LOCAL hbrushold:DWORD
				LOCAL hbrushdefault:DWORD
				LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
				LOCAL hbrushnewcolor:DWORD, hbrusholdcolor:DWORD
				LOCAL hpencolor:DWORD
; "xpaint_update"
;redraws all objects in updateobjects database.
;basically, same as xpaint_entire(), except doesn't loop thru all
;of OBJECTS database, only goes thru updates database.

;there is a problem. xpaint_entire() paints objects in order in which
;they are in the OBJECTS database, from beginning. Therefore wires
;will always paint after a node to which they are attached.
;nearobjects() scans the database, inserting objects into update list
;again in forward order, BUT xpaint_update paints in reverse, working
;back from the end of the list. it would seem best to change
;xpaint_update... (ok, it's done)
;note that xpaint_wipeout works back also, but that's actually desirable.

				mov hbrushold,0
				mov hbrushdefault,0
				mov hbrushnewcolor,0
				mov hbrusholdcolor,0


				  ;default colour for filling polygons....(no fill)
  ;mov g_errorapi,0A43h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke GetStockObject,NULL_BRUSH
				  mov hbrushdefault,eax
						invoke SelectObject, hdc,hbrushdefault
				  mov hbrushold,eax

  ;mov g_errorapi,0A44h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetBkMode, hdc, TRANSPARENT		 ;leave background showing.

;redraw only from update list...
  mov ebx,0  ;start from first item in list.
  lea esi,updates
end2:
  mov eax,updatesindex	;index of next free entry.
  shl eax,1 			;convert index to relative offset (4bytes/entry)
  shl eax,1 			;/
  cmp ebx,eax
  je  end1								;nothing more to update, getout.
  mov edi,[esi+ebx]    ;get an object
  or edi,edi ;cmp edi,0 							;precaution.
  je	end2b			   ;invalid object
  ;drop here if found an object, edi->object.

nextobj:
;here down to "end common code" is *almost* same in xpaint_entire().
;(and pretty much same in xpaint_print())
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov ebxsave,ebx
				;code in here uses esi->object, so...
				mov esi,edi
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01	  ;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
				  .ELSE 						  ;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)

										;chose a new brush, maybe...
										;(is already a null brush created start this func)
										mov hbrushnewcolor,0
										mov ebx,(OBJECT PTR [esi]).nfillcolor
										mov eax,(OBJECT PTR [esi]).nfillstyle
										.IF eax==0				   ;no fill
										  jmp e300
										.ELSEIF eax==1	   ;solid
e301:
                ;mov g_errorapi,0A45h ;for crash outside EVE, error codes range Axxh. v3.23
							  invoke CreateSolidBrush, ebx
										.ELSE							;hatch fill.
										  .IF eax==2
												mov eax,HS_BDIAGONAL
										  .ELSEIF eax==3
												mov eax,HS_CROSS
										  .ELSEIF eax==4
												mov eax,HS_DIAGCROSS
										  .ELSEIF eax==5
												mov eax,HS_FDIAGONAL
										  .ELSEIF eax==6
												mov eax,HS_HORIZONTAL
										  .ELSEIF eax==7
												mov eax,HS_VERTICAL
										  .ELSE
												jmp e301
										  .ENDIF
										  invoke CreateHatchBrush,eax,ebx
										.ENDIF
										mov hbrushnewcolor,eax
										invoke SelectObject, hdc,hbrushnewcolor
										mov hbrusholdcolor,eax
e300:


										;*EVE* .config4 bits 0/1/2 used for pen profile...
										;mov hpendefault,0

								;create a pen...
								mov eax,(OBJECT PTR [esi]).npenstyle
								.IF eax==0				;solid pen.
								  mov eax,PS_SOLID
								.ELSEIF eax==1	;invisible.
								  mov eax,PS_NULL
								.ELSEIF eax==2	;dashes.
								  mov eax,PS_DASH
								.ELSEIF eax==3	;dots.
								  mov eax,PS_DOT
								.ELSEIF eax==4			;v1.30.
								  mov eax,PS_DASHDOT	;/
								.ELSEIF eax==5			;/
								  mov eax,PS_DASHDOTDOT ;/
								.ELSE
								  mov eax,PS_SOLID
								.ENDIF
								mov ebx,(OBJECT PTR [esi]).npenwidth
								mov ecx,(OBJECT PTR [esi]).npencolor
                ;mov g_errorapi,0A46h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke CreatePen, eax,ebx,ecx
								mov hpencolor,eax
								invoke SelectObject,hdc,eax
								mov g_hpendefault,eax ;v3.31 mov hpendefault,eax


;finally, call the method to display object...
								  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

										invoke SelectObject,hdc,g_hpendefault
										invoke DeleteObject, hpencolor
								  ;and restore default brush...
										.IF hbrushnewcolor==0
										.ELSE
										  invoke SelectObject, hdc, hbrusholdcolor
										  invoke DeleteObject, hbrushnewcolor
										.ENDIF

				  .ENDIF
				.ENDIF
				mov ebx,ebxsave
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
;end common code.

end2b:
  add ebx,4
  jmp end2												;get next object from updates database.
end1: mov updatesindex,0		  ;buffer now empty.

				invoke SelectObject, hdc, hbrushold ;restore old brush.
		  invoke DeleteObject, hbrushdefault

				ret
xpaint_update ENDP
;------------------------------------------------------------------------
.CODE
xpaint_entire PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
				LOCAL hbrushold:DWORD
				LOCAL hbrushdefault:DWORD
				LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
				LOCAL hbrushnewcolor:DWORD, hbrusholdcolor:DWORD
				LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
				LOCAL hpencolor:DWORD
				LOCAL zhbrushnull:DWORD,zhbrushold:DWORD,fresize:BYTE
;redraws all objects within screen boundaries.	 "xpaint_entire"
;this is a large function, so for now, i'll just have the basic loop...
;***NOTE***
				xor eax,eax
				mov hbrushold,eax
				mov hbrushdefault,eax
				mov hbrushnewcolor,eax
				mov hbrusholdcolor,eax
				mov hpencolor,eax
				mov fresize,al

				   ;default colour for filling polygons....(no fill, transparent)
           ;mov g_errorapi,0A47h ;for crash outside EVE, error codes range Axxh. v3.23
				   invoke GetStockObject, NULL_BRUSH
				   mov hbrushdefault,eax
				   invoke SelectObject, hdc,hbrushdefault
				   mov hbrushold,eax

        ;mov g_errorapi,0A48h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetBkMode, hdc, TRANSPARENT		 ;leave background showing.

						  ;191100
						  ;draw selection-rectangle...
						  mov ebx,pTERSEDATA ;v1.92.
						  mov eax,(TERSEDATA PTR [ebx]).fviewprefs ;show bounding rect. bit5.
						  and al,0100000b						;/
						  .IF g_nstate==22		;mousemove while drawing rectangle.
dis1:							;find which corner is top-left, which bot-right...
								mov eax,n1stx
								mov ebx,n2ndx
								.IF SDWORD PTR eax<ebx
								  mov xleft,eax
								  mov eax,n2ndx
								  mov xright,eax
								.ELSE
								  mov xright,eax
								  mov eax,n2ndx
								  mov xleft,eax
								.ENDIF
								mov eax,n1sty
								mov ebx,n2ndy
								.IF SDWORD PTR eax<ebx
								  mov ytop,eax
								  mov eax,n2ndy
								  mov ybot,eax
								.ELSE
								  mov ybot,eax
								  mov eax,n2ndy
								  mov ytop,eax
								.ENDIF
								;invoke Rectangle, hdc,xleft,ytop,xright,ybot
                ;mov g_errorapi,0A49h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke SelectObject,hdc,g_hpengrey
								mov g_hpendefault,eax ;v3.31 mov zhpensave,eax
								;invoke GetStockObject,NULL_BRUSH
								;mov zhbrushnull,eax
								;invoke SelectObject,hdc,zhbrushnull
								;mov zhbrushold,eax
                ;mov g_errorapi,0A4Ah ;for crash outside EVE, error codes range Axxh. v3.23
								invoke Rectangle,hdc,xleft,ytop,xright,ybot
								;invoke SelectObject,hdc,zhbrushold
								;invoke DeleteObject,zhbrushnull
								invoke SelectObject,hdc,g_hpendefault ;zhpensave
								  .IF fresize==1
									;need drag handles on side, bottom...
									invoke SelectObject,hdc,g_hbrushred
									mov zhbrushold,eax
									mov eax,xright
									dec eax
									dec eax
									mov ebx,ybot
									sub ebx,ytop
									shr ebx,1
									add ebx,ytop
									dec ebx
									dec ebx
									mov ecx,eax
									add ecx,4
									mov edx,ebx
									add edx,4
                  ;mov g_errorapi,0A4Bh ;for crash outside EVE, error codes range Axxh. v3.23
									invoke Ellipse,hdc,eax,ebx,ecx,edx
									;now for bottom...
									mov eax,ybot
									dec eax
									dec eax
									mov ebx,xright
									sub ebx,xleft
									shr ebx,1
									add ebx,xleft
									dec ebx
									dec ebx
									mov ecx,eax
									add ecx,4
									mov edx,ebx
									add edx,4
									invoke Ellipse,hdc,ebx,eax,edx,ecx
									invoke SelectObject,hdc,zhbrushold
								  .ENDIF
						  .ELSEIF al==0100000b ;bit5. v1.92.
							  mov fresize,1
							  jmp dis1
						  .ENDIF


 mov updatesindex,0
 mov wipeoutsindex,0

				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty database.
						jmp nextobjy
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01	  ;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
				  .ELSE 						  ;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)

					mov eax,(TERSEDATA PTR [edi]).feveprefs
					and al,01000b ;bit3=1 disable intelligent window paint.
					.IF al==0
					  invoke isobjectinwindow, esi ;return TRUE if yes.
					.ELSE
						mov eax,TRUE	;redraw every element in diagram.
					.ENDIF

								.IF eax==TRUE

										;chose a new brush, maybe...
										;(is already a null brush created start this func)
										mov hbrushnewcolor,0
										mov ebx,(OBJECT PTR [esi]).nfillcolor
										mov eax,(OBJECT PTR [esi]).nfillstyle
										.IF eax==0				   ;no fill
										  jmp e300
										.ELSEIF eax==1	   ;solid
e301:
                ;mov g_errorapi,0A4Ch ;for crash outside EVE, error codes range Axxh. v3.23
							  invoke CreateSolidBrush, ebx
										.ELSE							;hatch fill.
										  .IF eax==2
												mov eax,HS_BDIAGONAL
										  .ELSEIF eax==3
												mov eax,HS_CROSS
										  .ELSEIF eax==4
												mov eax,HS_DIAGCROSS
										  .ELSEIF eax==5
												mov eax,HS_FDIAGONAL
										  .ELSEIF eax==6
												mov eax,HS_HORIZONTAL
										  .ELSEIF eax==7
												mov eax,HS_VERTICAL
										  .ELSE
												jmp e301
										  .ENDIF
										  invoke CreateHatchBrush,eax,ebx
										.ENDIF
										mov hbrushnewcolor,eax
										invoke SelectObject, hdc,hbrushnewcolor
										mov hbrusholdcolor,eax
e300:

										;*EVE* .config4 bits 0/1/2 used for pen profile...NO
										;mov hpendefault,0

								;create a pen...
								mov eax,(OBJECT PTR [esi]).npenstyle
								.IF eax==0				;solid pen.
								  mov eax,PS_SOLID
								.ELSEIF eax==1	;invisible.
								  mov eax,PS_NULL
								.ELSEIF eax==2	;dashes.
								  mov eax,PS_DASH
								.ELSEIF eax==3	;dots.
								  mov eax,PS_DOT
								.ELSEIF eax==4			;v1.30.
								  mov eax,PS_DASHDOT	;/
								.ELSEIF eax==5			;/
								  mov eax,PS_DASHDOTDOT ;/
								.ELSE
								  mov eax,PS_SOLID
								.ENDIF
								mov ebx,(OBJECT PTR [esi]).npenwidth
								mov ecx,(OBJECT PTR [esi]).npencolor
  ;mov g_errorapi,0A4Dh ;for crash outside EVE, error codes range Axxh. v3.23
								invoke CreatePen, eax,ebx,ecx
								mov hpencolor,eax
								invoke SelectObject,hdc,eax
								mov g_hpendefault,eax ;v3.31 mov hpendefault,eax


;finally, call the method to display object...
								  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

										invoke SelectObject,hdc,g_hpendefault
										invoke DeleteObject,hpencolor
								  ;and restore default brush...
										.IF hbrushnewcolor==0
										.ELSE
										  invoke SelectObject, hdc, hbrusholdcolor
										  invoke DeleteObject, hbrushnewcolor
										.ENDIF

								.ENDIF
				  .ENDIF
				.ENDIF
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop nextobjx
		jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

						invoke SelectObject, hdc, hbrushold ;restore old brush.
				  invoke DeleteObject, hbrushdefault

  ret
xpaint_entire ENDP
;------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
mousexold DWORD 0
mouseyold DWORD 0
mousexolder DWORD 0
mouseyolder DWORD 0
fbumping  BYTE 0
  BYTE 0,0,0

.CODE
origincorrection PROC STDCALL USES ebx ecx edx esi edi, lparam:DWORD
		LOCAL zoom:SBYTE
; "origincorrection"
;mouse coords have origin at top/left of client area of window.
;they need to be corrected if origin is moved or zoom not 0.
;corrected mouse coords are saved in g_mousex and g_mousey.

				mov esi,pTERSEDATA
				mov eax,(TERSEDATA PTR [esi]).nzoom
				mov zoom,al

;save the previous g_nmousex/g_nmousey...
				.IF fbumping==0
		  mov  eax,mousexold
		  mov  mousexolder,eax
		  mov  eax,mouseyold
		  mov  mouseyolder,eax
		  mov  eax,g_nmousex
		  mov  mousexold,eax
		  mov  eax,g_nmousey
		  mov  mouseyold,eax
				.ELSE							   ;refuse to move mouse, if have bumped a
				  .IF g_nstate==8												;only relevant if dragging...
		   mov	eax,mousexold
		   mov	g_nmousex,eax	 ;(see dragchilddiag).
				   mov	WORD PTR lparam,ax
		   mov	eax,mousexolder  ;comp/super up against another.
		   mov	mousexold,eax
		   mov	eax,mouseyold
		   mov	g_nmousey,eax
				   mov	WORD PTR lparam+2,ax
		   mov	eax,mouseyolder
		   mov	mouseyold,eax
				   ret
				  .ENDIF
				.ENDIF

;all mouse messages need to be corrected, if the screen is shifted.
				mov eax,clientrect.rc_left		;this is the correction.
				mov ebx,clientrect.rc_top		;/
				  push eax								;convert 16 to 32 bit.
				  mov ax,WORD PTR lparam  ;/	  ;mouse x
				  cwde									;/
				  mov ecx,eax					;/
				  pop eax								;/
				  push eax								;convert 16 to 32 bit.
				  mov ax,WORD PTR lparam+2		;/				;mouse y
				  cwde									;/
				  mov edx,eax					;/
				  pop eax								;/
				add ecx,eax
				add edx,ebx
				mov g_nmousex,ecx						 ;save
				mov g_nmousey,edx										;/

				  .IF zoom==0
				  .ELSEIF zoom>0
						mov cl,zoom
						sal g_nmousex,cl
						sal g_nmousey,cl
				  .ELSEIF zoom<0
						mov cl,zoom
						neg cl
						sar g_nmousex,cl
						sar g_nmousey,cl
				  .ENDIF

				ret
origincorrection ENDP
;------------------------------------------------------------------------
wmlbuttonup PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL plock:DWORD
		LOCAL xend:SDWORD,yend:SDWORD
		LOCAL exttype:DWORD
		LOCAL fgoback:BYTE
;comes via WM_LBUTTONUP    "wmlbuttonup"

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

;duplicatehighlighted() created new duplicate elements, and
;wmmousemove()/updateduplicates() is causing them to track
;the mouse. Freeze them in-place now...
		mov highlightedindexnewlist,0 ;remove all from highlightednewlist.

;;when moving a highlighted elements, fmovinghighlighted=1.
;;clear it now...
;		 .IF fmovinghighlighted==0
;		 .ELSE
;		   mov highlightedindex,0		;remove selected elements.
;		   mov g_fclrhighlighted,1		;wmpaint will clr .fconfig2/bit7.
;		   mov fmovinghighlighted,0
;		 .ENDIF

;lparam has mouse coords...x=low-word,y=hi-word (client coords)
				invoke	origincorrection, lparam
								;returns corrected coords in g_nmousex & g_nmousey
				  ;i'll correct lparam as well, cos old goofee code expected it...
				  ;wmmousemove()>WM_USER>xuser() does.
				  mov eax,g_nmousex
				  mov WORD PTR lparam,ax
				  mov eax,g_nmousey
				  mov WORD PTR lparam+2,ax

;v1.2 trying to get the page margins to draw right when scrolling (they must stay put)...
			   .IF g_naccelx != 0
drw1:			.IF fdrawmargins==1  ;see xpaint_wipeout() (only set while scrolling)
  ;mov g_errorapi,0A4Eh ;for crash outside EVE, error codes range Axxh. v3.23
				    invoke InvalidateRgn, g_hwnd,0,FALSE   ;invalidate entire window.
				    mov g_fredrawdiag,ENTIRE 							 ;redraw entire window.
				    mov fdrawmargins,0
				  .ENDIF
			   .ELSEIF g_naccely != 0
				   jmp drw1
			   .ENDIF

				mov g_naccelx,0 ;this is acceleration during scrolling.=0notscrolling
				mov g_naccely,0    ;..precaution, as scrolling() does clr it when done.
				mov  ctrlkey,0	 ;set if control-key held down, mouse on a node.


				;231100
				;if moving a group of elements, buttonup must terminate it...
				.IF fmovinghighlighted==1
						;this flag allows display multiple highlighted when 0...
						mov g_fclrhighlighted,1  ;wmpaint() will clr fconfig2/bit7.
						mov g_pselectedobject,0
						mov highlightedindex,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,0
						mov fmovinghighlighted,0
  ;mov g_errorapi,0A4Fh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
						mov g_fredrawdiag,ENTIRE
				.ENDIF

				;if duplicating a group of elements, buttonup must terminate it...
				.IF highlightedindexnewlist==0
				.ELSE
						mov g_fclrhighlighted,1  ;wmpaint() will clr fconfig2/bit7.
						mov g_pselectedobject,0
						mov highlightedindex,0	 ;precaution.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,0
						mov fmovinghighlighted,0 ;precaution.
						mov highlightedindexnewlist,0
  ;mov g_errorapi,0A50h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
						mov g_fredrawdiag,ENTIRE
				.ENDIF

				.IF g_nstate==0 				;normal state at startup & during operation.
				  nop

		  .ELSEIF g_nstate==1			 ;a prior lbuttondn has selected an obj.
										 ;...can only come here from state-0.
										 ;g_pselectedobjnew=object selected.
				  .IF g_pselectedobjnew==0  ;precaution. maybe redundant.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,0							;/
				  .ELSE
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,2
						mov ebx,g_pselectedobjnew ;done by lbuttondoen(& mouse not moved)
						  mov g_pselectedobject,ebx			 ;make highlighted.

						  ;v1.90
						  mov eax,(OBJECT PTR [ebx]).number  ;display element# top of window.
						  invoke displaynumber,eax			 ;/

						  mov g_pselectedobjnew,0
						  invoke add2updatelist, g_pselectedobject
						;this flag allows multiple highlighted when 0...
						mov g_fclrhighlighted,0
						;if <shift> key held down, we are selecting multiple
						;highlighted elements...
  ;mov g_errorapi,0A51h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke GetAsyncKeyState, VK_SHIFT
						and ax,8000h			;bit15=1 if key pressed.
						.IF ax==8000h
						  mov ebx,g_pselectedobject
						  or (OBJECT PTR [ebx]).fconfig2,10000000b ;set bit7.
						  invoke add2highlightedlist,ebx
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0 ;back to state0 so can make more selections.
						  mov g_pselectedobject,0 ;cos we're in state0.
						  ;...only use g_pselectedobject for a single highlighted
						  ;element.
						.ELSE
						
;v2.73 no, this is troublesome. don't do it for now...						
;						  ;v2.73 if click on a comp.obj., wmlbuttondown()/state0 went into
;						  ;state1 and g_pselectednew->boss, g_rplockedelement->locked child that
;						  ;was clicked on.
;						  ;now we have g_pselectedobject->boss/state2.
;						  ;i want to highlight all elements in comp.obj. have modified
;						  ;updateslaves() so will only add locked children to updatelist
;						  ;if pass param3...
;						  mov eax,g_rplockedelement	;note, this intended for use dblclk.
;						  .IF eax != 0						
;						    add eax,pTERSEDATA
;						    .IF eax != g_pselectedobject
;						      ;highlighted is different from clicked-on, so...
;						      invoke updateslaves,g_pselectedobject,0,0,2
;						      ;paint_() methods now check to see if boss has .fconfig2/bit7=1
;						      ;set (highlighted), so set it now..
;						      mov ebx,g_pselectedobject
;						      or (OBJECT PTR [ebx]).fconfig2,80h ;set bit7.
;						      ;...note, g_pselectedobject is still the selected one,
;						      ;the children will just paint as highlighted.
;						    .ENDIF
;						  .ENDIF

              ;v2.79 now can have attached link activator...
              ;link activator uses paint_(), which copies link.flinks to owner.flinks.
              ;this has values 60-69, just like icons, icon.nexttype...
              mov ebx,pTERSEDATA
              mov eax,(TERSEDATA PTR [ebx]).feveprefs
              and al,80h ;bit7=1 single-click equiv. to dblclk.
              .IF al != 0
                mov ebx,g_rplockedelement ;v3.11
                ;wmlbuttondown() makes this non0, ptg to element to which link activator
                ;is directly attached, element is locked. Whereas g_pselectedobject
                ;->boss (no owner).
                .IF ebx != 0  ;v3.11
                  add ebx,pTERSEDATA
                  jmp SHORT loe1
                .ELSE
                  mov ebx,g_pselectedobject
loe1:             mov eax,(OBJECT PTR [ebx]).flinks
                  .IF eax>=60
                    .IF eax<=69
                      ;note, xdblclk() does this, so redundant here...
                      ;has an attached link activator. now have to find it...
                      invoke findlinkactivator,ebx ;ret eax->activator, else eax=0.
                      .IF eax != 0 ;found.
                        ;the link activator should now take over...
                        ;post a message to xdblclk()...
  ;mov g_errorapi,0A52h ;for crash outside EVE, error codes range Axxh. v3.23
                        invoke PostMessage,g_hwnd,WM_LBUTTONDBLCLK,wparam,lparam
                      .ENDIF
                    .ENDIF
                  .ENDIF
                .ENDIF
              .ENDIF
					          	
						.ENDIF
  ;mov g_errorapi,0A53h ;for crash outside EVE, error codes range Axxh. v3.23
					  invoke InvalidateRgn, g_hwnd,0,FALSE ;inval.,not erase bkgrnd
					  mov  g_fredrawdiag,UPDATEobjs
				  .ENDIF

		  .ELSEIF g_nstate==2			 ;no mousemove, an lbuttonup, confirms
																;...this state, an obj is highlighted.
																;...can only come here from state-1.
																;g_pselectedobject=object selected.

		  .ELSEIF g_nstate==4			 ;a new object is being placed, first "end".
																;...can only come here from state-0.
				  ;error...
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0				   ;precaution. maybe redundant.
				  mov esi,g_pmovingobject  ;/
				  mov (OBJECT PTR [esi]).fstatus,0		;/
				  mov g_pmovingobject,0   ;/

		  .ELSEIF g_nstate==5			 ;a new obj is being placed, second "end".
										 ;...can only come here from state-4.

				  ;v1.99.
				  ;if placing a stretch-axes-element, don't want it to be a child
				  ;of anything, and want to go straight into state2 (selected)...
				  mov esi,g_pmovingobject
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF ax==21 ;alignment-axes-element.
					mov g_pmovingobject,0
					mov g_pselectedobject,esi
					mov g_nstateprev,5
					mov g_nstate,2
					invoke add2updatelist,esi
  ;mov g_errorapi,0A54h ;for crash outside EVE, error codes range Axxh. v3.23
					invoke InvalidateRgn, g_hwnd,0,FALSE
					mov  g_fredrawdiag,UPDATEobjs
					jmp end5
				  .ENDIF

				  ;wires with auto-stickiness disabled are an exception... v2.27
				  test (OBJECT PTR [esi]).fconfig1,01000000b
				  jnz nos1 ;do not stick.
				;if lbuttonup on an existing node,
				;set rpowner2 pointing to parent...
				;note onanobject() excludes g_pmovingobject from search...
				  invoke onanobject, g_nmousex,g_nmousey
				  ;return with eax=0 fail, else eax pts to found object.
				  mov plock,eax
						.IF eax==0
nos1:					  nop
						  ;mov esi,g_pmovingobject
						.ELSE

						  ;i want to exclude non-wire objs from setting rpowner2...
						  ;mov esi,g_pmovingobject		 ;new object.
						  mov edi,plock 						;parent object.
								mov g_nknee,0 ;paint_arc uses this.
								;firstly wipeout current position of child obj...
								invoke add2wipeoutlist, g_pmovingobject
								;invoke InvalidateRgn, g_hwnd,0,FALSE ...done in add2wipeoutlist()
								mov  g_fredrawdiag,WIPEOUTobjs
								push edi
								push esi
  ;mov g_errorapi,0A55h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke UpdateWindow, g_hwnd 			;wipe immediately.
								pop  esi
								pop  edi
						  mov ebx,(OBJECT PTR [esi]).fconfig1
						  and bl,01    ;bit0=1 if a wire-type object.
						  .IF bl==01
								  ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
								  ;assuming edi has value to be written...
								  mov  eax,edi	   ;plock
								  sub eax,pTERSEDATA
								mov (OBJECT PTR [esi]).rpowner2,eax ;lock child to parent.
								mov eax,edi
								;if both ends of wire in same parent, need to auto-
								;shift xmid/ymid outside of parent obj...
								mov ebx,(OBJECT PTR [esi]).rpowner1
								  ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
								  ;assuming ebx has value to be written...
								  .IF ebx==0
								  .ELSE
									add ebx,pTERSEDATA
								  .ENDIF
								.IF ebx==eax
								  invoke fixwiremid, edi,esi ;parent-obj,pnew-obj
								  ;a problem below, UpdateWindow() causes paint_arc()
								  ;which draws wire-mid overriding what we did in fixwiremid()
								  ;cos we're in state 5.
								  ;so, can we just get back to state 0...
								.ENDIF

								;uh-huh! newwire.nendring isn't set until paint_arc()
								;executes, as it's computed dynamicallybased on the
								;end coords.

								;so, do a quick paint...
								mov g_fredrawdiag,UPDATEobjs
								invoke add2updatelist,esi
  ;mov g_errorapi,0A56h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke InvalidateRgn, g_hwnd,0,FALSE
								push esi
  ;mov g_errorapi,0A57h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke UpdateWindow, g_hwnd
								pop esi

								;for efficiency, once we change to state0, paint_arc
								;doesn't recalc wire-ends.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								mov g_nstate,0
								mov g_pmovingobject,0
								;WARNING don't use g_pmovingobject below, use esi.

								;have problem with some objects getting wiped...
								;this adds nearby objects to update list...
								invoke nearobjects,esi

						  .ELSE
								;it's a non-wire new obj and i've released button
								;while still inside parent obj. this is a problem.
								;i need to auto-relocate the new obj outside parent...
								invoke fixnewchild,edi,esi ;plock,g_pmovingobject
						  .ENDIF
						  invoke add2updatelist,esi ;g_pmovingobject
  ;mov g_errorapi,0A58h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,FALSE
						  mov  g_fredrawdiag,UPDATEobjs
						.ENDIF
										;push eax			  ;save previous value of state.
										mov al,g_nstate 	 ;/
										mov g_nstateprev,al  ;/
										;pop eax			  ;/
				  mov g_nstate,0
				  mov g_pmovingobject,0
end5:


		  .ELSEIF g_nstate==8			 ;an object (not new) is being moved.

				;v0.99 code below is fine, but if dragging an individual handle, want to stay
				;in state8 when lbuttonup...
				;*NO* go to state2...
				mov fgoback,0
				.IF g_pmovingobject != 0 ;precaution.
						.IF g_nstateprev==2
								;go back to state2 (highlighted)...
								mov fgoback,1
						.ENDIF
				.ELSE ;precaution. should never come here.
				  mov g_nstateprev,8
				  mov g_nstate,0
				  jmp ov2
				.ENDIF

										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				mov g_nstate,0					 ;...can only come here from state-1.

				;if user was moving a wire-end, will have g_nknee=4/5.

				;v1.96 bug.
				;the code block below, for g_nknee=4 or 5, is only for sticky-wire ends,
				;but other elements will have g_nknee non-0 when dragging a handle.
				;polygon/line has g_nknee=vertice# (=1 for first vertice, bez0).
				;so, only do code block below if a wire-type element...
				mov esi,g_pmovingobject
				mov eax,(OBJECT PTR [esi]).fconfig1
				and al,01 ;bit1=1 wire-type.
				jz ov1
				  ;wires with auto-stickiness disabled are an exception... v2.27.
				  test (OBJECT PTR [esi]).fconfig1,01000000b
				  jnz ov1 ;do not stick.

				  ;if dragging a "free" end of wire, need to check if have
				  ;dragged it onto another element...
				  .IF g_nknee==4		  ;dragging first end.
						invoke onanobject, g_nmousex,g_nmousey
						;return with eax=0 fail, else eax pts to found object.
						mov plock,eax
						mov esi,g_pmovingobject
						push (OBJECT PTR [esi]).nexttype
						pop exttype
						.IF eax==0
						.ELSE
						  sub eax,pTERSEDATA
						  mov (OBJECT PTR [esi]).rpowner1,eax
								;the wire-end needs to get recalc'd (paint_arc not doing it)..
								  ;but first, wipe current position...
								  invoke add2wipeoutlist,esi
								  ;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
								  ;...done in add2wipeoutlist()
								  mov  g_fredrawdiag,WIPEOUTobjs
  ;mov g_errorapi,0A59h ;for crash outside EVE, error codes range Axxh. v3.23
								  invoke UpdateWindow, g_hwnd			 ;wipe immediately.
								mov ebx,(OBJECT PTR [esi]).xtopleft ;start-end of wire.
								mov xend,ebx									 ;/
								mov ebx,(OBJECT PTR [esi]).ytopleft ;/
								mov yend,ebx									 ;/
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov edi,plock
								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
									;this is only a precaution, as should only be a wire here...
									.IF exttype>=30
									  ;label, icon, uses a different field position for this...
									  mov eax,(OBJECT PTR [esi]).nbeginverticex ;poly vertice already on.
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
									.ENDIF
						  invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
						  ;...will return nearest point on boundary of parent, in xend/yend.
						  ;...also recalcs g_x/ydiffnorm used for arrow orientation.
								.IF exttype>=30   ;precaution again...
								  mov (OBJECT PTR [esi]).nbeginverticex,ebx ;snapped vertice if to poly.
								.ELSE
								  mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.
								.ENDIF
								  ;need to store ring# returned from snap_tonode/snap_tores
								  ;into current wire, 1st end...
								  mov (OBJECT PTR [esi]).nbeginring,eax ;al
								  ;update wire coords...
								  mov	eax,xend
								  mov (OBJECT PTR [esi]).xtopleft,eax
								  mov	eax,yend
								  mov (OBJECT PTR [esi]).ytopleft,eax
								  ;and arrow orientation...
								  ;*v111* careful here. now using these as vertices in polyline/gon,
								  ;so must not overwrite... see v1.96 note above.
								  mov eax,g_xdiffnorm
								  mov (OBJECT PTR [esi]).xdiffnorm1st,eax
								  mov eax,g_ydiffnorm
								  mov (OBJECT PTR [esi]).ydiffnorm1st,eax
						.ENDIF
				  .ELSEIF g_nknee==5 ;second end.
						invoke onanobject, g_nmousex,g_nmousey
						mov plock,eax
						mov esi,g_pmovingobject
						push (OBJECT PTR [esi]).nexttype
						pop exttype
						.IF eax==0
						.ELSE
						  sub eax,pTERSEDATA
						  mov (OBJECT PTR [esi]).rpowner2,eax
								;the wire-end needs to get recalc'd (paint_arc not doing it)..
								  ;but first, wipe current position...
								  invoke add2wipeoutlist,esi
								  ;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
								  ;...done in add2wipeoutlist()
								  mov  g_fredrawdiag,WIPEOUTobjs
  ;mov g_errorapi,0A5Ah ;for crash outside EVE, error codes range Axxh. v3.23
								  invoke UpdateWindow, g_hwnd			 ;wipe immediately.
								mov ebx,(OBJECT PTR [esi]).wwidth				;dest-end of wire.
								mov xend,ebx									 ;/
								mov ebx,(OBJECT PTR [esi]).height				;/
								mov yend,ebx									 ;/
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov edi,plock
								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
										;this is only a precaution, as should only be a wire here...
										.IF exttype>=30
										  ;label, icon, uses a different field position for this...
										  mov eax,(OBJECT PTR [esi]).nbeginverticex ;poly vertice already on.
										.ELSE
										  mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
										.ENDIF
						  invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
						  ;...will return nearest point on boundary of parent, in xend/yend.
						  ;...also recalcs g_x/ydiffnorm used for arrow orientation.
								.IF exttype>=30   ;precaution again...
								  mov (OBJECT PTR [esi]).nbeginverticex,ebx ;snapped vertice if to poly.
								.ELSE
								  mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.
								.ENDIF
								  ;need to store ring# returned from snap_tonode/snap_tores
								  ;into current wire, 1st end...
								  mov (OBJECT PTR [esi]).nendring,eax ;al
								  ;update wire coords...
								  mov	eax,xend
								  mov (OBJECT PTR [esi]).wwidth,eax
								  mov	eax,yend
								  mov (OBJECT PTR [esi]).height,eax
								  ;and arrow orientation...
								  ;*v111* careful here. now using these as vertices in polyline/gon,
								  ;so must not overwrite... see v1.96 note above.
								  mov eax,g_xdiffnorm
								  mov (OBJECT PTR [esi]).xdiffnorm2nd,eax
								  mov eax,g_ydiffnorm
								  mov (OBJECT PTR [esi]).ydiffnorm2nd,eax
						.ENDIF
				  .ENDIF
				  ;...paint_arc will update the .nbeginring/.nendring.
ov1:

				  .IF fgoback==1														 ;v0.99
								mov g_nknee,0
					;v1.97 a problem with alignment axes. last position of stretching-
					;handle not wiping...
					mov esi,g_pmovingobject
					mov eax,(OBJECT PTR [esi]).nexttype
					.IF eax==21 ;alignment axes element.
					  ;mov wipeoutsindex,0
					  invoke copyhi2wipe ;v1.99.
					  invoke add2wipeoutlist,esi
					  ;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
					  ;...done in add2wipeoutlist()
					  mov deltax,0 ;diff between last mousex, used in paint_axes().
					  mov deltay,0 ;/ (global).
					  mov  g_fredrawdiag,WIPEOUTobjs
  ;mov g_errorapi,0A5Bh ;for crash outside EVE, error codes range Axxh. v3.23
					  invoke UpdateWindow, g_hwnd			 ;wipe immediately.
					.ENDIF
						;note. had to put this here, as above code needs to be in state0.
								mov g_nstateprev,8
								mov g_nstate,2
								mov eax,g_pmovingobject
								mov g_pselectedobject,eax
;								 mov g_pmovingobject,0
				  .ENDIF

				  mov g_pmovingobject,0 ;g_pmovingobject=object being moved.
				  ;...lbuttonup stops the object moving.

ov2:
  ;mov g_errorapi,0A5Ch ;for crash outside EVE, error codes range Axxh. v3.23
			  invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
				  mov g_fredrawdiag,ENTIRE			   ;redraw entire window.
				  mov  fbumping,0				;see origincorrection & dragchilddiag.


		  .ELSEIF g_nstate==21
				  ;have placed 1st corner of selection-rectangle, but
				  ;haven't moved mouse, so invalid..
						;restore normal class cursor...
  ;mov g_errorapi,0A5Dh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
						;invoke SetCursor,g_hnormcursor ;restore cursor.
				  mov n1stx,0
				  mov n1sty,0
				  mov n2ndx,0
				  mov n2ndy,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0


		  .ELSEIF g_nstate==22
						;restore normal class cursor...
  ;mov g_errorapi,0A5Eh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
						;invoke SetCursor,g_hnormcursor ;restore cursor.
				  ;set 2nd corner of selection rectangle...
				  mov eax,g_nmousex
				  mov n2ndx,eax
				  mov eax,g_nmousey
				  mov n2ndy,eax
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0
						;this flag allows display multiple highlighted when 0...
						mov g_fclrhighlighted,0
				  ;now, have to find all elements inside rectangle and
				  ;highlight them...
		  pushad										   ;precaution, func now in C. *NO*
				  invoke highlightinsiderect	  ;NOW IN eve_C.C		*NO*
		  popad 										   ;/
						mov g_pselectedobject,0
  ;mov g_errorapi,0A5Fh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
						mov g_fredrawdiag,ENTIRE


		  .ELSE
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0						 ;error, default back to state 0.
				  mov g_pmovingobject,0
				  mov g_pselectedobjnew,0
				  mov g_pselectedobject,0
		  .ENDIF

out1:
				ret
wmlbuttonup ENDP
;------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
n1stx DWORD 0			;selection rectangle.
n1sty DWORD 0			;/
n2ndx DWORD 0			;/
n2ndy DWORD 0			;/
n2ndx0 DWORD 0 ;idm_resizesel saves original value of n2ndx here.
n2ndy0 DWORD 0 ; /
nmousex_save	DWORD 0
nmousey_save	DWORD 0
;fcanselrect BYTE 0
g_rplockedelement DWORD 0

.CODE
wmlbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL plock:DWORD
		LOCAL xend:DWORD, yend:DWORD
		LOCAL exttype:DWORD,zoom:SDWORD
		LOCAL fdeleteme:DWORD
;comes via WM_LBUTTONDOWN msg.	 "wmlbuttondown"

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() and xkey..() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

;lparam has mouse coords...x=low-word,y=hi-word
				invoke	origincorrection, lparam
								;returns corrected in g_nmousex & g_nmousey
				  ;i'll correct lparam as well, cos old goofee code expected it...
				  ;wmmousemove()>WM_USER>xuser() does.
				  mov eax,g_nmousex
				  mov WORD PTR lparam,ax
				  mov eax,g_nmousey
				  mov WORD PTR lparam+2,ax

		  mov ebx,pTERSEDATA
		  mov eax,(TERSEDATA PTR [ebx]).nzoom
		  mov zoom,eax

		  ;231100
		  ;when moving a group of elements, they simply track mouse,
		  ;deposited by lbuttonup, so do nothing here...
		  .IF fmovinghighlighted==1
				ret
		  .ENDIF

		  ;when duplicating a group of elements, they simply track mouse,
		  ;deposited by lbuttonup, so do nothing here...
		  .IF highlightedindexnewlist==0
		  .ELSE
				ret
		  .ENDIF

		  .IF g_rpani != 0 ;v3.09
		    ;set by wmmousemove() under very specific conditions, when pointer over
		    ;an element with animation activator that is required to be animated by a click.
		    ;g_rpani->animation activator. (also we are in state0).
		    mov ebx,g_rpani
		    add ebx,pTERSEDATA
        and (OBJECT PTR [ebx]).fconfig2,0FFFFFEFFh ;clr bit8.
        ;...bit8=0 actually *starts* the event.	(xtimer() will animate it).        	
          ;v3.14
          ;a problem if triggered by mouseclick, not stopping until wmmousemove()
          ;detects a mouse-out. also, if a finger cursor, stays until mouse-out....
          mov eax,(OBJECT PTR [ebx]).fconfig2
          and al,1110000b ;bits6,5,4 =011 mouseclick.
          .IF al==0110000b
            ;wmmousemove() sets bit17 if mouse-out, so let's do this, see if xtimer()
            ;will stop animation when returns to home...
            or (OBJECT PTR [ebx]).fconfig2,20000h ;set bit17, mouse-out.
            ;also, want to get rid of any finger cursor immediately...
            mov eax,(OBJECT PTR [ebx]).fconfig2
            and eax,10000h ;bit16=1 finger cursor when mouse-over.
            .IF eax != 0
  ;mov g_errorapi,0A60h ;for crash outside EVE, error codes range Axxh. v3.23
              invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
            .ENDIF
          .ENDIF
          
		    mov g_rpani,0 ;need to curtail life span of this.
		    ;...actually, g_rpani gets clrd every wmmousemove().
		      ;v3.10 a problem, don't want to select the element and get into state1,
		      ;but do want to find out if a goto link activator is attached...
		      ;um, we do know what mouse is over...		
		      mov edi,(OBJECT PTR [ebx]).rpowner1
		      .IF edi != 0
		        add edi,pTERSEDATA
		        mov eax,(OBJECT PTR [edi]).flinks
		        .IF eax != 0 ;non-0 have attached link activator.
		          ;need to know if it is activated by a mouse-click...
		          jmp ji1 ;try normal processing code, will go to state1, then
		          ;wmbuttonup() will post a msg to xdblclk() to perform the link action.
		        .ENDIF
		      .ENDIF
		
      .ELSEIF g_nstate==0						;normal state at startup & during operation.
				  ;need to decide if button-press is on an object...

fas5:				;v1.92 can have a resize rectangle...
					mov ebx,pTERSEDATA ;must have here as jump in from below, state30.
					mov eax,(TERSEDATA PTR [ebx]).fviewprefs
					and al,0100000b ;bit5 display resize rectangle.
					.IF al==0100000b
					  invoke onresizerect,g_nmousex,g_nmousey
					  .IF eax==0 ;fail.
fas1:					xor (TERSEDATA PTR [ebx]).fviewprefs,0100000b ;clr bit5.
						mov g_nknee,0
						;may come here while in state30, so clr...
						mov al,g_nstate
						mov g_nstateprev,al
						mov g_nstate,0
						 .IF g_pshadowmem != 0 ;precaution.
  ;mov g_errorapi,0A61h ;for crash outside EVE, error codes range Axxh. v3.23
						   invoke GlobalHandle,g_pshadowmem
						   invoke GlobalFree,eax
						   mov g_pshadowmem,0
						   ;mov nrotquad,0 ;see rot90hi().
						 .ENDIF
						jmp fas2
					  .ELSE
						.IF g_nknee==1 ;right handle.
fas0:					  ;let's have a new state for wmmousemove()...
										mov al,g_nstate 	 ;/
										mov g_nstateprev,al  ;/
						  mov g_nstate,30
						  jmp out1
						.ELSEIF g_nknee==2 ;bottom handle.
						  jmp fas0
						.ELSE ;fail.
						  jmp fas1
						.ENDIF
					  .ENDIF
					.ENDIF

				  ;if so, we go to state=1 and g_pselectedobjnew >object...
				  invoke onanobject, g_nmousex,g_nmousey
						;return with eax=0 fail, else eax pts to found object.
						.IF eax==0
						  ;do nothing
fail1:					  mov g_pselectedobjnew,0			;precaution.
						  .IF highlightedindex==0

							;v1.60
							;why not use this for drawing a selection
							;rectangle, as per IDM_RECT?...
								invoke zeroabsoluteptrs,1 ;precaution.
								;need a cross-hair cursor...
  ;mov g_errorapi,0A62h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hcrosshair ;NULL
								;...remove class cursor, allows a replacement.
								;invoke SetCursor,g_hcrosshair
								;wherever press left-button, start corner,
								;release button, end corner...
								mov g_nstate,20
								jmp s20 ;go to state21.

						  .ELSE
fas2:							mov g_fclrhighlighted,1
								mov highlightedindex,0
								;...the flag set will cause paint_*() to clr .fconfig2/bit7,
								;removing any highlighting. the index removes list of
								;highlighted objects.
								invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
								mov g_fredrawdiag,ENTIRE
						  .ENDIF
						.ELSE
						  mov edi,eax
ji1:				  mov g_rplockedelement,0 ;v1.87
						  mov eax,(OBJECT PTR [edi]).fconfig4
						  and al,01000b
						  .IF al==01000b ;bit3.
								;element is locked, cannot be dragged(except by parent)
								;or selected...
							  mov ebx,edi			   ;v1.87
							  sub ebx,pTERSEDATA
							  mov g_rplockedelement,ebx ;used in xdblclk().
							  ;...want to allow dblclk on locked icon.
								;let's try selecting it's owner...
								mov ebx,(OBJECT PTR [edi]).rpowner1
								.IF ebx==0
								  ;has no owner, but is locked...
								  ;jmp fail1
								  ;v1.81 previously couldn't drag it, but i want to be able
								  ;to, but remove its indepence --ie, a highlighted parent
								  ;is now locked and can't move without the children.
								  ;(look in drag_ methods). for here, just free it...
								  jmp found1
								.ELSE
try1:							  add ebx,pTERSEDATA
								  mov eax,(OBJECT PTR [ebx]).fconfig4
								  and al,01000b
								  .IF al==01000b ;locked.
										mov eax,(OBJECT PTR [ebx]).rpowner1
										.IF eax==0
										  ;jmp fail1
										  ;v1.81 has no parent, but lock-flag set.
										  ;this is still a valid boss...
										  jmp fnd3
										.ELSE
										  mov ebx,eax
										  jmp try1
										.ENDIF
								  .ELSE
fnd3:									;have found owner of the group...
										mov edi,ebx
										  ;there is a problem with the composite-element jumping...
										  ;as mouse is way off owner-element of group...
										  ;so recalc g_xdiff/g_ydiff...
										  ;call the specific method for owner...
								;on_arc may get confused if this non-0...
								mov g_pselectedobject,0
							;call the method to test if mouse an an object...
;NO 	  mov ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
;NO 	  invoke onPTR PTR [ebx+ptrs+ponobject], edi,g_nmousex,g_nmousey
							;returns eax=0 fail, else eax pts to object.--ignore.
							;...sets g_xdiff/g_ydiff.
										;we are pretending mouse is on the owner...
										;if a wire, set g_nknee=0, for drag entire element...
										;(drag_arc/drag_node,etc use this)...
										mov g_nknee,0
										  ;no need, all of the on_ methods have this
										  ;same code...
										  mov ecx,(OBJECT PTR [edi]).ymid
										  mov eax,g_nmousey
										  sub eax,ecx							;nmousey-ymid
										  mov g_ydiff,eax						;save.
										  ;x coords...
										  mov ecx,(OBJECT PTR [edi]).xmid
										  mov eax,g_nmousex
										  sub eax,ecx							;nmousex-xmid
										  mov g_xdiff,eax						;save.
										  ;...note, when press left button on a element that is not
										  ;locked to anything, g_xdiff/g_ydiff gets loaded inside the
										  ;on_***() method for that element.
										
										jmp found1
								  .ENDIF
								.ENDIF
								jmp fail1
						  .ELSE
found1: 					mov g_pselectedobjnew,edi ;eax
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								mov g_nstate,1
						  .ENDIF
						.ENDIF



		  .ELSEIF g_nstate==1			 ;a prior lbuttondn has highlighted an obj.
																;...can only come here from state-0.
																;g_pselectedobjnew=object selected.
				  ;error...  cannot be in this state when lbuttondn...
				  mov g_pselectedobjnew,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0

		  .ELSEIF g_nstate==2
			mov fdeleteme,0
				;lbuttondown/state0/on an object > state1 > no mousemove > lbuttonup
				; > state2. If do another lbuttondown, toggle the highlighted
				;object off, regardless where button pressed...NO...

;				   ;v1.98
;				   ;if press on alignment-axes element, need to make it the
;				   ;selected one immediately, and copy previous onto highlighted list...
;				   invoke onanobject,g_nmousex,g_nmousey
;				   ;return with eax=0 fail, else eax pts to found object.
;				   .IF eax==0
;				   .ELSE
;						 mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).nexttype
;						 .IF ecx==21 ;alignment axes element.
;						   .IF g_pselectedobject != 21 ;ignore if already alignmentaxes.
;							   ;have pressed button on alignment-axes element, a different
;							   ;element currently highlighted. currently highlighted
;							   ; must be moved to highlighted list to stretch (done in
;							   ;stretchhighlighted())...
;								 ;i think what i want to do now is stay in state2, change over
;								 ;to the alignment-axes as selected...
;								 mov ebx,g_pselectedobject
;								 mov g_pselectedobject,eax ;alignment-axes element.
;							   .IF highlightedindex==0
;								 .IF ebx==0  ;don't think will ever come here.
;								   ;error...
;								   invoke myerrorhandler,3
;								 .ELSE
;								   ;puts slaves as well into list...
;								   invoke add2highlightedlist,ebx
;								 .ENDIF
;							   .ENDIF
;							   mov ebx,g_pselectedobject
;							   mov eax,(OBJECT PTR [ebx]).number ;top-right of window.
;							   invoke displaynumber,eax 		 ;/
;							   invoke add2updatelist,ebx ;g_pselectedobject
;							   invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
;							   mov g_fredrawdiag,UPDATEobjs
;							   jmp end2  ;stay in state2.
;						   .ENDIF
;						 .ENDIF
;				   .ENDIF
;tss1:

				.IF g_pselectedobject==0
				.ELSE
				  ;well, if have clicked on a wire that is already highlighted,
				  ;may have clicked on one of the "controls", knee2 and knee3...
				  ;if so, allow to drag the control...
				  mov esi,g_pselectedobject
				  mov eax,(OBJECT PTR [esi]).fconfig1
				  and al,01
				  .IF al==01	;wire-type object
								 ;invoke onanobject, g_nmousex,g_nmousey
								 ;no, can't call onanobject(), must call the method for
								 ;wire directly, to only quiz the one object...
								 invoke on_arc, g_pselectedobject,g_nmousex,g_nmousey
						  ;return with eax=0 fail, else eax pts to found object.
						  .IF eax==g_pselectedobject  ;have clicked on a wire
								.IF g_nknee==1 ;middle of wire.  ;		/ that is already highlighted.
								  jmp SHORT s2to8
								.ELSEIF g_nknee==2
								  jmp SHORT s2to8
								.ELSEIF g_nknee==3		  ;2nd-half-mid
								  jmp SHORT s2to8
								.ELSEIF g_nknee==4		  ;start of wire.
								  jmp SHORT s2to8
								.ELSEIF g_nknee==5		  ;destination of wire.
s2to8:
										mov al,g_nstate
										mov g_nstateprev,al
								  mov g_nstate,8
								  mov eax,g_pselectedobject
								  mov g_pmovingobject,eax
								  mov g_pselectedobject,0
								.ELSE
								  jmp s2to0
								.ENDIF
						  .ELSE
								jmp s2to0
						  .ENDIF
				  .ELSE
						;oh, but now putting handles onto more objects...
						;for now, just polygons...
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==5 ;polygon
						  ;invoke on_poly, g_pselectedobject,g_nmousex,g_nmousey
p33:					  mov ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
			  invoke onPTR PTR [ebx+ptrs+ponobject],g_pselectedobject,g_nmousex,g_nmousey
						  ;...return with eax=0 fail, else eax pts to found object.
						  ;...returns with g_nknee =which corner clicked on.
						  .IF eax==0
								jmp s2to0
						  .ENDIF
						  .IF eax==g_pselectedobject  ;have clicked on an element
								.IF g_nknee==0			  ; that is already highlighted.
								  jmp s2to0
								.ELSE
								  jmp s2to8
								.ENDIF
						  .ENDIF
						.ELSEIF ax==0 ;ellipse
						  jmp p33
						.ELSEIF ax==3 ;rectangle
						  jmp p33
						.ELSEIF ax==4 ;rounded rectangle
						  jmp p33
						.ELSEIF ax==33 ;label v1.22 now has resize handle.
						  jmp p33
						.ELSEIF ax==21 ;alignment-axes-element.
						  ;v1.99
							;.fconfig1/bit3 is a "stopped" flag in elements of highlighted
							;list, used by stretchhighlighted() to stop entire comp-objs
							;when aligning... clr the bits here...
							invoke stoppedbit2hi,0 ;0 causes clr all.
						  ;alignment-axes-element (stretching) is currently selected.
						  ;if i have now pressed left button anywhere else, I want to
						  ;delete the axes-element...
						  invoke on_axes,esi,g_nmousex,g_nmousey
						  ;return with eax=0 fail, else eax pts to found object.
						  .IF eax==0
							;i have to wipe the selected element first, before can
							;delete it, so set a flag...
							mov fdeleteme,esi
							invoke copyhi2wipe ;v1.99.
							jmp s2to0
						  .ELSE
							jmp p33 ;behaviour as per prev version. convoluted code!
						  .ENDIF
						.ELSE
						   ;v1.47
						   ;for all solid-type elements, if already highlighted, i want to
						   ;test if on a handle. i've decided that allow dragging entire
						   ;element while highlighted...
						   jmp p33
s2to0:					  mov g_nknee,0
						  invoke add2wipeoutlist, g_pselectedobject
						  mov  g_fredrawdiag,WIPEOUTobjs
						  mov  eax,g_pselectedobject
						  mov  g_pselectedobject,0  ;else paint_ will use black brush.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0
						  push eax
  ;mov g_errorapi,0A63h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke UpdateWindow, g_hwnd							;wipe immediately.
						  pop  eax

							;v1.99 see above.
							.IF fdeleteme != 0
							  mov esi,fdeleteme ;actually has ptr to element to be deleted.
							  ;...which is the g_phighlightedelement.
							  mov  ebx,(OBJECT PTR [esi]).rpmethods
							  invoke deletePTR PTR [ebx+ptrs+pdelete],esi ;delete the object.
							  mov fdeleteme,0
							  jmp red1
							.ENDIF

								;v1.18 we have a problem when previously-highlighted element
								;redraws, could draw on top of something it is supposed to be
								;underneath (and other thing may not be a slave), so code below
								;doesn't work properly.
								;so, instead redraw entire window, but this is a problem when zoomed
								;out. so, check for zoom factor...
								;;add all slaves to update list...
								;push eax
								;invoke add2updatelist, eax 	   ;g_pselectedobject
								;pop  eax
								;invoke updateslaves, eax,0,0 ;0,0=no change in coords.
								;;...i added g_phighlighted first, cos get drawn first.
								;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								;mov	   g_fredrawdiag,UPDATEobjs
								;new code v1.18:
								.IF SDWORD PTR zoom > 1 ;=0 is normal zoom.
								  ;use same code as before...
								  ;add all slaves to update list...
								  invoke updateslaves, eax,0,0, 0 ;0,0=no change in coords.
								  ;...g_pselectedobject (eax) will also get added.
  ;mov g_errorapi,0A64h ;for crash outside EVE, error codes range Axxh. v3.23
								  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								  mov g_fredrawdiag,UPDATEobjs
								.ELSE
								  ;redraw entire window, so all elements painted in right order...
red1:
  ;mov g_errorapi,0A65h ;for crash outside EVE, error codes range Axxh. v3.23
							  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								  mov g_fredrawdiag,ENTIRE
								.ENDIF

								mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0
						.ENDIF
				  .ENDIF
				.ENDIF
end2:


		  .ELSEIF g_nstate==4			 ;a new object is being placed, first "end".
																;...can only come here from state-0.
          mov pmoving0,0 ;see wipeoutslaves() v2.80.
				  mov esi,g_pmovingobject
				  mov poldmovingobject,esi
				  ;...used to delete last object, even if not highlighted.
				  ;(refer xkeydown())
				  mov eax,(OBJECT PTR [esi]).nexttype
				  mov exttype,eax

;i want to detect if a new object is placed on top of an existing one...
;note onanobject() excludes g_pmovingobject from search...
				  ;wires with auto-stickiness disabled are an exception... v2.27
				  test (OBJECT PTR [esi]).fconfig1,01000000b
				  jnz nos1 ;do not stick.

				  invoke onanobject, g_nmousex,g_nmousey
				  ;return with eax=0 fail, else eax pts to found object.
				  mov plock,eax
						.IF eax==0
						  mov g_xdiff,0 ;fixes a bug. new poly was jumping, lbtndown->mmove. v3.21
						  mov g_ydiff,0 ;onanobject() was corrupting these, should be zero.
nos1:					  nop
						  ;mov esi,g_pmovingobject
						.ELSE
						  ;mov esi,g_pmovingobject

;v1.50							;tell the immediate-parent that it has a child-node...
;								 mov ebx,plock
;								 inc (OBJECT PTR [ebx]).nchildren ;non-0 means has child

						  ;set newobject.nbeginring here, and later on when paint_label()
						  ;and paint_cond() call snap_tonode(), this ring# is
						  ;passed and it is snapped to...
						  ;ALL OBJECT PTRS RELATIVE TO START TERSEDATA...
						  mov eax,plock
						  sub eax,pTERSEDATA
						  mov (OBJECT PTR [esi]).rpowner1,eax
								mov eax,g_nmousex
								mov xend,eax
								mov eax,g_nmousey
								mov yend,eax
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov edi,plock
								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  .IF exttype>=30 ;label, icon.
										mov eax,(OBJECT PTR [esi]).nbeginverticex ;poly vertice already on.
								  .ELSE ;database has different location for wires, etc for this....
										mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
								  .ENDIF
						  invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
						  ;...will return nearest point on boundary of parent, in xend/yend.
						  ;...also recalcs g_x/ydiffnorm used for arrow orientation.
						  .IF exttype>=30
								mov (OBJECT PTR [esi]).nbeginverticex,ebx ;snapped vertice if to poly.
						  .ELSE
								mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.
						  .ENDIF
								  ;need to store ring# returned from snap_tonode/snap_tores
								  ;into current wire, 1st end...
								  mov (OBJECT PTR [esi]).nbeginring,eax ;al
								  ;update wire coords...
								  mov	eax,xend
;								  mov (OBJECT PTR [esi]).xtopleft,eax
								  mov	eax,yend
;								  mov (OBJECT PTR [esi]).ytopleft,eax
						  ;*v111* careful here. now using these as vertices in polyline/gon,
						  ;so must not overwrite...
						  .IF exttype==5		 ;polyline or polygon.
						  .ELSEIF exttype==6 ;temp polyline during creation, becomes 5.
						  .ELSE
								  ;and arrow orientation...
								  mov eax,g_xdiffnorm
								  mov (OBJECT PTR [esi]).xdiffnorm1st,eax
								  mov eax,g_ydiffnorm
								  mov (OBJECT PTR [esi]).ydiffnorm1st,eax
						  .ENDIF

						.ENDIF
										;push eax						  ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										;pop eax						  ;/
				  mov g_nstate,5



		  .ELSEIF g_nstate==5			 ;a new obj is being placed, second "end".
																;...can only come here from state-4.
				  ;error...  (cannot already be in this state at lbuttondn)
										;push eax						  ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										;pop eax						  ;/
				  mov g_nstate,0								  ;precaution


		  .ELSEIF g_nstate==8			 ;an object is being moved.
				  invoke add2updatelist, g_pmovingobject
																;...can only come here from state-1.
																;g_pmovingobject=object being moved.

;				 ;v0.99 if got into state8(moving an object, with g_pmovingobject non-0)
;				 ;via state2(highlighted object) then am able to drag individual handles,
;				 ;and want to stay in state8...
;				 .IF g_pmovingobject != 0 ;precaution.
;						 .IF g_nstateprev==2
;						   ;stay in state8.
;						   jmp e00
;						 .ENDIF
;				 .ENDIF

				  ;error... (cannot already be in this state at lbuttondn)
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0								  ;precaution
				  mov g_pselectedobject,0	 ;/
				  mov g_pselectedobjnew,0	 ;/
e00:


		  .ELSEIF g_nstate==20 ;first corner of a selection-rectangle.
				;created via menu "control/selection rectangle" -> IDM_RECT
				; -> g_nstate=20.
s20:			mov eax,g_nmousex
				mov n1stx,eax
				mov eax,g_nmousey
				mov n1sty,eax
					   push eax 						;save previous value of state.
					   mov al,g_nstate			;/
					   mov g_nstateprev,al	;/
					   pop eax							;/
				mov g_nstate,21

		  .ELSEIF g_nstate==21
				;a mousemove will set state=22, so if come here, invalid...
				mov n1stx,0
				mov n1sty,0
				mov n2ndx,0
				mov n2ndy,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				mov g_nstate,0

		  .ELSEIF g_nstate==22
				;clicked to place 1st corner, now clicking again, but ignore
				;now, respond on buttonup to set 2nd corner.


		  .ELSEIF g_nstate==30 ;resize rect is displayed.  v1.92.
			;resize handle is being displayed, a handle has been dragged.
			;go back to and test if on a handle again...
			jmp fas5

		  .ELSE
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				 mov g_nstate,0 						;error, default back to state 0.
				 mov g_pselectedobject,0
				 mov g_pselectedobjnew,0
		  .ENDIF

out1:	  ret
wmlbuttondown ENDP
;------------------------------------------------------------------------
;------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
prbuttonobject DWORD 0 ;global, but restricted use.
prbuttonobject0 DWORD 0 ;v3.25

.CODE
wmrbuttondown PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL hmenu:DWORD,hpopupmenu:DWORD,mpoint:POINT
;comes via WM_RBUTTONDOWN msg.	   "wmrbuttondown" *EVE*
;the basic purpose is to popup a dialog box if mouse over an object.

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

		mov poldmovingobject,0 ;see wmlbuttondown/state4
		mov pmoving0,0 ;see wipeoutslaves(). v2.80

;lparam has mouse coords...x=low-word,y=hi-word

				xor eax,eax
				mov ax,WORD PTR lparam
				mov mpoint.pt_x,eax
				xor eax,eax
				mov ax,WORD PTR lparam+2
				mov mpoint.pt_y,eax

				invoke	origincorrection, lparam
								;returns corrected in g_nmousex & g_nmousey
				  ;i'll correct lparam as well, cos old goofee code expected it...
				  ;wmmousemove()>WM_USER>xuser() does.
				  mov eax,g_nmousex
				  mov WORD PTR lparam,ax
				  mov eax,g_nmousey
				  mov WORD PTR lparam+2,ax

		;v1.92
		;if a resize rect is being displayed, get rid of it...
		;we could be in state0 or 30. 0 when it 1st displays, 30 after dragging a handle.
		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).fviewprefs
		and al,0100000b ;bit5=1 display resize rect.
		.IF al==0100000b
		  .IF g_pshadowmem != 0 ;precaution.
  ;mov g_errorapi,0A66h ;for crash outside EVE, error codes range Axxh. v3.23
			invoke GlobalHandle,g_pshadowmem
			invoke GlobalFree,eax
			mov g_pshadowmem,0
			;mov nrotquad,0 ;see rot90hi().
		  .ENDIF
		  jmp fas6
		.ENDIF


		.IF g_nstate==0
		  ;test if mouse cursor on an object...
d88:	  invoke onanobject, g_nmousex,g_nmousey
		  ;return with eax=0 fail, else eax pts to found object.
		  .IF eax==0

d90:		;do a timeout before popping up the "Elements" menu...
  ;mov g_errorapi,0A67h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke Sleep,500 ;sleep for 500msec.
				invoke GetAsyncKeyState,VK_RBUTTON
				.IF SDWORD PTR eax>=0 ;msb set, right-button is down.
				  jmp j11
				.ENDIF

				;I would like to popup an "Elements" menu...
  ;mov g_errorapi,0A68h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke LoadMenuA,g_hinst,ADDR szeve
				mov hmenu,eax
				invoke GetSubMenu,eax,1
				mov hpopupmenu,eax
				invoke ClientToScreen,g_hwnd,ADDR mpoint  ;converted to screen coords
				invoke TrackPopupMenu,hpopupmenu,TPM_LEFTALIGN+TPM_RIGHTBUTTON, \
				  mpoint.pt_x,mpoint.pt_y,0,g_hwnd,0
				;...should cause a WM_COMMand msg to be sent to this app after exit,
				;with the wparam having the menu item id.
				invoke DestroyWindow,hmenu


j11:		;right-click somewhere on screen, not on an object, redraw
				;everything, wiping background...
				  ;051100 bug fix...
				  ;if have multiple highlighted elements, for code gen or
				  ;duplication, by holding down shift key, when operation is
				  ;finished, wmpaint() will use this flag to remove highlighting,
				  ;but only for elements that get redrawn. some elements further
				  ;away can miss out. hack-fix now is to set flag again when
				  ;do right-click, to wipe any highlighting...
				  mov g_fclrhighlighted,1
				mov g_fredrawdiag,ENTIRE
  ;mov g_errorapi,0A69h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background
				pushad
				invoke UpdateWindow,g_hwnd
				popad
		  .ELSE
			  mov edi,eax
			  mov prbuttonobject,eax ;global needed by callbacks.

			  ;v1.82
			  ;i want to be able to prevent pop-up of dlg-box of children of comp-obj
			  ;when boss-element is locked (as well as itself)...
			  ;(exception is if already highlighted, comes to d89: from state2 below)
			  ;want modified dlg-boxes for text-label ...and maybe boss?....
						  mov eax,(OBJECT PTR [edi]).fconfig4
						  and al,01000b
						  .IF al==01000b ;bit3.
								;element is locked. let's find it's owner...
								mov ebx,(OBJECT PTR [edi]).rpowner1
								.IF ebx==0
								  ;has no owner, but is locked...
								  ;ok, only allow a lock-object dlgbox...
								  ;(icon is a problem, as may want to leave it locked and
								  ; still edit it, cos of the custom width/height fields need
								  ; locked set)
now1:							lea ecx,lockproc
								  mov eax,403	   ;resource number in eve.rc
								  jmp dbx1
								.ELSE
try1:							add ebx,pTERSEDATA
								  mov eax,(OBJECT PTR [ebx]).fconfig4
								  and al,01000b
								  .IF al==01000b ;locked.
										mov eax,(OBJECT PTR [ebx]).rpowner1
										.IF eax==0
										  ;found boss, but lock-flag set.
										  ;...want to curtail the right-click dlg-box of child.
										  ;if it's a label, allow a text-field dlgbox...
										  mov eax,(OBJECT PTR [edi]).nexttype
										  .IF al==33 ;label
										  
										    ;v3.06 a locked label can now have it's handle hidden, which
										    ;should also mean that it is uneditable by r-click...
										    mov eax,(OBJECT PTR [edi]).fconfig1
										    and ax,100h ;bit8=1 don't display handle.
										    .IF ax != 0
										      ;get out.
										      ;*NOTE* r-click on a comp-obj needs a bit more work here,
										      ;as when boss locked, doesn't respond to r-click anywhere
										      ;except on the boss ...is this what we want?
										    .ELSE
											    lea ecx,textfieldproc
											    mov eax,402 	 ;resource number in eve.rc
dbx1:										  invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
                        .ENDIF
                        
										  .ENDIF
										  jmp out1 ;do nothing, get out (clrs prbuttonobject also).
										.ELSE
										  mov ebx,eax
										  jmp try1
										.ENDIF
								  .ELSE
									;have found owner of the group...
									;not locked.
								  .ENDIF
								.ENDIF
						  .ENDIF


d89:			;mov prbuttonobject,eax
				mov eax,(OBJECT PTR [edi]).fconfig1
				and al,01
				.IF al==01				;wire type.
				  mov eax,(OBJECT PTR [edi]).nexttype
				  .IF ax==11 ;*EVE* curved line
g22:					lea ecx,KENTER2proc  ;wireproc()
						mov eax,206  ;resource number of KENTER2 in eve.rc
						invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
				  .ELSEIF ax==12 ;segmented line.
						jmp g22
				  .ELSEIF ax==13 ;straight line.
						jmp g22
				  .ENDIF
				.ELSE					;non-wire type
				  mov eax,(OBJECT PTR [edi]).nexttype
				  .IF ax==0    ;normal node  ;*EVE* ellipse. ...closed-elements
						  lea ecx,KENTER5proc	  ;nodeproc
						  mov eax,205					 ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp dlgb1
				  .ELSEIF ax==3    ;*EVE* rectangle
p30:					lea ecx,resproc
						  mov eax,203					 ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp dlgb1
				  .ELSEIF ax==4    ;rectangle,rounded corners.
						jmp p30
				  .ELSEIF ax==5 ;ploygon.
						  lea ecx,polyproc
						  mov eax,204					 ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp SHORT dlgb1
				  .ELSEIF ax==20 ;grid.
						  lea ecx,gridproc
						  mov eax,300	   ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
              jmp SHORT dlgb1
				  .ELSEIF ax==33		;label *EVE* ...label-element.
						  lea ecx,KENTER33proc						 ;labelproc
						  mov eax,208	   ;resource number of KENTER33 in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp SHORT dlgb1
				  .ELSEIF ax==40		;animation activator.
						  lea ecx,aniproc
						  mov eax,401	   ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp SHORT dlgb1
				  .ELSEIF ax==41		;link activator. v2.76
						  lea ecx,linkproc ;similar to iconproc().
						  mov eax,219	   ;resource number in eve.rc
dlgb1:			  invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0

				  .ELSEIF ax==42		;inline SVG code. v3.25.
IFE fDEVELOPER  ;v3.25
ELSE
            .IF prbuttonobject0==0 ;prevents reentry
              mov eax,prbuttonobject ;note, gets clrd immediately further down.
              mov prbuttonobject0,eax ;used in inlineproc().
						  lea ecx,inlineproc ;
						  mov eax,405	   ;resource number in eve.rc
						  invoke DialogBoxParam,g_hinst,eax,0,ecx,0		 ;NO OWNER WINDOW!
						  ;...allows to keep window up while work on eve diagram.
						  mov prbuttonobject0,0 ;only comes here when dlgbox exited.
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ENDIF
ENDIF
						
				  .ELSEIF ax>=60		;execution-icon    *EVE*
						.IF ax<=69
						  ;60=execution-icon, 61=textfile-icon, 62=eve-icon, 63=generic-icon,
						  ;64= ,65=  ...up to 69 set aside for icons.
						  lea ecx,iconproc ;was commandproc
						  mov eax,200 ;was222		 ;resource number in eve.rc
						  ;invoke DialogBoxParam, g_hinst,eax,g_hwnd,ecx,0
						  jmp dlgb1
						.ELSE
						.ENDIF
				  .ENDIF
				.ENDIF
		  .ENDIF

		.ELSEIF g_nstate==2

			;v1.99
			;an alignment-axes-element has a limited life. get rid of it...
			mov esi,g_pselectedobject
		   .IF esi != 0
			 mov eax,(OBJECT PTR [esi]).nexttype
			 .IF eax==21 ;alignment-axes.
							;.fconfig1/bit3 is a "stopped" flag in elements of highlighted
							;list, used by stretchhighlighted() to stop entire comp-objs
							;when aligning... clr the bits here...
							invoke stoppedbit2hi,0 ;0 causes clr all.
			   mov	ebx,(OBJECT PTR [esi]).rpmethods
			   invoke deletePTR PTR [ebx+ptrs+pdelete],esi ;delete the object.
			   jmp fas6
			 .ENDIF
		   .ENDIF

		  ;what about other g_nstates?...
		  ;if highlight objects with <shift> held down, afterward is in state0,
		  ;so above works, screen redraws, highlighting disappears.
		  ;but, if highlight just one object without <shift>, state becomes 2.
		  ;would like complete redraw to work for state2...
		  ;also, will be able to popup dlgbox if on an element...
		  ;mov g_pselectedobject,0  ;the object highlighted in state2.
		  ;mov g_nstate,0
		  ;jmp d88 NO...
		  ;further qualification to this... i would really like the dlgbox
		  ;for the already-highlighted object to come up, not something
		  ;else hidden underneath...
				invoke onanobject, g_nmousex,g_nmousey
				;return with eax=0 fail, else eax pts to found object.
				.IF eax==0
				  mov g_pselectedobject,0  ;the object highlighted in state2.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0
				  jmp d90 ;redraw scrn, popup menu.
				.ELSE ;discard whatever it's on.
				  mov eax,g_pselectedobject ;used at d89:
				  mov g_pselectedobject,0  ;the object highlighted in state2.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0

				  ;have a problem, if some objs highlighted prior to right-click, seems to
				  ;be going back to state0 but obj doesn't get redrawn (sometimes) and the
				  ;highlighting/handles are still there. so, let's force a redraw...
				  mov edi,eax											;*MAY NEED TO WIPE IT*
				  invoke add2wipeoutlist,edi
				  ;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  ;...done in add2wipeoutlist()
				  mov  g_fredrawdiag,WIPEOUTobjs
  ;mov g_errorapi,0A6Ah ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke UpdateWindow,g_hwnd
					;v1.82
					;going to pop-up dlg box, but want to exclude free locked element...
						  mov eax,(OBJECT PTR [edi]).fconfig4
						  and al,01000b
						  .IF al==01000b ;bit3.
								;element is locked. let's find it's owner...
								mov ebx,(OBJECT PTR [edi]).rpowner1
								.IF ebx==0
								  ;has no owner, but is locked...
								  ;pop up a special locked dlg box...
								  mov eax,edi
								  mov prbuttonobject,eax  ;needed by callback.
								  jmp now1
								.ENDIF
						  .ENDIF
				  ;continue popup normal dlgbox,as case of lockedchild-elements and any unlocked...
				  mov eax,edi
				  mov prbuttonobject,eax  ;global, needed by callback.
				  jmp d89  ;pop up a dlg box.
				.ENDIF

		.ELSEIF g_nstate==30 ;resize rect is displayed.  v1.92.
fas6:				mov g_pselectedobject,0	;precaution
					mov al,g_nstate
					mov g_nstateprev,al
				  mov g_nstate,0
				  mov g_nknee,0
				  mov highlightedindex,0
				  mov g_fclrhighlighted,1 ;precaution.
				  mov ebx,pTERSEDATA
				  and (TERSEDATA PTR [ebx]).fviewprefs,0FFFFFFDFh ;clr bit5.
  ;mov g_errorapi,0A6Bh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
		  mov  g_fredrawdiag,ENTIRE


		.ENDIF

out1:	mov prbuttonobject,0
		ret
wmrbuttondown ENDP

;------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
g_windowright DWORD 0

.CODE
wmsize PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
;WM_SIZE causes this, in response to window size changing. "wmsize" *EVE*

  ;mov g_errorapi,0A6Ch ;for crash outside EVE, error codes range Axxh. v3.23
				invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
				mov g_fredrawdiag,ENTIRE								;redraw entire window.

;clientrectold is not "old" --it is the current physical client coords.
;i.e. top,left =0,0 bot,right = height,width of client region.
  ;mov g_errorapi,0A6Dh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetClientRect, g_hwnd, ADDR clientrectold ;backup copy.

;save width and height of client area...
				mov  ax,WORD PTR lparam ;(used by xkeydown)
				cwde
				mov  xclientpixels,eax
				mov  ax,WORD PTR lparam+2
				cwde
				mov  yclientpixels,eax

;280900
;update window coords...
  ;mov g_errorapi,0A6Eh ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GetWindowRect, g_hwnd, ADDR windowrect			;used for clipping.
						  ;... see scrollingbymouse()
				;v1.21
				;scrollingbymouse() modifies windowrect<>, need save actual right
				;boundary for placement of x/y mouse coords... (see also wmcreate())
				mov eax,windowrect.rc_right ;screen coords.
				sub eax,windowrect.rc_left
				mov g_windowright,eax ;window-relative coords.

;280900
;there seems to be a problem with clientrect not getting updated.
;this results in some elements not drawing when the window is resized.
				mov eax,clientrect.rc_left
				add eax,xclientpixels
				mov clientrect.rc_right,eax
				mov eax,clientrect.rc_top
				add eax,yclientpixels
				mov clientrect.rc_bottom,eax

		ret
wmsize ENDP
;-----------------------------------------------------------------------------
szfilter DB "EVE Data Files ",0,"*.eve",0,0
				 DB 20 DUP(0)
szemffilter DB "Enhanced Metafiles ",0,"*.emf",0,0
				 DB 20 DUP(0)
szwmffilter DB "Windows Metafiles ",0,"*.wmf",0,0
				 DB 20 DUP(0)
szembeddedfilter DB "Embedded EVE Files ",0,"*.eve.exe",0,0
				 DB 20 DUP(0)
sizeszfile EQU 260 ;256 v3.47
szdeffile				 DB "*.eve", sizeszfile-4 DUP(0)
szdefemffile	 DB "*.emf", sizeszfile-4 DUP(0)
szdefwmffile	 DB "*.wmf", sizeszfile-4 DUP(0)
szextension DB "eve",0
szemfextension DB "emf",0
szwmfextension DB "wmf",0
szembeddedextension DB "exe",0
;stuff for eve.ini file...
szsectionopen  BYTE "open",0
szentryfile1   BYTE "file1",0
szeveini	   BYTE "eve.ini",0


.DATA
szfile	 DB "*.eve", sizeszfile-5 DUP(0)
szemffile				 DB "*.emf", sizeszfile-5 DUP(0)
;szoldfile				  DB "*.eve", sizeszfile-4 DUP(0)
ALIGN 4 ;v3.24
defaulttersefile OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
								0, 1, (OFFSET szfile), sizeszfile,\
								0, 0, 0, 0,\
								OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szextension), 0 ,0, 0>
								DB 0,0,0,0
;opentersefile OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
;								 0, 1, (OFFSET szfile), sizeszfile,\
;								 0, 0, 0, 0,\
;								 OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
;								 0, 0, (OFFSET szextension), 0 ,0, 0>
;								 ;first field is size of structure.
;								 DB 0,0
ALIGN 4 ;v3.24
defaultemffile OPENFILENAME <, 0, 0, (OFFSET szemffilter) ,0,\
								0, 1, (OFFSET szemffile), sizeszfile,\
								0, 0, 0, 0,\
								OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szemfextension), 0 ,0, 0>
								;first field is size of structure.
								DB 0,0,0,0
;openemffile OPENFILENAME <, 0, 0, (OFFSET szemffilter) ,0,\
;								 0, 1, (OFFSET szemffile), sizeszfile,\
;								 0, 0, 0, 0,\
;								 OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
;								 0, 0, (OFFSET szemfextension), 0 ,0, 0>
;								 ;first field is size of structure.
;								 DB 0,0
ALIGN 4 ;v3.24
g_hfile DWORD -1   ;handle of data file.(initialised to nothing open).
g_ndatabasesize  DWORD 0,0	  ;size of datafile on disk & mem block.
testsignature  DWORD 0	;signature read from datafile.
testversion    DWORD 0	;version number read from datafile.
;nbytesread    DWORD 0,0 ;ReadFile reports here how many bytes read.
nbyteswrote DWORD 0,0
				 DWORD 0 ;for testing, i insert a sign before szasciitbl.
szasciitbl DB 16 DUP(0) ;used by bin2dec.
szblanks DB 24 DUP(" ")
				 DB 0




.CODE
opendatafile PROC STDCALL USES edi eax ebx ecx edx
				LOCAL nsizetotal:DWORD
				LOCAL opentersefile:OPENFILENAME
				LOCAL szoldfile[sizeszfile]:BYTE
				LOCAL flzp:BYTE
; "opendatafile"
;note that embedded eve datafile is opened via wmcreate()-->openembedded(), not here.

;wmcreate() can call here, with commandline tail...
				.IF ftail==1 ;set in wmcreate().
				  jmp x99 ;we have a filename in szfile.
				.ELSEIF ftail==2   ;v1.39 via IDM_LASTOPEN
				  jmp v99
				.ENDIF

				;first, copy default structure...
				lea edi,opentersefile
				lea ebx,defaulttersefile
				mov ecx,OPENFILENAME_
oo1:			mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1
				  lea eax,szfile
				  mov opentersefile.on_lpstrFile,eax


				;do same for szfile...
								;first save current contents...
								lea edi,szoldfile
								lea ebx,szfile
								mov ecx,sizeszfile
oo3:							mov al,[ebx]
								mov [edi],al
								inc ebx
								inc edi
								dec ecx
								jnz oo3
				lea edi,szfile
				lea ebx,szdeffile
				mov ecx,sizeszfile
oo2:			mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo2
				
				lea eax,opentersefile ;v3.00
        ;mov g_errorapi,0A6Fh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetOpenFileName,eax ;ADDR opentersefile
						.IF eax==0						;0=error/cancel
								;not necessarily an error here, but put up a msgbox...
								   ;we can keep the previously open file, so restore szfile...
										lea edi,szfile
										lea ebx,szoldfile
										mov ecx,sizeszfile
oo4:									mov al,[ebx]
										mov [edi],al
										inc ebx
										inc edi
										dec ecx
										jnz oo4
								.IF g_hfile==-1
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
								  mov g_nstate,0
								  mov g_pmovingobject,0
								  mov g_pselectedobjnew,0
								  ret
								.ELSE
                  invoke CommDlgExtendedError
                  ;push eax
                  ;invoke bin2dec,10 ;returns eax->string in szasciitbl.
                  ;lea ecx,szer005
                  ;invoke lstrcpy,ecx,eax ;copy into 005 error message.
                  ;pop eax ;eax has error code.
                  .IF eax==0                      ;v2.99
                    mov eax,1 ;alert, no error.
                  .ELSE
                    or eax,0C00h ;make it a high value, treated as error.
                  .ENDIF
								  invoke myalertbox,ADDR szerrget,eax ;invoke myerrorhandler,005
ferr2:
								  invoke zeroabsoluteptrs,0
								  ret
								.ENDIF
						.ENDIF

;......
;go ahead and open it...
v99:
		;v1.26
    ;mov g_errorapi,0A70h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

;have to put this in here, while previous database still exists...
;this scans current database and wipes out any bitmap handles and DCs...
		invoke deletebitmaphandles		 ;(they are used for drawing GIFs)

;point of no-return for previously opened file. reload mem block with
;new default database...  close file first...
				  .IF g_hfile==-1 ;-1 means no file previously open.
				  .ELSE
            ;mov g_errorapi,0A71h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CloseHandle, g_hfile ;close previous file.
						mov g_hfile,-1
				  .ENDIF
;now copy complete default template to memory block...
				  .IF pTERSEDATA==0
				  .ELSE   ;should always come here.
					  ;the mem block already exists, made in wmcreate, so really
					  ;just need to call GlobalReAlloc() to resize it ...
            ;mov g_errorapi,0A72h ;for crash outside EVE, error codes range Axxh. v3.23
				    invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				    invoke GlobalReAlloc,eax,(SIZEOF TERSEDATA)+128,GMEM_MOVEABLE
				    ;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				    ;here doesn't change that. this func will return eax=new address of block.
								  .IF eax==0
										;fail...
										mov g_ndatabasesize,0
										invoke myalertbox,ADDR szer204,802h ;eax ;invoke myerrorhandler,204
										;...error message and exit EVE...
										invoke DestroyWindow, g_hwnd
										jmp eo1 ;ret
								  .ELSE
									  ;all absolute pointers are invalid...
									  invoke zeroabsoluteptrs,1
										mov g_ndatabasesize,(SIZEOF TERSEDATA)
										mov pTERSEDATA,eax		  ;new pointer.
								  .ENDIF
												mov edi,pTERSEDATA
												lea ebx,instantiatedTERSEDATA
												mov ecx,(SIZEOF TERSEDATA)
oo6:											mov al,[ebx]
												mov [edi],al
												inc ebx
												inc edi
												dec ecx
												jnz oo6
				  .ENDIF
          ;mov g_errorapi,0A73h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvalidateRgn, g_hwnd,0,TRUE	 ;invalidate entire window.
				  mov g_fredrawdiag,ENTIRE								;redraw entire window.

x99:	;open existing file...
      ;mov g_errorapi,0A74h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke CreateFile, ADDR szfile,\
								GENERIC_READ+GENERIC_WRITE,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, OPEN_EXISTING,\				;only opens an existing file.
								FILE_ATTRIBUTE_NORMAL, 0
				cmp eax,INVALID_HANDLE_VALUE	;-1
				jne ofok
				  ;open failed ...
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0
				mov g_pmovingobject,0
				mov g_pselectedobjnew,0
				invoke myalertbox,ADDR szer100,4 ;invoke myerrorhandler,100
				mov g_hfile,-1
				jmp eo1 ;  ret
ofok:
				mov g_hfile,eax   ;handle of newly-opened file.
				;NOTE: it has to be an existing file to get this far.

;Before we go ahead and read the file, is it .EVE? Is it correct
;signature? correct version?
;opentersefile, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfile, where is datafile extension ...
		cmp ftail,1 ;have come from wmcreate, filename in szfile, don't have the
		je b56			;opentersefile structure setup, so bypass this test.
		cmp ftail,2 ;v1.39 from IDM_LASTOPEN, structure not setup.
		je b56
				xor eax,eax
				mov ax,opentersefile.on_nFileExtension
				lea ebx,szfile
				add ebx,eax
				;now compare this with content of szextension...
        ;mov g_errorapi,0A75h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke lstrcmpi, ebx,ADDR szextension
				.IF eax==0
				.ELSE
				  ;compare failed...
				  invoke myalertbox,ADDR szerrnogoo,4 ;invoke myerrorhandler,002
ferr:
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0
				  mov g_pmovingobject,0
				  mov g_pselectedobjnew,0
				  invoke CloseHandle, g_hfile ;close file.
				  mov g_hfile,-1
								;NOTE i'll leave mem. block alone, as i have
								;already restored it back to new default.
								;the only place we'll call GlobalFree() will be
								;in wmdestroy().
				  jmp eo1 ;ret
				.ENDIF
b56:

;find out if an older uncompressed tersedata file...
        ;the end of the file has the total file size, if compressed... v3.30
        mov flzp,0
				invoke SetFilePointer,g_hfile,-4,0,FILE_END
				invoke ReadFile,g_hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
				invoke GetFileSize,g_hfile,0
				.IF DWORD PTR szasciitbl==eax ;then it is compressed.
            ;mov g_errorapi,0A76h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetFilePointer,g_hfile,-12,0,FILE_END
						;lea eax,szasciitbl
						;lea ebx,nbyteswrote
						invoke ReadFile,g_hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						.IF DWORD PTR szasciitbl==-1
gop1:				  ;lea eax,szasciitbl
						  ;lea ebx,nbyteswrote
						  invoke ReadFile,g_hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						  .IF DWORD PTR szasciitbl==-1
								;compressed, my original method...
								jmp c99
						  .ENDIF
						.ELSEIF DWORD PTR szasciitbl==-2
						  mov flzp,1
						  jmp gop1 ;new lzp algorithm.
						.ENDIF
				.ENDIF		
				;uncompressed...

;this is old code for opening uncompressed .eve file...
				  ;set filepointer back to start of file...
          ;mov g_errorapi,0A77h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke SetFilePointer, g_hfile,0,0,FILE_BEGIN
				  ;lea ebx,nbyteswrote
				  invoke ReadFile, g_hfile,ADDR testsignature,8,ADDR nbyteswrote,0
				  .IF testversion==NCURRENTVERSION
				  .ELSE
						invoke myalertbox,ADDR szer109,4 ;invoke myerrorhandler,109
						jmp ferr		;error message and close file.
				  .ENDIF
				  ;set filepointer back to start of file...
				  invoke SetFilePointer, g_hfile,0,0,FILE_BEGIN
				  ;get size of file...
				  invoke GetFileSize, g_hfile,0
				  mov g_ndatabasesize,eax
;				   invoke GlobalReAlloc, pTERSEDATA,g_ndatabasesize,GMEM_MOVEABLE
              ;mov g_errorapi,0A78h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				  invoke GlobalReAlloc,eax,g_ndatabasesize,GMEM_MOVEABLE
				  ;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				  ;here doesn't change that. this func will return eax=new address of block.
								 ;all absolute pointers are invalid...
								 invoke zeroabsoluteptrs,1
				  mov pTERSEDATA,eax	;new pointer.
				  ;read file and write to block...
				  mov eax,pTERSEDATA
				  ;lea ebx,nbyteswrote
				  invoke ReadFile, g_hfile,eax,g_ndatabasesize,ADDR nbyteswrote,0
				  jmp j77

c99:

				invoke setupmemblock,g_hfile,ADDR pTERSEDATA,ADDR g_ndatabasesize,0
				;...return eax=0 error, else =total size of compr. eve datafile.
				;...writes new values to pTERSEDATA and g_ndatabasesize.
				.IF eax==0
				  jmp ferr
				.ENDIF
				mov nsizetotal,eax
				.IF flzp==0  ;v3.30
				  invoke file2uncompress,g_hfile,pTERSEDATA
				.ELSE
				  invoke file2uncompress_lzp,g_hfile,pTERSEDATA
				.ENDIF

;if get here, then file has been opened and loaded to memory!
;pTERSEDATA points to memory block.

j77:
		  ;we've opened an eve file,
		  ;need to set this if zero...
		  ;(precaution, in case of an old eve file without this
		  ; field set)...
		  mov esi,pTERSEDATA
		  mov eax,(TERSEDATA PTR [esi]).noffsetobjs
		  .IF eax==0
				;load the default...
				lea eax,(TERSEDATA PTR [esi]).OBJECTS
				sub eax,esi
				mov (TERSEDATA PTR [esi]).noffsetobjs,eax
				jmp ok2 ;don't do a signature check.
		  .ENDIF

;a bit late, but now check signature...
		invoke calcsig	;returns sig in eax.
		mov esi,pTERSEDATA
		cmp (TERSEDATA PTR [esi]).nsignature,eax
		je		ok2
		invoke myalertbox,ADDR szer207,803h ;eax ;invoke myerrorhandler,207
ok2:

    invoke checkintegrity,1 ;1=suppress all msgs. v3.28
    ;...in the case of a signature error, diag still loads, but may be corrupt
    ;and cause a crash, so need to run integrity check.
    ;in the case of uncompressed file, a good idea to run this check also,
    ;as have bypassed signature check, but note we aren't reporting any errors,
    ;just fixing them.

;the database may contain composite-object library members. need to
;load them into the Elements menu...
				invoke addcomposites2menu,0

				  ;241000
				  ;load top/left client-window coords (saved in database)...
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_right
				  sub eax,clientrect.rc_left	 ;width.
				  mov ebx,clientrect.rc_bottom
				  sub ebx,clientrect.rc_top  ;height.
				  mov ecx,(TERSEDATA PTR [esi]).xleft
				  mov clientrect.rc_left,ecx
				  add ecx,eax
				  mov clientrect.rc_right,ecx
				  mov ecx,(TERSEDATA PTR [esi]).ytop
				  mov clientrect.rc_top,ecx
				  add ecx,ebx
				  mov clientrect.rc_bottom,ecx

				  ;load global "hide" flags...
				  mov fhidehandles,0 ;v3.22
				  mov fhidehighlighting,0 ;/
				  mov eax,(TERSEDATA PTR [esi]).fviewprefs
				  test al,010b ;bit1=1 hide handles.
				  jz nx1
				  mov fhidehandles,1
nx1:			  test al,01000b ;bit3=1 hide highlighting
				  jz nx8
				  mov fhidehighlighting,1
nx8:

				  ;v1.39 save latest open path/filename in eve.ini...
          ;mov g_errorapi,0A79h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke WritePrivateProfileString,ADDR szsectionopen, \
						 ADDR szentryfile1,ADDR szfile,ADDR szpathspeceveini
				  ;also append it to File menu...
				  invoke append2filemenu,1 ;1=replace, not append.(wmcreate() calls 1st)

				  ;v1.39 have to tell the window class about background color...
				  mov esi,pTERSEDATA
				  mov ebx,(TERSEDATA PTR [esi]).nbackground
				  .IF ebx==3 ;special case...
					mov eax,COLOR_WINDOW
					inc eax
					jmp go1
				  .ENDIF
				  mov eax,ebx
				  shl eax,1 ;dword
				  shl eax,1 ;/
				  lea ebx,g_hwhitebrush
				  add ebx,eax ;address of brush.
				  mov eax,[ebx] ;get brush.
go1:
        ;mov g_errorapi,0A7Ah ;for crash outside EVE, error codes range Axxh. v3.23
			  invoke SetClassLongA,g_hwnd,GCL_HBRBACKGROUND,eax

				 ;v1.40
				 ;set coarseness when drag an element...
				 mov eax,(TERSEDATA PTR [esi]).feveprefs
				 and al,01100000b ;bits5/6.
				 .IF al==0 ;fine 1 unit.
				   mov fdragmask,0FFh
				 .ELSEIF al==0100000b ;2 units.
				   mov fdragmask,0FEh
				 .ELSE	  ;coarse 4 units.
				   mov fdragmask,0FCh
				 .ENDIF

         ;v2.95 when i introduced "Find" buttons in EVE, this enabled the current
         ;folder to change. wmcreate() recorded home folder in szhomefolder, and
         ;called SetCurrentDirectory,ADDR szhomeflder in xdblclk() before
         ;running a link.
         ;however, when open a new file, need to change szhomefolder to the new
         ;home of the opened eve file...
         ;mov eax,opentersefile.on_lpstrFile ;full path\filename.
         invoke lstrcpy,ADDR szhomefolder,ADDR szfile ;eax v3.47
         lea ebx,szhomefolder
         ;xor eax,eax
         ;mov ax,opentersefile.on_nFileOffset
         ;add ebx,eax ;offset in .lpstrFile to filename.
         ;mov [ebx],BYTE PTR 0 ;leave just path.
         ;no need to call SetCurrentDirectory() now, as opening file has set it.
         push ebx             ;v3.47
         invoke lstrlen,ebx
         pop ebx
         add ebx,eax
         ;go back, find "\"...
zgo1:     mov al,[ebx]
         .IF al=="\"
           inc ebx
         .ELSE
           dec ebx
           lea eax,szhomefolder
           .IF ebx>eax
             jmp zgo1
           .ENDIF
         .ENDIF
         mov [ebx],BYTE PTR 0
         ;er, i'm not sure that it has... v3.47
         invoke SetCurrentDirectory,ADDR szhomefolder

         ;v3.01 have moved external editors out of the database. need to write a
         ;zero to those strings in the database, as in future may want to use those
         ;fields.
         ;IN FUTURE, WHEN USE THESE FIELDS, NEED TO REMOVE THIS CODE!
         mov (TERSEDATA PTR [esi]).wszeditor1,0
         mov (TERSEDATA PTR [esi]).wszeditor2,0
         mov (TERSEDATA PTR [esi]).wszbrowser2,0
         mov (TERSEDATA PTR [esi]).wszpainter1,0

			invoke zeroabsoluteptrs,1
      ;mov g_errorapi,0A7Bh ;for crash outside EVE, error codes range Axxh. v3.23
			invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
			mov g_fredrawdiag,ENTIRE								;redraw entire window.

eo1:
		;v1.26
		;restore cursor...
		push eax
    ;mov g_errorapi,0A7Ch ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax

  ret
opendatafile ENDP
;--------------------------------------------------------------------------

.CODE
setupmemblock PROC STDCALL USES ebx ecx edx esi edi, \
		hfile:DWORD,ppdata:DWORD,pnsize:DWORD,fnew:DWORD
		LOCAL nsizetotal:DWORD
		LOCAL pdata:DWORD,nsize:DWORD
; "setupmemblock"		
;called from opendatafile(), openembedded(), openmerge(), opentemplate().
;eve file previously opened, have hfile (normally =g_hfile).
;ppdata is address of pTERSEDATA (normally).
;ppsize is address of g_ndatabasesize (normally).
;fnew=1 create a new memory block.
;writes to g_ndatabasesize and reallocates memory block.


;compressed file...
;get total size of stored data file...
            ;mov g_errorapi,0A7Dh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetFilePointer,hfile,-4,0,FILE_END
						;lea eax,szasciitbl
						;lea ebx,nbyteswrote
						invoke ReadFile,hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						.IF eax==0 ;fail
ferrr:
			        invoke myalertbox,ADDR szer200,804h ;eax ;invoke myerrorhandler,200
						  jmp ferr						;error message and close file.
						.ENDIF
						mov eax,DWORD PTR szasciitbl
						mov nsizetotal,eax

;get version...
;umm, compressed, so have stored version near end of file...
						invoke SetFilePointer,hfile,-28,0,FILE_END
						;lea eax,szasciitbl
						;lea ebx,nbyteswrote
						invoke ReadFile,hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						.IF DWORD PTR szasciitbl>NCURRENTVERSION
								invoke myalertbox,ADDR szer102,1 ;invoke myerrorhandler,102  ;warning.
						.ENDIF
;if get here, file open and correct version etc...

;get uncompressed size of tersedata...
						invoke SetFilePointer,hfile,-24,0,FILE_END
						;lea eax,szasciitbl
						;lea ebx,nbyteswrote
						invoke ReadFile,hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						mov eax,DWORD PTR szasciitbl
						;mov g_ndatabasesize,eax
						  mov edi,pnsize
						  mov [edi],eax ;normally g_ndatabasesize.
						  mov nsize,eax

				.IF fnew==1
				  ;we have to open a new mem block... (previous pdata irrelevant)
          ;mov g_errorapi,0A7Eh ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke GlobalAlloc, GMEM_FIXED,nsize
				  .IF eax==0					;NULL
						;fail...
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
						invoke myalertbox,ADDR szer205,805h ;eax ;invoke myerrorhandler,205
						jmp ferr
				  .ELSE
						jmp ok1
				  .ENDIF
				.ENDIF

						  mov edi,ppdata		 ;pre-existing memory block.
						  mov eax,[edi] ;normally pTERSEDATA
						  mov pdata,eax

;(orignally created in wmcreate()).
;just need to call GlobalReAlloc() to resize it ...
;				 invoke GlobalReAlloc, pdata,nsize,GMEM_MOVEABLE
        ;mov g_errorapi,0A7Fh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GlobalHandle,pdata ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,nsize,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
							 ;all absolute pointers are invalid...
								 invoke zeroabsoluteptrs,1
;																				 mov g_pmovingobject,0
;																				 mov poldmovingobject,0
;																				 mov g_pselectedobjnew,0
;																				 mov g_pselectedobject,0
;																				 mov g_perrorobject,0
;																				 mov wipeoutsindex,0
;																				 mov updatesindex,0
;																				 mov highlightedindex,0
;										 push eax						  ;save previous value of state.
;										 mov al,g_nstate		  ;/
;										 mov g_nstateprev,al  ;/
;										 pop eax						  ;/
;																				 mov g_nstate,0
;																	  mov highlightedindexnewlist,0
				.IF eax==0
				  ;GlobalRealloc() fail...
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
		      invoke myalertbox,ADDR szer202,806h ;eax ;invoke myerrorhandler,202
				  jmp ferr								;error message and close file.
				.ELSE
				  ;mov pTERSEDATA,eax	 ;new pointer.
ok1:	    mov pdata,eax
				  mov edi,ppdata
				  mov [edi],eax   ;normally pTERSEDATA.
				.ENDIF

		mov eax,nsizetotal
		ret
ferr:
		xor eax,eax
		ret
setupmemblock ENDP
;--------------------------------------------------------------------------
ALIGN 4
sztempeve BYTE "temp.eve",0

openembedded PROC STDCALL USES ebx ecx edx edi esi, \
				hfile:DWORD,pszmodulefilename:DWORD
				LOCAL nsizetotal:DWORD,htempeve:DWORD
				LOCAL ntmpbuffer[4]:BYTE
;called from wmcreate(), if eve.exe has embedded eve graphic image.
;based on opendatafile().
;hfile is this eve.exe file currently running, pszmodulefilename
;is ptr to the filespec.
; "openembedded"

		;v1.26
    ;mov g_errorapi,0A80h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

				invoke setupmemblock,hfile,ADDR pTERSEDATA,ADDR g_ndatabasesize,0
				;...return eax=0 error, else =total size of compr. eve datafile.
				;...this func writes to pTERSEDATA and g_ndatabasesize.
				.IF eax==0
				  jmp ferr
				.ENDIF
				mov nsizetotal,eax

        ;v3.36
        ;the LZP uncompressor code requires the graphic file to start right at
        ;beginning of file. so have to extract it from eve.exe...
		    invoke CreateFile, ADDR sztempeve,\
								GENERIC_READ+GENERIC_WRITE,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, CREATE_ALWAYS,\ ;creates a new file.
								FILE_ATTRIBUTE_NORMAL, 0
        .IF eax==INVALID_HANDLE_VALUE ;-1
          jmp ferr
        .ENDIF
				mov htempeve,eax
        mov eax,nsizetotal
        neg eax				
				invoke SetFilePointer,hfile,eax,0,FILE_END
				;fileptr now at start of embedded graphic.
				;need to copy the embedded graphic to new file htempeve...
				mov ecx,nsizetotal
nxt4:   push ecx				
				invoke ReadFile,hfile,ADDR ntmpbuffer,1,ADDR nbyteswrote,0
			  invoke WriteFile,htempeve,ADDR ntmpbuffer,1,ADDR nbyteswrote,0
			  ;...inefficient, but the filesize can be an odd number.
			  pop ecx
			  loop nxt4
				
        ;v3.30...
				;invoke file2uncompress,hfile,pTERSEDATA
				;...reads eve datafile and writes to pTERSEDATA
				; (requires memory block already sized).
			  invoke file2uncompress_lzp,htempeve,pTERSEDATA ;v3.30 v3.36

        invoke CloseHandle,htempeve   ;v3.36
        
;if get here, then file has been opened and loaded to memory!
;pTERSEDATA points to memory block.

j77:
;a bit late, but now check signature...
		invoke calcsig	;returns sig in eax.
		mov esi,pTERSEDATA
		cmp (TERSEDATA PTR [esi]).nsignature,eax
		je		ok2
		invoke myalertbox,ADDR szer207,807h ;eax ;invoke myerrorhandler,207
ok2:


				  ;241000
				  ;load top/left client-window coords (saved in database)...
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_right
				  sub eax,clientrect.rc_left	 ;width.
				  mov ebx,clientrect.rc_bottom
				  sub ebx,clientrect.rc_top  ;height.
				  mov ecx,(TERSEDATA PTR [esi]).xleft
				  mov clientrect.rc_left,ecx
				  add ecx,eax
				  mov clientrect.rc_right,ecx
				  mov ecx,(TERSEDATA PTR [esi]).ytop
				  mov clientrect.rc_top,ecx
				  add ecx,ebx
				  mov clientrect.rc_bottom,ecx

				  ;load global "hide" flags...
				  mov fhidehandles,0 ;v3.22
				  mov fhidehighlighting,0 ;/
				  mov eax,(TERSEDATA PTR [esi]).fviewprefs
				  test al,010b ;bit1=1 hide handles.
				  jz nx1
				  mov fhidehandles,1
nx1:			  test al,01000b ;bit3=1 hide highlighting
				  jz nx8
				  mov fhidehighlighting,1
nx8:

				  ;v1.39 have to tell the window class about background color...
				  mov ebx,(TERSEDATA PTR [esi]).nbackground
				  .IF ebx==3 ;special case...
					mov eax,COLOR_WINDOW
					inc eax
					jmp go1
				  .ENDIF
				  mov eax,ebx
				  shl eax,1 ;dword
				  shl eax,1 ;/
				  lea ebx,g_hwhitebrush
				  add ebx,eax ;address of brush.
				  mov eax,[ebx] ;get brush.
go1:
        ;mov g_errorapi,0A81h ;for crash outside EVE, error codes range Axxh. v3.23
			  invoke SetClassLongA,g_hwnd,GCL_HBRBACKGROUND,eax

				 ;v1.40
				 ;set coarseness when drag an element...
				 mov eax,(TERSEDATA PTR [esi]).feveprefs
				 and al,01100000b ;bits5/6.
				 .IF al==0 ;fine 1 unit.
				   mov fdragmask,0FFh
				 .ELSEIF al==0100000b ;2 units.
				   mov fdragmask,0FEh
				 .ELSE	  ;coarse 4 units.
				   mov fdragmask,0FCh
				 .ENDIF



				invoke zeroabsoluteptrs,1
        ;mov g_errorapi,0A82h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
				mov g_fredrawdiag,ENTIRE			   ;redraw entire window.

;one problem, ...
		mov eax,hfile
		mov g_hfile,eax
		;also, copy szmodulefilename across to szfile...
		;(1st is local data, 2nd is actual open filespec)
		mov eax,pszmodulefilename
		invoke lstrcpy,ADDR szfile,eax

		jmp eo1 ;ret

ferr:
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
		invoke myalertbox,ADDR szer218,808h ;eax ;invoke myerrorhandler,218
		invoke CloseHandle,hfile
		xor eax,eax

eo1:
		;v1.26
		;restore cursor...
		push eax
    ;mov g_errorapi,0A83h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax

		ret
openembedded ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szdeffiletemplate DB "*.eve", sizeszfile-4 DUP(0)
szextensiontemplate DB "eve",0
sztemplate1  BYTE """Import template..."" gives you the opportunity to "
						 BYTE "open any .EVE file and apply all of its settings to "
						 BYTE "the current file (Note: the settings are those you "
						 BYTE "choose under ""Control/EVE preferences..."", "
						 BYTE "custom colors, and page setup). Do you want "
						 BYTE "to continue?",0

.DATA
ALIGN 4 ;v3.24
szfiletemplate	 DB "*.eve", sizeszfile-4 DUP(0)   ;v3.30
ALIGN 4
defaulttemplate OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
								0, 1, (OFFSET szfiletemplate), sizeszfile,\
								0, 0, 0, 0,\
								OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szextension), 0 ,0, 0>
								DB 0,0,0,0
ALIGN 4 ;v3.24
openfiletemplate OPENFILENAME <, 0, 0, (OFFSET szfilter) ,0,\
								0, 1, (OFFSET szfiletemplate), sizeszfile,\
								0, 0, 0, 0,\
								OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szextension), 0 ,0, 0>
								;first field is size of structure.
								DB 0,0,0,0
;testsigtemplate DWORD 0				 ;signature read from datafile.    (MUST be in
;testvertemplate DWORD 0				 ;version number read from datafile. this order!)

.CODE
opentemplate PROC STDCALL USES ebx ecx edx esi edi
				LOCAL hfiletemplate:DWORD
				LOCAL nsizetemplate:DWORD
				LOCAL pTERSEDATAtemp:DWORD
		LOCAL ntstart:DWORD, ntsize:DWORD
		LOCAL flzp:BYTE ;v3.30
; "opentemplate"
;like opendatafile(), except only reads template portion of TERSEDATA.

  mov hfiletemplate,-1

  invoke myalertbox,ADDR sztemplate1,2
  ;invoke MessageBox,g_hwnd,ADDR sztemplate1, \
	;							ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
  .IF ax != IDYES
		jmp out1 ;ret
  .ENDIF

;first, copy default structure...
				lea edi,openfiletemplate
				lea ebx,defaulttemplate
				mov ecx,OPENFILENAME_
oo1:	mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1

;do same for szfiletemplate...
				lea edi,szfiletemplate
				lea ebx,szdeffiletemplate
				mov ecx,sizeszfile
oo2:	  mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo2

  ;mov g_errorapi,0A84h ;for crash outside EVE, error codes range Axxh. v3.23
  invoke GetOpenFileName, ADDR openfiletemplate  ;<<<DIALOG BOX<<<<
  .IF eax==0					;0=error/cancel
    jmp ex2 ;exit
  .ENDIF

;open existing file, read-only...
  ;mov g_errorapi,0A85h ;for crash outside EVE, error codes range Axxh. v3.23
  invoke CreateFile, ADDR szfiletemplate,\
								GENERIC_READ,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, OPEN_EXISTING,\				;only opens an existing file.
								FILE_ATTRIBUTE_NORMAL, 0
  .IF eax==INVALID_HANDLE_VALUE ;-1
	   ;open failed ...
		 invoke myalertbox,ADDR szer100,4 ;invoke myerrorhandler,100
		 jmp ex2 ;exit
  .ENDIF
  mov hfiletemplate,eax   ;handle of newly-opened file.

;Before we go ahead and read the file, is it .eve? Is it correct
;signature? correct version?
;openfiletemplate, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfiletemplate, where is datafile extension ...
				xor eax,eax
				mov ax,openfiletemplate.on_nFileExtension
				lea ebx,szfiletemplate
				add ebx,eax
				;now compare this with content of szextension...
				invoke lstrcmpi, ebx,ADDR szextension
				.IF eax != 0
				  ;compare failed...
				  invoke myalertbox,ADDR szerrnogoo,4 ;invoke myerrorhandler,002
					jmp ex1 ;exit.
				.ENDIF

;;now check for correct signature and version...
;  invoke ReadFile,hfiletemplate,ADDR testsigtemplate,8,ADDR nbytestemplate,0
;																																;read first 8 bytes.
;				.IF eax==0								;=0 if failed.
;				  ;failed to read file...
;				 invoke CloseHandle, hfiletemplate ;close file.
;				 invoke myerrorhandler,200
;				  jmp ex1								;error msg and return.
;				.ENDIF
;
;;set filepointer back to start of file...
;  invoke SetFilePointer, hfiletemplate,0,0,FILE_BEGIN
;				  .IF eax==-1
;								;fail...
;						 invoke CloseHandle, hfiletemplate ;close file.
;				 invoke myerrorhandler,200
;						  jmp ex1						;error msg and close file.
;				  .ENDIF
;
;  .IF testvertemplate==NCURRENTVERSION ;ReadFile read 8 bytes!
;						;correct version. now test for signature...
;						.IF testsigtemplate==0
;						  ;i will accept this as ok...
;						.ELSE
;						  ;***NOTE*** need code here in future, to read entire
;						  ;file, compute signature and compare ***NOTE***
;						.ENDIF	 ;(opendatafile() has same problem)
;  .ELSE
;						;incorrect version...
;						.IF testvertemplate<NCURRENTVERSION
;								;old datafile version...
;						 invoke CloseHandle, hfiletemplate ;close file.
;				invoke myerrorhandler,101
;						  jmp ex1						;error msg and close file.
;						.ELSE
;						  ;later version????....
;						 invoke CloseHandle, hfiletemplate ;close file.
;				invoke myerrorhandler,102
;						  jmp ex1						;error msg and close file.
;						.ENDIF
;  .ENDIF

;if get here, file open.

;v3.30 copied from opendatafile()...
;find out if an older uncompressed tersedata file...
        ;the end of the file has the total file size, if compressed... v3.30
        mov flzp,0
				invoke SetFilePointer,hfiletemplate,-4,0,FILE_END
				invoke ReadFile,hfiletemplate,ADDR szasciitbl,4,ADDR nbyteswrote,0
				invoke GetFileSize,hfiletemplate,0
				mov nsizetemplate,eax
				.IF DWORD PTR szasciitbl==eax ;then it is compressed.
						invoke SetFilePointer,hfiletemplate,-12,0,FILE_END
						invoke ReadFile,hfiletemplate,ADDR szasciitbl,4,ADDR nbyteswrote,0
						.IF DWORD PTR szasciitbl==-1
gop1:				  invoke ReadFile,hfiletemplate,ADDR szasciitbl,4,ADDR nbyteswrote,0
						  .IF DWORD PTR szasciitbl==-1 ;verify compressed.
								;compressed...
							.ELSE ;something wrong, treat as uncompressed...
                jmp SHORT un1	
						  .ENDIF
						.ELSEIF DWORD PTR szasciitbl==-2
						  mov flzp,1
						  jmp gop1 ;new lzp algorithm.
						.ELSE ;something wrong, treat as uncompressed...
						  jmp SHORT un1
						.ENDIF
				.ELSE		;uncompressed...
un1:		  invoke GlobalAlloc,GMEM_FIXED,nsizetemplate
				  mov pTERSEDATAtemp,eax
				  invoke SetFilePointer,hfiletemplate,0,0,FILE_BEGIN
		      invoke ReadFile,hfiletemplate,pTERSEDATAtemp,nsizetemplate,ADDR nbyteswrote,0
		      jmp SHORT cs1
				.ENDIF		

;compressed file. check version, allocate a memblock...
		  invoke setupmemblock,hfiletemplate,ADDR pTERSEDATAtemp,ADDR nsizetemplate,1
				;...return eax=0 error, else =total size of compr. eve datafile.
				;...writes new values to pTERSEDATAtemp and nsizetemplate.
				;..."1" param means it creates a new mem block.
				.IF eax==0
				  jmp ex1
				.ENDIF
;now read the entire file and write to mem block...
;		invoke ReadFile, hfiletemplate,pTERSEDATAtemp,nfilesizetemplate,ADDR nbytestemp,0
				;invoke file2uncompress,hfiletemplate,pTERSEDATAtemp v3.30
				;...reads eve datafile and writes to pTERSEDATAtemp
				; (requires memory block already sized).
				.IF flzp==0  ;v3.30
				  invoke file2uncompress,hfiletemplate,pTERSEDATAtemp
				.ELSE
				  invoke file2uncompress_lzp,hfiletemplate,pTERSEDATAtemp
				.ENDIF

cs1:    ;check signature...
        push pTERSEDATA
		    mov esi,pTERSEDATAtemp
		    mov pTERSEDATA,esi ;calcsig needs this, to check our temp loaded database.
		    invoke calcsig	;returns sig in eax.
		    pop pTERSEDATA
		    cmp (TERSEDATA PTR [esi]).nsignature,eax
		    je ok2
		    invoke myalertbox,ADDR szer207,803h ;eax ;invoke myerrorhandler,207
		    jmp ex1 ;close file.
ok2:    ;bypass.

;copy template from pTERSEDATAtemp to pTERSEDATA...
  mov esi,pTERSEDATA
  lea ebx,(TERSEDATA PTR [esi]).templatestart ;start of template area.
  lea eax,(TERSEDATA PTR [esi]).templateend ;end of template area.
  sub eax,ebx					;size of template area.
  mov ntsize,eax
  mov ntstart,ebx
		;copy from...
		mov esi,pTERSEDATAtemp
		lea edi,(TERSEDATA PTR [esi]).templatestart ;start of template area.
		  mov esi,ntstart
		  mov ecx,ntsize
m77:  mov al,[edi]
		  mov [esi],al
		  inc edi
		  inc esi
		  loop m77

;now deallocate pTERSEDATAtemp...
      ;mov g_errorapi,0A86h ;for crash outside EVE, error codes range Axxh. v3.23
			invoke GlobalHandle,pTERSEDATAtemp
			invoke GlobalFree,eax ; pTERSEDATAtemp

;if get here, then file has been opened and template loaded to memory!


;we don't need the file anymore...
ex1:    ;mov g_errorapi,0A87h ;for crash outside EVE, error codes range Axxh. v3.23
        invoke CloseHandle, hfiletemplate ;close file.
ex2:				  mov g_pmovingobject,0
						  mov g_pselectedobjnew,0
						  mov g_pselectedobject,0
						  mov g_perrorobject,0
							mov al,g_nstate 		 ;/
							mov g_nstateprev,al  ;/
		          mov g_nstate,0
				invoke InvalidateRgn, g_hwnd,0,TRUE    ;invalidate entire window.
				mov g_fredrawdiag,ENTIRE								;redraw entire window.
out1:
  ret
opentemplate ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szmerge1   BYTE "You have chosen to merge another .EVE diagram with "
				   BYTE "the current one. The other diagram .EVE file will "
				   BYTE "still exist, and if you only want to view the merged "
				   BYTE "diagrams and not permanently have the elements of the "
				   BYTE "other diagram in the current one, simply remember NOT "
				   BYTE " to File/Save.", 0Dh,0Ah
				   BYTE "The elements of the imported diagram will be highlighted, "
				   BYTE "and you may go to the menu ""Control"" to move/duplicate/delete "
				   BYTE "the highlighted (selected) elements (note, do not click "
				   BYTE "anywhere in the diagram beforehand, as that will "
				   BYTE "deselect the highlighted elements).",0Dh,0Ah
				   BYTE "Do you want to continue?",0
;testsigtemp DWORD 0   ;signature read from datafile.	(MUST be in
;testvertemp DWORD 0   ;version number read from datafile.		this order!)

.CODE
openmerge PROC STDCALL USES ebx ecx edx esi edi
				LOCAL hfiletemp:DWORD
				LOCAL nsizetemp:DWORD
				LOCAL pTERSEDATAtemp:DWORD
				LOCAL nsizeobjectstemp:DWORD, nsizeobjectsold:DWORD
				LOCAL nsizeactualold:DWORD, numobjectstemp:WORD
				LOCAL pendactualold:DWORD,nsizetotal:DWORD
				LOCAL flzp:BYTE
; "openmerge"
;from "File/Import diagram..." > IDM_MERGE.
;very similar to opentemplate(), except copies OBJECTS database into
;current mem block. doesn't close current file.

  mov hfiletemp,-1
  mov pTERSEDATAtemp,0

  invoke myalertbox,ADDR szmerge1,2
  ;invoke MessageBox,g_hwnd,ADDR szmerge1,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
  .IF ax==IDYES
  .ELSE
    jmp ex3 ;get out.
  .ENDIF

;first, copy default structure...
				lea edi,openfiletemplate
				lea ebx,defaulttemplate
				mov ecx,OPENFILENAME_
oo1:			mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1

;do same for szfiletemplate...
				lea edi,szfiletemplate
				lea ebx,szdeffiletemplate
				mov ecx,sizeszfile
oo2:			mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo2

  ;mov g_errorapi,0A88h ;for crash outside EVE, error codes range Axxh. v3.23
  invoke GetOpenFileName, ADDR openfiletemplate  ;<<<DIALOG BOX<<<<
  .IF eax==0					;0=error/cancel
		jmp ex4 ;exit
  .ENDIF

;.....
;now go ahead and do it...

		;v1.26
    ;mov g_errorapi,0A89h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

;open existing file, read-only...
  ;mov g_errorapi,0A8Ah ;for crash outside EVE, error codes range Axxh. v3.23
  invoke CreateFile, ADDR szfiletemplate,\
								GENERIC_READ,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, OPEN_EXISTING,\				;only opens an existing file.
								FILE_ATTRIBUTE_NORMAL, 0
  .IF eax==INVALID_HANDLE_VALUE ;-1
				  ;open failed ...
	  invoke myalertbox,ADDR szer100,4 ;invoke myerrorhandler,100
		jmp ex1
  .ENDIF
  mov hfiletemp,eax  ;handle of newly-opened file.

;Before we go ahead and read the file, is it .eve? Is it correct
;signature? correct version?
;openfiletemplate, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfiletemplate, where is datafile extension ...
				xor eax,eax
				mov ax,openfiletemplate.on_nFileExtension
				lea ebx,szfiletemplate
				add ebx,eax
				;now compare this with content of szextension...
				invoke lstrcmpi, ebx,ADDR szextension
				.IF eax != 0
				  ;compare failed...
			    invoke myalertbox,ADDR szerrnogoo,4 ;invoke myerrorhandler,002
				  jmp ex2 ;exit.
				.ENDIF

;v3.30 copied from opendatafile()...
;find out if an older uncompressed tersedata file...
        ;the end of the file has the total file size, if compressed... v3.30
        mov flzp,0
				invoke SetFilePointer,hfiletemp,-4,0,FILE_END
				invoke ReadFile,hfiletemp,ADDR szasciitbl,4,ADDR nbyteswrote,0
				invoke GetFileSize,hfiletemp,0
				mov nsizetemp,eax
				.IF DWORD PTR szasciitbl==eax ;then it is compressed.
						invoke SetFilePointer,hfiletemp,-12,0,FILE_END
						invoke ReadFile,hfiletemp,ADDR szasciitbl,4,ADDR nbyteswrote,0
						.IF DWORD PTR szasciitbl==-1
gop1:				  invoke ReadFile,hfiletemp,ADDR szasciitbl,4,ADDR nbyteswrote,0
						  .IF DWORD PTR szasciitbl==-1 ;verify compressed.
								;compressed...
							.ELSE ;something wrong, treat as uncompressed...
                jmp SHORT un1	
						  .ENDIF
						.ELSEIF DWORD PTR szasciitbl==-2
						  mov flzp,1
						  jmp gop1 ;new lzp algorithm.
						.ELSE ;something wrong, treat as uncompressed...
						  jmp SHORT un1
						.ENDIF
				.ELSE		;uncompressed...
un1:		  invoke GlobalAlloc,GMEM_FIXED,nsizetemp
				  mov pTERSEDATAtemp,eax
				  invoke SetFilePointer,hfiletemp,0,0,FILE_BEGIN
		      invoke ReadFile,hfiletemp,pTERSEDATAtemp,nsizetemp,ADDR nbyteswrote,0
		      jmp SHORT cs1
				.ENDIF		

;compressed file. check version, allocate a memblock...
		  invoke setupmemblock,hfiletemp,ADDR pTERSEDATAtemp,ADDR nsizetemp,1
				;...return eax=0 error, else =total size of compr. eve datafile.
				;...writes new values to pTERSEDATAtemp and nsizetemp.
				.IF eax==0
				  jmp ex2 ;exit
				.ENDIF
;now read the entire file and write to mem block...
				;...reads eve datafile and writes to pTERSEDATAtemp
				; (requires memory block already sized).
				.IF flzp==0  ;v3.30
				  invoke file2uncompress,hfiletemp,pTERSEDATAtemp
				.ELSE
				  invoke file2uncompress_lzp,hfiletemp,pTERSEDATAtemp
				.ENDIF

cs1:    ;check signature...
        push pTERSEDATA
		    mov esi,pTERSEDATAtemp
		    mov pTERSEDATA,esi ;calcsig needs this, to check our temp loaded database.
		    invoke calcsig	;returns sig in eax.
		    pop pTERSEDATA
		    cmp (TERSEDATA PTR [esi]).nsignature,eax
		    je ok2
		    invoke myalertbox,ADDR szer207,803h ;eax ;invoke myerrorhandler,207
		    jmp ex2 ;close file, exit.
ok2:    ;bypass.


;now close the file...
;we don't need the file anymore...
  invoke CloseHandle, hfiletemp
  mov hfiletemp,0

;TERSEDATA mem block will have to be increased...
		;note, g_ndatabasesize is the total size of database in memory, NOT the file.
		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).numrecords
		mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		mul ecx 				;eax=size of OBJECTS database.
		mov nsizeobjectsold,eax 		;save size of old OBJECTS database.
				  mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
				  add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
		add ebx,eax 			;ACTUAL end of total database.
		mov pendactualold,ebx			 ;save. ***SEE RECALC BELOW***
		sub ebx,pTERSEDATA
		mov nsizeactualold,ebx	  ;ACTUAL size of total database.
				;now do similar for the incoming database...
				mov esi,pTERSEDATAtemp
				xor edx,edx
				mov eax,(TERSEDATA PTR [esi]).numrecords
				mov numobjectstemp,ax					;save number incoming objects.
				mov ecx,(TERSEDATA PTR [esi]).nsizeobject
				mul ecx 		;eax=size of OBJECTS database.
				mov nsizeobjectstemp,eax				;save size of incoming OBJECTS database.

		mov eax,nsizeactualold
		add eax,nsizeobjectstemp
		mov g_ndatabasesize,eax 	;new total size of database.
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,g_ndatabasesize,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
								  .IF eax==0
										;fail...
										invoke DestroyWindow, g_hwnd	 ;exit.
										mov g_ndatabasesize,0
										invoke myalertbox,ADDR szer204,80Ah ;eax ;invoke myerrorhandler,204
										jmp ex1 ;exit.
								  .ENDIF
								  mov pTERSEDATA,eax	;new pointer.
		;ah-ha! pendactualold (pointer to total end of old database) is
		;now invalid. recalculate it...
		add eax,nsizeactualold
		mov pendactualold,eax

;now copy objects from pTERSEDATAtemp across to pTERSEDATA...
		mov ebx,pTERSEDATAtemp
		mov ecx,(TERSEDATA PTR [ebx]).numrecords  ;number objects incoming.

				;adding some intelligence. add incoming objects to
				;highlighted list, so can move them...
				.IF cx>NUMHIGHLIGHTED	;size limit on highlighted list.
				  ;pushad
				  invoke myalertbox,ADDR szer103,1 ;invoke myerrorhandler,103
				  ;popad
				.ENDIF

	  mov esi,(TERSEDATA PTR [ebx]).noffsetobjs
	  add esi,ebx ;pTERSEDATA ;starting address of OBJECTS.
		mov ebx,pTERSEDATA
		mov edi,pendactualold  ;total end of old database.
		;ebx-->TERSEDATA...

				;introduced a dummy data-element in position #0 of database
				;when imported though, won't be at start of database...
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				.IF al==01 ;valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF ax==-1 ;data-element.
						;eliminate it... (otherwise integritycheck() will cough)
						mov (OBJECT PTR [esi]).fstatus,0
				  .ENDIF
				.ENDIF

				mov highlightedindex,0	;empty highlighted list.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				mov g_nstate,0	;precaution.
				mov g_fclrhighlighted,0 ;allow display multiple highlighted.
				mov g_pselectedobject,0 ;precaution.

nxtobj:
;we copy objects *regardless* of valid/data/null types...
;as we are copying into a newly allocated region in TERSEDATA, no
;problem with clashing with existing objects (except for those that
;may occupy same coords). so, we copy *everything* across...
								   ;copy one object...
								   pushad
								   mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
nxtbyte:						   mov al,[esi]
								   mov [edi],al
								   inc esi
								   inc edi
								   loop nxtbyte
								   popad

		  mov eax,(OBJECT PTR [edi]).nexttype
		  ;v1.26 err, dataelements will all have bits14-31 set (0FFFFC000h) and
		  ;v1.31 and 0FFFFE000h bits13-31 set (submenu data element).
		  ;library-object elements will all have bits15-31 set (0FFFF8000h), so
		  ;to exclude all of these invisible elements, just do this...
		  .IF SWORD PTR ax>=0 ;eax != -1
				invoke add2highlightedlist0,edi
				;...v1.26 have found a bug ...cannot call add2highlightedlist() here.
				;(nothing got into the highlighted list).
				or (OBJECT PTR [edi]).fconfig2,10000000b ;bit7,display highlighted.
		  .ENDIF

		mov eax,(TERSEDATA PTR [ebx]).nsizeobject
		add edi,eax 							;next object
		add esi,eax 							;/
		loop nxtobj

;update the number-of-objects field in TERSEDATA...
		;update .numrecords...
		mov esi,pTERSEDATAtemp
		mov edi,pTERSEDATA
		;xor ecx,ecx
		mov ecx,(TERSEDATA PTR [esi]).numrecords
		add (TERSEDATA PTR [edi]).numrecords,ecx

;now need to scan thru the newly-added objects and offset all
;OBJECT pointer fields, by amount nsizeobjectsold...
		mov esi,pTERSEDATA
		mov ecx,(TERSEDATA PTR [esi]).numbitmaps
		mov ebx,nsizeobjectsold
		xor eax,eax
		mov ax,numobjectstemp
		invoke updateobjptrs,pendactualold,eax,ebx,ecx
		;...pendactualold->start of newly imported objects,
		; numobjectstemp=number of incoming objects.
		; nsizeobjectsold=change added to pointers.
		; numbitmaps=change added to new icon.nlibrary if non-0.


;now deallocate pTERSEDATAtemp...
								invoke GlobalHandle,pTERSEDATAtemp
								invoke GlobalFree,eax ; pTERSEDATAtemp
;								mov pTERSEDATAtemp,0
								  .IF eax==0	;returns 0 if succeeds.
								  .ELSE
									;GlobalFree() failed...
									invoke myalertbox,ADDR szer208,80Bh ;eax ;invoke myerrorhandler,208
									jmp ex1
								  .ENDIF

;i think need this to fix element numbers (.number) fields...
				invoke checkintegrity,1 ;=1 suppress all msgs.
				;...also fixes.

;the database may contain composite-object library members. need to
;load them into the Elements menu...
				invoke addcomposites2menu,0

;now tidy up...

		;v2.15
		;move diagram so highlighted objs in centre of window...
		mov ebx,pTERSEDATA
		mov edx,(TERSEDATA PTR [ebx]).nzoom
		.IF highlightedindex != 0 ;precaution.
		  mov ebx,highlightedlist
		  .IF ebx != 0 ;precaution.
			mov eax,(OBJECT PTR [ebx]).xtopleft
			mov ecx,(OBJECT PTR [ebx]).ytopleft
			invoke centralizeobj,eax,ecx,edx,0 ;only if not inside window.
			;;need to move the mouse-cursor...
			;jmp edoit1
		  .ENDIF
		.ENDIF

exx:
		  ;v1.26 restore cursor...
		  invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		  
ex4:	invoke zeroabsoluteptrs,0 ;must leave highlightedindex as-is.

ex3:	invoke InvalidateRgn, g_hwnd,0,FALSE	;don't erase existing.
		  mov g_fredrawdiag,ENTIRE								;redraw entire window.
out1:
	    ret
ex2:  ;close file, error exit...
			invoke GlobalHandle,pTERSEDATAtemp
			invoke GlobalFree,eax ; pTERSEDATAtemp
ex1:  ;error exit
		  jmp exx
openmerge ENDP

;--------------------------------------------------------------------------
.DATA?
ALIGN 4   ;v3.44...
NELEMENTSBITMAPS EQU 10 ;10 of these...
hbitmap474 DWORD ? ;handles of bitmaps loaded to elements menu. v3.44
hbitmap475 DWORD ?
hbitmap476 DWORD ?
hbitmap477 DWORD ?
hbitmap478 DWORD ?
hbitmap479 DWORD ?
hbitmap480 DWORD ?
hbitmap481 DWORD ?
hbitmap482 DWORD ?
hbitmap483 DWORD ?

.DATA
ALIGN 4 ;v3.24
xscreenpixels DWORD 0	;display pixels/inch, x
yscreenpixels DWORD 0	;display pixels/inch, y
xprintpixels  DWORD 0	;ditto, printer
yprintpixels  DWORD 0	;/
g_nxratio	  SDWORD 0		;printer>display scaling, x
g_nyratio	  SDWORD 0		;/ ,y	(actually these always +ve values)
RATIOSCALE	  EQU 4 	;#shifts. above ratios are 16x actual.
g_nxprnpixsize	 DWORD 0				;width of printer paper, in pixels.
g_nyprnpixsize	 DWORD 0				;height /
xclientpixels DWORD 0	;width of client area, in pixels.
yclientpixels DWORD 0	;/
xwinext    SDWORD 0 ;# pixels corresponding to paper width (in screen pixels).
ywinext    SDWORD 0 ;/	" height.
xwinext_exact SDWORD 0 ;above slightly lower, by MARGINADJ.
ywinext_exact SDWORD 0 ;/
XMARGINADJ EQU 10
YMARGINADJ EQU 10
;szmodulefilename BYTE 256 DUP(0)
hmodulefile DWORD 0  ;must be global.
g_cycaption DWORD 0
g_cyframe	DWORD 0
g_cyborder	DWORD 0
g_cymenu	DWORD 0

fNT BYTE 0 ;=0 if win9x. =3 if OS is NT3.5, =4 if NT4, =5 NT5 or later.
fdrivertransparent BYTE 0  ;v2.90
  BYTE 0,0

;v3.01 moved these from eve database...
szeditor1	 BYTE "WORDPAD.EXE",0  ;
		       BYTE 244 DUP(0)	;256 bytes total.	
szeditor2  BYTE "NOTEPAD.EXE",0 ;v2.31
           BYTE 244 DUP(0) ; 256 bytes total.
szbrowser2 BYTE 256 DUP(0) ;alternative browser.
szpainter1 BYTE "MSPAINT.EXE",0
           BYTE 244 DUP(0) ;external paint app.

.CODE
;v300c... read-only data, defined in code segment...
;eve.ini file...
szzero		BYTE "0000",0 ;must be 4 zero chars.
sztwo     BYTE "2",0 ;v3.31
szsectionpreferences BYTE "preferences",0
szentryfeveprefs	 BYTE "feveprefs",0
szentryfviewprefs	 BYTE "fviewprefs",0
szentrynbackground	 BYTE "nbackground",0
szentrycharsetdefault BYTE "charsetdefault",0
szentryxfineprn 	 BYTE "xfineprn",0
szentryyfineprn 	 BYTE "yfineprn",0
szentryszeditor 	 BYTE "szeditor",0
szentry2szeditor 	 BYTE "szeditor2",0
szentryszbrowser2  BYTE "szbrowser2",0
szentryszpainter   BYTE "szpainter",0
szentrynhandleradius    BYTE "handleradius",0 ;v3.31
szno BYTE "no",0
sznon BYTE "non",0
;v2.28 this is section and keys in eve.ini file, used header svg gen...
szsectionsvgpre BYTE "svgpre",0
szentryline1    BYTE "line1",0
szentryline2    BYTE "line2",0
szentryline3    BYTE "line3",0
szentryline4    BYTE "line4",0
szentryline5    BYTE "line5",0

;--------------------------------------------------------------------------
loadcheckmarks PROC STDCALL, helementsmenu:DWORD
; "loadcheckmarks"
;note, NELEMENTSBITMAPS EQU 10, defines how many of these.
				invoke SetMenuItemBitmaps,helementsmenu,IDM_NODE,MF_BYCOMMAND,hbitmap474,hbitmap474
				invoke SetMenuItemBitmaps,helementsmenu,IDM_NODEP,MF_BYCOMMAND,hbitmap475,hbitmap475
				invoke SetMenuItemBitmaps,helementsmenu,IDM_SYNC2,MF_BYCOMMAND,hbitmap476,hbitmap476
				invoke SetMenuItemBitmaps,helementsmenu,IDM_POLY,MF_BYCOMMAND,hbitmap477,hbitmap477
				invoke SetMenuItemBitmaps,helementsmenu,IDM_RES,MF_BYCOMMAND,hbitmap478,hbitmap478
				invoke SetMenuItemBitmaps,helementsmenu,IDM_RESR,MF_BYCOMMAND,hbitmap479,hbitmap479
				invoke SetMenuItemBitmaps,helementsmenu,IDM_WIRE,MF_BYCOMMAND,hbitmap480,hbitmap480
				invoke SetMenuItemBitmaps,helementsmenu,IDM_VECTOR,MF_BYCOMMAND,hbitmap481,hbitmap481
				invoke SetMenuItemBitmaps,helementsmenu,IDM_UVECTOR,MF_BYCOMMAND,hbitmap481,hbitmap481
				invoke SetMenuItemBitmaps,helementsmenu,IDM_MULTI,MF_BYCOMMAND,hbitmap482,hbitmap482
				invoke SetMenuItemBitmaps,helementsmenu,IDM_label,MF_BYCOMMAND,hbitmap483,hbitmap483

    ret
loadcheckmarks ENDP
;--------------------------------------------------------------------------
wmcreate PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
				LOCAL hdc1:DWORD,ffnd:BYTE,fspaces:BYTE
				LOCAL szmodulefilename[256]:BYTE
				LOCAL myosinfo:OSVERSIONINFO
; "wmcreate"
		mov szmodulefilename,0
		mov hmodulefile,0
		mov szpathspeceveini,0

;one of the first jobs is to create a new default database...
				mov g_ndatabasesize,(SIZEOF TERSEDATA) ;actual size of database in memory.
				mov eax,(SIZEOF TERSEDATA)+8096 ;128 ;128 is slop space.
				;...v2.15 why not allocate lots of extra space?!
        ;mov g_errorapi,0A8Bh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GlobalAlloc,GMEM_FIXED,eax ;g_ndatabasesize
				.IF eax==0								;NULL
				  ;fail...
		      invoke myalertbox,ADDR szer203,80Ch ;eax ;invoke myerrorhandler,203
				  mov pTERSEDATA,0								;should be 0, but be sure.
				  invoke DestroyWindow, g_hwnd	  ;exit eve
								;NOTE this will post WM_DESTROY msg, which calls wmdestroy()
								;which posts PostQuitMessage().
				  ret
				.ELSE
				  mov pTERSEDATA,eax	;address of memory block.
				.ENDIF
;now copy complete default template to memory block...
												mov edi,pTERSEDATA
												lea ebx,instantiatedTERSEDATA
												mov ecx,(SIZEOF TERSEDATA)
oo1:									mov al,[ebx]
												mov [edi],al
												inc ebx
												inc edi
												dec ecx
												jnz oo1

		mov edi,pTERSEDATA

		  ;we have a blank new eve database,
		  ;need to set .noffsetobjs ...(createnewobject() needs it)
				lea eax,(TERSEDATA PTR [edi]).OBJECTS
				sub eax,edi
				mov (TERSEDATA PTR [edi]).noffsetobjs,eax

;object.number field starts from zero (1st element in OBJECTS) which is
;a problem for any other element that is attached to it -- due to some
;problem with my code, it becomes unattached. so, create a dummy data
;element...
				invoke createnewobject,0
				.IF eax==0
				.ELSE
				  mov ebx,eax
				  xor eax,eax
				  mov (OBJECT PTR [ebx]).nexttype,-1 ;data-element.
				  mov (OBJECT PTR [ebx]).rpowner1,eax ;0 			  ;precaution.
				  mov (OBJECT PTR [ebx]).rpowner2,eax ;0 			  ;/
				  mov (OBJECT PTR [ebx]).ximage,eax ;0 ;/
				  mov (OBJECT PTR [ebx]).number,eax ;0 ;don't use it.
				  mov (OBJECT PTR [ebx]).nrings,eax ;0
				  mov (OBJECT PTR [ebx]).nbeginring,eax ;0
				  mov (OBJECT PTR [ebx]).nendring,eax ;0
				  ;v3.13d for export to svg, choose default o/p width/height in pixels...
				  mov (OBJECT PTR [ebx]).fconfig3,10000000b ;bits7/6 =1/0 pixels.
				.ENDIF

;now here's the stuff from old goofee...

  ;mov g_errorapi,0A8Ch ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetClientRect, g_hwnd, ADDR clientrect
   ;..returns coord of client rect. (left/top=0/0, right/bottom=width/height)
   ;..we only use the left/top origin coords, for origin-shifting.
				  add clientrect.rc_left,4				   ;
				  add clientrect.rc_right,4    ;/  (fixes a zooming problem
				  add clientrect.rc_top,4				   ;/	when scrolling on axis)
				  add clientrect.rc_bottom,4	   ;/
				invoke GetClientRect, g_hwnd, ADDR clientrectold ;backup copy.

;280900
;wmsize() (WM_SIZE) invoked when window has been resized, sets
;xclientpixels,yclientpixels =width,height of client area, for use by
;xkeydown() for window scrolling by arrow-keys.
;however, I should set them initially here also? ...
				mov eax,clientrectold.rc_right
				mov xclientpixels,eax
				mov eax,clientrectold.rc_bottom
				mov yclientpixels,eax

				  add clientrectold.rc_left,4	   ;
				  add clientrectold.rc_right,4	   ;/
				  add clientrectold.rc_top,4					   ;/
				  add clientrectold.rc_bottom,4    ;/

  ;mov g_errorapi,0A8Dh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetWindowRect, g_hwnd, ADDR windowrect	;used for clipping.
				;v1.21
				;scrollingbymouse() modifies windowrect<>, need save actual right
				;boundary for placement of x/y mouse coords... (updated in wmsize())
				mov eax,windowrect.rc_right ;screen coords.
				sub eax,windowrect.rc_left
				mov g_windowright,eax ;window-relative coords.

;timer...
  ;mov g_errorapi,0A8Eh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetTimer, g_hwnd,1,250,0 ;generates WM_TIMER, every 500msec.
										   ;***NOTE*** experiment with 250msec, for scrolling


		  ;invoke getprinterdetails ;-->szname,szdriver,szport
		  invoke printeranalysis,0		;0=initialise structure fields.

		  ;v1.21
		  ;get height of window caption area, to calc location of text in xpaint_extras()...
      ;mov g_errorapi,0A8Fh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke GetSystemMetrics,SM_CYCAPTION
		  mov g_cycaption,eax ;in screen units.
		  invoke GetSystemMetrics,SM_CYFRAME
		  mov g_cyframe,eax ;in screen units.
		  invoke GetSystemMetrics,SM_CYBORDER
		  mov g_cyborder,eax ;in screen units.
		  invoke GetSystemMetrics,SM_CYMENU
		  mov g_cymenu,eax ;in screen units.



;is there an embedded EVE file?...
;how to get a handle for currently-running file?...
        ;mov g_errorapi,0A90h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetModuleFileNameA,0,ADDR szmodulefilename,255
;								invoke SetFileAttributesA,ADDR szmodulefilename, \
;														 FILE_ATTRIBUTE_NORMAL

                ;mov g_errorapi,0A91h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke CreateFile, ADDR szmodulefilename,\
								GENERIC_READ,\	;*WON'T ACCEPT GENERIC_WRITE* <<<<
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, OPEN_EXISTING,\				;only opens an existing file.
								FILE_ATTRIBUTE_NORMAL, 0
								.IF eax==INVALID_HANDLE_VALUE	;-1
								  ;open failed ...
								  invoke myalertbox,ADDR szer217,80Dh ;eax ;invoke myerrorhandler,217
								  jmp n56
								.ENDIF
								mov hmodulefile,eax  ;handle of newly-opened file.

        ;mov g_errorapi,0A92h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SetFilePointer,hmodulefile,-12,0,FILE_END ;looking for endmarker.
				.IF eax==-1
				  invoke myalertbox,ADDR szer217,80Eh ;eax ;invoke myerrorhandler,217
				  jmp n56x
				.ENDIF
				;lea eax,szasciitbl
				;lea ebx,nbyteswrote
				invoke ReadFile,hmodulefile,ADDR szasciitbl,8,ADDR nbyteswrote,0
				.IF DWORD PTR szasciitbl==-1
mkr1:		  .IF DWORD PTR szasciitbl+4==-1
						;32-bit value =-1 means an EVE file already embedded.
						
						  ;need to be certain it is an embedded file... v3.36
				      invoke SetFilePointer,hmodulefile,-20,0,FILE_END ;special field, total size.
				      invoke ReadFile,hmodulefile,ADDR szasciitbl,4,ADDR nbyteswrote,0
				      invoke GetFileSize,hmodulefile,0  ;-20 field of file has size of file.
				      .IF DWORD PTR szasciitbl==eax ;then it is compressed.
						    invoke openembedded,hmodulefile,ADDR szmodulefilename
						    jmp n56y
						  .ENDIF
						  
						.IF eax==0
						  invoke myalertbox,ADDR szer218,80Fh ;eax ;invoke myerrorhandler,218
						.ENDIF
				  .ENDIF
				.ELSEIF DWORD PTR szasciitbl==-2 ;new LZP format. v3.36
				  jmp mkr1
				.ENDIF
				;doesn't have embedded eve, so close file...

n56x: ;file open, can't set filepointer...
				invoke CloseHandle,hmodulefile
n56:  ;file not open if jumped to here...
				mov hmodulefile,0
n56y: ;if jumped to here,opened embedded eve file, leave hmodulefile open.
		  ;(note, openembedded() sets g_hfile=hmodulefile, also copies
		  ; szmodulefilename to szfile).

		  ;we've opened an emmbedded eve file, or we have a blank new one,
		  ;need to set this if zero...
		  ;(precaution, in case of an old embedded eve file without this
		  ; field set --see above, already done for new eve file)...
		  mov edi,pTERSEDATA
		  mov eax,(TERSEDATA PTR [edi]).noffsetobjs
		  .IF eax==0
				;load the default...
				lea eax,(TERSEDATA PTR [edi]).OBJECTS
				sub eax,edi
				mov (TERSEDATA PTR [edi]).noffsetobjs,eax
		  .ENDIF


;can open an .EVE file from the commandline. at startup copied the commandline
;(not the program name) into szcommandline...
;commandline has this format: path\eve.exe "path\file.eve"
;bug -- path and filenames allowed to have space chars. note also,
;i want it to work with or without the double-quotes.
		.IF hmodulefile==0
				mov ffnd,0
				mov fspaces,0
				lea ebx,szcommandline
x98:			mov al,[ebx]
				.IF al==0 ;no commandline tail.
				.ELSEIF al==0Dh ;/
				.ELSEIF al==0Ah ;/
				.ELSE
				  .IF al==" "
						;fix a bug... allowed to have space in path...
						cmp fspaces,0
						je x87 ;ignore any spaces.
x88:			 mov ffnd,1
x87:			 inc ebx
						 jmp x98
				  .ELSEIF al==09 ;tab char.
						 jmp x88
				  .ELSEIF al==22h ;double-quote char.
						jmp x87
				  .ENDIF
				  .IF ffnd==0 ;in case stuff before the datafilename.
						.IF fspaces==0 ;ignoring spaces.
						  ;we'll ignore spaces until get to string ".exe"...
						  .IF al=="."
								mov al,[ebx+1]
								.IF al=="e"
y11:					  mov al,[ebx+2]
								  .IF al=="x"
y12:							mov al,[ebx+3]
										.IF al=="e"
y13:							  mov fspaces,1
										.ELSEIF al=="E"
										  jmp y13
										.ENDIF
								  .ELSEIF al=="X"
										jmp y12
								  .ENDIF
								.ELSEIF al=="E"
								  jmp y11
								.ENDIF
						  .ENDIF
						.ENDIF
						inc ebx
						jmp x98
				  .ENDIF
						;hmmm, we need to go to opendatafile() but bypass all the open-file
						;stuff....
						mov ftail,1
						;dec ebx
						invoke lstrcpy,ADDR szfile,ebx
						  ;need to get rid of the double-quote char on end...
						  invoke lstrlen,ADDR szfile
						  lea ebx,szfile
						  add ebx,eax
						  dec ebx
x55:					  mov al,[ebx]
						  .IF al==0Dh
x56:						dec ebx
							jmp x55
						  .ELSEIF al==0Ah
								jmp x56
						  .ELSEIF al==22h ;double-quote char.
								mov [ebx],BYTE PTR 0
						  .ENDIF
						invoke opendatafile
						;no, further down... mov ftail,0
				.ENDIF
		.ENDIF

		;v1.39
		;szmodulefilename has path/filename of this executable. copy it
		;to szpathspeceveini and change filename to "eve.ini".
		;then, read eve.ini and load last opened file to "File" menu...
		invoke lstrcpy,ADDR szpathspeceveini,ADDR szmodulefilename
		invoke lstrlen,ADDR szpathspeceveini
		or eax,eax ;cmp eax,0
		je mx2	 ;precaution.
		lea ebx,szpathspeceveini
		add ebx,eax
		dec ebx
		  ;i think, just go back until first "/"...
		  mov ecx,eax
mx1:	mov al,[ebx]
		  cmp al,"\"
		  je mx3
		  dec ebx
		  loop mx1
		  mov szpathspeceveini,0
		  jmp mx2 ;"\" not found.
mx3:	          inc ebx

        ;v2.95 not, i could have used GetCurrentDirectory(). anyway, i want to
        ;save this home folder...
        mov [ebx],BYTE PTR 0
        push ebx
        invoke lstrcpy,ADDR szhomefolder,ADDR szpathspeceveini ;sometimes in app,
        pop ebx            ;need to restore current directory to home.
        ;...note, szhomefolder gets changed whenever open a .EVE file.

		  invoke lstrcpy,ebx,ADDR szeveini ;append "eve.ini"
			;append szpathspeceveini to File menu...
			
  ;mov g_errorapi,0A93h ;for crash outside EVE, error codes range Axxh. v3.23
			invoke append2filemenu,0 ;0=append, with separator.
			  ;v1.39
			  ;if new datafile, use defaults from eve.ini...
			  .IF ftail==0 ;no tail.
				.IF hmodulefile==0 ;no embedded file.
				  invoke prefs2new ;read eve.ini, to new datafile preferences.
				.ENDIF
			  .ENDIF
mx2:			
			mov ftail,0 ;moved down from above.


;v2.28
;for svg o/p, want the header text to optionally be in the eve.ini file.
;in section "[svgpre]" and "line1=", "line2=", etc.
;the default header is in eve2.asm, at "szsvgpre:".
;i'll add "szline2:", szline3:", szline4:, szline5:"...
IFE fDEVELOPER
ELSE
        ;get 1st line...
        lea ebx,szasciibuf
        mov [ebx],DWORD PTR 0
  ;mov g_errorapi,0A94h ;for crash outside EVE, error codes range Axxh. v3.23
	invoke GetPrivateProfileString,ADDR szsectionsvgpre,ADDR szentryline1, \
		  ADDR sznon,ebx,126,ADDR szpathspeceveini
	lea ebx,szasciibuf
	cmp [ebx],DWORD PTR "non" ;"no" 3
	je qq2 ;qmx1
	lea ebx,szasciibuf
	lea ecx,szsvgpre
	invoke lstrcpy,ecx,ebx ;ADDR szasciibuf
        ;get 2nd line...
qq2:    lea ebx,szasciibuf
        mov [ebx],DWORD PTR 0
	invoke GetPrivateProfileString,ADDR szsectionsvgpre,ADDR szentryline2, \
		  ADDR sznon,ebx,126,ADDR szpathspeceveini
	lea ebx,szasciibuf
	cmp [ebx],DWORD PTR "non" ;"no" 3
	je qq3 ;qmx1
;        lea ebx,szasciibuf
	lea ecx,szline2
	invoke lstrcpy,ecx,ebx ;ADDR szasciibuf
        ;get 3rd line...
qq3:    lea ebx,szasciibuf
	invoke GetPrivateProfileString,ADDR szsectionsvgpre,ADDR szentryline3, \
		  ADDR sznon,ebx,126,ADDR szpathspeceveini
	lea ebx,szasciibuf
	cmp [ebx],DWORD PTR "non" ;"no" 3
	je qq4 ;qmx1
;        lea ebx,szasciibuf
	lea ecx,szline3
	invoke lstrcpy,ecx,ebx ;aDDR szasciibuf
        ;get 4th line...
qq4:    lea ebx,szasciibuf
	invoke GetPrivateProfileString,ADDR szsectionsvgpre,ADDR szentryline4, \
		  ADDR sznon,ebx,126,ADDR szpathspeceveini
	lea ebx,szasciibuf
	cmp [ebx],DWORD PTR "non" ;"no" 3
	je qq5 ;qmx1
;        lea ebx,szasciibuf
	lea ecx,szline4
	invoke lstrcpy,ecx,ebx ;ADDR szasciibuf
        ;get 5th line...
qq5:    lea ebx,szasciibuf
	invoke GetPrivateProfileString,ADDR szsectionsvgpre,ADDR szentryline5, \
		  ADDR sznon,ebx,126,ADDR szpathspeceveini
	lea ebx,szasciibuf
	cmp [ebx],DWORD PTR "non" ;"no" 3
	je qmx1
    ;    lea ebx,szasciibuf
	lea ecx,szline5
	invoke lstrcpy,ecx,ebx ;ADDR szasciibuf
qmx1:
ENDIF



;;v2.14
;;will use ShellExecuteEx() to launch other windows apps, based on file-associations.
;;need a structure for this...
;		 mov myshell.cbSize,SIZEOF SHELLEXECUTEINFO
;		 mov eax,g_hwnd
;		 mov myshell.hwnd,eax
;		 lea eax,szopen
;		 mov myshell.lpVerb,eax
;		 xor eax,eax
;		 mov myshell.lpParameters,eax
;		 mov myshell.lpDirectory,eax
;		 mov myshell.nShow,eax
;		 mov myshell.hInstApp,eax
;		 mov myshell.fMask,eax ;SEE_MASK_NOCLOSEPROCESS

;v2.14
;determine whether winNT or Win9x...
		mov myosinfo.ov_dwOSVersionInfoSize,OSVERSIONINFO_ ;size.
		lea eax,myosinfo
  ;mov g_errorapi,0A95h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GetVersionEx,eax
		mov eax,myosinfo.ov_dwPlatformId
		mov fNT,4 ;winNT4+
		.IF eax==VER_PLATFORM_WIN32_WINDOWS
		  mov fNT,0 ;win9x.
		.ELSE
		  mov eax,myosinfo.ov_dwMajorVersion ;v2.90
		  ;.IF eax==3 ;NT3.x
		    mov fNT,al
		  ;.ENDIF
		.ENDIF

;v2.90 find out if video supports a transparent color...
  ;mov g_errorapi,0A96h ;for crash outside EVE, error codes range Axxh. v3.23
			invoke GetDC,g_hwnd					;-->eax=display context client area.
			mov hdc1,eax
      invoke GetDeviceCaps,hdc1,CAPS1 ;enquire if device driver can do transparent.
      and eax,C1_TRANSPARENT
      .IF eax != 0 ;==C1_TRANSPARENT
        mov fdrivertransparent,1
      .ENDIF
			invoke ReleaseDC,g_hwnd,hdc1

      ;v3.44
      ;load bitmaps from resources. note must also call DeleteObject() when wmdestroy().
      mov esi,474
      lea ebx,hbitmap474
      mov ecx,NELEMENTSBITMAPS ;10
nxtb1: mov edi,ecx
       push ebx
			 invoke LoadBitmap,g_hinst,esi ;in .rc file, menu_***.bmp.
			 pop ebx
			 mov [ebx],eax ;handle of bitmap.
      inc esi
      add ebx,4
      mov ecx,edi
      loop nxtb1
      ;will call SetMenuItemBitmaps() to load to menu.
      
      ;v3.44 now load bitmaps to menu items...
      invoke GetMenu,g_hwnd
      invoke GetSubMenu,eax,1 ;1=Elements menu.
      invoke loadcheckmarks,eax ;helementsmenu

						  push eax						   ;save previous value of state.
						  mov al,g_nstate		   ;/
						  mov g_nstateprev,al  ;/
						  pop eax						   ;/
		  mov g_nstate,0
		  mov g_pmovingobject,0
		  mov g_pselectedobjnew,0
		  invoke InvalidateRgn, g_hwnd,0,TRUE	 ;invalidate entire window.
		  mov g_fredrawdiag,ENTIRE								  ;redraw entire window.
		ret
wmcreate ENDP
;--------------------------------------------------------------------------

append2filemenu PROC STDCALL USES ebx ecx edx esi edi,freplace:DWORD
	LOCAL hmenu0:DWORD,hfilemenu:DWORD
; "append2filemenu"
;gets last-open eve file out of eve.ini, appends to File menu.
;wmcreate setup pathspec for eve.ini, in szpathspeceveini.
;freplace=1, replace last entry at end of File menu.

	mov szlastopen,0
  ;mov g_errorapi,0A97h ;for crash outside EVE, error codes range Axxh. v3.23
	invoke GetPrivateProfileString,ADDR szsectionopen,ADDR szentryfile1, \
		  ADDR szno,ADDR szlastopen,255,ADDR szpathspeceveini
	cmp eax,3
	jbe mx1
	cmp szlastopen,0
	je	mx1
	  ;now write szlastopen to File menu...
	  invoke GetMenu,g_hwnd
	  mov hmenu0,eax
	  invoke GetSubMenu,hmenu0,0 ;0=File menu.
	  mov hfilemenu,eax
	  .IF freplace==0 ;append to File menu.
mx3:	invoke AppendMenuA,hfilemenu,MF_SEPARATOR,0,0
		invoke AppendMenuA,hfilemenu,MF_STRING,IDM_LASTOPEN,ADDR szlastopen
		;(IDM_LASTOPEN =600 =identifier for menu item).
	  .ELSE
		invoke DeleteMenu,hfilemenu,MF_BYCOMMAND,IDM_LASTOPEN
		jmp mx3
	  .ENDIF

mx1:
	ret
append2filemenu ENDP
;--------------------------------------------------------------------------
prefs2new PROC STDCALL USES ebx ecx edx esi edi
				LOCAL szbuf[256]:BYTE
; "prefs2new"
;reads [preferences] section from eve.ini, applies to new datafile.

				  mov szbuf,0
				  mov edi,pTERSEDATA
  ;mov g_errorapi,0A98h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentryfeveprefs,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
					 ;if entry not there, or eve.ini not there, bypass rest...
					 cmp DWORD PTR szbuf,"0000" ;nothing read.
					 je mx2
					 or eax,eax ;cmp eax,0 ;precaution
					 je mx2
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).feveprefs,eax
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentryfviewprefs,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).fviewprefs,eax
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentrynbackground,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).nbackground,eax
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentrycharsetdefault,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).charsetdefault,eax
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentryxfineprn,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).xfineprn,eax
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentryyfineprn,ADDR szzero,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).yfineprn,eax
				  ;v3.31...
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ADDR szentrynhandleradius,ADDR sztwo,ADDR szbuf,255,ADDR szpathspeceveini
				  invoke str2longint,ADDR szbuf
				  mov (TERSEDATA PTR [edi]).nhandleradius,eax
				
				  ;v3.00 *LOOKS LIKE FOUND XP/2000 BUG: can't use "sznull" for lpdefault param...
				  ;NO, that wasn't the problem! can put sznull back if want to.
				  ;lea ebx,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1  v3.01
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				   ;ADDR szentryszeditor,ADDR sznull,ebx,255,ADDR szpathspeceveini
			ADDR szentryszeditor,ADDR szzero,ADDR szeditor1,255,ADDR szpathspeceveini ;v3.01
				     ;lea ebx,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1 ;v3.00  v3.01
				     cmp DWORD PTR szeditor1,"0000"             ;/   v3.01
				     jne not0000                            ;/
				     mov szeditor1,0  ;null string.    ;/ v3.01
not0000:				                                    ;/
				  ;v2.31
				  ;lea ebx,(TERSEDATA PTR [edi]).szeditor2  v3.01
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
				ADDR szentry2szeditor,ADDR szzero,ADDR szeditor2,255,ADDR szpathspeceveini ;v3.01
				     ;lea ebx,(TERSEDATA PTR [edi]).szeditor2 ;v3.00 v3.01
				     cmp DWORD PTR szeditor2,"0000"             ;/  v3.01
				     jne not0000b                            ;/
				     mov szeditor2,0  ;null string.    ;/  v3.01
not0000b:				                                    ;/
				  ;v2.89
				  ;lea ebx,(TERSEDATA PTR [edi]).szbrowser2  v3.01
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
			ADDR szentryszbrowser2,ADDR szzero,ADDR szbrowser2,255,ADDR szpathspeceveini ;v3.01
				     ;lea ebx,(TERSEDATA PTR [edi]).szbrowser2 ;v3.00  v3.01
				     cmp DWORD PTR szbrowser2,"0000"             ;/ v3.01
				     jne not0000c                            ;/
				     mov szbrowser2,0  ;null string.    ;/ v3.01
not0000c:				                                    ;/
				  ;v2.92
				  ;lea ebx,(TERSEDATA PTR [edi]).szpainter1  v3.01
				  invoke GetPrivateProfileString,ADDR szsectionpreferences, \
			 ADDR szentryszpainter,ADDR szzero,ADDR szpainter1,255,ADDR szpathspeceveini ;v3.01
				     ;lea ebx,(TERSEDATA PTR [edi]).szpainter1 ;v3.00  v3.01
				     cmp DWORD PTR szpainter1,"0000"             ;/ v3.01
				     jne not0000d                            ;/
				     mov szpainter1,0  ;null string.    ;/ v3.01
not0000d:				                                    ;/

		  ;have to tell the window class about this...
		  mov ebx,(TERSEDATA PTR [edi]).nbackground
		  .IF ebx==3 ;special case...
			mov eax,COLOR_WINDOW
			inc eax
			jmp go1
		  .ENDIF
		  mov eax,ebx
		  shl eax,1 ;dword
		  shl eax,1 ;/
		  lea ebx,g_hwhitebrush
		  add ebx,eax ;address of brush.
		  mov eax,[ebx] ;get brush.
go1:	  invoke SetClassLongA,g_hwnd,GCL_HBRBACKGROUND,eax

		  ;v1.40
		  ;set coarseness when drag an element...
		  mov eax,(TERSEDATA PTR [edi]).feveprefs
		  and al,01100000b ;bits5/6.
		  .IF al==0 ;fine 1 unit.
			mov fdragmask,0FFh
		  .ELSEIF al==0100000b ;2 units.
			mov fdragmask,0FEh
		  .ELSE    ;coarse 4 units.
			mov fdragmask,0FCh
		  .ENDIF
		  
mx2:
	ret
prefs2new ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
mydevmode DEVMODE <>
mydevnames DEVNAMES <>
hdevmode DWORD 0
hdevnames DWORD 0

.CODE
printeranalysis PROC STDCALL USES ebx ecx edx esi edi,freenter:DWORD
		LOCAL hdcp:DWORD,hdc1:DWORD
; "printeranalysis"
;*EVE* called from wmcreate and myprintersetup...
;freenter=0 on first entry from wmcreate(), clrs fields.

;find out the resolution of the display...
  ;mov g_errorapi,0A99h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetDC, g_hwnd					;-->ax=display context client area.
				mov  hdc1,eax
				invoke GetDeviceCaps, hdc1,LOGPIXELSX	;query pixels/inch.
				mov  xscreenpixels,eax
				invoke GetDeviceCaps, hdc1,LOGPIXELSY	;query pixels/inch.
				mov  yscreenpixels,eax
				invoke ReleaseDC, g_hwnd,hdc1

;create a display-context for the printer...
				  .IF freenter==0
						mov myprintdlg.pr_lStructSize,SIZEOF PRINTDLGA
						mov myprintdlg.pr_hwndOwner,0
						  invoke GlobalHandle,ADDR mydevmode
						  mov hdevmode,eax
						mov myprintdlg.pr_hDevMode,eax ;0
						  invoke GlobalHandle,ADDR mydevnames
						  mov hdevnames,eax
						mov myprintdlg.pr_hDevNames,eax ;0
						mov myprintdlg.pr_hDC,0
						mov myprintdlg.pr_nFromPage,0
						mov myprintdlg.pr_nToPage,0
						mov myprintdlg.pr_nMinPage,0
						mov myprintdlg.pr_nMaxPage,0
						mov myprintdlg.pr_nCopies,0
						mov myprintdlg.pr_hInstance,0
						mov myprintdlg.pr_lCustData,0
						mov myprintdlg.pr_lpfnPrintHook,0
						mov myprintdlg.pr_lpfnSetupHook,0
						mov myprintdlg.pr_lpPrintTemplateName,0
						mov myprintdlg.pr_lpSetupTemplateName,0
						mov myprintdlg.pr_hPrintTemplate,0
						mov myprintdlg.pr_hSetupTemplate,0
						;mov eax,g_hwnd
						mov myprintdlg.pr_hwndOwner,0 ;eax
				 .ENDIF
		mov myprintdlg.pr_Flags,PD_RETURNDC+PD_RETURNDEFAULT
		invoke PrintDlgA, ADDR myprintdlg
		.IF eax==0		;error.
		  mov fnoprinter,1 ;flag that no printer driver, or misfunctioning.
;				   invoke myerrorhandler,019
				  mov eax,myprintdlg.pr_hDC
				  .IF eax==0
				  .ELSE
						invoke DeleteDC,eax
				  .ENDIF
				  ;free global memory objects...
				  mov eax,myprintdlg.pr_hDevMode
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
				  mov eax,myprintdlg.pr_hDevNames
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
		  ;just in case, put some default values into these...
		  mov xprintpixels,300
		  mov yprintpixels,300
		  mov g_nxprnpixsize,8*300 ;8 inches wide.
		  mov g_nyprnpixsize,10*300 ;10 inches high.
		  jmp go1
;		   ret
		.ENDIF
		mov ecx,myprintdlg.pr_hDC
		mov hdcp,ecx



;find out resolution of the printer...
				invoke GetDeviceCaps, hdcp,LOGPIXELSX	;query pixels/inch.
				mov  xprintpixels,eax
				invoke GetDeviceCaps, hdcp,LOGPIXELSY	;query pixels/inch.
				mov  yprintpixels,eax
				invoke GetDeviceCaps, hdcp,HORZRES		;query width in pixels.
				mov  g_nxprnpixsize,eax
				invoke GetDeviceCaps, hdcp,VERTRES		;query height in pixels.
				mov  g_nyprnpixsize,eax
				invoke DeleteDC, hdcp

go1:
;caclulate the ratio...
				mov  eax,xprintpixels	;print width. unsigned.
				;shl  eax,1 											 ;*4, so can be more accurate.
				;shl  eax,1 											 ;/
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
				xor  edx,edx
				mov  ebx,xscreenpixels	;screen width, unsigned.
				div  ebx								;unsigned divide
;***NOTE*** g_nxratio & g_nyratio should always be +ve,
;but i've defined them as SDWORD.
				mov  g_nxratio,eax				;display>printer scaling, x.
				mov  eax,yprintpixels	;print paper height.
;				 shl  eax,1 											 ;*4, more accurate.
;				 shl  eax,1 											 ;/
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
				xor  edx,edx
				mov  ebx,yscreenpixels	;display height.
				div  ebx
				mov  g_nyratio,eax				;display>printer scaling, y.

;setup logical-->device scaling...
				  mov  eax,g_nxprnpixsize		  ;size of paper, found above.
				  mov  ebx,g_nyprnpixsize		  ;/
						  .IF g_nxratio>1		  ;should always be!(higher prtr res.)
								  xor  edx,edx													   ;prn/scrn ratio
;								   shl eax,1			 ;cos we modified xratio*4
;								   shl eax,1			 ; back in xcreate.
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
								  div  g_nxratio				;scale-up by prn/scrn ratio. ;/
								  push eax																		 ;/
										mov  eax,ebx																	 ;/
										xor  edx,edx																	 ;/
;								   shl eax,1			 ;cos we modified xratio*4
;								   shl eax,1			 ; back in xcreate.
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
								  div	g_nyratio												 ;/
								  mov  ebx,eax	 ;new .rc_right in ax					 ;/
								  pop  eax				;new .rc_bottom in bx.			   ;/
						  .ENDIF
				  ;***NOTE*** actually +ve values, but these vars are signed...
				  mov xwinext_exact,eax
				  sub eax,XMARGINADJ
				  mov  xwinext,eax				;save. used by ctrl-arrow keys.
				  mov ywinext_exact,ebx
				  sub ebx,YMARGINADJ
				  mov  ywinext,ebx				;/



		ret
printeranalysis ENDP
;--------------------------------------------------------------------------
wmdestroy PROC wmsg:DWORD,wparam:DWORD,lparam:DWORD
; "wmdestroy"
				;close current datafile memory block...
				.IF pTERSEDATA==0
				.ELSE
				  ;it should always be non-zero, meaning a mem block exists...


				 ;this scans current database and wipes out any bitmap handles and DCs...
				 invoke deletebitmaphandles   ;(they are used for drawing GIFs)
				 ;...also any checkmark bitmap handles. v3.45

						.IF  g_fhaschanged==1
						  invoke myalertbox,ADDR szchanged,2
              ;invoke MessageBox,g_hwnd,ADDR szchanged,ADDR szeve,MB_OK+MB_YESNO+MB_ICONQUESTION
						  .IF ax==IDYES
								invoke savedatafile
						  .ENDIF
						.ENDIF


				  ;free the memory block...
  ;mov g_errorapi,0A9Ah ;for crash outside EVE, error codes range Axxh. v3.23
								invoke GlobalHandle,pTERSEDATA
								invoke GlobalFree,eax ; pTERSEDATA
								mov pTERSEDATA,0
						  .IF g_fhack1==1
								;user selected close-box at top of window (see WM_SYSCOMMAND)
								;seems that Windows frees the local memory block before
								;getting here, so the above will fail.
								;so, don't give any error msg.
								;NO!!! i just got the return flag wrong...
								jmp SHORT freeme
						  .ELSE
freeme: 				  .IF eax==0   ;0 if *succeeds*
								  .ELSE
												;GlobalFree() failed...
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
						invoke myalertbox,ADDR szer208,810h ;eax ;invoke myerrorhandler,208
								  .ENDIF
						  .ENDIF
				.ENDIF

		;if wmcreate() opened an eve datafile embedded in this exe,
		;hmodulefile will be non-zero...
		.IF hmodulefile != 0
		  invoke CloseHandle,hmodulefile
		  mov hmodulefile,0
		.ENDIF

		;idm_fliph/v,idm_resizesel create a shadow memory block, which should have been destroyed
		;immediately after use. in case not..
		.IF g_pshadowmem != 0
		  invoke GlobalHandle,g_pshadowmem
		  invoke GlobalFree,eax
		  mov g_pshadowmem,0
		.ENDIF

      ;v3.44
      ;wmcreate loaded bitmaps from resources, by LoadBitmap(). need to delete...
      lea esi,hbitmap474  ;table of handles.
      mov ecx,NELEMENTSBITMAPS ;10
nxtb1: mov edi,ecx
       mov eax,[esi]
			 invoke DeleteObject,eax
       add esi,4
       mov ecx,edi
       loop nxtb1
      ;will call SetMenuItemBitmaps() to load to menu.



		invoke PostQuitMessage,0
		ret
wmdestroy ENDP
;--------------------------------------------------------------------------

createnewobject PROC STDCALL USES esi edi ebx ecx edx, fatend:DWORD
				LOCAL pnewobject:DWORD
				LOCAL rpnewobject:DWORD
				mov pnewobject,0
;menu selection to create new node, via IDM_NODE, comes here...
;ditto for all other new elements (wires, etc).   "createnewobject"
;called from move1object().
;fatend=1 if new object must be created at end of database, =0 at closest
;empty record to beginning (if no empty record, defaults to creating a new one at end).
;...note, be careful with modifying this func, as move1object() relies on this behaviour.
;returns address of new element.

;!!!!BUG!!!!LOOK AT THIS CODE>>>> NOT ACTUALLY CHANGING STATE>>>>
				;can only create new object if in norm state...
;v2.02 so, delete it... 				 push eax						  ;save previous value of state.
;										 mov al,g_nstate		  ;/
;										 mov g_nstateprev,al  ;/
;										 pop eax						  ;/
				cmp g_nstate,0
				jne getout

				  mov edi,pTERSEDATA															  ;start of mem block.
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.

;if fatend=1 must create new object at end of database...
		  .IF fatend==1
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				mul ecx 				;eax=size of OBJECTS database.
				add esi,eax ;esi=address beyond end of database.
				jmp SHORT atend1
		  .ENDIF

;search objects database for invalid object...
   ;xor ecx,ecx
   mov ecx,(TERSEDATA PTR [edi]).numrecords
   .IF ecx==(DWORD PTR 0)												;hope this never happens.
   .ELSE
nod1:	test (OBJECT PTR [esi]).fstatus,01				 ;bit0=0 if invalid object.
				jz foundone 							;with esi ptg to found object.
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add  esi,eax
				loop nod1
   .ENDIF
				  ;no invalid objects, so increase mem block and create a new one...
		  ;we come here with esi->beyond end of TERSEDATA.

atend1:
;				 mov pnewobject,esi  ;save.
				 ;no, bug. we need to save a relative addr...
				 mov eax,esi			 ;don't change esi here, need it below.
				 sub eax,pTERSEDATA
				 mov rpnewobject,eax

				mov eax,pTERSEDATA
				sub esi,eax 	;gives total size of TERSEDATA.
				add esi,(SIZEOF OBJECT) ;make it bigger.
				mov g_ndatabasesize,esi   ;save it here.

;v3.55 duplicatehighlighted() now has a global flag, if g_fnoresize=1 then
;database has already been resized, so no need to do it here...
.IF g_fnoresize == 0				
        ;mov g_errorapi,0A9Bh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,g_ndatabasesize,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
								 ;all absolute pointers are invalid...
								 invoke zeroabsoluteptrs,0
						;*NO* these are not absolute pointers. and they're not in
						;the database (they are relative to start of an arrayof pointers)
						;duplicatehighlighted() calls duplicatedataelement() which
						;calls createnewobject() -- which erases highlightedindex
						;and highlightedindexnewlist, which crashes on return to
						;duplicatehighlighted. therefore, comment them out...
														  mov wipeoutsindex,0
														  mov updatesindex,0
														  ;mov highlightedindex,0
														  ;mov highlightedindexnewlist,0
						.IF eax==0
						  ;fail...
						  invoke myalertbox,ADDR szer209,811h ;eax ;invoke myerrorhandler,209
						  jmp getout ;err1				  ;error message and close file.
						.ELSE
						  mov pTERSEDATA,eax	;new pointer.
						.ENDIF
.ENDIF

				   ;now copy instantiatedOBJECT to the new object...
						mov edi,pTERSEDATA
						mov ebx,rpnewobject ;fix
						add ebx,edi 	;make absolute addr new object.
						mov pnewobject,ebx		;save it.
						lea esi,instantiatedOBJECT ;default to copy to memblock
						mov ecx,(SIZEOF OBJECT)
oo1:					mov al,[esi]
						mov [ebx],al	;append end of objects database.
												inc ebx
												inc esi
												dec ecx
												jnz oo1
				  ;update...
								inc (TERSEDATA PTR [edi]).numrecords
								jmp done				;new object created. pnewobject pts to it.

foundone:				mov pnewobject,esi
								;this is an existing empty object, but may
								;have stuff in it from earlier usage!!!...
						mov edi,pTERSEDATA
						mov ebx,pnewobject
						lea esi,instantiatedOBJECT ;default to copy to memblock
						mov ecx,(SIZEOF OBJECT)
oo3:					mov al,[esi]
						mov [ebx],al
												inc ebx
												inc esi
												dec ecx
												jnz oo3

done:

;defaultnew***() sets the fields for each type of object, but all of
;them need an element number...  (dataelements don't, but give it anyway for now).
				mov ebx,pTERSEDATA
;				lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
				  mov ecx,(TERSEDATA PTR [ebx]).noffsetobjs
				  add ecx,ebx ;pTERSEDATA ;starting address of OBJECTS.
				mov eax,pnewobject
				sub eax,ecx
				xor edx,edx
				xor ecx,ecx
				mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
				div ecx
				mov esi,pnewobject
				mov (OBJECT PTR [esi]).number,eax

;precaution...
				mov (OBJECT PTR [esi]).fstatus,01 ;bit0=1 valid object.

				mov eax,pnewobject				;return this.
				ret
getout:
				xor eax,eax 					;return 0, no new obj.
				ret
createnewobject ENDP
;--------------------------------------------------------------------------
defaultnewnode PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewnode"
; *EVE*
;menu selection to create new node, via IDM_NODE, via createnewobject().
;now have to customise new object with default settings for a node.
;entered with pnew ptg to new node in mem block.
				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,0				 ;it is a node.
				mov (OBJECT PTR [edi]).nexttype,0				;normal node.
				mov (OBJECT PTR [edi]).wwidth,40 ;32
				mov (OBJECT PTR [edi]).height,40 ;32
				mov (OBJECT PTR [edi]).fstatus,01				;now a valid node.

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (pnode-ptrs)

;concentric, totem, rings...
;*EVE* ignore OBJECT.fconfig3/bits2/3/4, TERSEDATA.fviewprefs/bits3/2...
				mov (OBJECT PTR [edi]).xdeltacentre,0	;default anyway.
				mov (OBJECT PTR [edi]).ydeltacentre,0	;/
				mov (OBJECT PTR [edi]).nringwidth,8 ;gap between each conc. ring.
				mov (OBJECT PTR [edi]).npenwidth,1

;v2.96 partial ellipse, via IDM_NODEP...
    .IF fvartype != 0
      mov (OBJECT PTR [edi]).fconfig1,100000b ;pie.
    .ENDIF
    ;for partial and full ellipses, setup the start/end handles...
    mov (OBJECT PTR [edi]).rxstartarc,30
    mov (OBJECT PTR [edi]).rystartarc,-10
    mov (OBJECT PTR [edi]).rxendarc,-10
    mov (OBJECT PTR [edi]).ryendarc,30

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewnode ENDP
;--------------------------------------------------------------------------
defaultnewgrid PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
;v1.28 "defaultnewgrid"
;menu selection to create new grid, via IDM_GRID, via createnewobject().
;now have to customise new object with default settings for a grid.
;entered with pnew ptg to new node in mem block.
				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,0				 ;it is not a wire.
				mov (OBJECT PTR [edi]).nexttype,20				 ;grid.
				mov (OBJECT PTR [edi]).wwidth,6 ;40 ;32
				mov (OBJECT PTR [edi]).height,6 ;40 ;32
				mov (OBJECT PTR [edi]).fstatus,01				;now a valid element.
;				  ;ah, but want bit5=1 so default is to display label...
;				  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (pgrid-ptrs)

;want pen 1-pixel this, all zoom factors...
				mov (OBJECT PTR [edi]).npenwidth,0

;give it a bit of color...
				mov (OBJECT PTR [edi]).nfillcolor,255 ;red.
				mov (OBJECT PTR [edi]).nfillstyle,1    ;solid


				mov (OBJECT PTR [edi]).nfontsize,12 ;size in points.
				;.nfonttype=0 is timesnewroman, .nfontstyle=0 is normal
				;.nfontcolor=0 is black.

;the default character set...
				mov ebx,pTERSEDATA
				mov eax,(TERSEDATA PTR [ebx]).charsetdefault
				mov (OBJECT PTR [edi]).ncharset,eax

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewgrid ENDP
;--------------------------------------------------------------------------
defaultnewaxes PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
;v1.28 "defaultnewaxes"
;menu selection to create new alignment axes, via IDM_STRETCHSEL, via createnewobject().
;entered with pnew ptg to new element in mem block.
				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,0				 ;it is not a wire.
				mov (OBJECT PTR [edi]).nexttype,21				 ;alignment axes.
				mov (OBJECT PTR [edi]).wwidth,6 ;40 ;32
				mov (OBJECT PTR [edi]).height,6 ;40 ;32
				mov (OBJECT PTR [edi]).fstatus,01				;now a valid element.

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (paxes-ptrs)

;want pen 1-pixel this, all zoom factors...
				mov (OBJECT PTR [edi]).npenwidth,0
				mov (OBJECT PTR [edi]).npencolor,0C0C0C0h  ;grey.

;give it a bit of color...
				mov (OBJECT PTR [edi]).nfillcolor,255 ;red.
				mov (OBJECT PTR [edi]).nfillstyle,1    ;solid



;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewaxes ENDP
;--------------------------------------------------------------------------
defaultnewcommand PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewcommand" *EVE* execution-icon.
;031000
;entered with pnew ptg to new node in mem block.

;121000 ... now has its own methods "pinfo" (based on node methods)...

				mov edi,pnew
				invoke defaultnewinfo,edi
				mov (OBJECT PTR [edi]).nexttype,60				;execution-icon.
				mov (OBJECT PTR [edi]).nfillcolor,0FFh ;bright red.

				ret
defaultnewcommand ENDP
;--------------------------------------------------------------------------
defaultnewwww PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewwww" WWW-icon.
;entered with pnew ptg to new node in mem block.

;has its own methods "pinfo" (based on node methods)...

				mov edi,pnew
				invoke defaultnewinfo,edi
				mov (OBJECT PTR [edi]).nexttype,65				;WWW-icon.
				mov (OBJECT PTR [edi]).nfillcolor,0FFFFh ;yellow.

				ret
defaultnewwww ENDP
;--------------------------------------------------------------------------
defaultnewinfo PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewinfo" *EVE*
;131000
;elements/text-fileicon --> idm_infoicon --> here

				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,0  ;bit0=it is a node.
				mov (OBJECT PTR [edi]).nexttype,61				;text-file-icon.
				mov (OBJECT PTR [edi]).wwidth,36 ;48 ;32
				mov (OBJECT PTR [edi]).height,36 ;48 ;32
				mov (OBJECT PTR [edi]).fstatus,01				;now a valid element.
;				  ;ah, but want bit5=1 so default is to display label...
;				  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (pinfo-ptrs)

;note, .number of object set in createnewobject().

;				   or	(OBJECT PTR [edi]).fconfig1,0100b ;turn on color-fill.
				  mov  (OBJECT PTR [edi]).nfillcolor,0FF00FFh	;purple-pink "fuschia"
						;... was =08080FFh ;B-G-R, pale-red.
				  mov (OBJECT PTR [edi]).nfillstyle,1 ;solid
				  mov (OBJECT PTR [edi]).npenwidth,1
				  mov (OBJECT PTR [edi]).nbeginring,1
				  mov (OBJECT PTR [edi]).nrings,1
				  mov (OBJECT PTR [edi]).nfontsize,12

;the default character set...
				mov ebx,pTERSEDATA
				mov eax,(TERSEDATA PTR [ebx]).charsetdefault
				mov (OBJECT PTR [edi]).ncharset,eax

				ret
defaultnewinfo ENDP
;------------------------------------------------------------------------
defaultnewgeneric PROC STDCALL USES ebx ecx edx esi edi,pnew:DWORD
		LOCAL dummy:DWORD
;new generic icon.
		mov edi,pnew
		invoke defaultnewinfo,edi
		mov (OBJECT PTR [edi]).nexttype,63
		mov  (OBJECT PTR [edi]).nfillcolor,00FF00h		 ;green

		ret
defaultnewgeneric ENDP
;------------------------------------------------------------------------
defaultnewsound PROC STDCALL USES ebx ecx edx esi edi,pnew:DWORD
		LOCAL dummy:DWORD
;new generic icon.
		mov edi,pnew
		invoke defaultnewinfo,edi
		mov (OBJECT PTR [edi]).nexttype,64
		mov  (OBJECT PTR [edi]).nfillcolor,0FFFF00h   ;aqua-blue.
;				 mov (OBJECT PTR [edi]).wwidth,44 ;36
;				 mov (OBJECT PTR [edi]).height,36

		ret
defaultnewsound ENDP
;------------------------------------------------------------------------
defaultneweve PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultneweve" *EVE*
;131000
;elements/EVE icon --> idm_eveicon --> here

				mov edi,pnew
				invoke defaultnewinfo,edi
				mov (OBJECT PTR [edi]).nexttype,62				;eve-icon.
				mov (OBJECT PTR [edi]).nfillcolor,08080FFh		 ;
						;... was =08080FFh ;B-G-R, pale-red.

				ret
defaultneweve ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
defaultnewres PROC STDCALL USES ebx ecx edx esi edi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewres"		*EVE*  -- now rectangle-element .nexttype=3
; rounded .nexttype=4
;menu selection to create new res, via IDM_RES, via createnewobject().
;now have to customise new object with default settings for a resource.
;entered with pnew ptg to new object in mem block.
;---also handle polygons. .nexttype=5

				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,0				 ;it is a node/res.
				xor eax,eax
				mov al,fvartype 		 ;see idm_res, etc.
				mov (OBJECT PTR [edi]).nexttype,eax
				  ;ah, but want bit5=1 so default is to display label...
				  ;v2.80 no these elements don't have displayable labels...
				  mov (OBJECT PTR [edi]).fstatus,01		 ;now valid element.
				  mov (OBJECT PTR [edi]).npenwidth,1
				  mov (OBJECT PTR [edi]).nbeginring,1
				  mov (OBJECT PTR [edi]).nrings,1

		  .IF fvartype==3		 ;rectangle.
p22:			mov (OBJECT PTR [edi]).wwidth,48 ;26
				mov (OBJECT PTR [edi]).height,24 ;14
				;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (pres-ptrs)
		  .ELSEIF fvartype==4  ;rounded rectangle.
				mov (OBJECT PTR [edi]).ncornerwidth,10	;only used by rounded
				mov (OBJECT PTR [edi]).ncornerheight,10 ; rectangle.
				jmp p22
		  .ELSEIF fvartype==5  ;polygon
		    or (OBJECT PTR [edi]).fconfig1,010b ;set bit1, selectable inside poly.
				mov (OBJECT PTR [edi]).ncorners,9
g11:			mov (OBJECT PTR [edi]).bez0x,30
				mov (OBJECT PTR [edi]).bez0y,30 ;10
				mov (OBJECT PTR [edi]).bez1x,50 ;40
				mov (OBJECT PTR [edi]).bez1y,40 ;15
				mov (OBJECT PTR [edi]).bez2x,60 ;45
				mov (OBJECT PTR [edi]).bez2y,60 ;25
				mov (OBJECT PTR [edi]).bez3x,55 ;40
				mov (OBJECT PTR [edi]).bez3y,75 ;35
				mov (OBJECT PTR [edi]).bez4x,40 ;30
				mov (OBJECT PTR [edi]).bez4y,88 ;40
				mov (OBJECT PTR [edi]).bez5x,20 ;20
				mov (OBJECT PTR [edi]).bez5y,88 ;35
				mov (OBJECT PTR [edi]).bez6x,5 ;15
				mov (OBJECT PTR [edi]).bez6y,75 ;25
				mov (OBJECT PTR [edi]).bez7x,0	;15
				mov (OBJECT PTR [edi]).bez7y,60 ;15
				mov (OBJECT PTR [edi]).bez8x,10 ;20
				mov (OBJECT PTR [edi]).bez8y,40 ;10
				  ;v1.11 have added 5 more vertices...
				  mov (OBJECT PTR [edi]).bez9x,10 ;20
				  mov (OBJECT PTR [edi]).bez9y,25 ;35 ;10
				  mov (OBJECT PTR [edi]).bez10x,10 ;20
				  mov (OBJECT PTR [edi]).bez10y,10 ;30 ;10
				  mov (OBJECT PTR [edi]).bez11x,10 ;20
				  mov (OBJECT PTR [edi]).bez11y,-5 ;15 ;10
				  mov (OBJECT PTR [edi]).bez12x,10 ;20
				  mov (OBJECT PTR [edi]).bez12y,-20 ;20 ;10
				  mov (OBJECT PTR [edi]).bez13x,10 ;20
				  mov (OBJECT PTR [edi]).bez13y,-35 ;15 ;10
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (ppoly-ptrs)
		  .ELSEIF fvartype==6 ;polyline, multi-segmented.
				mov (OBJECT PTR [edi]).nexttype,5 ;same as polygon.
				mov (OBJECT PTR [edi]).fconfig4,01 ;flag open-ended.
				mov (OBJECT PTR [edi]).ncorners,9
				jmp g11
		  .ELSEIF fvartype==7 ;polyline, bezier multi-segmented.
				mov (OBJECT PTR [edi]).nexttype,5 ;same as polygon.
				mov (OBJECT PTR [edi]).fconfig4,011b ;bit0=flag open-ended,bit1=bezier.
				;limitations on #vertices (4,7,10,13)...
				mov (OBJECT PTR [edi]).ncorners,10
				jmp g11
		  .ELSEIF fvartype==40 ;animation activator.
			  mov (OBJECT PTR [edi]).nfillcolor,0255 ;red 0FFFFFFh ;white.
act1:	  mov (OBJECT PTR [edi]).npencolor,0C0C0C0h  ;grey.
			  mov (OBJECT PTR [edi]).nfillstyle,1 ;solid
			  mov (OBJECT PTR [edi]).wwidth,12 ;8
			  mov (OBJECT PTR [edi]).height,12 ;8
			  mov eax,(OBJECT PTR [edi]).xtopleft
			  add eax,6 ;4
			  mov (OBJECT PTR [edi]).xmid,eax
			  mov eax,(OBJECT PTR [edi]).ytopleft
			  add eax,6 ;4
			  mov (OBJECT PTR [edi]).ymid,eax
			  mov (OBJECT PTR [edi]).rpmethods,OFFSET (pani-ptrs)
			.ELSEIF fvartype==41 ;link activator v2.76.
			  ;mov (OBJECT PTR [edi]).fstatus,01		 ;don't display text.
			  mov (OBJECT PTR [edi]).flinks,65 ;WWW link.
			  mov (OBJECT PTR [edi]).nfillcolor,0FFFFh ;yellow.
			  mov (OBJECT PTR [edi]).nfontsize,12 ;12 point text.
			  jmp act1
			.ELSEIF fvartype==42 ;inline SVG code. v3.25.
			  ;mov (OBJECT PTR [edi]).fstatus,01		 ;don't display text.
			  mov (OBJECT PTR [edi]).flinks,0 ;
			  mov (OBJECT PTR [edi]).nfillcolor,0 ;black fill.
			  mov (OBJECT PTR [edi]).nfontsize,12 ;12 point text.
			  jmp act1
		  .ELSE
				jmp p22
		  .ENDIF

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewres ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
defaultnewlabel PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewlabel"  *EVE*		label-element.
;menu selection to create new label, via IDM_label, via createnewobject().
;now have to customise new object with default settings for a label.
;entered with pnew ptg to new object in mem block.
;note, already created a data-element, with .rpdata pointing to it.

				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,100h ;bit0=0 it is a node/res type.
				;...v3.04 bit8=1 don't display handle if element locked.
				mov (OBJECT PTR [edi]).nexttype,33				;label object.
				mov (OBJECT PTR [edi]).wwidth,4
				mov (OBJECT PTR [edi]).height,4
				mov (OBJECT PTR [edi]).nbeginring,0 ;not yet owned by a node.
;				mov (OBJECT PTR [edi]).fstatus,01				;now a valid object.
				  ;ah, but want bit5=1 so default is to display label...
				  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (pact-ptrs)

;give it a bit of color...
				mov (OBJECT PTR [edi]).nfillcolor,0 ;black
				mov (OBJECT PTR [edi]).nfillstyle,1    ;solid


				mov (OBJECT PTR [edi]).nfontsize,12 ;size in points.
				;.nfonttype=0 is timesnewroman, .nfontstyle=0 is normal
				;.nfontcolor=0 is black.
				  mov (OBJECT PTR [edi]).npenwidth,1

;the default character set...
				mov ebx,pTERSEDATA
				mov eax,(TERSEDATA PTR [ebx]).charsetdefault
				mov (OBJECT PTR [edi]).ncharset,eax

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewlabel ENDP
;--------------------------------------------------------------------------
defaultnewwire PROC STDCALL USES ebx ecx edx edi esi, pnew:DWORD
		LOCAL dummy:DWORD
; "defaultnewwire" line,curved.
; *EVE*
;menu selection to create new execution-flow wire, via IDM_WIRE,
;via createnewobject().
;now have to customise new object with default settings for a
;execution-flow wire.
;entered with pnew ptg to new object in mem block.
;i've created a global variable "nnewwiretype" set by IDM_WIRE,
;IDM_SYNC2, IDM_VECTOR.

				mov edi,pnew
				mov (OBJECT PTR [edi]).fconfig1,101h ;bit0=1, it is a wire type.
				;...v3.04 bit8=1 don't display handle if element locked.

				xor eax,eax
				mov ax,nnewwiretype
				.IF ax==130 ;disabled-auto-stickiness, straight line. v2.27.
				  mov ax,13
				  or (OBJECT PTR [edi]).fconfig1,01000000b ;bit6.
				.ENDIF
				mov (OBJECT PTR [edi]).nexttype,eax

;start with a short wire...
				mov eax,(OBJECT PTR [edi]).xtopleft
				add eax,10
				mov (OBJECT PTR [edi]).xknee2,eax
				add eax,10
				mov (OBJECT PTR [edi]).xmid,eax
				add eax,10
				mov (OBJECT PTR [edi]).xknee3,eax
				add eax,10
				mov (OBJECT PTR [edi]).wwidth,eax		;wwidth is end-x for wires.
				mov eax,(OBJECT PTR [edi]).ytopleft
				sub eax,10
				mov (OBJECT PTR [edi]).yknee2,eax
				sub eax,10
				mov (OBJECT PTR [edi]).ymid,eax
				sub eax,10
				mov (OBJECT PTR [edi]).yknee3,eax
				sub eax,10
				mov (OBJECT PTR [edi]).height,eax

				mov (OBJECT PTR [edi]).fstatus,01				;now a valid object.
;				  ;ah, but want bit5=1 so default is to display label...
;				  mov (OBJECT PTR [edi]).fstatus,0100001b

;.rpmethods points relative to start of ptrs (methods table)...
				mov (OBJECT PTR [edi]).rpmethods,OFFSET (parc-ptrs)

;there will be a little circle in middle of wire -- fill with black...
				mov (OBJECT PTR [edi]).nfillstyle,1 ;solid fill.
				;(.nfillcolor=0 black already).
				mov (OBJECT PTR [edi]).npenwidth,1

;note, .number of object set in createnewobject().
;all other fields in OBJECT definition are ok.

				ret
defaultnewwire ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
wmrbuttonup PROC STDCALL
; "wmrbuttonup"

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

;v1.72
;a problem with page margins. if turned on, when scrolling, fdrawmargins=1 (only
;while scrolling) to cause xpaint_wipeout() to call drawprintmargins() to draw
;margins in white. when xkeyup() or wmlbuttonup(), scrolling will stop and
;fdrawmargins is clrd. except, a bug, it doesn't clr sometimes, and margins keep
;painting white when not scrolling. so...
		.IF fdrawmargins==1
		  mov fdrawmargins,0
		.ENDIF

out1:
	ret
wmrbuttonup ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
g_rpani DWORD 0
rpani0  DWORD 0
nmxold SDWORD 0
nmyold SDWORD 0
deltax SDWORD 0
deltay SDWORD 0
fdontmoveduplicates BYTE 0
g_fdontsnapwire BYTE 0 ;v3.35
  BYTE 0,0

.CODE
wmmousemove PROC STDCALL wmsg:DWORD,wparam:DWORD,lparam:DWORD
	LOCAL nratio:DWORD,fbuff:DWORD
	LOCAL xfixed:DWORD,yfixed:DWORD ;v3.42
	LOCAL fshift:BYTE,fnobut:BYTE,fmouseover:BYTE,fmouseoff:BYTE
	LOCAL fneedclick:BYTE
; "wmmousemove"	
;WM_MOUSEMOVE causes entry here.


  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. scrollingbymouse() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF
  
;if mousemove to boundary, can we scroll screen?...
    mov ebx,pTERSEDATA
    mov eax,(TERSEDATA PTR [ebx]).feveprefs
    and al,0100b					;bit2=1 disable scrolling by mouse.
    .IF al==0
		  invoke scrollingbymouse, wparam,lparam
    .ENDIF

		;v2.81 this test was in asmwndproc(), moved it in here...
		mov fnobut,0
		mov eax,(TERSEDATA PTR [ebx]).feveprefs
		and al,010000b ;bit4=1, disable mouse buttons, except dbl-clk.
		.IF al != 0
		  mov fnobut,1 ;see below.
		.ENDIF

;;v1.72
;;a problem with page margins. if turned on, when scrolling, fdrawmargins=1 (only
;;while scrolling) to cause xpaint_wipeout() to call drawprintmargins() to draw
;;margins in white. when xkeyup() or wmlbuttonup(), scrolling will stop and
;;fdrawmargins is clrd. except, a bug, it doesn't clr sometimes, and margins keep
;;painting white when not scrolling. so...
;	 .IF g_naccelx==0
;	   .IF g_naccely==0
;		 .IF fdrawmargins==1
;		   mov fdrawmargins,0
;		 .ENDIF
;	   .ENDIF
;	 .ENDIF

;lparam is client coords, origin is top/left of client area...
				invoke	origincorrection, lparam
								;returns corrected for origin-shift in g_nmousex & g_nmousey
				  ;i'll correct lparam as well, cos old goofee code expected it...
				  ;wmmousemove()>WM_USER>xuser() does.
				  mov eax,g_nmousex
				  mov WORD PTR lparam,ax
				  mov eax,g_nmousey
				  mov WORD PTR lparam+2,ax

				invoke	displaymouse, g_nmousex,g_nmousey ;display mouse coords.

        .IF fnobut != 0 ;v2.81
          .IF g_nstate==0
            ;this should allow just the animations.
          .ELSE
            jmp out1 ;get out
          .ENDIF
        .ENDIF

;save mouse coords, so can calc change each time...
				.IF nmxold==0
				  mov deltax,0
				.ELSE
				  mov eax,g_nmousex
				  sub eax,nmxold
				  mov deltax,eax
				.ENDIF
				mov eax,g_nmousex
				mov nmxold,eax
				.IF nmyold==0
				  mov deltay,0
				.ELSE
				  mov eax,g_nmousey
				  sub eax,nmyold
				  mov deltay,eax
				.ENDIF
				mov eax,g_nmousey
				mov nmyold,eax

        mov g_rpani,0 ;v3.09
				.IF g_nstate==0 				   ;normal state at startup & during operation.
				  ;if there are new duplicated elements, they will track the mouse
				  ;until lbuttonup...
				  .IF highlightedindexnewlist==0
						;if highlighted elements are being moved, fmovinghighlighted=1...
						.IF fmovinghighlighted==0
              ;v2.71
              ;nothing to update or move, check the "mouseover" for animation
              ;elements...
                ;v3.09
                ;animation event may also be a mouse-click, if .fconfig2/bits6,5,4=011.
                ;can detect here, set a hand-cursor if required ...why not write
                ;to a global variable "g_rpani", so wmlbuttondown() can detect it
                ;non-0 and immediately activate it.
              ;need to scan thru anilist, if an entry has animator.fconfig2/bits654=010
              ;then it is mouseover event. then check if animator-target under mouse.
              ;if so, clr animator.fconfig2/bit8, else set it...
              pushad
                mov fmouseover,0
                mov fmouseoff,0
                mov ebx,NUMANI
                shl ebx,1
                shl ebx,1
nadd2:        mov fneedclick,0 ;v3.09
                lea esi,anilist
                sub ebx,4
                mov edi,[ebx+esi] ;entries are relative ptrs.
                .IF edi != 0
                  add edi,pTERSEDATA
                  mov eax,(OBJECT PTR [edi]).fconfig2
                  and al,01110000b ;test bits 6/5/4.
                  .IF al==0100000b ;010=mouseover.
clk1:               ;test if target under mouse...
                    mov eax,(OBJECT PTR [edi]).rpowner1 ;owner.
                    .IF eax != 0
                      add eax,pTERSEDATA
                      mov esi,eax
                      push ebx
                      mov ebx,(OBJECT PTR [esi]).rpmethods
                      invoke onPTR PTR [ebx+ptrs+ponobject],esi,g_nmousex,g_nmousey
                      .IF eax != 0 ;yes. clr "wait event" flag for xtimer()...
                        .IF fneedclick==0
                          and (OBJECT PTR [edi]).fconfig2,0FFFFFEFFh ;clr bit8.
                          ;...bit8=0 actually *starts* the event.
                        .ELSE  ;not now, wait for left-button-down. v3.09
                          mov eax,edi ;edi->animation activator.
                          sub eax,pTERSEDATA
                          mov g_rpani,eax ;read by wmlbuttondown(), which starts event.
                          mov rpani0,eax ;v3.09
                        .ENDIF
                        test (OBJECT PTR [edi]).fconfig2,10000h ;bit16=1 finger cursor.
                        jz nof1 ;v2.82.
                        ;mov g_errorapi,0A9Ch ;for crash outside EVE, error codes range Axxh. v3.23
						            invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hfingercursor ;v2.82
		                    ;invoke SetCursor,g_hfingercursor ;to change immediately.
nof1:		                inc fmouseover
                      .ELSE

                          ;v3.09 for mouse-click event, may need to restore cursor here...
                          .IF fneedclick != 0
                            .IF rpani0 != 0 ;have already found animator, set handcursor.
                              test (OBJECT PTR [edi]).fconfig2,10000h ;bit16=1 finger cursor.
                              jz ooo1
                                mov ebx,rpani0  ;note, this persists between func calls.
                                add ebx,pTERSEDATA
                                .IF ebx==edi ;we are off the ani.activator with handcursor.
                                  mov rpani0,0
                                  inc fmouseoff ;code below will restore cursor.
                                  jmp ison1
                                .ENDIF
                            .ENDIF
                          .ENDIF
ooo1:                     ;...careful, need to continue to code below...

                        test (OBJECT PTR [edi]).fconfig2,10000h ;bit16=1 finger cursor.
                        jz isoff7 ;isoff1 ;v2.82. don't incr fmouseoff.
                        test (OBJECT PTR [edi]).fconfig2,0100h ;test bit8.
                        jnz isoff9 ;isoff1 ;=1 is already off.
                        inc fmouseoff ;record moving off a target.
                        jmp isoff8
isoff7:                 test (OBJECT PTR [edi]).fconfig2,0100h ;test bit8.
                        jnz isoff9 ;isoff1 ;=1 is already off.
isoff8:                 or (OBJECT PTR [edi]).fconfig2,20000h ;20080h ;set bit7 highlighted v2.87
                        ;...this will highlight the animator and it will keep
                        ;moving until reach "home" position, then xtimer() will
                        ;set bit8 and stop it. need this so when export to svg
                        ;will export in home position.  v2.87
                        ;...also set bit17, special flag used in xtimer().
                        ;...NO, set bit17 only, xtimer() modified.
                        ;jmp SHORT isoff9
;isoff1:                 or (OBJECT PTR [edi]).fconfig2,0100h ;set bit8.
isoff9:                 ;precaution...
                        test (OBJECT PTR [edi]).fconfig2,100h ;bit8 event.
                        jz ison1
			                  and (OBJECT PTR [edi]).fconfig2,0FFFDFFFEh
                        ;...clr bits17,0. 17=special flag, 0=special flag.
                        ;...xtimer() should have done this.
ison1:                  ;bypass
                      .ENDIF
                      pop ebx
                    .ENDIF
                  .ELSEIF al==40h ;bits6/5/4 =100 mouseon. v3.16.
                    ;note, preserve ebx.
                      ;find out if mouse is on target...
                      mov esi,(OBJECT PTR [edi]).rpowner1 ;owner.
                      .IF esi != 0
                        add esi,pTERSEDATA
                        push ebx
                        mov ebx,(OBJECT PTR [esi]).rpmethods
                        invoke onPTR PTR [ebx+ptrs+ponobject],esi,g_nmousex,g_nmousey
                        .IF eax==0 ;not on.
                          mov eax,(OBJECT PTR [edi]).fconfig2
                          and eax,100000h ;bit20.
                          .IF eax != 0 ;mouse was previously on the target element.
                            ;restore cursor...
                            test (OBJECT PTR [edi]).fconfig2,10000h ;bit16=1 finger cursor.
                            jz nnof1
                            ;mov g_errorapi,0A9Dh ;for crash outside EVE, error codes range Axxh. v3.23
						                invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
nnof1:		                  ;ok.
                          .ENDIF
                          and (OBJECT PTR [edi]).fconfig2,0FFEFFFFFh ;clr bit20,mouseoff.v3.16
                        .ELSE ;on.
                          mov eax,(OBJECT PTR [edi]).fconfig2
                          and eax,100000h ;bit20 mouseoff flag to allow mouseon retrigger.
                          .IF eax==0 ;prevent retriggering until a mouseoff.
                            ;trigger in same way as mouseover...
                            ;the code above for mouseout sets bit17, which causes xtimer()
                            ;to complete current action and stop. mouseclick sets bit17
                            ;in wmlbuttondown() so will stop after first animation.
                            ;need to do it here for mouseon...
                            ;will stop animation when returns to home...
                            or (OBJECT PTR [edi]).fconfig2,20000h ;set bit17, "mouse-out".
                            ;wmlbuttondown() also restores cursor immediately, but here
                            ;i think have to leave it until a mouseout.
                            ;there is another problem... need to prevent retriggering while
                            ;mouse is on target element. use a flag...
                            or (OBJECT PTR [edi]).fconfig2,100000h ;set bit20. clrd on mouseoff.
                            ;jmp clk1 no...
                            and (OBJECT PTR [edi]).fconfig2,0FFFFFEFFh ;clr bit8.
                            ;...bit8=0 actually *starts* the event.
                            test (OBJECT PTR [edi]).fconfig2,10000h ;bit16=1 finger cursor.
                            jz xnof1
                            ;mov g_errorapi,0A9Eh ;for crash outside EVE, error codes range Axxh. v3.23
						                invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hfingercursor
		                        ;invoke SetCursor,g_hfingercursor ;to change immediately.
xnof1:		                  inc fmouseover ;think need this?.
                          .ENDIF

                        .ENDIF
                        pop ebx
                      .ENDIF
                  .ELSEIF al==0110000b ;6,5,4 =011 mouse-click. v3.09
                    mov fneedclick,1
                    jmp clk1
                  .ENDIF
                .ENDIF
                or ebx,ebx ;cmp ebx,0
                jne nadd2
                .IF fmouseover==0 ;v2.82 mouse ain't on any animator-targets.
                  .IF fmouseoff != 0
                    ;mov g_errorapi,0A9Fh ;for crash outside EVE, error codes range Axxh. v3.23
						        invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
						      .ENDIF
                .ENDIF
              popad
              
						.ELSE
						  invoke updatemove
              ;mov g_errorapi,0AA0h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
						  mov  g_fredrawdiag,ENTIRE
						.ENDIF
				  .ELSE
					  .IF fdontmoveduplicates==0 ;eve2.asm selectedsaveassvg() sets this.
						  invoke updateduplicates
              ;mov g_errorapi,0AA1h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
						  mov  g_fredrawdiag,ENTIRE
					  .ENDIF
				  .ENDIF


				.ELSEIF g_nstate==1    ;a prior lbuttondn has selected an obj.
				  ;...can only come here from state-0.
				  ;g_pselectedobjnew=object selected
				  ;A selected object cannot be highlighted (g_pselectedobject,
				  ; state-2)as mouse moved.
						mov eax,g_pselectedobjnew
						mov g_pmovingobject,eax 		 ;required for state-8.
						mov g_pselectedobjnew,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,8

				.ELSEIF g_nstate==2  ;...this state, an obj is highlighted.
														  ;ignore.

				.ELSEIF g_nstate==4    ;a new object is being placed, first "end".
																;...can only come here from state-0.
				  ;new object must track the mouse...(first-end not yet placed)
				  
				    mov edi,g_pmovingobject
            ;v3.42... see note below for state8...
				    ;mov eax,g_nmousex		;mouse x-coord (world)
				    ;sub eax,g_xdiff
				    ;mov xfixed,eax			;corrected for initial lbuttondown difference.
				    ;mov eax,g_nmousey		;mouse y-coord.
				    ;sub eax,g_ydiff
				    ;mov yfixed,eax
            ;calc change to apply to object coords...
				    mov eax,(OBJECT PTR [edi]).xmid
				    sub eax,g_nmousex ;xfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_xchange,eax 		;x-change.
				    mov eax,(OBJECT PTR [edi]).ymid
				    sub eax,g_nmousey ;yfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_ychange,eax 		;y-change.

				  ;before moving the object, erase its current location...
						invoke add2wipeoutlist, g_pmovingobject
          ;mov g_errorapi,0AA2h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke PostMessage, g_hwnd,WM_USER+100h,wparam,lparam
													  ;come back to draw new position.
						;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
						;...done in add2wipeoutlist()
						mov  g_fredrawdiag,WIPEOUTobjs
            ;mov g_errorapi,0AA3h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
				  ;...will stay in this state until lbuttondn.

				.ELSEIF g_nstate==5    ;a new obj is being placed, second "end".
																;...can only come here from state-4.
				  ;lbuttondn on a node, while dragging a new wire, causes state-5.
				  ;the other-end of the wire has to track the mouse...
;ditto for any objects, if placed by lbuttondown on top of existing
;object, it becomes parent. now we are dragging it away from middle
;of parent...

				  .IF g_pmovingobject==0				  ;precaution.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,0							;precaution
				  .ELSE
						;before moving the object, erase its current location...
						invoke add2wipeoutlist, g_pmovingobject ;(attached wires
						mov edi,g_pmovingobject
						
            ;v3.42... see note below for state8...
				    mov eax,g_nmousex		;mouse x-coord (world)
				    sub eax,g_xdiff
				    mov xfixed,eax			;corrected for initial lbuttondown difference.
				    mov eax,g_nmousey		;mouse y-coord.
				    sub eax,g_ydiff
				    mov yfixed,eax
            ;calc change to apply to object coords...
				    mov eax,(OBJECT PTR [edi]).xmid
				    sub eax,xfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_xchange,eax 		;x-change.
				    mov eax,(OBJECT PTR [edi]).ymid
				    sub eax,yfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_ychange,eax 		;y-change.

						;v3.42
						;.IF g_naccelx != 0						;non-0 =scrolling is happening.
						;  jmp SHORT xacc1
						;.ELSE
						;  .IF g_naccely != 0
xacc1:			;		;scrolling() has already called updatewindow().
            ;    ;mov g_errorapi,0AA4h ;for crash outside EVE, error codes range Axxh. v3.23
						;		invoke PostMessage,g_hwnd,WM_USER+2+100h,wparam,lparam
						;						;NOTE lparam is now WORLD coords.(see above)
						;  .ELSE 		;no scrolling happening.
                ;mov g_errorapi,0AA5h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke PostMessage, g_hwnd,WM_USER+2+100h,wparam,lparam
								;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
								;...done in add2wipeoutlist()
								mov  g_fredrawdiag,WIPEOUTobjs
                ;mov g_errorapi,0AA6h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke UpdateWindow, g_hwnd 	 ;wipe immediately.
						;  .ENDIF
						;.ENDIF
				  .ENDIF


				.ELSEIF g_nstate==8 ;an object is being moved.(dragged)
          ;can be whole object moving or a handle dragged.
				  ;g_pmovingobject=object being moved.
				  .IF g_pmovingobject==0				  ;precaution.
						mov al,g_nstate 		 ;save previous value of state.
						mov g_nstateprev,al  ;/
						mov g_nstate,0							;precaution
				  .ELSE
						;before moving the object, erase its current location...
						mov edi,g_pmovingobject

            ;v3.42...
            ;moved this code out of drag_() methods.
            ;now, paint_() method scan use it at wipeout, before drag.
            ;(for purpose of calc'g two invalidated rectangles for wipeout).
            ;this correction stops object from "jumping" when it is first dragged...
				    mov eax,g_nmousex		;mouse x-coord (world)
				    sub eax,g_xdiff
				    mov xfixed,eax			;corrected for initial lbuttondown difference.
				    mov eax,g_nmousey		;mouse y-coord.
				    sub eax,g_ydiff
				    mov yfixed,eax
            ;calc change to apply to object coords...
				    mov eax,(OBJECT PTR [edi]).xmid
				    sub eax,xfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_xchange,eax 		;x-change.
				    mov eax,(OBJECT PTR [edi]).ymid
				    sub eax,yfixed
				    and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
				    mov g_ychange,eax 		;y-change.

						;v1.97 bug.
						;dragging stretching-handle on alignment axes, highlighted elements
						;aren't wiping...
						mov eax,(OBJECT PTR [edi]).nexttype
						.IF ax==21 ;alignment axes element.
						  invoke copyhi2wipe ;copy highlighted list to wipeout list.
						.ENDIF

						;v3.35. trying to fix stuff left behind when drag wire end...
						;yes, works! what we are doing here is paint now, paint_arc() wont
						;snap, then below paint again, with snap of wire end.
						mov eax,(OBJECT PTR [edi]).nexttype
						.IF ax==11 ;bezier wire.
						  jmp SHORT wn1
						.ELSEIF ax==12 ;segmented wire
						  jmp SHORT wn1
						.ELSEIF ax==13 ;straight wire.
wn1:					invoke add2wipeoutlist, g_pmovingobject
                ;i don't think we need to wipe the children here...
						    ;mov  ebx,(OBJECT PTR [edi]).rpmethods
						    ;invoke wipePTR PTR [ebx+ptrs+pwipeslaves], g_pmovingobject
								;... adds any slave-objects to wipeout-list.
								mov  g_fredrawdiag,WIPEOUTobjs
								xor eax,eax
								mov al,g_nknee
								push eax
								mov g_nknee,0  ;v1.0 *WOW* *BUG FIXED*
								mov g_fdontsnapwire,1 ;used in paint_arc(), won't snap end. v3.35
								invoke UpdateWindow, g_hwnd 	 ;wipe immediately.
								mov g_fdontsnapwire,0 ;v3.35
								pop eax
								mov g_nknee,al ;yes, it IS necessary to save and restore this!						
						.ENDIF

						invoke add2wipeoutlist, g_pmovingobject
						mov  ebx,(OBJECT PTR [edi]).rpmethods
						invoke wipePTR PTR [ebx+ptrs+pwipeslaves], g_pmovingobject
								;... adds any slave-objects to wipeout-list.
								
						;v3.35 when drag to window edge, there is a wipeout problem. the above
            ;call to scrollingbymouse() sets g_naccelx/y non0 which causes xtimer()
            ;to scroll the diag. let's try comment out, and always UpdateWindow() here...
            ;(yep, seems to work real good!)
						;.IF g_naccelx != 0						;non-0 =scrolling is happening.
						;  jmp SHORT acc1
						;.ELSE
						;  .IF g_naccely != 0
acc1:				;		;scrolling() has already called updatewindow().
            ;    ;mov g_errorapi,0AA7h ;for crash outside EVE, error codes range Axxh. v3.23
						;	  invoke PostMessage,g_hwnd,WM_USER+1+100h,wparam,lparam
						;	  ;NOTE lparam is now WORLD coords.(see above)
						;	  ;xuser1 adds g_pmovingobject+slaves to updatelist.
						;  .ELSE 		;no scrolling happening.
                ;mov g_errorapi,0AA8h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke PostMessage, g_hwnd,WM_USER+1+100h,wparam,lparam
								;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw bkgrnd.
								;...done in add2wipeoutlist()
								mov  g_fredrawdiag,WIPEOUTobjs
								xor eax,eax
								mov al,g_nknee
								push eax
								mov g_nknee,0  ;v1.0 *WOW* *BUG FIXED*
								;...was driving me crazy. when drag wire end, was getting ghost
								;white lines on screen. this fixed it. also have pushed current
								;value and restored it -- NECESSARY!
                ;mov g_errorapi,0AA9h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke UpdateWindow, g_hwnd 	 ;wipe immediately.
								pop eax
								mov g_nknee,al ;yes, it IS necessary to save and restore this!
						;  .ENDIF
						;.ENDIF
						
				  .ENDIF
stay1:	  ;...will stay in this state until lbuttonup.


; **NO** g_nstate=8 used for moving ends (with g_nknee=4 or 5)...


				.ELSEIF g_nstate==20
				  ;menu "control/selection rectangle"-->IDM_RECT-->state=20
				  ;do nothing (need lbuttondown to put it into state=21)

				.ELSEIF g_nstate==21 ;drawing 2nd corner selection-rectangle.
				  ;menu "control/selection rectangle" -->IDM_RECT-->state=20.
						;a problem n2ndx/n2ndy may be 0/0 and xpaint_entire/state22
						;will draw a incorrect rectangle on first pass. give initial
						;values...
						mov eax,g_nmousex
						mov n2ndx,eax
						mov eax,g_nmousey
						mov n2ndy,eax
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,22		;flag a mouse-move has occurred.
				  jmp SHORT yy9

				.ELSEIF g_nstate==22
yy9:	  ;paint wipeout immediately...
				  ;(there is code inside xpaint_wipeout() to detect state22
				  ; and draw the rectangle)
            ;mov g_errorapi,0AAAh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
            ;mov g_errorapi,0AABh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex
						mov eax,g_nmousex
						mov n2ndx,eax
						mov eax,g_nmousey
						mov n2ndy,eax
				  ;paint immediately...
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
				  mov  g_fredrawdiag,ENTIRE
						push g_nmousex
						push g_nmousey
				  invoke UpdateWindow, g_hwnd
						pop g_nmousey
						pop g_nmousex

				.ELSEIF g_nstate==30 ;wmlbuttondown() did this, dragging handle of resize rect.
				  ;n1stx,n1sty,n2ndx,n2ndy has coords of resize rect.
				  ;g_nknee=1 right handle, =2 bottom handle.
				  ;shift key down for keep-proportions...
				  mov fshift,0
          ;mov g_errorapi,0AACh ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke GetAsyncKeyState,VK_SHIFT
				  .IF SWORD PTR ax<0 ;bit15=1 if key down.
					mov fshift,1
				  .ENDIF
				  ;need x/y ratio of rectangle for proportional resizing...
				  mov eax,n2ndx0 ;orig.
				  sub eax,n1stx  ;width.
				    ;v2.29...
				    ;precaution, in case get zero width...
				    .IF eax==0
				      inc n2ndx0 ;give it width of 1.
				      inc eax    ;/
				    .ELSEIF SDWORD PTR eax<0
				      mov eax,n1stx
				      inc eax
				      mov n2ndx0,eax
				      mov eax,1  
				    .ENDIF
				  mov fbuff,eax
				  mov ebx,n2ndy0
				  sub ebx,n1sty  ;height.
				    ;v2.29...
				    ;precaution, in case get zero height...
				    .IF ebx==0
				      inc n2ndy0 ;give it height of 1.
				      inc ebx    ;/
				    .ELSEIF SDWORD PTR ebx<0
				      mov ebx,n1sty
				      inc ebx
				      mov n2ndy0,ebx
				      mov ebx,1
				    .ENDIF
				  fild fbuff
				  mov fbuff,ebx
				  fidiv fbuff
				  fstp nratio ;as f/p number.
				  .IF g_nknee==1
						;wipe immediately. there is code inside xpaint_wipeout() to detect tersedata.fviewprefs
						;bit5=1 (flag to display resize rect)...
						  ;v1.95
						  ;elements are leaving stuff on screen...need to wipe them...
						  ;need to copy contents of highlightedlist to wipeoutlist...
						  invoke copyhi2wipe
  ;mov g_errorapi,0AADh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
  ;mov g_errorapi,0AAEh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex
						mov eax,g_nmousex
						mov n2ndx,eax
						  ;calc change...
						  mov eax,n2ndx0 ;*original* right side of resize rect.
						  sub eax,g_nmousex ;xchange.
						  .IF fshift==0
							xor ebx,ebx 	  ;ychange=0.
						  .ELSE
							push eax
							mov fbuff,eax
							fild fbuff
							fdiv nratio ;nratio is f/p.
							fistp fbuff  ;ychange.
							mov ebx,fbuff ;ychange.
							mov eax,n2ndy0
							sub eax,ebx
							mov n2ndy,eax	  ;new bottom handle position.
							pop eax
						  .ENDIF
yyb:				  ;resize the highlighted elements...
					  invoke resizehighlighted,eax,ebx ;xchange,ychange.
					;paint immediately...
					invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
					mov  g_fredrawdiag,ENTIRE
					push g_nmousex
					push g_nmousey
					mov al,g_nknee
					push eax
					mov g_nknee,0
  ;mov g_errorapi,0AAFh ;for crash outside EVE, error codes range Axxh. v3.23
					invoke UpdateWindow, g_hwnd
					pop eax
					mov g_nknee,al
					pop g_nmousey
					pop g_nmousex
				  .ELSE ;g_nknee=2
						  ;v1.95
						  ;elements are leaving stuff on screen...need to wipe them...
						  ;need to copy contents of highlightedlist to wipeoutlist...
						  invoke copyhi2wipe
						invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
  ;mov g_errorapi,0AB0h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex
						mov eax,g_nmousey
						mov n2ndy,eax
					;calc change...
					mov ebx,n2ndy0 ;*original* coord.
					sub ebx,g_nmousey ;ychange.
					.IF fshift==0
					  xor eax,eax		;xchange=0.
					.ELSE
					  ;mov eax,ebx		 ;xchange=ychange.
							push ebx
							mov fbuff,ebx
							fild fbuff
							fmul nratio ;nratio is f/p.
							fistp fbuff  ;xchange.
							mov eax,fbuff ;xchange.
							mov ebx,n2ndx0
							sub ebx,eax
							mov n2ndx,ebx	  ;new bottom handle position.
							pop ebx
					.ENDIF
					jmp yyb
				  .ENDIF

				.ELSE
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				  mov g_nstate,0						;error, default back to state 0.
				.ENDIF

out1:
				ret
wmmousemove ENDP
;--------------------------------------------------------------------------
newmousetrack PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL xcoord:SDWORD,ycoord:SDWORD
; "newmousetrack"
;called by "new object" --> state=4 -->WM_MOUSEMOVE --> wmmousemove()
; --> WM_USER+100h --> xuser().
;display object at mouse coords.
;note that when coords origin shifted from window top corner or zoom not 0,
;taken care of by wmmousemove() --> origincorrection().

		  mov edi,pobj
				  ;v1.40
				  mov ax,WORD PTR lparam		   ;mouse x-coord
				  cwde
				  and al,fdragmask ;snap to even coords.(see prefsproc())
				  mov xcoord,eax
				  mov ax,WORD PTR lparam+2		  ;y-coord
				  cwde
				  and al,fdragmask ;snap to even coords.
				  mov ycoord,eax

		  mov eax,(OBJECT PTR [edi]).nexttype
		  .IF ax==5 ;polygon
				mov g_xdiff,0
				mov g_ydiff,0
				invoke drag_poly,edi
		  .ELSE
				  ;mov ax,WORD PTR lparam			;mouse x-coord
				  ; 	 cwde
				  mov eax,xcoord
				  mov (OBJECT PTR [edi]).xtopleft,eax
				  ;mov ax,WORD PTR lparam+2 	   ;y-coord
				  ; 	 cwde
				  mov eax,ycoord
				  mov (OBJECT PTR [edi]).ytopleft,eax

				mov eax,(OBJECT PTR [edi]).fconfig1
				and al,01												;extract bit0.
				.IF al==01												;bit0=1 wire.
				  ;mov ax,WORD PTR lparam						  ;just draw a short wire.
				  ; 	 cwde
				  mov eax,xcoord
						add eax,10												   ;/
						mov (OBJECT PTR [edi]).xmid,eax
						add eax,10
				  mov (OBJECT PTR [edi]).wwidth,eax ;/
				  ;mov ax,WORD PTR lparam+2 					  ;/
				  ; 	 cwde
				  mov eax,ycoord
						add eax,10												   ;/
						mov (OBJECT PTR [edi]).ymid,eax
						add eax,10
						mov (OBJECT PTR [edi]).height,eax		;/
				.ELSE
						;object is a node (any type), so xmid/ymid should also track....
						xor eax,eax
						mov  eax,(OBJECT PTR [edi]).wwidth
						sar  eax,1														;xradius.
						mov  ebx,(OBJECT PTR [edi]).xtopleft
						add  eax,ebx
						mov  (OBJECT PTR [edi]).xmid,eax						;centre of node
						mov  eax,(OBJECT PTR [edi]).height
						sar  eax,1														;yradius.
						mov  ebx,(OBJECT PTR [edi]).ytopleft
						add  eax,ebx
						mov  (OBJECT PTR [edi]).ymid,eax						;centre of node.
				.ENDIF
		  .ENDIF

				ret
newmousetrack ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
updatesindex0 DWORD 0
g_nmousex0 DWORD 0
g_nmousey0 DWORD 0
pobj00 DWORD 0
fptrsinvalid_nearobjects BYTE 1 ;set by zeroabsoluteptrs().
  BYTE 0,0,0
  
.CODE
nearobjects PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
				LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD,ebxsave:DWORD
; "nearobjects"
;we can quickly scan database; any object near mouse will get added
;to updatelist...		 uses g_nmousex/g_nmousey....
;NOTE that pobj itself gets added to the update list.

;v2.74 try to speedup...
    mov ebx,pobj
    .IF ebx==pobj00 ;previous value.
      mov eax,g_nmousex
      sub eax,g_nmousex0
      .IF SDWORD PTR eax<0
        neg eax
      .ENDIF
      .IF eax<100
        mov eax,g_nmousey
        sub eax,g_nmousey0
        .IF SDWORD PTR eax<0
          neg eax
        .ENDIF
        .IF eax<50
          ;need to be very careful that pointers still valid...
          .IF fptrsinvalid_nearobjects==0
            .IF fprinting==0
              .IF fsaving==0
                ;restore updatesindex...
                mov eax,updatesindex0 ;see end this func.
                mov updatesindex,eax ;note, painting will have cleared updatesindex.
                jmp out9
              .ENDIF
            .ENDIF
          .ENDIF
        .ENDIF
      .ENDIF
    .ENDIF
    mov eax,pobj
    mov pobj00,eax
    mov eax,g_nmousex
    mov g_nmousex0,eax
    mov eax,g_nmousey
    mov g_nmousey0,eax
    mov fptrsinvalid_nearobjects,0
    ;...zeroabsoluteptrs() will set this if ptrs become invalid, affects next entry.


;this code basically same as inside xpaint_entire()...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF SWORD PTR ax<0 ;ax==-1
						.ELSE							;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).
							;v1.41 note xmid/ymid not necessarily used in polygon,
							;but all vertices of polygon track mouse, so should be
							;ok to test it...
						  ;v1.44 no,i'm phasing out testing of xmid/ymid wherever possible...
						  ;mov eax,(OBJECT PTR [esi]).xmid
						  ;sub eax,g_nmousex
						  ;.IF SDWORD PTR eax<0
						  ; 	 neg eax
						  ;.ENDIF
						  ;.IF eax<350 ;v1.41 100
						  ; 	 mov eax,(OBJECT PTR [esi]).ymid
						  ; 	 sub eax,g_nmousey
						  ; 	 .IF SDWORD PTR eax<0
						  ; 	   neg eax
						  ; 	 .ENDIF
						  ; 	 .IF eax<100 ;v1.41 100
						  ; 	   invoke add2updatelist,esi
						  ; 	   jmp kf1
						  ; 	 .ENDIF
						  ;.ENDIF
						  mov eax,(OBJECT PTR [esi]).fconfig1
						  and al,01
						  .IF al==01	;wire-type
								mov eax,(OBJECT PTR [esi]).xtopleft
								sub eax,g_nmousex
								.IF SDWORD PTR eax<0
								  neg eax
								.ENDIF
								.IF eax<100 ;40
								  mov eax,(OBJECT PTR [esi]).ytopleft
								  sub eax,g_nmousey
								  .IF SDWORD PTR eax<0
										neg eax
								  .ENDIF
								  .IF eax<100 ;40
										invoke add2updatelist,esi
										jmp kf1
								  .ENDIF
								.ENDIF
								mov eax,(OBJECT PTR [esi]).wwidth
								sub eax,g_nmousex
								.IF SDWORD PTR eax<0
								  neg eax
								.ENDIF
								.IF eax<100 ;40
								  mov eax,(OBJECT PTR [esi]).height
								  sub eax,g_nmousey
								  .IF SDWORD PTR eax<0
										neg eax
								  .ENDIF
								  .IF eax<100 ;40
										invoke add2updatelist,esi
										jmp kf1
								  .ENDIF
								.ENDIF
						  .ELSE
						    mov eax,(OBJECT PTR [esi]).nexttype
						    .IF eax==20 ;page grid. v3.42
						      ;this has a large grid, that we need to redraw if over...
						      mov eax,(OBJECT PTR [esi]).xtopleft
						      sub eax,50
						      .IF SDWORD PTR g_nmousex>=eax
						        mov ebx,(OBJECT PTR [esi]).pagewidth
						        add ebx,eax
						        add ebx,100
						        .IF SDWORD PTR g_nmousex<ebx
						          mov eax,(OBJECT PTR [esi]).ytopleft
						          sub eax,50
						          .IF SDWORD PTR g_nmousey>=eax
						            mov ebx,(OBJECT PTR [esi]).pageheight
						            add ebx,eax
						            add ebx,100
						            .IF SDWORD PTR g_nmousey<ebx
						              jmp in6 ;yes!
						            .ENDIF
						          .ENDIF
						        .ENDIF
						      .ENDIF
						    .ELSE
							    ;v1.41
								  mov eax,(OBJECT PTR [esi]).xtopleft
								  sub eax,g_nmousex
								  .IF SDWORD PTR eax<0
								    neg eax
								  .ENDIF
								  .IF eax<500 ;400 ;v1.44 300
								    mov eax,(OBJECT PTR [esi]).ytopleft
								    sub eax,g_nmousey
								    .IF SDWORD PTR eax<0
										  neg eax
								    .ENDIF
								    .IF eax<300 ;200 ;100
in6:								  invoke add2updatelist,esi
										  jmp kf1
								    .ENDIF
								  .ENDIF
								.ENDIF
						  .ENDIF
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4:
    mov eax,updatesindex  ;v2.74
    mov updatesindex0,eax ;/
out9:
				ret
nearobjects ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
g_rponelement DWORD 0

.CODE
xuser PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
; "xuser"
;called via state=4 --> WM_MOUSEMOVE --> wmmousemove() --> WM_USER+100h msg.
;update position, and redraw, new moving object.
;when WM_PAINT is next generated, wmpaint() --> xpaint_update()
;(which paints to screen/printer from updatelist)

;we can quickly scan database; any object near mouse will get added
;to updatelist...
				invoke	nearobjects ,g_pmovingobject
				;...if g_nmousex/g_nmousey near object.

 invoke  newmousetrack, g_pmovingobject,wparam,lparam ;object must follow mouse.

;v2.24
;i would like to display handles if new element over a poly...
				  xor eax,eax	  ;precaution.
				  mov al,g_nknee
				  push eax
				   push g_nring    ;need to save, cos newmousetrack clrs them. v3.21
				   push g_xdiff    ; / must be 0, else poly will jump when lbdown->mmove.
				   push g_ydiff    ; /
				  invoke onanobject, g_nmousex,g_nmousey
				   pop g_ydiff
				   pop g_xdiff
				   pop g_nring
				  pop ecx
				  mov g_nknee,cl
				  ;...return with eax=0 fail, else eax pts to found object.
				  .IF eax != 0
					  push eax
					  invoke add2updatelist,eax
					  pop eax
					  mov ebx,eax
					  mov ecx,(OBJECT PTR [ebx]).nexttype
					  .IF ecx==5 ;i want to restrict this to polys only.
					    sub eax,pTERSEDATA
					  .ELSE
					    xor eax,eax
					  .ENDIF
				  .ENDIF
				  mov g_rponelement,eax
				  ;...paint_node() can use this to show poly handles (and clrs it immediately,
				  ;and adds poly to wipepoutlist).

				  invoke add2updatelist, g_pmovingobject
          ;mov g_errorapi,0AB1h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;TRUE	 ;*N0*updatewindow
				  mov  g_fredrawdiag,UPDATEobjs

				ret
xuser ENDP
;--------------------------------------------------------------------------
.DATA
fdragmask BYTE 0FFh
  BYTE 0,0,0

.CODE
xuser1 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;called via wmmousemove()/state8   "xuser1"
;note that lparam is WORLD coords.
;this routine adds g_pmovingobject and any slave objects (locked to it)
;are also added to update list.

		mov edi,g_pmovingobject

;		 .IF edi==pTERSEDATA
;		   invoke myerrorhandler,edi
;		 .ENDIF

;we can quickly scan database; any object near mouse will get added
;to updatelist...
				invoke	nearobjects,edi ; g_pmovingobject

;;*NO* can't have this, there's a conflict.... ***CONFLICT***
;;(i have got it ok for placing new wires, see xuser() and xuser2())...
;v2.24
;i would like to display handles if new element over a poly...
				  xor eax,eax
				  mov al,g_nknee
				  push eax
				  push g_nring
				  push g_xdiff
				  push g_ydiff
				  invoke onanobject, g_nmousex,g_nmousey
				  pop g_ydiff
				  pop g_xdiff
				  pop g_nring
				  pop ecx
				  mov g_nknee,cl
				  ;...return with eax=0 fail, else eax pts to found object.
				  .IF eax != 0
					push eax
					invoke add2updatelist,eax
					pop eax
					mov ebx,eax
					mov ecx,(OBJECT PTR [ebx]).nexttype
					.IF ecx==5 ;i want to restrict this to polys only.
					  mov ecx,(OBJECT PTR [edi]).fconfig1 ;also moving obj wire only.
					  and cl,01 ;bit0.
					  .IF cl==01
						sub eax,pTERSEDATA
					  .ELSE
						xor eax,eax
					  .ENDIF
					.ELSE
					  xor eax,eax
					.ENDIF
				  .ENDIF
				  mov g_rponelement,eax
				  ;...paint_node() can use this to show poly handles (and clrs it immediately,
				  ;and adds poly to wipepoutlist).

		;mov edi,g_pmovingobject
		mov  ebx,(OBJECT PTR [edi]).rpmethods
		invoke dragPTR PTR [ebx+ptrs+pdrag],edi ; g_pmovingobject
		;...pdrag takes care of adding any slave-objects to updatelist.
		;...it also updates the coordinates of movingobject & slaves.
;		 invoke add2updatelist,edi ; g_pmovingobject ;add last so gets painted last.
;		 ;...umm, nearobjects() will have already added it, in correct order, but leave
;		 ; this in a precaution.
    ;mov g_errorapi,0AB2h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,UPDATEobjs

;v1.99
;have a problem with selected elements wiping ok but not repainting, when dragging a
;handle of an alignment-axes-element...
	mov eax,(OBJECT PTR [edi]).nexttype
	.IF ax==21 ;alignment-axes.
	  ;do an immediate paint...
		invoke copyhi2update
		;...stretchhighlighted() puts highlighted elements into update list when
		;dragging the side or bottom handle. however, it isn't happening when drag
		;alignment-axes at the crossover-handle, so call copyhi2update().
		invoke add2updatelist,edi ; g_pmovingobject ;add last so gets painted last.
		;...umm, nearobjects() will have already added it, in correct order, but leave
		; this in a precaution. ...may need this here, as i don't know if alignment-axes
		;is getting put onto update list elsewhere.
	  push g_nmousex
	  push g_nmousey
	  ;NOTE, must leave g_nstate and g_nknee as-is...
;	   mov al,g_nstate
;	   push eax
;	   mov bl,g_nknee
;	   push ebx
;	   mov g_nknee,0
;	   mov g_nstate,0
    ;mov g_errorapi,0AB3h ;for crash outside EVE, error codes range Axxh. v3.23
	  invoke UpdateWindow,g_hwnd
;	   pop ebx
;	   mov g_nknee,bl
;	   pop eax
;	   mov g_nstate,al
	  pop g_nmousey
	  pop g_nmousex
	.ELSE
		invoke add2updatelist,edi ; g_pmovingobject ;add last so gets painted last.
		;...umm, nearobjects() will have already added it, in correct order, but leave
		; this in a precaution.
	.ENDIF

out1:
  ret
xuser1 ENDP
;--------------------------------------------------------------------------
xuser2 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD

; "xuser2" *EVE*
;from wmmousemove()/state5 (2nd end being placed) > WM_USER+2
;
;we can quickly scan database; any object near mouse will get added
;to updatelist...
				invoke	nearobjects, g_pmovingobject

;v2.24
;i would like to display handles if new element over a poly...
				  xor eax,eax  ;precaution.
				  mov al,g_nknee
				  push eax
				    push g_nring ;when placing new poly, g_x/ydiff is wrong, causing jump. v3.21
				    push g_xdiff ; / try this save.
				    push g_ydiff ; /
				  invoke onanobject, g_nmousex,g_nmousey
				    pop g_ydiff
				    pop g_xdiff
				    pop g_nring
				  pop ecx
				  mov g_nknee,cl
				  ;...return with eax=0 fail, else eax pts to found object.
				  .IF eax != 0
					push eax
					invoke add2updatelist,eax
					pop eax
					mov ebx,eax
					mov ecx,(OBJECT PTR [ebx]).nexttype
					.IF ecx==5 ;i want to restrict this to polys only.
					  sub eax,pTERSEDATA
					.ELSE
					  xor eax,eax
					.ENDIF
				  .ENDIF
				  mov g_rponelement,eax
				  ;...paint_node() can use this to show poly handles (and clrs it immediately,
				  ;and adds poly to wipepoutlist).

		mov edi,g_pmovingobject
		mov  ebx,(OBJECT PTR [edi]).rpmethods
		invoke dragPTR PTR [ebx+ptrs+pdrag], g_pmovingobject
		;...pdrag takes care of adding any slave-objects to updatelist.
		;(although this is a new object and hasn't got any)
		;...it also updates the coordinates of movingobject & slaves.
		invoke add2updatelist, g_pmovingobject
  ;mov g_errorapi,0AB4h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,UPDATEobjs


  ret
xuser2 ENDP
;--------------------------------------------------------------------------
xuser4 PROC STDCALL, wmsg:DWORD,wparam:DWORD,lparam:DWORD
;comes here indirectly via xpaint_print...
						  invoke InvalidateRgn, g_hwnd,0,FALSE
						  mov g_fredrawdiag,ENTIRE
				ret
xuser4 ENDP
;--------------------------------------------------------------------------

.DATA
;used by add2wipeoutlist() ...
ALIGN 4 ;v3.24
numwipeouts   EQU 256 ;v2.74 96
wipeouts		  DWORD numwipeouts DUP (0) ;list of objects requiring erasing.
								  ;(contains pointers to the objects)
wipeoutsindex DWORD 0					   ;index of next free entry.

.CODE
add2wipeoutlist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
		LOCAL dummy:BYTE
; "add2wipeoutlist"
;adds the object, pobj, to the wipeout-list, for future screen repainting.
;difference from add2updatelist, is these objects are to be redraw
;same colour as background....

;see note in add2updatelist()...
		mov eax,pobj
		.IF eax==0
		  jmp SHORT out1 ;ret
		.ELSEIF eax==pTERSEDATA ;v1.87 precaution, this is invalid ptr.
		  jmp SHORT out1
		.ENDIF

		   ;uses pobj in eax...
		   mov ebx,wipeoutsindex   ;index to next free entry.
		   .IF DWORD PTR ebx<numwipeouts		  ;max size of wipeout-list buffer.
				 shl ebx,1								;convert to relative offset.
				 shl ebx,1						;/ (4 bytes per entry)
				 lea esi,wipeouts				 ;/
				 or ebx,ebx ;cmp ebx,0								;empty list.
				 je  wipe3						   ;/
wipe2:							dec ebx
								dec ebx
								dec ebx
								dec ebx
				 mov edx,[ebx+esi]	   ;find out if it is already in list.
				 cmp edx,eax
				 je  wipe												;jmp if it is.
				   or ebx,ebx ;cmp ebx,0
				   jne wipe2
				 mov ebx,wipeoutsindex	  ;reload bx.
				 shl ebx,1								 ;/ 4 bytes
				 shl ebx,1								 ;/
wipe3:
				 mov [ebx+esi],eax				  ;add object to list
				 inc wipeoutsindex				;update index
wipe:
		   .ENDIF
  ;mov g_errorapi,0AB5h ;for crash outside EVE, error codes range Axxh. v3.23
		   invoke InvalidateRgn, g_hwnd,0,FALSE  ;don't wipe background.
		   nop

out1:	   ret
add2wipeoutlist ENDP
;--------------------------------------------------------------------------
.DATA
;used by add2updatelist() ...
ALIGN 4 ;v3.24
numupdates		 EQU	256		;v2.74 96
updates 		 DWORD numupdates DUP (0)  ;list of objects requiring screen
												;updating. contains pointers to the objects.
updatesindex DWORD 0	   ;index of next free entry in updates.

.CODE
add2updatelist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
		LOCAL dummy:BYTE
;WM_PAINT will cause objects in this list to be drawn.	"add2updatelist"
;adds the object, pobj, to the update-list, for future screen repainting.

;i had a problem that exited from snapclonewires2(), to snapclonewires(),
;to drag_arc(), with error eax=-1. drag_arc() exited back to xuser1()
;(which had been called from wmmousemove()/state8). situation was
;dragging a wire-end on master-clone of a clone-chain.
;anyway, comes back to xuer1() with g_pmovingobject=0, and then
;calls add2updatelist() with passed param of 0. so, screen this out...
		mov eax,pobj
		.IF eax==0
		  jmp SHORT out1 ;ret
		.ELSEIF eax==pTERSEDATA ;v1.87 precaution, this is invalid ptr.
		  jmp SHORT out1
		.ENDIF

		   ;eax used here...
		   mov ebx,updatesindex   ;index to next free entry.
		   .IF DWORD PTR ebx<numupdates 		 ;max size of update-list buffer.
				 shl ebx,1								;convert to relative offset.
				 shl ebx,1						;(based on 4 bytes per entry)
				 lea esi,updates				;/
				 or ebx,ebx ;cmp ebx,0								;empty list.
				 je  nadd3						   ;/
nadd2:					dec ebx 								;find out if it is already in list.
						dec ebx 									  ;/
						dec ebx 									  ;/
						dec ebx 										;/
						mov edx,[ebx+esi]	;/
						cmp edx,eax 					;/
						je		nadd									;/jmp if yes it is.
						or ebx,ebx ;cmp ebx,0					  ;/
						jne nadd2										;/
						;fall down here if it isn't already in list.
;add object to list...
						  mov ebx,updatesindex	  ;append it to end of list.
						  shl ebx,1 			  ;/
						  shl ebx,1 								 ;/
nadd3:			 mov [ebx+esi],eax				  ;/
				 inc updatesindex		   ;/
nadd:
		   .ENDIF

out1:	   ret
add2updatelist ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
NUMANI		 EQU 32 ;8 ;max number of animations allowed.
anilist 	 DWORD NUMANI DUP (0)  ;ptrs to animation elements.(can grow up if reqd)

.CODE
add2anilist PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
		LOCAL dummy:DWORD
;v1.59 "add2anilist"
;xtimer() uses this list to activate animations. defaultnewres() places new entry.
;NOTE: ptrs stored as relative (pTERSEDATA previously subtracted).
;NOTE2: also unlike earlier lists, this one is a fixed length.
;if pobj=0 wipe all entries.

;		 .IF pobj==0
;		   jmp out1 ;ret
;		 .ENDIF
		mov eax,pobj
		.IF eax==pTERSEDATA ;v1.87 precaution, this is invalid ptr.
		  jmp SHORT out1
		.ENDIF

		   ;eax used here...
				 sub eax,pTERSEDATA ;make relative!!!
				 mov ebx,NUMANI ;anilistindex	;index to next free entry.
				 shl ebx,1					 ;convert to relative offset.
				 shl ebx,1					 ;(based on 4 bytes per entry)
				 lea esi,anilist			 ;/
nadd2:			 dec ebx					 ;find out if it is already in list.
				 dec ebx					 ;/
				 dec ebx					 ;/
				 dec ebx					 ;/
				 mov edx,[ebx+esi]			 ;/
				 .IF pobj==0
				   ;want to erase all entries...
				   mov [ebx+esi],DWORD PTR 0
				 .ELSE
				   cmp edx,eax				   ;/
				   je  nadd 				   ;/jmp if yes it is.
				 .ENDIF
				 or ebx,ebx ;cmp ebx,0					 ;/
				 jne nadd2					 ;/
				 ;fall down here if it isn't already in list.
;add object to list...
			mov ebx,NUMANI
			shl ebx,1
			shl ebx,1
xnadd2: 	dec ebx
			dec ebx
			dec ebx
			dec ebx
			mov edx,[ebx+esi]
			or edx,edx ;cmp edx,0	;empty entry.
			je xnadd3
			or ebx,ebx ;cmp ebx,0
			jne xnadd2
			jmp SHORT nadd
xnadd3: 	mov eax,pobj
			.IF eax != 0
			  sub eax,pTERSEDATA ;make relative!!!
			  mov [ebx+esi],eax ;put it in.
			.ENDIF
nadd:

out1:
		   ret
add2anilist ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
xtest DWORD 0
ytest DWORD 0
;used by getprinterdetails() and xpaint()....
pregion 				DWORD 0
;g_fprintdiag	BYTE 0					  ;non-0 if want to print.
;  BYTE 0,0,0
;szwininiline	 BYTE 64 DUP(0) ;returns found line in win.ini
;szwininidef	 BYTE 64 DUP(0)

.CODE
;v3.01 moved from .DATA...
szwinspool BYTE "WINSPOOL",0
szprntitle DB "Print instructions",0
szprntext  DB "Press Cancel to abort printing now, OK to continue.",0Ah,0Dh
				   DB "After each page prints, press an CTRL-Arrow to select",0Ah,0Dh
				   DB "next page (up,down,left,right), and print again.",0
;szwininititle	 BYTE "windows",0
;szwininisub	 BYTE "device",0
szprname				BYTE "EVE diagram",0
;szname1 BYTE "HP LaserJet 6P",0
				
xpaint_print PROC STDCALL USES ebx ecx edx esi edi
				LOCAL hdcp:DWORD								;device context for printer.
				LOCAL printdocinfo:DOCINFO
				LOCAL prnleft:DWORD 			;viewport origin for printing.
				LOCAL prntop:DWORD								;/
				LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
				LOCAL hbrushold:DWORD, hbrushgreen:DWORD
;				LOCAL hpendefault:DWORD
				LOCAL hbrushnewcolor:DWORD,hbrusholdcolor:DWORD
				LOCAL hpencolor:DWORD
				LOCAL xexp:SDWORD,yexp:SDWORD
				LOCAL xwext:DWORD,ywext:DWORD,xratio:DWORD,yratio:DWORD
				LOCAL zoom:SBYTE								;zoom factor.
;				"xpaint_print"

				mov prnleft,0
				mov prntop,0
				mov hbrushold,0
				mov hbrushgreen,0
				mov hdcp,0
				mov zoom,0
				mov hbrushnewcolor,0
				mov hbrusholdcolor,0
				mov hpencolor,0

;keyboard instructions...
				invoke myalertbox,ADDR szprntext,6
        ;invoke MessageBox, g_hwnd,ADDR szprntext,ADDR szprntitle,MB_OKCANCEL
				.IF eax==IDCANCEL
				  ;mov  g_fprintdiag,0
				  ret
				.ENDIF
		    mov g_fprintingnow,TRUE  ;tested at entry to wmpaint(), non0; ret. v3.34
		    ;...moved from idm_pra, must be after above msgbox.

;v1.37
			invoke drawprintmargins,0 ;0=doesn't actaully draw margins, just calcs
			;margin coords g_mleft,g_mtop,g_mright,g_mbottom, used isobjectinpage().

;setup printdocinfo structure...
		mov printdocinfo.cbSize,SIZEOF DOCINFO ;20		;size of structure.
				;lea eax,szfile
				lea eax,szprname
				mov printdocinfo.lpszDocName,eax ;name of document.
				; note we could load addr of szfile for above paramter.
				mov printdocinfo.lpszOutput,0	;name of o/p file --use DC.
				mov printdocinfo.lpszDataType,0
				mov printdocinfo.fwType,0

;note, wmcreate() calls printeranalysis() which sets up myprintdlg fields.


;create a display-context for the printer...
		;mov ebx,SIZEOF PRINTDLGA
		;invoke ZeroMemory, ADDR myprintdlg,ebx
						mov myprintdlg.pr_lStructSize,SIZEOF PRINTDLGA
						mov myprintdlg.pr_hwndOwner,0
						mov myprintdlg.pr_hDevMode,0
						mov myprintdlg.pr_hDevNames,0
						mov myprintdlg.pr_hDC,0
						mov myprintdlg.pr_nFromPage,0
						mov myprintdlg.pr_nToPage,0
						mov myprintdlg.pr_nMinPage,0
						mov myprintdlg.pr_nMaxPage,0
						mov myprintdlg.pr_nCopies,0
						mov myprintdlg.pr_hInstance,0
						mov myprintdlg.pr_lCustData,0
						mov myprintdlg.pr_lpfnPrintHook,0
						mov myprintdlg.pr_lpfnSetupHook,0
						mov myprintdlg.pr_lpPrintTemplateName,0
						mov myprintdlg.pr_lpSetupTemplateName,0
						mov myprintdlg.pr_hPrintTemplate,0
						mov myprintdlg.pr_hSetupTemplate,0
						mov eax,g_hwnd
						mov myprintdlg.pr_hwndOwner,0 ;eax
		mov myprintdlg.pr_Flags,PD_RETURNDC+PD_RETURNDEFAULT
  ;mov g_errorapi,0AB6h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke PrintDlgA, ADDR myprintdlg
		.IF eax==0		;error.
				  mov eax,myprintdlg.pr_hDC
				  .IF eax==0
				  .ELSE
						invoke DeleteDC,eax
				  .ENDIF
				  ;free global memory objects...
				  mov eax,myprintdlg.pr_hDevMode
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
				  mov eax,myprintdlg.pr_hDevNames
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
		  ret
		.ENDIF
		mov ecx,myprintdlg.pr_hDC
		mov hdcp,ecx

;;create a display-context for the printer...
;				  invoke CreateDC, 0,ADDR szname1,0,0
;				   ;...1st param was "ADDR szdriver", now NULL for win95.
;				   ;...2nd=last param is "ADDR szport", which is normally LPT1:
;				   ;however win95 prefers NULL entry.
;				  mov  hdcp,eax

;make WinNT compatible...
		invoke GetGraphicsMode,hdcp
		.IF eax==GM_COMPATIBLE
		.ELSE
		  invoke SetGraphicsMode,hdcp,GM_COMPATIBLE
		.ENDIF



  invoke StartDoc, hdcp,ADDR printdocinfo  ;start a print job.
  invoke StartPage, hdcp				;prepares printer driver to accept data.

						;invoke GetMapMode, hdcp
						invoke SetMapMode, hdcp,MM_ANISOTROPIC
						;(needed for SetWindowExtEx() to work)
						.IF eax==0		;failed
						 pushad
						 invoke myalertbox,ADDR szer104,4 ;invoke myerrorhandler,104
						 popad
						.ENDIF
						invoke GetMapMode, hdcp
						.IF eax==MM_ANISOTROPIC
						.ELSE
						 pushad
						 invoke myalertbox,ADDR szer104,4 ;invoke myerrorhandler,104
						 popad
						.ENDIF


;let's also create a grey pen...
						  invoke CreatePen, PS_SOLID,0,0C0C0C0h 		;want 1-wide,grey.
						  mov g_hpengrey,eax
						  ;(no need for grey dashed line, as in wmpaint()).
;and a global font...
		  mov eax,12
		  neg eax
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,0,ADDR szarialbold
		  mov  g_hfontx1,eax			;11-point Arial Bold.

;colour for filling polygons....
		 invoke GetStockObject, NULL_BRUSH
				 mov hbrushgreen,eax
				invoke SelectObject, hdcp,hbrushgreen
				 mov hbrushold,eax
;colour for text....
				invoke SetBkMode, hdcp, TRANSPARENT   ;leave background showing.


;				  invoke SetWindowExtEx, hdcp,748,1088,0				;<<<<<<<TEST<<<<******
;				  .IF eax==0 ;fail
;						pushad
;										invoke myerrorhandler,104
;						popad
;				  .ENDIF
;		   invoke SetViewportExtEx, hdcp,g_nxprnpixsize,g_nyprnpixsize,0
;		   invoke SetViewportExtEx, hdcp,4676,6814,0			;<<<<<<<TEST<<<<<******
;		   .IF eax==0 ;fail
;				pushad
;								 invoke myerrorhandler,104
;				popad
;		   .ENDIF

;		 invoke ScaleViewportExtEx, hdcp,6,0,6,0,0


;copied from wmcreate()...
;find out resolution of the printer...
				invoke GetDeviceCaps, hdcp,LOGPIXELSX	;query pixels/inch.
				mov  xprintpixels,eax
				invoke GetDeviceCaps, hdcp,LOGPIXELSY	;query pixels/inch.
				mov  yprintpixels,eax
				invoke GetDeviceCaps, hdcp,HORZRES				;query width in pixels.
				mov  g_nxprnpixsize,eax
				invoke GetDeviceCaps, hdcp,VERTRES				;query height in pixels.
				mov  g_nyprnpixsize,eax
;caclulate the ratio...
				mov  eax,xprintpixels	;print width. unsigned.
;				 shl  eax,1 											 ;*4, so can be more accurate.
;				 shl  eax,1 											 ;/
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
				xor  edx,edx
				mov  ebx,xscreenpixels	;screen width, unsigned.
				div  ebx								;unsigned divide
;***NOTE*** g_nxratio & g_nyratio should always be +ve,
;but i've defined them as SDWORD.
				mov  g_nxratio,eax				;display>printer scaling, x.
				mov  eax,yprintpixels	;print paper height.
;				 shl  eax,1 											 ;*4, more accurate.
;				 shl  eax,1 											 ;/
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
				xor  edx,edx
				mov  ebx,yscreenpixels	;display height.
				div  ebx
				mov  g_nyratio,eax				;display>printer scaling, y.

;setup logical-->device scaling...
				  mov  eax,g_nxprnpixsize				;size of paper, found above.
				  mov  ebx,g_nyprnpixsize								;/
						  .IF g_nxratio>1				;should always be!(higher prtr res.)
								  xor  edx,edx													   ;prn/scrn ratio
;								   shl eax,1			 ;cos we modified xratio*4
;								   shl eax,1			 ; back in xcreate.
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
								  div  g_nxratio				;scale-up by prn/scrn ratio. ;/
								  push eax																		 ;/
										mov  eax,ebx																	 ;/
										xor  edx,edx																	 ;/
;										 shl  eax,1 					 ;ditto, correct yratio*4
;										 shl  eax,1 					 ;/
				mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				shl eax,cl		   ;/
								  div	g_nyratio												 ;/
								  mov  ebx,eax	 ;new .rc_right in eax					 ;/
								  pop  eax				;new .rc_bottom in ebx. 		   ;/
						  .ENDIF
				  ;***NOTE*** actually +ve values, but these vars are signed...
				  mov xwinext_exact,eax
				  sub eax,XMARGINADJ	;***NOTE*** this fixes edge of printout lost
												;IN FUTURE, configurable by user.
				  mov  xwinext,eax				;save. used by ctrl-arrow keys.
				  mov ywinext_exact,ebx
				  sub ebx,YMARGINADJ	;***ditto.
				  mov  ywinext,ebx				;/(+ve value always).

;v1.2
;.xfineprn/.yfineprn are 1/10% adjustments...
;compute xexp= g_nprnpixsize - ((xfineprn*g_nprnpixsize)/1000) ,ditto for yexp...
						mov esi,pTERSEDATA
						mov eax,g_nyprnpixsize
						mov ecx,(TERSEDATA PTR [esi]).yfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						  ;sar eax,1 ;v1.37 ummm, trying fix bug,printout too big.WORKS!
						neg eax ;cos subtracting.
						add eax,g_nyprnpixsize
						mov yexp,eax
						mov eax,g_nxprnpixsize
						mov ecx,(TERSEDATA PTR [esi]).xfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						  ;sar eax,1 ;v1.37 ummm, trying fix bug,printout too big.WORKS!
						neg eax
						add eax,g_nxprnpixsize
						mov xexp,eax

;setup logical-->device scaling...
				mov esi,pTERSEDATA
				mov eax,(TERSEDATA PTR [esi]).nzoom
				mov zoom,al
				  mov  eax,xexp ;g_nxprnpixsize ;v1.2	;size of paper, found by wmcreate.
				  mov  ebx,yexp ;g_nyprnpixsize ;v1.2	;/		(unsigned values) in dots.
						  .IF zoom>0
								  mov cl,zoom
								  sal	eax,cl
								  sal	ebx,cl
						  .ELSEIF zoom==0
						  .ELSE
								  mov cl,zoom
								  neg cl								;***NOTE*** is this right?
								  sar eax,cl
								  sar ebx,cl
						  .ENDIF
						  .IF g_nxratio>1		  ;*always* +ve!
								xor  edx,edx													 ;prn/scrn ratio
								mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
								shl eax,cl		   ;/
								div g_nxratio ;scale-up by prn/scrn ratio. ;/
								push eax																	   ;/
								mov  eax,ebx																	 ;/
								xor  edx,edx																	 ;/
								mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
								shl eax,cl		   ;/
								div g_nyratio						   ;/
								mov  ebx,eax			;new .right in eax						 ;/
								pop  eax			  ;new .bottom in ebx.			   ;/
						  .ENDIF
				  mov xwext,eax 	 ;v1.38
				  mov ywext,ebx 	 ;/
				  invoke SetWindowExtEx, hdcp,eax,ebx,0

				  xor edx,edx				 ;v1.38 req'd for correct viewport org.
				  mov ecx,RATIOSCALE		 ;/
				  mov eax,g_nxprnpixsize	 ;/
				  shl eax,cl				 ;/
				  div xwext 				 ;/
				  mov xratio,eax			 ;/
				  xor edx,edx				 ;/
				  mov eax,g_nyprnpixsize	 ;/
				  shl eax,cl				 ;/
				  div ywext 				 ;/
				  mov yratio,eax			 ;/

;v1.2 seems finetune adj has to be to the window extent (above)...
		  invoke SetViewportExtEx, hdcp,g_nxprnpixsize,g_nyprnpixsize,0


		  .IF eax==0 ;fail
				;pushad
				 invoke myalertbox,ADDR szer104,4 ;invoke myerrorhandler,104
				;popad
		  .ENDIF

;*NOTE* this has to be after StartPage() to work...
;origin for printer... uses clientrect as current region...
;problem...viewport seems to be printer pixel (device) coords...
;v1.38 x/yratio are exact, including finetuning factors...
			;v1.38 this works for zoom=0...
			.IF zoom==0
				  mov eax,clientrect.rc_left
				  imul xratio ;g_nxratio	 ;remember, xratio is *16. v1.38
				  mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				  sar eax,cl		 ;/
				  neg eax		   ;used for axis polarity.
				  mov prnleft,eax
				  mov eax,clientrect.rc_top
				  imul yratio ;g_nyratio v1.38
				  mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				  sar eax,cl		 ;/
				  neg eax												;/
				  mov prntop,eax
				  invoke SetViewportOrgEx,hdcp,prnleft,prntop,0
			.ELSE
			  ;so, leave above working code alone, and let's consider zoom <>0.
			  ;printout has ok size but org is wrong.
			  ;i reckon we need to include zoom into the calcs... (WORKS)...
				  mov eax,clientrect.rc_left
				  imul xratio ;g_nxratio	 ;remember, xratio is *16. v1.38
				  mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				  sar eax,cl		 ;/
				  mov cl,zoom
				  .IF SBYTE PTR cl<0
					neg cl
					sar eax,cl
				  .ELSE
					sal eax,cl
				  .ENDIF
				  neg eax		   ;used for axis polarity.
				  mov prnleft,eax
				  mov eax,clientrect.rc_top
				  imul yratio ;g_nyratio v1.38
				  mov ecx,RATIOSCALE ;v1.37 ratio is stored as 16x actual.
				  sar eax,cl		 ;/
				  mov cl,zoom
				  .IF SBYTE PTR cl<0
					neg cl
					sar eax,cl
				  .ELSE
					sal eax,cl
				  .ENDIF
				  neg eax												;/
				  mov prntop,eax
				  invoke SetViewportOrgEx,hdcp,prnleft,prntop,0
			.ENDIF


tst4:
;now go ahead and print all the objects...
 mov updatesindex,0
 mov wipeoutsindex,0
 mov highlightedindex,0

				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp jj3
				  .ENDIF
nextobj:

				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01				;bit0=1, valid object.
				mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
				  .ELSE 				;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).


				  ;v1.37
				  ;invoke isobjectinwindow, esi  ;return TRUE if yes.
					mov eax,(TERSEDATA PTR [edi]).feveprefs
					and al,01000b ;bit3=1 disable intelligent window paint.
					.IF al==0
					  invoke isobjectinpage,esi ;return TRUE if yes.
					.ELSE
					  mov eax,TRUE	  ;redraw every element in diagram.
					.ENDIF

								.IF eax==TRUE

										;chose a new brush, maybe...
										;(is already a null brush created start this func)
										mov hbrushnewcolor,0
										mov ebx,(OBJECT PTR [esi]).nfillcolor
										mov eax,(OBJECT PTR [esi]).nfillstyle
										.IF eax==0				   ;no fill
										  jmp e300
										.ELSEIF eax==1	   ;solid
e301:							  invoke CreateSolidBrush, ebx
										.ELSE							;hatch fill.
										  .IF eax==2
												mov eax,HS_BDIAGONAL
										  .ELSEIF eax==3
												mov eax,HS_CROSS
										  .ELSEIF eax==4
												mov eax,HS_DIAGCROSS
										  .ELSEIF eax==5
												mov eax,HS_FDIAGONAL
										  .ELSEIF eax==6
												mov eax,HS_HORIZONTAL
										  .ELSEIF eax==7
												mov eax,HS_VERTICAL
										  .ELSE
												jmp e301
										  .ENDIF
										  invoke CreateHatchBrush,eax,ebx
										.ENDIF
										mov hbrushnewcolor,eax
										invoke SelectObject, hdcp,hbrushnewcolor
										mov hbrusholdcolor,eax
e300:

;NO 					;*EVE* .config4 bits 0/1/2 used for pen profile...
										;mov hpendefault,0

								;create a pen...
								mov eax,(OBJECT PTR [esi]).npenstyle
								.IF eax==0				;solid pen.
								  mov eax,PS_SOLID
								.ELSEIF eax==1	;invisible.
								  mov eax,PS_NULL
								.ELSEIF eax==2	;dashes.
								  mov eax,PS_DASH
								.ELSEIF eax==3	;dots.
								  mov eax,PS_DOT
								.ELSEIF eax==4			;v1.30.
								  mov eax,PS_DASHDOT	;/
								.ELSEIF eax==5			;/
								  mov eax,PS_DASHDOTDOT ;/
								.ELSE
								  mov eax,PS_SOLID
								.ENDIF
								mov ebx,(OBJECT PTR [esi]).npenwidth
								mov ecx,(OBJECT PTR [esi]).npencolor
								invoke CreatePen, eax,ebx,ecx
								mov hpencolor,eax
								invoke SelectObject,hdcp,eax
								mov g_hpendefault,eax ;v3.31 mov hpendefault,eax


;finally, call the method to display object...
								  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdcp,esi

;								  invoke SelectObject, hdcp,holdtextfont				;restore original.
										invoke SelectObject,hdcp,g_hpendefault
										invoke DeleteObject, hpencolor
								  ;and restore default brush...
										.IF hbrushnewcolor==0
										.ELSE
										  invoke SelectObject, hdcp, hbrusholdcolor
										  invoke DeleteObject, hbrushnewcolor
										.ENDIF

								.ENDIF

				  .ENDIF
				.ENDIF
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
				loop jj2 ;nextobj
jj1:	jmp SHORT jj3
jj2:	jmp nextobj
jj3:


tst3:
				invoke SelectObject, hdcp, hbrushold
		  invoke DeleteObject, hbrushgreen

						  invoke DeleteObject,g_hpengrey
						  mov g_hpengrey,0
		  invoke DeleteObject,g_hfontx1
		  mov g_hfontx1,0
		
;end of redrawdiag code.  have outputted to printer, restore status...
				  invoke EndPage, hdcp
				  invoke EndDoc, hdcp


;tst2:
				;mov  g_fprintdiag,0
				invoke DeleteDC,hdcp
				  ;free global memory objects...
				  mov eax,myprintdlg.pr_hDevMode
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
				  mov eax,myprintdlg.pr_hDevNames
				  .IF eax==0
				  .ELSE
						invoke GlobalFree,eax
				  .ENDIF
				mov  hdcp,0
				mov  pregion,0

				ret
xpaint_print ENDP
;--------------------------------------------------------------------------
isobjectinwindow PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD
				LOCAL zoom:SBYTE
				LOCAL xadiff:SDWORD, yadiff:SDWORD
; "isobjectinwindow"
;xpaint_entire() calls here, passing ptr to an object.
;v1.37 xpaint_print() calls isobjectinpage().
;return TRUE if object is showing on the current window.
;note that oldgoofee did this checking inside xpaint_entire().

;bug -- if window is small, when print doesn't print all elements!
;so, I suggest cast the net wider...
;could use fprinting =0 if to screen, =1 printer, =2 emf, =3 clipboard.
;1 & 2 are the problem. in those cases, capture everything within
;3 times client window...
;(note fprinting is a global variable, set before call to xpaint_print(),etc.

;v1.37 think need bigger capture zone. make it 5xwindow for zoom=0.

				mov edi,pobj
		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).nzoom
				mov zoom,al

		;v1.28
		;.nexttype=20-29 will always draw...
		mov eax,(OBJECT PTR [edi]).nexttype
		.IF eax>=20
		  .IF eax<=29
			jmp sx1
		  .ENDIF
		.ENDIF

;to screen, capture everything within 1.5 times client window...
;v1.2 now varying capture, proportional to zoom factor. zoom=0 capt 1.5 times client
;window, =-1 capt 2 times, =+1 capt 1.25 times.
;v1.37 now 3x for zoom=0.

		  ;v1.2 i reckon should cast net wider when zoomed in also...
		  mov cl,zoom
		  .IF SBYTE PTR zoom<0
			neg cl
			mov eax,clientrect.rc_right 			  ;purpose is to make rect x1.5 size
			sub eax,clientrect.rc_left					  ;so will draw everything inside
			;sal eax,1 ;v1.37 ;2xwindow.
			  ;v1.39 can still lose elements when zoomed-in...
			  ;shr cl,1
			  sal eax,cl	 ;increase to *(2^|zoom|) of client rect.
			  ;...v1.39 i can concieve of trouble if shift more than 4 times.
			  ;...for zoom=-6, this gives 4 shifts total. still can lose elements.
			  ;maybe I should limit zoom-in to -4. ...see IDM_ZOOMIN. <<DONE.
			mov xadiff,eax
			mov eax,clientrect.rc_bottom
			sub eax,clientrect.rc_top
			;sal eax,1 ;v1.37 ;2xwindow.
			  ;v1.39 can still lose elements when zoomed-in...
			  sal eax,cl	 ;increase to *(2^|zoom|) of client rect.
			mov yadiff,eax						  ;always +ve.
		  .ELSE
			mov eax,clientrect.rc_right 			  ;purpose is to make rect x1.5 size
			sub eax,clientrect.rc_left					  ;so will draw everything inside
			sal eax,1 ;v1.37 ;2xwindow.
			sar eax,cl		   ;decrease.
			mov xadiff,eax
			mov eax,clientrect.rc_bottom
			sub eax,clientrect.rc_top
			sal eax,1 ;v1.37 ;2xwindow.
			sar eax,cl		   ;decrease.
			mov yadiff,eax						  ;always +ve.
		  .ENDIF


				mov eax,(OBJECT PTR [edi]).xtopleft ;xmid
				mov edx,(OBJECT PTR [edi]).ytopleft ;ymid
				mov  cl,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF  zoom>0
				  sar  eax,cl
				  sar edx,cl
				.ELSEIF zoom<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				.ENDIF									;0=normal size.
				mov ecx,clientrect.rc_left
				sub ecx,xadiff					;make rect twice size.
				.IF SDWORD PTR eax>ecx	;in left side?
				  mov ecx,clientrect.rc_right
				  add ecx,xadiff
				  .IF SDWORD PTR eax<ecx ;in right side?
						mov ecx,clientrect.rc_top
						sub ecx,yadiff
						.IF SDWORD PTR edx>ecx			;in top side?
						  mov ecx,clientrect.rc_bottom
						  add ecx,yadiff
						  .IF SDWORD PTR edx<ecx
								;success! object is inside window client area
								mov eax,TRUE
								ret
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF


		  mov eax,(OBJECT PTR [edi]).fconfig1
		  and al,01
		  .IF al==01							;wire-type element.
				mov eax,(OBJECT PTR [edi]).wwidth
				mov edx,(OBJECT PTR [edi]).height
				mov  cl,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF  zoom>0
				  sar  eax,cl
				  sar edx,cl
				.ELSEIF zoom<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				.ENDIF									;0=normal size.
				mov ecx,clientrect.rc_left
				sub ecx,xadiff					;make rect twice size.
				.IF SDWORD PTR eax>ecx	;in left side?
				  mov ecx,clientrect.rc_right
				  add ecx,xadiff
				  .IF SDWORD PTR eax<ecx ;in right side?
						mov ecx,clientrect.rc_top
						sub ecx,yadiff
						.IF SDWORD PTR edx>ecx			;in top side?
						  mov ecx,clientrect.rc_bottom
						  add ecx,yadiff
						  .IF SDWORD PTR edx<ecx
sx1:							;success! object is inside window client area
								mov eax,TRUE
								ret
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF
		  .ENDIF

;fall out here, fail...
		mov eax,FALSE
		ret
isobjectinwindow ENDP
;--------------------------------------------------------------------------
isobjectinpage PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD
				LOCAL zoom:SBYTE
				LOCAL xadiff:SDWORD, yadiff:SDWORD
;v1.37 "isobjectinpage"
;xpaint_print() calls here, passing ptr to an object.
;note xpaint_entire() calls isobjectinwindow().
;return TRUE if object is showing on the current window.
;xpaint_print() first calls drawprintmargins,0, which calcs margin coords.

				mov edi,pobj
		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).nzoom
				mov zoom,al

		;v1.28
		;.nexttype=20-29 will always draw...
		mov eax,(OBJECT PTR [edi]).nexttype
		.IF eax>=20
		  .IF eax<=29
			jmp sx1
		  .ENDIF
		.ENDIF

		mov cl,zoom
		.IF zoom<0
			mov eax,g_mright ;clientrect.rc_right	;purpose is to make rect x1.5 size
			sub eax,g_mleft ;clientrect.rc_left    ;so will draw everything inside
			sal eax,1 ;4x window.
			sal eax,1 ;/
			mov xadiff,eax
			mov eax,g_mbottom ;clientrect.rc_bottom
			sub eax,g_mtop ;clientrect.rc_top
			sal eax,1 ;4x window.
			sal eax,1 ;/
			mov yadiff,eax						  ;always +ve.
		.ELSE
			mov eax,g_mright ;clientrect.rc_right	;purpose is to make rect x1.5 size
			sub eax,g_mleft ;clientrect.rc_left    ;so will draw everything inside
			sal eax,1 ;2xwindow.
			sar eax,cl	;decrease.
			mov xadiff,eax
			mov eax,g_mbottom ;clientrect.rc_bottom
			sub eax,g_mtop ;clientrect.rc_top
			sal eax,1 ;2xwindow.
			sar eax,cl		   ;decrease.
			mov yadiff,eax						  ;always +ve.
		.ENDIF

				mov eax,(OBJECT PTR [edi]).xtopleft ;xmid
				mov edx,(OBJECT PTR [edi]).ytopleft ;ymid
				mov  cl,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF  zoom>0
				  sar  eax,cl
				  sar edx,cl
				.ELSEIF zoom<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				.ENDIF									;0=normal size.
				mov ecx,g_mleft ;clientrect.rc_left
				sub ecx,xadiff					;make rect twice size.
				.IF SDWORD PTR eax>ecx	;in left side?
				  mov ecx,g_mright ;clientrect.rc_right
				  add ecx,xadiff
				  .IF SDWORD PTR eax<ecx ;in right side?
						mov ecx,g_mtop ;clientrect.rc_top
						sub ecx,yadiff
						.IF SDWORD PTR edx>ecx			;in top side?
						  mov ecx,g_mbottom ;clientrect.rc_bottom
						  add ecx,yadiff
						  .IF SDWORD PTR edx<ecx
								;success! object is inside window client area
								;mov eax,TRUE
								;ret
								jmp sx1
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF


		  mov eax,(OBJECT PTR [edi]).fconfig1
		  and al,01
		  .IF al==01							;wire-type element.
				mov eax,(OBJECT PTR [edi]).wwidth
				mov edx,(OBJECT PTR [edi]).height
				mov  cl,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF  zoom>0
				  sar  eax,cl
				  sar edx,cl
				.ELSEIF zoom<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				.ENDIF									;0=normal size.
				mov ecx,g_mleft ;clientrect.rc_left
				sub ecx,xadiff					;make rect twice size.
				.IF SDWORD PTR eax>ecx	;in left side?
				  mov ecx,g_mright ;clientrect.rc_right
				  add ecx,xadiff
				  .IF SDWORD PTR eax<ecx ;in right side?
						mov ecx,g_mtop ;clientrect.rc_top
						sub ecx,yadiff
						.IF SDWORD PTR edx>ecx			;in top side?
						  mov ecx,g_mbottom ;clientrect.rc_bottom
						  add ecx,yadiff
						  .IF SDWORD PTR edx<ecx
sx1:							;success! object is inside window client area
								mov eax,TRUE
								ret
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF
		  .ENDIF

;fall out here, fail...
		mov eax,FALSE
		ret
isobjectinpage ENDP
;--------------------------------------------------------------------------
calcsig PROC STDCALL USES ebx ecx edx esi edi
		 LOCAL pend:DWORD
; "calcsig"

		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).numrecords
		mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		mul ecx
				  mov ecx,(TERSEDATA PTR [esi]).noffsetobjs
				  add ecx,esi ;pTERSEDATA ;starting address of OBJECTS.
		add eax,ecx
		mov pend,eax
		xor edx,edx
		sub pend,4						;prevent overrun end of database.
		add esi,4						;bypass nsignature field.
go2:	test edx,80000000h				;msb
		jz calc1
		xor edx,41081048h				;tapping points
calc1:	xor edx,[esi]
		shl edx,1								;this is signature.
		add esi,4
		cmp esi,pend
		jb		go2

  mov eax,edx	;return the signature.
  ret
calcsig ENDP
;--------------------------------------------------------------------------
.CODE
savedatafile PROC STDCALL USES ebx ecx edx esi edi
		LOCAL pend:DWORD
		LOCAL recalcdatabasesize:DWORD
; "savedatafile"
;return eax=1 if error aborted save, eax=2 cancel save.

				  ;241000
				  ;save top/left coords of window to database...
				  ;(must do this before calcsig())
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_left
				  mov (TERSEDATA PTR [esi]).xleft,eax
				  mov eax,clientrect.rc_top
				  mov (TERSEDATA PTR [esi]).ytop,eax

		.IF hmodulefile != 0
		  ;current open eve file is embedded inside this exe.
		  ;it is read-only...
		  invoke myalertbox,ADDR szer9501,1 ;invoke myerrorhandler,016
		  mov eax,2
		  jmp out1 ;ret
		.ENDIF

		.IF g_hfile==-1   ;invalid or no file open.
		  ;we will have to do saveas...
		  invoke saveasdatafile
		.ELSE

      ;v3.36...
		  ;i think this is a good idea. some people are saving files with elements
		  ;highlighted...
		  invoke zeroabsoluteptrs,1

		  ;v1.26
		  ;change to hour-glass cursor...
      ;mov g_errorapi,0AB7h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		  invoke SetCursor,g_hbusycursor
		  ;...crosshair cursor didn't need this func. need it here to cause immediate change.

		  ;this scans current database and wipes out any bitmap handles and DCs...
		  ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
		  ;because when reload database it won't be valid...
		  invoke deletebitmaphandles	   ;(they are used for drawing bitmaps)
		  ;...also deletes library-data-element.ximage, bitmap "handles". v3.46

		  ;v1.24
		  ;this moves elements toward beginning of database, searching from beginning,
		  ;eliminating all empty records...
		  invoke compactdatabase
		  ;...er no, problem. this calls addcomposites2menu(), which loads the menuitems
		  ;and writes to the database also. library-data-element.ximage gets loaded with
		  ;"handle" of checkmark bitmap for menu item. v3.46
		  ;so, i've pulled it out and placed addcomposites2menu() further down here...

		  ;move the filepointer to beginning of file...
      ;mov g_errorapi,0AB8h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke SetFilePointer, g_hfile,0,0,FILE_BEGIN
		  .IF eax==-1
								;fail...
ferr:
		    invoke myalertbox,ADDR szer210,812h ;eax ;invoke myerrorhandler,210
				invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				mov g_fredrawdiag,ENTIRE				;redraw entire window.
				mov eax,1
		  .ELSE
				;ok, now write entire TERSEDATA to file...
				;g_ndatabasesize is size of memory block, pTERSEDATA->start TERSEDATA.
				.IF g_ndatabasesize==0
				  ;never come here, as g_ndatabasesize setup by wmcreate().
				  invoke myalertbox,ADDR szer211,813h ;eax ;invoke myerrorhandler,211
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
				  mov eax,1
				.ELSE
				  ;ok now we can write it...

				  invoke checkintegrity,2 ;=2 display any errors, not final msg.
				  ;...also fixes all .number fields.

				  ;calculate signature...
				  invoke calcsig
				  mov esi,pTERSEDATA
				  mov (TERSEDATA PTR [esi]).nsignature,eax

				  ;suspected bug...
				  ;if write to a file bigger than current diagram, the old
				  ;end of the file will remain. need to erase data in file
				  ;completely... do this inside compress2file....

          ;v3.01 precaution, calc the database size here...				
            mov eax,(TERSEDATA PTR [esi]).numrecords
            mov ecx,(TERSEDATA PTR [esi]).nsizeobject
            mul ecx 				;eax=size of OBJECTS database.
            add eax,(TERSEDATA PTR [esi]).noffsetobjs ;size of total database.
            mov recalcdatabasesize,eax
            ;...should be same as g_ndatabasesize.
            mov g_ndatabasesize,eax ;better make sure it's right.
            ;...note, there is a func calcdatabasesize(), returns size in eax.
          ;v3.01 "eve preferences" has option to save uncompressed...
          mov eax,(TERSEDATA PTR [esi]).feveprefs
          and ax,0200h ;bit9=1 save uncompressed.
          .IF ax != 0
            ;v3.01 save file uncompressed (as-is)...
            ;mov g_errorapi,0AB9h ;for crash outside EVE, error codes range Axxh. v3.23
				    invoke SetEndOfFile,g_hfile ;truncates file to zero bytes.
            invoke WriteFile,g_hfile,esi,recalcdatabasesize,ADDR nbyteswrote,0
            ;invoke FlushFileBuffers,herrorfile
          .ELSE
;;				   mov eax,pTERSEDATA
;;				   invoke WriteFile, g_hfile,eax,g_ndatabasesize,ADDR nbyteswrote,0
				    invoke compress2file,g_hfile,esi,recalcdatabasesize ;g_ndatabasesize
          .ENDIF
				  .IF eax==0
						jmp ferr		 ;error message.
				  .ENDIF

				  mov eax,0 ;return flag succeeded.
				.ENDIF
		  .ENDIF
		  ;restore normal cursor...
      ;mov g_errorapi,0ABAh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		.ENDIF

	invoke addcomposites2menu,0
	;...see note above. this was relocated from compactdatabase(). v3.46
out1:
  ret
savedatafile ENDP
;--------------------------------------------------------------------------
newdatafile PROC STDCALL USES ebx ecx edx esi edi
	LOCAL dummy:DWORD
;v1.27 "newdatafile"

		.IF g_hfile==-1 		;invalid or nothing open.
		.ELSEIF g_hfile==0 ;v1.27
		.ELSE
		  ;first close current file...
      ;mov g_errorapi,0ABBh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CloseHandle, g_hfile ;close previous file.
		  mov g_hfile,-1
		  mov szfile,0
		.ENDIF

;well, reckon we can just delete elements then resize the database, as done in
;erasediagram()...
		invoke erasediagram

;and restore coords to 0/0 and zoom to 0...
		mov esi,pTERSEDATA
		mov (TERSEDATA PTR [esi]).nzoom,0
		invoke xorigin

;v1.39 read preferences from eve.ini...
	invoke prefs2new

;leave other TERSEDATA settings as-is.

	ret
newdatafile ENDP
;--------------------------------------------------------------------------

saveasdatafile PROC STDCALL USES ebx ecx edx esi edi
        LOCAL recalcdatabasesize:DWORD
				LOCAL opentersefile:OPENFILENAME
				LOCAL szoldfile[sizeszfile]:BYTE
; "saveasdatafile"
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.

		;invoke zeroabsoluteptrs,0
		;wouldn't it be wiser to clr all ptrs?... v3.36
		invoke zeroabsoluteptrs,1

				  ;241000
				  ;save top/left coords of window to database...
				  ;(must do this before calcsig())
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_left
				  mov (TERSEDATA PTR [esi]).xleft,eax
				  mov eax,clientrect.rc_top
				  mov (TERSEDATA PTR [esi]).ytop,eax

				.IF g_ndatabasesize==0
				  ;never come here, as wmcreate() sets up g_nfilesixe.
				  invoke myalertbox,ADDR szer211,814h ;eax ;invoke myerrorhandler,211
					invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
					mov g_fredrawdiag,ENTIRE				;redraw entire window.
				  mov eax,1
				  ret
				.ENDIF

		.IF g_hfile==-1 		;invalid or nothing open.
		  ;go ahead and bring up a dialog box...
		.ELSE
		  ;first close current file...
      ;mov g_errorapi,0ABCh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CloseHandle, g_hfile ;close previous file.
		  mov g_hfile,-1
		  mov szfile,0
		.ENDIF

				  ;first, copy default structure...
				  lea edi,opentersefile
				  lea ebx,defaulttersefile
				  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo1
				  ;do same for szfile...
								;first save current contents...
								lea edi,szoldfile
								lea ebx,szfile
								mov ecx,sizeszfile
oo3:					mov al,[ebx]
								mov [edi],al
								inc ebx
								inc edi
								dec ecx
								jnz oo3
				  lea edi,szfile
				  lea ebx,szdeffile
				  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo2
  ;mov g_errorapi,0ABDh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetSaveFileName, ADDR opentersefile ;<<<DIALOG BOX
				.IF eax==0								;0=error/cancel
								;not necessarily an error here, but put up a msgbox...
						;we can keep the previously open file, so restore szfile...
												lea edi,szfile
												lea ebx,szoldfile
												mov ecx,sizeszfile
oo4:									mov al,[ebx]
												mov [edi],al
												inc ebx
												inc edi
												dec ecx
												jnz oo4
								  .IF g_hfile==-1
										;		 lea eax,rsave2
										;		 jmp ferr2
										jmp SHORT fe88
								  .ELSE
						invoke myalertbox,ADDR szerrsave,1 ;invoke myerrorhandler,006
ferr2:
fe88:					invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								mov g_fredrawdiag,ENTIRE				;redraw entire window.
										  mov eax,2
										  ret
								  .ENDIF
				  .ENDIF

;.............
;point of no-return for previously opened file...
				.IF g_hfile==-1 ;-1 means no file previously open.
				  .ELSE
  ;mov g_errorapi,0ABEh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CloseHandle, g_hfile ;close previous file.
						mov g_hfile,-1
				  .ENDIF

	   ;v1.26...
  ;mov g_errorapi,0ABFh ;for crash outside EVE, error codes range Axxh. v3.23
	   invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

;create the file...
;v300d... had CREATE_NEW, now CREATE_ALWAYS, so won't get an error if try to
;overwrite an existing eve file... (note, it is possible to use GetLastError()
;to check for this condition)...
  ;mov g_errorapi,0AC0h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke CreateFile, ADDR szfile,\
								GENERIC_READ+GENERIC_WRITE,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, CREATE_ALWAYS,\ ;creates a new file.
								FILE_ATTRIBUTE_NORMAL, 0
		  .IF eax==INVALID_HANDLE_VALUE   ;-1
fer5:			mov g_hfile,-1
				  mov szfile,0
				invoke myalertbox,ADDR szer212,815h ;eax ;invoke myerrorhandler,212
				invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				mov g_fredrawdiag,ENTIRE				;redraw entire window.
				mov eax,1
				jmp eo1 ;ret
		  .ELSE
				mov g_hfile,eax
				;now go ahead and write all of TERSEDATA to the file...

			 ;this scans current database and wipes out any bitmap handles and DCs...
			 ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
			 ;because when reload database it won't be valid...
				invoke deletebitmaphandles		 ;(they are used for drawing GIFs)

				;do this first...
				invoke checkintegrity,2 ;=2 display any errors,not final msg.
				;...fixes also.

				;calculate signature...
				invoke calcsig
				mov esi,pTERSEDATA
				mov (TERSEDATA PTR [esi]).nsignature,eax

          ;v3.01 precaution, calc the database size here...				
            mov eax,(TERSEDATA PTR [esi]).numrecords
            mov ecx,(TERSEDATA PTR [esi]).nsizeobject
            mul ecx 				;eax=size of OBJECTS database.
            add eax,(TERSEDATA PTR [esi]).noffsetobjs ;size of total database.
            mov recalcdatabasesize,eax
            ;...should be same as g_ndatabasesize.
            mov g_ndatabasesize,eax ;better make sure it's right.
            ;...note, there is a func calcdatabasesize(), returns size in eax.
          ;v3.01 "eve preferences" has option to save uncompressed...
          mov eax,(TERSEDATA PTR [esi]).feveprefs
          and ax,0200h ;bit9=1 save uncompressed.
          .IF ax != 0
            ;v3.01 save file uncompressed (as-is)...
            ;mov g_errorapi,0AC1h ;for crash outside EVE, error codes range Axxh. v3.23
				    invoke SetEndOfFile,g_hfile ;truncates file to zero bytes.
            invoke WriteFile,g_hfile,esi,recalcdatabasesize,ADDR nbyteswrote,0
            ;invoke FlushFileBuffers,herrorfile
          .ELSE
				    invoke compress2file,g_hfile,esi,recalcdatabasesize ;g_ndatabasesize
          .ENDIF
				  .IF eax==0
						;fail...
						invoke CloseHandle, g_hfile ;close file.
						jmp fer5						;error message.
				  .ENDIF
				  
		  .ENDIF

         ;v2.95 when i introduced "Find" buttons in EVE, this enabled the current
         ;folder to change. wmcreate() recorded home folder in szhomefolder, and
         ;called SetCurrentDirectory,ADDR szhomeflder in xdblclk() before
         ;running a link.
         ;however, when open a new file, need to change szhomefolder to the new
         ;home of the opened eve file...
         ;mov eax,opentersefile.on_lpstrFile ;full path\filename.
         ;invoke lstrcpy,ADDR szhomefolder,eax
         ;lea ebx,szhomefolder
         ;xor eax,eax
         ;mov ax,opentersefile.on_nFileOffset
         ;add ebx,eax ;offset in .lpstrFile to filename.
         ;mov [ebx],BYTE PTR 0 ;leave just path.
         ;no need to call SetCurrentDirectory() now, as opening file has set it.
         invoke lstrcpy,ADDR szhomefolder,ADDR szfile ;eax v3.47
         lea ebx,szhomefolder
         push ebx             ;v3.47
         invoke lstrlen,ebx
         pop ebx
         add ebx,eax
         ;go back, find "\"...
zgo1:     mov al,[ebx]
         .IF al=="\"
           inc ebx
         .ELSE
           dec ebx
           lea eax,szhomefolder
           .IF ebx>eax
             jmp zgo1
           .ENDIF
         .ENDIF
         mov [ebx],BYTE PTR 0
         ;er, i'm not sure that it has... v3.47
         invoke SetCurrentDirectory,ADDR szhomefolder

		mov hmodulefile,0 ;if previous open eve file was embedded, this was
										  ;non-0. note, savedatafile() references this.
		invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
		mov g_fredrawdiag,ENTIRE				;redraw entire window.
		mov eax,0		;succeeded.

eo1:
		;v1.26
		;restore cursor...
		push eax
  ;mov g_errorapi,0AC2h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax

		ret
saveasdatafile ENDP
;--------------------------------------------------------------------------
.DATA
szfilespec BYTE 256 DUP(0)

.CODE ;v3.36...
defaultembeddedfile OPENFILENAME <, 0, 0, (OFFSET szembeddedfilter) ,0,\
								0, 1, 0, sizeszfile,\
								0, 0, 0, 0,\
								OFN_CREATEPROMPT+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szembeddedextension), 0 ,0, 0>
								DB 0,0,0,0
szdefembeddedfile DB "*.eve.exe", sizeszfile-4 DUP(0)								
szeveexe BYTE "eve.exe",0 ;v3.01 moved from .DATA
;sztest BYTE "test.exe",0

saveasembedded PROC STDCALL USES ebx ecx edx esi edi
				LOCAL hfile:DWORD
				LOCAL openembeddedfile:OPENFILENAME
				LOCAL szembeddedfile[sizeszfile]:BYTE
        LOCAL ncompletesize:DWORD
; "saveasembedded"
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.
;menu file/save as embedded -> idm_embedded ->
;save data file embedded, appended at end, of eve.exe file.
;based on saveasdatafile().

;										push eax						 ;save previous value of state.
;										mov al,g_nstate 		 ;/
;										mov g_nstateprev,al  ;/
;										pop eax 						 ;/
;				mov g_nstate,0
;				mov g_pmovingobject,0
;				mov g_pselectedobjnew,0
    invoke zeroabsoluteptrs,1 ;v3.36

				  ;save top/left coords of window to database...
				  ;(must do this before calcsig())
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_left
				  mov (TERSEDATA PTR [esi]).xleft,eax
				  mov eax,clientrect.rc_top
				  mov (TERSEDATA PTR [esi]).ytop,eax


				.IF g_ndatabasesize==0
				  ;never come here, as wmcreate() sets up g_nfilesixe.
				  invoke myalertbox,ADDR szer211,816h ;eax ;invoke myerrorhandler,211
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
				  mov eax,1
				  jmp out1 ;ret
				.ENDIF

				  ;first, copy default structure...
				  lea edi,openembeddedfile
				  lea ebx,defaultembeddedfile
				  mov ecx,OPENFILENAME_
oo1:			  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo1
				  lea eax,szembeddedfile
				  mov openembeddedfile.on_lpstrFile,eax

				  ;do same for szembeddedfile...
								lea edi,szembeddedfile
								lea ebx,szdefembeddedfile
								mov ecx,sizeszfile
oo3:							mov al,[ebx]
								mov [edi],al
								inc ebx
								inc edi
								dec ecx
								jnz oo3

        ;mov g_errorapi,0AC3h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetSaveFileName, ADDR openembeddedfile ;<<<DIALOG BOX
				.IF eax==0								;0=error/cancel
								;not necessarily an error here, but put up a msgbox...
						invoke myalertbox,ADDR szerrsave,1 ;invoke myerrorhandler,006
ferr2:
fe88:				invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
						mov g_fredrawdiag,ENTIRE				;redraw entire window.
						mov eax,2
						jmp out1 ;ret
				  .ENDIF


		;v1.26
		;busy cursor...
    ;mov g_errorapi,0AC4h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

;now for the exciting part...
        ;mov g_errorapi,0AC5h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SearchPathA,0,ADDR szeveexe,0,255,ADDR szfilespec,0
				;...note this looks in folder in which eve.exe loaded, then current folder.
				.IF eax==0 ;fail
				  invoke myalertbox,ADDR szer215,817h ;eax ;invoke myerrorhandler,215
				  jmp fer5
				.ENDIF
				;...eve.exe will be found, path/name in szfilespec.
        ;mov g_errorapi,0AC6h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke CopyFileA,ADDR szfilespec,ADDR szembeddedfile,0
				;...copies eve.exe to new file (name already chosen above).
				.IF eax==0 ;fail
				  invoke myalertbox,ADDR szer216,818h ;eax ;invoke myerrorhandler,216
				  jmp fer5
				.ENDIF

;create the file...
        ;mov g_errorapi,0AC7h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke CreateFile, ADDR szembeddedfile,\
								GENERIC_READ+GENERIC_WRITE,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, OPEN_EXISTING,\				;must exist.
								FILE_ATTRIBUTE_NORMAL, 0
			  .IF eax==INVALID_HANDLE_VALUE   ;-1
fer5:			mov hfile,-1
				  mov szembeddedfile,0
				  invoke myalertbox,ADDR szer212,819h ;eax ;invoke myerrorhandler,212
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				;redraw entire window.
				  mov eax,1
				  jmp eo1 ;ret
			  .ELSE
				  mov hfile,eax
				  ;now go ahead and write all of TERSEDATA to the file...

				  ;v1.23 savedatafile(), saveasdatafile, have this, forgot it for here...
				  ;this scans current database and wipes out any bitmap handles and DCs...
				  ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
				  ;because when reload database it won't be valid...
				  invoke deletebitmaphandles		 ;(they are used for drawing bitmaps)

				  ;do this first...
				  invoke checkintegrity,2 ;=2 display any errors,not final msg.
				  ;...fixes also.

				  ;calculate signature...
				  invoke calcsig
				  mov esi,pTERSEDATA
				  mov (TERSEDATA PTR [esi]).nsignature,eax

				  ;before writing the data, move file-pointer to end of file...
          ;mov g_errorapi,0AC8h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke SetFilePointer,hfile,-12,0,FILE_END
				  .IF eax==-1
				    jmp f33
				  .ENDIF
				  ;check that don't already have an embedded EVE datafile...
				  ;lea eax,szasciitbl
				  invoke ReadFile,hfile,ADDR szasciitbl,8,ADDR nbyteswrote,0
				  .IF DWORD PTR szasciitbl==-1
tst1:		    .IF DWORD PTR szasciitbl+4==-1
						  ;32-bit value =-1 means an EVE file already embedded.
						  ;precaution only, as eve.exe itself unlikely to have embeddedEVE.
						  ;the next 4 bytes will be the EVE filesize(including
						  ; end-marker and filesize)...
						  ;lea eax,szasciitbl
						  invoke ReadFile,hfile,ADDR szasciitbl,4,ADDR nbyteswrote,0
						  mov eax,DWORD PTR szasciitbl ;size of appended embedded file.
						  neg eax
						  invoke SetFilePointer,hfile,eax,0,FILE_END
						  invoke SetEndOfFile,hfile   ;get rid of embedded file.
				    .ENDIF
				  .ELSEIF DWORD PTR szasciitbl==-2 ;v3.36 new LZP format.
				    jmp tst1				
          .ENDIF
				  invoke SetFilePointer,hfile,0,0,FILE_END

            ;precaution, calc the database size here...				v3.36
            mov eax,(TERSEDATA PTR [esi]).numrecords
            mov ecx,(TERSEDATA PTR [esi]).nsizeobject
            mul ecx 				;eax=size of OBJECTS.
            add eax,(TERSEDATA PTR [esi]).noffsetobjs ;size of total database.
            mov g_ndatabasesize,eax
            
				  ;writes at current filepointer...
				  invoke compress2file,hfile,pTERSEDATA,g_ndatabasesize
				  .IF eax==0
						;fail...
f33:				invoke CloseHandle, hfile ;close file.
					  jmp fer5						;error message.
				  .ENDIF

          invoke GetFileSize,hfile,0 ;v3.36
		      mov ncompletesize,eax
				  invoke SetFilePointer,hfile,-20,0,FILE_END ;spare field.   v3.36
		      invoke WriteFile,hfile,ADDR ncompletesize,4,ADDR nbyteswrote,0

				  invoke CloseHandle, hfile ;close file.
			  .ENDIF

		mov eax,0		;succeeded.

eo1:
		;v1.26
		;restore cursor...
		push eax
    ;mov g_errorapi,0AC9h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax
out1:
		ret
saveasembedded ENDP
;--------------------------------------------------------------------------
;compress2file PROC STDCALL USES ebx ecx edx esi edi, \
;				   hfile:DWORD,pdata:DWORD,nsize:DWORD
;		LOCAL outbuffer:DWORD,mkr:DWORD,fout:DWORD
;		LOCAL cntcompressed:DWORD,cntstack:DWORD
;		LOCAL ecxsave:DWORD,cntuncompressed:DWORD
;; "compress2file"
;;write to current nfileptr1st position, data-block pdata, size nsize,
;;compressed.
;;append bit-flags,,size of bitflags,size of tersedata,
;;endmarker (64bit),total size.
;;return eax=0 if fail.
;;presumes filepointer already set to correct position.
;
;		mov mkr,01		  ;shift register.
;		mov cntcompressed,0
;		mov cntstack,0
;		mov fout,0
;		mov cntuncompressed,0
;		mov esi,pdata
;		mov ecx,nsize
;		shr ecx,1 ;cos will copy a word at a time.
;nxt1:
;		mov ecxsave,ecx
;		mov ax,[esi]
;		.IF ax==0
;		  mov eax,mkr
;		  or fout,eax
;		.ELSE
;		  mov WORD PTR outbuffer,ax
;      ;mov g_errorapi,0ACAh ;for crash outside EVE, error codes range Axxh. v3.23
;		  invoke WriteFile,hfile,ADDR outbuffer,2,ADDR nbyteswrote,0
;		  .IF eax==0
;				ret
;		  .ENDIF
;		  inc cntcompressed ;count actual size of stored words.
;		.ENDIF
;		shl mkr,1
;		  ;when the "1" shifts into carry flag, push fout onto stack...
;		  jnc nxt2
;		  push fout
;		  mov mkr,01 ;reset shift register.
;		  mov fout,0 ;reset bit flags register.
;		  inc cntstack ;count number dwords bit-flags on stack.
;nxt2:
;		add cntuncompressed,2 ;#bytes tersedata uncompressed
;		inc esi
;		inc esi
;		mov ecx,ecxsave
;		loop nxt1
;		
;		;one possible problem, mkr part-way across...
;		.IF mkr==01
;		.ELSE
;		  push fout
;		  inc cntstack
;		.ENDIF
;
;;now we have to append the extra stuff...
;;write the bit-flags...
;		mov ecx,cntstack
;nxt3:
;		mov ecxsave,ecx
;		pop eax
;		  mov outbuffer,eax
;      ;mov g_errorapi,0ACBh ;for crash outside EVE, error codes range Axxh. v3.23
;		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
;		mov ecx,ecxsave
;		loop nxt3
;
;;before appending the extra params to the data file, a potential
;;problem -- if saving to a eve file that was previously bigger, the
;;old stuff will be left there. Need to truncate file now...
;  ;mov g_errorapi,0ACCh ;for crash outside EVE, error codes range Axxh. v3.23
;				invoke SetEndOfFile,hfile
;
;;version#...															  ;-28 from end of file.
;		  mov ebx,pTERSEDATA
;		  mov eax,(TERSEDATA PTR [ebx]).nversion
;		  mov outbuffer,eax
;  ;mov g_errorapi,0ACDh ;for crash outside EVE, error codes range Axxh. v3.23
;		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
;;uncompressed size of tersedata (#bytes)...
;		  invoke WriteFile,hfile,ADDR cntuncompressed,4,ADDR nbyteswrote,0
;;size of bitflags (# DWORDs)...
;		  invoke WriteFile,hfile,ADDR cntstack,4,ADDR nbyteswrote,0
;;size of tersedata (# WORDs)...
;		  invoke WriteFile,hfile,ADDR cntcompressed,4,ADDR nbyteswrote,0
;;64-bit end-marker...
;		  mov outbuffer,-1
;		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
;		  mov outbuffer,-1
;		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
;;total size of tersedate+bitflags+endstuff(including this total cnt)(BYTEs)...
;		  mov eax,cntcompressed
;		  shl eax,1
;		  mov outbuffer,eax
;		  mov eax,cntstack
;		  shl eax,1
;		  shl eax,1
;		  add outbuffer,eax
;		  add outbuffer,28
;		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
;
;		mov eax,1
;		ret
;compress2file ENDP
;--------------------------------------------------------------------------
compress2file PROC STDCALL USES ebx ecx edx esi edi, \
				   hfile:DWORD,pdata:DWORD,nsize:DWORD
    LOCAL pofile:DWORD,nsizecompr:DWORD
    LOCAL outbuffer:DWORD
; "compress2file"
;write to current file ptr position, data-block pdata, size nsize,
;compressed.
;append endmarker (64bit),total size.
;return eax=0 if fail.
;presumes filepointer already set to correct position.

    ;need temp o/p buffer...
    invoke GlobalAlloc,GMEM_FIXED,nsize ;note, don't really need this big.
    .IF eax==0
      jmp out1
    .ENDIF
    mov pofile,eax
    
    invoke lzp_compress,pdata,nsize,pofile
    ;...compresses and writes to an o/p buffer ofile.
    ;returns eax=size compressed data.
    mov nsizecompr,eax
    
    ;now write ofile to disk...
	  invoke WriteFile,hfile,pofile,nsizecompr,ADDR nbyteswrote,0

    ;append extra stuff...
    ;before appending the extra params to the data file, a potential
    ;problem -- if saving to a eve file that was previously bigger, the
    ;old stuff will be left there. Need to truncate file now...
		invoke SetEndOfFile,hfile

    ;i'm keeping same format on end of file as original compression method...
      ;version#...															  ;-28 from end of file.
		  mov ebx,pTERSEDATA
		  mov eax,(TERSEDATA PTR [ebx]).nversion
		  mov outbuffer,eax
		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
      ;uncompressed size of tersedata (#bytes)...
		  invoke WriteFile,hfile,ADDR nsize,4,ADDR nbyteswrote,0
      ;size of bitflags (# DWORDs)... *NOW WRITE ZERO HERE*
      mov outbuffer,0 ;v3.36 note, saveasembedded() puts total filesize in here.
		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
      ;size of compressed tersedata (#WORDs)... *NOW #BYTES*
		  invoke WriteFile,hfile,ADDR nsizecompr,4,ADDR nbyteswrote,0
      ;64-bit end-marker...
		  mov outbuffer,-2 ;original method had -1.
		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
		  mov outbuffer,-1
		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0
      ;total size of file (bytes)... (in case of embedded, this is size embedded part)
		  mov eax,nsizecompr
		  mov outbuffer,eax
		  add outbuffer,28 ;appended stuff.
		  invoke WriteFile,hfile,ADDR outbuffer,4,ADDR nbyteswrote,0

    ;destroy temp buffer...
		invoke GlobalHandle,pofile
		invoke GlobalFree,eax

		mov eax,1
out1:		
		ret
compress2file ENDP
;--------------------------------------------------------------------------
file2uncompress PROC STDCALL USES ebx ecx edx esi edi,
						hfile:DWORD,pdata:DWORD
		LOCAL inbuffer:DWORD,cntcompressed:DWORD,cntstack:DWORD
		LOCAL totalsize:DWORD,ecxsave:DWORD,cntuncompressed:DWORD
		LOCAL mkr:DWORD,fout:DWORD
; "file2uncompress"
;extract compressed eve file.
;pdata =ptr to destination TERSEDATA.

;get total size... (#bytes)...
  ;mov g_errorapi,0ACEh ;for crash outside EVE, error codes range Axxh. v3.23
						invoke SetFilePointer,hfile,-4,0,FILE_END
						invoke ReadFile,hfile,ADDR totalsize,4,ADDR nbyteswrote,0
;get uncompressed size of tersedata... (#bytes)...
						invoke SetFilePointer,hfile,-24,0,FILE_END
						invoke ReadFile,hfile,ADDR cntuncompressed,4,ADDR nbyteswrote,0
;get size of bitflags... (#dwords)...
						invoke ReadFile,hfile,ADDR cntstack,4,ADDR nbyteswrote,0
;get size of tersedata (compressed)... (#words)...
						invoke ReadFile,hfile,ADDR cntcompressed,4,ADDR nbyteswrote,0

;read the bitflags off the file...
						mov eax,cntstack ;# dwords.
						add eax,7		;# dwords endstuff.
						shl eax,1
						shl eax,1
						neg eax 		;# bytes back from end of file.
						invoke SetFilePointer,hfile,eax,0,FILE_END
		mov ecx,cntstack
xt3:
		mov ecxsave,ecx
		  invoke ReadFile,hfile,ADDR inbuffer,4,ADDR nbyteswrote,0
		  mov eax,inbuffer
		  push eax
		mov ecx,ecxsave
		loop xt3


;now read and uncompress tersedata...
						mov eax,totalsize
						neg eax 		;# bytes back from end of file.
						invoke SetFilePointer,hfile,eax,0,FILE_END
		mov mkr,01		  ;shift register.
		mov fout,0
		mov esi,pdata
nxt1:
		  .IF mkr==01
				pop eax
				mov fout,eax
		  .ENDIF
		  mov eax,mkr
		  and eax,fout
		  .IF eax==0
				invoke ReadFile,hfile,ADDR inbuffer,2,ADDR nbyteswrote,0
				mov eax,inbuffer
				mov [esi],ax
				  dec cntcompressed ;was #words compressed data.
				  jbe xt7 ;finished
		  .ELSE  ;bitflag=1, 0-word was extracted.
				mov [esi],WORD PTR 0
		  .ENDIF
		  shl mkr,1
		  jnc nxt5
		  mov mkr,01
nxt5:
		inc esi
		inc esi
		jmp nxt1
xt7:


;v2.15
;it seems g_ndatabasesize isn't getting loaded correctly, so calc it here...
		invoke calcdatabasesize
		mov g_ndatabasesize,eax
		;...note, file2uncompress() may just be appending a file to existing database,
		;but on return the actual new total for g_ndatabasesize is calc'd.


		mov eax,cntuncompressed
		ret
file2uncompress ENDP
;--------------------------------------------------------------------------
;v3.30...
file2uncompress_lzp PROC STDCALL USES ebx ecx edx esi edi,
						hfile:DWORD,pdata:DWORD
		LOCAL psourcedata:DWORD,cntcompressed:DWORD
		LOCAL cntuncompressed:DWORD ;,graphicfilesize:DWORD
; "file2uncompress_lzp"
;extract compressed eve file.
;pdata =ptr to destination TERSEDATA.
;return eax=uncompressed database size.

;get uncompressed size of tersedata... (#bytes)...
						invoke SetFilePointer,hfile,-24,0,FILE_END
						invoke ReadFile,hfile,ADDR cntuncompressed,4,ADDR nbyteswrote,0
;get size of tersedata (compressed)... (#bytes)...
						invoke SetFilePointer,hfile,-16,0,FILE_END
						invoke ReadFile,hfile,ADDR cntcompressed,4,ADDR nbyteswrote,0
						;...this includes the 5 byte header stored at the start of the file,
						;1st byte=0, next 4 bytes =size of uncompressed database (same value
						;as i have stored in cntuncompressed)
;						invoke SetFilePointer,hfile,-4,0,FILE_END                         ;v3.36
;						invoke ReadFile,hfile,ADDR graphicfilesize,4,ADDR nbyteswrote,0   ;/
;            ;...not total filesize in case of embedded graphic.
            
    mov eax,cntcompressed
    add eax,128
	  invoke GlobalAlloc,GMEM_FIXED,eax
	  .IF eax==0					;NULL
	    jmp out1
	  .ENDIF
	  mov psourcedata,eax
	  
	  invoke SetFilePointer,hfile,0,0,FILE_BEGIN
	  ;;for embedded file, file has eve.exe in front. so, have to move fileptr back
	  ;;from end...
	  ;mov eax,graphicfilesize
	  ;neg eax
		;invoke SetFilePointer,hfile,eax,0,FILE_END    ;v3.36
		;...no, the LZP uncompressor code requires our graphic file to be right from
		;start of file. v3.36
	
	  invoke ReadFile,hfile,psourcedata,cntcompressed,ADDR nbyteswrote,0
	  ;...note, not reading the 28 byte appended info by me.
	
    ; Fill dest with garbage to simplify matching
    mov eax,0F7D9A03Fh         ; <- "magic number" :) just garbage...
    mov edi,pdata
    mov ecx,cntuncompressed
    shr ecx,2
fi1: mov [edi],eax
    add edi,4
    loop fi1

    invoke lzp_decompress,pdata,psourcedata
    ;...returns eax=size uncompressed data. (also have it from above)

		invoke GlobalHandle,psourcedata
		invoke GlobalFree,eax
		
;it seems g_ndatabasesize isn't getting loaded correctly, so calc it here... v2.15
		invoke calcdatabasesize
		mov g_ndatabasesize,eax
		;...note, file2uncompress() may just be appending a file to existing database,
		;but on return the actual new total for g_ndatabasesize is calc'd.
		;...cannot load actual incoming file size into g_ndatabasesize, as will break v3.30
		;opentemplate(). leave code like this. openmerge() recalcs after return.		
		
		mov eax,cntuncompressed
out1:		
		ret ;eax=uncompressed file size.
file2uncompress_lzp ENDP
;--------------------------------------------------------------------------
selectedsaveasdatafile PROC STDCALL USES ebx ecx edx esi edi
				LOCAL numobjectsprev:DWORD,nsizenew:DWORD
				LOCAL nsizeobjectsold:DWORD
				LOCAL opentersefile:OPENFILENAME
				LOCAL szoldfile[sizeszfile]:BYTE
; "selectedsaveasdatafile"
;called via file/selected elements save as..." > idm_saveass
;adapted from saveasdatafile().
;returns eax=1 if aborted with error, eax=2 if cancel, else eax=0 succeeded.

;										push eax						 ;save previous value of state.
;										mov al,g_nstate 		 ;/
;										mov g_nstateprev,al  ;/
;										pop eax 						 ;/
;				mov g_nstate,0
;				mov g_pmovingobject,0
;				mov g_pselectedobjnew,0
		invoke zeroabsoluteptrs,0  ;v3.36

				  ;241000
				  ;save top/left coords of window to database...
				  ;(must do this before calcsig())
				  mov esi,pTERSEDATA
				  mov eax,clientrect.rc_left
				  mov (TERSEDATA PTR [esi]).xleft,eax
				  mov eax,clientrect.rc_top
				  mov (TERSEDATA PTR [esi]).ytop,eax


				.IF g_ndatabasesize==0
				  ;never come here, as wmcreate() sets up g_nfilesixe.
				  invoke myalertbox,ADDR szer211,81Ah ;eax ;invoke myerrorhandler,211
					invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
					mov g_fredrawdiag,ENTIRE				;redraw entire window.
				  mov eax,1
				  ret
				.ENDIF

		.IF g_hfile==-1 		;invalid or nothing open.
		  ;go ahead and bring up a dialog box...
		.ELSE
		  ;first close current file...
      ;mov g_errorapi,0ACFh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CloseHandle, g_hfile ;close previous file.
		  mov g_hfile,-1
		  mov szfile,0
		.ENDIF

				  ;first, copy default structure...
				  lea edi,opentersefile
				  lea ebx,defaulttersefile
				  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo1
				  ;do same for szfile...
								;first save current contents...
								lea edi,szoldfile
								lea ebx,szfile
								mov ecx,sizeszfile
oo3:					mov al,[ebx]
								mov [edi],al
								inc ebx
								inc edi
								dec ecx
								jnz oo3
				  lea edi,szfile
				  lea ebx,szdeffile
				  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo2
        ;mov g_errorapi,0AD0h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetSaveFileName, ADDR opentersefile ;<<<DIALOG BOX
				.IF eax==0								;0=error/cancel
								;not necessarily an error here, but put up a msgbox...
						;we can keep the previously open file, so restore szfile...
												lea edi,szfile
												lea ebx,szoldfile
												mov ecx,sizeszfile
oo4:									mov al,[ebx]
												mov [edi],al
												inc ebx
												inc edi
												dec ecx
												jnz oo4
								  .IF g_hfile==-1
										;		 lea eax,rsave2
										;		 jmp ferr2
										jmp SHORT fe88
								  .ELSE
						invoke myalertbox,ADDR szerrsave,1 ;invoke myerrorhandler,006
ferr2:
fe88:					invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								mov g_fredrawdiag,ENTIRE				;redraw entire window.
										  mov eax,2
										  ret
								  .ENDIF
				  .ENDIF

;......
;point of no-return for previously opened file...

		;v1.26
    ;mov g_errorapi,0AD1h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

				.IF g_hfile==-1 ;-1 means no file previously open.
				  .ELSE
						invoke CloseHandle, g_hfile ;close previous file.
						mov g_hfile,-1
				  .ENDIF

;create the file...
      ;mov g_errorapi,0AD2h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CreateFile, ADDR szfile,\
								GENERIC_READ+GENERIC_WRITE,\
								FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, CREATE_ALWAYS,\ ;creates a new file.
								FILE_ATTRIBUTE_NORMAL, 0
		  .IF eax==INVALID_HANDLE_VALUE   ;-1
fer5:			  mov g_hfile,-1
				  mov szfile,0
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
				  invoke myalertbox,ADDR szer212,81Bh ;eax ;invoke myerrorhandler,212
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
				  mov eax,1
				  jmp eo1 ;ret
		  .ELSE
				 mov g_hfile,eax
				 ;now go ahead and write all of TERSEDATA to the file...


				 ;v1.23 savedatafile(), saveasdatafile(), saveasembedded() have this, so need here...
				 ;this scans current database and wipes out any bitmap handles and DCs...
				 ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
				 ;because when reload database it won't be valid...
				 invoke deletebitmaphandles 	  ;(they are used for drawing bitmaps)


				  ;this is where will differ from saveasdatafile()...

				  ;only save selected elements...
				  mov eax,highlightedlist  ;1st highlighted element
				  invoke repositioncursor,eax ;move mouse to 1st highlighted element.				
				  invoke duplicatehighlighted,1 ;copy duplicate elements to end dbase.
				  ;...param=1 also copy any pics attached to icons. v3.15
				   ;...exit from this routine with highlightednewlist pointing to
				   ;   all of the duplicated elements.
				   ;   their coords track the mouse until a left-click.
				   ; returns eax=previous # objects in database.
				  ;now delete all elements not duplicated...
				   mov numobjectsprev,eax
				   .IF eax==0
						 jmp no1
					 .ELSEIF eax==1 ;v3.15
					   jmp no1
				   .ELSE
						 mov ecx,eax			;# objects to delete.
						 ;xor eax,eax
						 mov esi,pTERSEDATA
						 mov eax,(TERSEDATA PTR [esi]).nsizeobject
						   mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
						   add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
						   add ebx,(TERSEDATA PTR [esi]).nsizeobject ;v3.15 have to skip rec#0.
						   dec ecx    ;v3.15 /
nxtobj: 		 mov (OBJECT PTR [ebx]).fstatus,0
						 add ebx,eax
						 loop nxtobj
				   .ENDIF


				  ;now move elements to begining of dbase...
				  ;xor ecx,ecx
				  mov eax,numobjectsprev
				  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
				  mul ecx
				  mov nsizeobjectsold,eax				;size of prev OBJECTS dbase.
						mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
						add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add ebx,eax	;actual end addr of previous database.
						mov eax,(TERSEDATA PTR [esi]).numrecords
						mov ecx,(TERSEDATA PTR [esi]).nsizeobject
						mul ecx
						  mov edi,(TERSEDATA PTR [esi]).noffsetobjs
						  add edi,esi ;pTERSEDATA ;starting address of OBJECTS.
						add edi,eax ;actual end addr of current database.
						  sub edi,ebx	;size of new elements.
						  mov ecx,edi
				  ;now relocate...
				  ;ebx=start of new elements, ecx=size new elements (bytes)...
				  mov nsizenew,ecx
				  .IF ecx==0
				  .ELSE
						  mov edi,(TERSEDATA PTR [esi]).noffsetobjs
						  add edi,esi ;pTERSEDATA ;starting address of OBJECTS.
						  add edi,(TERSEDATA PTR [esi]).nsizeobject ;v3.15 ignore rec#0.
mvobjs: 		mov al,[ebx]
						mov [edi],al
						inc ebx
						inc edi
						loop mvobjs
				  .ENDIF

				  ;fix pointers...
						;update the number-of-objects field in TERSEDATA...
						;xor ecx,ecx
						mov ecx,(TERSEDATA PTR [esi]).numrecords
						sub ecx,numobjectsprev
						inc ecx ;because of rec#0 v3.15
						mov (TERSEDATA PTR [esi]).numrecords,ecx
				  ;now need to scan thru the newly-added objects and offset all
				  ;OBJECT pointer fields, by amount nsizeobjectsold...
				  ;...no, because copy new records to rec#1 onwards. see below. v3.15
				  ;nsizeobjectsold =size previous database.
				  ;numobjectsprev  =# objects previous database.

;				  lea edi,(TERSEDATA PTR [esi]).OBJECTS
						mov edi,(TERSEDATA PTR [esi]).noffsetobjs
						add edi,esi ;pTERSEDATA ;starting address of OBJECTS.
				  mov ecx,(TERSEDATA PTR [esi]).numrecords
				  mov ebx,nsizeobjectsold
				  sub ebx,(TERSEDATA PTR [esi]).nsizeobject ;cos of rec#0. v3.15
				  neg ebx ;cos routine adds this value to pointers.
				  invoke updateobjptrs,edi,ecx,ebx,0
				  ;...edi->start of objects,
				  ; ecx=number of objects.
				  ; ebx=change added to pointers.


				  ;and resize database...
;				  lea eax,(TERSEDATA PTR [esi]).OBJECTS
						mov eax,(TERSEDATA PTR [esi]).noffsetobjs
						add eax,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add eax,nsizenew
				  add eax,(TERSEDATA PTR [esi]).nsizeobject ;cos of rec#0. v3.15
				  sub eax,pTERSEDATA	;total size TERSEDATA database.
				  mov g_ndatabasesize,eax
;				   invoke GlobalReAlloc, pTERSEDATA,eax,GMEM_MOVEABLE
  ;mov g_errorapi,0AD3h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,g_ndatabasesize,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
								;all absolute pointers are invalid...
								invoke zeroabsoluteptrs,1
;								 mov g_pmovingobject,0
;								 mov poldmovingobject,0
;								 mov g_pselectedobjnew,0
;								 mov g_pselectedobject,0
;								 mov g_perrorobject,0
;								 mov wipeoutsindex,0
;								 mov updatesindex,0
;								 mov highlightedindex,0
;										 push eax			  ;save previous value of state.
;										 mov al,g_nstate		  ;/
;										 mov g_nstateprev,al  ;/
;										 pop eax				  ;/
;								   mov g_nstate,0
;								   mov highlightedindexnewlist,0
;								   mov highlightedindexnewlist,0
				.IF eax==0
				  ;GlobalRealloc() fail...
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
				  invoke myalertbox,ADDR szer202,81Ch ;eax ;invoke myerrorhandler,202
				  jmp ferr								;error message and close file.
				.ELSE
				  mov pTERSEDATA,eax	;new pointer.
				.ENDIF

						;do an integrity check...
						invoke checkintegrity,1 ;=1, suppress all msgs.
						;...need this to fix .number field in elements.

						;calculate signature...
						invoke calcsig
						mov esi,pTERSEDATA
						mov (TERSEDATA PTR [esi]).nsignature,eax


no1:			mov eax,pTERSEDATA
				;invoke WriteFile, g_hfile,eax,g_ndatabasesize,ADDR nbyteswrote,0
				  invoke compress2file,g_hfile,pTERSEDATA,g_ndatabasesize
				  .IF eax==0
ferr:				;fail...
					invoke CloseHandle, g_hfile ;close file.
					jmp fer5						;error message.
				  .ENDIF
		  .ENDIF

		  invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
		  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
		  mov eax,0 	  ;succeeded.

eo1:
		;v1.26
		;restore cursor...
		push eax
  ;mov g_errorapi,0AD4h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax

		ret
selectedsaveasdatafile ENDP
;--------------------------------------------------------------------------
;.DATA
;;sztest1 BYTE "test1.wmf",0
;nsizecopy DWORD 0 ;v3.56
;pcopydbase DWORD 0 ;/
;szcopyerror BYTE "Database has changed at offset: "
;szcopyerror1 BYTE 64 DUP(0)

;.CODE
selectedsaveasemf PROC STDCALL USES ebx ecx edx esi edi,fwmf:DWORD
				LOCAL numobjectsprev:DWORD,nsizenew:DWORD,nobjshigh:DWORD
				LOCAL nsizeobjectsold:DWORD,pendprev:DWORD
				LOCAL hdc:DWORD
				LOCAL hbrushold:DWORD, hpencolor:DWORD
				LOCAL hbrushdefault:DWORD   ;, hpendefault:DWORD
				LOCAL hbrushnewcolor:DWORD
				LOCAL hbrusholdcolor:DWORD
				LOCAL edisave:DWORD,esisave:DWORD,ecxsave:DWORD
				LOCAL openemffile:OPENFILENAME
; "selectedsaveasemf"
;called via file/selected elements save as EMF..." > idm_saveass_emf
;adapted from saveasdatafile()/selectedsaveasdatafile().
;fwmf=0 save as EMF, =1 save as WMF.

										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				mov g_nstate,0
				mov g_pmovingobject,0
				mov g_pselectedobjnew,0

;v3.56 need to do this before calc the signature...
		  ;this scans current database and wipes out any bitmap handles and DCs...
		  ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
		  ;because when reload database it won't be valid...
		  invoke deletebitmaphandles	   ;(they are used for drawing bitmaps)
		  ;...also deletes library-data-element.ximage, bitmap "handles". v3.46
		
;*BUG?* WHEN MULTIPLE ELEMENTS HIGHLIGHTED, .fconfig3/bit7=1, SO DOESN'T THIS MESS
;UP THE SIG CALC????
;...i think ok if that bit stays set when do sig check below.
						;calculate signature...
						invoke calcsig
						mov esi,pTERSEDATA
						mov (TERSEDATA PTR [esi]).nsignature,eax

				.IF g_ndatabasesize==0
				  ;never come here, as wmcreate() sets up g_nfilesixe.
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
				  invoke myalertbox,ADDR szer211,81Dh ;eax ;invoke myerrorhandler,211
								invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
								mov g_fredrawdiag,ENTIRE				;redraw entire window.
				  ;mov eax,1
				  ret
				.ENDIF


				  ;first, copy default structure...
				  lea edi,openemffile
				  lea ebx,defaultemffile
				  mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo1
						;change some fields if saving as WMF...
						.IF fwmf==1
						  mov openemffile.on_lpstrFilter,OFFSET szwmffilter
						  mov openemffile.on_lpstrDefExt,OFFSET szwmfextension
						.ENDIF
						
						;v3.55..
						mov openemffile.on_Flags,OFN_OVERWRITEPROMPT OR OFN_HIDEREADONLY OR OFN_EXPLORER
						;...prompt if file already exists. (removed OFN_CREATEPROMPT OR)

				  ;do same for szemffile...
				  lea edi,szemffile
						.IF fwmf==1
						  lea ebx,szdefwmffile
						.ELSE
						  lea ebx,szdefemffile
						.ENDIF
				  mov ecx,sizeszfile
oo2:	  mov al,[ebx]
				  mov [edi],al
				  inc ebx
				  inc edi
				  dec ecx
				  jnz oo2
  ;mov g_errorapi,0AD5h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetSaveFileName, ADDR openemffile ;<<<DIALOG BOX
				.IF eax==0								;0=error/cancel
				  ;not necessarily an error here, but put up a msgbox...
				          ;v2.70
                  invoke CommDlgExtendedError
                  ;invoke bin2dec,10 ;returns eax->string in szasciitbl.
                  ;lea ecx,szer007
                  ;invoke lstrcpy,ecx,eax ;copy into 007 error message.
                  .IF eax==0 ;v2.99
                    mov eax,1
                  .ELSE
                    or eax,0C00h ;makes it treated as an error.
                  .ENDIF
				  invoke myalertbox,ADDR szerremf,eax ;1 ;invoke myerrorhandler,007
ferr2:
fe88:			  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
				  ret
				.ENDIF

;.......
;now copy all selected elements to end of database...

;v3.56 TEST...
;test completed, now comment this out...
;   mov esi,pTERSEDATA
;				  mov eax,(TERSEDATA PTR [esi]).numrecords
;				  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
;				  mul ecx
;					add eax,(TERSEDATA PTR [esi]).noffsetobjs
;					mov nsizecopy,eax
;					;eax=size of database.
;					invoke GlobalAlloc,GMEM_FIXED,eax
;					mov pcopydbase,eax
;					mov ebx,eax
;					mov ecx,nsizecopy
;nxc1:			mov al,[esi]
;					mov [ebx],al
;					inc esi
;					inc ebx
;					loop nxc1
;...


		;v1.26
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,NULL ;g_hbusycursor
		invoke SetCursor,g_hbusycursor
		;...crosshair cursor didn't need this func. need it here to cause immediate change.

				  ;only save selected elements...
				  mov eax,highlightedlist  ;1st highlighted element
				  invoke repositioncursor,eax ;move mouse to 1st highlighted element.
				  invoke duplicatehighlighted,0 ;copy duplicate elements to end dbase.
				   ;...exit from this routine with highlightednewlist pointing to
				   ;   all of the duplicated elements.
				   ;   their coords track the mouse until a left-click.
				   ; returns eax=previous # objects in database. =0 if error.
				   mov numobjectsprev,eax
				   .IF eax==0
				     jmp eo1 ;get out.
				   .ENDIF

				  mov esi,pTERSEDATA
				  ;xor ecx,ecx
				  mov eax,numobjectsprev
				  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
				  mul ecx
				  mov nsizeobjectsold,eax				;size of prev OBJECTS dbase.
;				  lea ebx,(TERSEDATA PTR [esi]).OBJECTS
						mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
						add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add ebx,eax	;actual end addr of previous database.
				  mov pendprev,ebx

				  mov eax,(TERSEDATA PTR [esi]).numrecords
				  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
				  mul ecx
;				  lea ebx,(TERSEDATA PTR [esi]).OBJECTS
						mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
						add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add ebx,eax	;actual end.
				  sub ebx,pendprev ;size highlighted objs.
				  xor edx,edx
				  mov eax,ebx
				  div ecx ;# highlighted elements. v1.37
				  mov nobjshigh,eax


;do stuff prior to drawing metafile...
				  mov g_fredrawdiag,ENTIRE				;draw all.
				  mov hbrushold,0
				  mov hbrushdefault,0
				  mov hbrushnewcolor,0
				  mov hbrusholdcolor,0
				  mov hpencolor,0
;				  mov hpendefault,0
				  ;let's also create a grey pen...
				  invoke CreatePen, PS_SOLID,0,0C0C0C0h ;want 1-wide,grey.
				  mov g_hpengrey,eax
				  ;(no need for grey dashed line, as in wmpaint()).
				  ;and a global font...
				  mov eax,12
				  neg eax
				  invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,0,ADDR szarialbold
				  mov  g_hfontx1,eax			;11-point Arial Bold.
				  ;default colour for filling polygons....
						invoke GetStockObject, NULL_BRUSH
						mov hbrushdefault,eax
				  mov updatesindex,0
				  mov wipeoutsindex,0


				;need to create a DC for an EMF...
				.IF fwmf==1
				  lea eax,szemffile 					 ;addr of complete filespec.
				  xor ecx,ecx
				  mov cx,openemffile.on_nFileOffset ;point to filename.
				  ;...because createmetafile can't handle a path.
				  add eax,ecx
				  invoke CreateMetaFileA,eax ;ADDR szemffile
				.ELSE
				  invoke CreateEnhMetaFileA, 0,ADDR szemffile,0,0
				.ENDIF
				.IF eax==0
				  mov szemffile,0
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
				  invoke myalertbox,ADDR szer213,81Eh ;eax ;invoke myerrorhandler,213
				  invoke InvalidateRgn, g_hwnd,0,FALSE ;don't redraw background.
				  mov g_fredrawdiag,ENTIRE				  ;redraw entire window.
				  ;ret
				  jmp b77x
				.ELSE
				  mov hdc,eax

;				   ;make WinNT compatible...
;				   invoke GetGraphicsMode,eax
;				   .IF eax==GM_COMPATIBLE
;				   .ELSE
;						 invoke SetGraphicsMode,hdc,GM_COMPATIBLE
;				   .ENDIF

;*NO* not recommended to set mode inside metafile... but, i saw it done in some example code
				  ;it may be that metafiles have to be in this mode...
;				   invoke SetMapMode, hdc,MM_ANISOTROPIC

				  ;*NOTE* inside a metafile dc, SelectObject() doesn't return old handle.
				  ;don't save return value, no need to restore hbrushold later...
;done below...
;				   invoke SelectObject, hdc,hbrushdefault
				  ;mov hbrushold,eax

				  invoke SetBkMode, hdc,TRANSPARENT   ;leave background showing.

				  mov edi,pTERSEDATA
				  mov esi,pendprev ;end prev objects.
				  mov ecx,nobjshigh ;# highlighted elements.
				  .IF cx==0 ;empty database.
						jmp nextobjy
				  .ENDIF
				  ;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				  mov esisave,esi
				  mov edisave,edi
				  mov ecxsave,ecx
				  ;xor eax,eax
				  mov eax,(OBJECT PTR [esi]).fstatus
				  and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF SWORD PTR ax<0 ;ax==-1
						.ELSE							;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).
			   ;(...so, the 16-bit lower half also -ve).

								  ;if outputing to wmf, cannot have any bezier curves...
								  .IF fwmf==1
										.IF ax==11 ;bezier curved line.
										  mov (OBJECT PTR [esi]).nexttype,12 ;segmented line.
										  ;...changes actual diagram! ...but, shouldn't upset
										  ;signature, as these are the elements appended
										  ;temporarily onto end of database.
										.ENDIF
								  .ENDIF

										;mov hpendefault,0

										;chose a new brush, maybe...
										;(is already a null brush created start this func)
										;mov hbrushnewcolor,0
										mov ebx,(OBJECT PTR [esi]).nfillcolor
										mov eax,(OBJECT PTR [esi]).nfillstyle
										.IF eax==0				   ;no fill
										  ;jmp e300
										  mov eax,hbrushdefault ;null brush.
										.ELSEIF eax==1	   ;solid
e301:							  invoke CreateSolidBrush, ebx
										.ELSE							;hatch fill.
										  .IF eax==2
												mov eax,HS_BDIAGONAL
										  .ELSEIF eax==3
												mov eax,HS_CROSS
										  .ELSEIF eax==4
												mov eax,HS_DIAGCROSS
										  .ELSEIF eax==5
												mov eax,HS_FDIAGONAL
										  .ELSEIF eax==6
												mov eax,HS_HORIZONTAL
										  .ELSEIF eax==7
												mov eax,HS_VERTICAL
										  .ELSE
												jmp e301
										  .ENDIF
										  invoke CreateHatchBrush,eax,ebx
										.ENDIF
										mov hbrushnewcolor,eax
										invoke SelectObject, hdc,hbrushnewcolor
										;*NOTE* see note above. doesn't return old handle.
										;windows will delete all brushes when finished playing the metafile...
										;mov hbrusholdcolor,eax
;e300:

								;create a pen...
								mov eax,(OBJECT PTR [esi]).npenstyle
								.IF eax==0				;solid pen.
								  mov eax,PS_SOLID
								.ELSEIF eax==1	;invisible.
								  mov eax,PS_NULL
								.ELSEIF eax==2	;dashes.
								  mov eax,PS_DASH
								.ELSEIF eax==3	;dots.
								  mov eax,PS_DOT
								.ELSEIF eax==4			;v1.30.
								  mov eax,PS_DASHDOT	;/
								.ELSEIF eax==5			;/
								  mov eax,PS_DASHDOTDOT ;/
								.ELSE
								  mov eax,PS_SOLID
								.ENDIF
								mov ebx,(OBJECT PTR [esi]).npenwidth
								mov ecx,(OBJECT PTR [esi]).npencolor
								invoke CreatePen, eax,ebx,ecx
								mov hpencolor,eax
								invoke SelectObject,hdc,eax
								;*NO* see note above...
								;mov hpendefault,eax
								mov g_hpendefault,eax ;i am happier having a valid value in here! v3.31
                ;...this pen only used by handles, but let's play safe.

								  ;finally, call the method to display object...
								  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  invoke displayPTR PTR [ebx+ptrs+pdisplay], hdc,esi

								;invoke SelectObject, hdc,hpendefault
								;invoke DeleteObject, hpencolor
								;.IF hbrushnewcolor==0
								;.ELSE
								;		 invoke SelectObject, hdc,hbrusholdcolor
								;		 invoke DeleteObject, hbrushnewcolor
								;.ENDIF

						.ENDIF
				  .ENDIF
				  mov ecx,ecxsave
				  mov edi,edisave
				  mov esi,esisave
				  ;xor eax,eax
				  mov eax,(TERSEDATA PTR [edi]).nsizeobject
				  add esi,eax					;addr of next object.
				  loop nextobjx
				  jmp  SHORT nextobjy
nextobjx: jmp nextobj
nextobjy:

				  ;*NO* see note above...
				  ;invoke SelectObject, hdc, hbrushold	 ;restore old brush.


				  .IF fwmf==1
						invoke CloseMetaFile,hdc
						invoke DeleteMetaFile,eax
				  .ELSE
						invoke CloseEnhMetaFile,hdc
						;...dunno why, but need this to actually write the file to disk.
						invoke DeleteEnhMetaFile,eax ;has no effect on the actual file.
				  .ENDIF
				.ENDIF

; invoke MessageBeep,MB_ICONEXCLAMATION
 
b77x:
;cleanup after drawing metafile...
				;delete the fonts created at start of this section...
				invoke DeleteObject,g_hpengrey
				mov g_hpengrey,0
				;delete global font...
				invoke DeleteObject,g_hfontx1
				mov g_hfontx1,0
				;delete the null brush...
				invoke DeleteObject, hbrushdefault



b77:
;and resize database...
;(duplicatehighlighted() made it bigger, so restore)...
				  ;(this wipes out the new elements).
				   mov esi,pTERSEDATA
				   mov eax,numobjectsprev
				   mov (TERSEDATA PTR [esi]).numrecords,eax
;				  lea eax,(TERSEDATA PTR [esi]).OBJECTS
						mov eax,(TERSEDATA PTR [esi]).noffsetobjs
						add eax,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add eax,nsizeobjectsold
				  sub eax,pTERSEDATA	;total size TERSEDATA database.
				  mov g_ndatabasesize,eax
;				   invoke GlobalReAlloc, pTERSEDATA,eax,GMEM_MOVEABLE
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,g_ndatabasesize,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
							   ;all absolute pointers are invalid...
							   invoke zeroabsoluteptrs,1
;								mov g_pmovingobject,0
;								mov poldmovingobject,0
;								mov g_pselectedobjnew,0
;								mov g_pselectedobject,0
;								mov g_perrorobject,0
;								mov wipeoutsindex,0
;								mov updatesindex,0
;								mov highlightedindex,0
;										 push eax			  ;save previous value of state.
;										 mov al,g_nstate		  ;/
;										 mov g_nstateprev,al  ;/
;										 pop eax						  ;/
;								mov g_nstate,0
;								mov highlightedindexnewlist,0
;								mov highlightedindexnewlist,0
				.IF eax==0
				  ;GlobalRealloc() fail...
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
				  invoke myalertbox,ADDR szer202,81Fh ;eax ;invoke myerrorhandler,202
				  jmp ferx								;error message and close file.
				.ELSE
				  mov pTERSEDATA,eax	;new pointer.
				.ENDIF

;v3.56 TEST....
;compare blocks... test completed, now comment this out...
;  mov esi,pTERSEDATA
;  mov ebx,pcopydbase ;copy of orig dbase.
;  mov ecx,nsizecopy
;nxc2:
;  mov al,[esi]
;  mov dl,[ebx]
;    .IF al != dl
;      ;difference found...
;      mov eax,esi
;      sub eax,pTERSEDATA
;	    invoke bin2dec,10 ;ret eax->szasciitbl.
;	    invoke lstrcpy,ADDR szcopyerror1,eax
;      invoke MessageBox,g_hwnd,ADDR szcopyerror,0,MB_OK+MB_ICONEXCLAMATION
;      jmp exit1
;    .ENDIF
;  inc esi
;  inc ebx
;  loop nxc2
;nxc3:
;...the bug I have found, is signature test below fails because the .ximage field
;of image dataelement is changed.


;we copied the selected elements to end of database, wrote them to
;emf disk file, then resized the database back to previous, thus
;wiping out the duplicates. messy, so check that signature still
;computes the same...

;v3.56 need to do this before calc the signature...
		  ;this scans current database and wipes out any bitmap handles and DCs...
		  ;embedded gif 1stdataelement.ximage =hDCBitmap -- must make this zero
		  ;because when reload database it won't be valid...
		  invoke deletebitmaphandles	   ;(they are used for drawing bitmaps)
		  ;...also deletes library-data-element.ximage, bitmap "handles". v3.46
		
						;calculate signature...
						invoke calcsig
						mov esi,pTERSEDATA
						mov ecx,(TERSEDATA PTR [esi]).nsignature
						.IF eax==ecx	;ok.
						.ELSE
						  mov (TERSEDATA PTR [esi]).nsignature,eax
						  .IF szemffile==0 ;nothing in it, so no file saved.
							invoke myalertbox,ADDR szer225,820h ;eax ;invoke myerrorhandler,225
						  .ELSE
ferx:
						invoke myalertbox,ADDR szer214,821h ;eax ;invoke myerrorhandler,214
						  .ENDIF
						.ENDIF

;v3.56
;a bug, custom shapes menu-bitmaps were getting corrupted. i think we need
;to rebuild the entire menu here...
;the database may contain composite-object library members. need to
;load them into the Elements menu...
				invoke addcomposites2menu,0

		invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
		mov g_fredrawdiag,ENTIRE				;redraw entire window.
		mov eax,0		;succeeded. not used.

exit1:
		;v1.26
		;restore cursor...
		push eax
		invoke SetClassLongA,g_hwnd,GCL_HCURSOR,g_hnormcursor
		pop eax
eo1:
		ret
selectedsaveasemf ENDP
;--------------------------------------------------------------------------
paint_axes PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
;				 LOCAL xend:SDWORD, yend:SDWORD
				LOCAL state:BYTE, exttype:DWORD,chandle:DWORD,f2nd:BYTE
;this is a method, to display alignment axes.		"paint_axes" v1.97.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF


		  mov esi,pobject
		  mov eax,(OBJECT PTR [esi]).nexttype
		  mov exttype,eax

;paint the axes...
				;horiz axis...
				mov eax,(OBJECT PTR [esi]).xtopleft
				add eax,3 ;xmid.
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add ebx,3 ;ymid.
				sub eax,400
				push eax
				push ebx
				invoke MoveToEx,hdc,eax,ebx,0
				pop ebx
				pop eax
				add eax,800
				invoke LineTo,hdc,eax,ebx
				;vert axis...
				mov eax,(OBJECT PTR [esi]).xtopleft
				add eax,3 ;xmid.
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add ebx,3 ;ymid.
				sub ebx,400
				push eax
				push ebx
				invoke MoveToEx,hdc,eax,ebx,0
				pop ebx
				pop eax
				add ebx,800
				invoke LineTo,hdc,eax,ebx
;paint middle handle of axes... and make sure size remains constant...
						  mov eax,(OBJECT PTR [esi]).bez0x ;xtopleft
						  mov ebx,(OBJECT PTR [esi]).bez0y ;ytopleft
						  mov ecx,eax
						  mov edx,ebx
						  add ecx,3
						  mov (OBJECT PTR [esi]).xmid,ecx
						  add ecx,3
						  add edx,3
						  mov (OBJECT PTR [esi]).ymid,edx
						  add edx,3
						  invoke Ellipse, hdc,eax,ebx,ecx,edx
						  mov (OBJECT PTR [esi]).wwidth,6
						  mov (OBJECT PTR [esi]).height,6

;also need to paint stretching-handles if doing wipeout, as wmmousemove/state8
;calls UpdateWindow() with g_nknee=0 (saved and restored) so won't wipe them below...
;i've added special detection below.

		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp fhidehighlighting,1
		je m90
;when an object is highlighted, need to draw it black...
hidres:
				mov esi,pobject
				cmp g_perrorobject,esi
				je	oo1
;also have multiple highlighted objects...
				  mov eax,(OBJECT PTR [esi]).fconfig2
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:			  mov g_perrorobject,0	;only do this once.
oo1b:
						mov eax,(OBJECT PTR [esi]).xtopleft
						mov ebx,(OBJECT PTR [esi]).ytopleft
						mov ecx,eax ;xright
						add ecx,6
						mov edx,ebx ;ybottom
						add edx,6
  ;mov g_errorapi,0AD6h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateEllipticRgn, eax,ebx,ecx,edx		;-->eax=hrgn
				  push eax
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:


		cmp fprinting,2 ;metafile o/p. ;maybe not needed here.
		je m91 ;bypass this section.
		cmp fhidehandles,1
		je m91
;now draw handles, if element highlighted...
;v1.97 a problem is, stretching handles can be in two possible locations when in state8
;-- moving entire element, or dragging a stretching-handle. when wiping, need to wipe both
;positions...
  mov f2nd,0
  .IF  g_fredrawdiag==WIPEOUTobjs
		jmp SHORT E1
  .ELSEIF g_nstate==8
		.IF esi==g_pmovingobject
		  .IF g_nstateprev==2
				;if currently moving an object (and we will be in state8, so above double
				;-check is a precaution) and if came from state2 (highlighted object), then
				;am enabling dragging of individual handles...
				jmp SHORT E1
		  .ENDIF
		.ENDIF
  .ELSEIF g_pselectedobject==esi
E1:
		;invoke SelectObject,hdc,g_hbrushred   ;note, it is white if wipeout.
		;mov hbrushold,eax
		  ;put handles on right and bottom...
			;a short vertical line...
			.IF g_nknee==1 ;dragging right handle.
			  mov eax,g_nmousex
			.ELSEIF f2nd==1
			  jmp SHORT saz1
			.ELSEIF g_fredrawdiag==WIPEOUTobjs ;fixes wipeout problem.
				mov eax,g_nmousex
				sub eax,deltax ;diff between previous mousex.
			.ELSE
saz1:		  mov eax,(OBJECT PTR [esi]).xmid
			  add eax,102
			.ENDIF
			mov chandle,eax
			mov ebx,(OBJECT PTR [esi]).ymid
			sub ebx,30
			push eax
			push ebx
			invoke MoveToEx,hdc,eax,ebx,0
			pop ebx
			pop eax
			add ebx,60
			invoke LineTo,hdc,eax,ebx
			
		  ;horiz-axis handle...
		  mov eax,chandle
		  ;sub eax,2
		  ;mov ecx,eax
		  ;add ecx,4
		  mov ebx,(OBJECT PTR [esi]).ymid
		  ;mov edx,ebx
		  ;sub ebx,2
		  ;add edx,2
		  ;invoke Ellipse,hdc,eax,ebx,ecx,edx ;right.
		  invoke painthandle,hdc,eax,ebx,1 ;1=red fill v3.31
		  
			;a short horizontal line...
			.IF g_nknee==2 ;dragging bottom handle.
			  mov eax,g_nmousey
			.ELSEIF f2nd==1
			  jmp SHORT saz2
			.ELSEIF g_fredrawdiag==WIPEOUTobjs ;fixes wipeout problem.
				mov eax,g_nmousey
				sub eax,deltay ;diff between previous mousey.
			.ELSE
saz2:		  mov eax,(OBJECT PTR [esi]).ymid
			  add eax,102
			.ENDIF
			mov chandle,eax			
			mov ebx,(OBJECT PTR [esi]).xmid
			sub ebx,30
			push eax
			push ebx
			invoke MoveToEx,hdc,ebx,eax,0
			pop ebx
			pop eax
			add ebx,60
			invoke LineTo,hdc,ebx,eax
			
		  ;vertical-axis handle...
		  mov eax,chandle
		  ;mov ecx,eax
		  ;add ecx,4
		  mov ebx,(OBJECT PTR [esi]).xmid
		  ;mov edx,ebx
		  ;sub ebx,2
		  ;add edx,2
		  ;invoke Ellipse,hdc,ebx,eax,edx,ecx ;right.
		  invoke painthandle,hdc,ebx,eax,1 ;1=red fill v3.31

		;invoke SelectObject,hdc,hbrushold

	;now for the problem of two locations for strewtching handles...
	.IF f2nd==1
	.ELSEIF g_fredrawdiag==WIPEOUTobjs ;fixes wipeout problem.
	  mov f2nd,1
	  jmp E1
	.ENDIF

  .ENDIF
m91:

		ret
;.................

paint_axes ENDP
;--------------------------------------------------------------------------
;.DATA
;warray DWORD 40 DUP(0) ;address of source of point in element.
;;...global array of absolute ptrs, so be careful, use immediately.
;rarray DWORD 40 DUP(0) ;address of reference bez vertice. MUST BE IMMEDIATELY after warray.
;;...global array of absolute ptrs, so be careful, use immediately.

;.CODE
combinepolyarrays PROC STDCALL
	LOCAL dummy:DWORD
	;LOCAL xvertice:SDWORD,yvertice:SDWORD
	;LOCAL psourceref:DWORD,psource:DWORD
;v2.03 "combinepolyarrays"
;uses all regs from caller. esi->element.
;enter with esi->polygon element, edx=address varray (varray[84]:SDWORD).

	push esi
	push edi
	mov edi,esi

				lea ebx,(OBJECT PTR [edi]).bez0x
				mov esi,edx
				mov ecx,NCORNERSMAX14*2 ;old polys have 14 vertices max.
g11:			mov eax,[ebx]
				mov [esi],eax
				add ebx,4
				add esi,4
				loop g11

		mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		.IF eax==0 ;no more vertices.
		.ELSE
		  mov ebx,eax
		  add ebx,pTERSEDATA
		  lea eax,(OBJECT PTR [ebx]).sztext
		  mov ebx,eax
		  mov ecx,28*2 ;28 extra vertices in the data-element.
xg11:			  mov eax,[ebx]
				  ;vertices are stored relative to bez0x/y...
				  mov dl,cl
				  and dl,01 ;test bit0.
				  .IF dl==0
					add eax,(OBJECT PTR [edi]).bez0x
				  .ELSE
					add eax,(OBJECT PTR [edi]).bez0y
				  .ENDIF
				mov [esi],eax
				add ebx,4
				add esi,4
				loop xg11
		.ENDIF

	pop edi
	pop esi
	ret
combinepolyarrays ENDP
;--------------------------------------------------------------------------
;v3.44...
visibilitytoggle_paint PROC STDCALL
;called from paint_() methods.
;enter esi->element.
;return eax=0 if element in visibility-toggle mode, else 1.

;v3.19 changed, include locked child visibility toggle...
;v2.73 want to invert if a locked child of a flashing animated element
            mov ebx,esi
nxtup:      mov eax,(OBJECT PTR [ebx]).fconfig4
            and al,01000b ;bit3=1 locked.
            .IF al != 0
              mov eax,(OBJECT PTR [ebx]).rpowner1
              .IF eax != 0
                add eax,pTERSEDATA
                mov ebx,eax
                jmp nxtup
              .ENDIF
            .ENDIF
            ;drop here with ebx->top element in comp.obj.
            .IF ebx != esi ;if equal, do normal code below.
              ;esi must be a locked child of ebx. see if ebx is animated... v2.81
				      mov eax,(OBJECT PTR [ebx]).fconfig2
              mov ecx,eax  ;v3.19
              and ecx,2000h ;bit13, control child visibility.
              .IF ecx != 0
inv5:                 and ax,4200h ;test bit9 (flashing) and bit14 (child persist). ;0200h ;bit9 =1 invert child colors.
                      .IF ax==0
inv2:                   test (OBJECT PTR [esi]).fconfig2,8000h ;bit15. temp flag.
                        jz noto1
                        xor (OBJECT PTR [esi]).fstatus,400h ;bit10. restore visibility.
                        xor (OBJECT PTR [esi]).fconfig2,8000h ;clr bit15.
noto1:                  ;bypass if visibility not toggled.
                      .ELSE
inv1:                   .IF ecx != 0 ;toggle display visibility.
                          test (OBJECT PTR [esi]).fconfig2,8000h ;bit15. temp flag.
                          jnz noto3
                          xor (OBJECT PTR [esi]).fstatus,400h ;toggle bit10.
                          or (OBJECT PTR [esi]).fconfig2,8000h ;set bit15.
noto3:                    ;...record that label visibility in toggled state.
                        .ENDIF
                      .ENDIF
                xor eax,eax
              .ELSE
                  ;there is a little hiccup, visibility not restoring. this is because
                  ;xtimer() is clrg bit13 on completion of loop (as well as 9 and 14).
                  ;...it doesn't really have to, but let's fix it here, check bit15...
                  test (OBJECT PTR [esi]).fconfig2,8000h ;bit15. temp flag.
                  jnz inv5 ;don't do color flashing. careful, need eax.
                mov eax,1
              .ENDIF
            .ELSE ;esi=ebx so is not child.
              mov eax,1
            .ENDIF

    ret
visibilitytoggle_paint ENDP
;--------------------------------------------------------------------------
;v3.44...
colortoggle_paint PROC STDCALL,fwhich:DWORD
;called from paint_() methods.
;enter esi->element.
;fwhich=0 toggle invert, done after exit, eax=0 invert, eax=1 no invert.
;fwhich=1 toggle pen color.
;fwhich=2 toggle font color.

;v3.19 changed, include locked child visibility toggle...
;v2.73 want to invert if a locked child of a flashing animated element
            mov ebx,esi
znxtup:     mov eax,(OBJECT PTR [ebx]).fconfig4
            and al,01000b ;bit3=1 locked.
            .IF al != 0
              mov eax,(OBJECT PTR [ebx]).rpowner1
              .IF eax != 0
                add eax,pTERSEDATA
                mov ebx,eax
                jmp znxtup
              .ENDIF
            .ENDIF
            ;drop here with ebx->top element in comp.obj.
          .IF fwhich==2 ;toggle font color.
                      .IF ebx != esi ;if equal, do normal code below.
                        ;esi is a locked child attached to ebx. find out is ebx
                        ;is animated...
                        mov eax,(OBJECT PTR [ebx]).fconfig2
                        and eax,4200h ;test bit9 (invert) or bit14 (persist). v2.81
                        jnz zinv1   ;either bit=1, invert.
                        jmp SHORT zinv2
                      .ENDIF
                      ;v2.72 for other paint_() methods, check .fconfig2/bit9=1, flashing
                      ;animation, then jump to invertregion(). however for label, just
                      ;want to flash the .nfontcolor... note, bit9=1 color inverted, =0 normal.
                      ;test if current element esi has animator directly attached...
                      mov eax,(OBJECT PTR [esi]).fconfig2
                      and ax,0200h ;bit9
                      .IF ax==0
zinv2:                   mov eax,(OBJECT PTR [esi]).nfontcolor
                        .IF SDWORD PTR eax<0 ;toggled color is -ve.
                          not eax
                          mov (OBJECT PTR [esi]).nfontcolor,eax ;restore correct color.
                        .ENDIF
                      .ELSE
zinv1:                   ;not (OBJECT PTR [esi]).nfontcolor ;toggle color.
                        mov eax,(OBJECT PTR [esi]).nfontcolor ;v2.75
                        .IF SDWORD PTR eax>=0 ;color is +ve.
                          not eax
                          mov (OBJECT PTR [esi]).nfontcolor,eax ;invert color.
                        .ENDIF
                      .ENDIF										
          .ELSE
            .IF ebx != esi ;if equal, do normal code below.
              ;esi must be a locked child of ebx. see if ebx is animated... v2.81
				      mov eax,(OBJECT PTR [ebx]).fconfig2
              mov ecx,eax  ;v3.19
              and ecx,2000h ;bit13, control child visibility.
              .IF ecx != 0
zinv5:           ;vis toggle removed.
              .ELSE
                .IF fwhich==0   ;toggle invert, after exit.
                  ;there is a little hiccup, visibility not restoring. this is because
                  ;xtimer() is clrg bit13 on completion of loop (as well as 9 and 14).
                  ;...it doesn't really have to, but let's fix it here, check bit15...
                  test (OBJECT PTR [esi]).fconfig2,8000h ;bit15. temp flag.
                  jnz zinv5 ;don't do color flashing. careful, need eax.
                  ;have bit14=1 overrides bit9. used for keeping child
                  ;inverted for entire duration...
                  ;(child reads these bits in boss, ebx)
                  mov eax,(OBJECT PTR [ebx]).fconfig2
                  and eax,4200h ;test bit9 (flashing) and bit14 (persist).
                  jnz oo1b   ;either set, invert.
                .ELSEIF fwhich==1 ;toggle pen color.
;                  ;there is a little hiccup, visibility not restoring. this is because
;                  ;xtimer() is clrg bit13 on completion of loop (as well as 9 and 14).
;                  ;...it doesn't really have to, but let's fix it here, check bit15...
;                  test (OBJECT PTR [esi]).fconfig2,8000h ;bit15. temp flag.
;                  jnz inv5 ;don't do color flashing. careful, need eax.
                  ;have bit14=1 overrides bit9. used for keeping child
                  ;inverted for entire duration...
                  ;(child reads these bits in boss, ebx)
                  mov eax,(OBJECT PTR [ebx]).fconfig2
                  and eax,4200h ;test bit9 (flashing) and bit14 (persist).
                  .IF eax != 0   ;either set, invert.
inv6:               mov eax,(OBJECT PTR [esi]).npencolor
                    .IF SDWORD PTR eax>0
                      neg eax   ;-ve, color is inverted.
                      mov (OBJECT PTR [esi]).npencolor,eax
                    .ELSEIF eax==0 ;black.
                      mov (OBJECT PTR [esi]).npencolor,-1
                    .ENDIF
                  .ELSE  ;restore pen color.
inv7:               mov eax,(OBJECT PTR [esi]).npencolor
                    .IF eax==-1
                      mov (OBJECT PTR [esi]).npencolor,0
                    .ELSEIF SDWORD PTR eax<0
                      neg eax
                      mov (OBJECT PTR [esi]).npencolor,eax
                    .ENDIF
                  .ENDIF
                .ENDIF
              .ENDIF
            .ELSE ;esi=ebx so is not child.
              .IF fwhich==0
                mov eax,(OBJECT PTR [ebx]).fconfig2
                and eax,200h ;test bit9 (flashing).
                jnz oo1b   ;bit9 set, invert.
              .ELSEIF fwhich==1
                mov eax,(OBJECT PTR [ebx]).fconfig2
                and eax,200h ;test bit9 (flashing).
                jnz inv6   ;bit9 set, invert.
                jmp inv7
              .ENDIF
            .ENDIF
          .ENDIF
    mov eax,1
out1:
    ret
oo1b: xor eax,eax ;invert flag.
      jmp out1
colortoggle_paint ENDP
;--------------------------------------------------------------------------
paint_node PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL ringwidth:DWORD
				LOCAL xright:DWORD
				LOCAL ybottom:DWORD
				LOCAL xend:SDWORD, yend:SDWORD
				LOCAL plock:DWORD
				LOCAL xend1:SDWORD, yend1:SDWORD
				LOCAL exttype:DWORD
				LOCAL holdfont:DWORD
				LOCAL hpensaved:DWORD,hpenold2:DWORD
				LOCAL x1:SDWORD,y1:SDWORD,x2:SDWORD,y2:SDWORD,ring:DWORD
;				LOCAL hbrusholdcolor:DWORD,hbrushnewcolor:DWORD
				LOCAL xmid2:SDWORD,ymid2:SDWORD
				LOCAL hbrushold:DWORD,ponelement:DWORD
				LOCAL varray[84]:SDWORD
				LOCAL nhandle:DWORD,xdispl:DWORD,ydispl:DWORD ;v3.32
				LOCAL eaxsave:DWORD ;v3.42
				LOCAL state:BYTE,ringstmp:BYTE
				LOCAL ncolorindex:BYTE,ellipsetype:BYTE
				LOCAL fmode:BYTE
;this is a method, to display nodes.	   "paint_node"
; *EVE* -- ellipses, rectangles,
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF

		mov esi,pobject

				mov eax,(OBJECT PTR [esi]).wwidth
		  add eax,(OBJECT PTR [esi]).xtopleft
				mov xright,eax
		  mov ebx,(OBJECT PTR [esi]).height
		  add ebx,(OBJECT PTR [esi]).ytopleft
				mov ybottom,ebx
				mov eax,(OBJECT PTR [esi]).nexttype
				mov exttype,eax

        ;had to move this up here... v3.31
        .IF exttype==0 ;ellipse/partial-ellipse.
                 ;v2.96 now have ellipse, pie, chord, arc...
                 mov eax,(OBJECT PTR [esi]).fconfig1
                 and al,110000b ;bits 5/4.
                 mov ellipsetype,al
        .ENDIF
        
;v3.19 copied this code up from below, cut out colr-toggle, leave visibility-toggle...
;sequence for this func now: toggle-visibility>paint-element>toggle-color>invertrgn.
        invoke visibilitytoggle_paint ;v3.44
        

		.IF exttype==5	;polygon
		  lea edx,varray ;needed in... registers eax, esi used in...
		  invoke combinepolyarrays ;uses edx,esi.
		  
      ;now using bit10=1 invisible... v3.19
			.IF g_fredrawdiag != WIPEOUTobjs
        mov eax,(OBJECT PTR [esi]).fstatus
        and eax,400h ;bit10.
        .IF eax != 0 ;bit10=1 invisible.
          jmp vis1 ;bypass painting element.
        .ENDIF
      .ENDIF
      
		  mov eax,(OBJECT PTR [esi]).ncorners
		  lea ebx,varray ;used below.

      ;NOT YET... NEEDS EXTENSIVE MODS TO paintgradientrect(). FUTURE!
      ;mov eax,(OBJECT PTR [esi]).morphingwidth ;v3.41
      ;.IF eax != 0
			;	.IF g_fredrawdiag==WIPEOUTobjs
			;	.ELSE
			;	  ;ebx->varray, esi->element.
			;	  mov edi,ebx
      ;    invoke paintgradientrect,hdc,0,0,0,0 ;
      ;    ;...calcs mid-pt of bounding rect, draws multiple polys, toward mid-pt.
      ;    jmp saw2
      ;  .ENDIF
      ;.ENDIF
      
		  mov ecx,(OBJECT PTR [esi]).fconfig4
		  and cl,011b
		  .IF cl==0 ;closed polygon.
        ;mov g_errorapi,0AD7h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke Polygon,hdc,ebx,eax
		  .ELSEIF cl==011b ;bit1/0=11b bezier polyline.
			  ;v2.03 # vertices must be 4,7,10, or 13...
			  xor edx,edx
			  .IF eax<4
				mov eax,4 ;min #vertices.
				mov (OBJECT PTR [esi]).ncorners,eax
			  .ENDIF
			  dec eax ;(n-1)/3 must have no remainder.
			  mov ecx,3
			  div ecx
			  mov eax,(OBJECT PTR [esi]).ncorners
			  .IF edx != 0 ;remainder.
				sub eax,edx
			  .ENDIF
        ;mov g_errorapi,0AD8h ;for crash outside EVE, error codes range Axxh. v3.23
			  invoke PolyBezier,hdc,ebx,eax
			  jmp SHORT saw1 ;v2.03.
		  .ELSE 	 ;bit0=1 polyline.
        ;mov g_errorapi,0AD9h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke Polyline,hdc,ebx,eax
saw1:
					;if previously highlighted, wipeout inverted region
						;of open-polyline...
						.IF g_fredrawdiag==WIPEOUTobjs
		          mov eax,(OBJECT PTR [esi]).ncorners
		          lea ebx,varray
              ;mov g_errorapi,0ADAh ;for crash outside EVE, error codes range Axxh. v3.23
				      invoke Polygon,hdc,ebx,eax
						.ENDIF
saw2:  ;bypass.
		  .ENDIF
		.ELSE  ;not a polygon.
		
      ;now using bit10=1 invisible... v3.19
			.IF g_fredrawdiag != WIPEOUTobjs
        mov eax,(OBJECT PTR [esi]).fstatus
        and eax,400h ;bit10.
        .IF eax != 0 ;bit10=1 invisible.
          jmp vis1 ;bypass painting element.
        .ENDIF
      .ENDIF
      
		  ;draw each ring, maybe non-concentric....
						mov ecx,(OBJECT PTR [esi]).nrings
						mov ring,ecx

						  ;may upset arrow snapping, which relies on x/y radius for calcs...
						  ;(so width/height has to be an even number)...
						  ;but, may need width/height to paint exactly sometimes...
						  ;we'll only do this if has only 1 ring...
						  .IF ecx==1 ;only 1 ring.
							  mov ringwidth,0 ;not needed.
							  mov eax,(OBJECT PTR [esi]).fconfig4
							  test al,010000b ;bit4=1 exact width/height.
							  jz ex00
								mov eax,(OBJECT PTR [esi]).xtopleft
								mov x1,eax
								add eax,(OBJECT PTR [esi]).wwidth
								mov x2,eax ;note, already calc'd xright above.
								mov eax,(OBJECT PTR [esi]).ytopleft
								mov y1,eax
								add eax,(OBJECT PTR [esi]).height
								mov y2,eax ;note, already calc'd ybottom above.
								jmp x09
						  .ENDIF
ex00:

vzxiter1:								  ;loop here to draw each ring.
						mov ecx,ring
						dec ecx
						mov eax,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
						mul ecx
						mov ringwidth,eax ;total width, from ring1.
						  mov ecx,(OBJECT PTR [esi]).wwidth
						  shr ecx,1
						  add ecx,ringwidth  ;total x-radius from centre of ring.
						   mov eax,(OBJECT PTR [esi]).xdeltacentre
						   mov edx,ring
						   dec edx
						   imul edx
						   add eax,(OBJECT PTR [esi]).xmid		;middle of ring.
						   mov edx,eax
						   sub edx,ecx
						   mov x1,edx	;x-coord, top-left ellipse.
						   add eax,ecx
						   mov x2,eax	;x-coord, bot-right ellipse.
						  mov ecx,(OBJECT PTR [esi]).height
						  shr ecx,1
						  add ecx,ringwidth  ;total y-radius from centre of ring.
						   mov eax,(OBJECT PTR [esi]).ydeltacentre
						   mov edx,ring
						   dec edx
						   imul edx
						   add eax,(OBJECT PTR [esi]).ymid		;middle of ring.
						   mov edx,eax
						   sub edx,ecx
						   mov y1,edx	;y-coord, top-left ellipse.
						   add eax,ecx
						   mov y2,eax	;y-coord, bot-right ellipse.
						   
x09:				   ;mov eax,x1                ;v3.38
						   ;mov rect3d.rc_left,eax
						   ;mov eax,y1
						   ;mov rect3d.rc_top,eax
						   ;mov eax,x2
						   ;mov rect3d.rc_right,eax
						   ;mov eax,y2
						   ;mov rect3d.rc_bottom,eax
						
				       .IF exttype==0 ;ellipse

                 mov al,ellipsetype ;v3.31
                 .IF g_fredrawdiag==WIPEOUTobjs
                   jmp SHORT so2 ;always wipeout entire ellipse.
                 .ENDIF
                 .IF al==0 ;ellipse
                   mov eax,(OBJECT PTR [esi]).morphingwidth ;always +ve. v3.40
                   .IF eax==0 ;normal paint of rectangle...
so2:                 invoke Ellipse,hdc,x1,y1,x2,y2
                   .ELSE ;need to morph pen color to fill color.
                     invoke paintgradientrect,hdc,x1,y1,x2,y2 ;v3.39
                   .ENDIF
						     .ELSE ;IF al==010000b ;chord.
						       mov eax,(OBJECT PTR [esi]).rxstartarc
						       add eax,(OBJECT PTR [esi]).xtopleft
						       mov ecx,eax
						       mov eax,(OBJECT PTR [esi]).rystartarc
						       add eax,(OBJECT PTR [esi]).ytopleft
						       mov ebx,eax
						       mov eax,(OBJECT PTR [esi]).rxendarc
						       add eax,(OBJECT PTR [esi]).xtopleft
						       mov eaxsave,eax
						       mov eax,(OBJECT PTR [esi]).ryendarc
						       add eax,(OBJECT PTR [esi]).ytopleft
						       mov edx,eax
						
                   mov eax,(OBJECT PTR [esi]).morphingwidth ;always +ve. v3.40
                   .IF eax==0 ;normal paint of rectangle...
                     mov eax,eaxsave
						         .IF ellipsetype==010000b ;chord.
                       ;mov g_errorapi,0ADBh ;for crash outside EVE, error codes range Axxh. v3.23
						           invoke Chord,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						         .ELSEIF ellipsetype==100000b ;pie
                       ;mov g_errorapi,0ADCh ;for crash outside EVE, error codes range Axxh. v3.23
						           invoke Pie,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						         .ELSE ;arc.
                       ;mov g_errorapi,0ADDh ;for crash outside EVE, error codes range Axxh. v3.23
						           invoke Arc,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						         .ENDIF
                   .ELSE ;need to morph pen color to fill color.
                     invoke paintgradientrect,hdc,x1,y1,x2,y2 ;v3.39
                   .ENDIF
						
						     .ENDIF
						     
					     .ELSEIF exttype==3 ;rectangle
p52:             ;mov g_errorapi,0ADEh ;for crash outside EVE, error codes range Axxh. v3.23
                 ;v3.38...
                 mov eax,(OBJECT PTR [esi]).morphingwidth ;always +ve.
                 .IF g_fredrawdiag==WIPEOUTobjs
                   ;v3.42...
                   ;no, not working right... always wipe entire rect...
 		               ;.IF state==4 ;new rect being placed, need to wipe it all. v3.42
norm1:             invoke Rectangle,hdc,x1,y1,x2,y2
		               ;.ELSE
                   ;  ;v3.42 calc two invalidated rectangles, and paint them...
                   ;  ;(this reduces flicker when dragging)...
                   ;  mov eax,(OBJECT PTR [esi]).xtopleft ;coord before move.
                   ;  .IF SDWORD PTR g_xchange<0 ;dragging to right.
                   ;    mov ecx,eax
                   ;    sub ecx,g_xchange ;loaded in wmmousemove()/state8.
                   ;  .ELSE
                   ;    add eax,(OBJECT PTR [esi]).wwidth
                   ;    mov ecx,eax
                   ;    sub eax,g_xchange
                   ;  .ENDIF
                   ;  mov ebx,(OBJECT PTR [esi]).ytopleft ;coord before move.
                   ;  mov edx,ebx
                   ;  add edx,(OBJECT PTR [esi]).height
		               ;  invoke Rectangle,hdc,eax,ebx,ecx,edx
	                 ;  mov ebx,(OBJECT PTR [esi]).ytopleft
		               ;  .IF SDWORD PTR g_ychange<0 ;>=0
		               ;    mov edx,ebx
		               ;    sub edx,g_ychange
		               ;  .ELSE
		               ;    add ebx,(OBJECT PTR [esi]).height
		               ;    mov edx,ebx
		               ;    sub ebx,g_ychange
		               ;  .ENDIF
		               ;  mov eax,(OBJECT PTR [esi]).xtopleft
		               ;  mov ecx,eax
		               ;  add ecx,(OBJECT PTR [esi]).wwidth
		               ;  invoke Rectangle,hdc,eax,ebx,ecx,edx
 		               ;.ENDIF
			
                 .ELSEIF eax==0 ;normal paint of rectangle...
                   jmp norm1 ;invoke Rectangle,hdc,x1,y1,x2,y2 ;jmp norm1 v3.42
                 .ELSE ;need to morph pen color to fill color.
                   invoke paintgradientrect,hdc,x1,y1,x2,y2 ;v3.39
                 .ENDIF
						     jmp ex7
					     .ELSEIF exttype==4 ;rectangle,rounded.
                 ;mov g_errorapi,0ADFh ;for crash outside EVE, error codes range Axxh. v3.23
					       ;v3.39...
                 mov eax,(OBJECT PTR [esi]).morphingwidth ;always +ve.
                 .IF g_fredrawdiag==WIPEOUTobjs
                   jmp SHORT crn1 ;p59 ;paint invalidated rectangles. v3.42
                 .ELSEIF eax==0 ;normal paint of rectangle...
crn1:	             mov eax,(OBJECT PTR [esi]).ncornerwidth
						       mov ebx,(OBJECT PTR [esi]).ncornerheight
						       invoke RoundRect,hdc,x1,y1,x2,y2,eax,ebx
                 .ELSE ;need to morph pen color to fill color.
                   invoke paintgradientrect,hdc,x1,y1,x2,y2 ;v3.39
                 .ENDIF						
						     jmp ex7
					     .ELSE
						     jmp p52 ;default for anything in the future!<<<<
					     .ENDIF
						dec ring
						cmp ring,0
						ja vzxiter1
ex7:   ;...bypass rings for rectangle.
		.ENDIF
vis1: ;visibility bypass.

		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
				mov esi,pobject
				cmp g_perrorobject,esi
				je oo1 ;clr g_perrorobject then invert.
;also have multiple highlighted objects...

;v3.19 split up, leave colr-toggle, cut out visibility-toggle to earlier...
;sequence for this func now: toggle-visibility>paint-element>toggle-color>invertrgn.
      invoke colortoggle_paint,0 ;0=toggle invert. v3.44
      .IF eax==0
        jmp oo1b ;invert.
      .ENDIF

    ;v2.81 have moved this fhidehighlighting test down, don't block color animation...				
		cmp fhidehighlighting,1 ;same as TERSEDATA.fviewprefs/bit3.
		je m90 ;bypass inversion.
				  mov eax,(OBJECT PTR [esi]).fconfig2
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
				  .IF exttype==0  ;ellipse
						mov eax,(OBJECT PTR [esi]).xtopleft
						mov ebx,(OBJECT PTR [esi]).ytopleft
						mov ecx,xright
						mov edx,ybottom
						;add eax,2
						;add ebx,2
						;sub ecx,2
						;sub edx,2
            ;mov g_errorapi,0AE0h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateEllipticRgn, eax,ebx,ecx,edx		;-->eax=hrgn
				  .ELSEIF exttype==3 ;rectangle
p51:			mov eax,(OBJECT PTR [esi]).xtopleft
						mov ebx,(OBJECT PTR [esi]).ytopleft
						mov ecx,xright
						mov edx,ybottom
						;add eax,2
						;add ebx,2
						;sub ecx,2
						;sub edx,2
            ;mov g_errorapi,0AE1h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateRectRgn, eax,ebx,ecx,edx			;-->eax=hrgn
				  .ELSEIF exttype==4 ;rectangle,rounded.
						;jmp p51
						mov eax,(OBJECT PTR [esi]).xtopleft
						mov ebx,(OBJECT PTR [esi]).ytopleft
						mov ecx,(OBJECT PTR [esi]).ncornerheight
						mov edx,(OBJECT PTR [esi]).ncornerwidth
            ;mov g_errorapi,0AE2h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateRoundRectRgn,eax,ebx,xright,ybottom,ecx,edx ;-->eax=hrgn
				  .ELSEIF exttype==5 ;polygon.
				
				    ;v3.04 highlight polylines same as polygon...
						;mov eax,(OBJECT PTR [esi]).fconfig4
						;and eax,01
						;.IF eax==0		;closed polygon.
						  mov eax,(OBJECT PTR [esi]).ncorners
						  lea ebx,varray
              ;mov g_errorapi,0AE3h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke CreatePolygonRgn,ebx,eax,WINDING ;0
						;.ELSE
						;  mov eax,(OBJECT PTR [esi]).bez0x ;xtopleft
						;  mov ebx,(OBJECT PTR [esi]).bez0y ;ytopleft
						;  mov ecx,eax
						;  mov edx,ebx
						;  add eax,6
						;  add ebx,6
						;  sub ecx,6
						;  sub edx,6
						;  invoke CreateEllipticRgn, eax,ebx,ecx,edx ;-->eax=hrgn
						;.ENDIF
				  .ELSE
						jmp p51 ;default for anything in the future!
				  .ENDIF
				  push eax
          ;mov g_errorapi,0AE4h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:    ;bypass inversion.

;now draw a line from node to parent-object...
;*BUG* was working, except some stray grey lines and white lines...
;		   ;only for g_nstate>0...
;		   cmp g_nstate,0
;		   je pass1

;*BUG* replaced with this restriction, still not right...
;		 cmp esi,g_pselectedobject ;restrict so only highlighted object has grey line.
;		 jne pass1										  ;/

;		 mov eax,(OBJECT PTR [esi]).rpowner1  ;non-0 if node locked to parent.
;														 ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
;														 ;assuming eax has value to be written...
;														 .IF eax==0
;														 .ELSE
;														   add eax,pTERSEDATA
;														 .ENDIF
;		 mov plock,eax
;		 .IF eax==0 	 ;do nothing, as not locked.
;		 .ELSE
;				 mov edi,plock	 ;parent.
;
;				;*EVE* use .nbeginring for ring# of parent to snap-to...
;				mov eax,(OBJECT PTR [esi]).nbeginring
;				mov g_nsnapring,eax
;
;				 mov ebx,(OBJECT PTR [esi]).xmid ;addr of middle of node.
;				 mov xend,ebx									  ;/
;				 mov ebx,(OBJECT PTR [esi]).ymid ;/
;				 mov yend,ebx									  ;/
;								   ;now, IMPORTANT ... call snap_ method of PARENT obj...
;								   mov	ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
;								   ;(relative to "ptrs", which is start of the methods table)
;								   mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
;				 invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
;				 ;...will return nearest point on boundary of parent, in xend/yend.
;				 ;...or on ring1 in case of totem-pole rings.
;						 mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.
;		   ;now draw line...
;						 ;but for polygons, coord calc'd below jumps around...
;						 .IF exttype==5 ;polygon.
;						   mov eax,(OBJECT PTR [esi]).bez0x
;						   mov xend1,eax
;						   mov eax,(OBJECT PTR [esi]).bez0y
;						   mov yend1,eax
;						   jmp doit1
;						 .ENDIF
;				   ;aah, except also want line at "this end" to be on boundary...
;								   mov eax,xend
;								   mov xend1,eax
;								   mov eax,yend
;								   mov yend1,eax
;								   mov	ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
;				 invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1,0,0,0
;		   ;NOW can draw line...
;doit1: 		 invoke MoveToEx, hdc, xend1,yend1,0
;						 .IF g_fredrawdiag==WIPEOUTobjs
;						   invoke LineTo, hdc, xend,yend
;						 .ELSE
;						   invoke SelectObject, hdc,g_hpengrey
;						   mov hpensaved,eax
;						   invoke LineTo, hdc, xend,yend
;						   invoke SelectObject, hdc,hpensaved
;						 .ENDIF
;		 .ENDIF
;pass1:

		cmp fprinting,2 ;metafile o/p. ;maybe not needed here.
		je m91 ;bypass this section.
		cmp fhidehandles,1
		je m91

;now draw handles, if element highlighted...
	;v2.24 show poly handles if g_rponelement==esi...
	mov eax,g_rponelement
	.IF eax != 0
	  add eax,pTERSEDATA
	  mov ponelement,eax
	  ;see below...
	.ENDIF
  .IF  g_fredrawdiag==WIPEOUTobjs
		jmp zzE1
  .ELSEIF g_nstate==8
		.IF esi==g_pmovingobject
		  .IF g_nstateprev==2
				;if currently moving an object (and we will be in state8, so above double
				;-check is a precaution) and if came from state2 (highlighted object), then
				;am enabling dragging of individual handles...
				jmp SHORT E1
		  .ENDIF
		.ELSE
		  ;may be dragging a wire-end (wire is highlighted, and in state8) over a poly, want
		  ;handles to show on poly...
		  .IF ponelement==esi
			jmp SHORT cE1
		  .ENDIF
		.ENDIF
  .ELSEIF ponelement==esi		;v2.24
cE1: mov g_rponelement,0
	 .IF exttype==5 ;poly.
	   ;a problem is how to wipe the handles...
	   invoke add2wipeoutlist,esi ;to get rid of handles.
	   mov fmode,2 ;invoke SelectObject,hdc,g_hbrushpurple v3.31
	   jmp SHORT zE1 ;display handles.
	 .ENDIF
  .ELSEIF g_pselectedobject==esi
E1:

		  ;v1.81 element is boss (.rpowner1=0) yet is locked (.fconfig4/bit3=1)
		  ;(i want to be able to drag, but not alone -- with children --see drag_node())
		  ;also want to disable dragging of handles...
		  mov eax,(OBJECT PTR [esi]).fconfig4
		  and al,01000b ;bit3.
		  .IF al==01000b ;locked.
			mov eax,(OBJECT PTR [esi]).rpowner1
			.IF eax==0
			  ;don't paint handles...
			  jmp m91
			.ENDIF
		  .ENDIF

zzE1:	mov fmode,1 ;invoke SelectObject,hdc,g_hbrushred   ;note, it is white if wipeout.v3.31
zE1:	;mov hbrushold,eax v3.31
		.IF exttype==5 ;polygon
		    mov ebx,pTERSEDATA  ;v3.32
		    mov eax,(TERSEDATA PTR [ebx]).nhandleradius ;in pixels.
		    inc eax
		    mov ecx,(TERSEDATA PTR [ebx]).nzoom
		    .IF SBYTE PTR cl<0
		      neg cl
		      shr eax,cl
		    .ELSEIF SBYTE PTR cl>0
		      shl eax,cl
		    .ENDIF
		    mov xdispl,eax ;displacement for vertice numbering.
		    mov ydispl,6 ;needs to be fixed #pixels.
		    
		  ;want handle at each corner...	
			invoke SelectObject,hdc,g_hfontcode ;small courier new font. v3.32
			mov holdfont,eax
			mov ecx,(OBJECT PTR [esi]).ncorners
			lea ebx,varray ;x
			mov edi,ebx
			add edi,4	   ;y
			mov nhandle,0
E11:  inc nhandle
	    mov eax,[ebx]
		  mov xend,eax
		  mov edx,[edi]
		  mov yend,edx
		  ;sub xend,2
		  ;sub yend,2
		  ;add eax,2
		  ;add edx,2
		  ;pushad
		  ;invoke Ellipse, hdc,xend,yend,eax,edx
		    invoke painthandle,hdc,xend,yend,fmode ;1=red fill 2=light purple fill v3.31
		  ;popad
		  .IF fmode != 2 ;don't show vertice #s for light purple fill. v3.46
		    mov eax,nhandle         ;v3.32
		    invoke bin2dec,10 ;ret eax->szasciitbl.
		    mov edx,xend
		    add edx,xdispl
		    mov xend,edx
		    mov edx,yend
		    sub edx,ydispl
		    mov yend,edx
		    invoke TEXTOUTx,hdc,xend,yend,eax,2 ;max 2 chars.
		  .ENDIF
		  add ebx,8
		  add edi,8
		  loop E11
		  invoke SelectObject,hdc,holdfont
		  
		.ELSE
		  ;put handles on right and bottom...
		  mov ebx,(OBJECT PTR [esi]).xtopleft
		  add ebx,(OBJECT PTR [esi]).wwidth
		  mov edx,(OBJECT PTR [esi]).ytopleft
		  mov eax,(OBJECT PTR [esi]).height
		  shr eax,1
		  add edx,eax
		  mov xend,ebx
		  mov yend,edx
		  ;sub xend,2
		  ;sub yend,2
		  ;add ebx,2
		  ;add edx,2
		  ;invoke Ellipse,hdc,xend,yend,ebx,edx ;right.
		  invoke painthandle,hdc,ebx,edx,fmode ;1=red fill 2=light purple fill v3.31
		  mov ebx,(OBJECT PTR [esi]).xtopleft
		  mov eax,(OBJECT PTR [esi]).wwidth
		  shr eax,1
		  add ebx,eax
		  mov edx,(OBJECT PTR [esi]).ytopleft
		  add edx,(OBJECT PTR [esi]).height
		  mov xend,ebx
		  mov yend,edx
		  ;sub xend,2
		  ;sub yend,2
		  ;add ebx,2
		  ;add edx,2
		  ;invoke Ellipse,hdc,xend,yend,ebx,edx ;right.
		  invoke painthandle,hdc,ebx,edx,fmode ;1=red fill 2=light purple fill v3.31

      ;v2.96
      ;partial ellipse...
      .IF exttype==0 ;ellipse type. ;v3.19
        .IF ellipsetype != 0 ;=0 if complete ellipse.
		      mov ebx,(OBJECT PTR [esi]).rxstartarc
		      add ebx,(OBJECT PTR [esi]).xtopleft
		      mov edx,(OBJECT PTR [esi]).rystartarc
		      add edx,(OBJECT PTR [esi]).ytopleft
		      mov xend,ebx
		      mov yend,edx
		      ;sub xend,2
		      ;sub yend,2
		      ;add ebx,2
		      ;add edx,2
		      ;invoke Ellipse,hdc,xend,yend,ebx,edx ;start handle.
		      invoke painthandle,hdc,ebx,edx,fmode ;1=red fill 2=light purple fill v3.31
		      mov ebx,(OBJECT PTR [esi]).rxendarc
		      add ebx,(OBJECT PTR [esi]).xtopleft
		      mov edx,(OBJECT PTR [esi]).ryendarc
		      add edx,(OBJECT PTR [esi]).ytopleft
		      mov xend,ebx
		      mov yend,edx
		      ;sub xend,2
		      ;sub yend,2
		      ;add ebx,2
		      ;add edx,2
		      ;invoke Ellipse,hdc,xend,yend,ebx,edx ;end handle.
		      invoke painthandle,hdc,ebx,edx,fmode ;1=red fill 2=light purple fill v3.31
        .ENDIF
      .ENDIF
      
		.ENDIF
		  ;invoke SelectObject,hdc,hbrushold v3.31
  .ENDIF
m91:

		ret
;.................
paint_node ENDP
;--------------------------------------------------------------------------
;v3.39...
paintgradientrect PROC STDCALL USES ebx ecx edx esi edi,hdc:DWORD,x1:DWORD,y1:DWORD,x2:DWORD,y2:DWORD
				LOCAL brushpen:DWORD,ecxsave:DWORD  ;v3.38
				LOCAL colornew:DWORD,brushold:DWORD,pennew:DWORD,penold:DWORD ;v3.38
				LOCAL deltared:DWORD,deltagreen:DWORD,deltablue:DWORD ;v3.38
				LOCAL morphingwidthadj:DWORD ;v3.38
				LOCAL zoom:DWORD,exttype:DWORD ;v3.38
				LOCAL redremainder:DWORD,greenremainder:DWORD,blueremainder:DWORD ;v3.38
				LOCAL x1b:DWORD,y1b:DWORD,x2b:DWORD,y2b:DWORD ;v3.39
				LOCAL colorbright:DWORD,colorbrighter:DWORD,colorbrightest:DWORD ;v3.39
        LOCAL hpenbright:DWORD,hpenbrighter:DWORD,hpenbrightest:DWORD ;v3.39
        LOCAL ellipsetype:BYTE
; "paintgradientrect"
;called from paint_node(), paints rectangle/ellipse with color morphing.
;enter esi->element.
    mov ebx,pTERSEDATA    ;v3.38
    mov eax,(TERSEDATA PTR [ebx]).nzoom
    mov zoom,eax
    mov eax,(OBJECT PTR [esi]).nexttype
    mov exttype,eax
    .IF eax==0 ;ellipse.
      mov eax,(OBJECT PTR [esi]).fconfig1
      and al,110000b
      mov ellipsetype,al
    .ENDIF
    
                     ;limit morphingwidth...  v3.39
                     mov ecx,(OBJECT PTR [esi]).morphingwidth
                     mov ebx,(OBJECT PTR [esi]).wwidth
                     mov edx,(OBJECT PTR [esi]).height
                     mov eax,(OBJECT PTR [esi]).fconfig0 ;limit morphingwidth sometimes.
                     and al,0Fh ;bits3-0 morphing skew.
                     .IF al==1 ;top skew.
                       jmp SHORT ver1
                     .ELSEIF al==3 ;right skew.
                       jmp SHORT hor1
                     .ELSEIF al==5 ;bottom skew.
ver1:                  .IF ecx>=edx
                         mov ecx,edx
                         dec ecx
                       .ENDIF
                     .ELSEIF al==7 ;left skew.
hor1:                  .IF ecx>=ebx
                         mov ecx,ebx
                         dec ecx
                       .ENDIF
                     .ELSE ;=0 no skew =2 top-right =4 bottom-right =6 bottom-left =8 top-left.
                       shr ebx,1 ;horiz radius.
                       shr edx,1 ;vert radius.
                       .IF ecx>=ebx
                         mov ecx,ebx
                         dec ecx
                       .ENDIF
                       .IF ecx>=edx
                         mov ecx,edx
                         dec ecx
                       .ENDIF
                     .ENDIF
                     mov (OBJECT PTR [esi]).morphingwidth,ecx ;limited value.
                     
                   invoke GetStockObject,NULL_BRUSH
                   invoke SelectObject,hdc,eax
                   mov brushold,eax
                   mov eax,(OBJECT PTR [esi]).npencolor
                   mov colornew,eax
                     mov ebx,(OBJECT PTR [esi]).morphingwidth ;+ve only.
                       mov ecx,zoom
                       .IF SBYTE PTR cl>0 ;paint less bands when zoomed out.
                         shr ebx,cl
                       .ENDIF
                       .IF ebx==0
                         inc ebx
                       .ENDIF
                       mov morphingwidthadj,ebx ;(ebx value used below).
                     mov eax,(OBJECT PTR [esi]).nfillcolor
                     and eax,0FFh ;get 1 color.
                     mov ecx,(OBJECT PTR [esi]).npencolor
                     and ecx,0FFh
                     sub eax,ecx
                     cdq
                     idiv ebx
                     mov deltared,eax ;incremental change to red color.
                     mov redremainder,edx ;note, -ve also if top value was -ve!!!
                     mov eax,(OBJECT PTR [esi]).nfillcolor
                     and eax,0FF00h ;get 1 color.
                     mov ecx,(OBJECT PTR [esi]).npencolor
                     and ecx,0FF00h
                     sub eax,ecx
                     sar eax,8
                     cdq
                     idiv ebx
                     mov deltagreen,eax ;incremental change to greencolor.
                     mov greenremainder,edx ;signed!!!
                     mov eax,(OBJECT PTR [esi]).nfillcolor
                     and eax,0FF0000h ;get 1 color.
                     mov ecx,(OBJECT PTR [esi]).npencolor
                     and ecx,0FF0000h
                     sub eax,ecx
                     sar eax,16
                     cdq
                     idiv ebx
                     mov deltablue,eax ;incremental change to blue color.
                     mov blueremainder,edx ;signed!!!
                     
                     ;thinking about a light source. use .fconfig0/bits7-4...
                     ;create a pen 2-steps brighter than .nfillcolor,
                     ;as we paint each rectangle, also paint the bright lines...
                     mov eax,(OBJECT PTR [esi]).fconfig0
                     and al,0F0h ;bits7-4.
                     .IF al != 0 ;non0 = side light.
                       mov eax,(OBJECT PTR [esi]).nfillcolor ;v3.39
                       invoke brightencolor,eax,deltared,deltagreen,deltablue,1
                       ;1=compemsate for pen brighter than fill.
                       mov colorbright,eax
                       mov eax,1
                       .IF exttype==4 ;v3.39
                         inc eax ;need wider pen to cover corners.
                       .ELSEIF exttype==0 ;ellipse. v3.40
                         inc eax
                       .ENDIF
                       invoke CreatePen,PS_SOLID,eax,colorbright
                       mov hpenbright,eax
                       invoke brightencolor,colorbright,deltared,deltagreen,deltablue,0
                       mov colorbrighter,eax
                       mov eax,1
                       .IF exttype==4 ;v3.39
                         inc eax ;need wider pen to cover corners.
                       .ELSEIF exttype==0 ;ellipse. v3.40
                         inc eax ;ditto.
                       .ENDIF
                       invoke CreatePen,PS_SOLID,eax,colorbrighter
                       mov hpenbrighter,eax
                       invoke brightencolor,colorbrighter,deltared,deltagreen,deltablue,0
                       mov colorbrightest,eax
                       mov eax,1
                       .IF exttype==4 ;v3.39
                         inc eax ;need wider pen to cover corners.
                       .ELSEIF exttype==0 ;ellipse. v3.40
                         inc eax
                       .ENDIF
                       invoke CreatePen,PS_SOLID,eax,colorbrightest
                       mov hpenbrightest,eax
                     .ENDIF
                       

                   mov ecx,morphingwidthadj
                   inc ecx ;have to loop thru one extra time. v3.39
band1:             mov ecxsave,ecx ;push ecx
                   mov eax,1
                   .IF exttype==4 ;v3.39
                     inc eax ;need wider pen to cover corners.
                   .ELSEIF exttype==0 ;ellipse. v3.40
                     inc eax ;ditto.
                   .ENDIF
                   invoke CreatePen,PS_SOLID,eax,colornew
                   mov pennew,eax
                   invoke SelectObject,hdc,eax
                   mov penold,eax
                   
				           .IF exttype==0 ;ellipse
                     mov al,ellipsetype ;v3.31
                     .IF al==0 ;ellipse
                       invoke Ellipse,hdc,x1,y1,x2,y2
						         .ELSE ;IF al==010000b ;chord.
						           mov eax,(OBJECT PTR [esi]).rxstartarc
						           add eax,(OBJECT PTR [esi]).xtopleft
						           mov ecx,eax
						           mov eax,(OBJECT PTR [esi]).rystartarc
						           add eax,(OBJECT PTR [esi]).ytopleft
						           mov ebx,eax
						           mov eax,(OBJECT PTR [esi]).rxendarc
						           add eax,(OBJECT PTR [esi]).xtopleft
						           push eax
						           mov eax,(OBJECT PTR [esi]).ryendarc
						           add eax,(OBJECT PTR [esi]).ytopleft
						           mov edx,eax
						           pop eax						
						             .IF ellipsetype==010000b ;chord.
						               invoke Chord,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						             .ELSEIF ellipsetype==100000b ;pie
						               invoke Pie,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						             .ELSE ;arc.
						               invoke Arc,hdc,x1,y1,x2,y2,ecx,ebx,eax,edx
						             .ENDIF
						         .ENDIF						
                   .ELSEIF exttype==4 ;rounded rect.  v3.39
      			         mov eax,(OBJECT PTR [esi]).ncornerwidth
						         mov ebx,(OBJECT PTR [esi]).ncornerheight
						         invoke RoundRect,hdc,x1,y1,x2,y2,eax,ebx
                   .ELSE
                     invoke Rectangle,hdc,x1,y1,x2,y2
                   .ENDIF
                   
                       ;we need to adjust colornew...
                       mov eax,colornew
                       and eax,0FFh
                       add eax,deltared
                       .IF SDWORD PTR redremainder>0 ;compensate for remainder. v3.39
                         inc eax
                         dec redremainder
                       .ELSEIF SDWORD PTR redremainder<0
                         dec eax
                         inc redremainder
                       .ENDIF
                       mov ebx,colornew
                       and ebx,0FF00h
                       shr ebx,8
                       add ebx,deltagreen
                       .IF SDWORD PTR greenremainder>0 ;compensate for remainder. v3.39
                         inc ebx
                         dec greenremainder
                       .ELSEIF SDWORD PTR greenremainder<0
                         dec ebx
                         inc greenremainder
                       .ENDIF
                       shl ebx,8
                       mov ecx,colornew
                       and ecx,0FF0000h
                       shr ecx,16
                       add ecx,deltablue
                       .IF SDWORD PTR blueremainder>0 ;compensate for remainder. v3.39
                         inc ecx
                         dec blueremainder
                       .ELSEIF SDWORD PTR blueremainder<0
                         dec ecx
                         inc blueremainder
                       .ENDIF
                       shl ecx,16
                       mov colornew,0
                       or colornew,eax
                       or colornew,ebx
                       or colornew,ecx
                       
                     mov ecx,zoom
                     mov eax,1
                     .IF SBYTE PTR cl>0
                       shl eax,cl
                     .ENDIF
                     mov ebx,(OBJECT PTR [esi]).fconfig0
                     and bl,0Fh ;bits3-0 morphing skew.
                     mov ecx,ecxsave
                     and cl,01 ;test bit0, get alternate loops.
                     .IF bl==0 ;no skew.
                       add x1,eax
                       add y1,eax
                       sub x2,eax
                       sub y2,eax
                     .ELSEIF bl==2 ;skew top-right.
                       .IF cl==0
                         sub x2,eax
                         add y1,eax
                       .ENDIF
                       add x1,eax
                       sub y2,eax
                     .ELSEIF bl==4 ;skew bottom-right.
                       .IF cl==0
                         sub x2,eax
                         sub y2,eax
                       .ENDIF
                       add x1,eax
                       add y1,eax
                     .ELSEIF bl==6 ;skew bottom-left.
                       .IF cl==0
                         add x1,eax
                         sub y2,eax
                       .ENDIF
                       sub x2,eax
                       add y1,eax
                     .ELSEIF bl==8 ;skew top-left.
                       .IF cl==0
                         add x1,eax
                         add y1,eax
                       .ENDIF
                       sub x2,eax
                       sub y2,eax
                     .ELSEIF bl==1 ;skew top.
                       sub y2,eax
                       .IF exttype==0 ;ellipse. v3.40
                         .IF cl!=0 ;alternate
                           sub x2,eax
                           add x1,eax
                         .ENDIF
                       .ENDIF
                     .ELSEIF bl==3 ;skew right.
                       add x1,eax
                       .IF exttype==0 ;ellipse. v3.40
                         .IF cl!=0
                           sub y2,eax
                           add y1,eax
                         .ENDIF
                       .ENDIF
                     .ELSEIF bl==5 ;skew bottom.
                       add y1,eax
                       .IF exttype==0 ;ellipse. v3.40
                         .IF cl!=0
                           sub x2,eax
                           add x1,eax
                         .ENDIF
                       .ENDIF
                     .ELSEIF bl==7 ;skew left.
                       sub x2,eax
                       .IF exttype==0 ;ellipse. v3.40
                         .IF cl!=0
                           sub y2,eax
                           add y1,eax
                         .ENDIF
                       .ENDIF
                     .ENDIF

                     ;before loop back up and paint rectangle, paint it here, but
                     ;offset so bright lines will be exposed when overpainted...
                     mov eax,(OBJECT PTR [esi]).fconfig0
                     and al,0F0h ;bits7-4 light source.
                     .IF al != 0
                       mov ebx,x1
                       mov x1b,ebx
                       mov ebx,y1
                       mov y1b,ebx
                       mov ebx,x2
                       mov x2b,ebx
                       mov ebx,y2
                       mov y2b,ebx
                       ;paint bright lines...
                       push eax
                       mov ecx,ecxsave
                       .IF ecx==3 ;3rd last loop.
                         invoke SelectObject,hdc,hpenbrighter
                       .ELSEIF ecx==2 ;2nd last loop.
                         invoke SelectObject,hdc,hpenbright
                       .ELSEIF ecx==1 ;last loop.
                         pop eax
                         jmp by2 ;don't paint offset bright rect on last loop.
                       .ELSEIF ecx>morphingwidthadj ;1st loop.
                         invoke SelectObject,hdc,hpenbright
                       .ELSE
                         invoke SelectObject,hdc,hpenbrightest
                       .ENDIF
                       pop eax
                       .IF al==10h ;top-left
                         dec x1b
                         dec y1b
                       .ELSEIF al==20h ;top-right
                         inc x2b
                         dec y1b
                       .ELSEIF al==30h ;bottom-right.
                         inc x2b
                         inc y2b
                       .ELSEIF al==40h ;bottom-left.
                         dec x1b
                         inc y2b
                       .ENDIF
                       
				               .IF exttype==0 ;ellipse v3.40
                         mov al,ellipsetype ;v3.31
                         .IF al==0 ;ellipse
                           invoke Ellipse,hdc,x1b,y1b,x2b,y2b
						             .ELSE ;IF al==010000b ;chord.
						               mov eax,(OBJECT PTR [esi]).rxstartarc
						               add eax,(OBJECT PTR [esi]).xtopleft
						               mov ecx,eax
						               mov eax,(OBJECT PTR [esi]).rystartarc
						               add eax,(OBJECT PTR [esi]).ytopleft
						               mov ebx,eax
						               mov eax,(OBJECT PTR [esi]).rxendarc
						               add eax,(OBJECT PTR [esi]).xtopleft
						               push eax
						               mov eax,(OBJECT PTR [esi]).ryendarc
						               add eax,(OBJECT PTR [esi]).ytopleft
						               mov edx,eax
						               pop eax						
						               .IF ellipsetype==010000b ;chord.
						                 invoke Chord,hdc,x1b,y1b,x2b,y2b,ecx,ebx,eax,edx
						               .ELSEIF ellipsetype==100000b ;pie
						                 invoke Pie,hdc,x1b,y1b,x2b,y2b,ecx,ebx,eax,edx
						               .ELSE ;arc.
						                 invoke Arc,hdc,x1b,y1b,x2b,y2b,ecx,ebx,eax,edx
						               .ENDIF
						             .ENDIF						
                       .ELSEIF exttype==4 ;rounded rect.  v3.39
      			             mov eax,(OBJECT PTR [esi]).ncornerwidth
						             mov ebx,(OBJECT PTR [esi]).ncornerheight
						             invoke RoundRect,hdc,x1b,y1b,x2b,y2b,eax,ebx
                       .ELSE
                         invoke Rectangle,hdc,x1b,y1b,x2b,y2b
                       .ENDIF

                     .ENDIF
by2:                 ;bypass bright rect.
                     
                   invoke SelectObject,hdc,penold
                   invoke DeleteObject,pennew
                   mov ecx,ecxsave ;pop ecx
                   .IF ecx==2 ;final paint of rect will have the fill.
                     .IF exttype>=60 ;icons 60-69, want no fill in middle.
                     .ELSE
                       invoke SelectObject,hdc,brushold
                     .ENDIF
                   .ENDIF
                   mov ecx,ecxsave
                   loop band1x
                   jmp SHORT band1z
band1x:            jmp band1
band1z:            ;out of loop.
                   .IF exttype>=60 ;cos missed doing it above.
                     invoke SelectObject,hdc,brushold
                   .ENDIF
                   
                     ;also need to delete these...
                     mov eax,(OBJECT PTR [esi]).fconfig0
                     and al,0F0h ;bits7-4.
                     .IF al != 0 ;non0 = side light.
                       invoke DeleteObject,hpenbright
                       invoke DeleteObject,hpenbrighter
                       invoke DeleteObject,hpenbrightest
                     .ENDIF


    ret
paintgradientrect ENDP
;--------------------------------------------------------------------------
brightencolor PROC STDCALL USES ebx ecx edx esi edi, colorpre:DWORD, \
    deltared:DWORD,deltagreen:DWORD,deltablue:DWORD,fcompensate:DWORD
    LOCAL colorbright:DWORD,avglevel:DWORD,avglevelpen:DWORD,fpenlighter:DWORD
    LOCAL deltaredp:DWORD,deltagreenp:DWORD,deltabluep:DWORD
; "brightencolor"
;called by paintgradientrect(). enter esi->element.
;return eax=brighter color.
    ;detect average brightness of fill...
    mov eax,(OBJECT PTR [esi]).nfillcolor
    mov edx,eax
    mov ebx,eax
    and eax,0FFh
    shr ebx,8
    and ebx,0FFh
    add eax,ebx
    shr edx,16
    and edx,0FFh
    add eax,edx
    mov ecx,3
    xor edx,edx
    div ecx
    mov avglevel,eax
    ;also for pen...
    mov eax,(OBJECT PTR [esi]).npencolor
    mov edx,eax
    mov ebx,eax
    and eax,0FFh
    shr ebx,8
    and ebx,0FFh
    add eax,ebx
    shr edx,16
    and edx,0FFh
    add eax,edx
    mov ecx,3
    xor edx,edx
    div ecx
    mov avglevelpen,eax
    mov fpenlighter,0
    .IF eax>avglevel
      mov fpenlighter,1
    .ENDIF

                       mov edi,0
                       mov eax,deltared
                       .IF SDWORD PTR eax<0
                         neg eax
                       .ENDIF
                       mov deltaredp,eax
                       ;add edi,eax
                       mov eax,deltagreen
                       .IF SDWORD PTR eax<0
                         neg eax
                       .ENDIF
                       mov deltagreenp,eax
                       ;add edi,eax
                       mov eax,deltablue
                       .IF SDWORD PTR eax<0
                         neg eax
                       .ENDIF
                       mov deltabluep,eax
                       
                   ;light-source brightness adjustment...
                   mov ebx,deltaredp
                   shr ebx,1
                   mov ecx,deltagreenp
                   shr ecx,1
                   mov edx,deltabluep
                   shr edx,1
                   mov eax,(OBJECT PTR [esi]).fconfig0
                   and eax,0F00h ;bits11-8 are light-source brightness.
                   .IF eax==100h ;brighter.
                     shr ebx,1
                     shr ecx,1
                     shr edx,1
                     jmp SHORT br1
                   .ELSEIF eax==200h ;duller.
                     shr ebx,1
                     shr ecx,1
                     shr edx,1
                     jmp SHORT du1
                   .ELSEIF eax==300h ;brightest
br1:                 add deltaredp,ebx
                     add deltagreenp,ecx
                     add deltabluep,edx
                   .ELSEIF eax==400h ;dullest.
du1:                 sub deltaredp,ebx
                     sub deltagreenp,ecx
                     sub deltabluep,edx
                   .ENDIF

                         mov eax,colorpre
                         mov ebx,eax
                         shr ebx,8
                         and ebx,0FFh
                         mov ecx,eax
                         shr ecx,16
                         and ecx,0FFh
                         and eax,0FFh
                         add eax,deltaredp ;edi ;deltared
                         .IF fcompensate != 0
                           ;.IF SDWORD PTR deltared<0 ;means pen is lighter than fill.
                           .IF fpenlighter!=0 ;v3.41
                             push eax
                             mov ecx,(OBJECT PTR [esi]).morphingwidth ;npencolor
                             shr ecx,1
                             mov eax,deltaredp ;+ve. v3.41
                             mul ecx
                             ;neg eax
                             mov edx,eax
                             pop eax
                             add eax,edx ;to make sure about brighter than pen.
                           .ENDIF
                         .ENDIF
                         .IF eax>0FFh
                           and eax,0FFh ;get the overflow. add it to the other colors...
                           .IF avglevel<100
                             shl eax,1 ;need to boost brightness.
                           .ELSEIF avglevel<150
                             ;double overflow.
                           .ELSEIF avglevel<200
                             shr eax,1 ;normal overflow.
                           ;.ELSEIF avglevel<200
                           ;  shr eax,3 ;very small overflow.
                           ;.ELSEIF avglevel<215
                           ;  shr eax,5 ;3
                           ;.ELSEIF avglevel<225
                           ;  shr eax,6 ;4
                           .ELSE
                             shr eax,2 ;mov eax,0 ;shr eax,5
                           .ENDIF
                           add ebx,eax
                           add ecx,eax
                           mov eax,0FFh
                         .ENDIF
                         add ebx,deltagreenp ;edi ;deltagreen
                         .IF fcompensate != 0
                           ;.IF SDWORD PTR deltagreen<0 ;means pen is lighter than fill.
                           .IF fpenlighter!=0 ;v3.41
                             push eax
                             mov ecx,(OBJECT PTR [esi]).morphingwidth ;npencolor
                             shr ecx,1
                             mov eax,deltagreenp ;v3.41
                             mul ecx
                             ;neg eax
                             mov edx,eax
                             pop eax
                             add ebx,edx ;to make sure about brighter than pen.
                           .ENDIF
                         .ENDIF
                         .IF ebx>0FFh
                           and ebx,0FFh ;see note above.
                           .IF avglevel<100
                             shl ebx,1 ;need to boost brightness.
                           .ELSEIF avglevel<150
                             ;double overflow.
                           .ELSEIF avglevel<200 ;180
                             shr ebx,1 ;normal overflow.
                           ;.ELSEIF avglevel<200
                           ;  shr ebx,3 ;very small overflow.
                           ;.ELSEIF avglevel<215
                           ;  shr ebx,5 ;3
                           ;.ELSEIF avglevel<225
                           ;  shr ebx,6 ;4
                           .ELSE
                             shr ebx,2 ;mov ebx,0 ;shr ebx,5
                           .ENDIF
                           add eax,ebx
                           add ecx,ebx
                           mov ebx,0FFh
                         .ENDIF
                         add ecx,deltabluep ;edi ;deltablue
                         .IF fcompensate != 0
                           ;.IF SDWORD PTR deltablue<0 ;means pen is lighter than fill.
                           .IF fpenlighter!=0 ;v3.41
                             push eax
                             push ecx
                             mov ecx,(OBJECT PTR [esi]).morphingwidth ;npencolor
                             shr ecx,1
                             mov eax,deltabluep ;v3.41
                             mul ecx
                             ;neg eax
                             mov edx,eax
                             pop ecx
                             pop eax
                             add ecx,edx ;to make sure about brighter than pen.
                           .ENDIF
                         .ENDIF
                         .IF ecx>0FFh
                           and ecx,0FFh ;see note above.
                           .IF avglevel<100
                             shl ecx,1 ;need to boost brightness.
                           .ELSEIF avglevel<150
                             ;double overflow.
                           .ELSEIF avglevel<200 ;180
                             shr ecx,1 ;normal overflow.
                           ;.ELSEIF avglevel<200
                           ;  shr ecx,3 ;very small overflow.
                           ;.ELSEIF avglevel<215
                           ;  shr ecx,5 ;3
                           ;.ELSEIF avglevel<225
                           ;  shr ecx,6 ;4
                           .ELSE
                             shr ecx,2 ;mov ecx,0 ;shr ecx,5
                           .ENDIF
                           add eax,ecx
                           add ebx,ecx
                           mov ecx,0FFh
                         .ENDIF
                         .IF eax>0FFh
                           mov eax,0FFh
                         .ENDIF
                         .IF ebx>0FFh
                           mov ebx,0FFh
                         .ENDIF
                         .IF ecx>0FFh
                           mov ecx,0FFh
                         .ENDIF
                         shl ebx,8
                         shl ecx,16
                         mov colorbright,0
                         or colorbright,eax
                         or colorbright,ebx
                         or colorbright,ecx

    mov eax,colorbright
    ret
brightencolor ENDP
;--------------------------------------------------------------------------
paint_ani PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL ringwidth:DWORD
				LOCAL xright:DWORD
				LOCAL ybottom:DWORD
				LOCAL xend:SDWORD, yend:SDWORD
				LOCAL plock:DWORD
				LOCAL xend1:SDWORD, yend1:SDWORD
				LOCAL exttype:DWORD
				LOCAL x1:SDWORD,y1:SDWORD,x2:SDWORD,y2:SDWORD,ring:DWORD
;				LOCAL myhfontnew:DWORD,myhfontold:DWORD,mynweight:DWORD
;				LOCAL myfitalic:DWORD,myfstrikethru:DWORD,myfunderline:DWORD
			  LOCAL textrect:RECT
        LOCAL pdata:DWORD,hfontsaved:DWORD
        LOCAL state:BYTE
;this is a method, to display animation activators. 	  "paint_ani"
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;v2.76 also paints link activator, .nexttype==41.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF

		  mov esi,pobject
			mov eax,(OBJECT PTR [esi]).nexttype
			mov exttype,eax


		cmp fprinting,0   ;=0 screen, =1 printer, =2 emf, =3 clipboard.
		jne m91 ;get out.
    .IF eax==40 ;animation activator. v2.76
      .IF fsaving==0 ;i think a wise precaution. v2.76.
		    ;zeroabsoluteptrs,1 wiped all entries in anilist, by add2anilist,0, so reload them here...
		    invoke add2anilist,esi ;(good to have this below the fprinting compare)
		  .ENDIF
		.ELSEIF eax==41 ;link activator. v2.76
		  mov ebx,(OBJECT PTR [esi]).rpowner1
		  .IF ebx != 0
		    add ebx,pTERSEDATA
		    ;.flinks=60-69, as per old icon.nexttype. copy this to target.flinks,
		    ;so when click/dblclk on target, will know quickly that a link action
		    ;is required...
		    mov eax,(OBJECT PTR [esi]).flinks
		    mov (OBJECT PTR [ebx]).flinks,eax
		  .ENDIF
		.ENDIF
		cmp fhidehandles,1
		je m91   ;get out.
		;...for activator, treat it like a "handle", so won't print or export.

				mov eax,(OBJECT PTR [esi]).wwidth
				add eax,(OBJECT PTR [esi]).xtopleft
				mov xright,eax
				mov ebx,(OBJECT PTR [esi]).height
				add ebx,(OBJECT PTR [esi]).ytopleft
				mov ybottom,ebx
				  ;precaution...
				  mov eax,(OBJECT PTR [esi]).wwidth
				  shr eax,1
				  add eax,(OBJECT PTR [esi]).xtopleft
				  mov (OBJECT PTR [esi]).xmid,eax
				  mov eax,(OBJECT PTR [esi]).height
				  shr eax,1
				  add eax,(OBJECT PTR [esi]).ytopleft
				  mov (OBJECT PTR [esi]).ymid,eax

						mov ecx,(OBJECT PTR [esi]).nrings
						mov ring,ecx
							  mov ringwidth,0 ;not needed.
								mov eax,(OBJECT PTR [esi]).xtopleft
								mov x1,eax
								add eax,(OBJECT PTR [esi]).wwidth
								mov x2,eax ;note, already calc'd xright above.
								mov eax,(OBJECT PTR [esi]).ytopleft
								mov y1,eax
								add eax,(OBJECT PTR [esi]).height
								mov y2,eax ;note, already calc'd ybottom above.
  ;mov g_errorapi,0AE5h ;for crash outside EVE, error codes range Axxh. v3.23
					   invoke Rectangle,hdc,x1,y1,x2,y2

;v3.25...
;this applies to link activator and inline SVG. animation activator doesn't have
;attached text.
;now to display text on the object...first x-coord...
		mov eax,(OBJECT PTR [esi]).fstatus
		and ax,0100000b 		   ;extract bit 5
		.IF ax != 0				;bit5=1, display label.
		  .IF g_hfontcode != 0 ;precaution.
        invoke SelectObject,hdc,g_hfontcode
        mov hfontsaved,eax
      .ENDIF
				mov  eax,(OBJECT PTR [esi]).xtopleft ;xmid
				add  eax,(OBJECT PTR [esi]).wwidth ;30 ;10
				inc eax
				inc eax
				  ;offset text, from OBJECT.x/ylabeloffset ....
				  mov ecx,eax
				  mov eax,(OBJECT PTR [esi]).xlabeloffset				;x offset (signed)
				  add ecx,eax	;new x-coord.
				mov  textrect.rc_left,ecx
        ;now y-coord...
				mov  ebx,(OBJECT PTR [esi]).ymid
				sub  ebx,9
				mov eax,(OBJECT PTR [esi]).ylabeloffset ;y offset (signed)
				add ebx,eax ;new y-coord
				mov  textrect.rc_top,ebx
				mov ebx,(OBJECT PTR [esi]).rpdata		;data-element.
				.IF ebx==0				
				.ELSE
				  add ebx,pTERSEDATA
				  lea edx,(OBJECT PTR [ebx]).sztext ;start of data area.
				  mov pdata,edx
				  invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
			    invoke DrawText, hdc,pdata,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
			  .ENDIF
		  .IF g_hfontcode != 0 ;precaution.
        invoke SelectObject,hdc,hfontsaved
      .ENDIF
		.ENDIF




		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp fhidehighlighting,1
		je m90
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
hidres: 		mov esi,pobject
				cmp g_perrorobject,esi
				je		oo1
				;also have multiple highlighted objects...
				  mov eax,(OBJECT PTR [esi]).fconfig2
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:			  mov g_perrorobject,0	;only do this once.
oo1b:					mov eax,(OBJECT PTR [esi]).xtopleft
						mov ebx,(OBJECT PTR [esi]).ytopleft
						mov ecx,xright
						mov edx,ybottom
  ;mov g_errorapi,0AE6h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateRectRgn, eax,ebx,ecx,edx			;-->eax=hrgn
				  push eax
  ;mov g_errorapi,0AE7h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:

;now draw a line from node to parent-object...
		mov eax,(OBJECT PTR [esi]).rpowner1	;non-0 if node locked to parent.
										;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
										;assuming eax has value to be written...
										.IF eax==0
										.ELSE
										  add eax,pTERSEDATA
										.ENDIF
		mov plock,eax
		.IF eax==0		;do nothing, as not locked.
		.ELSE
				mov edi,plock	;parent.
			   ;*EVE* use .nbeginring for ring# of parent to snap-to...
			   mov eax,(OBJECT PTR [esi]).nbeginring
			   mov g_nsnapring,eax
				mov ebx,(OBJECT PTR [esi]).xmid ;addr of middle of node.
				mov xend,ebx									 ;/
				mov ebx,(OBJECT PTR [esi]).ymid ;/
				mov yend,ebx									 ;/
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
				invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
				;...will return nearest point on boundary of parent, in xend/yend.
				;...or on ring1 in case of totem-pole rings.
						mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.
				;now draw line...
				  ;aah, except also want line at "this end" to be on boundary...
								  mov eax,xend
								  mov xend1,eax
								  mov eax,yend
								  mov yend1,eax
								  mov  ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
				invoke snapPTR PTR [ebx+ptrs+psnap], esi,ADDR xend1,ADDR yend1,0,0,0
				;NOW can draw line...
doit1:			invoke MoveToEx, hdc, xend1,yend1,0
						;.IF g_fredrawdiag==WIPEOUTobjs
						;  invoke LineTo, hdc, xend,yend
						;.ELSE
						;  invoke SelectObject, hdc,g_hpengrey
						;  mov hpensaved,eax
  ;mov g_errorapi,0AE8h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke LineTo, hdc, xend,yend
						;  invoke SelectObject, hdc,hpensaved
						;.ENDIF
		.ENDIF
pass1:

m91:
		ret
paint_ani ENDP
;--------------------------------------------------------------------------
mycreatefont PROC STDCALL USES ebx ecx edx esi edi
  LOCAL nweight:DWORD,fitalic:DWORD,fstrikethru:DWORD,funderline:DWORD
  LOCAL hfontnew:DWORD
; "mycreatefont"
;enter esi->element.
;return eax=hnewfont.

								  mov hfontnew,0
								  mov nweight,0
								  mov fitalic,0
										mov ebx,(OBJECT PTR [esi]).nfontstyle
										mov ecx,(OBJECT PTR [esi]).nfonttype
										.IF ecx==0
												lea ecx,sztimesnewroman
										.ELSEIF ecx==1
												lea ecx,szarial
										.ELSEIF ecx==2
												lea ecx,szcouriernew
										.ELSEIF ecx==3 ;custom font.
										  ;the name of custom font is stored in element.szfontname...
										  lea ecx,(OBJECT PTR [esi]).szfontname
										.ELSE
											lea ecx,sztimesnewroman
										.ENDIF
										  .IF ebx==0	 ;normal.
												mov nweight,400
										  .ELSEIF ebx==1 ;bold.
												mov nweight,700
										  .ELSEIF ebx==2 ;italic.
												mov nweight,400
												mov fitalic,1
										  .ELSEIF ebx==3 ;bold italic.
												mov nweight,700
												mov fitalic,1
										  .ENDIF
										  mov fstrikethru,0
										  mov funderline,0
										  mov eax,(OBJECT PTR [esi]).ffonteffects
										  test al,01 ;bit0=1 strikethru.
										  jz v01
										  mov fstrikethru,1
v01:									  test al,010b ;bit1=1 underline.
										  jz v02
										  mov funderline,1
v02:									mov edx,(OBJECT PTR [esi]).ncharset
										mov ebx,(OBJECT PTR [esi]).nfontangle
										mov eax,(OBJECT PTR [esi]).nfontsize ;in points.
										neg eax
  ;mov g_errorapi,0AEEh ;for crash outside EVE, error codes range Axxh. v3.23
 invoke CreateFont,eax,0,ebx,ebx,nweight,fitalic,funderline,fstrikethru,edx,OUT_TT_ONLY_PRECIS,0,0,0,ecx
										mov hfontnew,eax
										
  ret
mycreatefont ENDP
;--------------------------------------------------------------------------
paint_grid PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL plock:DWORD
				LOCAL state:BYTE,fnodiv:BYTE, exttype:DWORD
				LOCAL holdfont:DWORD
				LOCAL hpensaved:DWORD
				LOCAL x1:SDWORD,y1:SDWORD,x2:SDWORD,y2:SDWORD,ring:DWORD
				LOCAL textrect:RECT,hbrushold:DWORD
				LOCAL nleft:SDWORD,nright:SDWORD,ntop:SDWORD,nbottom:SDWORD
				LOCAL xedgeadj:SDWORD,yedgeadj:SDWORD
				LOCAL xadj:SDWORD,yadj:SDWORD
				LOCAL nruler:DWORD
				LOCAL hfontnew:DWORD,hfontold:DWORD
				LOCAL zxscreenpixelsx2:DWORD,zyscreenpixelsx2:DWORD
				LOCAL zoomcal:SDWORD,nleft0:SDWORD,ntop0:SDWORD
;this is a method, to display grids.	   "paint_grid"
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF


		  mov esi,pobject
		  mov fnodiv,0

		  mov eax,(OBJECT PTR [esi]).nexttype
		  mov exttype,eax
						  mov eax,(OBJECT PTR [esi]).xtopleft
						  mov x1,eax
						  add eax,(OBJECT PTR [esi]).wwidth
						  mov x2,eax
						  mov eax,(OBJECT PTR [esi]).ytopleft
						  mov y1,eax
						  add eax,(OBJECT PTR [esi]).height
						  mov y2,eax

;v1.30
			  mov eax,(OBJECT PTR [esi]).fconfig3
			  and al,0111000b ;bits 3/4/5. zoom factor calibration.
			  .IF al==0
				mov ecx,0
			  .ELSEIF al==01000b  ;out1.
				mov ecx,1
			  .ELSEIF al==010000b ;out2.
				mov ecx,2
			  .ELSEIF al==011000b ;in1.
				mov ecx,-1
			  .ELSE ;in2.
				mov ecx,-2
			  .ENDIF
			  mov zoomcal,ecx

;v1.29
;choose grid divisions to be inches or centimetres...
		mov eax,(OBJECT PTR [esi]).fconfig3
		and al,011000000b ;bits6 and 7.
		.IF al==0 ;inches.
		  mov ebx,xscreenpixels  ;#pixels per inch.
		  shl ebx,1 	;v1.37 x2
		  mov zxscreenpixelsx2,ebx ;#pixels per grid division.
		  mov ebx,yscreenpixels
		  shl ebx,1 	;v1.37 x2
		  mov zyscreenpixelsx2,ebx
		.ELSE	  ;centimetres.
		  ;1 inch = 2.54 centimetres.
		  mov ebx,xscreenpixels
		  shl ebx,1
		  mov eax,100
		  mul ebx
		  mov ebx,254
		  div ebx
		  mov zxscreenpixelsx2,eax ;# pixels per grid division.
		  mov ebx,yscreenpixels
		  shl ebx,1
		  mov eax,100
		  mul ebx
		  mov ebx,254
		  div ebx
		  mov zyscreenpixelsx2,eax ;# pixels per grid division.
		.ENDIF
						;v1.37 add this...
						;# pixels/division on screen has to get modified by "fineprn"
						;(finetune print size) (as done below for margins)...
						mov eax,zxscreenpixelsx2 ;note 2x #pixels per div.
						;mov ebx,pTERSEDATA
						;mov ecx,(TERSEDATA PTR [ebx]).xfineprn  ;1/10%
						mov ecx,(OBJECT PTR [esi]).bez2x ;v1.38 "xfineprn"
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						sub zxscreenpixelsx2,eax
						mov eax,zyscreenpixelsx2 ;note 2x #pixels per div.
						;mov ebx,pTERSEDATA
						;mov ecx,(TERSEDATA PTR [ebx]).yfineprn  ;1/10%
						mov ecx,(OBJECT PTR [esi]).bez2y ;v1.38 "yfineprn"
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						sub zyscreenpixelsx2,eax
			 ;v1.30 add this...
			 mov ebx,zxscreenpixelsx2
			 mov edx,zyscreenpixelsx2
			 mov ecx,zoomcal
			 .IF SDWORD PTR ecx<0
				  neg ecx
				  sar eax,cl
				  sar edx,cl
				  sar ebx,cl
			 .ELSE
				  sal eax,cl
				  sal edx,cl
				  sal ebx,cl
			 .ENDIF
			 mov zxscreenpixelsx2,ebx
			 mov zyscreenpixelsx2,edx



;draw an ellipse...
;but, it is like a handle...
;JUMP OVER EVERYTHING, cos don't want to print grid at all...
		cmp fprinting,0   ;=0 screen, =1 printer, =2 emf, =3 clipboard.
		jne m91
		;cmp fprinting,2 ;metafile o/p. ;maybe not needed here.
		;je m91 ;bypass this section.
		cmp fhidehandles,1
		je m91

;		   invoke SelectObject,hdc,g_hbrushred	 ;note, it is white if wipeout.
;		   mov hbrushold,eax
		  .IF g_fredrawdiag==WIPEOUTobjs
				   mov eax,x1
				   mov ebx,y1
				   mov ecx,x2
				   mov edx,y2
				   sub eax,6
				   sub ebx,6
				   add ecx,6
				   add edx,6
  ;mov g_errorapi,0AE9h ;for crash outside EVE, error codes range Axxh. v3.23
				   invoke Ellipse,hdc,eax,ebx,ecx,edx
		  .ELSE
  ;mov g_errorapi,0AEAh ;for crash outside EVE, error codes range Axxh. v3.23
			invoke Ellipse, hdc, x1,y1, x2,y2
		  .ENDIF
;		   invoke SelectObject,hdc,hbrushold


		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp fhidehighlighting,1
		je m90
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
hidres: 		mov esi,pobject
				cmp g_perrorobject,esi
				je		oo1
;also have multiple highlighted objects...
				  mov eax,(OBJECT PTR [esi]).fconfig2
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:			  mov g_perrorobject,0	;only do this once.
oo1b:					mov eax,x1 ;(OBJECT PTR [esi]).xtopleft
						mov ebx,y1 ;(OBJECT PTR [esi]).ytopleft
						mov ecx,x2 ;xright
						mov edx,y2 ;ybottom
						sub eax,6
						sub ebx,6
						add ecx,6
						add edx,6
  ;mov g_errorapi,0AEBh ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke CreateEllipticRgn, eax,ebx,ecx,edx 	  ;-->eax=hrgn
				  push eax
  ;mov g_errorapi,0AECh ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:


;need code here to draw the grid...
	  .IF g_fredrawdiag==WIPEOUTobjs
	  .ELSE
		test (OBJECT PTR [esi]).fconfig3,100h ;bit8 =1 hide grid.
		jnz m91
		invoke SelectObject, hdc,g_hpengrey
		mov hpensaved,eax
	  .ENDIF

		  ;draw page boundary first...
		  ;i need to draw the grid right to the printable margins...
		  ;x/yscreenpixels	=screen pixels per inch.
		  ;x/yprintpixels	=paper dots per inch.
		  ;g_nx/yprnpixsize =size of paper in dots.

		  ;i've copied this code from drawprintmargins()...
			mov eax,xwinext_exact ;(see printeranalysis())
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling... (+ve is enlarged)
						;mov ebx,pTERSEDATA
						;mov ecx,(TERSEDATA PTR [ebx]).xfineprn
						mov ecx,(OBJECT PTR [esi]).bez2x ;v1.38 "xfineprn"
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.
						;mov ecx,2		;v1.37 margins have to come in from both sides.
						;sar eax,cl 	;/
						;...v1.38 no.
						  mov xedgeadj,eax ;/
						add eax,xwinext_exact
			mov edx,clientrect.rc_left
			;mov ebx,pTERSEDATA
			;mov ecx,(TERSEDATA PTR [ebx]).nzoom
			mov ebx,xedgeadj ;v1.2
			;v1.28 removed...
			;.IF SDWORD PTR ecx<0
			;	   neg ecx
			;	   sar eax,cl
			;	   sar edx,cl
			;	   sar ebx,cl
			;.ELSE
			;	   sal eax,cl
			;	   sal edx,cl
			;	   sal ebx,cl
			;.ENDIF

			 ;v1.30 add this...
			 mov ecx,zoomcal
			 .IF SDWORD PTR ecx<0
				  neg ecx
				  sar eax,cl
				  sar edx,cl
				  sar ebx,cl
			 .ELSE
				  sal eax,cl
				  sal edx,cl
				  sal ebx,cl
			 .ENDIF

			mov nleft,edx
			;sub nleft,ebx ;v1.2 this will actually increase nleft. v1.38
			add eax,edx
			mov nright,eax

				mov eax,ywinext_exact
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling... (+ve means enlarged)
						;mov ebx,pTERSEDATA
						;mov ecx,(TERSEDATA PTR [ebx]).yfineprn
						mov ecx,(OBJECT PTR [esi]).bez2y ;v1.38 "yfineprn"
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the height has to be reduced if enlarged.
;						 mov ecx,2		;v1.37 margins have to come in from both sides.
;						 sar eax,cl 	;/
;						   mov yedgeadj,eax ;/
;...no, not for vertical, as diag at top of window doesn't shift...
						  mov yedgeadj,0 ;v1.2
						add eax,ywinext_exact
				mov edx,clientrect.rc_top
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov ebx,yedgeadj
				;v1.28 removed...
				;.IF SDWORD PTR ecx<0
				;  neg ecx
				;  sar eax,cl
				;  sar edx,cl
				;  sar ebx,cl
				;.ELSE
				;  sal eax,cl
				;  sal edx,cl
				;  sal ebx,cl
				;.ENDIF

				  ;v1.30 add this...
				  mov ecx,zoomcal
				  .IF SDWORD PTR ecx<0
					neg ecx
					sar eax,cl
					sar edx,cl
					sar ebx,cl
				  .ELSE
					sal eax,cl
					sal edx,cl
					sal ebx,cl
				 .ENDIF

				mov ntop,edx
				sub ntop,ebx ;v1.2 this will actually increase ntop.(but ebx=0 as not using this)
				add eax,edx
				mov nbottom,eax
		  ;...now we have the paper margins (in screen coords), as nleft,nright,ntop,nbottom.

		  ;however, need to be shifted to track grid-element...
		  ;x2/y2 are the element right/bottom coords...
		  mov eax,x2
		  sub eax,nleft
		  mov xadj,eax
		  mov eax,y2
		  sub eax,ntop
		  mov yadj,eax
			mov eax,x2
			mov nleft,eax
			mov eax,y2
			mov ntop,eax
			mov eax,xadj
			add nright,eax
			mov eax,yadj
			add nbottom,eax

			;now draw the margins...
  ;mov g_errorapi,0AEDh ;for crash outside EVE, error codes range Axxh. v3.23
			invoke MoveToEx, hdc,nright,ntop,0
			invoke LineTo, hdc,nright,nbottom
			invoke LineTo, hdc,nleft,nbottom
			invoke LineTo, hdc,nleft,ntop
			invoke LineTo, hdc,nright,ntop
			;.IF xedgeadj==0 ;v1.2
			;.ELSE
			;	 invoke LineTo,hdc,nleft,ntop ;left margin.
			;.ENDIF

      ;v3.42 i would like to save these paper dimensions in the element.
      ;nearobjects() can use them, to ensure paper grid correctly gets redrawn...
      mov eax,nright
      sub eax,nleft
      mov (OBJECT PTR [esi]).pagewidth,eax
      mov eax,nbottom
      sub eax,ntop
      mov (OBJECT PTR [esi]).pageheight,eax

		  ;now can draw the actual grid...

			  ;v1.42
			  ;can hide the division lines...
			  mov fnodiv,0
			  mov eax,(OBJECT PTR [esi]).fconfig3
			  and ax,400h ;bit10.
			  .IF ax==400h
				mov fnodiv,1 ;used below.
			  .ENDIF

								  ;create a font...
									invoke mycreatefont      ;enter esi->element. v3.50
									mov hfontnew,eax         ;/
									invoke SelectObject,hdc,eax
									mov hfontold,eax
										.IF g_fredrawdiag==WIPEOUTobjs
										  ;xpaint_wipeout has already set color to white.
										.ELSE
										  mov eax,(OBJECT PTR [esi]).nfontcolor
										  invoke SetTextColor,hdc,eax
										.ENDIF

		  mov eax,nright
		  sub eax,nleft ;width.
		  shl eax,1 		  ;v1.37
		  xor edx,edx
		  div zxscreenpixelsx2 ;number of inch/cm divisions.
		  mov ecx,eax
			mov edi,0 ;v1.37 nleft
			mov nruler,0 ;text for each grid line.
nx1:		  push ecx							;draw vertical lines.
			  inc nruler
			  add edi,zxscreenpixelsx2 ;x2 actual pixels/div.
			  mov eax,edi	;v1.37
			  shr eax,1 	;/
			  add eax,nleft ;/
			  push eax
			  invoke MoveToEx,hdc,eax,ntop,0
			  pop eax
			  push eax
			  .IF fnodiv==0
				invoke LineTo,hdc,eax,nbottom
			  .ENDIF
			  pop edx
				;and the text...
				mov eax,nruler
				invoke bin2dec,10
				mov ebx,ntop
				sub ebx,13
				mov ecx,edx ;edi
				sub ecx,4
				invoke TEXTOUTx,hdc,ecx,ebx,eax,10
			  pop ecx
			  loop nx1
		  ;now draw horiz lines...
		  mov eax,nbottom
		  sub eax,ntop ;height.
		  shl eax,1    ;v1.37
		  xor edx,edx
		  div zyscreenpixelsx2 ;number of inch divisions.
		  mov ecx,eax
			mov edi,0 ;ntop
			mov nruler,0 ;text for each grid line.
nx0:		  push ecx							;draw horizontal lines.
			  inc nruler
			  add edi,zyscreenpixelsx2
			  mov eax,edi	;v1.37
			  shr eax,1 	;v1.37
			  add eax,ntop	;/
			  push eax		;/
			  invoke MoveToEx,hdc,nleft,eax,0
			  pop eax
			  push eax
			  .IF fnodiv==0
				invoke LineTo,hdc,nright,eax
			  .ENDIF
			  pop edx
				;and the text...
				mov eax,nruler
				invoke bin2dec,10
				mov ebx,nleft
				sub ebx,12
				mov ecx,edx ;edi
				sub ecx,7
				invoke TEXTOUTx,hdc,ebx,ecx,eax,10
			  pop ecx
			  loop nx0


			  ;...have drawn grid, but have added option of inter-division
			  ;dashed lines...
			  mov eax,(OBJECT PTR [esi]).fconfig3
			  and ax,200h ;bit9.
			  .IF ax==200h
				;well, we need to select a dashed line...
				.IF g_fredrawdiag==WIPEOUTobjs
				.ELSE
				  invoke SelectObject, hdc,g_hpengreydashed ;no need to save old pen.
				.ENDIF
				mov eax,nright
				sub eax,nleft ;width.
				shl eax,1 ;v1.37
				xor edx,edx
				div zxscreenpixelsx2 ;number of inch/cm divisions.
				mov ecx,eax
				mov edi,nleft
				mov eax,zxscreenpixelsx2
				shr eax,1 ;get line between divisions.
				shr eax,1 ;v1.37
				sub edi,eax ;/
				mov nleft0,edi
				mov edi,0
				mov nruler,0 ;text for each grid line.
xnx1:			 push ecx						   ;draw vertical lines.
				 inc nruler
				 add edi,zxscreenpixelsx2
				 mov eax,edi
				 shr eax,1
				 add eax,nleft0
				 push eax
				 invoke MoveToEx,hdc,eax,ntop,0
				 pop eax
				 invoke LineTo,hdc,eax,nbottom
				 pop ecx
				 loop xnx1
			   ;now draw horiz lines...
			   mov eax,nbottom
			   sub eax,ntop ;height.
			   shl eax,1 ;v1.37
			   xor edx,edx
			   div zyscreenpixelsx2 ;number of inch divisions.
			   mov ecx,eax
			   mov edi,ntop
				mov eax,zyscreenpixelsx2
				shr eax,1 ;get line between divisions.
				shr eax,1 ;v1.37
				sub edi,eax ;
				mov ntop0,edi
				mov edi,0
			   mov nruler,0 ;text for each grid line.
xnx0:			push ecx						  ;draw horizontal lines.
				inc nruler
				add edi,zyscreenpixelsx2
				mov eax,edi
				shr eax,1
				add eax,ntop0
				push eax
				invoke MoveToEx,hdc,nleft,eax,0
				pop eax
				invoke LineTo,hdc,nright,eax
				pop ecx
				loop xnx0
			  .ENDIF


		;*???* check this again. i read somewhere about metafiles ignoring these funcs...
		cmp fprinting,2 ;metafile o/p.
		je m92 ;bypass this section.
		invoke SelectObject,hdc,hfontold
		invoke DeleteObject,hfontnew
	  .IF g_fredrawdiag==WIPEOUTobjs
	  .ELSE
		invoke SelectObject, hdc,hpensaved
	  .ENDIF
m92:


m91:  ret

paint_grid ENDP
;--------------------------------------------------------------------------
common_paint_icon PROC STDCALL USES eax ebx edx esi edi,hdc:DWORD, \
				pobject:DWORD,xright:SDWORD,ybottom:SDWORD
				LOCAL hpensave:DWORD,hfontold:DWORD,hfontnew:DWORD
				LOCAL textrect:RECT,pdata:DWORD
				LOCAL xend:SDWORD, yend:SDWORD
				LOCAL plock:DWORD
				;LOCAL nweight:DWORD,fitalic:DWORD,funderline:DWORD,fstrikethru:DWORD
;common code extracted from paint_exec and paint_info...

;now to display text on the object...
;text is stored in a data element, so get code from paint_label (label-element)...
		  mov esi,pobject
		  mov hpensave,0


								  ;create a font...
									invoke mycreatefont      ;enter esi->element. v3.50
									mov hfontnew,eax         ;/
									invoke SelectObject,hdc,eax
									mov hfontold,eax
										.IF g_fredrawdiag==WIPEOUTobjs
										  ;xpaint_wipeout has already set color to white.
										.ELSE
										  mov eax,(OBJECT PTR [esi]).nfontcolor
  ;mov g_errorapi,0AF0h ;for crash outside EVE, error codes range Axxh. v3.23
										  invoke SetTextColor,hdc,eax
										.ENDIF

		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
				mov esi,pobject
				cmp g_perrorobject,esi
				je		oo1
;also have multiple highlighted objects...

;v3.19 split up, leave colr-toggle, cut out visibility-toggle to earlier...
;sequence for this func now: toggle-visibility>paint-element>toggle-color>invertrgn.
;v3.19 changed, include locked child visibility toggle...
;v2.73 want to invert if a locked child of a flashing animated element
      invoke colortoggle_paint,0 ;0=toggle invert. v3.44
      .IF eax==0
        jmp oo1b ;invert.
      .ENDIF

    ;v2.81 have moved this fhidehighlighting test down, don't block color animation...				
		cmp fhidehighlighting,1 ;same as TERSEDATA.fviewprefs/bit3.
		je m90 ;bypass inversion.
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
  ;mov g_errorapi,0AF1h ;for crash outside EVE, error codes range Axxh. v3.23
 invoke CreateRectRgn, (OBJECT PTR [esi]).xtopleft,\
												(OBJECT PTR [esi]).ytopleft,\
										 xright,ybottom 		;-->eax=hrgn
				  push eax
  ;mov g_errorapi,0AF2h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:

;now to display text on the object...first x-coord...
		;xor eax,eax
		mov eax,(OBJECT PTR [esi]).fstatus
		and ax,0100000b 		   ;extract bit 5
		.IF ax==0100000b				;bit5=1, display label.
				mov  eax,(OBJECT PTR [esi]).xtopleft ;xmid
				add  eax,(OBJECT PTR [esi]).wwidth ;30 ;10
				inc eax
				inc eax
				  ;offset text, from OBJECT.x/ylabeloffset ....
				  mov ecx,eax
				  mov eax,(OBJECT PTR [esi]).xlabeloffset				;x offset (signed)
				  add ecx,eax	;new x-coord.
				mov  textrect.rc_left,ecx
;now y-coord...
				mov  ebx,(OBJECT PTR [esi]).ymid
				sub  ebx,9
				mov eax,(OBJECT PTR [esi]).ylabeloffset ;y offset (signed)
				add ebx,eax ;new y-coord
				mov  textrect.rc_top,ebx

				mov ebx,(OBJECT PTR [esi]).rpdata		;data-element.
				.IF ebx==0
				  jmp notxt
				.ELSE
				  add ebx,pTERSEDATA
				  lea edx,(OBJECT PTR [ebx]).sztext ;start of data area.
				  mov pdata,edx
				.ENDIF
  ;mov g_errorapi,0AF3h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke DrawText, hdc,edx,-1,ADDR textrect,DT_CALCRECT
				  invoke DrawText, hdc,pdata,-1,ADDR textrect,DT_NOCLIP+DT_NOPREFIX
		.ENDIF
notxt:


;now draw a line from label to parent-object...
;*BUG* was working, but some stray lines...
;		   ;only for g_nstate>0...
;		   cmp g_nstate,0
;		   je pass1

;*BUG* tried further restriction, still not right...
;		 cmp esi,g_pselectedobject ;restrict so only highlighted object has grey line.
;		 jne pass1										  ;/

;		 mov eax,(OBJECT PTR [esi]).rpowner1  ;non-0 if cmt locked to parent.
;														 ;ALL OBJECT PTRS RELATIVE TO START OBJECTS...
;														 ;assuming eax has value to be written...
;														 .IF eax==0
;														 .ELSE
;														   add eax,pTERSEDATA
;														 .ENDIF
;		 mov plock,eax
;		 .IF eax==0 	 ;do nothing, as not locked.
;		 .ELSE
;
;				 ;note, wmlbuttondown()/state4 determined which ring of parent
;				 ;node the label is on, and stored it in .nbeginring.
;				 ;this is now passed to a global variable "g_nsnapring",
;				 ;which snap_tonode() (the only snap_ method that an label obj
;				 ;will call, as it can only be attached to anode) to use
;				 ;to snap xend/yend to that ring...
;				 ;xor eax,eax
;				 mov eax,(OBJECT PTR [esi]).nbeginring
;				 mov g_nsnapring,eax
;
;				 mov ebx,(OBJECT PTR [esi]).xmid ;addr of middle of comment.
;				 mov xend,ebx									  ;/
;				 mov ebx,(OBJECT PTR [esi]).ymid ;/
;				 mov yend,ebx									  ;/
;								   ;now, IMPORTANT ... call snap_ method of PARENT obj...
;								   mov edi,plock
;								   mov	ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
;								   ;(relative to "ptrs", which is start of the methods table)
;								   mov eax,(OBJECT PTR [esi]).nbeginverticex ;poly vertice already on.
;								   ;...note, exttype<30 uses .nbeginvertice field for this.
;				 invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
;				 ;...will return nearest point on boundary of parent, in xend/yend.
;						 mov (OBJECT PTR [esi]).nbeginverticex,ebx ;snapped vertice if to poly.
;		   ;now draw line...
;		   mov ecx,(OBJECT PTR [esi]).xmid		;comment middle
;		   mov edx,(OBJECT PTR [esi]).ymid		;/
;		   invoke MoveToEx, hdc, ecx,edx,0
;
;						 .IF g_fredrawdiag==WIPEOUTobjs
;						   invoke LineTo, hdc, xend,yend
;						 .ELSE
;						   invoke SelectObject, hdc,g_hpengrey
;						   mov hpensave,eax
;						   invoke LineTo, hdc, xend,yend
;						   invoke SelectObject, hdc,hpensave
;						 .ENDIF
;		 .ENDIF
;pass1:

;*???* check this again. i read somewhere about metafiles ignoring these funcs...
		cmp fprinting,2 ;metafile o/p.
		je m91 ;bypass this section.
		  invoke SelectObject,hdc,hfontold
		  invoke DeleteObject,hfontnew
m91:

		ret
common_paint_icon ENDP
;--------------------------------------------------------------------------
.DATA?
ALIGN 4 ;v3.24
mygifinfo		  GIF_INFO		  <>
;hDCBitmap		 dd  ?
;hBitmap		 dd  ?
;.DATA
;BitmapInfo   BITMAPINFOHEADER	  <>
;ColorTable   db 256*4 DUP(?)  ; 32*4 dup (?)			 ;*MUST* BE AFTER BitmapInfo!!!!!
;GifFileName	 db  "test image.gif",0 		 ;!!!! Thegiffilename*TEST*
;.DATA

.CODE
common_paint_bitmap PROC STDCALL USES ebx ecx edx esi edi,hdc:DWORD,pobj:DWORD
		LOCAL pdata2:DWORD,pmem:DWORD,p1stdataelement:DWORD
		LOCAL widthpixels:DWORD,heightpixels:DWORD
		LOCAL widthhimetric:DWORD,heighthimetric:DWORD
		LOCAL zoom:SDWORD
		LOCAL hdcpict:DWORD,hdcold:DWORD
		LOCAL oldmode:DWORD,rgbbk:DWORD,nrgbtransparent:DWORD
;		 LOCAL	 bitptr:DWORD,hcompatdc:DWORD
; "common_paint_bitmap"
;called from paint_info, paint_exec, paint_eve ...the icons.
;pobj.rpdata2 !=0 pts to a GIF/jpg/bmp/wmf file, as a chain of data-elements.
; -- see insertbitmap() and choosebitmap().
;first data-element has .xdata=filesize, .fstatus/bit4/3=1/1 means GIF,
;.rpdata->next data-element, else 0.

		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).nzoom
		mov zoom,eax

		mov edi,pobj
		;precaution...
		mov eax,(OBJECT PTR [edi]).rpdata2
		or eax,eax ;cmp eax,0
		je oe1
		add eax,pTERSEDATA
		mov p1stdataelement,eax

		;"hDCBitmap" is stored inside the 1stdataelement.ximage
		;icon.rpdata2 -> 1st data element.
		;the width and height should be stored in the icon,
		;icon xtopleft/ytopleft are top/left coords of image...
		mov ebx,eax
;		 add ebx,pTERSEDATA
		mov eax,(OBJECT PTR [ebx]).ximage ;=0 if no expanded image.
		.IF eax==0

		  ;read the chained-data-elements to a contiguous block...
		  invoke mygifload,ADDR mygifinfo,pobj,0
		  ;...returns eax->block, else=0.
		  ;...writes file size and start address of block into mygifinfo.
		  mov pmem,eax

		  invoke creategifhdc,pobj,pmem,p1stdataelement
		  ;...will also load 1stdataelement.ximage and icon.wwidth/height.
		  mov pmem,0 ;finished using it.
		  .IF eax != 0  ;v2.94.
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
		    invoke myalertbox,ADDR szer300,822h ;eax ;invoke myerrorhandler,eax ;error rendering picture.
		    ;i think need to detach picture from icon...
		    mov ebx,pobj
        mov (OBJECT PTR [ebx]).rpdata2,0
		    jmp SHORT oe1
		  .ENDIF
		.ELSE
		  ;1stdataelement.ximage =hDCBitmap of expanded image...
		.ENDIF

		;width/height in pixels...
		mov esi,(OBJECT PTR [edi]).wwidth
		mov widthpixels,esi
		mov ebx,(OBJECT PTR [edi]).height
		mov heightpixels,ebx
		;width/height in himetric units...
		mov esi,(OBJECT PTR [edi]).widthhimetric
		mov widthhimetric,esi
		mov ebx,(OBJECT PTR [edi]).heighthimetric
		mov heighthimetric,ebx

		mov ebx,p1stdataelement

		;special code for rendering wmf picture...
		mov eax,(OBJECT PTR [ebx]).fstatus
		test al,01000000b ;bit6=1 if picture is wmf.
		jnz spec1

;v2.93 comment out for now...
;      ;v2.90 experiment... convert ipicture to bitmap and use bitblt()...
;    mov eax,(OBJECT PTR [ebx]).fconfig1
;    and al,80h ;bit7=1 use transparent color.
;    .IF al != 0
;      ;invoke GetDeviceCaps,hdc,CAPS1 ;enquire if device driver can do transparent.
;      .IF fdrivertransparent != 0 ;eax==C1_TRANSPARENT (done in wmcreate()).
;          invoke SetBkMode,hdc,NEWTRANSPARENT
;          mov oldmode,eax
;          mov eax,(OBJECT PTR [edi]).rgbtransparent
;          invoke SetBkColor,hdc,eax
;          mov rgbbk,eax
;        invoke CreateCompatibleDC,hdc
;        mov hdcpict,eax
;          ;now call ipicture::SelectPicture(hdcpict,&hdcold,0);
;          push 0
;          lea eax,hdcold
;          push eax
;          push hdcpict
;          mov ebx,p1stdataelement
;          mov eax,(OBJECT PTR [ebx]).ximage
;          push eax
;          mov edx,DWORD PTR [eax]
;          call DWORD PTR [edx+GPSelectPicture]
;        mov eax,hdcpict ;need handle of bitmap in eax.
;        mov ecx,(OBJECT PTR [edi]).xtopleft
;        mov edx,(OBJECT PTR [edi]).ytopleft
;        mov esi,(OBJECT PTR [edi]).wwidth  ;mygifinfo.dwImageWidth
;        mov edi,(OBJECT PTR [edi]).height  ;mygifinfo.dwImageHeight
;        invoke BitBlt,hdc,ecx,edx,esi,edi,eax,0,0,SRCCOPY
;          ;now call ipicture::SelectPicture(hdcold,0,0);
;          push 0
;          push 0
;          push hdcold
;          mov ebx,p1stdataelement
;          mov eax,(OBJECT PTR [ebx]).ximage  ;gpPicture
;          push eax
;          mov edx,DWORD PTR [eax]
;          call DWORD PTR [edx+GPSelectPicture]
;        invoke DeleteObject,hdcpict
;          invoke SetBkColor,hdc,rgbbk
;          invoke SetBkMode,hdc,oldmode
;        jmp oe1 ;bypass ::Render().
;      .ELSEIF fNT>=5 ;NT5+ OS version supports TransparentBlt().
;        invoke CreateCompatibleDC,hdc
;        mov hdcpict,eax
;          ;now call ipicture::SelectPicture(hdcpict,&hdcold,0);
;          push 0
;          lea eax,hdcold
;          push eax
;          push hdcpict
;          mov ebx,p1stdataelement
;          mov eax,(OBJECT PTR [ebx]).ximage
;          push eax
;          mov edx,DWORD PTR [eax]
;          call DWORD PTR [edx+GPSelectPicture]
;        ;mov eax,hdcpict ;need handle of bitmap in eax.
;        mov eax,(OBJECT PTR [edi]).rgbtransparent
;        mov nrgbtransparent,eax
;        mov eax,(OBJECT PTR [edi]).origwidth
;        mov ebx,(OBJECT PTR [edi]).origheight
;        mov ecx,(OBJECT PTR [edi]).xtopleft
;        mov edx,(OBJECT PTR [edi]).ytopleft
;        mov esi,(OBJECT PTR [edi]).wwidth  ;mygifinfo.dwImageWidth
;        mov edi,(OBJECT PTR [edi]).height  ;mygifinfo.dwImageHeight
;        ;v2.90
;        ;invoke BitBlt,hdc,ecx,edx,esi,edi,eax,0,0,SRCCOPY
;        invoke TransparentBlt,hdc,ecx,edx,esi,edi,hdcpict,0,0,eax,ebx,nrgbtransparent
;          ;now call ipicture::SelectPicture(hdcold,0,0);
;          push 0
;          push 0
;          push hdcold
;          mov ebx,p1stdataelement
;          mov eax,(OBJECT PTR [ebx]).ximage  ;gpPicture
;          push eax
;          mov edx,DWORD PTR [eax]
;          call DWORD PTR [edx+GPSelectPicture]
;        invoke DeleteObject,hdcpict
;        jmp oe1 ;bypass ::Render().
;      .ENDIF
;    .ENDIF

		mov eax,(OBJECT PTR [ebx]).ximage ;gpPicture ;hDCBitmap
		.IF eax != 0 ;precaution.
  ;mov g_errorapi,0AF4h ;for crash outside EVE, error codes range Axxh. v3.23
		  mov ecx,(OBJECT PTR [edi]).xtopleft
		  mov edx,(OBJECT PTR [edi]).ytopleft
   ;									// display picture using IPicture::Render
   ; gpPicture->Render(hdc, 0, 0, nWidth, nHeight, 0, hmHeight, hmWidth, -hmHeight, &rc);
;		 lea ebx,clientrect
;		 push	   ebx ;0		;really need addr of client rect here. ? (for wmf file)
		  push 0
		  mov   ebx,heighthimetric				 ;needs to be -ve, otherwise picture
		  neg   ebx												 ;displays upside down. see also below topcorner.
		  push	  ebx ;heighthimetric					 ;y height to copy from source picture. himetric
		  push	  widthhimetric 						;x width to copy from source picture.	units.
		  push	  heighthimetric						;upper-left corner of source,  NOTE, not 0.
		  push	  0 											 ; / himetric units.
		  push	  heightpixels									 ;height  diagram coords.
		  push	  widthpixels									 ;wwidth		 /
		  push	  edx ;0												 ;y upper-left corner,
		  push	  ecx ;0												 ;x diagram coords.
		  push	  hdc											;hdc.
;		mov   eax,dword ptr gpPicture
		  push	  eax
		  mov   edx,dword ptr [eax]
		  call	  dword ptr [edx+GPRender]   ;32 v2.90
    .ENDIF
    
oe1:
		ret
;.....
spec1:
;special code for painting wmf pictures...
;doesn't scale, also offset when zoomed in or out. &&&
;*BUG* CURRENTLY DOES NOT WORK !!!! ONLY DISPLAYS CORRECTLY AT 100% ZOOM *BUG*
;-- MAYBE ONLY WORKS FOR MM_TEXT MAPPING?

				;i got this out of isobjectinwindow()...
				mov eax,(OBJECT PTR [edi]).xtopleft
				mov edx,(OBJECT PTR [edi]).ytopleft
				mov  ecx,zoom					;+ve=zoomed-out, -ve=zoomed-in
				.IF SBYTE PTR cl>0
				  sar  eax,cl
				  sar edx,cl
				  ;sar heightpixels,cl
				  ;sar widthpixels,cl
				.ELSEIF SBYTE PTR cl<0
				  neg  cl
				  sal  eax,cl
				  sal  edx,cl
				  ;sal heightpixels,cl
				  ;sal widthpixels,cl
				.ENDIF									;0=normal size.
				mov ecx,eax

  ;mov g_errorapi,0AF5h ;for crash outside EVE, error codes range Axxh. v3.23
		mov eax,(OBJECT PTR [ebx]).ximage ;gpPicture ;hDCBitmap

   ;									// display picture using IPicture::Render
   ; gpPicture->Render(hdc, 0, 0, nWidth, nHeight, 0, hmHeight, hmWidth, -hmHeight, &rc);
;		 lea ebx,clientrect
;		 push	   ebx ;0		;really need addr of client rect here. ? (for wmf file)
		push 0
		mov   ebx,heighthimetric				 ;needs to be -ve, otherwise picture
		neg   ebx												 ;displays upside down. see also below topcorner.
		push	  ebx ;heighthimetric					 ;y height to copy from source picture. himetric
		push	  widthhimetric 						;x width to copy from source picture.	units.
		push	  heighthimetric						;upper-left corner of source,  NOTE, not 0.
		push	  0 											 ; / himetric units.
		push	  heightpixels									 ;height  diagram coords.
		push	  widthpixels									 ;wwidth		 /
		push	  edx ;0												 ;y upper-left corner,
		push	  ecx ;0												 ;x diagram coords.
		push	  hdc											;hdc.
;		mov   eax,dword ptr gpPicture
		push	  eax
		mov   edx,dword ptr [eax]
		call	  dword ptr [edx+GPRender]  ;32 v2.90

		jmp oe1 ;ret.
common_paint_bitmap ENDP
;------------------------------------------------------------------------
.CODE ;.DATA v3.01
;default gif image, <256 bytes... 251 bytes, 32-color gif...
eveimage \
 DB 47h,49h,46h,38h,37h,61h,10h,00h,0Ch,00h,0F4h,00,00,3Ah,32h,1Dh						   ;GIF87a.......:2.
 DB 0B1h,9Ah,75h,0CCh,0BFh,0A8h,6Ch,5Ch,3Dh,0FBh,0E1h,0BBh,87h,73h,54h,0E3h    ;..u...l\=....sT.
 DB 0C1h,97h,0BFh,0A0h,7Bh,0F5h,0F2h,0E8h,0C8h,0C6h,0C2h,9Dh,85h,60h,0F5h,0CDh ;....{........`..
 DB 0A1h,0BAh,0ACh,96h,4Eh,43h,2Bh,0A2h,9Ch,8Dh,0F6h,0D6h,0ACh,0C8h,0ABh,83h   ;....NC+.........
 DB 0E3h,0E0h,0DAh,81h,7Ah,6Bh,6Fh,68h,57h,0DAh,0CCh,0B6h,0DBh,0BDh,96h,0FEh   ;....zkohW.......
 DB 0FBh,0F2h,0FBh,0EBh,0D1h,44h,3Bh,21h,90h,7Bh,5Ah,62h,54h,39h,73h,63h		   ;.....D;!.{ZbT9sc
 DB 42h,0D0h,0B1h,87h,0D1h,0CEh,0C8h,0A2h,8Eh,69h,0FFh,0FFh,0FFh,2Ch,00h,00h   ;B........i...,..
 DB 00h,00h,10h,00h,0Ch,00h,00h,05h,80h,0E0h,27h,8Eh,0A2h,85h,5Ch,17h			   ;..........'...\.
 DB 0F1h,28h,4Eh,79h,0Ah,0D1h,0B5h,70h,4Bh,0BDh,28h,98h,0BAh,18h,4Bh,30h		   ;.(Ny...pK.(...K0
 DB 70h,86h,43h,0AFh,0B0h,69h,60h,76h,1Ch,0C5h,6Ch,0B0h,38h,08h,31h,98h 		   ;p.C..i`v..l.8.1.
 DB 44h,07h,0B1h,18h,60h,24h,95h,0CAh,64h,91h,11h,42h,38h,84h,8Ch,63h			   ;D...`$..d..B8..c
 DB 0E1h,09h,04h,20h,8Fh,4Ch,55h,68h,9Bh,1Ch,6Bh,8Ah,0C2h,6Ch,0D1h,10h			   ;... .LUh..k..l..
 DB 1Eh,3Ch,05h,0E3h,0A2h,50h,18h,0C8h,77h,00h,42h,6Eh,1Dh,22h,0Bh,50h			   ;.<...P..w.Bn.".P
 DB 1Dh,16h,35h,07h,81h,0Bh,6Eh,26h,89h,1Eh,1Eh,02h,0Eh,15h,5Ch,8Ch 	   ;..5...n&......\.
 DB 0Fh,98h,1Ch,6Fh,33h,18h,01h,55h,8Ch,36h,9Ah,14h,14h,06h,0Ch,13h 	   ;...o3..U.6......
 DB 0Eh,02h,12h,13h,0A3h,0ACh,0Ch,0Eh,21h,00h,3Bh,86h,47h,18h,0A2h,18h			   ;........!.;.G...
   ;...actually, 3Bh is the last character in the gif file.

.CODE
mygifload PROC STDCALL USES ebx ecx edx esi edi,pmygifinfo:DWORD, \
		pobj:DWORD,fdelete:DWORD
		LOCAL pdata2:DWORD,sizegif:DWORD,pmem:DWORD
;    LOCAL pgifextpackedf:DWORD,pgiftranscolor:DWORD
;		LOCAL pgifcolortable:DWORD,pendgif:DWORD
    LOCAL fisgif:DWORD
; "mygifload"
;read gif file from data-elements to a contiguous block.
;return eax->block, else =0.

;dataelement.rpdata->child dataelement, else =0 end of chain.
;head-dataelement.xdata =size of gif file.
;pobj->element/icon that has an attached data-element-chain.
;icon.rpdata2->head-of-chain-data-element.
;fdelete=1 delete the picture. delete data-elements in chain,
;load a dummy gif into 1st data-element.

;v1.23 fdelete=-1, then pobj = direct address of first data element.

		mov edi,pmygifinfo

	  .IF fdelete==-1
		mov eax,pobj	;v1.23
	  .ELSEIF fdelete==2 ;v1.55
		  ;pobj-->actual data element...
		  mov eax,pobj
		  mov fdelete,0
	  .ELSE
		  mov esi,pobj
		  mov eax,(OBJECT PTR [esi]).rpdata2
		  add eax,pTERSEDATA
	  .ENDIF

		mov pdata2,eax			;start of gif file, data-elements.
		  mov ebx,pdata2
		  mov eax,(OBJECT PTR [ebx]).xdata ;size of gif file.
		  mov (GIF_INFO PTR [edi]).dwGIFDataSize,eax
		  mov sizegif,eax
		  
    ;v2.91 record if it's gif format...
    mov fisgif,0
    mov ecx,(OBJECT PTR [ebx]).fstatus
    and ecx,01000011000b ;bits 9/4/3 set if gif.
    .IF ecx != 0
      mov fisgif,1
    .ENDIF

;now a memory block...
		add eax,256 ;precaution, make block a bit bigger.
  ;mov g_errorapi,0AF6h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GlobalAlloc,GMEM_FIXED,eax
		mov (GIF_INFO PTR [edi]).lpGIFData,eax	  ;ptr to gif file.
		mov pmem,eax

;now copy the data across...
		mov ebx,pdata2 ;pts to 1st data-element.
		mov edi,pmem
k11:
		 lea esi,(OBJECT PTR [ebx]).sztext ;where data starts inside dataelement.
		 push ebx
		   ;invoke lstrcpyn,edi,esi,256  ---agh! seems to terminate on first zero.
		   mov ecx,256
j11:   mov al,[esi]
		   mov [edi],al
		   inc esi
		   inc edi
		   loop j11
		 pop ebx
		 ;add edi,256
		 mov eax,(OBJECT PTR [ebx]).rpdata ;next data element.
		 or eax,eax ;cmp eax,0
		 je kdone
		 add eax,pTERSEDATA
		 mov ebx,eax
		   .IF fdelete==1
				 ;invalidate the data-element...
				 mov (OBJECT PTR [ebx]).fstatus,0
		   .ENDIF
		 jmp k11
kdone:

;if fdelete=1, have invalidated dataelements in chain, except the 1st.
;now, need to load a default graphic into first data element, and
;return 0...
		.IF fdelete==1
		  mov esi,pdata2 ;1st dataelement.
		  mov (OBJECT PTR [esi]).fstatus,01000011001b ;bits9/4/3 =1/1/1 gif image. bit0=1 valid obj.
		  mov (OBJECT PTR [esi]).rpdata,0 ;no more dataelements.
		  mov (OBJECT PTR [esi]).ximage,0
		  ;...should already be 0, as only call this func when need to
		  ;create a new expanded image (only done once when icon 1st drawn).
		  mov (OBJECT PTR [esi]).xdata,251 ;size of graphic image.
		  lea edi,(OBJECT PTR [esi]).sztext ;start of data area.
		  lea ebx,eveimage
		  mov ecx,256
t55:  mov al,[ebx]
		  mov [edi],al
		  inc ebx
		  inc edi
		  loop t55
  ;mov g_errorapi,0AF7h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke GlobalHandle,pmem
		  invoke GlobalFree,eax ;pmem ;not going to use it this time.
		  mov pmem,0
		.ENDIF

    ;v2.93 this code crashes sometimes.... put in limit checking...
    ;v2.91
    ;if a gif, i want to read the transparent color...
    invoke getgiftransparent,pmem,sizegif,pdata2,fisgif
    ;...writes to 1stdata.end01.
    

		mov eax,pmem
		ret
mygifload ENDP
;--------------------------------------------------------------------------
getgiftransparent PROC STDCALL USES eax ebx ecx edx esi edi, \
  pmem:DWORD,sizegif:DWORD,pdata2:DWORD,fisgif:DWORD
  LOCAL pgiftranscolor:DWORD,pgifextpackedf:DWORD,pgifcolortable:DWORD
  LOCAL pendgif:DWORD
; "getgiftransparent"
;pdata2->1st data element. pmem->contiguous block of image.
;fisgif=0 not gif, =1 is gif, >1 ptr to picture icon.
;in last case, write r/g/b to .rgbtransparent.
;saves color info in 1stdata.end01 (immediately after 256bytes data).

    mov pgifextpackedf,0
    mov pgiftranscolor,0
    mov ebx,pmem
    mov eax,ebx     ;v2.93
    add eax,sizegif ;/
    mov pendgif,eax ;/
    .IF ebx != 0
      .IF fisgif != 0
        mov al,[ebx+3] ;should have "gif89a"
        .IF al=="8"
          mov al,[ebx+4]
          .IF al=="9"
            mov al,[ebx+10] ;packed fields.
            and al,80h
            add ebx,13 ;start of color table.
            mov pgifcolortable,ebx
            .IF al != 0 ;bit7=1 there is a color table.
              xor eax,eax
              mov al,[ebx-2] ;color index.
              inc al
              mov ecx,eax
              mov eax,1
              shl eax,cl
              mov ecx,3
              mul ecx ;now have size of color table in eax.
              add ebx,eax ;pt to next past color table.
              .IF ebx>=pendgif ;v2.93 off end.
                jmp ex3 ;error.
              .ENDIF
            .ENDIF
            mov al,[ebx]
            .IF al==21h ;graphic control extension identifier1
              mov al,[ebx+1]
              .IF al==0F9h ;identifier2.
                mov al,[ebx+2]
                .IF al==4 ;block size, always 4.
                  add ebx,3
                  mov al,[ebx] ;this is the packed fields.
                  mov pgifextpackedf,ebx
                  and al,01 ;bit0=1 there is a transparent color index.
                  .IF al != 0
                    add ebx,3 ;ebx is the transparent color index.
                    xor eax,eax
                    mov al,[ebx] ;color index.
                    mov ecx,3
                    mul ecx ;now have offset into color table in eax.
                    mov ebx,pgifcolortable
                    add ebx,eax
                    mov pgiftranscolor,ebx
                  .ENDIF
                .ENDIF
              .ENDIF
            .ENDIF
          .ENDIF
        .ENDIF
      .ENDIF
    .ELSE ;pmem=0
      jmp SHORT ex3
    .ENDIF
    ;store transparent color offsets at end of 1st data element...
    mov ebx,pdata2
    mov eax,pgiftranscolor
    .IF ebx != 0 ;precaution.
      .IF eax != 0
        sub eax,pmem ;make into offset start of data block.
        shl eax,16
        mov ecx,pgifextpackedf
        sub ecx,pmem ;make into offset
        mov ax,cx
        mov (OBJECT PTR [ebx]).end01,eax
      .ELSE
ex3:    mov ebx,pdata2
        mov (OBJECT PTR [ebx]).end01,0
      .ENDIF
    .ENDIF

    ;v2.95
    .IF fisgif>1 ;ptr direct to icon (picture is attached to an icon).
      mov edi,fisgif
      mov ebx,pgiftranscolor
      mov eax,pgifextpackedf
      and al,01 ;bit0=1 has trans color.
      .IF al != 0
        .IF ebx != 0
          mov eax,[ebx] ;red
          and eax,0FFh
          mov (OBJECT PTR [edi]).rgbtransparent,eax
          mov eax,[ebx+1] ;green
          and eax,0FFh
          shl eax,8
          or (OBJECT PTR [edi]).rgbtransparent,eax
          mov eax,[ebx+2] ;blue.
          and eax,0FFh
          shl eax,16
          or (OBJECT PTR [edi]).rgbtransparent,eax
          or (OBJECT PTR [edi]).fconfig1,80h ;set bit7, has trans color.
        .ELSE
          jmp SHORT er1
        .ENDIF
      .ELSE
er1:    mov (OBJECT PTR [edi]).rgbtransparent,0 ;color.
        and (OBJECT PTR [edi]).fconfig1,0FFFFFF7Fh ;clr bit7, no trans color.
      .ENDIF
    .ENDIF

  ret
getgiftransparent ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szsch	 BYTE "Snd",0
szwww	 BYTE "WWW",0
szgch	 BYTE "Pic",0 ;v2.78 "Gen",0
szexe	 BYTE "EXE",0
szdoc	 BYTE "DOC",0

.CODE
paint_info PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL ringwidth:DWORD
				LOCAL ringstmp:BYTE
				LOCAL xright:DWORD
				LOCAL ybottom:DWORD
				LOCAL xchange:DWORD,ychange:DWORD ;v3.42
				LOCAL state:BYTE
; "paint_info" "paint_icon"
;131000 for text-file-icon, via "pinfo" row in method table
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF


		  mov esi,pobject

				mov eax,(OBJECT PTR [esi]).wwidth
		  add eax,(OBJECT PTR [esi]).xtopleft
				mov xright,eax
		  mov ebx,(OBJECT PTR [esi]).height
		  add ebx,(OBJECT PTR [esi]).ytopleft
				mov ybottom,ebx

;v3.19 copied this code up from below, cut out colr-toggle, leave visibility-toggle...
;sequence for this func now: toggle-visibility>paint-element>toggle-color>invertrgn.
;v3.19 changed, include locked child visibility toggle...
;v2.73 want to invert if a locked child of a flashing animated element
        invoke visibilitytoggle_paint ;v3.44

    ;now using bit10=1 invisible... v3.19
			.IF g_fredrawdiag != WIPEOUTobjs
        mov eax,(OBJECT PTR [esi]).fstatus
        and eax,400h ;bit10.
        .IF eax != 0 ;bit10=1 invisible.
          jmp vis1 ;bypass painting element.
        .ENDIF
      .ENDIF

		.IF g_fredrawdiag==WIPEOUTobjs
		
;v3.49 no, still problems. comment all this out for now...		
;		  ;v3.49 a problem for gifs with transparent edges, not wiping...
;		  ;i do have code that detects transparency, doesn't work prperly though...
;		  ;getgiftransparent() gets called when a gif imported, loads 1stdata.end01=transparent
;		  ;color. Later, use external paint editor, puts trans color into icon.rgbtransparent
;		  ;and icon.fconfig1/bit7. but, current state of code is can only assume data.end01
;		  ;is loaded...
;		  mov ebx,(OBJECT PTR [esi]).rpdata2 ;attached raster picture.
;		  xor eax,eax
;		  .IF ebx!=0
;		    add ebx,pTERSEDATA
;		    mov eax,(OBJECT PTR [ebx]).end01
;		  .ENDIF
;		  .IF state==4 ;new icon being placed, need to wipe it all. v3.42
;		  .ELSEIF eax!=0 ;1st data element.end01 non0 means gif has transparent color.
;		  .ELSE
;        ;v3.42 calc two invalidated rectangles, and paint them...
;        ;(this reduces flicker when dragging)...
;        mov eax,(OBJECT PTR [esi]).xtopleft ;coord before move.
;        .IF SDWORD PTR g_xchange<0 ;dragging to right.
;          mov ecx,eax
;          sub ecx,g_xchange ;loaded in wmmousemove()/state8.
;        .ELSE
;          add eax,(OBJECT PTR [esi]).wwidth
;          mov ecx,eax
;          sub eax,g_xchange
;        .ENDIF
;        mov ebx,(OBJECT PTR [esi]).ytopleft ;coord before move.
;        mov edx,ebx
;        add edx,(OBJECT PTR [esi]).height
;		    invoke Rectangle,hdc,eax,ebx,ecx,edx
;	      mov ebx,(OBJECT PTR [esi]).ytopleft
;		    .IF SDWORD PTR g_ychange<0 ;>=0
;		      mov edx,ebx
;		      sub edx,g_ychange
;		    .ELSE
;		      add ebx,(OBJECT PTR [esi]).height
;		      mov edx,ebx
;		      sub ebx,g_ychange
;		    .ENDIF
;		    mov eax,(OBJECT PTR [esi]).xtopleft
;		    mov ecx,eax
;		    add ecx,(OBJECT PTR [esi]).wwidth
;		    invoke Rectangle,hdc,eax,ebx,ecx,edx
; 		    jmp e33 ;bypass any more painting.
; 		  .ENDIF
 		  
		.ELSE
		  mov eax,(OBJECT PTR [esi]).rpdata2  ;(note, alias for .rpowner2).
		  .IF eax==0 ;precaution.
		  .ELSE
				invoke common_paint_bitmap,hdc,esi				
          mov eax,(OBJECT PTR [esi]).morphingwidth ;always +ve. v3.39
          .IF eax != 0 ;need to morph pen color to fill color.
            ;this will paint a border around the picture...
						mov eax,xright
						mov ebx,ybottom
						mov ecx,(OBJECT PTR [esi]).xtopleft
						mov edx,(OBJECT PTR [esi]).ytopleft
            invoke paintgradientrect,hdc,ecx,edx,eax,ebx ;v3.39
          .ENDIF								
				jmp e33
		  .ENDIF
		.ENDIF

;draw rectangle, with color-fill...
						  mov eax,xright
						  mov ebx,ybottom
						  mov ecx,(OBJECT PTR [esi]).xtopleft
						  mov edx,(OBJECT PTR [esi]).ytopleft
              ;mov g_errorapi,0AF8h ;for crash outside EVE, error codes range Axxh. v3.23
						  invoke Rectangle, hdc, ecx,edx, eax,ebx		   ;

		  mov eax,(OBJECT PTR [esi]).nexttype
		  .IF ax==61 ;text-file icon
				lea edi,szdoc
				jmp SHORT c34
		  .ELSEIF ax==60 ;execution icon
				 lea edi,szexe
				 jmp SHORT c34
		  .ELSEIF ax==62 ;eve icon
				lea edi,szeve
c34:	invoke SelectObject,hdc,g_hfontx1
				push eax
				mov eax,(OBJECT PTR [esi]).xtopleft
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add eax,4 ;2
				add ebx,8
        ;mov g_errorapi,0AF9h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke TextOut,hdc,eax,ebx,edi,3
				pop eax
;*???* check this again. i read somewhere about metafiles ignoring this func...
				  cmp fprinting,2 ;metafile o/p.
				  je m91 ;bypass this section.
        ;mov g_errorapi,0AFAh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke SelectObject,hdc,eax
m91:
		  .ELSEIF ax==64 ;sound icon.
				lea edi,szsch
				jmp c34
		  .ELSEIF ax==65 ;WWW icon.
				lea edi,szwww
				jmp c34
		  .ELSE ;generic icon. v2.80 this now the ONLY supported type of icon.
				lea edi,szgch
				jmp c34
		  .ENDIF
e33:
vis1: ;bypass paint element.

		invoke common_paint_icon, hdc,pobject,xright,ybottom


		ret
paint_info ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
TEXTOUTx  PROC STDCALL USES eax ebx ecx edx esi edi, hdc:DWORD,tx:DWORD,\
																ty:DWORD,lpt:DWORD,tn:DWORD
  LOCAL nactual:DWORD
; "TEXTOUTx"
;this is an envelope for TEXTOUT, to remove trailing 0s.
;entered with hdc=displaycontext,tx/ty=coords, lpt=farpointer to text
;tn=max. number chars to display
;modified, displays chars until first 0.
				mov  nactual,0
				mov  edi,lpt
txtry:
				cmp  [edi],BYTE PTR 0
				je		 txdone
				mov  eax,tn 			;max chars to display.
				inc  edi
				inc  nactual
				cmp  eax,nactual
				jg		 txtry
txdone:
				cmp  nactual,0
				je		 txpass
				mov  edi,lpt
  ;mov g_errorapi,0AFBh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke TextOut, hdc,tx,ty,edi,nactual
txpass:
		  ret
TEXTOUTx  ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szhintresize BYTE "SHIFT: held down resizes text, keeps x/y proportions. BACKSPACE: undo.",0

.CODE
xpaint_extras PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD
				LOCAL htmpwin:DWORD
				LOCAL hfilefont:DWORD
				LOCAL holdfilefont:DWORD
				LOCAL holdblackpen:DWORD
				LOCAL bkcolorold:DWORD,bkmodeold:DWORD
				LOCAL hpenold:DWORD,hpennull:DWORD
				LOCAL syscolor:DWORD,hbrushold:DWORD,hbrushnew:DWORD
;called by wmpaint().  "xpaint_extras"

	mov edi,pTERSEDATA
;display current data file...
  ;mov g_errorapi,0AFCh ;for crash outside EVE, error codes range Axxh. v3.23
  invoke GetWindowDC, g_hwnd
  mov  htmpwin,eax
;select font...
  mov  eax,12 ;12 points size.
  neg  eax
 ;times new roman...
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR sztimesnewroman
  mov  hfilefont,eax
;assign font to display context...
  invoke SelectObject, htmpwin,hfilefont
  mov  holdfilefont,eax

  invoke GetSysColor,COLOR_MENU
  mov syscolor,eax
  invoke SetBkColor,htmpwin,eax
  mov bkcolorold,eax
  invoke SetBkMode, htmpwin,OPAQUE ;TRANSPARENT ;leave background showing.
  mov bkmodeold,eax
  invoke CreateSolidBrush,syscolor
  mov hbrushnew,eax
  invoke SelectObject,htmpwin,eax
  mov hbrushold,eax

  .IF szfile=="*"
  .ELSE
		invoke CreatePen,PS_NULL,0,0
		mov hpennull,eax
		invoke SelectObject,htmpwin,eax
		mov hpenold,eax
		  ;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
		  ;of frame...
		  mov eax,g_cycaption
		  add eax,g_cyframe
		  mov ebx,eax
		  add ebx,16
			;v1.21 x...
						   mov ecx,g_windowright ;see wmsize() and wmcreate().
						   sub ecx,g_cyframe
						   sub ecx,600 ;620 ;(x was 170)
						   .IF SDWORD PTR ecx<190
							 mov ecx,190
						   .ENDIF
						   mov edx,g_windowright
						   sub edx,g_cyframe
						   sub edx,124 ;right x side of text box.
						   push ecx
		invoke Rectangle,htmpwin,ecx,eax,edx,ebx ;170,24,500,40
		invoke SelectObject,htmpwin,hpenold
		invoke DeleteObject,hpennull
						   pop ecx
		mov eax,g_cycaption
		add eax,g_cyframe

		mov edx,(TERSEDATA PTR [edi]).fviewprefs
		and dl,0100000b ;bit5.
		.IF dl==0100000b ;displaying bounding rectangle
		  .IF g_nstate != 22 ;=22 not displaying resize handles.
			;(specifically, we would be in state 30 when dragging a handle, else 0)
			lea ebx,szhintresize
			jmp SHORT ov1
		  .ENDIF
		.ENDIF
		lea ebx,szfile ;display szfile.
ov1:

		invoke TEXTOUTx,htmpwin,ecx,eax,ebx,254 ;display szfile
  .ENDIF

  invoke SelectObject,htmpwin,hbrushold
  invoke DeleteObject,hbrushnew
  invoke SetBkColor,htmpwin,bkcolorold
  invoke SetBkMode, htmpwin,bkmodeold
  invoke SelectObject,htmpwin,holdfilefont
  invoke DeleteObject,hfilefont 				 ;***NOTE***move after selectobj.
  invoke ReleaseDC, g_hwnd,htmpwin

;display zero x and y axis...
;note win95 still has only 16-bit x/y coord system...
;note this allows +/- 32,0000, actually.
		invoke SelectObject, hdc,g_hpengrey ;grey 1pixel pen.
		mov holdblackpen,eax

;*EVE* no axis...
;		 invoke MoveToEx, hdc, -15000,0, 0
;		 invoke LineTo, hdc,			15000,0
;		 invoke MoveToEx, hdc, 0,-15000, 0
;		 invoke LineTo, hdc,			0,15000

		;mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).nzoom
		.IF SDWORD PTR eax>2
		  ;also put box around boundary...
		  invoke MoveToEx, hdc,15000,15000,0
		  invoke LineTo, hdc, 15000,-15000
		  invoke LineTo, hdc, -15000,-15000
		  invoke LineTo, hdc, -15000,15000
		  invoke LineTo, hdc, 15000,15000
		.ENDIF

;*EVE* .feveprefs/bit0 =1 show paper page margins...
;top-left of client area is always top-left corner margin on paper,
;and xwinext/ywinext is width/height of drawable area in screen pixels...
;(setup in wmcreate(), note not recalc'd except in xpaint_print)
;only draw right and bottom margins...
		;mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).fviewprefs
		test eax,01 ;bit0
		jz no1
		invoke drawprintmargins,hdc
no1:

  invoke SelectObject, hdc,holdblackpen

  ret
xpaint_extras ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
g_mleft   SDWORD 0
g_mtop	  SDWORD 0
g_mright  SDWORD 0
g_mbottom SDWORD 0

.CODE
drawprintmargins PROC STDCALL USES ebx ecx edx esi edi,hdc:DWORD
				LOCAL nright:DWORD,nbottom:DWORD,ntop:DWORD,nleft:DWORD
				LOCAL xedgeadj:SDWORD,yedgeadj:SDWORD
; "drawprintmargins"
;called from xpaint_extras() to paint grey page margins.
;called from xpaint_wipeout() to paint white margins.
;v1.28 have copied this code to paint_grid().
;v1.37 hdc=0 doen't paint any lines. call from xpaint_print().

		  ;calc a zoom multiplier factor...
		  mov eax,xwinext_exact ;(see printeranalysis())
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling... (+ve is enlarged)
						mov ebx,pTERSEDATA
						mov ecx,(TERSEDATA PTR [ebx]).xfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.
						;mov ecx,2		;v1.37 margins have to come in from both sides.
						;sar eax,cl 	;/
						;...v1.38 no.
						  mov xedgeadj,eax ;/
						add eax,xwinext_exact
		  mov edx,clientrect.rc_left
		  mov g_mleft,edx ;v1.38
		  mov g_mright,edx ;/
		  add g_mright,eax ;/
		  mov ebx,pTERSEDATA
		  mov ecx,(TERSEDATA PTR [ebx]).nzoom
		  mov ebx,xedgeadj ;v1.2
		  .IF SDWORD PTR ecx<0
				neg ecx
				sar eax,cl
				sar edx,cl
				sar ebx,cl
		  .ELSE
				sal eax,cl
				sal edx,cl
				sal ebx,cl
		  .ENDIF
		  mov nleft,edx
		  ;sub nleft,ebx ;v1.2 this will actually increase nleft. v1.38
		  add eax,edx
		  mov nright,eax

				mov eax,ywinext_exact
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling... (+ve means enlarged)
						mov ebx,pTERSEDATA
						mov ecx,(TERSEDATA PTR [ebx]).yfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the height has to be reduced if enlarged.
;						 mov ecx,2		;v1.37 margins have to come in from both sides.
;						 sar eax,cl 	;/
;						   mov yedgeadj,eax ;/
;...no, not for vertical, as diag at top of window doesn't shift...
						  mov yedgeadj,0 ;v1.2
						add eax,ywinext_exact
				mov edx,clientrect.rc_top
				mov g_mtop,edx
				mov g_mbottom,edx
				add g_mbottom,eax
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov ebx,yedgeadj
				.IF SDWORD PTR ecx<0
				  neg ecx
				  sar eax,cl
				  sar edx,cl
				  sar ebx,cl
				.ELSE
				  sal eax,cl
				  sal edx,cl
				  sal ebx,cl
				.ENDIF
				mov ntop,edx
				sub ntop,ebx ;v1.2 this will actually increase ntop.(but ebx=0 as not using this)
				add eax,edx
				mov nbottom,eax

		.IF hdc != 0 ;v1.37
  ;mov g_errorapi,0AFDh ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke MoveToEx, hdc,nright,ntop,0
		  invoke LineTo, hdc,nright,nbottom
		  invoke LineTo, hdc,nleft,nbottom
		  ;.IF xedgeadj==0 ;v1.2
		  ;.ELSE
		  ; 	 invoke LineTo,hdc,nleft,ntop ;left margin.
		  ;.ENDIF
		.ENDIF

		;;v1.37
		;mov eax,nleft
		;mov g_mleft,eax
		;mov eax,ntop
		;mov g_mtop,eax
		;mov eax,nright
		;mov g_mright,eax
		;mov eax,nbottom
		;mov g_mbottom,eax

		ret
drawprintmargins ENDP
;--------------------------------------------------------------------------
erasediagram PROC STDCALL USES ebx ecx edx esi edi
				LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
; "erasediagram"
;via File/Erase-diagram --> IDM_ERASEDIA.
;also called from idm_new-->newdatafile()-->.

;v1.31
;category-dataelements can have handles to popup menus. these are deleted and
;reloaded in addcomposites2menu(), called below, but we need to delete the popups
;now, before the database is erased...
	invoke deleteallcategorypopups
	;...no, can't delete the popups as they're appended to Elements menu, and will
	;get destroyed when Elements menu is destroyed (in addcomposites2menu()).
	;but this routine does clr all category-dataelement.ximage (handle of popup menu).
;i reckon too, we should delete any bitmap handles (as is done before we open another
;datafile or exit)...
	invoke deletebitmaphandles
	mov edi,pTERSEDATA
	mov (TERSEDATA PTR [edi]).numbitmaps,0

;remove ptrs to animations...
	invoke add2anilist,0 ;wipe all entries.


;scan through all objects, clearing .fstatus member...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;already empty
						jmp nextobjy
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov (OBJECT PTR [esi]).fstatus,0		;invalidate it.
				  .ENDIF
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		  loop nextobj
nextobjy:

;so, can now decrease mem block...
;  invoke GlobalReAlloc, pTERSEDATA,(SIZEOF TERSEDATA)+128,GMEM_MOVEABLE
  ;mov g_errorapi,0AFEh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				invoke GlobalReAlloc,eax,(SIZEOF TERSEDATA)+8096,GMEM_MOVEABLE
				;...v2.15 was 128, 8096 is bigger slop space!
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
  .IF eax==0
		 ;fail...
		 mov g_ndatabasesize,0
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
						invoke myalertbox,ADDR szer204,823h ;eax ;invoke myerrorhandler,204
		 ;error message and exit EVE...
		 invoke DestroyWindow, g_hwnd
		 ret
  .ELSE
		 ;all absolute pointers are invalid...
		 invoke zeroabsoluteptrs,1
		 mov g_ndatabasesize,(SIZEOF TERSEDATA)
		 mov pTERSEDATA,eax    ;new pointer.
  .ENDIF

;v1.25
;actually, there are 10 records initially. .numrecords is the actual number of
;records in the database...
		mov (TERSEDATA PTR [edi]).numrecords,10 ;0 ;no objects in database.

;v1.25
;must always have record #0 reserved as a data element...
	invoke createnewobject,0
	;...the (SIZEOF TERSEDATA) allocation above, has 10 records in it, all empty,
	;so createnewobject,0 will create it in record #0.
	mov ebx,eax
	xor eax,eax
	mov (OBJECT PTR [ebx]).nexttype,-1 ;data element.
	mov (OBJECT PTR [ebx]).rpdata,eax ;0 ;precaution.
	mov (OBJECT PTR [ebx]).rpowner1,eax ;0 ;/
	mov (OBJECT PTR [ebx]).rpowner2,eax ;0 ;/
				  mov (OBJECT PTR [ebx]).nrings,eax ;0
				  mov (OBJECT PTR [ebx]).nbeginring,eax ;0
				  mov (OBJECT PTR [ebx]).nendring,eax ;0
				  ;v3.13d for export to svg, choose default o/p width/height in pixels...
				  mov (OBJECT PTR [ebx]).fconfig3,10000000b ;bits7/6 =1/0 pixels.

;v1.25
;any library-object entries in the Elements menu must be removed...
	invoke addcomposites2menu,0 ;=1 will remove library-objs, but no need to here.


  invoke InvalidateRgn, g_hwnd,0,TRUE ;redraw background.
  mov g_fredrawdiag,ENTIRE								;redraw entire window.


  ret
erasediagram ENDP
;--------------------------------------------------------------------------
.DATA
fclipped BYTE 0
fdelay	 BYTE 0 		;delay scrolling effect when mouse at boundary.
nGAP EQU 7 ;5	;how close to edge of window before scrolling.
SCDELAY EQU 0	;2 = 1 second delay
  BYTE 0,0

.CODE
scrollingbymouse PROC STDCALL USES ebx ecx edx esi edi, wparam:DWORD,lparam:DWORD
		LOCAL mousex:WORD, mousey:WORD	;unsigned!
		LOCAL eaxsave:DWORD,ebxsave:DWORD,ecxsave:DWORD
;called by wmmousemove().  "scrollingbymouse"
;when mouse approaching boundary, start scrolling window.
;lparam is mouse client coords, origin relative to top/left client area.

;i use clientrectold here, as it is top,left =0,0 bot,right =height,width
;of client, and lparam is mouse coords in client-coords, i.e. mouse
;0,0 coord is top,left of client area.
;note that clientrect is the actual region of the diagram being displayed,
;but it must have the same height,width as clientrectold.
;therefore, when xtimer() does the actual scrolling (not done in this func)
;it scrolls clientrect.

;note that wparam of WM_MOUSEMOVE is non-zero if shift/ctrl or any
;mouse button pressed.
;i think i'll scroll if any of these pressed...
		.IF wparam==0
		  jmp sc6				;make sure everything is clear then ret.
		.ENDIF

				  mov ax,WORD PTR lparam+2
				  mov mousey,ax
				  cwde
				  mov ebx,eax
				  mov ax,WORD PTR lparam
				  mov mousex,ax
				  cwde															   ;actually...
				  mov ecx,clientrectold.rc_left 		   ;=0 as original unshifted.
				  mov edx,clientrectold.rc_right		   ;=width " (client coords)
				  mov edi,clientrectold.rc_top			   ;=0	"
				  mov esi,clientrectold.rc_bottom		   ;=height "

;i've got a problem with scrolling happening when mouse is just outside
;the window...
		.IF mousex>dx	;unsigned, as these values always +ve.
sc6:  mov g_naccelx,0
		  mov g_naccely,0
		  mov fdelay,0
		  jmp sc4				;get out, but free cursor just in case it's clipped.
		.ENDIF
		.IF mousey>si
		  jmp sc6
		.ENDIF

				sub ecx,eax 			;how close to left side.
				.IF SDWORD PTR ecx<0
				  neg  ecx								;convert to +ve.
				.ENDIF
				sub edx,eax
				.IF SDWORD PTR edx<0
				  neg  edx
				.ENDIF
				sub edi,ebx 			;how close to top.
				.IF SDWORD PTR	edi<0
				  neg  edi								;convert to +ve.
				.ENDIF
				sub esi,ebx
				.IF SDWORD PTR	esi<0
				  neg  esi
				.ENDIF

  .IF eax==ebx					  ;invalid condition, occurs if over top.
		mov g_naccelx,0
		mov g_naccely,0
		jmp done1
  .ENDIF

;firstly, x direction...
  .IF ecx<nGAP					 ;mouse on left side?
		  .IF g_naccelx==0		;i only want xtimer to incr it beyond 2.
				sub g_naccelx,2 				;(accel will be a -ve value)
		  .ENDIF
		jmp done1
  .ELSEIF edx<nGAP		   ;mouse on right side?
		  .IF g_naccelx==0
				add g_naccelx,2    ;(accel will be a +ve value)
		  .ENDIF
		jmp done1
  .ELSE
		mov g_naccelx,0
  .ENDIF

;now for y direction...
  .IF edi<nGAP			 ;mouse on top side?
		  .IF g_naccely==0
				sub g_naccely,2 				;(accel will be -ve value)
		  .ENDIF
		  jmp done1
  .ELSEIF esi<nGAP		 ;mouse on bottom side?
		  .IF g_naccely==0
				add g_naccely,2
		  .ENDIF
		  jmp done1
  .ELSE 				;fail
		 mov g_naccely,0
  .ENDIF

done1:

;that's it. xtimer() runs every 500msec and looks at g_naccelx/g_naccely
;to scroll if they're non-zero.

;if scrolling is to occur, clip the cursor...
  .IF fclipped==0								;prevent calling ClipCursor more than once.
		.IF g_naccely != 0
		  jmp sc3
		.ENDIF
		.IF g_naccelx != 0
sc3:
		  .IF fdelay>=SCDELAY			;# entries to xtimer (2 = 1 sec) delay.
  ;mov g_errorapi,0AFFh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetWindowRect, g_hwnd,ADDR windowrect
;				 add windowrect.rc_top,42	;/	(i'm clipping cursor in from edges
				  ;v1.21...
				  mov eax,g_cyframe
				  add eax,g_cycaption
				  add eax,g_cymenu
				  add eax,g_cyborder
				  ;add eax,4
				  add windowrect.rc_top,eax   ;/  (i'm clipping cursor in from edges
				  mov eax,g_cyframe
				add windowrect.rc_left,eax ;4 ;3 ;2    ;limit region to inside client area.
				sub windowrect.rc_right,eax ;4 ;3 ;2 ;/ as getting resize-arrows
				sub windowrect.rc_bottom,eax ;4 ;3 ;2				 ;/ appearing)
				invoke ClipCursor, ADDR windowrect
				mov fclipped,1
		  .ENDIF
		.ENDIF
  .ENDIF

;280900
;note, windowrect is setup in wmcreate() and i'm now updating it in
;wmsize() (everytime window is resized) so not really necessary to
;call GetWindowRect() above.


sc4:
  .IF g_naccely==0
		.IF g_naccelx==0
		  .IF fclipped==1
        ;mov g_errorapi,0B00h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke ClipCursor, 0	;free the cursor.
				mov fclipped,0
				mov fdelay,0
		  .ENDIF
		.ENDIF
  .ENDIF

   ret
scrollingbymouse ENDP
;--------------------------------------------------------------------------
.CODE
displaymouse PROC STDCALL USES ebx ecx edx esi edi, nmx:DWORD, nmy:DWORD
				LOCAL htmpwinx:DWORD
				LOCAL htextfont:DWORD
				LOCAL holdtextfont:DWORD
				LOCAL fneg:BYTE
;entered with corrected mouse coords.  "displaymouse"
;display them. called from xtimer() and wmmousemove().
;note, also see displaynumber() has code from here.

				mov fneg,0
  ;mov g_errorapi,0B01h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetWindowDC, g_hwnd
				mov  htmpwinx,eax

;select font...
  mov  eax,12  ;12 points size
  neg  eax
;  invoke CreateFont, eax,0,0,0,0,0,0,0,0,0,0,0,04,ADDR szmsserif
 ;times new roman...
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR sztimesnewroman
  mov  htextfont,eax
;assign font to display context...
  invoke SelectObject, htmpwinx,htextfont
  mov  holdtextfont,eax

;  invoke SetBkMode, htmpwinx,TRANSPARENT

;i've got a problem as win95 is only 16bit coords. so, -ve coord
;will have bit15=1, but can i be sure there is sign extension?
;i'm testing just bit15 here... ***NOTE***
				mov  eax,nmx
				 mov edx,0
				   test eax,8000h				;test if -ve coord. ***NOTE***
				   jz	dim1
				   neg	ax								;make it +ve.
				 cwde					;sign-extend. i think this will fill eax with 0s.
				   mov	fneg,1					;flag that it is neg.
dim1:	 invoke bin2dec,10						;eax-->szasciitbl(convert to ascii)
				 lea edi,szasciitbl+1
				 mov [edi],WORD PTR "=X"  ;prefix with title
				   .IF fneg==1
;*						 mov  [edi+2],BYTE PTR "-"		;-ve sign.
						 mov  fneg,0
						 invoke SetTextColor, htmpwinx,00FFh ;red
						 push eax
;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
						   ;of frame...
						   mov eax,g_cycaption
						   add eax,g_cyframe			;was 24.
						   mov ebx,g_windowright ;see wmsize() and wmcreate().
						   sub ebx,g_cyframe
						   sub ebx,120 ;(x was 508)
						   push eax
						   push ebx
						 invoke TextOut, htmpwinx,ebx,eax,ADDR szblanks,18 ;21
						   pop ebx
						   pop eax
						 invoke TextOut, htmpwinx,ebx,eax,edi,9 ;8 ;paint 8 chars.no, 9.
						 pop  eax
						 invoke SetTextColor, htmpwinx,eax ;restore.
				   .ELSE
;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
						   ;of frame...
						   mov eax,g_cycaption
						   add eax,g_cyframe			;was 24.
						   mov ebx,g_windowright ;see wmsize() and wmcreate().
						   sub ebx,g_cyframe
						   sub ebx,120 ;(x was 508)
						   push eax
						   push ebx
						 invoke TextOut, htmpwinx,ebx,eax,ADDR szblanks,18 ;21
						   pop ebx
						   pop eax
						 invoke TextOut, htmpwinx,ebx,eax,edi,9 ;8
				   .ENDIF

;now do it all again for y coord...
				mov eax,nmy
				 mov edx,0
				   test ax,8000h				;test if -ve coord.
				   jz	xdim1
				   neg	ax								;make it +ve.
				 cwde									;try this again, sign-extend to eax.
				   mov	fneg,1					;flag that it is neg.
xdim1:	 invoke bin2dec,10
				 lea edi,szasciitbl+1
				 mov [edi],WORD PTR "=Y"
				   .IF fneg==1
;*						 mov  [edi+2],BYTE PTR "-"		;-ve sign.
						 mov  fneg,0
						 invoke SetTextColor, htmpwinx,00FFh ;red
						 push eax
;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
						 ;of frame...
						 mov eax,g_cycaption
						 add eax,g_cyframe			  ;was 24.
						   mov ebx,g_windowright ;see wmsize() and wmcreate().
						   sub ebx,g_cyframe
						   sub ebx,63 ;(x was 565)
						 push eax
						   push ebx
						 invoke TextOut, htmpwinx,ebx,eax,ADDR szblanks,18 ;21
						   pop ebx
						 pop eax
						 invoke TextOut, htmpwinx,ebx,eax,edi,9 ;8
						 pop  eax
						 invoke SetTextColor, htmpwinx,eax		;restore.
				   .ELSE
;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
						 ;of frame...
						 mov eax,g_cycaption
						 add eax,g_cyframe			  ;was 24.
						   mov ebx,g_windowright ;see wmsize() and wmcreate().
						   sub ebx,g_cyframe
						   sub ebx,63 ;(x was 565)
						 push eax
						   push ebx
						 invoke TextOut, htmpwinx,ebx,eax,ADDR szblanks,18 ;21
						   pop ebx
						 pop eax
						 invoke TextOut, htmpwinx,ebx,eax,edi,9 ;8
				   .ENDIF

;***NOTE*** found must delete object AFTER selecting old one back to DC...
;(otherwise, fonts go funny)
				invoke SelectObject, htmpwinx,holdtextfont
				invoke DeleteObject, htextfont

				invoke ReleaseDC, g_hwnd,htmpwinx

  ret
displaymouse ENDP
;--------------------------------------------------------------------------
bin2dec PROC STDCALL USES ebx ecx edx edi esi,nradix:DWORD
				LOCAL pstart:DWORD
; "bin2dec"
;binary to ascii-bcd conversion.  requires binary number in eax
;returns asciiz string in szasciitbl.
;return eax->start of string (past the blanks).
;The generated string is right-justified to asciitbl+9, with
;blanks from ascittbl to the string.
;nradix -- now handles conversion to any radix.

				xor edx,edx
				xor esi,esi
;				 mov pstart,0

				lea edi,szasciitbl
				mov ebx,edi
				add edi,10
				mov BYTE PTR [edi],0
				dec edi
ssss:	mov ecx,nradix ;10
				div ecx 								;edx:eax/2 -->edx has remainder
				add dl,30h		   ;convert to ascii.
				  .IF dl>=3Ah
						add dl,7   ;ascii for A-F.
				  .ENDIF
sssss:	mov [edi],dl
				dec edi
				mov edx,0
				or eax,eax ;cmp eax,0
				jne ssss
				  .IF esi==0
						mov esi,edi ;pts to start of string-1.
				  .ENDIF
				mov dl," "
				cmp ebx,edi
				jbe sssss

				   .IF szasciitbl+9==" "
						 mov szasciitbl+9,"0"  ;we want a zero to display, not nothing.
				   .ENDIF

				inc esi
				mov eax,esi   ;pts to start of string.
				ret
bin2dec ENDP
;--------------------------------------------------------------------------
.DATA
;fflashonce BYTE 0 ;used for oneshot color change.
;flashhalfsec BYTE 0
ALIGN 4 ;v3.24
g_flinearscroll DWORD 0 ;v3.10 set in xdblclk(), for goto link
g_nstepslimit   DWORD 0 ;/ (used in xtimer())
ncntsteps       DWORD 0 ;used in xtimer() v3.10
xstepaccum      DWORD 0 ;/ v3.11
ystepaccum      DWORD 0 ;/ v3.11

.CODE
ACCELMAXPOS EQU 200
ACCELMAXNEG EQU -200
xtimer PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL scrollrect:RECT,clientrectsave:RECT
		LOCAL zoom:DWORD
		LOCAL naccelx:SDWORD,naccely:SDWORD
		LOCAL hdc:DWORD,hpenwhite:DWORD,hpensaved:DWORD
		LOCAL eaxsave:DWORD
		LOCAL panimated:DWORD  ;,panilist:DWORD
		LOCAL nknee0:BYTE,fdragmask0:BYTE ;,fredrawall:BYTE
;called every 500msec. (now 250msec) "xtimer"
;if g_naccelx or g_naccely non-0 then scroll...
;this is for scrolling when mouse left-button-down, against window-edge
;...see scrollingbymouse().
;this is for scrolling by arrow key also, see xkeydown().

    ;mov g_errorapi,0B5Ch ;for crash outside EVE, error codes range A00h-BFFh. v3.23
    ;...not in front of an win32api func, but may come in here and return without
    ;calling an api, then die back in windows.
    
    ;mov fredrawall,0
		mov naccelx,0
		mov naccely,0
		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).nzoom
		mov zoom,eax
;		 lea eax,(TERSEDATA PTR [esi]).anilist
;		 mov panilist,eax

;record if diagram has changed...
				.IF g_nstate>3
				  mov  g_fhaschanged,1
				.ENDIF

  .IF g_naccelx == 0 ;v1.59
	  .IF g_naccely == 0
	    .IF g_nstate == 0
		    .IF fprinting==0 ;not exporting to emf/wmf,clipboard,printer.
		      .IF fsaving==0 ;not saving or embedding, or exporting to svg.
			      .IF g_fredrawdiag != ENTIRE
			        .IF SBYTE PTR zoom<2 ;maybe too much work if big diag.
				        ;mov eax,(TERSEDATA PTR [esi]).numrecords
				        ;.IF ax<3000 ;1000 	   ;maybe too much work if big diag.
				          ;allowed to have animation...
				          jmp ani1
				        ;.ENDIF
				      .ELSE
				        jmp SHORT em1 ;v2.74
			        .ENDIF
			      .ENDIF
		      .ENDIF
		    .ENDIF
	    .ENDIF
	  .ELSE
em1:  invoke add2anilist,0 ;empty it. v2.74
      ;...this will only fill up again via paint_ani() method, so only
      ;animators in current window will get put into the list.
      ;...note, could consider calling this every alternate entry (half second).
	  .ENDIF
	.ELSE
	  jmp em1
  .ENDIF

  .IF g_naccelx != 0 ;v3.10
en1: .IF fdelay<SCDELAY
		   inc fdelay			;we count entries to xtimer.
		   jmp out1
		 .ENDIF
		 .IF g_flinearscroll != 0  ;v3.10
        ;goto link (in xdblclk()) set g_flinearscroll=1 and g_nstepslimit=#steps...
        inc ncntsteps
        mov eax,ncntsteps
        .IF eax>g_nstepslimit
          ;this may be redundant now, as clring these just before painting below,
          ;but precaution leave this code here...
          mov ncntsteps,0
          mov xstepaccum,0
          mov ystepaccum,0
          mov g_flinearscroll,0
          mov g_naccelx,0 ;will stop xtimer() from scrolling.
          mov g_naccely,0
          jmp out1
        .ELSEIF eax==g_nstepslimit
            ;what about a final fine-tune of destination to exactly g_nx/g_ny in middle...
            ;v3.11...
            ;had trouble previous version3.10, for zoom!=0. so, now using
            ;x/ystepaccum, accumulates each step, incl. rounding off error when zoom>0...
            ;the total required shift is in g_nh/g_nv, set in xdblclk(), goto link...
            mov eax,g_nh
            sub eax,xstepaccum
            mov g_naccelx,eax ;final corrected step.
            mov eax,g_nv
            sub eax,ystepaccum
            mov g_naccely,eax ;final corrected step.
        .ENDIF
     .ENDIF
  .ELSEIF g_naccely != 0
    jmp en1
  .ELSE
    mov ncntsteps,0 ;precaution.
    mov xstepaccum,0 ;/
    mov ystepaccum,0 ;/
    mov g_flinearscroll,0 ;precaution, cos r-click can prematurely clr g_naccelx/y.
    ;...no can't, cos i've put bypasses into wm..() and x..() funcs if g_flinearscroll!=0.
  .ENDIF
  
  .IF g_naccelx != 0
				;for zoom=-1 and -2, change is rounded off,
				;i think i did this because of some problem with the ScrollWindowEx()
				;func, but it's a problem with g_flinearscroll=1 as want to end up
				;at an exact destination...
				  .IF g_flinearscroll != 0 ;set in xdblclk(), by goto link. v3.10
			      mov edx,g_naccelx
			      ;um, the above-mentioned rounding off problem isn't going to occur
			      ;for goto link scrolling, as have to scale the g_naccelx/y for
			      ;zoom factor, so get correct displacement...
			      mov ecx,zoom
			      mov eax,edx ;g_naccelx
			      .IF SDWORD PTR ecx>0
			        sar edx,cl
			          mov eax,edx ;want to accum exact steps. v3.11
			          sal eax,cl  ;normalise again.
			      .ELSEIF SDWORD PTR ecx<0
			        neg ecx
			        sal edx,cl ;we get the rounding off automatically!
				    .ENDIF
	          add xstepaccum,eax
;            mov edx,g_naccelx  ;v3.11
;            add xstepaccum,edx ;/
				  .ELSE ;previous version code, normal scrolling...
				    mov eax,g_naccelx  ;real acceleration.
				    sar eax,1				;  divide by 2
				    add g_naccelx,eax  ;  now it's 1.5 times bigger.
				    .IF SDWORD PTR g_naccelx<ACCELMAXNEG
						  mov g_naccelx,ACCELMAXNEG
				    .ELSEIF SDWORD PTR g_naccelx>ACCELMAXPOS
						  mov g_naccelx,ACCELMAXPOS
				    .ENDIF
				    mov edx,g_naccelx	  ;this is a signed number.
				    .IF SDWORD PTR zoom<0			  ;v1.19
				      .IF zoom==-1
						    and edx,0FFFFFFFEh ;clr bit0, so even #.
				      .ELSEIF zoom==-2
						    and edx,0FFFFFFFCh ;clr bottom 2 bits.
				      .ENDIF
				    .ENDIF
				  .ENDIF
			    mov naccelx,edx
		  add clientrect.rc_left,edx
		  add clientrect.rc_right,edx
		  add g_nmousex,edx 	;so mouse coords also keep track while mouse may be stationary.
		  ;normally only allow scroll x or y, not both, but for v3.10...
		  ;.IF g_flinearscroll==0
		  ;  jmp xt1 ;x only.
		  ;.ENDIF
		  ;...any repercussions, now allowing both x and y scrolling? <<<< v3.10
  .ENDIF

  .IF g_naccely != 0
				;for zoom=-1 and -2, change is rounded off,
				;i think i did this because of some problem with the ScrollWindowEx()
				;func, but it's a problem with g_flinearscroll=1 as want to end up
				;at an exact destination...
				  .IF g_flinearscroll != 0 ;set in xdblclk(), by goto link. v3.10
			      mov edx,g_naccely
			      ;um, the above-mentioned rounding off problem isn't going to occur
			      ;for goto link scrolling, as have to scale the g_naccelx/y for
			      ;zoom factor, so get correct displacement...
			      mov ecx,zoom
			      mov eax,edx ;g_naccely
			      .IF SDWORD PTR ecx>0
			        sar edx,cl
			          mov eax,edx ;want to accum exact steps. v3.11
			          sal eax,cl  ;normalise.
			      .ELSEIF SDWORD PTR ecx<0
			        neg ecx
			        sal edx,cl ;we get the rounding off automatically!
				    .ENDIF
	          add ystepaccum,eax ;exact step accumulation.
;            mov edx,g_naccely ;v3.11
;            add ystepaccum,edx
				  .ELSE ;previous version code, normal scrolling...
				    mov eax,g_naccely  ;real acceleration.
				    sar eax,1				;  divide by 2
				    add g_naccely,eax  ;  now it's 1.5 times bigger.
				    .IF SDWORD PTR g_naccely<ACCELMAXNEG
						  mov g_naccely,ACCELMAXNEG
				    .ELSEIF SDWORD PTR g_naccely>ACCELMAXPOS
						  mov g_naccely,ACCELMAXPOS
				    .ENDIF
				    mov edx,g_naccely	  ;this is a signed number.
				    .IF SDWORD PTR zoom<0			  ;v1.19
				      .IF zoom==-1
						    and edx,0FFFFFFFEh ;clr bit0, so even #.
				      .ELSEIF zoom==-2
						    and edx,0FFFFFFFCh ;clr bottom 2 bits.
				      .ENDIF
				    .ENDIF
				  .ENDIF
			    mov naccely,edx
		  add clientrect.rc_top,edx
		  add clientrect.rc_bottom,edx
		  add g_nmousey,edx
		  
xt1:      ;;HACK>>>
				  ;.IF g_flinearscroll != 0 ;set in xdblclk(), by goto link. v3.10
				  ;  jmp cx1 ;trying to get redraw while scrolling.
				  ;.ENDIF
				.IF SDWORD PTR zoom<-2			  ;v1.19
				  ;... got it working for zoomed-in twice, not further in.
				  ;ScrollWindow() isn't working properly when zoomed-in.
				  ;so, use original code...
cx1:
          ;mov g_errorapi,0B5Bh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
	    invoke InvalidateRgn, g_hwnd,0,TRUE  ;invalidate entire window.
				  jmp w12
				;.ELSEIF fredrawall != 0
				;  jmp cx1
				.ENDIF

				;also get scrolling distortion ... (see xtimer()) v1.19
				mov eax,(TERSEDATA PTR [esi]).xfinescrn
				.IF eax != 0
				  jmp cx1
				.ENDIF
				mov eax,(TERSEDATA PTR [esi]).yfinescrn
				.IF eax != 0
				  jmp cx1
				.ENDIF

		  mov ecx,naccelx				;v1.19
		  neg ecx
		  mov edx,naccely
		  neg edx

						  ;v1.2 if margins displayed, they will scroll too. prevent...
						  pushad
						  mov ebx,pTERSEDATA
						  mov eax,(TERSEDATA PTR [ebx]).fviewprefs
						  test eax,01 ;bit0
						  jz no1
							mov wipeoutsindex,0 ;make sure nothing in wipeout list.
							mov fdrawmargins,1	;flag tell xpaint_wipeout() to draw margins,
									;by calling drawprintmargins().
								mov g_nknee,0 ;paint_arc uses this.
                ;mov g_errorapi,0B02h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke InvalidateRgn, g_hwnd,0,FALSE
								mov  g_fredrawdiag,WIPEOUTobjs
								push g_nmousex
								push g_nmousey
                ;mov g_errorapi,0B03h ;for crash outside EVE, error codes range Axxh. v3.23
								invoke UpdateWindow, g_hwnd 			;wipe immediately.
								pop  g_nmousey
								pop  g_nmousex
;							 mov fdrawmargins,0
no1:					  popad
;note that xkeyup() and wmlbuttonup() detect fdrawmargins=1 and redraw diag, to overwrite
;the vertical white lines.


      ;mov g_errorapi,0B04h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke ScrollWindowEx,g_hwnd,ecx,edx,0,0,0, \
				  ADDR scrollrect,0 ;SW_ERASE
;		   invoke InvalidateRgn, g_hwnd,0,TRUE	 ;invalidate entire window.
		  ;although we redraw entire client area when call UpdateWindow(),
		  ;only the scrollrect portion will have the background wiped,
		  ;thus reducing flickering.

      ;v3.10 when we scroll x and y simultaneously, the invalidated region returned in
      ;scrollrect is the entire client area. so, we have to calculate it...
      .IF eax==COMPLEXREGION ;returned by ScrollWindowEx().
        ;need to calc 2 rect regions...
        ;if naccelx +ve, diag moved left, so right-side of window invalidated...
        .IF SDWORD PTR naccelx >=0
          mov eax,clientrectold.rc_right
          mov scrollrect.rc_right,eax
          sub eax,naccelx
          mov scrollrect.rc_left,eax
        .ELSE
          mov eax,clientrectold.rc_left
          mov scrollrect.rc_left,eax
          sub eax,naccelx ;naccelx is -ve.
          mov scrollrect.rc_right,eax
        .ENDIF
        mov eax,clientrectold.rc_top
        mov scrollrect.rc_top,eax
        mov eax,clientrectold.rc_bottom
        mov scrollrect.rc_bottom,eax
        ;mov g_errorapi,0B05h ;for crash outside EVE, error codes range Axxh. v3.23
		    invoke InvalidateRect, g_hwnd,ADDR scrollrect,TRUE   ;invalidate.
		    ;now do same for vertical shift...
		    ;naccely +ve shifts diag up...
        .IF SDWORD PTR naccely >=0
          mov eax,clientrectold.rc_bottom
          mov scrollrect.rc_bottom,eax
          sub eax,naccely
          mov scrollrect.rc_top,eax
        .ELSE
          mov eax,clientrectold.rc_top
          mov scrollrect.rc_top,eax
          sub eax,naccely ;naccely is -ve.
          mov scrollrect.rc_bottom,eax
        .ENDIF
        mov eax,clientrectold.rc_left
        mov scrollrect.rc_left,eax
        mov eax,clientrectold.rc_right
        mov scrollrect.rc_right,eax
        jmp SHORT inr1
      .ELSE
inr1:
   ;mov g_errorapi,0B06h ;for crash outside EVE, error codes range Axxh. v3.23
   invoke InvalidateRect, g_hwnd,ADDR scrollrect,TRUE   ;invalidate.
		  .ENDIF

w12:	  mov g_fredrawdiag,ENTIRE								   ;redraw entire window.
          ;v3.10 if this is the last paint in the goto link scrolling, clr g_naccelx/y
          ;so that anilist can reload (done by paint_ani() method)...
          .IF g_flinearscroll != 0
            mov eax,ncntsteps
            .IF eax==g_nstepslimit
              mov g_naccelx,0
              mov g_naccely,0
              mov g_flinearscroll,0 ;bug fix, not getting clrd.
              mov ncntsteps,0 ;think must clr this also!
              mov xstepaccum,0 ;/
              mov ystepaccum,0 ;/
            .ENDIF
          .ENDIF
				  push g_nmousex
				  push g_nmousey
          ;mov g_errorapi,0B07h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
				  pop  g_nmousey
				  pop  g_nmousex

		  invoke  displaymouse, g_nmousex,g_nmousey ;display mouse coords.
	.ELSE
    ;v3.10 if g_naccelx non-0, jump back to xt1...
    .IF g_naccelx != 0
      jmp xt1
    .ENDIF	
  .ENDIF

out1:
  ret

;.......
ani1:
		mov ebx,0
		mov eax,NUMANI-1 ;anilistindex
end2:	lea esi,anilist
		mov ebx,eax
		or eax,eax ;cmp eax,0
		je end1 ;get out.
		shl ebx,1
		shl ebx,1
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0
		je end2b
		  ;found...
		  pushad
		  ;edi pts to a animation element...

			  ;do a validation, ptr within database... (precaution)
;				   push ebx
;				   mov ebx,pTERSEDATA															   ;start of mem block.
;				   mov esi,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add esi,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   .IF edi<=esi ;exclude #0 also.
;					 pop ebx
;					 jmp fa1
;				   .ENDIF
;				   mov eax,(TERSEDATA PTR [ebx]).nsizeobject
;				   mov ecx,(TERSEDATA PTR [ebx]).numrecords
;				   mul ecx				   ;eax=size of OBJECTS database.
;				   add esi,eax ;esi=address beyond end of database.
;				   pop ebx
;				   .IF edi>=esi
;					 jmp fa1
;				   .ENDIF
				;note, need to preserve ebx.
				invoke ispointerok,edi ;rel.ptr req'd.
				or eax,eax ;cmp eax,0
				je fa1 ;fail
		  add edi,pTERSEDATA ;cos stored in anilist as relative (unlike earlier lists).


		mov eax,(OBJECT PTR [edi]).fstatus
		and al,01
		.IF al==01 ;valid object
			mov eax,(OBJECT PTR [edi]).nexttype
			.IF ax==40 ;animation element.
			  ;success!
			  ;edi-->animation element.
			  ;for o/p to svg, need to stop animation at its "home" position. this was
			  ;detected and bit0 set...
			    ;v2.87 for mouseover, when mouseout need to stop at "home" position.
			    ;wmmousemove() sets bit7 (highlighted) of animator, and does not set
			    ;bit8 (which would stop animation immediately). also sets bit17, special
			    ;flag test here...
			    mov eax,(OBJECT PTR [edi]).fconfig2
			    and eax,20001h ;test bit17, bit0.
			    .IF eax==20001h ;special condition. bit17=1 wmmousemove() detected mouseout.
			      and (OBJECT PTR [edi]).fconfig2,0FFFDFFFFh ;clr bit17 special flag.
			      or (OBJECT PTR [edi]).fconfig2,100h ;set bit8, stop event.
			      jmp stop1z
			    .ENDIF
			  mov eax,(OBJECT PTR [edi]).fconfig2
			  and al,81h ;bit7=1 highlighted, bit0=1 stopped (see below).
			  .IF al==81h
		      and (OBJECT PTR [edi]).fconfig2,0FFFDFFFFh ;clr bit17 special flag. precaution.
				  jmp SHORT stop1z ;v2.71
			  .ELSE
				  and (OBJECT PTR [edi]).fconfig2,0FFFFFFFEh ;clr bit0.
			  .ENDIF
				;in dialog box for activator is "start event" checkboxes. anything other
				;than "continous" will set bit8. if the event occurs this bit will be clr...
				mov eax,(OBJECT PTR [edi]).fconfig2
				and ax,100h ;bit8=1 waiting on event.
				.IF ax==100h
stop1z:   ;v2.71 restore brush color to normal...
          and (OBJECT PTR [edi]).fconfig2,0FFFFEFFFh ;clr bit12 used by oneshot.
				  mov ebx,(OBJECT PTR [edi]).rpowner1
				  .IF ebx != 0
				    add ebx,pTERSEDATA
				      ;v2.81 also test bits 13 and 14 in target...
				      mov eax,(OBJECT PTR [ebx]).fconfig2
				      and eax,2000h
				      .IF eax != 0 ;bit13 controls label visibility.
				        mov g_fredrawdiag,ENTIRE ;to help wipeout of label.
				      .ENDIF
				    test (OBJECT PTR [ebx]).fconfig2,6000h
				    jnz pa5 ;either bits set will jump.
				    mov eax,(OBJECT PTR [edi]).fconfig2
				    and eax,600h ;bit9=1 flash fill color. bit10=1 oneshot. v2.75
				    .IF eax != 0 ;either.
				      mov eax,(OBJECT PTR [ebx]).fconfig2
				      and eax,0200h ;bit9=1 target fill color is inverted.
				      .IF eax != 0
pa5:		        mov eax,(OBJECT PTR [ebx]).npencolor
				        .IF SDWORD PTR eax<0
				          not (OBJECT PTR [ebx]).npencolor ;restore to normal.
				        .ENDIF
				        ;...restricts pen flashing to element animator directly attached to.
		            ;and (OBJECT PTR [ebx]).fconfig2,0FFFFFDFFh ;clr bit9 in target.
				        ;v2.81 clr bit9, bit13 and bit14 in target...
				        and (OBJECT PTR [ebx]).fconfig2,0FFFF9DFFh
				        ;...for comp.objs, just painting this one may be wrong when stop
				        ;flashing. need to paint them all...
				        invoke updateslaves,ebx,0,0,2 ;2=will add all elements attached to
				        ;and locked to ebx, including ebx. ignores x/ychange (0,0).
				      .ENDIF
				    .ENDIF
				  .ENDIF
				  jmp stop1x ;v2.71 stop1
				.ENDIF
				
			  ;.x/ydeltacentre has change for each 1/4 second, .cntani tracks #moves,
			  ;.maxcntani is max #moves in each direction, .fconfig2/bit3 is current direction...
			  ;mov eax,(OBJECT PTR [edi]).anitime ;0 time disables animation.
			  ;.IF eax != 0
			  ;...v2.83 .anitime=0 now means jump full distance in zero seconds.
				  inc (OBJECT PTR [edi]).cntani
				  mov eax,(OBJECT PTR [edi]).cntani
				  mov ecx,(OBJECT PTR [edi]).maxcntani
				  .IF eax>ecx
					  ;change direction...
					  xor (OBJECT PTR [edi]).fconfig2,01000b ;toggle bit3.
					  mov (OBJECT PTR [edi]).cntani,1 ;0
					  mov eaxsave,eax
					  
					    ;v3.09
					    ;darn complicated code!... now have "no return" radiobutton, bit18=1 ticked...
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,40008h ;bit18,bit3=1 reverse direction.
					    .IF eax == 40008h					
					      ;just reversed, but stop now before going back to home...
			          or (OBJECT PTR [edi]).fconfig2,100h ;set bit8, stop event.
						    mov (OBJECT PTR [edi]).cntani,0 ;cnt of # steps taken.
						    ;i think also need to clr bit3 back to forward direction (fixes bug)...
					      and (OBJECT PTR [edi]).fconfig2,0FFFFFFF7h ;01000b ;clr bit3.						
					      jmp stop1
					      ;...when next reenter xtimer(), further above will see bit8=1
					      ;and will go to stop1z:, which clrs color changes and bypasses animation.
					    .ENDIF
					    
					  ;v1.62
					  ;if element highlighted, need to freeze animated element at start,
					  ;for correct positioning when export to svg...
					  mov eax,(OBJECT PTR [edi]).fconfig2
					  and al,088h ;bit7 =1 highlighted. bit3=0 have just changed to forward dir.
					  .IF al==80h ;have just changed to forward, and it's highlighted, so stop...
						  or (OBJECT PTR [edi]).fconfig2,01 ;set bit0, stop animation.
						  mov (OBJECT PTR [edi]).cntani,0
						  jmp stop1
					  .ENDIF
					    ;v2.87 do same for mouseout in wmmousemove() which sets bit17...
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,20008h ;bit17 special flag. bit3=0 have just changed to forward.
					    .IF eax==20000h ;just changed to forward, so stop.
						    or (OBJECT PTR [edi]).fconfig2,01 ;set bit0, stop animation.
						    mov (OBJECT PTR [edi]).cntani,0
						    jmp stop1					
					    .ENDIF
					  mov eax,eaxsave
				  .ENDIF
				  ;now to drag target element...
				  mov ebx,(OBJECT PTR [edi]).rpowner1
				  .IF ebx==0
					  jmp stop1
				  .ELSE
					  add ebx,pTERSEDATA
					  
					    ;v3.09
					    ;now have a checkbox to animate "boss" element (and children),
					    ;not just the immediate target element.
					    ;ebx->target element, ie what the animator is attached to.
					    ;edi->animator.
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,80000h ;bit19=1, animate boss.
					    .IF eax != 0
					      ;boss is defined as element without an owner...
					      ;(not concerned if locked or not, for compatibility with svg).
own1:			      mov eax,(OBJECT PTR [ebx]).rpowner1
					      .IF eax != 0
					        mov ebx,eax
					        add ebx,pTERSEDATA
					        jmp own1
					      .ENDIF
					    .ENDIF
					    
					  mov panimated,ebx

 					    ;v2.71 flash colors... v2.75 one-shot...
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,0600h ;bit9=1 flash fill (brush) color of target.
					    .IF eax==0200h ;bit9 only.
					        ;mov (OBJECT PTR [ebx]).nfillcolor,eax
				          ;not (OBJECT PTR [ebx]).nfillcolor
				          ;not (OBJECT PTR [ebx]).nfontcolor ;flash labels here.
onflash:          not (OBJECT PTR [ebx]).npencolor
				          ;...v2.72 paint_() methods to read bit9, flash fill, font colors.
					        xor (OBJECT PTR [ebx]).fconfig2,0200h ;toggle bit9 in target.
					        ;...this keeps track if color currently reversed.
					    .ELSEIF eax==0400h ;bit10 only, one-shot.
onflash1:       mov eax,(OBJECT PTR [ebx]).npencolor
					      .IF SDWORD PTR eax>=0
				          not (OBJECT PTR [ebx]).npencolor ;reverse color and leave inverted.
					      .ENDIF
					      or (OBJECT PTR [ebx]).fconfig2,0200h ;set bit9 in target and leave.
					    .ELSEIF eax==0600h ;both.
					      ;want to flash colors just once...
					      mov eax,(OBJECT PTR [edi]).fconfig2
					      and eax,1000h ;bit12, used to record a single invert has happened.
					      .IF eax==0 ;fflashonce==0
					        or (OBJECT PTR [edi]).fconfig2,1000h ;inc fflashonce
					        jmp onflash1
					      .ELSE ;IF fflashonce==1
					        ;inc fflashonce
					        ;jmp onflash
				          mov eax,(OBJECT PTR [ebx]).npencolor
				          .IF SDWORD PTR eax<0
				            not (OBJECT PTR [ebx]).npencolor ;restore to normal.
				          .ENDIF
				          and (OBJECT PTR [ebx]).fconfig2,0FFFFFDFFh ;clr bit9 in target.
					      .ENDIF
					    .ENDIF
					    ;v2.81 bit14 is an override that child of target reads, overrides
					    ;blinking, keeps child inverted for duration of event...
					    ;(paint_() methods have to read these bits)
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,04000h ;bit14.
					    .IF eax != 0
					      or (OBJECT PTR [ebx]).fconfig2,04000h ;set bit14 in target.
					    .ENDIF
					    ;v2.81 bit13=1 makes target/child label visible (if normally invisible)...
					    mov eax,(OBJECT PTR [edi]).fconfig2
					    and eax,02000h ;bit13.
					    .IF eax != 0
					      or (OBJECT PTR [ebx]).fconfig2,02000h ;set bit13 in target.
					    .ENDIF
					    					
					  mov ebx,(OBJECT PTR [edi]).xdeltacentre
					  mov ecx,(OBJECT PTR [edi]).ydeltacentre
					  neg ebx ;goes the wrong way!
					  neg ecx ;/
					  mov eax,(OBJECT PTR [edi]).fconfig2
					  and eax,4000Eh ;al,1110b  ;bit3=1 backwards, bit2=1 smooth back, bit1=1 jump back.
					  .IF al==1100b ;smooth backwards
					    neg ebx
					    neg ecx
					  .ELSEIF al==1010b ;jump back.
					    mov eax,(OBJECT PTR [edi]).maxcntani
					    imul ebx
					    mov ebx,eax
					    neg ebx
					    mov eax,(OBJECT PTR [edi]).maxcntani
					    imul ecx
					    mov ecx,eax
					    neg ecx
					    ;mov (OBJECT PTR [edi]).cntani,0
					    ;xor (OBJECT PTR [edi]).fconfig2,01000b ;clrs bit3. forwards.
					    mov eax,(OBJECT PTR [edi]).maxcntani
					    mov (OBJECT PTR [edi]).cntani,eax ;reached the end.
					  ;.ELSEIF eax==40008h ;no return. bit18=1. v3.14
					  ;  ;*PROBLEM* have code above for detecting no-return, which did work,
					  ;  ;but just tried an example and it didn't stop at far end. so put in
					  ;  ;this extra detection...
					  ;  mov ebx,0 ;no change.
					  ;  mov ecx,0 ;/
					  ;  mov eax,(OBJECT PTR [edi]).maxcntani
					  ;  mov (OBJECT PTR [edi]).cntani,eax ;reached the end.
					  ;  jmp stop1
					  .ENDIF
					  
					  ;v3.14 going forward, last step, apply error correction (calc in aniproc())...
					  ;i see a problem with doing this for smooth-return and jump-return, as
					  ;they currently don't add-in the error when returning (though I could add
					  ;it to above code ...maybe). so, restrict this correction to the
					  ;"no return" animation only...
					  ;enter ebx,ecx has x,y step.
					  mov eax,(OBJECT PTR [edi]).fconfig2
					  and eax,40008h ;1000b ;bit3=0 forward. bit18=1 no return.
					  .IF eax==40000h
					    ;how to detect last step?...
					    mov eax,(OBJECT PTR [edi]).maxcntani
					    mov edx,(OBJECT PTR [edi]).cntani
					    .IF eax==edx
					      ;subtract, because negated ebx,ecx above...
					      sub ebx,(OBJECT PTR [edi]).xenderror ;calc in aniproc().
					      sub ecx,(OBJECT PTR [edi]).yenderror ;/
					    .ENDIF
					  .ENDIF
					  
				    ;need to wipeout current position of elements...
					  mov al,g_nknee
					  mov nknee0,al ;push eax
					  mov g_nknee,0
					  mov al,fdragmask
					  mov fdragmask0,al ;push eax
					  mov fdragmask,0 ;precaution. i don't think call any drag_ methods anyway.
					  
					  ;v2.83 bypass if not moving...
					  mov eax,(OBJECT PTR [edi]).xlabeloffset ;total x change.
					  .IF eax==0
					    mov eax,(OBJECT PTR [edi]).ylabeloffset
					    .IF eax==0
					      jmp stop1v
					    .ENDIF
					  .ENDIF
				      pushad
				      invoke add2wipeoutlist,panimated
				      invoke wipeoutslaves,panimated
				      ;invoke InvalidateRgn, g_hwnd,0,FALSE
				      ;...done in add2wipeoutlist()
				      mov  g_fredrawdiag,WIPEOUTobjs
				      push g_nmousex
				      push g_nmousey
  ;mov g_errorapi,0B08h ;for crash outside EVE, error codes range Axxh. v3.23
				      invoke UpdateWindow, g_hwnd			  ;wipe immediately.
				      pop  g_nmousey
				      pop  g_nmousex
				      popad
					    ;v1.72 see note below.
					    ;v1.71...
					    pushad
					    push g_nmousex ;nearobjects uses these for nearness.
					    push g_nmousey ;/
					    mov ebx,panimated
					    mov eax,(OBJECT PTR [ebx]).xtopleft
					    mov g_nmousex,eax
					    mov eax,(OBJECT PTR [ebx]).ytopleft
					    mov g_nmousey,eax
					    invoke nearobjects,ebx ;adds near objs to updatelist,incl ebx.
					    pop g_nmousey
					    pop g_nmousex
					    popad
stop1v:       ;bypass					
					    
					    ;ebx,ecx have x/y change...
					    ;v2.72 if animator.fconfig2/bit9=1 flash colors, then set bit7
					    ;(highlighted) in all slaves, else clr bit7...
					    invoke updateslaves,panimated,ebx,ecx,1
					    ;1= pmoving also updated.
					    ;adds all elements found to updatelist.
					    ;...although they are probably all found by nearobjects(),
					    ; ensuring them listed in correct order for painting.
					    ;invoke clrmovedbit 		   ;.status/bit7 set if a wire moved.
					  mov al,fdragmask0 ;pop eax
					  mov fdragmask,al
					  mov al,nknee0 ;pop eax
					  mov g_nknee,al
stop1x:		  invoke InvalidateRgn,g_hwnd,0,FALSE ;don't redraw background.
					  ;mov g_fredrawdiag,UPDATEobjs
					  ;...v1.72 a problem with repainting when menus used.
					  ;if just put g_fredrawdiag=ENTIRE, makes too much work for
					  ;xtimer() every 1/4 second. so...
					  .IF g_fredrawdiag != ENTIRE ;if something else has set it.
					    mov g_fredrawdiag,UPDATEobjs
					  .ENDIF
				  .ENDIF
stop1:  ;.ENDIF ;end of test .anitime==0 v2.83
			.ELSE ;not an animation element.
			  jmp SHORT fa1
			.ENDIF ;end test if animation element.
		.ELSE ;not a valid element.
fa1:	;animation element isn't there, so remove from anilist...
			lea esi,anilist
			mov [esi+ebx],DWORD PTR 0
		.ENDIF ;end test if valid element.
		  popad
end2b:	dec eax
		jmp end2
end1:

	jmp out1
xtimer ENDP
;--------------------------------------------------------------------------
xorigin PROC STDCALL
;from menu Control/Go to origin > IDM_ORIGIN.

				  mov  eax,clientrect.rc_right
				  sub  eax,clientrect.rc_left
						add eax,4
				  mov  clientrect.rc_right,eax
				  mov  clientrect.rc_left,4
				  mov  eax,clientrect.rc_bottom
				  sub  eax,clientrect.rc_top
						add eax,4
				  mov  clientrect.rc_bottom,eax
				  mov  clientrect.rc_top,4
				  invoke InvalidateRgn, g_hwnd,0,TRUE	;invalidate entire window.
				  mov g_fredrawdiag,ENTIRE								;redraw entire window.

  ret
xorigin ENDP
;--------------------------------------------------------------------------
xkeyup PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
; "xkeyup"
;from WM_KEYUP

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp SHORT out1 ;get out.
  .ENDIF

						  mov g_naccelx,0		;stops xtimer() from scrolling.
						  mov g_naccely,0		;/
						  mov fdelay,0			;/

;v1.2 trying to get the page margins to draw right when scrolling (they must stay put)...
		.IF fdrawmargins==1  ;see xpaint_wipeout() (only set while scrolling)
		  invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
		  mov g_fredrawdiag,ENTIRE								;redraw entire window.
		  mov fdrawmargins,0
		.ENDIF

out1:
		ret
xkeyup ENDP
;--------------------------------------------------------------------------
xkeydown PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:DWORD
; "xkeydown"
;from WM_KEYDOWN...

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

		  mov esi,pTERSEDATA

		  .IF g_nstate==0
;we can use arrow keys to scroll window...
;if ctrl key is helf down, scrolling is by printer paper-size,
;else by size of window client area...
e00:
  ;mov g_errorapi,0B09h ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GetAsyncKeyState, VK_CONTROL
				and  ax,8000h									;bit15=1 if key down.
				.IF ax==8000h
				  .IF wparam==VK_RIGHT

;						   mov	eax,clientrect.rc_left
;						   add	eax,xwinext 			 ;width of prn page, scaled down.
;						   mov	clientrect.rc_left,eax
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling...
						mov eax,xwinext    ;note, not xwinext_exact.
						mov ecx,(TERSEDATA PTR [esi]).xfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.(+ve .xfineprn=enlarged)
						add eax,xwinext
						add clientrect.rc_left,eax

;						   mov	eax,clientrect.rc_right
;						   add	eax,xwinext
;						   mov	clientrect.rc_right,eax
						add clientrect.rc_right,eax ;v1.2

z00:			  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
				  .ELSEIF wparam==VK_LEFT
;						   mov	eax,clientrect.rc_left
;						   sub	eax,xwinext
;						   mov	clientrect.rc_left,eax
;						   mov	eax,clientrect.rc_right
;						   sub	eax,xwinext
;						   mov	clientrect.rc_right,eax
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling...
						mov eax,xwinext
						mov ecx,(TERSEDATA PTR [esi]).xfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.(+ve .xfineprn=enlarged)
						add eax,xwinext
						sub clientrect.rc_left,eax
						sub clientrect.rc_right,eax ;v1.2

;						   invoke InvalidateRgn, g_hwnd,0,TRUE
;						   mov g_fredrawdiag,ENTIRE
						jmp z00 ;v1.2
				  .ELSEIF wparam==VK_DOWN
;						   mov	eax,clientrect.rc_top
;						   add	eax,ywinext 			 ;height of prn page, scaled down.
;						   mov	clientrect.rc_top,eax
;						   mov	eax,clientrect.rc_bottom
;						   add	eax,ywinext
;						   mov	clientrect.rc_bottom,eax
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling...
						mov eax,ywinext  ;note not ywinext_exact.
						mov ecx,(TERSEDATA PTR [esi]).yfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.(+ve .xfineprn=enlarged)
						add eax,ywinext
						add clientrect.rc_top,eax
						add clientrect.rc_bottom,eax

;						   invoke InvalidateRgn, g_hwnd,0,TRUE
;						   mov g_fredrawdiag,ENTIRE
						jmp z00 ;v1.2
				  .ELSEIF wparam==VK_UP
;						   mov	eax,clientrect.rc_top
;						   sub	eax,ywinext
;						   mov	clientrect.rc_top,eax
;						   mov	eax,clientrect.rc_bottom
;						   sub	eax,ywinext
;						   mov	clientrect.rc_bottom,eax
						;v1.2 also see xpaint_print()
						;adj for printer finetune scaling...
						mov eax,ywinext
						mov ecx,(TERSEDATA PTR [esi]).yfineprn
						imul ecx
						mov ecx,1000 ;100
						idiv ecx
						neg eax ;the width has to be reduced if enlarged.(+ve .xfineprn=enlarged)
						add eax,ywinext
						sub clientrect.rc_top,eax
						sub clientrect.rc_bottom,eax

;						   invoke InvalidateRgn, g_hwnd,0,TRUE
;						   mov g_fredrawdiag,ENTIRE
						jmp z00 ;v1.2
				  .ELSEIF wparam==VK_DELETE
				  
						;delete most recently placed object... (ctrl key held down)
						mov edi,poldmovingobject
						.IF edi==0
						.ELSE
						  mov  ebx,(OBJECT PTR [edi]).rpmethods
						  invoke deletePTR PTR [ebx+ptrs+pdelete], edi ;delete the object.
						  invoke zeroabsoluteptrs,1 ;just in case.
						  invoke InvalidateRgn, g_hwnd,0,TRUE			;invalidate entire window.
						  mov g_fredrawdiag,ENTIRE						;redraw entire window.
						.ENDIF

				  .ENDIF
				.ELSE											  ;ctrl key not held down.
				  mov ebx,pTERSEDATA
				  mov eax,(TERSEDATA PTR [ebx]).feveprefs
				  and al,010b			;bit1
				  .IF al==0 	;incremental scroll.
						;note, wmmousemove()-->scrolling() tests mouse on boundary
						;with <ctrl> held down, then does same thing.
						;xtimer() does the actual scrolling.
						;note, need to clear g_naccelx and g_naccely. for mouse,
						;wmlbuttonup does it. for here, use xkeyup().
						.IF wparam==VK_RIGHT	;scroll to right.
						  .IF g_naccelx==0
								add g_naccelx,2    ;(accel will be a +ve value)
						  .ENDIF
						.ELSEIF wparam==VK_LEFT ;scroll to left.
						  .IF g_naccelx==0		;i only want xtimer to incr it beyond 2.
								sub g_naccelx,2 				;(accel will be a -ve value)
						  .ENDIF
						.ELSEIF wparam==VK_DOWN
						  .IF g_naccely==0
								add g_naccely,2    ;(accel will be a +ve value)
						  .ENDIF
						.ELSEIF wparam==VK_UP
						  .IF g_naccely==0		;i only want xtimer to incr it beyond 2.
								sub g_naccely,2 				;(accel will be a -ve value)
						  .ENDIF
;						.ELSE
;						  mov g_naccelx,0		;stops xtimer() from scrolling.
;						  mov g_naccely,0		;/
;						  mov fdelay,0			;/
						.ENDIF
				  .ELSE 						;scroll a window at a time.
						.IF wparam==VK_RIGHT
						  mov  eax,clientrect.rc_left
						  add  eax,xclientpixels						;width of client area.
						  mov  clientrect.rc_left,eax
						  mov  eax,clientrect.rc_right
						  add  eax,xclientpixels
						  mov  clientrect.rc_right,eax
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ELSEIF wparam==VK_LEFT
						  mov  eax,clientrect.rc_left
						  sub  eax,xclientpixels
						  mov  clientrect.rc_left,eax
						  mov  eax,clientrect.rc_right
						  sub  eax,xclientpixels
						  mov  clientrect.rc_right,eax
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ELSEIF wparam==VK_DOWN
						  mov  eax,clientrect.rc_top
						  add  eax,yclientpixels						;height of client area.
						  mov  clientrect.rc_top,eax
						  mov  eax,clientrect.rc_bottom
						  add  eax,yclientpixels
						  mov  clientrect.rc_bottom,eax
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ELSEIF wparam==VK_UP
						  mov  eax,clientrect.rc_top
						  sub  eax,yclientpixels
						  mov  clientrect.rc_top,eax
						  mov  eax,clientrect.rc_bottom
						  sub  eax,yclientpixels
						  mov  clientrect.rc_bottom,eax
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_fredrawdiag,ENTIRE
						.ENDIF
				  .ENDIF ;end of test incremental/window scroll.
				  
				  ;v2.79 state0, if have pressed delete key, want to delete any group of
				  ;selected elements. This is also done from menu "Control/Delete
				  ;selected elements"... copy code from there,modified...
				  .IF wparam==VK_DELETE
						.IF highlightedindex != 0
					    invoke deleteelements
						  ;mov highlightedindex,0
						  mov g_fredrawdiag,ENTIRE
						  invoke InvalidateRgn, g_hwnd,0,TRUE
						  mov g_nknee,0  ;precaution.
						.ENDIF
					.ENDIF	
				  
				.ENDIF ;end of test control key.

				;v2.20
				;BACKSPACE key to restore shadow mem to highlighted list elements...
				.IF g_pshadowmem != 0
				  .IF highlightedindex != 0
					.IF wparam==VK_BACK
					  invoke copyshadow2hi
					  invoke calcboundingrecthi
						  ;...global coords n1stx,n1sty,n2ndx,n2ndy.
						  ;save originals...
						  mov eax,n2ndx
						  mov n2ndx0,eax ;original left-top coord.
						  mov eax,n2ndy
						  mov n2ndy0,eax
					  invoke InvalidateRgn, g_hwnd,0,TRUE ;wipe background.
					  mov g_fredrawdiag,ENTIRE
					.ENDIF
				  .ENDIF
				.ENDIF



		  .ELSEIF g_nstate==2							 ;object-highlighted state
			   ;if user presses DEL key, while an object is highlighted, it deletes.
			   ;if a node, any attached wires also delete...
			   .IF wparam==VK_DELETE	;delete key?
				 .IF g_pselectedobject==0	  ;***redundant, as cannot be in
				   nop													;***state-2 without this set.
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
				   mov	g_nstate,0
				 .ELSE
				   mov edi,g_pselectedobject
				   mov	ebx,(OBJECT PTR [edi]).rpmethods
				   invoke deletePTR PTR [ebx+ptrs+pdelete],edi ;delete highlighted object.
				   mov g_pselectedobject,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						mov g_nstate,0							 ;back to normal state.
						invoke InvalidateRgn, g_hwnd,0,TRUE ;invalidate entire window.
						mov g_fredrawdiag,ENTIRE						;redraw entire window.
				 .ENDIF
			   .ELSEIF wparam==VK_TAB ;v1.46
				 ;i want to be able to sequentially highlight all attached elements
				 ;(common owner, but not necessarily locked)...
				 mov edi,g_pselectedobject
				 or edi,edi ;cmp edi,0	;precaution.
				 je bb3 	;/

				   ;v1.81 element is boss (.rpowner1=0) yet is locked (.fconfig4/bit3=1)
				   ;i want to be able to drag, but not alone -- with children --see drag_node().
				   ;also want to disable dragging/display of handles --see paint_node().
				   ;also for comp-obj, don't want TAB to children...
				   mov eax,(OBJECT PTR [edi]).fconfig4
				   and al,01000b ;bit3.
				   .IF al==01000b ;locked.
					 mov eax,(OBJECT PTR [edi]).rpowner1
					.IF eax==0
					  ;bypass everything below...
					  jmp bb3
					.ENDIF
				  .ENDIF

						;wipeout and redraw current element...
						invoke add2wipeoutlist,edi
						mov g_pselectedobject,0 ;precaution.
						mov g_nknee,0			   ;/
						;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						;...done in add2wipeoutlist()
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex
						invoke add2updatelist,edi		;
				 invoke findnextattached,edi
				 ;no return in eax. puts next element in g_pselectedobject
				 mov edi,g_pselectedobject
				   mov eax,(OBJECT PTR [edi]).number ;v1.90 top-right of window.
				   invoke displaynumber,eax 		 ;/
				 invoke add2updatelist,edi
				 invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
				 mov g_fredrawdiag,UPDATEobjs
bb3:
			   .ELSE  ;v0.99
				  ;i want to be able to use arrow keys when an obj is highlighted(state2)...
				  jmp e00 ;test for arrow-keys.
			   .ENDIF
		  .ENDIF

out1:
  ret
xkeydown ENDP
;--------------------------------------------------------------------------
findnextattached PROC STDCALL USES ebx ecx edx esi edi, phigh:DWORD
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
		LOCAL proot:DWORD,pobjs:DWORD
;v1.46 "findnextattached"
;similar to stretchcompobj().
;finds next element with same root owner as phigh, makes it highlighted.
;this function is called when EVE is in g_nstate=2. phigh is current highlighted element.
;comes here from WM_KEYDOWN-->xkeydown()-->statr2/VK_TAB pressed.
;note, loops around database if reaches end.

;bug -- i found an element that had .rpowner1 ptg to itself -- not allowed. need to
;detect and zero it here.

		;find the root owner...
		mov ebx,phigh
mnz1:	mov eax,(OBJECT PTR [ebx]).rpowner1
		.IF eax == 0
		.ELSE
		  add eax,pTERSEDATA
		  .IF eax==ebx
			;it's ptg to itself...
			mov (OBJECT PTR [ebx]).rpowner1,0
			jmp SHORT mn2
		  .ENDIF
		  mov ebx,eax
		  jmp mnz1
		.ENDIF
mn2:	mov proot,ebx ;root owner.

;scan through all objects...
bb1:		  mov edi,pTERSEDATA
			  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
			  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
			  mov pobjs,esi
			  mov ecx,(TERSEDATA PTR [edi]).numrecords
			  .IF cx==0  ;precaution.
				jmp xj03
			  .ENDIF
			  ;as we loop around, edi->start of TERSEDATA, esi->current object...
			  .IF phigh != 0
				mov esi,phigh
				add esi,(TERSEDATA PTR [edi]).nsizeobject ;next record.
				  ;as we are part-way into the database, have to reduce the count...
				  mov eax,esi
				  sub eax,pobjs
				  mov ebx,(TERSEDATA PTR [edi]).nsizeobject
				  xor edx,edx
				  div ebx ;gives eax=number of records before esi.
					.IF eax>=ecx ;have gone over end of database.
bb2:				  mov phigh,0
					  jmp bb1 ;start from beginning of database.
					.ENDIF
				  sub ecx,eax ;# records still to be searched!
			  .ENDIF
xnextobj:
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				.IF al==01	  ;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ignore all invisible elements.
				  .ELSE
					;find root owner of this element...
					mov ebx,esi
nnz1:				mov eax,(OBJECT PTR [ebx]).rpowner1
					.IF eax == 0
					.ELSE
					  add eax,pTERSEDATA
						.IF eax==ebx
						  ;it's ptg to itself...
						  mov (OBJECT PTR [ebx]).rpowner1,0 ;fix.
						  jmp SHORT xmn2
						.ENDIF
					  mov ebx,eax
					  jmp nnz1
					.ENDIF
xmn2:				;...root owner in ebx
					.IF ebx==proot
					  jmp SHORT fnd1
					.ENDIF
				  .ENDIF
				.ENDIF
				mov ecx,ecxsave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
				loop  xnextobj
xj03:
		;restart search from beginning of database...
		jmp bb2 	;(if no other, at least it'll refind itself).

fnd1:
		mov g_pselectedobject,esi
		ret

findnextattached ENDP
;...................................................................
findlinkactivator PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
  LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
; "find linkactivator"
;finds if a link activator (.nexttype=41) is attached to pobj.
;returns eax->activator, else eax=0.

;v3.29 there is a bug, linkactivator.flinks is getting clrd. precaution here...
    mov ebx,pobj
    mov eax,(OBJECT PTR [ebx]).nexttype
    .IF eax==41 ;this is a link activator, so an error.
      jmp kf4 ;exit, not fnd.
    .ENDIF
    
;scan thru database...
	      mov ebx,pobj
				mov edi,pTERSEDATA
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF eax==41 ;link activator.
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  .IF eax != 0
						    add eax,pTERSEDATA
						    .IF eax==ebx ;link activator is attached to pobj.
						      mov eax,(OBJECT PTR [esi]).flinks
						      mov (OBJECT PTR [ebx]).flinks,eax ;keep it correct.
								  jmp SHORT fnd1
								.ENDIF
							.ENDIF	
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
			mov edi,edisave
			mov esi,esisave
			mov eax,(TERSEDATA PTR [edi]).nsizeobject
			add esi,eax 			;addr of next object.
		loop nextobj
;		jmp SHORT kf4
;kf3: jmp nextobj

    mov (OBJECT PTR [ebx]).flinks,0 ;as no links activator attached.
kf4:
		xor esi,esi ;not found. return eax=0.		
fnd1:
		mov eax,esi
		ret
findlinkactivator ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szstartexe BYTE "start.exe ",0
szopen	   BYTE "open",0
szneedbrowser BYTE "First choose alternative browser in EVE preferences",0

.CODE
xdblclk PROC STDCALL USES edi esi ebx ecx edx,wmsg:DWORD,wparam:DWORD,lparam:DWORD
    ;LOCAL pvalue:DWORD
		LOCAL zoom:SDWORD
		LOCAL horizshift:DWORD, vertshift:DWORD
		LOCAL xend:DWORD, yend:DWORD
		LOCAL nring:WORD
		LOCAL pendeditor:DWORD
		LOCAL fdone:BYTE, ptop:DWORD, pfirsttop:DWORD
		LOCAL psz2:DWORD,pdata:DWORD,fwipe:BYTE
		LOCAL pmem:DWORD,picfiletype:DWORD
		LOCAL xoldmid:SDWORD,yoldmid:SDWORD
;called via WM_LBUTTONDBLCLK	"xdblclk" *EVE*

  ;v3.10 g_flinearscroll set =1 in xdblclk() by goto link. also g_naccelx/y non-0
  ;and xtimer() uses these 3 to scroll. some wm...() can clr g_naccelx/y
  ;so bypass... in fact, why not get out entirely?...
  .IF g_flinearscroll != 0
    jmp out1 ;get out.
  .ENDIF

  mov pdata,0
  mov fwipe,0
  mov ebx,pTERSEDATA ;v3.11
  mov eax,(TERSEDATA PTR [ebx]).nzoom
  mov zoom,eax
  .IF g_nstate==0
		  ;my idea here is when zoomed out, if dblclk somewhere, it becomes
		  ;new client origin and zoom=0...
		  ;also if zoomed in, will jump to zoomed out, keeping same place...
		  invoke bigmove

  .ELSEIF g_nstate==1


  .ELSEIF g_nstate==2

;wmlbuttondown() on a node causes g_nstate=1.
;this is followed by wmlbuttonup() which puts g_nstate=2.

		;v1.87 wmlbuttondown()/state0 on a locked element, puts value into g_rplockedelement
		;(else 0). i want to be able to dbl-clk on a locked icon...
		;(for lockedelement, g_pselectedobject pts to unlocked parent)
		mov eax,g_rplockedelement
		.IF eax==0
		  ;carry on as normal...
		  mov esi,g_pselectedobject
		.ELSE							  ;v1.88
		  add eax,pTERSEDATA
		  mov esi,eax
			;if the highlighted obj is different from lockedelement, the highlighted is not
			;clring its highlighting...
			mov eax,g_pselectedobject
			.IF eax != esi
			  invoke add2wipeoutlist,eax
			  mov fwipe,1 ;used below.
			.ENDIF
		  mov g_rplockedelement,0 ;precaution.
		.ENDIF
		;...drop here with esi->"hotspot" element with attached link activator.

    ;v2.95 with these links, we may have say "test.txt" for a text-file link,
    ;meaning it is in the eve.exe home directory. however, use of "Find" buttons
    ;changes the current directory. i recorded it in szhomefolder in wmcreate()...
  ;mov g_errorapi,0B0Ah ;for crash outside EVE, error codes range Axxh. v3.23
    invoke SetCurrentDirectory,ADDR szhomefolder
    ;...will also need to load szhomefolder in opendatafile().

    ;v2.76 now can have attached link activator...
    ;link activator uses paint_(), which copies link.flinks to owner.flinks.
    ;this has values 60-69, just like icons, icon.nexttype...
    mov eax,(OBJECT PTR [esi]).flinks
    .IF eax>=60
      .IF eax<=69
        ;has an attached link activator. now have to find it...
        invoke findlinkactivator,esi ;ret eax->activator, else eax=0.
        .IF eax != 0 ;found.
          ;the link activator should now take over...
          mov esi,eax
          mov eax,(OBJECT PTR [esi]).flinks ;value 60-69.
          jmp SHORT act1
        .ENDIF
      .ENDIF
    .ENDIF
    
;double-click on an element, open external editor...
						  mov eax,(OBJECT PTR [esi]).nexttype
act1:				  .IF ax==33 ;label.
							  mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax==0 ;precaution.
								.ELSE
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
										mov prbuttonobject,esi
										;...editor originally designed to be opened by a right-
										;button click on cond/action/comment.(goosee).
                      ;v2.31
							        ;can have chained data...
							        lea eax,g_bigblock
							        invoke chain2block,ebx,eax ;0 ;0=create a block.
							        mov pmem,eax
							        .IF eax != 0
								        invoke openexternaleditor,eax,0,0 ;ret eax.
								        .IF eax != 0 ;=0 if picture not changed.
								          invoke lstrlen,pmem
								          inc eax ;include terminating zero.
								          mov edx,esi  ;v2.60
								          sub edx,pTERSEDATA
								          push edx
                          invoke block2chain,pmem,esi,eax,0
                          pop esi
                          add esi,pTERSEDATA
                          ;...pmem->block, esi->label, eax=size of block.
								          ;invoke GlobalHandle,pmem
								          ;invoke GlobalFree,eax
								        .ENDIF
								      .ENDIF
										;lea eax,(OBJECT PTR [ebx]).sztext ;data element.
										;invoke openexternaleditor, eax
								.ENDIF
						  .ELSEIF ax==61 ;text-file icon *OBSOLETE see note above*
								mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax==0 ;precaution.
								.ELSE
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
								  mov al,BYTE PTR (OBJECT PTR [ebx]).sztext
								  .IF al==0
								  .ELSE
										mov prbuttonobject,esi
										;...editor originally designed to be opened by a right-
										;button click on cond/action/comment.(goosee).
;										mov szcommandline,"""" ;need quotes around path/file with spaces.
;										mov edi,pTERSEDATA
;										lea eax,(TERSEDATA PTR [edi]).szeditor1
;										invoke lstrcpy, (OFFSET szcommandline)+1, eax
;										invoke lstrlen, ADDR szcommandline
;										add eax,OFFSET szcommandline
;										mov pendeditor,eax		;we will place the filespec after this.
;										mov ebx,pendeditor
;										mov [ebx],BYTE PTR """" ;quote.
;										inc ebx
;										inc pendeditor
;										mov [ebx],BYTE PTR " "			;/
;										inc pendeditor
;										mov ebx,pdata
;										lea eax,(OBJECT PTR [ebx]).sztext ;data element.
;										mov ebx,pendeditor
;										invoke lstrcpy, ebx,eax
;										lea eax,szcommandline
;										invoke WinExec, ADDR szcommandline, SW_SHOW
										mov edi,pTERSEDATA
										lea eax,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1 v3.01
com1:								mov ebx,pdata
										lea ecx,(OBJECT PTR [ebx]).sztext ;data element.
  ;mov g_errorapi,0B0Bh ;for crash outside EVE, error codes range Axxh. v3.23
                    invoke ShellExecute,g_hwnd,ADDR szopen,eax,ecx,0,SW_SHOWNORMAL										
								  .ENDIF
								.ENDIF
						  .ELSEIF ax==60 ;execution icon *OBSOLETE see note above*
xza1:						mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax==0 ;precaution.
								.ELSE
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
								  mov al,BYTE PTR (OBJECT PTR [ebx]).sztext
								  .IF al==0
								  .ELSE
										lea eax,(OBJECT PTR [ebx]).sztext ;data element.
										mov prbuttonobject,esi
										invoke lstrcpy, ADDR szcommandline, eax
  ;mov g_errorapi,0B0Ch ;for crash outside EVE, error codes range Axxh. v3.23
										invoke WinExec, ADDR szcommandline, SW_SHOW
								  .ENDIF
								.ENDIF
						  .ELSEIF ax==62 ;eve icon. *OBSOLETE see note above*  v2.95.
								mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax != 0 ;precaution.
								  add eax,pTERSEDATA
								  mov pdata,eax
  ;mov g_errorapi,0B0Dh ;for crash outside EVE, error codes range Axxh. v3.23
				          invoke GetModuleFileNameA,0,ADDR szcommandline,255
				          ;...gets path and filename of eve.exe.
				          lea eax,szcommandline
				          jmp com1
				        .ENDIF
						  .ELSEIF ax==64 ;sound icon. *OBSOLETE see note above*
								mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax==0 ;precaution.
								.ELSE
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
								  mov al,BYTE PTR (OBJECT PTR [ebx]).sztext
								  .IF al==0
								  .ELSE
										mov edi,pTERSEDATA
										xor (TERSEDATA PTR [edi]).fviewprefs,0100b ;toggle bit2.
										mov eax,(TERSEDATA PTR [edi]).fviewprefs
										and al,0100b ;bit2 =1 sound on.
										.IF al==0100b
										  lea eax,(OBJECT PTR [ebx]).sztext ;data element.
										.ELSE
										  mov eax,0
										.ENDIF
;										   mov prbuttonobject,esi
;										   invoke lstrcpy, ADDR szcommandline, eax
  ;mov g_errorapi,0B0Dh ;for crash outside EVE, error codes range Axxh. v3.23
										  invoke PlaySound,eax,0, \
												SND_ASYNC+SND_FILENAME ;+SND_LOOP   ;+SND_MEMORY +SND_LOOP v3.23
								  .ENDIF
								.ENDIF
						  .ELSEIF ax==65 ;www icon. *OBSOLETE see note above*
							  mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax==0 ;precaution.
								.ELSE
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
								  mov al,BYTE PTR (OBJECT PTR [ebx]).sztext
								  .IF al==0
								  .ELSE
								  
								    ;v2.89 alternative browser...
								    mov edi,pTERSEDATA
								    mov eax,(TERSEDATA PTR [edi]).feveprefs
								    and eax,100h ;bit8=1 use alternative browser.
								    .IF eax != 0
								      mov al,szbrowser2 ;(TERSEDATA PTR [edi]).szbrowser2  v3.01
								      .IF al==0
		                    invoke myalertbox,ADDR szneedbrowser,4
                        ;invoke MessageBox,g_hwnd,ADDR szneedbrowser,0,MB_OK+MB_ICONEXCLAMATION
		                    jmp by1
								      .ENDIF
;								      mov szcommandline,""""
								      lea eax,szbrowser2 ;(TERSEDATA PTR [edi]).szbrowser2  v3.01
;								      invoke lstrcpy,OFFSET szcommandline+1,eax
;							        invoke lstrlen,ADDR szcommandline
;									    lea edi,szcommandline
;									    add edi,eax
;									    mov [edi],BYTE PTR """"
;									    inc edi
;									    mov [edi],WORD PTR " "
;									    inc edi
;								      jmp SHORT as1 ;*NOTE* still using winexec().
                      jmp com1
								    .ENDIF
								  
									;differs from execution-icon here...
										mov prbuttonobject,esi
										jmp SHORT aww1 ;v2.93 let's do it always.
									.IF fNT==0 ;win9x
;									  invoke lstrcpy,ADDR szcommandline,ADDR szstartexe
;    							  invoke lstrlen,ADDR szcommandline
;									  lea edi,szcommandline
;									  add edi,eax
;as1:								mov ebx,pdata
;										lea eax,(OBJECT PTR [ebx]).sztext ;data element.
;										invoke lstrcpy,edi,eax
;										invoke WinExec, ADDR szcommandline, SW_SHOW
									.ELSE ;winNT+
									  ;this will open the default web browser...
aww1:								mov ebx,pdata
										lea eax,(OBJECT PTR [ebx]).sztext ;data element.
  ;mov g_errorapi,0B0Eh ;for crash outside EVE, error codes range Axxh. v3.23
									  invoke ShellExecute,g_hwnd,ADDR szopen,eax,0,0,0
									.ENDIF
								  .ENDIF
								.ENDIF
								
							.ELSEIF ax==66 ;v3.04 goto link.
							  ;need to read destination coords from attached data element,
							  ;and scroll diagram so coords are in centre...
							  mov eax,(OBJECT PTR [esi]).rpdata
								.IF eax != 0 ;precaution.
								  add eax,pTERSEDATA
								  mov ebx,eax
								  mov pdata,eax
								  mov al,BYTE PTR (OBJECT PTR [ebx]).sztext
								  .IF al != 0
								  
								    invoke parsegotolink ;uses ebx->link data element. v3.07
								    ;...reads .sztext, returns dest coords in g_nx/g_ny.
								    ;...v3.10 returns relative coords in g_nh/g_nv, time in g_nt.
								    ;... value of -1 is invalid.
								    
								      ;need a destination coord... v3.10
								      ;can't just use clientrect directly if zoom!=0...
						          invoke calcdiagmidwindow,zoom ;returns coords in eax/ecx.
								      mov xoldmid,eax ;note, eax value used below.
								      mov yoldmid,ecx
								      .IF g_nx==-1 ;invalid
								        .IF g_nh==-1 ;invalid
								          mov g_nh,0 ;v3.11
								          mov g_nx,eax ;no movement.
								        .ELSE ;use g_nh/g_nv as relative dest coord.
								          add eax,g_nh
								          mov g_nx,eax
								        .ENDIF
								      .ELSE ;use g_nx as absolute dest x coord.
								        mov eax,g_nx    ;v3.11
								        sub eax,xoldmid
								        mov g_nh,eax
								      .ENDIF
								      mov eax,yoldmid  ;note, eax value used below.
								      .IF g_ny==-1 ;invalid
								        .IF g_nv==-1 ;invalid
								          mov g_nv,0 ;v3.11
								          mov g_ny,eax ;no movement.
								        .ELSE ;use g_nv as relative dest coord.
								          add eax,g_nv
								          mov g_ny,eax
								        .ENDIF
								      .ELSE ;use g_ny as absolute dest y coord.
								        mov eax,g_ny
								        sub eax,yoldmid
								        mov g_nv,eax
								      .ENDIF
								      .IF g_nt==-1 ;invalid time, so use t=0.	v3.10	
								        mov g_nt,0
go0:						        invoke centralizeobj,g_nx,g_ny,zoom,1 ;1=keep in middle.
								      .ELSEIF g_nt==0
								        jmp go0
								      .ELSE
								        ;have a time duration, so have to scroll...
								        ;xtimer() uses g_naccelx/g_naccely non-0 as amount to
								        ;scroll by, but accelerates them by a half each time,
								        ;so let's define a flag to tell xtimer() not to change
								        ;rate of scrolling: g_flinearscroll.
								        mov g_flinearscroll,1
								        mov eax,g_nx
								        sub eax,xoldmid ;x change.
								        cdq ;sign-extend to edx:eax.
								        idiv g_nt ;gives step size per second.
								        sar eax,2 ;gives step size per 1/4 second.
								        mov g_naccelx,eax
								          mov eax,g_ny
								          sub eax,yoldmid ;y change.
								          cdq ;sign-extend to edx:eax.
								          idiv g_nt ;gives step size per second.
								          sar eax,2 ;gives step size per 1/4 second.
								          mov g_naccely,eax								
								        mov eax,g_nt
								        sal eax,2 ;# steps.
								        mov g_nstepslimit,eax ;used by xtimer() when g_flinearscroll=1.
								        ;...xtimer() will see g_naccelx/y non-zero and will now scroll.
				                  mov prbuttonobject,0
						              mov g_pselectedobject,0	  ;remove highlighting
						              mov g_nknee,0
										      mov al,g_nstate 		 ;/
										      mov g_nstateprev,al  ;/
						              mov g_nstate,0								  ;/
						              jmp out1
								      .ENDIF
								    ;mov fwipe,1 ;need to wipe and redraw diag.
						          mov prbuttonobject,0
						          mov g_pselectedobject,0	  ;remove highlighting
						          mov g_nknee,0
										  mov al,g_nstate 		
										  mov g_nstateprev,al
						          mov g_nstate,0			
						        invoke InvalidateRgn,g_hwnd,0,TRUE ;TRUE=wipe window.
						        jmp ex1
							    .ENDIF
              	.ENDIF
              	
							.ELSEIF ax==63 ;was generic icon, now picture icon v2.93.
                ;this code same as in iconproc()...
		            ;we want to launch the editor, spec'd in tersedata.szpainter1,
          		  ;with a temp filename, say temp.gif/bmp/jpg, then on exit
          		  ;read the file and zeroise it.
          		  ;i got this code out of labelproc(), but here we need to find out
          		  ;if data is gif/bmp/jpg. also, data is attached to icon.rpdata2...
          						mov eax,(OBJECT PTR [esi]).rpdata2
          						.IF eax==0
          						.ELSE
          						  mov prbuttonobject,esi
          						  add eax,pTERSEDATA
          						  mov ebx,eax ;1st data element.
          						  mov eax,(OBJECT PTR [ebx]).fstatus ;find out gif/jpg/bmp/wmf.
          						  and eax,0342h ;test bits 9/8/6/1
          						  .IF eax==02 ;bit1=1 jpg.
          						    mov picfiletype,2
          						  .ELSEIF eax==40h ;bit6=1 wmf.
          						    mov picfiletype,4
          						  .ELSEIF eax==200h ;bit9=1 gif.
          						    mov picfiletype,1
          						  .ELSE
          						    mov picfiletype,3 ;bmp.
          						  .ENDIF
          						  lea eax,g_bigblock
          							invoke chain2block,ebx,eax ;0 ;0=create a block.
          							.IF eax != 0
          							  mov ecx,(OBJECT PTR [ebx]).xdata ;size of picture.
         								  invoke openexternaleditor,eax,ecx,picfiletype
								          .IF eax != 0 ;=0 if picture not changed.
          								  ;...returns global nfsize =size of image file returned in g_bigblock.
								              ;mygifload() calls getgiftransparent() to extract transparent
								              ;color info from contiguous block and write to 1stdata.end01.
								              ;need to do it here also...
								              .IF picfiletype==1 ;gif.
							                  mov eax,edi
no1:					                  mov ecx,(OBJECT PTR [ebx]).xdata ;size of picture.
                                lea edx,g_bigblock
						                    invoke getgiftransparent,edx,ecx,ebx,eax
								                ;ebx->1stdata, edi->icon.
								                ;...lastparam!=0, reads trans color from gif to 1stdata.end01
								                ;...lastparam>1, ->icon to write r/g/b to.
								              .ELSE
								                xor eax,eax ;flag not a gif.
								                jmp no1
								              .ENDIF
								            mov edx,esi  ;v2.60
								            sub edx,pTERSEDATA
								            push edx
								            lea eax,g_bigblock
								            mov ecx,nfsize
                            invoke block2chain,eax,edi,ecx,1 ;eax
                            ;...what happens if chain gets longer and ptrs become invalid?
                            ;...well, we are not changing the start of the chain, only maybe
                            ;extending the end, so all relative ptrs to the graphic should be ok.
                            pop esi
                            add esi,pTERSEDATA ;edi=ptr to this icon.
                            ;...pmem->block, edi->icon, eax=size of block.
                            ;to do, need to delete the ipicture object, cos it is for the
                            ;older image...
                            ;this scans current database and wipes out any bitmap handles and DCs...
                            invoke deletebitmaphandles   ;(they are used for drawing pictures)
                          .ENDIF
          							.ENDIF
          						.ENDIF
              	
						  .ELSE
								;jmp za1
						  .ENDIF
by1:          ;bypass.						

				      mov prbuttonobject,0
						  mov g_pselectedobject,0	  ;remove highlighting
						  mov g_nknee,0
										push eax						 ;save previous value of state.
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
										pop eax 						 ;/
						  mov g_nstate,0								  ;/
					  .IF fwipe==1 ;v1.88
						  mov g_fredrawdiag,WIPEOUTobjs
						  ;push g_nmousex
						  ;push g_nmousey
						  invoke UpdateWindow, g_hwnd 	;wipe immediately.
						  ;pop g_nmousey
						  ;pop g_nmousex
					  .ENDIF
						  invoke InvalidateRgn, g_hwnd,0,FALSE
ex1:				  mov g_fredrawdiag,ENTIRE

  .ENDIF ;end testing states.
out1:
  xor eax,eax
  ret
xdblclk ENDP
;--------------------------------------------------------------------------
parsegotolink PROC STDCALL USES edi esi ecx edx ;v3.07
  LOCAL pvalue:DWORD
; "parsegotolink"
;uses ebx->link data element. reads .sztext for x/y dest coords,
;writes to g_nx/g_ny.
;v3.10 reads "h=nnn v=nnn t=nnn" returns in g_nh, g_nv, g_nt -relative dest, time.

								    mov g_nx,-1 ;0 v3.10 use -1 as invalid entry.
								    mov g_ny,-1 ;0
								    mov g_nh,-1 ;0
								    mov g_nv,-1 ;0
								    mov g_nt,-1 ;0
								    
								    lea eax,(OBJECT PTR [ebx]).sztext
								    mov ebx,eax
nx1:                mov al,[ebx]
 						        .IF al=="x"
nx2:                  mov pvalue,OFFSET g_nx
nx2b:                 lea edi,szasciitbl
nx5:                  inc ebx
                      mov al,[ebx]
                      .IF al>="0"
                        .IF al<="9"
nx7:                      mov [edi],al
                          inc edi
                          jmp nx5
                        .ENDIF
                      .ENDIF
                      .IF al=="+"
                        jmp nx7
                      .ELSEIF al=="-"
                        jmp nx7
                      .ELSEIF al==" " ;end.
                      .ELSEIF al==0 ;end.
                      .ELSE
                        jmp nx5
                      .ENDIF
                      mov [edi],BYTE PTR 0
                      invoke str2longint,ADDR szasciitbl
                      mov edi,pvalue
                      mov [edi],eax ;dest x-coord.
                      jmp nx1
								    .ELSEIF al=="X"
								      jmp nx2
								    .ELSEIF al=="y"
nx3:						      mov pvalue,OFFSET g_ny
								      jmp nx2b
								    .ELSEIF al=="Y"
								      jmp nx3
								    .ELSEIF al=="h" ;horizontal change v3.10
v10a:                 mov pvalue,OFFSET g_nh
                      jmp nx2b								
								    .ELSEIF al=="H"
								      jmp v10a
								    .ELSEIF al=="v" ;vertical change v3.10
v10b:								  mov pvalue,OFFSET g_nv
                      jmp nx2b
								    .ELSEIF al=="V"
								      jmp v10b
								    .ELSEIF al=="t" ;time duration of transition v3.10
v10c:								  mov pvalue,OFFSET g_nt
                      jmp nx2b
								    .ELSEIF al=="T"
								      jmp v10c
								    .ELSEIF al==0 ;end
								    ;.ELSEIF al<32 ;ignore non-printing chars.
								    .ELSE
								      inc ebx
								      jmp nx1
								    .ENDIF
								    ;...should have coords on g_nx/g_ny.
								

  ret
parsegotolink ENDP
;--------------------------------------------------------------------------
bigmove PROC STDCALL USES ebx ecx edx esi edi
		LOCAL zoom:SBYTE
;from xdblclk.

		  mov esi,pTERSEDATA
		  mov eax,(TERSEDATA PTR [esi]).nzoom
		  mov zoom,al
		  .IF zoom>0
						mov (TERSEDATA PTR [esi]).nzoom,0
big1:			;make logical mouse coords the new origin...
						;first do x coord...
						mov eax,clientrect.rc_left
						mov ebx,g_nmousex
						mov clientrect.rc_left,ebx		;set left to g_nmousex
						sub ebx,eax
						add clientrect.rc_right,ebx ;move right by same amount.
						  ;then do y coord...
						  mov eax,clientrect.rc_top
						  mov ebx,g_nmousey
						  mov clientrect.rc_top,ebx ;set left to g_nmousex
						  sub ebx,eax
						  add clientrect.rc_bottom,ebx ;move right by same amount.
						invoke InvalidateRgn,g_hwnd,0,TRUE		;invalidate entire window.
						mov g_fredrawdiag,ENTIRE						;redraw entire window.
		  .ELSEIF zoom<0
						mov (TERSEDATA PTR [esi]).nzoom,2 ;zoom out
						jmp big1
		  .ENDIF

  ret
bigmove ENDP
;--------------------------------------------------------------------------
shoot PROC STDCALL USES ebx ecx edx esi edi
				LOCAL chdc:DWORD, crect:RECT, memdc:DWORD,hcpybitmap:DWORD
				LOCAL cwidth:DWORD, cheight:DWORD, hclipbrd:DWORD
				LOCAL holdbitmap:DWORD
; "shoot"
;from File/Copy > IDM_CPY. copies diagram to clipboard.
;copy entire client area to clipboard...(as a bitmap)
				invoke GetDC, g_hwnd	;dc for client area.
				mov  chdc,eax

  ;mov g_errorapi,0B0Fh ;for crash outside EVE, error codes range Axxh. v3.23
				invoke GetClientRect, g_hwnd,ADDR crect
				mov  eax,crect.rc_right
				sub  eax,crect.rc_left
				mov  cwidth,eax
				mov  ebx,crect.rc_bottom
				sub  ebx,crect.rc_top
				mov  cheight,ebx
				invoke CreateCompatibleDC, chdc
				mov  memdc,eax
				invoke CreateCompatibleBitmap, chdc,cwidth,cheight
				mov  hcpybitmap,eax 							;handle of bitmap.
				invoke SelectObject, memdc,hcpybitmap
				mov  holdbitmap,eax
				invoke BitBlt, memdc,0,0,cwidth,cheight,chdc,0,0,SRCCOPY
				invoke OpenClipboard, g_hwnd
				mov  hclipbrd,eax												;handle for clipboard.
				invoke EmptyClipboard
				invoke SetClipboardData,CF_BITMAP,hcpybitmap
				invoke CloseClipboard
				invoke SelectObject, memdc,holdbitmap
				invoke DeleteDC, memdc

				invoke ReleaseDC, g_hwnd,chdc

  ret
shoot ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
PROJECTproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;menu Control/Project-management > IDM_PROJECT > PROJECT dialog box.

		  mov esi,pTERSEDATA

  .IF message==WM_INITDIALOG
		  ;IDD_PROJNUM is the control for project number =TERSEDATA.nproject
		  ;IDD_SUBPROJNUM is control for sub-project number =TERSEDATA.nsubproject
		  ;IDD_DBASEVER is control for database version =TERSEDATA.nversion
		  ;xor eax,eax
		  mov eax,(TERSEDATA PTR [esi]).nproject
		  invoke bin2dec,10    ;-->asciitbl--asciitbl+9, right-justified.
		  ;...returns eax->start of string, past the leading blanks.
;		   lea eax,szasciitbl+6
		  invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,WM_SETTEXT,0,eax
		  invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,EM_LIMITTEXT,4,0
		  ;xor eax,eax
		  mov eax,(TERSEDATA PTR [esi]).nsubproject
		  invoke bin2dec,10
		  ;...returns eax->start of string, past the leading blanks.
;		   lea eax,szasciitbl+6
		  invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,WM_SETTEXT,0,eax
		  invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,EM_LIMITTEXT,4,0
		  mov eax,(TERSEDATA PTR [esi]).nversion
		  invoke bin2dec,10
;		   lea eax,szasciitbl+6
		  invoke SendDlgItemMessage,hdlg,IDD_DBASEVER,WM_SETTEXT,0,eax

		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1

		  ;lea  eax,szasciitbl
		  invoke SendDlgItemMessage,hdlg,IDD_PROJNUM,WM_GETTEXT,5,ADDR szasciitbl
		  invoke str2longint, ADDR szasciitbl  ;--> eax.
		  mov (TERSEDATA PTR [esi]).nproject,eax
		  ;lea  eax,szasciitbl
		  invoke SendDlgItemMessage,hdlg,IDD_PROJSUBNUM,WM_GETTEXT,5,ADDR szasciitbl
		  invoke str2longint, ADDR szasciitbl  ;--> eax.
		  mov (TERSEDATA PTR [esi]).nsubproject,eax


		  invoke EndDialog, hdlg,1 ;TRUE
		  mov eax,TRUE
		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
PROJECTproc ENDP
;--------------------------------------------------------------------------
windowchanged PROC STDCALL,fwipe:DWORD
; "windowchanged"
;called from callback procs.
;fwipe=TRUE wipe background. v3.50

				invoke InvalidateRgn, g_hwnd,0,fwipe ;FALSE	;invalidate entire window.
				mov g_fredrawdiag,ENTIRE								;redraw entire window.
				  push g_nmousex
				  push g_nmousey
  ;mov g_errorapi,0B10h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
				  pop  g_nmousey
				  pop  g_nmousex
				mov  eax,TRUE
	ret
windowchanged ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
xg_perrorobject DWORD 0

.CODE
sznfinderr BYTE "Invalid or out-of-range element number.",0  ;015 v3.01 moved from .DATA

NFINDproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
; "nfindproc"
;menu Control/Element find > IDM_NFIND > NFIND dialog box (id=220).

;v1.18 call here from IDM_BIND_TFIND (MMB interface), with g_hwnd,WM_COMMAND,IDOK,-1, and
;number in g_nx...

		  mov esi,pTERSEDATA

  .IF message==WM_INITDIALOG
		  mov xg_perrorobject,0
		  invoke SendDlgItemMessage,hdlg,204,EM_LIMITTEXT,4,0
		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK

		  mov esi,pTERSEDATA

		  .IF lparam==-1 ;v1.18 see above note.
				;the number is in g_nx...
				mov eax,g_nx
				jmp x01
		  .ENDIF

		  ;lea  eax,szasciitbl
		  invoke SendDlgItemMessage,hdlg,204,WM_GETTEXT,5,ADDR szasciitbl
		  invoke str2longint, ADDR szasciitbl  ;--> eax.
				;xor ebx,ebx
x01:	mov ebx,(TERSEDATA PTR [esi]).numrecords
				.IF SDWORD PTR eax<0
xx1:
				  invoke myalertbox,ADDR sznfinderr,4 ;invoke myerrorhandler,015
				  jmp	nfindno 		;do not end dialog box.
				.ELSEIF eax>=ebx
				  jmp xx1
				.ELSE
				  ;xor ebx,ebx
				  xor edx,edx
				  mov ebx,(TERSEDATA PTR [esi]).nsizeobject
				  mul ebx
;				  lea ebx,(TERSEDATA PTR [esi]).OBJECTS ;starting addr of OBJECTS
						mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
						add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
				  add eax,ebx	;eax now has address of element.
						mov ebx,eax
						mov ecx,(OBJECT PTR [ebx]).fstatus
						and cl,01
						.IF cl==0
						  ;invalid element...
						  jmp xx1
						.ENDIF
						mov ecx,(OBJECT PTR [ebx]).nexttype
						.IF SWORD PTR cx<0 ;cx==-1
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).
			   ;(...so, the 16-bit lower half also -ve).
						  ;non-display element...
						  jmp xx1
						.ENDIF
				  mov xg_perrorobject,eax ;xpaint_entire() will use this to move diag.
				  ;...when window redraws, need the element# in centre.
				  ;mov (TERSEDATA PTR [esi]).nzoom,0 ;diagram move only works at zoom=0.
				  ;;221000 ...note also, have fixed wmpaint() to zoom=0 when
				  ;;  g_perrorobject<>0 (for error on composing).
				  ;...have fixed zoom.
				.ENDIF

		  .IF lparam==-1 ;v1.18 see above note.
				;didn't call this proc from a dialog box.
		  .ELSE
				invoke EndDialog, hdlg,1 ;TRUE
		  .ENDIF
nfindno:
		  mov eax,TRUE
		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
NFINDproc ENDP
;--------------------------------------------------------------------------
.DATA			   ;must all be static...
ALIGN 4 ;v3.24
nlength  DWORD 0				  ;length of test string (not incl 0-terminator)
psource  DWORD 0				  ;ptr into element being tested.
pfoundelement DWORD 0
tesisave DWORD 0
tedisave DWORD 0
tecxsave DWORD 0
sztfind BYTE 64 DUP(0)
sztfindold BYTE 64 DUP(0)
sztsource  BYTE 64 DUP(0)

.CODE
sztend	 BYTE "Search complete. Enter a new text string and press ""Find"" " ;v3.01 moved
				 BYTE "button to perform another search.",0
				 
TFINDproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
; "tfindproc" *EVE*
;*EVE* only search data elements (.nexttype=-1)
;menu Control/Text find > IDM_TFIND > TFIND dialog box (id=221).

;v1.18 call here from IDM_BIND_TFIND (MMB interface), with g_hwnd,WM_COMMAND,IDOK,-1, and
;string in sztfind...

  .IF message==WM_INITDIALOG
		  mov pfoundelement,0
		  mov sztfindold,0
		  invoke SendDlgItemMessage,hdlg,204,EM_LIMITTEXT,62,0
		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK				   ;"Find" button.

				cmp lparam,-1 ;v1.18 see above note.
				je x01

		  lea  eax,sztfind
		  invoke SendDlgItemMessage,hdlg,204,WM_GETTEXT,63,eax
		  ;...saved in sztfind
x01:  invoke lstrlen, ADDR sztfind
		  mov nlength,eax
		  .IF sztfindold==0
ee1:	invoke lstrcpy, ADDR sztfindold, ADDR sztfind
		  .ELSE
				invoke lstrcmp, ADDR sztfindold, ADDR sztfind
				.IF eax==0
				  ;strings are equal...
				.ELSE
				  ;string has been changed, so start search from beginning...
				  mov pfoundelement,0
				  jmp ee1
				.ENDIF
		  .ENDIF

		  ;if a continuation of the search, pfoundelement is non-0...
		  .IF pfoundelement==0
		  .ELSE
				jmp kf1
		  .ENDIF

		  ;go thru all elements, looking for text string, with allowed
		  ;delimiters.
		  ;when found, set g_perrorobject ptg to that element.
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov tesisave,esi
				mov tedisave,edi
				mov tecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				  .IF al==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==-1
;*EVE* we only want data-elements!		  .ELSE 						;not a data object.

								;mov psource,esi		 ;start of element.
								lea eax,(OBJECT PTR [esi]).sztext ;in data-element.*EVE*
								mov psource,eax

ss3:					  ;gone over end of element?...
								  mov eax,(TERSEDATA PTR [edi]).nsizeobject
								  add eax,esi			;addr of next element.
								  .IF psource>=eax
										;have finished searching this element, gotonext one...
										jmp kf1
								  .ELSE
										mov ebx,psource
										add ebx,nlength
										inc ebx 				;need room for end-delimiter also.
										.IF ebx>=eax
										  ;string being tested goes over end of this element...
										  jmp kf1
										.ENDIF
								  .ENDIF
								mov ebx,psource
								dec ebx 				;look for start-delimiter before string.
								mov al,[ebx]
								  ;look for a delimiter...
								  .IF al==0 ;end of previous field.
										jmp ss1
								  .ELSEIF al=="{"
ss1:							  ;zeroise sztsource buffer...
										  lea ebx,sztsource
										  mov ecx,nlength
										  inc ecx
ss2:							  mov [ebx],BYTE PTR 0
										  inc ebx
										  loop ss2
										mov ebx,psource
										;**TRICKY!** this actually copies nlength-1 chars
										;from psource, followed by a zero...
										;invoke lstrcpyn, ADDR sztsource,ebx,nlength
										;so, do it this way...
										  mov eax,nlength
										  inc eax
										  invoke lstrcpyn, ADDR sztsource,ebx,eax
										invoke lstrcmp, ADDR sztfind,ADDR sztsource
										.IF eax==0
										  ;strings are the same, but test end-delimiter valid...
										  mov ebx,psource
										  add ebx,nlength
										  mov al,[ebx]			;get end-delimiter.
										  .IF al==0
												jmp ss5
										  .ELSEIF al=="{"
ss5:									;found, set pfoundelement...
												mov pfoundelement,esi
												;then...
												;when window redraws, need the element in centre.
												mov (TERSEDATA PTR [edi]).nzoom,0
												;...diagram move only works at zoom=0.
												invoke InvalidateRgn, g_hwnd,0,TRUE
												;...invalidate entire window, TRUE=wipe previous
												;221000 ...note, wmpaint() now detects g_perrorobject
												;not=0 and sets zoom=0.
												jmp ss9
												;...gets out of this loop but doesn't end dialog.
										  .ELSEIF al=="}"
												jmp ss5
										  .ELSEIF al=="("
												jmp ss5
										  .ELSEIF al==")"
												jmp ss5
										  .ELSEIF al=="~"
												jmp ss5
										  .ELSEIF al=="^"
												jmp ss5
										  .ELSEIF al=="|"
												jmp ss5
										  .ELSEIF al=="!"
												jmp ss5
										  .ELSEIF al=="="
												jmp ss5
										  .ELSEIF al==">"
												jmp ss5
										  .ELSEIF al=="<"
												jmp ss5
										  .ELSEIF al=="%"
												jmp ss5
										  .ELSEIF al=="/"
												jmp ss5
										  .ELSEIF al=="\"
												jmp ss5
										  .ELSEIF al=="#"
												jmp ss5
										  .ELSEIF al==","
												jmp ss5
										  .ELSEIF al==" "
												jmp ss5
										  .ELSEIF al==";"
												jmp ss5
										  .ELSEIF al==":"
												jmp ss5
										  .ELSEIF al=="+"
												jmp ss5
										  .ELSEIF al=="-"
												jmp ss5
										  .ELSEIF al=="*"
												jmp ss5
										  .ELSEIF al=="&"
												jmp ss5
										  .ELSEIF al=="."
												jmp ss5
										  .ELSEIF al=="$"
												jmp ss5
										  .ELSEIF al==0Dh
												jmp ss5
										  .ELSEIF al==0Ah
												jmp ss5
										  .ELSEIF al==09		;tab char
												jmp ss5
										  .ELSE
												;incorrect end-delimiter, keep searching...
												inc psource
												jmp ss3
										  .ENDIF
										.ELSE
										  ;strings not the same, keep searching...
										  inc psource
										  jmp ss3
										.ENDIF

								  .ELSEIF al=="}"
										jmp ss1
								  .ELSEIF al=="("
										jmp ss1
								  .ELSEIF al==")"
										jmp ss1
								  .ELSEIF al=="~"
										jmp ss1
								  .ELSEIF al=="^"
										jmp ss1
								  .ELSEIF al=="|"
										jmp ss1
								  .ELSEIF al=="!"
										jmp ss1
								  .ELSEIF al=="="
										jmp ss1
								  .ELSEIF al==">"
										jmp ss1
								  .ELSEIF al=="<"
										jmp ss1
								  .ELSEIF al=="%"
										jmp ss1
								  .ELSEIF al=="/"
										jmp ss1
								  .ELSEIF al=="\"
										jmp ss1
								  .ELSEIF al=="#"
										jmp ss1
								  .ELSEIF al==","
										jmp ss1
								  .ELSEIF al==" "
										jmp ss1
								  .ELSEIF al==";"
										jmp ss1
								  .ELSEIF al==":"
										jmp ss1
								  .ELSEIF al=="+"
										jmp ss1
								  .ELSEIF al=="-"
										jmp ss1
								  .ELSEIF al=="*"
										jmp ss1
								  .ELSEIF al=="&"
										jmp ss1
								  .ELSEIF al=="."
										jmp ss1
								  .ELSEIF al=="$"
										jmp ss1
								  .ELSEIF al==0Dh
										jmp ss1
								  .ELSEIF al==0Ah
										jmp ss1
								  .ELSEIF al==09		;tab char.
										jmp ss1
								  .ENDIF
								  inc psource
								  jmp ss3  ;keep searching this element.
						.ENDIF
				  .ENDIF
kf1:	mov ecx,tecxsave
				mov edi,tedisave
				mov esi,tesisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		  loop kf3 ;nextobj
		  jmp SHORT kf4
kf3:  jmp nextobj
kf4:
		  ;put up a messagebox here, end of search...
		  mov pfoundelement,0
						  ;lea eax,sztend
						  invoke myalertbox,ADDR sztend,0
              ;invoke MessageBox,hdlg,eax,ADDR szeve,MB_OK
		  ;do not end dialog box.
		  mov eax,TRUE

		.ELSEIF wparam==IDCANCEL		   ;"Done" button.
		  invoke EndDialog, hdlg,2 ;2 is returned to dialogboxparam() TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
				invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
ss9:	mov ebx,pfoundelement	;keeps found element highlighted.
				  ;*EVE* we searched only data-elements, so need to
				  ;find owner...
				  or ebx,ebx ;cmp ebx,0
				  je p40
				  mov eax,(OBJECT PTR [ebx]).rpowner1 ;owner.
				  add eax,pTERSEDATA
				mov g_perrorobject,eax	; / (xpaint_entire() clears it after 1 paint)
p40:	mov g_fredrawdiag,ENTIRE								;redraw entire window.
				  push g_nmousex
				  push g_nmousey
				  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
				  pop  g_nmousey
				  pop  g_nmousex
				mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF
		ret

TFINDproc ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
str2longint  PROC STDCALL USES ebx ecx edx esi edi, lpstr2:DWORD
		LOCAL dummy:WORD
; "str2longint"
;enter with address of string. returns binary value in eax.
;this routine reads a "-" char and will convert to 2s-complement binary.
;***NOTE*** i haven't fully converted this from 16bit, just put
;a fix on the end to return eax.

				push ebp

				mov  esi,lpstr2
				xor  eax,eax

						xor ax,ax								;DX:AX = 0
						xor bh,bh								;BH = 0
						cwd
						mov cx,10								;CX = 10

p1_ploop:		mov bl,[esi]					 ;Load char
						inc esi
						cmp bl,' '								;Loop while char is space
						je p1_ploop 			;(20h, or 09h thru 0Dh)
				cmp  bl,"0" ;me
				je		 p1_ploop		;/
						cmp bl,9
						jna p1_cont
						cmp bl,13
						jbe p1_ploop

p1_cont:		xor bp,bp								;BP = 0
						cmp bl,'+'								;If char = '+', ignore
						je p1_loop
						cmp bl,'-'								;If char <> '-', keep it
						jne p1_skip
						inc bp									;Set negative flag

p1_loop:		mov bl,[esi]					 ;Load char
						inc esi

p1_skip:		cmp bl,'9'								;Not a digit, finish
						ja p1_finish
						sub bl,'0'
						jc p1_finish

						mul cx									;Multiply by 10
						add ax,bx								;Add in digit...
						adc dl,dh
						jz p1_loop								;Not a long yet, loop
						jmp p1_lload					;Go into long loop

p1_lloop:		mov di,dx								;DI = old hi word
						mov cx,10								;Multiply old lo word by 10
						mul cx
						xchg dx,cx								;CX = new hi word(1)
						xchg ax,di								;DI = new lo word
						mul dx									;Multiply old hi word by 10
						xchg ax,dx								;DX = new hi word(2)
						xchg ax,di								;AX = new lo word
						add ax,bx								;Add in digit
						adc dx,cx								;DX:AX = new value

p1_lload:		mov bl,[esi]					 ;load char
						inc esi

						cmp bl,'9'								;Not a digit, finish
						ja p1_finish
						sub bl,'0'
						jnc p1_lloop					;Jump to loop

p1_finish:		dec bp									;Positive, don't negate
						jl p1_done

						neg dx									;Negate the result
						neg ax
						sbb dx,0

p1_done:
				mov bx,ax		;convert dx:ax to eax.
				mov ax,dx		;/
				mov cl,16		;/
				shl eax,cl		 ;/
				mov ax,bx		;/


				pop ebp

				ret
str2longint ENDP
;--------------------------------------------------------------------------
onresizerect PROC  STDCALL USES edi esi ebx ecx edx,nmousex:DWORD,nmousey:DWORD
	LOCAL pbeginning:DWORD
;v1.92 "onresizerect"
;returns eax=0 if mouse cursor not on rect, else eax pts to object.(using element#0).

;v1.92 now can have a selection rectangle around highlighted elements, when go to menu
;Control/Resize selected elements. test if on a handle of rectangle...
		mov edi,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).noffsetobjs
		add eax,edi ;pTERSEDATA ;starting address of OBJECTS.
		mov pbeginning,eax
;		 mov eax,(TERSEDATA PTR [edi]).fviewprefs
;		 and al,0100000b ;bit5 display resize rectangle.
;		 .IF al==0100000b
		  ;rect. coords in n1stx,n1sty,n2ndx,n2ndy...
		  ;use element#0...
		  mov ebx,pbeginning ;element#0.
		  mov eax,n1stx
		  mov (OBJECT PTR [ebx]).xtopleft,eax
		  mov eax,n2ndx
		  sub eax,n1stx
		  mov (OBJECT PTR [ebx]).wwidth,eax
		  shr eax,1
		  add eax,n1stx
		  mov (OBJECT PTR [ebx]).xmid,eax
		  mov eax,n1sty
		  mov (OBJECT PTR [ebx]).ytopleft,eax
		  mov eax,n2ndy
		  sub eax,n1sty
		  mov (OBJECT PTR [ebx]).height,eax
		  shr eax,1
		  add eax,n1sty
		  mov (OBJECT PTR [ebx]).ymid,eax
			mov g_pselectedobject,ebx ;req'd in on_res().
			invoke on_res,ebx,nmousex,nmousey
			;...return with eax=0 fail, else eax pts to found object.
			;...g_nknee=1 right handle, =2 bottom handle.
			mov g_pselectedobject,0

;		 .ENDIF

	ret
onresizerect ENDP
;--------------------------------------------------------------------------
onanobject PROC  STDCALL USES edi esi ebx ecx edx,nmousex:DWORD,nmousey:DWORD
		LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
		LOCAL pbeginning:DWORD,sizeobj:DWORD,plast:DWORD
; "onanobject"
;called from wmlbuttondown(), state=0.
;also called from wmlbuttondown()/state=4.(placing 1st end new obj).
;v2.24 called from xuser(), xuser1(), xuser2(), for displaying poly handles.
;returns eax=0 if mouse cursor not on an object, else eax pts to object.

;i would like to explicitly exclude g_pmovingobject (if non0)
;as when placing new child objects, i want to test if it is placed
;on top of an existing object...

;have decided it's best to search *back* thru database...
				mov edi,pTERSEDATA
				mov eax,(TERSEDATA PTR [edi]).noffsetobjs
				add eax,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov pbeginning,eax
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp nextobjy
				  .ENDIF
				dec ecx
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				mov sizeobj,eax
				mul ecx
				add eax,pbeginning
				mov plast,eax	;last object in database.
				inc ecx 				;ecx=number of objects.
				mov esi,eax

				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01				;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
				  .ELSE 				;not a data object.
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).
			   ;(...so, the 16-bit lower half also -ve).
						.IF esi==g_pmovingobject		;exclude this from search.
						.ELSE
						  ;finally, call the method test if mouse an an object...
						  mov			ebx,(OBJECT PTR [esi]).rpmethods ;rel.ptr to methods.
						  ;(relative to "ptrs", which is start of the methods table)
						  invoke onPTR PTR [ebx+ptrs+ponobject], esi,nmousex,nmousey
						  ;returns eax=0 fail, else eax pts to object.
						  .IF eax==0
						  .ELSE
								jmp getout
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				sub esi,sizeobj
				;mov eax,(TERSEDATA PTR [edi]).nsizeobject
				;add esi,eax					;addr of next object.
		loop nextobj
nextobjy:
		mov eax,0				;fail.

getout:

  ret
onanobject ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
.DATA	  ;bezier experiment for drawing a wire...
ALIGN 4 ;v3.24
bez1	POINT <0,0> ;x5/y5, loaded in draw1starrow()
bez2	POINT <0,0> ;x4/y4,  "
bez3	POINT <0,0> ;xknee2/yknee2, loaded in paint_arc
bez4	POINT <0,0> ;xmid/ymid, 		 "
bez5	POINT <0,0> ;xknee3/yknee3,  "
bez6	POINT <0,0> ;x4/y4, loaded in draw2ndarrow()
bez7	POINT <0,0> ;s5/y5,  "
;szinter BYTE "inter-task",0

.CODE
paint_arc PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL xright:SDWORD
				LOCAL ybottom:SDWORD
				LOCAL xleft:SDWORD
				LOCAL ytop:SDWORD
				LOCAL xend:SDWORD, yend:SDWORD
				LOCAL plock:DWORD
				LOCAL xend1:SDWORD, yend1:SDWORD
				LOCAL xstart:SDWORD, ystart:SDWORD
				LOCAL state:BYTE, exttype:DWORD
				LOCAL hbrushold:DWORD	 ;ncolorring:BYTE
;				 LOCAL ytmp:DWORD,xtmp:DWORD,deltaytmp:DWORD,hypot:DWORD
;  "paint_arc"  "paint_wire"
; *EVE* display open-elements. ...curved line .nexttype=11.
;this is a method, to display wires. it differs from displaying
;nodes/resources mainly in that .wwidth/.height is actually coords
;of other end of wire.
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;also handling segmented lines, .nexttype=12.

;note that state4 is when placing 1st end of a wire, state5 placing
;second end. a problem is that this wire can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore code below handling states4/5...
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF

		  mov esi,pobject
		  mov eax,(OBJECT PTR [esi]).nexttype
		  mov exttype,eax

;firstly, draw a little circle at the middle of the wire...
;however, when doing wipeout, maybe middle was highlighted, which
;is an inverted ellipse bigger than the normal ellipse as below.
;so, for wipeout case, (where brush is white) draw bigger circle...
;		cmp fprinting,0   ;don't want circle when printing. v3.33
;		jne a22
;		cmp fhidehandles,1
;		je a22
		  ;mov eax,(OBJECT PTR [esi]).xmid
		  ;add eax,2 ;3
		  ;mov xright,eax
		  ;sub eax,4 ;6
		  ;mov xleft,eax
		  ;mov eax,(OBJECT PTR [esi]).ymid
		  ;add eax,2 ;3
		  ;mov ybottom,eax
		  ;sub eax,4 ;6
		  ;mov ytop,eax
		  
		  ;invoke SelectObject,hdc,g_hbrushred
		  ;mov hbrushold,eax
		  ;invoke Ellipse, hdc, xleft,ytop, xright,ybottom
		    ;mov eax,(OBJECT PTR [esi]).xmid
		    ;mov ebx,(OBJECT PTR [esi]).ymid
        ;invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31
		  ;invoke SelectObject,hdc,hbrushold
		    ;...note, this paints under the wire. will have to repaint it further down. v3.31

		.IF g_fredrawdiag==WIPEOUTobjs
		  ;can't call painthandle() here (done below). this code will wipe any previous v3.31
		  ;inverted region in middle of wire...
		  ;mov eax,xleft
		  ;sub eax,6
		  ;mov ebx,ytop
		  ;sub ebx,6
		  ;mov ecx,xright
		  ;add ecx,6
		  ;mov edx,ybottom
		  ;add edx,6
      mov eax,(OBJECT PTR [esi]).xmid ;v3.31
      mov ebx,(OBJECT PTR [esi]).ymid
      mov ecx,eax
      mov edx,ebx
      sub eax,9 ;must be at least big as largest possible handle radius.
      sub ebx,9
      add ecx,9
      add edx,9
		  invoke Ellipse,hdc,eax,ebx,ecx,edx ;overwrite previous.
		.ENDIF
;a22:

		.IF state==4
;when placing 1st-end of a wire, it's confusing to go through all
;that code below. just get out...
;there's a bug with initial values of x/yknes2/3 -- they are fixed
;and don't move. cop-out...
        ;need to draw something... v3.32b
				mov eax,(OBJECT PTR [esi]).xtopleft
				mov ebx,(OBJECT PTR [esi]).ytopleft
				invoke MoveToEx,hdc,eax,ebx,0
				mov eax,(OBJECT PTR [esi]).wwidth
				mov ebx,(OBJECT PTR [esi]).height
				invoke LineTo,hdc,eax,ebx
		  ret
		.ENDIF

;invert central knee of wire...
		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp fhidehighlighting,1
		je m90
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
hidres:
				mov esi,pobject
				cmp g_perrorobject,esi
				je		oo1
;also have multiple highlighted objects...
				  mov eax,(OBJECT PTR [esi]).fconfig2
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 ;mov eax,xleft
 ;sub eax,5
 ;mov ebx,ytop
 ;sub ebx,5
 ;mov ecx,xright
 ;add ecx,5
 ;mov edx,ybottom
 ;add edx,5
   mov eax,(OBJECT PTR [esi]).xmid ;v3.31
   mov ebx,(OBJECT PTR [esi]).ymid
   mov ecx,eax
   mov edx,ebx
   sub eax,9 ;must be at least big as largest possible handle radius.
   sub ebx,9
   add ecx,9
   add edx,9
  ;mov g_errorapi,0B13h ;for crash outside EVE, error codes range Axxh. v3.23
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
				  push eax
          ;mov g_errorapi,0B14h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:

				mov esi,pobject

;note i'm testing below for rpowner1/2==0, but they should always
;be non-0, as wires always have both ends locked to parents. ***NOTE***

;err, i'm doing the below code for segmented-lines also, not necessary...
		.IF exttype==11 ;curved line.
;eve has a problem when dragging end of a wire (after highlighting
;the middle). wmmousemove/state8/g_nknee=2/3/4 > wipes immediately
; > posts to xuser1 > updates. however, the immediate wipe may be
;not quite the solution, because of the dynamic way in which ends
;are snapped in this paint_arc() routine.
;try directly painting without the snapping... just redraw from the
;previous bezier points...
;HEY, MAYBE SHOULD DO THIS FOR ALL WIPEOUTS!!!...
		  .IF g_fredrawdiag==WIPEOUTobjs
				.IF g_nknee==4
wipe1:	  ;redraw from previous set of bezier points.
  ;mov g_errorapi,0B15h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke PolyBezier, hdc, ADDR bez1, 7
				.ELSEIF g_nknee==5
				  jmp wipe1
				.ENDIF
		  .ENDIF
		.ENDIF
;... and continue on to snap and wipe again...

;v3.19
;v3.19 locked child visibility toggle...
;v2.73 want to invert if a locked child of a flashing animated element
    invoke visibilitytoggle_paint  ;v3.44
    invoke colortoggle_paint,1 ;1=toggle pen color. v3.44


;.....
;DRAWING FIRST HALF OF WIRE
;normal conditions for drawing 1st half of wire, is it has to be
;drawn from middle to knee2 then to x/ytopleft...
;note although snap_arc is called (via psnap method table), it only
;returns recommended snapped-to wire-end coords, and it is up to
;this paint_arc function to update the OBJECT.

;Note, when placing 2nd end of wire (state 5), the knees and middle are
;simply to track in a straight line between the two end coords.
;we'll update them after snapping xtopleft/ytopleft...

		mov eax,(OBJECT PTR [esi]).rpowner1		;non-0 if cmt locked to parent.
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
		mov plock,eax
		cmp fprinting,2 ;metafile o/p. ;precaution.
		je m92 ;bypass this section.
		.IF eax==0				;do nothing, as not locked.
		  ;(if we allowed state4 to come this far, it would come here)
				  ;crashed when open a database with an unattached 1st end of straight line.
				  ;see below, .nexttype=13 uses xend/yend, but initially the calc of these
				  ;gets bypassed. so, load them with some values here...
fe1:	  mov eax,(OBJECT PTR [esi]).xtopleft
				  mov xend,eax
				  mov eax,(OBJECT PTR [esi]).ytopleft
				  mov yend,eax
		.ELSEIF state==0				 ;*EVE*
		  ;to improve redrawing efficiency, don't recalc snap.
		  jmp fe1
		.ELSEIF g_fdontsnapwire != 0 ;v3.35
		  ;have a bug when dragging wire end. getting bits left behind. in state8
		  ;wmmousemove() calls UpdateWindow() to wipe moving element and kids immediately
		  ;so don't want any snap action here.
		  jmp fe1
		.ELSE
				  mov ebx,(OBJECT PTR [esi]).xtopleft  ;start-end of wire.
				  mov xend,ebx									 ;/
				  mov ebx,(OBJECT PTR [esi]).ytopleft	;/
				  mov yend,ebx									 ;/
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov edi,plock

								   ;*EVE* if snapping current wire-end to another wire,
								   ;need to orient the arrow more carefully, as the
								   ;wire middle has a very tiny circle...
								   mov eax,(OBJECT PTR [edi]).fconfig1
								   and al,01
								   .IF al==01	;bit0=1 wire.
										 ;this should keep the arrow straighter...
										 mov ebx,(OBJECT PTR [esi]).xknee2
										 mov xend,ebx
										 mov ebx,(OBJECT PTR [esi]).yknee2
										 mov yend,ebx
								   .ENDIF

								   ;FUTURE *NOTE*
								   ;may2001 now have two extra params on end of snap_ call.
								   ;pass x/y coord to straighter arrow orientation.
								   ;have done this with snap_topoly()... pass xknee2/yknee2
								   ;... used to calc g_xdiffnorm/g_ydiffnorm, used below
								   ;for drawing arrows.
								   ;FUTURE rewrite snap_toarc() so won't need the above code.

								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  mov ecx,(OBJECT PTR [esi]).xknee2
								  mov edx,(OBJECT PTR [esi]).yknee2
								  mov eax,(OBJECT PTR [esi]).nbeginvertice ;poly vertice already on.
								  ;...note, exttype>=30 uses .nbeginverticex field for this.
				invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,ecx,edx,eax
				  ;...will return nearest point on boundary of parent, in xend/yend.
				  ;...also recalcs g_x/ydiffnorm used for arrow orientation.
						mov (OBJECT PTR [esi]).nbeginvertice,ebx ;snapped vertice if to poly.

				  ;need to store ring# returned from snap_tonode/snap_tores
				  ;into current wire, 1st end...
				  mov (OBJECT PTR [esi]).nbeginring,eax ;al

				  ;update wire coords...
				  mov  eax,xend
				  mov (OBJECT PTR [esi]).xtopleft,eax
				  mov  eax,yend
				  mov (OBJECT PTR [esi]).ytopleft,eax
		.ENDIF
m92:

		;always execute this code-block for straight-line. keeps
		;everything in one line...
		.IF exttype==13 ;straight line.
		  jmp f11
		.ENDIF
;now this is where we take care of knees/middle coords in state5...
		  .IF state==5					;local state, see note above.
f11:	;firstly, track xmid/ymid...
				mov eax,(OBJECT PTR [esi]).xtopleft
				sub eax,(OBJECT PTR [esi]).wwidth		  ;note in state5, this end
				sar eax,1														  ;tracks the mouse, and
				add eax,(OBJECT PTR [esi]).wwidth		  ;isn't snapped (rpowner2=0)
				mov (OBJECT PTR [esi]).xmid,eax 		  ;(refer wmmousemove()
				mov eax,(OBJECT PTR [esi]).ytopleft ;for tracking of 2nd end)
				sub eax,(OBJECT PTR [esi]).height
				sar eax,1
				add eax,(OBJECT PTR [esi]).height
				mov (OBJECT PTR [esi]).ymid,eax
				  ;now track xknee2/yknee2...
				mov eax,(OBJECT PTR [esi]).xtopleft
				sub eax,(OBJECT PTR [esi]).xmid
				sar eax,1
				add eax,(OBJECT PTR [esi]).xmid
				mov (OBJECT PTR [esi]).xknee2,eax
				mov eax,(OBJECT PTR [esi]).ytopleft
				sub eax,(OBJECT PTR [esi]).ymid
				sar eax,1
				add eax,(OBJECT PTR [esi]).ymid
				mov (OBJECT PTR [esi]).yknee2,eax
				  ;now track xknee3/yknee3...
				mov eax,(OBJECT PTR [esi]).wwidth
				sub eax,(OBJECT PTR [esi]).xmid
				sar eax,1
				add eax,(OBJECT PTR [esi]).xmid
				mov (OBJECT PTR [esi]).xknee3,eax
				mov eax,(OBJECT PTR [esi]).height
				sub eax,(OBJECT PTR [esi]).ymid
				sar eax,1
				add eax,(OBJECT PTR [esi]).ymid
				mov (OBJECT PTR [esi]).yknee3,eax
		  .ENDIF

;;for segmented-line, draw from x/ymid to x/yknee2...
;		   .IF exttype==12 ;segmented.
;				 mov eax,(OBJECT PTR [esi]).xmid ;addr of midddle of wire.
;				 mov ebx,(OBJECT PTR [esi]).ymid ;/
;				 invoke MoveToEx, hdc, eax,ebx,0
;				 mov eax,(OBJECT PTR [esi]).xknee2
;				 mov ebx,(OBJECT PTR [esi]).yknee2
;				 invoke LineTo, hdc, eax,ebx
;		   .ENDIF

;this is real hack. g_xdiffnorm/g_ydiffnorm are calc'd inside snap_ methods
;but in the case of a straight wire, the arrow angle will be wrong.
;really *NEED OWN METHOD* for straight lines, but for now put in this hack...
		  .IF exttype==13 ;straight line
			invoke calcxydiffnorm,(OBJECT PTR [esi]).xknee2,xend,(OBJECT PTR [esi]).yknee2,yend
			;...calcs g_xdiffnorm/g_ydiffnorm.
			;now go ahead and call draw1starrow()...
		  .ENDIF


    ;now using bit10=1 invisible... v3.19
			.IF g_fredrawdiag != WIPEOUTobjs
        mov eax,(OBJECT PTR [esi]).fstatus
        and eax,400h ;bit10.
        .IF eax != 0 ;bit10=1 invisible.
          jmp vis1 ;bypass painting element.
        .ENDIF
      .ENDIF
      
;this is where can draw an arrowhead if wire is reply-type...
				mov eax,(OBJECT PTR [esi]).xtopleft  ;precaution.
				mov xend,eax
				mov eax,(OBJECT PTR [esi]).ytopleft  ;/
				mov yend,eax
				  mov eax,(OBJECT PTR [esi]).nbeginring
				  xor ebx,ebx
				  mov bl,state
				  invoke draw1starrow, hdc,edi,xend,yend,eax,esi,ebx
				;(edi=addr of parent node, eax=ring#, esi=addr of wire)
				;(ebx=local state)
				;(the last line drawn will be to back of arrow)
		  .IF exttype==12 ;segmented.
				;now draw line to complete drawing 1st half of wire...
				mov eax,(OBJECT PTR [esi]).xknee2
				mov ebx,(OBJECT PTR [esi]).yknee2
        ;mov g_errorapi,0B16h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke LineTo, hdc, eax,ebx
				mov eax,(OBJECT PTR [esi]).xmid ;addr of midddle of wire. v1.91
				mov ebx,(OBJECT PTR [esi]).ymid ;/
				invoke LineTo,hdc,eax,ebx
		  .ENDIF
vis1: ;bypass paint line.

;......
;DRAWING SECOND HALF OF WIRE
;now draw a line from middle of wire to other (destination) parent-object...

		  mov eax,(OBJECT PTR [esi]).rpowner2			;non-0 if locked to parent.
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
		  mov plock,eax
		cmp fprinting,2 ;metafile o/p. ;precaution.
		je m93 ;bypass this section.
		  .IF eax==0					;do nothing, as not locked.
				;this condition will exist in state5, when placing 2nd end.
				;it is responsibility of wmmousemove() to track 2nd wire end.
				  ;crashed when open a database with an unattached end of straight line.
				  ;see below, .nexttype=13 uses xend/yend, but initially the calc of these
				  ;gets bypassed. so, load them with some values here...
xfe1:	  mov eax,(OBJECT PTR [esi]).wwidth
				  mov xend,eax
				  mov eax,(OBJECT PTR [esi]).height
				  mov yend,eax
		  .ELSEIF state==0				 ;*EVE*
				;to improve redrawing efficiency, don't recalc snap.
				jmp xfe1
		  .ELSEIF g_fdontsnapwire != 0 ;v3.35
		    ;have a bug when dragging wire end. getting bits left behind. in state8
		    ;wmmousemove() calls UpdateWindow() to wipe moving element and kids immediately
		    ;so don't want any snap action here.
		    jmp xfe1
		  .ELSE
				mov ebx,(OBJECT PTR [esi]).wwidth  ;2nd-end of wire.
				mov xend,ebx									 ;/
				mov ebx,(OBJECT PTR [esi]).height  ;/
				mov yend,ebx									 ;/
								  ;now, IMPORTANT ... call snap_ method of PARENT obj...
								  mov edi,plock

								   ;*EVE* if snapping current wire-end to another wire,
								   ;need to orient the arrow more carefully, as the
								   ;wire middle has a very tiny circle...
								   mov eax,(OBJECT PTR [edi]).fconfig1
								   and al,01
								   .IF al==01	;bit0=1 wire.
										 ;this should keep the arrow straighter...
										 mov ebx,(OBJECT PTR [esi]).xknee3
										 mov xend,ebx
										 mov ebx,(OBJECT PTR [esi]).yknee3
										 mov yend,ebx
								   .ENDIF

								   ;FUTURE *NOTE*
								   ;may2001 now have two extra params on end of snap_ call.
								   ;pass x/y coord to straighter arrow orientation.
								   ;have done this with snap_topoly()... pass xknee2/yknee2
								   ;... used to calc g_xdiffnorm/g_ydiffnorm, used below
								   ;for drawing arrows.
								   ;FUTURE rewrite snap_toarc() so won't need the above code.

								  mov  ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
								  ;(relative to "ptrs", which is start of the methods table)
								  mov ecx,(OBJECT PTR [esi]).xknee3
								  mov edx,(OBJECT PTR [esi]).yknee3
								  mov eax,(OBJECT PTR [esi]).nendvertice ;poly vertice already on.
				invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,ecx,edx,eax
				;...will return nearest point on boundary of parent, in xend/yend.
						mov (OBJECT PTR [esi]).nendvertice,ebx ;snapped vertice if to poly.

				;need to store ring# returned from snap_tonode/snap_tores
				;into current wire, 2nd end...
				  mov (OBJECT PTR [esi]).nendring,eax ;al
				  ;update wire coords...
				  mov  eax,xend
				  mov (OBJECT PTR [esi]).wwidth,eax
				  mov  eax,yend
				  mov (OBJECT PTR [esi]).height,eax
		  .ENDIF
m93:

;;for segmented line...
;		   .IF exttype==12
;				 ;draw from x/ymid to x/yknee3...
;				 mov eax,(OBJECT PTR [esi]).xmid ;addr of midddle of wire.
;				 mov ebx,(OBJECT PTR [esi]).ymid ;/
;				 invoke MoveToEx, hdc, eax,ebx,0
;				 mov eax,(OBJECT PTR [esi]).xknee3
;				 mov ebx,(OBJECT PTR [esi]).yknee3
;				 invoke LineTo, hdc, eax,ebx
;		   .ENDIF

;this is real hack. g_xdiffnorm/g_ydiffnorm are calc'd inside snap_ methods
;but in the case of a straight wire, the arrow angle will be wrong.
;really *NEED OWN METHOD* for straight lines, but for now put in this hack...
		  .IF exttype==13 ;straight line
			invoke calcxydiffnorm,(OBJECT PTR [esi]).xknee3,xend,(OBJECT PTR [esi]).yknee3,yend
			;...calcs g_xdiffnorm/g_ydiffnorm.
			;now go ahead and call draw2ndarrow()...
		  .ENDIF


    ;now using bit10=1 invisible... v3.19
			.IF g_fredrawdiag != WIPEOUTobjs
        mov eax,(OBJECT PTR [esi]).fstatus
        and eax,400h ;bit10.
        .IF eax != 0 ;bit10=1 invisible.
          jmp vis2 ;bypass painting element.
        .ENDIF
      .ENDIF
      
;this is where can draw an arrowhead at destination-end of wire.
				  mov eax,(OBJECT PTR [esi]).wwidth  ;reload end coords
				  mov  xend,eax 										 ;(necessary because of
				  mov eax,(OBJECT PTR [esi]).height  ; state5)
				  mov  yend,eax
				  ;xor eax,eax
				  mov eax,(OBJECT PTR [esi]).nendring
				  xor ebx,ebx
				  mov bl,state
				  invoke draw2ndarrow, hdc,edi,xend,yend,eax,esi,ebx
				;(edi=addr of parent node, eax=ring#, esi=addr of wire)
				;(ebx=local state)
				;(the last line drawn will be to back of arrow)

      ;for segmented line...
		  .IF exttype==12
				;now draw line to complete 2nd end of wire...
				;invoke LineTo, hdc, xend,yend
				mov eax,(OBJECT PTR [esi]).xknee3
				mov ebx,(OBJECT PTR [esi]).yknee3
  ;mov g_errorapi,0B17h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke LineTo, hdc, eax,ebx
				mov eax,(OBJECT PTR [esi]).xmid ;addr of midddle of wire. v1.91
				mov ebx,(OBJECT PTR [esi]).ymid ;/
				invoke LineTo,hdc,eax,ebx
				jmp nc1 ;bypass bezier curve drawing.
		  .ELSEIF exttype==13 ;straight line.
				;draw a single straight line...
				mov eax,(OBJECT PTR [esi]).xtopleft
				mov ebx,(OBJECT PTR [esi]).ytopleft
  ;mov g_errorapi,0B18h ;for crash outside EVE, error codes range Axxh. v3.23
				invoke MoveToEx,hdc,eax,ebx,0
				mov eax,(OBJECT PTR [esi]).wwidth
				mov ebx,(OBJECT PTR [esi]).height
				invoke LineTo,hdc,eax,ebx
				jmp nc1 ;bypass bezier curve drawing.
		  .ENDIF

;experiment... HAVE DECIDED TO KEEP THIS METHOD! for curved line...
  mov eax,(OBJECT PTR [esi]).xknee2
  mov bez3.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee2
  mov bez3.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xmid
  mov bez4.pt_x,eax
  mov eax,(OBJECT PTR [esi]).ymid
  mov bez4.pt_y,eax
  mov eax,(OBJECT PTR [esi]).xknee3
  mov bez5.pt_x,eax
  mov eax,(OBJECT PTR [esi]).yknee3
  mov bez5.pt_y,eax
  ;mov g_errorapi,0B19h ;for crash outside EVE, error codes range Axxh. v3.23
  invoke PolyBezier, hdc, ADDR bez1, 7
nc1:
vis2: ;bypass paint line.

;tack this on... draw little circles at knee2/3...
;let's only display them if wire selected...
;no, also when wipeout-ing, as they're getting left on-screen...

		cmp fprinting,0   ;don't want circle when printing. v3.33
		jne m94		
		;cmp fprinting,2 ;metafile o/p.
		;je m94 ;bypass this section.
		cmp fhidehandles,1
		je m94
  .IF  g_fredrawdiag==WIPEOUTobjs
		jmp SHORT E1
  .ELSEIF g_nstate==8
		.IF esi==g_pmovingobject
		  .IF g_nstateprev==2
				;if currently moving an object (and we will be in state8, so above double
				;-check is a precaution) and if came from state2 (highlighted object), then
				;am enabling dragging of individual handles...
				jmp SHORT E1
		  .ENDIF
		.ENDIF
  .ELSEIF  g_pselectedobject==esi
E1: ;invoke SelectObject,hdc,g_hbrushred
		;mov hbrushold,eax
		.IF exttype==13 ;straight line.
		  jmp E11
		.ENDIF
		
		  ;mov eax,(OBJECT PTR [esi]).xmid
		  ;mov xend,eax
		  ;mov eax,(OBJECT PTR [esi]).ymid
		  ;mov yend,eax
		  ;mov ebx,xend
		  ;mov eax,yend
		  ;sub xend,2 ;1 ;2
		  ;sub yend,2 ;1 ;2
		  ;add eax,2
		  ;add ebx,2
		  ;invoke Ellipse, hdc, xend,yend, ebx,eax
		  mov eax,(OBJECT PTR [esi]).xmid
		  mov ebx,(OBJECT PTR [esi]).ymid
      invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31

		  ;mov eax,(OBJECT PTR [esi]).xknee2
		  ;mov xend,eax
		  ;mov eax,(OBJECT PTR [esi]).yknee2
		  ;mov yend,eax
		  ;mov ebx,xend
		  ;mov eax,yend
		  ;sub xend,2 ;1 ;2
		  ;sub yend,2 ;1 ;2
		  ;add eax,2
		  ;add ebx,2
		  ;invoke Ellipse, hdc, xend,yend, ebx,eax
		  mov eax,(OBJECT PTR [esi]).xknee2
		  mov ebx,(OBJECT PTR [esi]).yknee2
      invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31

		  ;mov eax,(OBJECT PTR [esi]).xknee3
		  ;mov xend,eax
		  ;mov eax,(OBJECT PTR [esi]).yknee3
		  ;mov yend,eax
		  ;mov ebx,xend
		  ;mov eax,yend
		  ;sub xend,2 ;1 ;2
		  ;sub yend,2 ;1 ;2
		  ;add eax,2
		  ;add ebx,2
		  ;invoke Ellipse, hdc, xend,yend, ebx,eax
		  mov eax,(OBJECT PTR [esi]).xknee3
		  mov ebx,(OBJECT PTR [esi]).yknee3
      invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31

E11:	;i would also like them at ends of the wire, for dragging ends...
		  ;mov eax,(OBJECT PTR [esi]).bez0x ;same as .xtopleft
		  ;mov xend,eax
		  ;mov eax,(OBJECT PTR [esi]).bez0y ;same as .ytopleft
		  ;mov yend,eax
		  ;mov ebx,xend
		  ;mov eax,yend
		  ;sub xend,2 ;1 ;2
		  ;sub yend,2 ;1 ;2
		  ;add eax,2
		  ;add ebx,2
		  ;invoke Ellipse, hdc, xend,yend, ebx,eax
		  mov eax,(OBJECT PTR [esi]).bez0x ;same as .xtopleft
		  mov ebx,(OBJECT PTR [esi]).bez0y ;same as .ytopleft
      invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31
		
		  ;mov eax,(OBJECT PTR [esi]).bez8x ;same as .wwidth
		  ;mov xend,eax
		  ;mov eax,(OBJECT PTR [esi]).bez8y ;same as .height
		  ;mov yend,eax
		  ;mov ebx,xend
		  ;mov eax,yend
		  ;sub xend,2 ;1 ;2
		  ;sub yend,2 ;1 ;2
		  ;add eax,2
		  ;add ebx,2
		  ;invoke Ellipse, hdc, xend,yend, ebx,eax
		  mov eax,(OBJECT PTR [esi]).bez8x ;same as .wwidth
		  mov ebx,(OBJECT PTR [esi]).bez8y ;same as .height
      invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31
			;invoke SelectObject,hdc,hbrushold
	.ELSE
	  ;handle in middle of wire... v3.31
		    ;v3.04 may not want to display mid-handle if wire is locked...
		    mov eax,(OBJECT PTR [esi]).fconfig4  ;v3.04
		    and al,01000b ;bit3=1 element locked.
		    .IF al != 0
		      mov eax,(OBJECT PTR [esi]).fconfig1
		      and ax,100h ;bit8=1 don't display mid-handle if locked.
		      .IF ax != 0
		        jmp SHORT a22b
		      .ENDIF
		    .ENDIF		
        mov eax,(OBJECT PTR [esi]).xmid
        mov ebx,(OBJECT PTR [esi]).ymid
        invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31  		
a22b:   ;bypass.
  .ENDIF
m94:

		ret
paint_arc ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
.DATA?
ALIGN 4 ;v3.24
MAXPLAINTEXTLINES EQU 64
ncharlist BYTE MAXPLAINTEXTLINES DUP(?) ;these must be global.
ncharheight DWORD ? 	 ;/
ncharascent DWORD ? 	 ;/
textrect  RECT <?,?,?,?> ;/
ntextwidth DWORD ?		 ;/
;ssize SIZEL <?,?>
nweight DWORD ?
fitalic DWORD ?
funderline DWORD ?
fstrikethru DWORD ?
extentaccum DWORD ?
pfont DWORD ?
xchareffective DWORD ?
ychareffective DWORD ?
nweightdef DWORD ?
fitalicdef DWORD ?
funderlinedef DWORD ?
fstrikethrudef DWORD ?
pfontdef DWORD ?
xstart DWORD ?
ystart DWORD ?
xstart0 DWORD ?
ystart0 DWORD ?
ngap SDWORD ?
ngapbr SDWORD ?
ncntz DWORD ?
hfonttag DWORD ?
;hfonttag0 DWORD ?
hfontcurrent DWORD ?
ssize SIZEL <?,?>
ssizebr SIZEL <?,?>
nsizetemp DWORD ?
hfontnew DWORD ?
xngapeffective DWORD ?
yngapeffective DWORD ?
nlinecnt DWORD ?
pstartpiece DWORD ?
ncntzaccum DWORD ?
textcolorcurrent DWORD ?
fbreak BYTE ?
fendz BYTE ?
;fbypass BYTE ?
fparalign BYTE ?
nspacesz BYTE ?
fforcenewline BYTE ?
fnewline BYTE ?
fleft BYTE ? ;must be global.
  BYTE ?
  
ALIGN 4 ;v3.24
nBIGBLOCKSIZE EQU 65536
g_4kblock  BYTE 4096 DUP(?)
g_bigblock BYTE nBIGBLOCKSIZE DUP(?)

.DATA
ftestbreaks BYTE 0
  BYTE 0,0,0

.CODE
;v3.01 moved...
szalignjustify BYTE "align=""justify""",0
szalignright   BYTE "align=""right""",0
szaligncenter  BYTE "align=""center""",0

paint_label  PROC STDCALL USES edi esi eax ebx ecx edx,hdc:DWORD,pobject:DWORD
				LOCAL xright:SDWORD
				LOCAL ybottom:SDWORD
				LOCAL xleft:SDWORD
				LOCAL ytop:SDWORD
				;LOCAL textrect:RECT
				LOCAL xend:SDWORD, yend:SDWORD
				LOCAL plock:DWORD
				LOCAL hprevfont:DWORD, hpensave:DWORD
				LOCAL state:BYTE,pdata:DWORD
				LOCAL hfontold:DWORD,hbrushold:DWORD
				LOCAL hbrushnull:DWORD
				LOCAL ncntlastword:DWORD
				LOCAL pplace:DWORD,nlinescnt:DWORD,pendword:DWORD
				LOCAL ecxsave:DWORD,edisave:DWORD,ebxsave:DWORD
				LOCAL mytextmetric:TEXTMETRIC
        LOCAL xshift:DWORD,yshift:SDWORD
				LOCAL ftextaligndef:DWORD
        LOCAL fattribs:DWORD,angleradians:DWORD
				;LOCAL nloops:BYTE
;		"paint_label"
; *EVE* now displays label-element.
;this is a method, to display labels. similar to paint_cmt().
;called via WM_PAINT -> wmpaint() -> xpaint_entire/update/wipeout()
;this method should NOT mess with fonts and colors.
;wmpaint() creates all fonts, xpaint_etc() assigns a font to the DC.
;xpaint_etc() creates and assigns a brush and a pen. and colors.

;this code is a precaution.
;if introduce testing for states, there can be trouble.
;note that state4 is when placing 1st end of a obj, state5 placing
;second end. a problem is that this obj can be redrawn when some
;other object is being placed, which is a disaster. therefore, if
;g_pmovingobject != pmoving, ignore any code below handling states4/5...
;NOTE: all code in this procedure should test state, not g_nstate!!!
		mov al,g_nstate
		mov state,al
		mov eax,g_pmovingobject
		.IF eax==pobject
		.ELSE
		  .IF state==4
				mov state,0
		  .ELSEIF state==5
				mov state,0
		  .ENDIF
		.ENDIF

		  mov esi,pobject
		  mov hpensave,0
		  mov edi,pTERSEDATA

		  ;v1.45
		  ;when stretch a comp-osite-object, can also stretch the handle of a label,
		  ;which i don't want... so keep it fixed here...
		  mov (OBJECT PTR [esi]).wwidth,4
		  mov (OBJECT PTR [esi]).height,4
		  mov eax,(OBJECT PTR [esi]).xtopleft
		  add eax,2
		  mov (OBJECT PTR [esi]).xmid,eax
		  mov eax,(OBJECT PTR [esi]).ytopleft
		  add eax,2
		  mov (OBJECT PTR [esi]).ymid,eax
		  ;...note, tersedata.nhandleradius has handle radius in pixels, painthandle() v3.31
		  ;paints the handles. When call on_label(), will use .nhandleradius rather than
		  ;above dimensions.
		  ;...don't change this size, as invertregion below relies on it.

								  ;create a font...
								  mov hfontnew,0
								  mov hfontold,0
								  mov nweight,0
								  mov fitalic,0
										mov ebx,(OBJECT PTR [esi]).nfontstyle
										mov ecx,(OBJECT PTR [esi]).nfonttype
										.IF ecx==0
												lea ecx,sztimesnewroman
										.ELSEIF ecx==1
												lea ecx,szarial
										.ELSEIF ecx==2
												lea ecx,szcouriernew
										.ELSEIF ecx==3 ;custom font.
										  ;the name of custom font is stored in element.szfontname...
										  lea ecx,(OBJECT PTR [esi]).szfontname
										.ELSE
												lea ecx,sztimesnewroman
										.ENDIF
										  .IF ebx==0	 ;normal.
												mov nweight,400
										  .ELSEIF ebx==1 ;bold.
												mov nweight,700
										  .ELSEIF ebx==2 ;italic.
												mov nweight,400
												mov fitalic,1
										  .ELSEIF ebx==3 ;bold italic.
												mov nweight,700
												mov fitalic,1
										  .ENDIF
										  mov fstrikethru,0
										  mov funderline,0
										  mov eax,(OBJECT PTR [esi]).ffonteffects
										  test al,01 ;bit0=1 strikethru.
										  jz v01
										  mov fstrikethru,1
v01:									  test al,010b ;bit1=1 underline.
										  jz v02
										  mov funderline,1
v02:                mov pfont,ecx ;save.
                      ;v2.43
                      mov pfontdef,ecx ;save all defaults.
                      mov eax,nweight
                      mov nweightdef,eax
                      mov eax,fitalic
                      mov fitalicdef,eax
                      mov eax,funderline
                      mov funderlinedef,eax
                      mov eax,fstrikethru
                      mov fstrikethrudef,eax
										mov edx,(OBJECT PTR [esi]).ncharset
										mov ebx,(OBJECT PTR [esi]).nfontangle
										mov eax,(OBJECT PTR [esi]).nfontsize ;in points.
										mov nsizetemp,eax	
										neg eax
                    ;mov g_errorapi,0B1Ah ;for crash outside EVE, error codes range Axxh. v3.23
										invoke CreateFont,eax,0,ebx,ebx,nweight,fitalic,funderline, \
																   fstrikethru,edx,OUT_TT_ONLY_PRECIS,0,0,0,ecx
										mov hfontnew,eax ;default font.
										mov hfontcurrent,eax ;current font, used in html labels.
										invoke SelectObject,hdc,eax
										mov hfontold,eax
										
										.IF g_fredrawdiag==WIPEOUTobjs
										  ;xpaint_wipeout has already set color to white.
										.ELSE

                      ;v3.20
                      ;separate out the code to toggle color and visibility, cos want either, not both...
                      ;visibility first...
                      invoke visibilitytoggle_paint ;v3.44
                      ;...return eax=0 if element in visibility-toggle mode..
                      .IF eax==0  ;visibility toggle, then no color toggle...
			                  jmp SHORT notc1
                      .ENDIF
                      invoke colortoggle_paint,2 ;2=toggle font color. v3.44
notc1:                ;bypass color toggle.
		                  mov eax,(OBJECT PTR [esi]).nfontcolor
		                  mov textcolorcurrent,eax
		                  invoke SetTextColor,hdc,eax

                    .ENDIF
mono1:

				mov eax,(OBJECT PTR [esi]).wwidth
				add eax,(OBJECT PTR [esi]).xtopleft
				mov xright,eax
				mov ebx,(OBJECT PTR [esi]).height
				add ebx,(OBJECT PTR [esi]).ytopleft
				mov ybottom,ebx
				mov eax,(OBJECT PTR [esi]).xtopleft
				mov xleft,eax
				mov eax,(OBJECT PTR [esi]).ytopleft
				mov ytop,eax
		cmp fprinting,0   ;don't want circle when printing.
		jne a22
		cmp fhidehandles,1
		je a22
		  .IF g_fredrawdiag==WIPEOUTobjs
				mov eax,xleft
				sub eax,7 ;6 ;5
				mov ebx,ytop
				sub ebx,7 ;6 ;5
				mov ecx,xright
				add ecx,7 ;6 ;5
				mov edx,ybottom
				add edx,7 ;6 ;5
				invoke Ellipse, hdc,eax,ebx,ecx,edx
		  .ELSE
		      ;v3.04 don't want a handle to show, maybe, if label locked...
		      mov eax,(OBJECT PTR [esi]).fconfig4  ;v3.04
		      and al,01000b ;bit3=1 element locked.
		      .IF al != 0
		        mov eax,(OBJECT PTR [esi]).fconfig1
		        and ax,100h ;bit8=1 don't display mid-handle if locked.
		        .IF ax != 0
		          jmp SHORT a22
		        .ENDIF
		      .ENDIF
				;invoke SelectObject,hdc,g_hbrushred
				;mov hbrushold,eax
				;invoke Ellipse, hdc, xleft,ytop, xright,ybottom
				;invoke SelectObject,hdc,hbrushold
        mov eax,(OBJECT PTR [esi]).xmid
        mov ebx,(OBJECT PTR [esi]).ymid
        invoke painthandle,hdc,eax,ebx,1 ;1=red fill 2=light purple fill v3.31  						
		  .ENDIF
a22:

;if label on left-side of node, text on left...
		mov eax,(OBJECT PTR [esi]).rpowner1
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
		mov plock,eax
		.IF plock==0	;label not attached to anything (precaution).
		  mov fleft,0
		.ELSE
		  mov edi,plock
		  ;edi-->parent, esi-->cond.
				mov eax,(OBJECT PTR [edi]).nringwidth ;normally 0 for totempoles.
				mov ecx,(OBJECT PTR [esi]).nbeginring  ;ring cond is attached to.
				dec ecx
				mul ecx
				mov edx,(OBJECT PTR [edi]).xtopleft
				sub edx,eax
				mov eax,edx
		  mov ecx,(OBJECT PTR [esi]).xtopleft
		  add ecx,(OBJECT PTR [esi]).wwidth
		  .IF SDWORD PTR eax>ecx
				;label is to left of parent...
				mov fleft,1
		  .ELSE
				mov fleft,0
		  .ENDIF
		.ENDIF

		;v1.48
		;can override text alignment...
		mov eax,(OBJECT PTR [esi]).fconfig4
		and ax,0700h ;bits10/9/8.
		.IF ax==0 ;automatic.
		  ;alignment as calc'd above.
		.ELSEIF ax==0100h ;left
		  mov fleft,0 ;text is actually left-aligned.
		.ELSE
		  mov fleft,1 ;text is right-aligned.
		.ENDIF
		;...v1.57 make this global, so composetext() can use it.


		cmp fprinting,2 ;metafile o/p.
		je m90 ;bypass this section.
		cmp fhidehighlighting,1
		je m90
		cmp g_fredrawdiag,WIPEOUTobjs ;v1.98.
		je m90
;when an object is highlighted, need to draw it black...
hidres:
				mov esi,pobject
				cmp g_perrorobject,esi
				je		oo1
;also have multiple highlighted objects...
				  mov eax,(OBJECT PTR [esi]).fconfig2
				    ;v2.72 see flash code above.
;				    ;v2.72 want to flash the label...
;				    test (OBJECT PTR [esi]).fconfig2,0200h ;bit9.
;				    jz noflash
;				    mov eax,(OBJECT PTR [esi]).xtopleft
;				    add eax,6
;				    add eax,(OBJECT PTR [esi]).xlabeloffset
;				    mov ebx,(OBJECT PTR [esi]).ytopleft
;				    sub ebx,6
;				    add ebx,(OBJECT PTR [esi]).ylabeloffset
;				    mov ecx,eax
;				    add ecx,(OBJECT PTR [esi]).widthtext
;				    mov edx,ebx
;				    add edx,(OBJECT PTR [esi]).heighttext
;				    jmp SHORT oo1bx ;invert
;noflash:				
				  and al,80h			;bit7.
				  .IF al==80h
						.IF g_fclrhighlighted==0
						  jmp SHORT oo1b
						.ELSE
						  and (OBJECT PTR [esi]).fconfig2,0FFFFFF7Fh ;clr bit7.
						.ENDIF
				  .ENDIF
				.IF g_pselectedobject==esi
				  jmp SHORT oo1b
oo1:	  mov g_perrorobject,0	;only do this once.
oo1b:
 mov eax,xleft
 sub eax,7 ;5 radius will be 9. must be at least as big as largest possible handle radius.
 mov ebx,ytop
 sub ebx,7 ;5
 mov ecx,xright
 add ecx,7 ;5
 mov edx,ybottom
 add edx,7 ;5
;oo1bx:
  ;mov g_errorapi,0B1Ch ;for crash outside EVE, error codes range Axxh. v3.23
 invoke CreateEllipticRgn, eax,ebx,ecx,edx ;xleft,ytop, xright,ybottom	;-->eax=hrgn
				  push eax
				  invoke InvertRgn, hdc, eax
				  pop  eax
				  invoke DeleteObject, eax
				.ENDIF
m90:

    ;v3.19 when o/p to svg, this func gets called from composetext(), with ftestbreaks=1,
    ;to calc line breaks for plain text. trouble is, code immediately below will bypass
    ;all that if label invisible. so, put a special test here...
    .IF ftestbreaks != 0
      jmp SHORT pntme
    .ENDIF

;now to display text on the object...first x-coord...
  ;xor eax,eax
  mov eax,(OBJECT PTR [esi]).fstatus
  ;now using bit10=1 invisible... v3.19
  and eax,400h ;bit10. and al,0100000b 		   ;extract bit5 <<now using bit10.
  .IF eax==0 ;bit10=0 display label. .IF al==0100000b				;bit5=1, display label.
pntme:
				mov  ecx,(OBJECT PTR [esi]).xmid
				add  ecx,6
				  ;offset text, from OBJECT.x/ylabeloffset ....
				  add ecx,(OBJECT PTR [esi]).xlabeloffset	 ;x offset (signed)
				mov  textrect.rc_left,ecx
				;now y-coord...
				mov  ebx,(OBJECT PTR [esi]).ymid
				sub  ebx,6 ;7 v2.43 changed to 6, as per file-format docs.
				add ebx,(OBJECT PTR [esi]).ylabeloffset ;y offset (signed)
				mov  textrect.rc_top,ebx

				mov ebx,(OBJECT PTR [esi]).rpdata		;data-element.
				.IF ebx==0
				  jmp notxt
				.ELSE
				  add ebx,pTERSEDATA
          ;v2.30
          ;text can now be in chained data elements, any size.
          ;size is in 1st-data-element.xdata, .rpdata->next in chain, else 0.
          mov eax,(OBJECT PTR [ebx]).xdata ;includes trailing zero.
          .IF eax>256
            invoke chain2block,ebx,ADDR g_bigblock
            ;ebx->source, 1st data element, g_bigblock is destination.
            lea eax,g_bigblock
            mov pdata,eax
          .ELSE
            ;code as before...
				    lea edx,(OBJECT PTR [ebx]).sztext ;start of data area.
				    mov pdata,edx                     ;
				  .ENDIF
				.ENDIF

				;v1.22 now have custom width/height...
				mov eax,(OBJECT PTR [esi]).fconfig4
				and al,80h ;test bit7.
				.IF al==0 ;auto width/height calc.
				  invoke DrawText, hdc,pdata,-1,ADDR textrect,DT_CALCRECT
				  mov eax,textrect.rc_left
				  mov ecx,textrect.rc_right
				  sub ecx,eax	;width.
				  mov (OBJECT PTR [esi]).widthtext,ecx
				  mov eax,textrect.rc_top
				  mov ecx,textrect.rc_bottom
				  sub ecx,eax	;height.
				  mov (OBJECT PTR [esi]).heighttext,ecx
				.ELSE ;custom width/height...
				  mov eax,textrect.rc_left
				  add eax,(OBJECT PTR [esi]).widthtext
				  mov textrect.rc_right,eax
				  mov eax,textrect.rc_top
				  add eax,(OBJECT PTR [esi]).heighttext
				  mov textrect.rc_bottom,eax
				.ENDIF

	  ;v1.56 this is only executed when called via UpdateWindow() via composetext(),
	  ;when generating an svg file... also from drag_label() when dragging a side handle...
		;v1.89 drag_label sets this flag as ftestbreaks got clrd too soon after drag_label set it...
		mov eax,(OBJECT PTR [esi]).fconfig1
		and al,0100b
		.IF al==0100b
		  xor (OBJECT PTR [esi]).fconfig1,0100b ;clr it immediately.
		  jmp doit1
		.ENDIF
	  cmp ftestbreaks,0  ;global. ;v1.89 this still used by composetext().
	  je fin2 ;bypass.
doit1:	;when o/p to svg, need to know where the word-breaks occur. not easy.
		mov eax,textrect.rc_right
		sub eax,textrect.rc_left ;width
		mov ntextwidth,eax
		  mov edi,pdata
		  mov pplace,edi
		  mov pendword,edi
		  mov ncntz,1 ;# chars.
		  mov ncntlastword,1
  ;mov g_errorapi,0B1Dh ;for crash outside EVE, error codes range Axxh. v3.23
			invoke GetTextExtentPoint32,hdc,edi,ncntz,ADDR ssize ;in case doesn't
			mov eax,ssize.y 									   ;go into loop below.
			mov ncharheight,eax ;global, used by composetext().    ;/
			mov (OBJECT PTR [esi]).charheight,eax ;v2.55.
			  ;v1.87
			  ;this is an overall height, but we also need a height from top to baseline...
  ;mov g_errorapi,0B1Eh ;for crash outside EVE, error codes range Axxh. v3.23
			  invoke GetTextMetrics,hdc,ADDR mytextmetric
			  mov eax,mytextmetric.tm_tmAscent
			  ;add eax,mytextmetric.tm_tmExternalLeading
			  ;...no, this makes the 1st line too far down.
			  mov ncharascent,eax ;global.
			  mov (OBJECT PTR [esi]).charascent,eax ;v2.63.
		  mov nlinescnt,0
		  mov fforcenewline,0
nx1:	  mov al,[edi]
		  .IF al==0 ;end of string.
			dec ncntz ;cos not avalid character.
			jmp nx2
		  .ELSEIF al==" "
ov0:
  ;mov g_errorapi,0B1Fh ;for crash outside EVE, error codes range Axxh. v3.23
		invoke GetTextExtentPoint32,hdc,pplace,ncntz,ADDR ssize
			;...returns width of text in ssize.x, height in ssize.y.
			mov eax,ssize.x
			mov ecx,ntextwidth
			;add ecx,14 ;15maybetohi ;20 ;13 too low ;10 too low ;allow a litle overlap.
			  ;...v1.89 no, i think i'll go back to 10, don't allow much overlap...
			  add ecx,10
			.IF eax>ecx ;ntextwidth ;word is over the end.
			  ;ncntz has the #chars. need to store somewhere...
ov1:		  mov fforcenewline,0
			  lea ebx,ncharlist ;global. used by composetext().
			  add ebx,nlinescnt
			  mov eax,ncntlastword
				.IF eax==0
				  ;only one word on the line...
				  mov eax,ncntz
				  mov pendword,edi
				.ENDIF
			  mov [ebx],al
			  inc nlinescnt
				.IF nlinescnt>(MAXPLAINTEXTLINES-1) ;15
				  jmp fin1 ;precaution.
				.ENDIF
			  ;pendword pts to end of last word.
			  mov eax,pendword
			  mov pplace,eax ;calc next line.
			  inc pplace ;cos it was ptg to space between words.
			  mov edi,eax ;start looking from begining of last word.
			  mov ncntz,0
			  mov ncntlastword,0
			.ELSE
			  mov pendword,edi ;mark end last word inside rect.(actually ptg at space between).
			  mov eax,ncntz
			  mov ncntlastword,eax
			  .IF fforcenewline==0
			  .ELSE
				inc edi 	;ptg to ignore 0Ah.
				inc ncntz	 ;/
				inc ncntlastword ;/
				inc pendword ;/
				;mov fforcenewline,0
				jmp ov1
			  .ENDIF
			.ENDIF
		  .ELSEIF al==0Dh ;hard returns have 0Dh,0Ah.
			;treat this a end of a line...
			mov fforcenewline,1
			jmp ov0
		  .ELSEIF al==0Ah
			;ignore this...
		  .ENDIF
		  inc ncntz
		  inc edi
		  jmp nx1
nx2:		 ;take care of last line...
			  lea ebx,ncharlist ;global. used by composetext().
			  add ebx,nlinescnt
			  mov eax,ncntz
			  ;dec eax
			  mov [ebx],al
fin1:		  inc ebx
			  mov [ebx],BYTE PTR 0 ;helps composetext().
				;we can also calc total height of the text...
				mov eax,nlinescnt
				inc eax ;#lines, starting from 1.
				mul ncharheight ;eax=total height.
				mov (OBJECT PTR [esi]).heighttext,eax ;update element. useful for custom text rect.
				  mov ecx,textrect.rc_top
				  add ecx,eax
				  mov textrect.rc_bottom,ecx
		   ;...let's set ftestbreaks inside drag_label/sidehandle so calc this when dragging handle.
			 ;pushad
			 ;invoke MessageBeep,-1
			 ;invoke MessageBeep,-1
			 ;popad
		   mov ftestbreaks,0 ;i reckon best to clr it here, immediately.
fin2:	   ;must be after clr ftestbreaks.

;...........
;now draw the text....
;v2.39 problem this isn't calcd 1st time load diagram...
  ;mov g_errorapi,0B20h ;for crash outside EVE, error codes range Axxh. v3.23
			invoke GetTextExtentPoint32,hdc,pdata,1,ADDR ssize ;v2.64 pdata->g_bigblock or .sztext.
			mov eax,ssize.y ;height of a character, current font.
			mov ncharheight,eax ;global, used by composetext().    ;/
			mov (OBJECT PTR [esi]).charheight,eax ;v2.55.
			;v2.61, same problem...
		  ;ncharheight is an overall height, but we also need a height from top to baseline...
		  invoke GetTextMetrics,hdc,ADDR mytextmetric
		  mov eax,mytextmetric.tm_tmAscent
		  ;add eax,mytextmetric.tm_tmExternalLeading
		  ;...no, this makes the 1st line too far down.
		  mov ncharascent,eax ;global.						
		  mov (OBJECT PTR [esi]).charascent,eax ;v2.63.
			  ;v2.54 save angle in radians for later...
			  mov eax,(OBJECT PTR [esi]).nfontangle ;deg*10.
			  mov ebxsave,eax
			  fild ebxsave
			  mov ebxsave,573
			  fidiv ebxsave
			  fstp angleradians
			  ;v2.41
			  ;modify if rotated...
			  mov eax,900 ;degrees*10 = radians*573
			  sub eax,(OBJECT PTR [esi]).nfontangle ;900-deg*10
			  mov ebxsave,eax
			  fild ebxsave
			  mov ebxsave,573
			  fidiv ebxsave ;converted to radians.
			  fst ebxsave   ;temp store.(NOT pop)
			  fsin
			  fimul ncharheight
			  fistp ychareffective ;effective vertical line spacing.
        fld ebxsave
        fcos
        fimul ncharheight
        fistp xchareffective
;v2.38 now can have markup tags. need to parse the text. it is in g_bigblock, pointed
;to by pdata...
    .IF fleft==0 ;this actually means text is on right side, left-justified.
    .ELSE
				  mov eax,textrect.rc_left
				  mov ecx,textrect.rc_right
				  sub ecx,eax	;width.
				  mov textrect.rc_right,eax
				  sub textrect.rc_left,ecx
				  sub textrect.rc_left,12 ;22
				  sub textrect.rc_right,12 ;22
    .ENDIF
    xor eax,eax ;0
    mov fendz,al ;0 =1 if end of label.
    mov ssize.y,eax ;0
    mov yshift,eax ;0
    mov hfonttag,eax ;0
    ;mov fbypass,al ;0
    mov fparalign,al ;0
    mov eax,(OBJECT PTR [esi]).fconfig4
    and ax,0800h ;bit11 =1 markup tags.
    .IF ax==0 ;plain text, code as before...
		   .IF fleft==0
			   invoke DrawText, hdc,pdata,-1,ADDR textrect,DT_NOPREFIX+DT_WORDBREAK+DT_NOCLIP
		   .ELSE
			 invoke DrawText,hdc,pdata,-1,ADDR textrect,DT_NOPREFIX+DT_RIGHT+DT_WORDBREAK+DT_NOCLIP
		   .ENDIF
    .ELSE
      mov eax,textrect.rc_top
      add eax,ncharascent ;don't use ncharheight. v2.61
      mov ystart,eax
      mov ystart0,eax
      mov eax,textrect.rc_left
      mov xstart,eax
      mov xstart0,eax
        invoke GetTextAlign,hdc ;v2.43 get default.(will restore later)
        mov ftextaligndef,eax   ;/
        mov ecx,TA_UPDATECP OR TA_BASELINE ;OR TA_RIGHT
       invoke SetTextAlign,hdc,ecx
       ;move current position to starting point for drawing text...
       ;invoke MoveToEx,hdc,textrect.rc_left,textrect.rc_top,0
       invoke MoveToEx,hdc,xstart,ystart,0 ;v2.61.
       mov edi,pdata ;source, g_bigblock.

       ;paint label, a line at a time...
       mov nlinecnt,1 ;# lines painted.
nxtline:
       mov xngapeffective,0 ;used for right/center alignment.
       mov yngapeffective,0 ;/
       .IF fparalign==0 ;left justified.
         invoke htmlpaint1line,hdc,0 ;0=normal paint.
         ;...exits with edi->1st char next line in source.
         ;...will exit immediately if encountered <br> or <p ...>.
         ;<p align=... can change the alignment...
       .ELSEIF fparalign==1 ;right.
         invoke htmlpaint1line,hdc,-1 ;don't paint, but do all calcs.
           ;code to move in from left by "ngap"...
           .IF fbreak==0 ;v2.60
             mov eax,ngap
           .ELSE
             mov eax,ngapbr ;line had a <br> or </p> on end.
           .ENDIF
ng1:       mov ebxsave,eax
           .IF SDWORD PTR eax>0
             fld angleradians
             fcos
             fimul ebxsave
             fistp xngapeffective
             fld angleradians
             fsin
             fimul ebxsave
             fistp yngapeffective
           .ENDIF
         invoke paintlinewithfonts,hdc ;v2.56
       .ELSEIF fparalign==2 ;centre.
         invoke htmlpaint1line,hdc,-1 ;don't paint, but do all calcs.
           ;code to move in from left by "ngap/2"...
           .IF fbreak==0 ;v2.60
             mov eax,ngap
           .ELSE
             mov eax,ngapbr ;line had a <br> or </p> on end.
           .ENDIF
           sar eax,1
           jmp ng1
       .ELSEIF fparalign==3 ;fully justified.
         invoke htmlpaint1line,hdc,-1 ;don't paint, but do all calcs.
           ;code here to adjust spacing between words...
               xor eax,eax
               mov al,nspacesz
               .IF eax != 0
                 invoke SetTextJustification,hdc,ngap,eax
                 ;...spreads the gap over the #spaces.
               .ENDIF
         invoke paintlinewithfonts,hdc ;v2.56
       .ENDIF
       invoke SetTextJustification,hdc,0,1 ;clr the space-adj.
       ;.IF eax != 0 ;returns eax=0 when finished painting label.
       .IF fendz==0 ;sets fendz=1 if reached end of label.
         jmp nxtline
       .ENDIF

ss11: mov eax,ftextaligndef    ;restore default text align flags.
      invoke SetTextAlign,hdc,eax ; / TA_NOUPDATECP,remove TA_BASELINE.
      .IF hfonttag != 0 ;precaution.
        invoke SelectObject,hdc,hfontnew ;the default font for this element.
        invoke DeleteObject,hfonttag
        mov hfonttag,0
      .ENDIF
    .ENDIF

  .ENDIF ;end "display the label".



notxt:
;now draw a line from label to parent-object...
;*BUG* original code...
;		   ;only for g_nstate>0...
;		   cmp g_nstate,0
;		   je pass1

;*BUG* still not right...
;		 cmp esi,g_pselectedobject ;restrict so only highlighted object has grey line.
;		 jne pass1										  ;/

;TEMP FIX...
;  jmp pass1

;		 mov eax,(OBJECT PTR [esi]).rpowner1 	 ;non-0 if cmt locked to parent.
;														 ;assuming eax has value to be written...
;														 .IF eax==0
;														 .ELSE
;														   add eax,pTERSEDATA
;														 .ENDIF
;		 mov plock,eax
;		 .IF eax==0 			 ;do nothing, as not locked.
;		 .ELSE
;
;				 ;note, wmlbuttondown()/state4 determined which ring of parent
;				 ;node the label is on, and stored it in .nbeginring.
;				 ;this is now passed to a global variable "g_nsnapring",
;				 ;which snap_tonode() (the only snap_ method that an label obj
;				 ;will call, as it can only be attached to anode) to use
;				 ;to snap xend/yend to that ring...
;				 ;xor eax,eax
;				 mov eax,(OBJECT PTR [esi]).nbeginring
;				 mov g_nsnapring,eax
;
;				 mov ebx,(OBJECT PTR [esi]).xmid ;addr of middle of comment.
;				 mov xend,ebx									  ;/
;				 mov ebx,(OBJECT PTR [esi]).ymid ;/
;				 mov yend,ebx									  ;/
;								   ;now, IMPORTANT ... call snap_ method of PARENT obj...
;								   mov edi,plock
;								   mov	ebx,(OBJECT PTR [edi]).rpmethods ;rel.ptr to methods.
;								   ;(relative to "ptrs", which is start of the methods table)
;								   mov eax,(OBJECT PTR [esi]).nbeginverticex ;poly vertice already on.
;								   ;...note, exttype<30 uses .nbeginvertice field for this.
;				 invoke snapPTR PTR [ebx+ptrs+psnap], plock,ADDR xend,ADDR yend,0,0,eax
;				 ;...will return nearest point on boundary of parent, in xend/yend.
;						 mov (OBJECT PTR [esi]).nbeginverticex,ebx ;snapped vertice if to poly.
;		   ;now draw line...
;		   mov ecx,(OBJECT PTR [esi]).xmid	;comment middle
;		   mov edx,(OBJECT PTR [esi]).ymid	;/
;		   invoke MoveToEx, hdc, ecx,edx,0
;
;						 .IF g_fredrawdiag==WIPEOUTobjs
;						   invoke LineTo, hdc, xend,yend
;						 .ELSE
;						   invoke SelectObject, hdc,g_hpengrey
;						   mov hpensave,eax
;						   invoke LineTo, hdc, xend,yend
;						   invoke SelectObject, hdc,hpensave
;						 .ENDIF
;		 .ENDIF
;pass1:

;*???* check this again. i read somewhere about metafiles ignoring these funcs...
		cmp fprinting,2 ;metafile o/p.
		je m92 ;bypass this section.
		invoke SelectObject,hdc,hfontold
		invoke DeleteObject,hfontnew
m92:

;v1.22
;tack this on... draw little resize handle if highlighted...
;let's only display it if wire selected...
;no, also when wipeout-ing, as they're getting left on-screen...
		cmp fprinting,2 ;metafile o/p.
		je m94 ;bypass this section.
		cmp fhidehandles,1
		je m94
  .IF  g_fredrawdiag==WIPEOUTobjs
		jmp SHORT E1
  .ELSEIF g_nstate==8
		.IF esi==g_pmovingobject
		  .IF g_nstateprev==2
				;if currently moving an object (and we will be in state8, so above double
				;-check is a precaution) and if came from state2 (highlighted object), then
				;am enabling dragging of individual handles...
				jmp SHORT E1
		  .ENDIF
		.ENDIF
  .ELSEIF  g_pselectedobject==esi
E1:

		  mov eax,(OBJECT PTR [esi]).xmid
		  add eax,6
		  add eax,(OBJECT PTR [esi]).xlabeloffset
		  mov xleft,eax
		  add eax,(OBJECT PTR [esi]).widthtext
		  mov xend,eax
		  mov xright,eax
		  mov eax,(OBJECT PTR [esi]).ymid
		  sub eax,6 ;7
		  add eax,(OBJECT PTR [esi]).ylabeloffset
		  mov ytop,eax
		  mov ecx,eax
		  mov ebx,(OBJECT PTR [esi]).heighttext
		  add ecx,ebx
		  mov ybottom,ecx
		  shr ebx,1
		  add eax,ebx
		  mov yend,eax

		  .IF fleft==0
		  .ELSE
			mov eax,(OBJECT PTR [esi]).widthtext
			sub xend,eax
			sub xend,12
			sub xend,eax ;handle now on left side of rectangle.
			sub xleft,eax
			sub xleft,12
			sub xright,eax
			sub xright,12
		  .ENDIF
		  
		  ;v2.53 html label has text placement different vertically...
		  mov eax,(OBJECT PTR [esi]).fconfig4
      and ax,0800h ;bit11 =1 markup tags.
		  .IF ax != 0
		    ;;move top horiz line upward...
		    ;v2.61 mov eax,ncharheight ;ychareffective
		    ;v2.61 sub ytop,eax
		    ;adj bottom line...
		    mov eax,ncharheight
		    xor edx,edx
		    mul nlinecnt
		    add eax,ytop
		    mov ybottom,eax
		    ;fix .heighttext...
		    sub eax,ytop
		    mov (OBJECT PTR [esi]).heighttext,eax ;v2.55
		    shr eax,1
		    add eax,ytop
		    mov yend,eax ;resize handle.
		  .ENDIF

		  .IF  g_fredrawdiag==WIPEOUTobjs
			  invoke Rectangle,hdc,xleft,ytop,xright,ybottom
			  mov ebx,xend
			  mov eax,yend
			  ;sub xend,2 ;1 ;2
			  ;sub yend,2 ;1 ;2
			  ;add eax,2
			  ;add ebx,2
			  ;invoke Ellipse, hdc,xend,yend,ebx,eax
        invoke painthandle,hdc,ebx,eax,1 ;1=red fill 2=light purple fill v3.31
		  .ELSE
			  invoke SelectObject, hdc,g_hpengrey
			  mov hpensave,eax
			  invoke GetStockObject, NULL_BRUSH
			  mov hbrushnull,eax
			  invoke SelectObject, hdc,hbrushnull
			  mov hbrushold,eax
			  invoke Rectangle,hdc,xleft,ytop,xright,ybottom
			  invoke SelectObject,hdc,hbrushold
			  invoke DeleteObject,hbrushnull
			  invoke SelectObject, hdc,hpensave
			  ;invoke SelectObject,hdc,g_hbrushred
			  ;mov hbrushold,eax
			  mov ebx,xend
			  mov eax,yend
			  ;sub xend,2 ;1 ;2
			  ;sub yend,2 ;1 ;2
			  ;add eax,2
			  ;add ebx,2
			  ;invoke Ellipse, hdc,xend,yend,ebx,eax
        invoke painthandle,hdc,ebx,eax,1 ;1=red fill 2=light purple fill v3.31
			  ;invoke SelectObject,hdc,hbrushold
		  .ENDIF

  .ENDIF
m94:

		ret
paint_label ENDP
;--------------------------------------------------------------------------
paintlinewithfonts PROC STDCALL, hdc:DWORD
  LOCAL hfontprev:DWORD
  ;LOCAL hfont0:DWORD,hfont:DWORD,pendblock:DWORD,color0:DWORD
; "paintlinewithfonts"
;paint text in g_4kblock, ncntzaccum==# chars in block.
;fontlist has ptr-to-text and hfont for each piece of text in g_4kblock.
;after painting, destroy fonts in fontlist.
  pushad ;must save all regs.
  
;may need to move back one line...
                   ;v2.60
                   mov eax,ystart0
                   sub eax,yngapeffective ;adj for right/center align.
                   mov ecx,xstart0
                   add ecx,xngapeffective ;adj for right/center align.
  ;mov g_errorapi,0B21h ;for crash outside EVE, error codes range Axxh. v3.23
    invoke MoveToEx,hdc,ecx,eax,0 ;v2.60 xstart0,ystart0,0
    ;...as htmlpaint1line() may have moved insertion point to next line.
    
;v2.59 go thru fontlist, extract all info and paint the piece of text...
  lea esi,fontlist
  mov ecx,fontlistindex
  .IF ecx==0 ;nothing in list.
  .ELSE
    shr ecx,1 ;cos we read two entries each time.
nxt1:  push ecx
       mov eax,[esi+4] ;hfontcurrent
  ;mov g_errorapi,0B22h ;for crash outside EVE, error codes range Axxh. v3.23
       invoke SelectObject,hdc,eax ;select font.
       mov eax,[esi+(NUMFONTS*4)] ;textcolorcurrent.
       .IF g_fredrawdiag==WIPEOUTobjs
         ;xpaint_wipeout has already set color to white.
       .ELSE
  ;mov g_errorapi,0B23h ;for crash outside EVE, error codes range Axxh. v3.23
         invoke SetTextColor,hdc,eax
       .ENDIF
       mov eax,[esi]   ;pstartpiece (start addr of piece of text).
       add esi,4
       mov edx,[esi+(NUMFONTS*4)] ;ncntz.
       invoke TextOut,hdc,0,0,eax,edx
       add esi,4 ;next entry.
       pop ecx
    loop nxt1
  .ENDIF
  
  ;move insertion point back to where it should be...
  ;mov g_errorapi,0B24h ;for crash outside EVE, error codes range Axxh. v3.23
  invoke MoveToEx,hdc,xstart,ystart,0

  mov eax,hfontcurrent
  invoke SelectObject,hdc,eax
  ;...note, htmlpaint1line() now uses hfontcurrent for the current font.
  ;...must not write to that variable here.
  ;...note, this variable will be same value as hfontnew or hfonttag.

;go thru fontlist and delete hfont entries. ignore duplicate entries...
;be careful not to delete hfontnew or hfonttag...
  mov hfontprev,0
  lea esi,fontlist
  mov ecx,fontlistindex
  .IF ecx==0 ;nothing in list.
  .ELSE
    shr ecx,1 ;cos we read two entries each time.
nxtx:  push ecx
       mov eax,[esi+4] ;hfontcurrent
       .IF eax != hfontprev ;test if already found in list.
         mov hfontprev,eax ;becomes previous font for next loop.
         .IF eax != hfontnew ;default font (deleted by paint_label()).
           .IF eax != hfonttag ;current custom font, in use by htmlpaint1line().
             ;...note, hfonttag also deleted by paint_label().
  ;mov g_errorapi,0B25h ;for crash outside EVE, error codes range Axxh. v3.23
             invoke DeleteObject,eax
           .ENDIF
         .ENDIF
       .ENDIF
       pop ecx
    add esi,8 ;next entry.
    loop nxtx
  .ENDIF
  mov fontlistindex,0 ;empty the list.

  popad
  ret
paintlinewithfonts ENDP
;--------------------------------------------------------------------------
.DATA
fsvgmode BYTE 0 ;controls coords for next line when rotated.
szspacez BYTE " ",0
  BYTE 0
sspace SIZEL <0,0>

.CODE
htmlpaint1line PROC STDCALL,hdc:DWORD,nmode:DWORD
; "htmlpaint1line"
;nmode=0: normal mode. paints line, with wordwrap.
;nmode=-1: don't paint. calcs nspacesz=#spaces in the line, ncntz=#chars in
;current piece, ngap=gap at end of left-aligned line (+ve=end line within right
;boundary).
;enter with edi->next char in source (g_bigblock).
;exit with edi->1st char on next line, source (g_bigblock).
;note, immediate exit with fforcenewline=1 if encounter <br> or <p ...>.
;return eax=0 if reached end of label (also fendz=1).

;  ;save hfonttag value at entry...
;  mov eax,hfonttag
;  mov hfonttag0,eax

  mov ngapbr,0
  mov fbreak,0 ;v2.60 set if <br> or </p> encountered.
  mov nspacesz,0
  mov ngap,0
  mov extentaccum,0  ;total extent for line., up to end last paint.
  mov fnewline,1
  mov fforcenewline,0
  mov ncntzaccum,0 ;total count chars on line.
    ;v2.56
    ;if nmode==-1, want to hold entire line in g_4kblock...
    ;well, i think can do that for any nmode...
;    lea ebx,g_4kblock ;using pstartpiece below...
;    mov pendpiece,ebx

;loops up to here painting pieces of text (when reach a "<"), and will drop
;out of this func only when reach right-margin or end of label (or <br>, </p>)...
ss0:   ;comes here after a paint, so g_4kblock now emptied.
       ;start reloading g_4kblock from edi (->next char in g_bigblock, source)...
         ;v2.56
         lea ebx,g_4kblock ;temp. destination.
         add ebx,ncntzaccum ;current end.
         ;mov ebx,pendpiece ;kept track of last char written to g_4kblock.(next past)
         mov pstartpiece,ebx ;start of current piece of text.
       mov ncntz,0  ;# chars in current piece in g_4kblock.
       mov ssize.x,0  ;extent of latest piece of text (in g_4kblock).

ss1:   ;loop to here to read next char from source...
       mov al,[edi]
       inc edi
       .IF al=="&" ;substitution.
;         ;v2.67 this func also called when output a label to SVG, want to
;         ;output these as-is...
;         .IF fsvgmode != 0 ;set by svghtmlcomposetext() in eve2.asm.
;           jmp SHORT svgt1
;         .ENDIF
         mov al,[edi]
         .IF al=="l"  ;"&lt;"
ss2:       mov al,"<"
ss3:       inc edi ;discard t.
           inc edi ;discard ;.
           inc edi
         .ELSEIF al=="L"
           jmp ss2
         .ELSEIF al=="g" ;"&gt;"
ss4:       mov al,">"
           jmp ss3
         .ELSEIF al=="G"
           jmp ss4
         .ELSEIF al=="a" ;"&amp;"
ss5:       mov al,"&"
           inc edi ;discard m.
           jmp ss3
         .ELSEIF al=="A"
           jmp ss5
         .ELSEIF al=="q" ;"&quot;"
ss6:       mov al,""""
ss7:       inc edi
           inc edi
           jmp ss3
         .ELSEIF al=="Q"
           jmp ss6
         .ELSEIF al=="n" ;"nbsp;"
ss8:       mov al," "
           jmp ss7
         .ELSEIF al=="N"
           jmp ss8
         .ELSE
           ;we will throw away the & only.
         .ENDIF
       .ELSEIF al=="<"  ;tag.
				 .IF SDWORD PTR ncntz<=0 ;precaution.
;				   ;v2.44 fix a bug...
;				   ;if come here and paint nothing, cos a tag right at beginning
;				   ;of line, also need to clr ssize.x otherwise it will add to
;				   ;extentaccum below.
;				   mov ssize.x,0 ;extent of current piece of text.
				 .ELSE
				   .IF SDWORD PTR nmode>=0 ;don't paint if -1.
			       ;********
  ;mov g_errorapi,0B26h ;for crash outside EVE, error codes range Axxh. v3.23
             invoke TextOut,hdc,0,0,pstartpiece,ncntz ;v2.56 ADDR g_4kblock,ncntz
             ;********
           .ENDIF
           ;...note, x/y coords ignored as TA_UPDATECP activated.
           mov eax,ncntz
           add ncntzaccum,eax
           ;v2.59
           .IF SDWORD PTR nmode<0 ;nmode=-1.
             invoke add2fontlist,pstartpiece
             ;...records pstartpiece, hfontcurrent, textcolorcurrent, and ncntz.
           .ENDIF
           ;v2.59 to try fix a problem with extent, space on end line...
           push ebx
  ;mov g_errorapi,0B27h ;for crash outside EVE, error codes range Axxh. v3.23
           invoke GetTextExtentPoint32,hdc,ADDR szspacez,1,ADDR sspace
               ;v2.60 right/center align need ngap for aligning this line...
               .IF fparalign==1 ;right.
ns2x:            invoke GetTextExtentPoint32,hdc,pstartpiece,ncntz,ADDR ssizebr
                 mov ecx,extentaccum
                 add ecx,ssizebr.x
                 mov eax,textrect.rc_right
                 sub eax,textrect.rc_left
                 sub eax,ecx
                 mov ngapbr,eax
               .ELSEIF fparalign==2 ;center.
                 jmp ns2x
               .ELSE
                 mov ngapbr,0
               .ENDIF
           pop ebx
         .ENDIF
           ;update the record of current position...
             ;v2.39
               ;v2.43 accumulate the extent, for testing when reached right
               ;boundary...
               mov eax,ssize.x
               add extentaccum,eax
               .IF hfonttag != 0
                 push ebx
                 mov eax,hfontnew
                 mov hfontcurrent,eax
  ;mov g_errorapi,0B28h ;for crash outside EVE, error codes range Axxh. v3.23
                 invoke SelectObject,hdc,eax ;hfontnew ;the default font for this element.
                   ;v2.56
                   .IF SDWORD PTR nmode>=0 ;normal.
                     invoke DeleteObject,hfonttag
                   .ELSE ;nmode==-1.
                     ;save hfont and ebx for later replay...
;                     lea eax,g_4kblock
;                     add eax,ncntzaccum
;                     invoke add2fontlist,eax ;ebx
;                     invoke add2fontlist,hfontnew
                   .ENDIF
                   mov hfonttag,0 ;always need to zero it here though.
                 pop ebx
               .ENDIF

         ;comes here if at a tag (just read a "<" char).
         ;now set the font characteristics for the next time we paint (at end
         ;of a line or next tag)...
dd2:     invoke htmlparsetag2nd,hdc,nmode ;enter edi->next char past "<"
         ;...note, func doesn't explicitly save any regs.
         ;...return edi->next char past ">".
         ;...return fforcenewline=1 if <br> or </p>, =2 if <p>(not clred in func).
           ;v2.40
           ;multiple tags can butt against each other, so check for this, and loop
           ;around digesting all tags until can drop down...
           mov ecx,edi
mm1:       mov al,[edi]
           .IF al=="<" ;another tag.
             inc edi
             jmp dd2
           .ELSEIF al==0 ;end of block.
           .ELSEIF al<32 ;control char.
             inc edi
             jmp mm1
           .ENDIF
           mov edi,ecx ;restore.
           ;exit here with edi->next char past ">".

           ;v2.44 need to create the font here...
           .IF hfonttag==0 ;precaution, only create one font.
             push ebx
	 			     mov edx,(OBJECT PTR [esi]).ncharset
						 mov ebx,(OBJECT PTR [esi]).nfontangle
						;mov eax,(OBJECT PTR [esi]).nfontsize ;in points.
						mov eax,nsizetemp
						neg eax
						mov ecx,pfont ;current font.
  ;mov g_errorapi,0B29h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke CreateFont,eax,0,ebx,ebx,nweight,fitalic,funderline, \
												   fstrikethru,edx,OUT_TT_ONLY_PRECIS,0,0,0,ecx
						mov hfonttag,eax
						mov hfontcurrent,eax
						invoke SelectObject,hdc,eax
             pop ebx
                   ;v2.56
                   ;.IF SDWORD PTR nmode<0 ;nmode==-1.
                     ;save hfont and ebx for later replay...
                     ;push ebx
                     ;lea eax,g_4kblock
                     ;add eax,ncntzaccum
                     ;invoke add2fontlist,eax ;ebx
                     ;invoke add2fontlist,hfonttag
                     ;pop ebx
                   ;.ENDIF
					 .ENDIF	

         .IF fforcenewline != 0
           jmp nl4 ;move current pos. to new line, then to ss00: (exit).
         .ENDIF
         ;now copy next piece into g_4kblock again...
         jmp ss0

       .ELSEIF al==">"
         ;v2.43 as this top-level of parsing, a ">" must be ignored.
         ;i don't know if this can happen, but let's avoid any
         ;potential problem...
         jmp ss1
       .ELSEIF al==0 ;end of text.
ss12:    .IF ncntz != 0
				   .IF SDWORD PTR nmode>=0 ;don't paint if -1.
				     ;******
  ;mov g_errorapi,0B2Ah ;for crash outside EVE, error codes range Axxh. v3.23
             invoke TextOut,hdc,0,0,pstartpiece,ncntz ;v2.56 ADDR g_4kblock,ncntz
             ;******
           .ENDIF
           mov eax,ncntz
           add ncntzaccum,eax
           ;v2.59
           .IF SDWORD PTR nmode<0 ;nmode=-1.
             invoke add2fontlist,pstartpiece
             ;...records pstartpiece, hfontcurrent, textcolorcurrent, and ncntz.
           .ENDIF
         .ENDIF
         jmp ss11 ;get out.
       .ELSEIF al<32 ;control char.
         ;v2.43 i think need to insert a space if 0Dh (carriage ret)...
         .IF al==0Dh
           mov al," "
           jmp SHORT sp1
         .ENDIF
         jmp ss1 ;dump it, get next char from source.
       .ELSEIF al==" "
sp1:     .IF ncntz==0 ;suppress all spaces at start of line...
           .IF fnewline==1
             jmp ss1
           .ENDIF
         .ELSE ;only allow one space...
           mov fnewline,0
           mov cl,[ebx-1] ;see if previous char is a space
           .IF cl==" "
             jmp ss1
           .ENDIF
         .ENDIF
       .ENDIF
       ;char is ok to paint, copy it to destination block...
       ;*****
       mov [ebx],al ;char has made it to destination, g_4kblock.
       ;*****
       inc ncntz
       mov fnewline,0 ;used to suppress spaces at start of new line.
       ;v2.51 also count #spaces in line...
       .IF al==" "
         inc nspacesz
         mov sspace.x,0 ;v2.61
       .ENDIF
;       ;v2.56...
;       mov pendpiece,ebx
;       inc pendpiece ;so pts to next free.


       ;v2.53 need to compute wordwrap...
       ;is text at right boundary?....
       ;ebx->last char in g_4kblock, edi->next past last in g_bigblock.
       invoke htmltestendline,hdc ;note, proc doesn't save any regs.
       ;...return with edi->1st char next line, source g_bigblock, and
       ;...sets fforcenewline=1 if text in g_4kblock has reached right boundary.
       ;...sets fendz=1 if reached end of label.
       ;...ebx->last char in destination, g_4kblock.
       .IF fforcenewline != 0
         ;immediately paint line in g_4kblock...
         .IF ncntz != 0 ;precaution.
				   .IF SDWORD PTR nmode>=0 ;don't paint if -1.
				     ;*******
  ;mov g_errorapi,0B2Bh ;for crash outside EVE, error codes range Axxh. v3.23
             invoke TextOut,hdc,0,0,pstartpiece,ncntz ;v2.56 ADDR g_4kblock,ncntz
             ;*******
           .ENDIF
           mov eax,ncntz
           add ncntzaccum,eax
           ;v2.59
           .IF SDWORD PTR nmode<0 ;nmode=-1.
             invoke add2fontlist,pstartpiece
             ;...records pstartpiece, hfontcurrent, textcolorcurrent, and ncntz.
           .ENDIF
         .ENDIF
         ;...note, x/y coords ignored as TA_UPDATECP activated.
         .IF fendz==0
           ;next time paint text, it will be on a new line...
nl4:         .IF nlinecnt==1 ;1st line. v2.55
;               mov eax,pendpiece
;               sub eax,OFFSET g_4kblock
               mov eax,ncntzaccum
               .IF eax==0 ;nothing painted on current line, suppress newline.
               .ELSE
                 jmp SHORT yp1
               .ENDIF
             .ELSE
yp1:
                 mov eax,xstart
                 mov xstart0,eax ;save prev.
                 mov eax,ystart
                 mov ystart0,eax ;/
                 .IF fsvgmode==0
                   mov eax,ychareffective ;=ncharheight if no rotation.
                   mov ecx,xchareffective ;=0 if no rotation.
                 .ELSE ;svg viewer does the rotation transform itself...
                   mov eax,ncharheight
                   mov ecx,0
                 .ENDIF
                 .IF fforcenewline==2 ;<p>
                   mov edx,ychareffective
                   sar edx,1
                   add eax,edx ;1.5 times linebreak, new paragraph.
                   mov edx,xchareffective
                   sar edx,1
                   add ecx,edx ;/ =0 if no rotation.
                 .ENDIF
                 add ystart,eax
                 add xstart,ecx
  ;mov g_errorapi,0B2Ch ;for crash outside EVE, error codes range Axxh. v3.23
                 invoke MoveToEx,hdc,xstart,ystart,0
               ;.ENDIF
               inc nlinecnt
             .ENDIF
;           mov fforcenewline,0
;           mov fnewline,1 ;used to suppress spaces at start of new line.
;           mov extentaccum,0 ;v2.43
           jmp ss00 ;exit from this func. reload g_4kblock from start.
         .ELSE
           jmp ss11 ;finished. exit from this func.
         .ENDIF
       .ENDIF
ne1:
       inc ebx ;next free place in destination, g_4kblock.
       lea eax,g_4kblock
       mov ecx,ebx
       sub ecx,eax
       .IF ecx<4095 ;v2.56 ncntz<4095
         jmp ss1
       .ELSE
         ;this would mean 4095 chars painting on same line!...
         mov [ebx],BYTE PTR 0
         jmp ss12
       .ENDIF

ss00:  ;comes here after painting a complete line.
  mov eax,1 ;flag not finished painting label.
getout:
  ret
ss11:
  mov fendz,1 ;flag finished painting label.
  xor eax,eax ;finished painting label.
  jmp getout
htmlpaint1line ENDP
;--------------------------------------------------------------------------
.DATA?
;used by add2fontlist() ...
ALIGN 4 ;v3.24
NUMFONTS   EQU 32
fontlist DWORD NUMFONTS DUP (?) ;use 1st dword for ptextpiece, 2nd hfontcurrent.
colorlist DWORD NUMFONTS DUP(?) ;use 1st dword for textcolorcurrent,
 ;...2nd dword for ncntz.
 
.DATA
ALIGN 4 ;v3.24
fontlistindex DWORD 0					   ;index of next free entry.

.CODE
add2fontlist PROC STDCALL USES ebx esi,nvalue:DWORD
		LOCAL dummy:BYTE		
; "add2fontlist"
;adds nvalue (ptextpiece) to the font-list. also saves textcolorcurrent.
;also saves ncntz in 2nd dword of colorlist.

       mov eax,nvalue
		   mov ebx,fontlistindex   ;index to next free entry.
		   .IF DWORD PTR ebx<NUMFONTS		  ;max size of wipeout-list buffer.
				 shl ebx,1								;convert to relative offset.
				 shl ebx,1						;/ (4 bytes per entry)
				 lea esi,fontlist				 ;/
				 mov [ebx+esi],eax				  ;add object to list
				 mov eax,hfontcurrent
				 mov [ebx+esi+4],eax  ;save current font.
				   mov eax,textcolorcurrent
				   mov [ebx+esi+(NUMFONTS*4)],eax ;save current color also.
				   add ebx,4
				   mov eax,ncntz
				   mov [ebx+esi+(NUMFONTS*4)],eax ;save ncntz also (# chars in current piece).
				   sub ebx,4
				 inc fontlistindex				;update index
				 inc fontlistindex ;weird method, storing 2 dwords each time.
		   .ENDIF

	   ret
add2fontlist ENDP
;--------------------------------------------------------------------------
htmltestendline PROC STDCALL,hdc:DWORD
  LOCAL ebxsave:DWORD,edisave:DWORD
; "htmltestendline"
;before entry, ebx->last char in g_4kblock, edi->next past last in g_bigblock.
;note, not saving any registers.
;exit with ebx->last char in g_4kblock, edi->next past last in g_bigblock,
;maybe modified from entry values if there was wordwrap.
;returns with fforcenewline=1 if reached right boundary.
;returns fendz=1 if reached end of label.

         ;v2.39 need to compute word-wrap...
         push ebx
         ;compute x extent for every character read from g_bigblock... (slow!)
  ;mov g_errorapi,0B2Dh ;for crash outside EVE, error codes range Axxh. v3.23
         invoke GetTextExtentPoint32,hdc,pstartpiece,ncntz,ADDR ssize
         pop ebx

         ;is text at right boundary?....
         ;ebx->last char in g_4kblock, edi->next past last in g_bigblock.

          mov ecx,extentaccum ;accumulated extent for current line.
          ;...updated each time paint a piece of text, see above.
          add ecx,ssize.x  ;latest piece of extent.
         ;sub ecx,xstart ;v2.41 get total extent.
         ;...xstart is the absolute x coord of start of (rotated) line.
         mov eax,textrect.rc_right
         sub eax,textrect.rc_left ;get width of rectangle.
         .IF SDWORD PTR eax<=ecx ;ssize.x ;x extent. v2.56 must be signed.
           ;yes, have reached right boundary...
             ;v2.51 calc the gap at end...
             sub eax,ecx ;frame-width - extent.
             mov ngap,eax ;signed number.(-ve, extent over boundary).
           mov al,[ebx]
           .IF al==" " ;a space is on right boundary.
             ;paint this line...
             dec edi ;so delimiter part of next line.
             dec ncntz
             ;dec nspacesz ;the space is going to be on next line.
             ;note, nspacesz is decr further on...
             jmp ff2
           .ELSE
              ;v2.62 ...text <b>bold</b>, text...
              ;have painted "bold", processed the "</b>", then htmlpaint1line()
              ;reads the "," and end up here... even if delimiter is slightly
              ;over boundary, have to paint it on same line...
                  .IF ncntz==1 ;have just 1 char in g_4kblock since last paint.
                    .IF al==","
                    .ELSEIF al=="."
                    .ELSEIF al==";"
                    .ELSEIF al==":"
                    .ELSEIF al=="'"
                    .ELSEIF al==""""
                    .ELSE
                      jmp SHORT ok1
                    .ENDIF
                    ;paint it on the same line...
                    inc nspacesz ;cos ff2: decr's it.
                    jmp ff2
                    ;...will set fforcenewline=1, then will exit this func,
                    ;then htmlpaint1line() will do TextOut() of this one
                    ;delimiter character, then will do a MoveTo() next line.
                  .ENDIF
ok1:          ;v2.62 don't allow chars to straddle right boundary...
              .IF SDWORD PTR ngap<0 ;-ve, a word is over right boundary.
                jmp wo1 ;wrap it to next line.
              .ENDIF
             mov al,[edi] ;next character not yet loaded.
             .IF al==" " ;this word just makes it onto current line...
               inc ebx
dd7z:          mov [ebx],BYTE PTR 0
               ;need to change current position to next line...
               mov fforcenewline,1  ;(done after painting current line)
               jmp dd5z ;exit this func.
             .ELSEIF al=="<" ;also a delimiter.
                 ;v2.43 another problem, could have "</b>," and the comma
                 ;must be together with the word. so, it won't make it
                 ;onto current line...
                 mov ecx,edi
gt1:             inc edi
                 mov al,[edi]
                 cmp al,">"
                 jne gt1
                 inc edi
                 mov al,[edi] ;next char past the >.
                   ;v2.62 ...text <big><b>bold</b></big>, text... needs to
                   ;keep going to end of abutted tags...
gt1v:              .IF al=="<"
                     jmp gt1
                   .ELSEIF al<32
                     inc edi
                     mov al,[edi]
                     jmp gt1v
                   .ENDIF
                 mov edi,ecx
                 .IF al==","
                 .ELSEIF al=="."
                 .ELSEIF al==";"
                 .ELSEIF al==":"
                 .ELSEIF al=="'"
                 .ELSEIF al==""""
                 .ELSE ;makes it onto current line...
                   ;a complication, if have </b> for example, normally we use the
                   ;< to trigger a paint, but here we have already decided to
                   ;paint as word is on right boundary.
                   ;;so, set a special flag...
                   ;mov fbypass,1
                   inc ebx
                   jmp dd7z
                 .ENDIF
               jmp wo1
             .ELSEIF al=="&" ;also a delimiter.
               inc ebx
               jmp dd7z
             .ELSEIF al==0 ;next char in source is end of text.
               mov fendz,1 ;causes exit from paint-label.
               mov fforcenewline,1
               jmp dd5z ;after exit, will paint line.
             .ELSEIF al<32 ;any control char.
               inc ebx
               jmp dd7z
             .ELSE
wo1:           ;word over end, go back...
               mov ebxsave,ebx ;ptg to last char in dest. g_4kblock.
               mov edisave,edi ;ptg to next char in source g_bigblock.
               dec edisave ;cos gets incr at ff1: below.
dd6:           dec ebx ;ebx->destination, g_4kblock.

               ;v2.56 problem area here...
               ;.IF ebx<(OFFSET g_4kblock) ;prevent underrrun error.
               mov eax,pstartpiece ;now putting all text for line into g_4kblock.
               .IF ebx<eax
               
                 mov eax,extentaccum ;v2.44 ppt.pt_x ;current position.
                 ;...accum extent incl. last piece painted, current line.
                 .IF SDWORD PTR eax==0 ;v2.44 eax<=textrect.rc_left
                   ;only one word on the current line, so no good to paint it on next
                   ;line, as will get moved down indefinitely.
                   ;so, go forward to paint whole word on current line...
                   mov ebx,ebxsave
                   mov edi,edisave
ff1:               inc ebx
                   inc edi
                   inc ncntz
                   mov al,[edi]
                   .IF al==" "
                   .ELSEIF al=="<"
                   .ELSEIF al=="&"
                   .ELSEIF al==0
                     mov fendz,1
                   .ELSEIF al<32
                   .ELSE
                     mov [ebx],al
                     jmp ff1
                   .ENDIF
                   dec ncntz
                   jmp SHORT ff2
                 .ELSE
                   ;have removed word from g_4kblock.
                   mov ncntz,0
                   ;now backstep to start of word in g_bigblock (source)...
                   jmp SHORT dd8
                 .ENDIF
               .ENDIF
               dec ncntz
               mov al,[ebx]
               cmp al," "   ;TO DO OTHER DELIMITERS? (this may be enough)
               jne dd6
               dec ncntz ;cos we're going to write zero into last place.
dd8:           dec edi  ;edi->source, g_bigblock.
               mov al,[edi]
               .IF al==" "
               .ELSEIF al==">"
               .ELSEIF al==";"
               .ELSEIF al<32 ;control char.
               .ELSE
                 jmp dd8
               .ENDIF
               inc edi
ff2:             ;need to change current position to next line...
                 mov fforcenewline,1
                   ;v2.59
                   .IF ncntz==0     ;current piece is zero length.
                     mov al,[ebx]
                     .IF al==" "   ;have a space on end of line.
                       mov eax,sspace.x ;extent of a space, previous font(??)
                       sub extentaccum,eax ;
                         ;v2.66 fontlist/colorlist has already recorded previous piece
                         ;that has this space on the end. we should really
                         ;get into it and decr the ncntz entry (#chars in piece)...
                         push ebx
                         mov ebx,pstartpiece
                         dec ebx ;look at end of last piece. problem if don't
                         mov al,[ebx] ;check this is a space.
                         .IF al==" "
                           mov eax,fontlistindex  ;only non-0 if nmode=-1.
                           .IF eax != 0
                             dec eax   ;each entry is 2 indexes.
                             dec eax   ;/
                             shl eax,1 ;4 bytes per value.
                             shl eax,1 ;/
                             lea ebx,colorlist
                             add ebx,eax
                             mov eax,[ebx+4] ;ncntz, #chars in previous piece.
                             .IF eax>1 ;precaution.
                               dec eax
                               mov [ebx+4],eax
                             .ENDIF
                           .ENDIF
                         .ENDIF
                         pop ebx
                     .ENDIF
                   .ENDIF
                   ;mov [ebx],BYTE PTR 0
               ;inc edi
                 ;v2.51 need to recalc gap at end of line...
                 pushad
  ;mov g_errorapi,0B2Eh ;for crash outside EVE, error codes range Axxh. v3.23
                 invoke GetTextExtentPoint32,hdc,pstartpiece,ncntz,ADDR ssize
                 mov ecx,extentaccum
                 add ecx,ssize.x
                 mov eax,textrect.rc_right
                 sub eax,textrect.rc_left
                 sub eax,ecx
                 mov ngap,eax
                 ;also, because have gone back one word, decr #spaces...
                 dec nspacesz
                 .IF SBYTE PTR nspacesz<0
                   mov nspacesz,0
                 .ENDIF
                 popad
;               jmp dd7
             .ENDIF
           .ENDIF ;end of "yes have reached right boundary".
         .ENDIF ;end of "have we reached right boundary?"
be1:
dd5z:

;       ;v2.56...
;       mov pendpiece,ebx
;       inc pendpiece ;so pts to next free.

  ret
htmltestendline ENDP
;--------------------------------------------------------------------------
htmlparsetag2nd PROC STDCALL,hdc:DWORD,nmode:DWORD
; "htmlparsetag2nd"
;have identified a top-level "<" meaning start of a tag,
;then did TextOut() to paint all text from pstartpiece marker in g_4kblock
;(text up to this tag).
;enter with edi->next char in source, g_bigblock (past the "<").
;now, identify this tag and set the flags/variables for the new font.
;exit with edi->next char after ">" tag.

dd2:     mov al,[edi]
         .IF al=="b" ;bold or break.
dd1:       inc edi
           mov al,[edi]
           .IF al==">" ;bold tag.
             .IF nweight>450
               mov nweight,400 ;normal.
             .ELSE
               mov nweight,700 ;bold.
             .ENDIF
           .ELSEIF al=="r"
br1:         inc edi
             mov al,[edi]
             .IF al==">"  ;<br> tag.
ns1x:          mov fforcenewline,1 ;v2.54.
               mov fbreak,1 ;need this for correct right/center align this line.
               jmp ns1 ;get out.    /
             .ELSEIF al<32
               jmp br1
             .ENDIF
           .ELSEIF al=="R"
             jmp br1
           .ELSEIF al=="i" ;<big> tag.
big1:        inc edi
             mov al,[edi]
             .IF al=="g"
big2:          inc edi
               mov al,[edi]
               .IF al==">"
                 ;have <big> tag...
;v2.43 commented out small pos. adj (see note below)...
                 mov eax,(OBJECT PTR [esi]).nfontsize ;default size in points.
                 .IF nsizetemp>eax
                   ;toggle back to normal size...
                   mov nsizetemp,eax
;                   neg yshift
                 .ELSE
                   mov ecx,eax
                   shr ecx,2 ;3
                   ;inc ecx
                   add eax,ecx
                   mov nsizetemp,eax ;bigger.
                 .ENDIF
               .ELSEIF al<32
                 jmp big2
               .ENDIF
             .ELSEIF al=="G"
               jmp big2
             .ELSEIF al<32
               jmp big1
             .ENDIF
           .ELSEIF al=="I"
             jmp big1
           .ELSEIF al<32 ;a control char
             jmp dd1
           .ENDIF
         .ELSEIF al=="B"
           jmp dd1
         .ELSEIF al=="i" ;italic.
it1:       inc edi
           mov al,[edi]
           .IF al==">"
             not fitalic ;toggle.
           .ELSEIF al<32
             jmp it1
           .ENDIF
         .ELSEIF al=="I"
           jmp it1
         .ELSEIF al=="s"  ;<small> tag?
sm1:       inc edi
           mov al,[edi]
           .IF al=="m"
sm2:         ;good enough, take it as <small>...
                 mov eax,(OBJECT PTR [esi]).nfontsize ;default size in points.
                 .IF nsizetemp<eax
                   ;toggle back to normal size...
                   mov nsizetemp,eax
                 .ELSE
                   mov ecx,eax
                   shr ecx,2 ;3
                   sub eax,ecx
                   mov nsizetemp,eax ;smaller.
                 .ENDIF
           .ELSEIF al=="M"
             jmp sm2
           .ELSEIF al<32
             jmp sm1
           .ENDIF
         .ELSEIF al=="S"
           jmp sm1
         .ELSEIF al=="p" ;<p> tag?
pa1:       inc edi
           mov al,[edi]
           .IF al==">"
             mov fparalign,0
pax:         mov fforcenewline,2 ;2=paragraph line break. 1 ;v2.54.
             jmp ns1 ;get out.   ;/
           .ELSEIF al==" "
             mov fparalign,0
             ;v2.43 can have <p xxxxx> so recognise this...
             ;</p> (below) will have to restore all font chars to default.
lt1:           mov al,[edi]
               inc edi
                 ;v2.51 <p align="justify"> ...
                 .IF al==" "
                   invoke stringcomparen,edi,ADDR szalignjustify
                   ;...edi->source block, 2ndparam->string to compare.
                   ;...case-insensitive, ignores <32 and spaces.
                   ;...returns eax=0 not equal, else eax->next char
                   ;beyond found string in source block.
                   .IF eax != 0 ;found.
                     mov edi,eax ;eax->next char beyond source string.
                     mov fparalign,3 ;used to adjust spacing when painting.
                     jmp SHORT fnd1
                   .ENDIF
                   invoke stringcomparen,edi,ADDR szalignright
                   .IF eax != 0 ;found.
                     mov edi,eax ;eax->next char beyond source string.
                     mov fparalign,1 ;used to adjust spacing when painting.
                     jmp SHORT fnd1
                   .ENDIF
                   invoke stringcomparen,edi,ADDR szaligncenter
                   .IF eax != 0 ;found.
                     mov edi,eax ;eax->next char beyond source string.
                     mov fparalign,2 ;used to adjust spacing when painting.
                     jmp SHORT fnd1
                   .ENDIF
                 .ENDIF
fnd1:          mov al,[edi]
               cmp al,">"
               jne lt1
             jmp pax
           .ELSEIF al<32
             jmp pa1
           .ENDIF
         .ELSEIF al=="P"
           jmp pa1
         .ELSEIF al=="f"
fo1:       inc edi
           mov al,[edi]
           .IF al=="o"
fo2:         ;good enough, say it's <font ... "#xxxxxx">
             ;let's scan, looking for "#", unless ">" reached...
             inc edi
             mov al,[edi]
             .IF al=="#"
               ;now read the color...
               inc edi
               invoke hexstr2longint,edi ;returned in eax.
                    ;RGB is wrong way round...
                    bswap eax
                    mov ecx,8
                    shr eax,cl
							 jmp fo7 ;invoke SetTextColor,hdc,eax
             .ELSEIF al==">"
               ;we have not found the #, this could be </font>.
               ;restore color to default...
								    mov eax,(OBJECT PTR [esi]).nfontcolor								
fo7:								.IF g_fredrawdiag==WIPEOUTobjs
										  ;xpaint_wipeout has already set color to white.
										.ELSE
									    mov textcolorcurrent,eax
										  .IF SDWORD PTR nmode>=0 ;nmode=-1, done in paintlinewithfonts.
  ;mov g_errorapi,0B2Fh ;for crash outside EVE, error codes range Axxh. v3.23
										    invoke SetTextColor,hdc,eax
										  .ENDIF
										.ENDIF
             .ELSE
               jmp fo2
             .ENDIF
           .ELSEIF al=="O"
             jmp fo2
           .ELSEIF al<32
             jmp fo1
           .ENDIF
         .ELSEIF al=="F"
           jmp fo1
         .ELSEIF al=="/"
           mov ecx,edi
pa5:       inc edi
           mov al,[edi]
           .IF al=="p" ;</p> tag.
pa4:         inc edi
             mov al,[edi]
             .IF al==">"
               ;this is a </p> tag. we want to ignore it.
               ;v2.43 no, restore font chars to defaults...
               mov eax,(OBJECT PTR [esi]).nfontsize
               mov nsizetemp,eax
               mov eax,nweightdef
               mov nweight,eax
               mov eax,fitalicdef
               mov fitalic,eax
               mov eax,funderlinedef
               mov funderline,eax
               mov eax,fstrikethrudef
               mov fstrikethru,eax
               mov eax,pfontdef
               mov pfont,eax
               ;v2.51 clr paragraph alignment...
               mov fparalign,0
               ;v2.55 also a new line...
               ;mov fforcenewline,1 ...done at ns1x:
               ;v2.60 for right/center align, need ngap before exit here...
               jmp ns1x
             .ELSEIF al<32
               jmp pa4
             .ELSE
               jmp SHORT pa6 ;not a </p> tag.
             .ENDIF
           .ELSEIF al=="P"
             jmp pa4
           .ELSEIF al<32
             jmp pa5
           .ELSE
pa6:         mov edi,ecx
             inc edi
             jmp dd2 ;process tag.
           .ENDIF
         .ELSEIF al<32 ;a control char
           inc edi
           jmp dd2
         .ENDIF
ns1:     mov al,[edi]
         inc edi
         cmp al,">"
         jne ns1

  ret
htmlparsetag2nd ENDP
;--------------------------------------------------------------------------
;v2.51
stringcomparen PROC STDCALL USES ebx ecx edx esi edi,psrc:DWORD,pstr:DWORD
  LOCAL pnext:DWORD
  LOCAL sbuftemp[64]:BYTE
; "stringcomparen"
;used by paint_label(), psrc->latest place in g_bigblock (source text),
;pstr->szstring to be compared.
;ignore chars <32 and spaces. case insensitive.
;return eax=0 not equal, else eax->next char beyond string in psource.
  mov edi,psrc
  ;let's copy the source string to a temporary block, stripping out
  ;char<=32...
    mov esi,pstr
    invoke lstrlen,esi
    mov ecx,eax
    .IF eax==0
      jmp SHORT fa1 ;precaution.
    .ELSEIF eax>63 ;precaution
      jmp SHORT fa1
    .ENDIF
  lea ebx,sbuftemp
nxt1:
  mov al,[edi]
  inc edi
  .IF al>32
    mov [ebx],al
    inc ebx
    mov pnext,edi
    loop nxt1
  .ELSEIF al==0 ;precaution. finshed.
  .ELSE     ;must be <32.
    jmp nxt1
  .ENDIF
;  .IF al != 0 ;precaution.
;    jmp nxt1
;  .ENDIF
  mov [ebx],BYTE PTR 0 ;terminator.
    ;now let's compare them...
    lea ebx,sbuftemp
    mov esi,pstr
    invoke lstrcmpi,esi,ebx
    ;...eax=0 if the same.
  .IF eax == 0
    mov eax,pnext ;->next char in source block beyond found string.
  .ELSE
fa1: xor eax,eax
  .ENDIF

  ret
stringcomparen ENDP
;--------------------------------------------------------------------------
delete_any		   PROC STDCALL USES edi esi eax ebx ecx edx, pobject:DWORD
		LOCAL dummy:DWORD
; "delete_any" *EVE*
		mov esi,pobject

		mov (OBJECT PTR [esi]).fstatus,0

;check if has a data-element...
tst2:
		mov ebx,(OBJECT PTR [esi]).rpdata
		.IF ebx==0
		.ELSE
		  add ebx,pTERSEDATA
		  mov (OBJECT PTR [ebx]).fstatus,0
		  ;v2.31 chained data...
		  mov esi,ebx
		  jmp tst2
		.ENDIF

		invoke deleteslaves, pobject

		ret
delete_any ENDP
;--------------------------------------------------------------------------
;v1.22
drag_label				 PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
		;LOCAL xfixed:SDWORD, yfixed:SDWORD
		LOCAL xchange:SDWORD, ychange:SDWORD
;similar to drag_node().
;called from wmmousemove/state8 > via pdrag method table. "drag_label"
;also from wmmousemove()/state5 (placing 2nd end new object).
;g_xdiff/g_ydiff was set in method that detected lbuttondown on the
;object (on_node()) -- difference between mouse and xmid/ymid.
;pmoving is the object being dragged.
;this routine also uses g_nmousex/g_nmousey -- world coords.
;v1.59 also called from xtimer()/state0 when animating an element.

		.IF g_nstate==5    ;placing other end, new object.
		  mov edi,pmoving
		  mov eax,g_nmousex
		  mov (OBJECT PTR [edi]).xmid,eax
		  mov ebx,(OBJECT PTR [edi]).wwidth
		  sar ebx,1
		  sub eax,ebx
		  mov (OBJECT PTR [edi]).xtopleft,eax
		  mov eax,g_nmousey
		  mov (OBJECT PTR [edi]).ymid,eax
		  mov ebx,(OBJECT PTR [edi]).height
		  sar ebx,1
		  sub eax,ebx
		  mov (OBJECT PTR [edi]).ytopleft,eax
		  invoke add2updatelist, pmoving
		  ret
		.ENDIF

;;this correction stops object from "jumping" when it is first dragged...
;				mov eax,g_nmousex		;mouse x-coord (world)
;				sub eax,g_xdiff
;				mov xfixed,eax			;corrected for initial lbuttondown difference.
;				mov eax,g_nmousey		;mouse y-coord.
;				sub eax,g_ydiff
;				mov yfixed,eax
;;calc change to apply to object coords...
;				mov edi,pmoving
;				mov eax,(OBJECT PTR [edi]).xmid
;				sub eax,xfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov xchange,eax 		;x-change.
;				mov eax,(OBJECT PTR [edi]).ymid
;				sub eax,yfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov ychange,eax 		;y-change.
    mov eax,g_xchange ;v3.42
    mov xchange,eax   ;/
    mov eax,g_ychange ;/
    mov ychange,eax   ;/

;update object coords...
		.IF g_pmovingobject==edi ;this object is moving. precaution.
		  .IF g_nknee==0		;dragging whole element.
d22:			mov eax,(OBJECT PTR [edi]).xmid
				sub eax,xchange
				mov (OBJECT PTR [edi]).xmid,eax
				mov eax,(OBJECT PTR [edi]).xtopleft
				sub eax,xchange
				mov (OBJECT PTR [edi]).xtopleft,eax
				mov eax,(OBJECT PTR [edi]).ymid
				sub eax,ychange
				mov (OBJECT PTR [edi]).ymid,eax
				mov eax,(OBJECT PTR [edi]).ytopleft
				sub eax,ychange
				mov (OBJECT PTR [edi]).ytopleft,eax
		  .ELSEIF g_nknee==1 ;right handle
				mov eax,(OBJECT PTR [edi]).xmid
				add eax,6
				add eax,(OBJECT PTR [edi]).xlabeloffset
				mov ebx,g_nmousex
				sub ebx,eax
				  .IF SDWORD PTR ebx<0
					;text is to left of xmid/ymid, ...
					neg ebx
					sub ebx,12
				  .ENDIF
					;0 width causes divide by 0 error...
					.IF SDWORD PTR ebx<10 ;2 ;0
					  mov ebx,10 ;2 ;neg ebx
					.ENDIF
				mov (OBJECT PTR [edi]).widthtext,ebx
				;mov xchange,0
				;mov ychange,0
				  ;v1.57 cause paint_label() to recalc .heighttext ...
				  ;mov ftestbreaks,1 ;(clrd inside paint_label()).
				  ;umm, careful don't paint any other labels, as will clr this flag...
				  ;v1.89 i'm having a problem with this getting clrd. use a flag
				  ;inside the label element...
				  or (OBJECT PTR [edi]).fconfig1,0100b ;bit2.
				  invoke add2updatelist,pmoving  ;v1.89
				  jmp SHORT out1
		  .ELSE
				jmp d22
		  .ENDIF
		.ELSE
		  ;if this obj being dragged, but it isn't the actual g_pmovingobject,
		  ;then move whole thing...
		  jmp d22
		.ENDIF
		invoke add2updatelist, pmoving

;need to locate all slave objects (locked-to this object)
;and add them to updatelist also
;and update their coords...

		invoke updateslaves, pmoving, xchange,ychange,0
		;invoke clrmovedbit 	 ;.status/bit7 set if a wire moved.

out1:	ret
drag_label ENDP
;--------------------------------------------------------------------------
drag_node				PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
		;LOCAL xfixed:SDWORD, yfixed:SDWORD
		LOCAL xchange:SDWORD, ychange:SDWORD
;called from wmmousemove/state8 > via pdrag method table. "drag_node"
;also from wmmousemove()/state5 (placing 2nd end new object).
;g_xdiff/g_ydiff was set in method that detected lbuttondown on the
;object (on_node()) -- difference between mouse and xmid/ymid.
;pmoving is the object being dragged.
;this routine also uses g_nmousex/g_nmousey -- world coords.

		mov edi,pmoving

		.IF g_nstate==5    ;placing other end, new object.
		  mov eax,g_nmousex
		  mov (OBJECT PTR [edi]).xmid,eax
		  mov ebx,(OBJECT PTR [edi]).wwidth
		  sar ebx,1
		  sub eax,ebx
		  mov (OBJECT PTR [edi]).xtopleft,eax
		  mov eax,g_nmousey
		  mov (OBJECT PTR [edi]).ymid,eax
		  mov ebx,(OBJECT PTR [edi]).height
		  sar ebx,1
		  sub eax,ebx
		  mov (OBJECT PTR [edi]).ytopleft,eax
		  invoke add2updatelist, pmoving
		  jmp out1 ;ret
		.ENDIF

;		 mov esi,edi
;		 sub esi,pTERSEDATA
;		 invoke ispointerok,esi
;		 .IF eax==0 ;fail.
;		   invoke myerrorhandler,esi
;		   jmp out1
;		 .ENDIF

;;this correction stops object from "jumping" when it is first dragged...
;				mov eax,g_nmousex		;mouse x-coord (world)
;				sub eax,g_xdiff
;				mov xfixed,eax			;corrected for initial lbuttondown difference.
;				mov eax,g_nmousey		;mouse y-coord.
;				sub eax,g_ydiff
;				mov yfixed,eax
;;calc change to apply to object coords...
;				;mov edi,pmoving
;				mov eax,(OBJECT PTR [edi]).xmid
;				sub eax,xfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov xchange,eax 		;x-change.
;				mov eax,(OBJECT PTR [edi]).ymid
;				sub eax,yfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov ychange,eax 		;y-change.
    mov eax,g_xchange ;v3.42
    mov xchange,eax   ;/
    mov eax,g_ychange ;/
    mov ychange,eax   ;/

;update object coords...
		.IF g_pmovingobject==edi ;this object is moving. precaution.

		  ;v1.81 element is boss (.rpowner1=0) yet is locked (.fconfig4/bit3=1)
		  ;i want to be able to drag, but not alone -- with children.
		  ;also want to disable dragging of handles...
		  mov eax,(OBJECT PTR [edi]).fconfig4
		  and al,01000b ;bit3.
		  .IF al==01000b ;locked.
			mov eax,(OBJECT PTR [edi]).rpowner1
			.IF eax==0
			  ;ignore g_nknee, drag whole element +children...
			  jmp d22
			.ENDIF
		  .ENDIF

		  .IF g_nknee==0		;dragging whole element.
d22:

;		 mov esi,edi
;		 sub esi,pTERSEDATA
;		 invoke ispointerok,esi
;		 .IF eax==0 ;fail.
;		   invoke myerrorhandler,esi
;		   jmp out1
;		 .ENDIF
;		 ;mov eax,(OBJECT PTR [edi]).number
;		 ;.IF ax==88
;		 ;.ELSEIF ax==89
;		 ;.ELSEIF ax==90
;		 ;.ELSE
;		 ;	;invoke myerrorhandler,eax
;		 ;	jmp out1
;		 ;.ENDIF
;		 .IF edi==pTERSEDATA
;		   invoke myerrorhandler,edi
;		 .ENDIF

				mov eax,xchange
				sub (OBJECT PTR [edi]).xmid,eax
				sub (OBJECT PTR [edi]).xtopleft,eax
				mov eax,ychange
				sub (OBJECT PTR [edi]).ymid,eax
				sub (OBJECT PTR [edi]).ytopleft,eax
		  .ELSEIF g_nknee==1 ;right handle
				  ;xchange/ychange calc'd above is relative to xmid/ymid, but here
				  ;they aren't moving. need to recalc...
				  mov eax,(OBJECT PTR [edi]).xtopleft
				  add eax,(OBJECT PTR [edi]).wwidth
				  sub eax,g_nmousex
				  mov xchange,eax
				  mov ychange,0
				mov eax,(OBJECT PTR [edi]).xtopleft
				mov ebx,g_nmousex
				sub ebx,eax
				;v0.99 0 width causes divide by 0 error...
				.IF SDWORD PTR ebx<2 ;0
				  mov ebx,2 ;neg ebx
				.ENDIF
				mov (OBJECT PTR [edi]).wwidth,ebx
				shr ebx,1
				mov eax,(OBJECT PTR [edi]).xtopleft
				add eax,ebx
				mov (OBJECT PTR [edi]).xmid,eax
				  ;invoke stretchcompobj,pmoving,xchange,ychange
				  ;v1.97 have removed stretchcompobj(), now using stretchhighlighted(),
				  ;which stretches selected elements. Can only use alignment-axes element
				  ;to stretch...
				  mov eax,(OBJECT PTR [edi]).nexttype
				  .IF eax==21 ;alignment axes element.
					mov ecx,deltax ;global. diff between current and prev mouse pos.
					neg ecx
					invoke stretchhighlighted,edi,ecx,0 ;xchange,ychange
				  .ENDIF
				  invoke add2updatelist,pmoving
				  jmp out1
		  .ELSEIF g_nknee==2 ;bottom handle.
				  ;xchange/ychange calc'd above is relative to xmid/ymid, but here
				  ;they aren't moving. need to recalc...
				  mov eax,(OBJECT PTR [edi]).ytopleft
				  add eax,(OBJECT PTR [edi]).height
				  sub eax,g_nmousey
				  mov ychange,eax
				  mov xchange,0
				mov eax,(OBJECT PTR [edi]).ytopleft
				mov ebx,g_nmousey
				sub ebx,eax
				;v0.99 0 height causes divide by 0 error...
				.IF SDWORD PTR ebx<2 ;0
				  mov ebx,2 ;neg ebx
				.ENDIF
				mov (OBJECT PTR [edi]).height,ebx
				shr ebx,1
				mov eax,(OBJECT PTR [edi]).ytopleft
				add eax,ebx
				mov (OBJECT PTR [edi]).ymid,eax
				  ;ditto, see above...
				  mov eax,(OBJECT PTR [edi]).nexttype
				  .IF eax==21 ;alignment axes element.
					mov ecx,deltay
					neg ecx
					invoke stretchhighlighted,edi,0,ecx ;xchange,ychange
				  .ENDIF
				  invoke add2updatelist,pmoving
				  jmp out1
		  .ELSEIF g_nknee==3 ;v1.44
			;v1.44 have introduced another handle, in on_() methods, for dragging
			;entire element when it is already highlighted, and any children won't move.
			;this is especially for moving a "boss" element of a comp-obj.
			;i want same code as "d22:" above, but want bypass "updateslaves()"...
				mov eax,xchange
				sub (OBJECT PTR [edi]).xmid,eax
				sub (OBJECT PTR [edi]).xtopleft,eax
				mov eax,ychange
				sub (OBJECT PTR [edi]).ymid,eax
				sub (OBJECT PTR [edi]).ytopleft,eax
				invoke add2updatelist,pmoving
				;invoke clrmovedbit ;???
				jmp out1
			.ELSEIF g_nknee==4 ;v2.96
			  ;start handle for partial ellipse.
			  mov eax,g_nmousex
			  sub eax,(OBJECT PTR [edi]).xtopleft
			  mov (OBJECT PTR [edi]).rxstartarc,eax
			  mov eax,g_nmousey
			  sub eax,(OBJECT PTR [edi]).ytopleft
			  mov (OBJECT PTR [edi]).rystartarc,eax
      .ELSEIF g_nknee==5 ;v2.96	
			  ;end handle for partial ellipse.
			  mov eax,g_nmousex
			  sub eax,(OBJECT PTR [edi]).xtopleft
			  mov (OBJECT PTR [edi]).rxendarc,eax
			  mov eax,g_nmousey
			  sub eax,(OBJECT PTR [edi]).ytopleft
			  mov (OBJECT PTR [edi]).ryendarc,eax
		  .ELSE
				jmp d22
		  .ENDIF
		.ELSE
		  ;if this obj being dragged, but it isn't the actual g_pmovingobject,
		  ;then move whole thing...
		  jmp d22
		.ENDIF
		invoke add2updatelist, pmoving

;need to locate all slave objects (locked-to this object)
;and add them to updatelist also
;and update their coords...

		invoke updateslaves, pmoving, xchange,ychange,0
		;invoke clrmovedbit 	 ;.status/bit7 set if a wire moved.
out1:
		ret
drag_node ENDP
;--------------------------------------------------------------------------
drag_poly PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
		;LOCAL xfixed:SDWORD, yfixed:SDWORD
		LOCAL xchange:SDWORD, ychange:SDWORD
		LOCAL varray[84]:SDWORD
		LOCAL fmeonly:BYTE
;called from wmmousemove/state8 > via pdrag method table. "drag_poly"
;also from wmmousemove()/state5 (placing 2nd end new object).
;g_xdiff/g_ydiff was set in method that detected lbuttondown on the
;object (on_node()) -- difference between mouse and xmid/ymid.
;pmoving is the object being dragged.
;this routine also uses g_nmousex/g_nmousey -- world coords.

;note, also call from wmmousemove()->xuser()->newmousetrack()/state4
;(placing first end new object).
;-- xuser doen't call the drag_ methods for other objects.


;;this correction stops object from "jumping" when it is first dragged...
;				mov eax,g_nmousex		;mouse x-coord (world)
;				sub eax,g_xdiff
;				mov xfixed,eax			;corrected for initial lbuttondown difference.
;				mov eax,g_nmousey		;mouse y-coord.
;				sub eax,g_ydiff
;				mov yfixed,eax
;;v2.23 trying to fix the initial jump when poly is boss of comp-obj....
;;calc change to apply to object coords...
;				mov edi,pmoving
;				mov eax,(OBJECT PTR [edi]).xmid ;2.23 bez0x ;xmid
;				sub eax,xfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov xchange,eax 		;x-change.
;				mov eax,(OBJECT PTR [edi]).ymid ;2.23 bez0y ;ymid
;				sub eax,yfixed
;				and al,fdragmask ;v1.40 see xuser1(). for snap to even coords.
;				mov ychange,eax 		;y-change.
    mov eax,g_xchange ;v3.42
    mov xchange,eax   ;/
    mov eax,g_ychange ;/
    mov ychange,eax   ;/

;v2.05 more vertices...
			  lea edx,varray ;needed in... registers eax, esi used in...
			  mov esi,edi
			  ;func uses esi->poly, edx->varray...
			  invoke combinepolyarrays

;update object coords...
    mov fmeonly,0
		.IF g_nstate==8 ;moving object
		  .IF g_pmovingobject==edi ;this object is moving.
				.IF g_nknee==0
				  ;dragging the entire polygon...
d11:			  mov eax,xchange
				  mov ebx,ychange
				  sub (OBJECT PTR [edi]).bez0x,eax
				  sub (OBJECT PTR [edi]).bez0y,ebx
				  sub (OBJECT PTR [edi]).bez1x,eax
				  sub (OBJECT PTR [edi]).bez1y,ebx
				  sub (OBJECT PTR [edi]).bez2x,eax
				  sub (OBJECT PTR [edi]).bez2y,ebx
				  sub (OBJECT PTR [edi]).bez3x,eax
				  sub (OBJECT PTR [edi]).bez3y,ebx
				  sub (OBJECT PTR [edi]).bez4x,eax
				  sub (OBJECT PTR [edi]).bez4y,ebx
				  sub (OBJECT PTR [edi]).bez5x,eax
				  sub (OBJECT PTR [edi]).bez5y,ebx
				  sub (OBJECT PTR [edi]).bez6x,eax
				  sub (OBJECT PTR [edi]).bez6y,ebx
				  sub (OBJECT PTR [edi]).bez7x,eax
				  sub (OBJECT PTR [edi]).bez7y,ebx
				  sub (OBJECT PTR [edi]).bez8x,eax
				  sub (OBJECT PTR [edi]).bez8y,ebx
						;v1.11 has 5 more vertices...
						sub (OBJECT PTR [edi]).bez9x,eax
						sub (OBJECT PTR [edi]).bez10x,eax
						sub (OBJECT PTR [edi]).bez11x,eax
						sub (OBJECT PTR [edi]).bez12x,eax
						sub (OBJECT PTR [edi]).bez13x,eax
						sub (OBJECT PTR [edi]).bez9y,ebx
						sub (OBJECT PTR [edi]).bez10y,ebx
						sub (OBJECT PTR [edi]).bez11y,ebx
						sub (OBJECT PTR [edi]).bez12y,ebx
						sub (OBJECT PTR [edi]).bez13y,ebx
				  ;note v2.05 has 28 more, but all relative.
				.ELSEIF g_nknee==-1 ;v3.03
				  ;rectangles and ellipses, on_res() and on_node() returned g_nknee=3
				  ;if left-button-down inside element when it's highlighted (not on a
				  ;handle). For poly, choose a value in on_poly() return g_nknee=-1
				  ;(not any handle) for button down inside poly.
				  ;need to drag poly independent of any children (special case of
				  ;dragging a highlighted element)...
				  mov fmeonly,1
				  jmp d11
				.ELSE
				  ;dragging just one corner...
				  ;this is only updating in varray...
				  lea ebx,varray
				  xor eax,eax
				  mov al,g_nknee
				  dec eax
				  mov ecx,8
				  mul ecx
				  add ebx,eax ;address of required corner.
				  ;mov eax,[ebx]
				  ;mov ecx,[ebx+4]
				  mov eax,g_nmousex ;xchange
				  mov ecx,g_nmousey ;ychange
				  mov [ebx],eax
				  mov [ebx+4],ecx

					;v2.05
					;if drag bez0 vertice (g_nknee=1), all vertices #15-42 also move,
					;as relative to bez0...
					.IF g_nknee==1
					  mov ebx,(OBJECT PTR [edi]).rpdata
					  .IF ebx != 0
						add ebx,pTERSEDATA
						lea eax,(OBJECT PTR [ebx]).sztext
						mov ebx,eax
						mov eax,g_nmousex
						sub eax,(OBJECT PTR [edi]).bez0x
						mov edx,g_nmousey
						sub edx,(OBJECT PTR [edi]).bez0y
						mov ecx,28
opo1:					sub [ebx],eax
						add ebx,4
						sub [ebx],edx
						add ebx,4
						loop opo1
					  .ENDIF
					.ENDIF

					;v2.05
					;combinepolyarrays() combines the bez and data-element vertices
					;into varray.
					;update original point in poly element...
					.IF BYTE PTR g_nknee<=14 ;vertices in bez0-13.
					  lea ebx,(OBJECT PTR [edi]).bez0x
					  xor eax,eax
					  mov al,g_nknee
					  dec eax
					  mov ecx,8
					  mul ecx
					  add ebx,eax ;address of required vertice.
					  mov eax,g_nmousex
					  mov ecx,g_nmousey
					  mov [ebx],eax
					  mov [ebx+4],ecx
					.ELSE
					  mov ebx,(OBJECT PTR [edi]).rpdata
					  .IF ebx != 0
						add ebx,pTERSEDATA
						lea eax,(OBJECT PTR [ebx]).sztext
						mov ebx,eax
						xor eax,eax
						mov al,g_nknee
						sub al,14
						dec eax
						mov ecx,8
						mul ecx
						add ebx,eax ;address of required vertice.
						mov eax,g_nmousex
						sub eax,(OBJECT PTR [edi]).bez0x ;value stored relative to bez0.
						mov ecx,g_nmousey
						sub ecx,(OBJECT PTR [edi]).bez0y ;value stored relative to bez0.
						mov [ebx],eax
						mov [ebx+4],ecx
					  .ENDIF
					.ENDIF

;				   invoke add2updatelist, pmoving
;				   jmp out1
				  mov xchange,0
				  mov ychange,0
				.ENDIF
		  .ENDIF
		.ELSE
		  ;drag entire object...
		  jmp d11
		.ENDIF

;need to locate all slave objects (locked-to this object)
;and add them to updatelist also
;and update their coords...
		.IF g_nstate==4
		  jmp SHORT out1 ;ret
		.ENDIF
		invoke add2updatelist, pmoving
    .IF fmeonly != 0 ;v3.03
      jmp SHORT out1
    .ENDIF
		.IF g_nstate==5
		.ELSE
		  invoke updateslaves, pmoving, xchange,ychange,0
		  ;invoke clrmovedbit			 ;.status/bit7 set if a wire moved.
		.ENDIF

out1:
		ret
drag_poly ENDP
;--------------------------------------------------------------------------
updateslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD, \
												xchange:DWORD, ychange:DWORD,finclme:DWORD
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
		LOCAL ffound:BYTE
		LOCAL fcontrol:BYTE
; "updateslaves" *EVE*
;locate all slaves attached to object pmoving, and update their
;coordinates by an amount xchange/ychange.
;also add slave objects to update list.
;this routine will have to be reentrant, as a slave object may in
;turn have its own slaves.
;(see also wipeoutslaves()).
;called from drag_*** method, while dragging an object.

;if plock1==pmoving, update slave.xtopleft/.ytopleft by xchange/ychange.
;if plock2==pmoving, update slave.wwidth/.height by xchange/ychange, as
;it is a wire (wwidth/height are coords other end of wire).

;v1.59 finclme=1 include pmoving in update.
;v1.60 removed recursion.
;v2.73 finclme=2 include pmoving, only incl children if locked (.fconfig4/bit3=1),
;                only follows the rpowner1 chain, ignores x/ychange.
;note, i'm often using this func with xchange=0/ychange=0, just to add elements
;to the update list.

;if <control> key held down, don't drag any child non-wire type
;elements... (but still add them to update list)...
		invoke GetAsyncKeyState, VK_CONTROL
		and ax,8000h			;bit15=1 if key down.
		.IF ax==8000h
		  mov fcontrol,1
		.ELSE
		  mov fcontrol,0
		.ENDIF

;scan through all objects...
				mov edi,pTERSEDATA
				mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0  ;precaution.
						jmp j03
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				  .IF al==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF SWORD PTR ax<0 ;al==-1				;data object
						.ELSE
			   ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
			   ;(...anything with .nexttype<0 is intended to be invisible)
			   ;(...dataelements guaranteed to have bits14-31 set).
			   ;(...so, the 16-bit lower half also -ve).
						  .IF esi==pmoving		;don't test itself.
							  .IF finclme>=1 ;v2.73
							    jmp yesme ;pmoving is to move also.
							  .ENDIF
						  .ELSE

							  mov ffound,0
							  ;follow the rpowner1 chain, see if reaches pmoving...
							  mov ebx,esi
t33:            mov eax,(OBJECT PTR [ebx]).fconfig4
                and eax,01000b ;bit3=1 locked. must be eax. v2.73
                cmp finclme,2
                jne t33m ;normal code, attached but not locked.
                .IF al != 0 ;locked.
t33m:				      mov eax,(OBJECT PTR [ebx]).rpowner1
							    .IF eax != 0
										  add eax,edi ;pTERSEDATA
										  .IF eax==pmoving
											  ;yes, attached to pmoving...
										  .ELSEIF eax==esi
											  ;an illegal loop...
nono1:									mov (OBJECT PTR [ebx]).rpowner1,0 ;break loop.
										  .ELSEIF eax==ebx
											  ;an element is attached to itself. illegal...
											  jmp nono1
										  .ELSE
											  mov ebx,eax
											  jmp t33
										  .ENDIF
							    .ENDIF
                .ENDIF
                
								.IF eax==pmoving  ;a bit weird, testing again.
yesme:						mov ffound,1
                  ;v2.73 need to execute finclme=2 fast, so we ignore the x/y change,
                  ;and don't check rpowner2 chain...
                  .IF finclme==2
                    jmp aa1 ;find next element.
                  .ENDIF

								  ;test for polygon...
								  mov eax,(OBJECT PTR [esi]).nexttype
								  .IF eax==5
										;v1.11 has 5 more vertices...
										mov eax,xchange
										sub (OBJECT PTR [esi]).bez9x,eax
										sub (OBJECT PTR [esi]).bez10x,eax
										sub (OBJECT PTR [esi]).bez11x,eax
										sub (OBJECT PTR [esi]).bez12x,eax
										sub (OBJECT PTR [esi]).bez13x,eax
										mov eax,ychange
										sub (OBJECT PTR [esi]).bez9y,eax
										sub (OBJECT PTR [esi]).bez10y,eax
										sub (OBJECT PTR [esi]).bez11y,eax
										sub (OBJECT PTR [esi]).bez12y,eax
										sub (OBJECT PTR [esi]).bez13y,eax
										jmp pol1 ;need to move all bezier coords.
								  .ENDIF

								  mov eax,(OBJECT PTR [esi]).fconfig1
								  and al,01
								  .IF al==0 ;non-wire type.
										.IF fcontrol==1
										  ;don't move non-wire type if <control> held down...
										  invoke add2updatelist,esi
										  jmp hack2
										.ENDIF
										;non-wire type, update middle coords,
										mov eax,xchange
										sub (OBJECT PTR [esi]).xmid,eax
										sub (OBJECT PTR [esi]).xtopleft,eax
										mov eax,ychange
										sub (OBJECT PTR [esi]).ymid,eax
										sub (OBJECT PTR [esi]).ytopleft,eax
								  .ELSE
										;*EVE* the problem is wires that are locked to parent,
										;wire.fconfig4/bit3=1... that is, cannot move independently
										;and must move entirely with owner...
										;i think we will just adjust all bezier coords in wire...
										mov eax,(OBJECT PTR [esi]).fconfig4
										and eax,01000b
										.IF eax==01000b ;locked...
p12:									  ;set a flag to prevent element being moved twice...
										  test (OBJECT PTR [esi]).fstatus,10000000b ;bit7
										  jnz hack2
										  or (OBJECT PTR [esi]).fstatus,010000000b ;set bit7.
pol1:											mov eax,xchange
												sub (OBJECT PTR [esi]).bez0x,eax ;.xtopleft
												sub (OBJECT PTR [esi]).bez1x,eax
												sub (OBJECT PTR [esi]).bez2x,eax
												sub (OBJECT PTR [esi]).bez3x,eax
												sub (OBJECT PTR [esi]).bez4x,eax
												sub (OBJECT PTR [esi]).bez5x,eax
												sub (OBJECT PTR [esi]).bez6x,eax
												sub (OBJECT PTR [esi]).bez7x,eax
												sub (OBJECT PTR [esi]).bez8x,eax ;.wwidth
												mov eax,ychange
												sub (OBJECT PTR [esi]).bez0y,eax ;.ytopleft
												sub (OBJECT PTR [esi]).bez1y,eax
												sub (OBJECT PTR [esi]).bez2y,eax
												sub (OBJECT PTR [esi]).bez3y,eax
												sub (OBJECT PTR [esi]).bez4y,eax
												sub (OBJECT PTR [esi]).bez5y,eax
												sub (OBJECT PTR [esi]).bez6y,eax
												sub (OBJECT PTR [esi]).bez7y,eax
												sub (OBJECT PTR [esi]).bez8y,eax ;.height
										.ELSE
										  ;wire not locked, so just move its 1st end...
										  mov eax,xchange
										  sub (OBJECT PTR [esi]).xtopleft,eax
										  mov eax,ychange
										  sub (OBJECT PTR [esi]).ytopleft,eax
										  ;also check 2nd end...
										  jmp tst1
										.ENDIF
								  .ENDIF
								.ELSE
								
tst1:             ;only go in here if a wire...(check 2nd end)...
                  ;v2.73 need to execute finclme=2 fast, so we ignore the x/y change,
                  ;and don't check rpowner2 chain...
                  .IF finclme==2
                    jmp aa2 ;find next element.
                  .ENDIF

								  mov eax,(OBJECT PTR [esi]).fconfig1
								  and al,01
								  .IF al==01  ;wire type.
									mov eax,(OBJECT PTR [esi]).rpowner2
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														  jmp ovr1
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
									.IF eax==pmoving
yesis1: 								  mov eax,(OBJECT PTR [esi]).fconfig4
										  and eax,01000b
										  .IF eax==01000b ;locked to owner.
												jmp p12
										  .ENDIF
										  mov eax,xchange						  ;update coords
										  sub (OBJECT PTR [esi]).wwidth,eax ;/ (intended for
										  mov eax,ychange						  ;/	   other end
										  sub (OBJECT PTR [esi]).height,eax ;/	   of wires)
										  mov ffound,1
									.ELSE
									  ;keep trying, follow rpowner1 chain...
									  mov ebx,eax
zt33:								  mov eax,(OBJECT PTR [ebx]).rpowner1
									  .IF eax != 0
										  add eax,edi ;pTERSEDATA
										  .IF eax==pmoving
											;yes, attached to pmoving...
											jmp yesis1
										  .ELSEIF eax==esi
											;an illegal loop...
nono2:										mov (OBJECT PTR [ebx]).rpowner1,0 ;break loop.
										  .ELSEIF eax==ebx
											;an element is attached to itself. illegal...
											jmp nono2
										  .ELSE
											mov ebx,eax
											jmp zt33
										  .ENDIF
									  .ENDIF
ovr1:								.ENDIF
								  .ENDIF
								.ENDIF
aa1:						.IF ffound==1
								  invoke add2updatelist, esi
hack2:					  mov ffound,0
								  and (OBJECT PTR [esi]).fstatus,0FFFFFF7Fh ;clr bit7.
								.ENDIF
						  .ENDIF
						.ENDIF
				  .ENDIF
aa2:		mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  j02 ;nextobj
		  jmp SHORT j03
j02:  jmp nextobj
j03:


  ret
updateslaves ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
pmoving0 DWORD 0
wipeoutsindex0 DWORD 0
fptrsinvalid_wipeoutslaves BYTE 1 ;set in zeroabsoluteptrs().
  BYTE 0,0,0
  
.CODE
wipeoutslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
		LOCAL ffound:BYTE
; "wipeoutslaves"
;very similar to updateslaves(), except *doesn't* alter slave-object
;coordinates, and adds slaves to wipeout list.
;locate all slaves locked to object pmoving.
;called from wipeslaves_*** method, while dragging an object.
;v1.60 have removed recursion.

;v2.80 a bug -- dragged a node, created a new attached acivator, dragged node
;again, activator didn't wipeout. the code below wasn't recognising the new
;attached element that should be added to the wipeoutlist. so, maybe i'll clr
;"pmoving0" whenever create a new element? so, i have put pmoving=0 in
;wmlbuttondown/state4. but, what if i just attach an existing
;element? i think, any entry to wmrbuttondown() --i have put pmoving0=0 there too.

;v2.74 try to speedup... if reenter here with same pmoving value as previous
;entry, use same list of slaves...
    mov ebx,pmoving
    .IF ebx==pmoving0 ;previous value.
      ;need to be very careful that pointers still valid...
      .IF fptrsinvalid_wipeoutslaves==0
        .IF fprinting==0
          .IF fsaving==0
            ;restore wipeoutsindex...
            mov eax,wipeoutsindex0 ;see end this func.
            mov wipeoutsindex,eax ;note, painting will have cleared wipeoutsindex.
            jmp out9
          .ENDIF
        .ENDIF
      .ENDIF
    .ENDIF
    mov eax,pmoving
    mov pmoving0,eax
    mov fptrsinvalid_wipeoutslaves,0
    ;...zeroabsoluteptrs() will set this if ptrs become invalid, affects next entry.

;scan through all objects...
				mov edi,pTERSEDATA
				mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0  ;precaution.
						jmp j03
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				  .IF al==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF SWORD PTR ax<0 ;al==-1				;data object
						  ;(also have excluded comp-objs in elements menu, which have bits15-31 set)
						  ;(...anything with .nexttype<0 is intended to be invisible)
						  ;(...dataelements guaranteed to have bits14-31 set).
						  ;(...so, the 16-bit lower half also -ve).
						.ELSE
						  .IF esi==pmoving		;don't test itself.
						  .ELSE

							  mov ffound,0
							  ;follow the rpowner1 chain, see if reaches pmoving...
							  mov ebx,esi
t33:						  mov eax,(OBJECT PTR [ebx]).rpowner1
							  .IF eax != 0
										  add eax,edi ;pTERSEDATA
										  .IF eax==pmoving
											;yes, attached to pmoving...
										  .ELSEIF eax==esi
											;an illegal loop...
nono1:										mov (OBJECT PTR [ebx]).rpowner1,0 ;break loop.
										  .ELSEIF eax==ebx
											;an element is attached to itself. illegal...
											jmp nono1
										  .ELSE
											mov ebx,eax
											jmp t33
										  .ENDIF
							  .ENDIF

								.IF eax==pmoving  ;a bit weird, testing again.
								  mov ffound,1
								.ELSE
								  ;only go in here if a wire...(check 2nd end)...
tst1:
								  mov eax,(OBJECT PTR [esi]).fconfig1
								  and al,01
								  .IF al==01  ;wire type.
									mov eax,(OBJECT PTR [esi]).rpowner2
														.IF eax==0
														  jmp ovr1
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
									.IF eax==pmoving
yesis1: 							  mov ffound,1
									.ELSE
									  ;keep trying, follow rpowner1 chain...
									  mov ebx,eax
zt33:								  mov eax,(OBJECT PTR [ebx]).rpowner1
									  .IF eax != 0
										  add eax,edi ;pTERSEDATA
										  .IF eax==pmoving
											;yes, attached to pmoving...
											jmp yesis1
										  .ELSEIF eax==esi
											;an illegal loop...
nono2:										mov (OBJECT PTR [ebx]).rpowner1,0 ;break loop.
										  .ELSEIF eax==ebx
											;an element is attached to itself. illegal...
											jmp nono2
										  .ELSE
											mov ebx,eax
											jmp zt33
										  .ENDIF
									  .ENDIF
ovr1:								.ENDIF
								  .ENDIF
								.ENDIF
								.IF ffound==1
								  invoke add2wipeoutlist, esi
hack2:							  mov ffound,0
								.ENDIF
						  .ENDIF
						.ENDIF
				  .ENDIF
				mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		  loop	j02 ;nextobj
		  jmp SHORT j03
j02:	  jmp nextobj
j03:
  mov eax,wipeoutsindex  ;v2.74
  mov wipeoutsindex0,eax ;/
out9:
  ret
wipeoutslaves ENDP
;--------------------------------------------------------------------------
deleteslaves PROC STDCALL USES ebx ecx edx esi edi, pmoving:DWORD
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
		LOCAL ffound:BYTE
; "deleteslaves"
;very similar to wipeoutslaves().
;locate all slaves locked to object pmoving.
;this routine will have to be reentrant, as a slave object may in
;turn have its own slaves.
;called from delete_*** method.

;note, will also delete data objects if locked to a valid object that
;is marked for deletion.

;scan through all objects...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp j03
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						  .IF esi==pmoving ;don't test itself.
						  .ELSE
								mov ffound,0
								mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								.IF eax==pmoving
								  mov ffound,1
								  jmp SHORT tst1				;in case other end wire on same node.
								.ELSE
tst1:					  mov eax,(OBJECT PTR [esi]).rpowner2
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pmoving
										mov ffound,1
								  .ENDIF
								.ENDIF
								.IF ffound==1

										mov (OBJECT PTR [esi]).fstatus,0 ;kill it.

										;check if has a data-element...
										mov ebx,(OBJECT PTR [esi]).rpdata
										.IF ebx==0
										.ELSE
										  add ebx,pTERSEDATA
										  mov (OBJECT PTR [ebx]).fstatus,0
										.ENDIF

										;now for recursion...
										invoke deleteslaves, esi

								  mov ffound,0
								.ENDIF
						  .ENDIF

				  .ENDIF
x1: mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  j02 ;nextobj
		  jmp SHORT j03
j02:  jmp nextobj
j03:

  ret
deleteslaves ENDP
;--------------------------------------------------------------------------
fixwiremid PROC PROC STDCALL USES ebx ecx edx esi edi,pparent:DWORD,pnew:DWORD
		LOCAL xcorrection:DWORD, ycorrection:DWORD
; "fixwiremid" *EVE*
;from lbuttonup()/state5.
;a wire has been placed with both ends on same node. need to auto-fix
;middle coords of wire outside the parent node...
;(code taken from goofee upinnode5())
;similar to fixnewchild(), which does same thing for new node.
;note -- wire.nendring isn't correct when this func called.

		mov esi,pnew
		mov edi,pparent

				mov  eax,(OBJECT PTR [edi]).xmid
				sub  eax,(OBJECT PTR [esi]).xmid				;xdelta

				;xor ecx,ecx
				mov  ecx,(OBJECT PTR [edi]).nrings				;added 16/12/96
				sub  ecx,(OBJECT PTR [esi]).nbeginring ;nendring				;/
				inc  ecx																;/
				imul ecx																;/ -->dx:ax
				mov xcorrection,eax
				mov  ecx,(OBJECT PTR [esi]).xmid								;/
				sub  ecx,eax													;/
				mov  eax,ecx													;/
				mov (OBJECT PTR [esi]).xmid,eax 		;new xmid of loopback.

				mov  ecx,(OBJECT PTR [esi]).xknee2
				sub  ecx,xcorrection
				mov (OBJECT PTR [esi]).xknee2,ecx
				mov  ecx,(OBJECT PTR [esi]).xknee3
				sub  ecx,xcorrection
				mov (OBJECT PTR [esi]).xknee3,ecx


				mov  eax,(OBJECT PTR [edi]).ymid
				sub  eax,(OBJECT PTR [esi]).ymid				;ydelta

				;xor ecx,ecx
				mov  ecx,(OBJECT PTR [edi]).nrings				;added 16/12/96
				sub  ecx,(OBJECT PTR [esi]).nbeginring ;nendring				;/
				inc  ecx																;/
				imul ecx																;/ -->dx:ax
				mov ycorrection,eax
				mov  ecx,(OBJECT PTR [esi]).ymid								;/
				sub  ecx,eax													;/
				mov  eax,ecx													;/
				mov (OBJECT PTR [esi]).ymid,eax

				mov  ecx,(OBJECT PTR [esi]).yknee2
				sub  ecx,ycorrection
				mov (OBJECT PTR [esi]).yknee2,ecx
				mov  ecx,(OBJECT PTR [esi]).yknee3
				sub  ecx,ycorrection
				mov (OBJECT PTR [esi]).yknee3,ecx

;24-4-98 sometimes we are getting wires mid-point jumping way off...
;do a limit-check here...
;esi-->new wire, edi-->node wire-end is on.
				mov eax,(OBJECT PTR [edi]).xmid
				sub eax,(OBJECT PTR [esi]).xmid
				mov ecx,eax
;				and ecx,8000h
				.IF SDWORD PTR ecx>=0	;+ve.
				  .IF SDWORD PTR eax>100
						mov eax,(OBJECT PTR [edi]).xmid
						sub eax,100
						mov (OBJECT PTR [esi]).xmid,eax
				  .ENDIF
				.ELSE
				  .IF SDWORD PTR eax<-100
						mov eax,(OBJECT PTR [edi]).xmid
						add eax,100
						mov (OBJECT PTR [esi]).xmid,eax
				  .ENDIF
				.ENDIF
				mov eax,(OBJECT PTR [edi]).ymid
				sub eax,(OBJECT PTR [esi]).ymid
				mov ecx,eax
;				and ecx,8000h
				.IF SDWORD PTR ecx>=0	;+ve.
				  .IF SDWORD PTR eax>100
						mov eax,(OBJECT PTR [edi]).ymid
						sub eax,100
						mov (OBJECT PTR [esi]).ymid,eax
				  .ENDIF
				.ELSE
				  .IF SDWORD PTR eax<-100
						mov eax,(OBJECT PTR [edi]).ymid
						add eax,100
						mov (OBJECT PTR [esi]).ymid,eax
				  .ENDIF
				.ENDIF


  ret
fixwiremid ENDP
;--------------------------------------------------------------------------
fixnewchild PROC PROC STDCALL USES ebx ecx edx esi edi,pparent:DWORD,pnew:DWORD
		LOCAL dummy:DWORD
; "fixnewchild" *EVE*
;from lbuttonup()/state5.
;a new node has been placed, with lbuttondown and lbuttonup on top
;of same parent node.  need to auto-fix
;middle coords of new obj outside the parent node...
;(code taken from goofee upinnode5())
;similar to fixwiremid(), which does same thing for new wire.

		mov esi,pnew
		mov edi,pparent

				mov  eax,(OBJECT PTR [edi]).xmid
				sub  eax,(OBJECT PTR [esi]).xtopleft ;xmid				;xdelta

				mov  ecx,(OBJECT PTR [edi]).nrings				;added 16/12/96
;*???	sub  ecx,(OBJECT PTR [esi]).nendring	;/
				inc  ecx																;/
				imul ecx																;/ -->dx:ax
				mov  ecx,(OBJECT PTR [esi]).xmid								;/
				sub  ecx,eax													;/
				mov  eax,ecx													;/
				mov (OBJECT PTR [esi]).xmid,eax 		;new xmid

				mov  eax,(OBJECT PTR [edi]).ymid
				sub  eax,(OBJECT PTR [esi]).ytopleft ;ymid				;ydelta

				mov  ecx,(OBJECT PTR [edi]).nrings				;added 16/12/96
;*???	sub  ecx,(OBJECT PTR [esi]).nendring	;/
				inc  ecx																;/
				imul ecx																;/ -->dx:ax
				mov  ecx,(OBJECT PTR [esi]).ymid								;/
				sub  ecx,eax													;/
				mov  eax,ecx													;/
				mov (OBJECT PTR [esi]).ymid,eax

;do a limit-check here...
;esi-->new wire, edi-->node wire-end is on.
				mov eax,(OBJECT PTR [edi]).xmid
				sub eax,(OBJECT PTR [esi]).xmid
				mov ecx,eax
;				and ecx,8000h
				.IF SDWORD PTR ecx>=0	;+ve.
				  .IF SDWORD PTR eax>100
						mov eax,(OBJECT PTR [edi]).xmid
						sub eax,100
						mov (OBJECT PTR [esi]).xmid,eax
				  .ENDIF
				.ELSE
				  .IF SDWORD PTR eax<-100
						mov eax,(OBJECT PTR [edi]).xmid
						add eax,100
						mov (OBJECT PTR [esi]).xmid,eax
				  .ENDIF
				.ENDIF
				mov eax,(OBJECT PTR [edi]).ymid
				sub eax,(OBJECT PTR [esi]).ymid
				mov ecx,eax
;				and ecx,8000h
				.IF SDWORD PTR ecx>=0	;+ve.
				  .IF SDWORD PTR eax>100
						mov eax,(OBJECT PTR [edi]).ymid
						sub eax,100
						mov (OBJECT PTR [esi]).ymid,eax
				  .ENDIF
				.ELSE
				  .IF SDWORD PTR eax<-100
						mov eax,(OBJECT PTR [edi]).ymid
						add eax,100
						mov (OBJECT PTR [esi]).ymid,eax
				  .ENDIF
				.ENDIF

;now update other coords of new object...
		mov eax,(OBJECT PTR [esi]).wwidth
		shr eax,1
		mov ebx,(OBJECT PTR [esi]).xmid
		sub ebx,eax
		mov (OBJECT PTR [esi]).xtopleft,ebx
		mov eax,(OBJECT PTR [esi]).height
		shr eax,1
		mov ebx,(OBJECT PTR [esi]).ymid
		sub ebx,eax
		mov (OBJECT PTR [esi]).ytopleft,ebx

  ret
fixnewchild ENDP
;--------------------------------------------------------------------------


drag_arc				PROC STDCALL USES edi esi eax ebx ecx edx, pmoving:DWORD
		LOCAL xchange:SDWORD, ychange:SDWORD
		;LOCAL xfixed:DWORD,yfixed:DWORD
		LOCAL exttype:DWORD
; *EVE*
;this is called via "pdrag" method table, from wmmousemove(), "drag_arc"
;states5 and 8. state5 is placing second end of wire, state8 is
;dragging middle of wire.

;no, also when placing "1st end" of new wire...
;wmousemove()/state4 > WM_USER+1 > xuser1() > drag_ methods > drag_arc

;NOTE the other drag_ methods use g_xdiff/g_ydiff to prevent an
;initial jump.
;*EVE* i've now set g_xdiff/g_ydiff in on_arc(), so use it here...
;...but i've only set it for dragging middle of wire (in state=8)...
;g_nknee =which handle to drag, =0 drag entire wire.
; --note, currently haven't implemented g_nkneee=0 below, as the
;only way entire wire gets dragged is by updateslaves(), updatemove(),
;which don't use drag_arc().

;v1.40 note, i haven't applied "fdragmask" to this func. other drag_() funcs use it.
;it's setup in prefsproc() for snapping of element when drag. at the moment, it seems
;best not to use it here.

		mov esi,pmoving
		mov eax,(OBJECT PTR [esi]).nexttype
		mov exttype,eax

		.IF g_nstate==5    ;dragging 2nd end of new object.
		  ;other end of wire to track mouse, middle to be in middle...
				;calc change...
				mov xchange,0
				mov ychange,0
		  mov eax,g_nmousex
		  mov (OBJECT PTR [esi]).wwidth,eax
		  sub eax,(OBJECT PTR [esi]).xtopleft
		  sar eax,1 			 ; /2
		  add eax,(OBJECT PTR [esi]).xtopleft
		  mov (OBJECT PTR [esi]).xmid,eax
		  mov eax,g_nmousey
		  mov (OBJECT PTR [esi]).height,eax
		  sub eax,(OBJECT PTR [esi]).ytopleft
		  sar eax,1
		  add eax,(OBJECT PTR [esi]).ytopleft
		  mov (OBJECT PTR [esi]).ymid,eax

		.ELSEIF g_nstate==8 	  ;dragging an object.
		  ;we're only dragging the middle of the wire if
		  ;pmoving (this wire) = g_pmovingobject...
		  mov eax,pmoving

		  .IF eax==g_pmovingobject

				  ;we are directly dragging this wire, but which knee?
				  ;on_arc (which detected mouse on the wire) sets g_nknee...
				  .IF g_nknee==1		;mouse on middle of wire.

						.IF g_nstateprev==2 ;obj was highlighted(state2) prior to moving(state8)...
						  ;the wire is highlighted, so drag middle handle independently...
						  .IF exttype != 13 ;but not a straight line.
								  mov eax,(OBJECT PTR [esi]).xmid
								  sub eax,g_nmousex
								  mov xchange,eax
								  mov eax,(OBJECT PTR [esi]).ymid
								  sub eax,g_nmousey
								  mov ychange,eax
								  mov eax,g_nmousex
								  mov (OBJECT PTR [esi]).xmid,eax
								  mov eax,g_nmousey
								  mov (OBJECT PTR [esi]).ymid,eax
						  .ELSE
							;v1.89
							;so, shall we test as per below, or just get out? get out...
							jmp out1
						  .ENDIF
						.ELSE

;								;*EVE* see note above, need to incorporate x/ydiff...
;								;this correction stops object from
;								;"jumping" when it is first dragged...
;								mov eax,g_nmousex				;mouse x-coord (world)
;								sub eax,g_xdiff
;								mov xfixed,eax			;corrected for initial lbuttondown difference.
;								mov eax,g_nmousey				;mouse y-coord.
;								sub eax,g_ydiff
;								mov yfixed,eax
;								;calc change to apply to object coords...
;								mov eax,(OBJECT PTR [esi]).xmid
;								sub eax,xfixed
;								mov xchange,eax 		;x-change.
;								mov eax,(OBJECT PTR [esi]).ymid
;								sub eax,yfixed
;								mov ychange,eax 		;y-change.
                mov eax,g_xchange ;v3.42
                mov xchange,eax   ;/
                mov eax,g_ychange ;/
                mov ychange,eax   ;/

								;if exttype=13, a straight line, must drag all coords...
								.IF exttype==13
								  mov ebx,(OBJECT PTR [esi]).rpowner1
								  mov edx,(OBJECT PTR [esi]).rpowner2
								  .IF ebx==0
										.IF edx==0
										  ;not attached either end, so can drag it...
										  mov eax,xchange
										  mov ecx,ychange
										  sub (OBJECT PTR [esi]).xtopleft,eax			;x start.
										  sub (OBJECT PTR [esi]).ytopleft,ecx			;y start.
										  sub (OBJECT PTR [esi]).wwidth,eax ;x end.
										  sub (OBJECT PTR [esi]).height,ecx ;y end.
										  ;...moved ends, now the rest...
										.ENDIF
								  .ENDIF
								  ;cannot drag it from middle...
								  ;jmp b12
									;v1.89
									;don't need this either...invoke add2updatelist, pmoving
									jmp out1 ;don't drag any slaves.
								.ENDIF

								;bezier experiment...
								;drag along knee2/3 as well...
								mov eax,xchange
								sub (OBJECT PTR [esi]).xmid,eax
								sub (OBJECT PTR [esi]).xknee2,eax
								sub (OBJECT PTR [esi]).xknee3,eax
								mov eax,ychange
								sub (OBJECT PTR [esi]).ymid,eax
								sub (OBJECT PTR [esi]).yknee2,eax
								sub (OBJECT PTR [esi]).yknee3,eax
						.ENDIF

;only allow knees to be selected if wire is highlighted...
;wmlbuttondown detected this, and put into state8, and set pmovingobject.
;the knees are not normally selectable. first the middle has to be
;highlighted, then lbuttondown on a knee (which paint_arc will display
;when wire highlighted) will result in state8 ... so this is the only
;way we can get g_nknee =2/3 when come here...
				  .ELSEIF g_nknee==2	;mouse on knee2
								  mov eax,(OBJECT PTR [esi]).xknee2
								sub eax,g_nmousex
								mov xchange,eax
								mov eax,(OBJECT PTR [esi]).yknee2
								sub eax,g_nmousey
								mov ychange,eax
								mov eax,g_nmousex
								mov (OBJECT PTR [esi]).xknee2,eax
								mov eax,g_nmousey
								mov (OBJECT PTR [esi]).yknee2,eax
				  .ELSEIF g_nknee==3	;mouse on knee3
								mov eax,(OBJECT PTR [esi]).xknee3
								sub eax,g_nmousex
								mov xchange,eax
								mov eax,(OBJECT PTR [esi]).yknee3
								sub eax,g_nmousey
								mov ychange,eax
								mov eax,g_nmousex
								mov (OBJECT PTR [esi]).xknee3,eax
								mov eax,g_nmousey
								mov (OBJECT PTR [esi]).yknee3,eax
				  .ELSEIF g_nknee==4	;mouse on start-end of wire.
								;note, a problem if this is wire on a master-node,
								;snapclonewires() looks for matching wire on clone,
								;but if xchange/ychange here is too big, the wire
								;on slave will "fall out" of tracking.
								;a further problem is cannot restrict xchange/ychange
								;as wire then cannot jump rings. so, impose the
								;xchange/ychange restriction only if wire-end is on
								;ring1 of a master node...

								;v1.50 delete...
								;mov ebx,(OBJECT PTR [esi]).rpowner1 	 ;owner-node
								;add ebx,pTERSEDATA
								;mov eax,(OBJECT PTR [ebx]).rpowner1 ;of master node
								;.IF eax==0 			 ;master, or free node.
								  ;mov eax,(OBJECT PTR [ebx]).nchildren
								  ;.IF al==0 ;node has no children
										  ;unrestricted xchange/ychange...
										  mov eax,(OBJECT PTR [esi]).xtopleft ;gg1:
										  sub eax,g_nmousex
										  mov xchange,eax
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  sub eax,g_nmousey
										  mov ychange,eax
										  mov eax,g_nmousex
										  mov (OBJECT PTR [esi]).xtopleft,eax
										  mov eax,g_nmousey
										  mov (OBJECT PTR [esi]).ytopleft,eax
								  ;.ELSE
								  ; 	 mov eax,(OBJECT PTR [esi]).nbeginring
								  ; 	 .IF al==1				 ;wire begins on ring1.
								  ; 	   ;note, i'm restricting xchange/ychange so
								  ; 	   ;wire can't be pulled out of ring1...
								  ; 	   ;*NO* can't stop it.
								  ; 	   mov eax,(OBJECT PTR [esi]).xtopleft
								  ; 	   sub eax,g_nmousex
								  ; 	   .IF SDWORD PTR eax<=-1 ;2
								  ; 			 mov xchange,-1 ;2
								  ; 	   .ELSEIF SDWORD PTR eax>=1 ;2
								  ; 			 mov xchange,1 ;2
								  ; 	   .ELSE
								  ; 			 mov xchange,eax
								  ; 	   .ENDIF
								  ; 	   mov eax,(OBJECT PTR [esi]).ytopleft
								  ; 	   sub eax,g_nmousey
								  ; 	   .IF SDWORD PTR eax<=-1 ;2
								  ; 			 mov ychange,-1 ;2
								  ; 	   .ELSEIF SDWORD PTR eax>=1 ;2
								  ; 			 mov ychange,1 ;2
								  ; 	   .ELSE
								  ; 			 mov ychange,eax
								  ; 	   .ENDIF
								  ; 	   mov eax,(OBJECT PTR [esi]).xtopleft
								  ; 	   sub eax,xchange
								  ; 	   mov (OBJECT PTR [esi]).xtopleft,eax
								  ; 	   mov eax,(OBJECT PTR [esi]).ytopleft
								  ; 	   sub eax,ychange
								  ; 	   mov (OBJECT PTR [esi]).ytopleft,eax
								  ; 			 ;now go ahead and snap the wires on clones...
								  ; 			 ;ebx -> master node. esi -> wire.
								  ; 			 mov eax,(OBJECT PTR [esi]).xtopleft
								  ; 			 mov ecx,(OBJECT PTR [esi]).ytopleft
								  ; 			 ;2nd param =0 means first end of wire...
								  ; 	 .ELSE
								  ; 	   jmp gg1
								  ; 	 .ENDIF
								  ;.ENDIF
								;.ELSE
								;  jmp gg1
								;.ENDIF

								  ;i've got a problem, parent node not redrawing
								  ;while i'm dragging wire end...
								  mov eax,(OBJECT PTR [esi]).rpowner1	;get parent.
								  add eax,pTERSEDATA	;cos it's relative.
								  invoke add2updatelist,eax
				  .ELSEIF g_nknee==5	;mouse on destination-end of wire.
						;see notes above for g_nknee==4.

								;v1.50 delete...
								;mov ebx,(OBJECT PTR [esi]).rpowner2 	 ;owner-node
								;add ebx,pTERSEDATA
								;mov eax,(OBJECT PTR [ebx]).rpowner1 ;of master node
								;.IF eax==0 			 ;master, or free node.
								;  mov eax,(OBJECT PTR [ebx]).nchildren
								;  .IF al==0 ;node has no children
										  ;unrestricted xchange/ychange...
										  mov eax,(OBJECT PTR [esi]).wwidth ;xgg1:
										  sub eax,g_nmousex
										  mov xchange,eax
										  mov eax,(OBJECT PTR [esi]).height
										  sub eax,g_nmousey
										  mov ychange,eax
										  mov eax,g_nmousex
										  mov (OBJECT PTR [esi]).wwidth,eax
										  mov eax,g_nmousey
										  mov (OBJECT PTR [esi]).height,eax
								;  .ELSE
								;		   ;this restricting of xchange/ychange should only apply to a
								;		   ;wire attached to a ellipse...messes up on rectangeles...
								;		   mov eax,(OBJECT PTR [esi]).nexttype
								;		   cmp ax,0 ;ellipse.
								;		   jne xgg1
								;		 mov eax,(OBJECT PTR [esi]).nendring
								;		 .IF al==1				 ;wire ends on ring1.
								;		   ;note, i'm restricting xchange/ychange so
								;		   ;wire can't be pulled out of ring1...
								;		   ;*NO* can't stop it.
								;		   mov eax,(OBJECT PTR [esi]).wwidth
								;		   sub eax,g_nmousex
								;		   .IF SDWORD PTR eax<=-1 ;2
								;				 mov xchange,-1 ;2
								;		   .ELSEIF SDWORD PTR eax>=1 ;2
								;				 mov xchange,1 ;2
								;		   .ELSE
								;				 mov xchange,eax
								;		   .ENDIF
								;		   mov eax,(OBJECT PTR [esi]).height
								;		   sub eax,g_nmousey
								;		   .IF SDWORD PTR eax<=-1 ;2
								;				 mov ychange,-1 ;2
								;		   .ELSEIF SDWORD PTR eax>=1 ;2
								;				 mov ychange,1 ;2
								;		   .ELSE
								;				 mov ychange,eax
								;		   .ENDIF
								;		   mov eax,(OBJECT PTR [esi]).wwidth
								;		   sub eax,xchange
								;		   mov (OBJECT PTR [esi]).wwidth,eax
								;		   mov eax,(OBJECT PTR [esi]).height
								;		   sub eax,ychange
								;		   mov (OBJECT PTR [esi]).height,eax
								;				  ;now go ahead and snap wires on clones...
								;				  ;ebx -> master node.	esi -> wire.
								;				  mov eax,(OBJECT PTR [esi]).wwidth
								;				  mov ecx,(OBJECT PTR [esi]).height
								;				  ;2nd param =1 means 2nd end of wire...
								;		 .ELSE
								;		   jmp xgg1
								;		 .ENDIF
								;  .ENDIF
								;.ELSE
								;  jmp xgg1
								;.ENDIF

								  ;i've got a problem, parent node not redrawing
								  ;while i'm dragging wire end...
								  mov eax,(OBJECT PTR [esi]).rpowner2	;get parent.
								  add eax,pTERSEDATA   ;cos it's relative.
								  invoke add2updatelist,eax

				  .ELSE
						;only other possible value is 0 ...do nothing.
				  .ENDIF
b12:

		  .ELSE
				;the user is not directly dragging this wire.
				;a parent object is being dragged, pulling this one along...
				;the parent drag_*** method calls updateslaves(), which
				;takes care of adjusting knee2 or knee3 coords of the
				;slave wire.
				;so, do nothing here.
		  .ENDIF

		.ELSEIF g_nstate==4  ;placing 1st end of wire.
		  ;defaultnewwire() set intial values. just update all of them,
		  ;tracking mouse...
		  mov eax,(OBJECT PTR [esi]).xtopleft
		  sub eax,g_nmousex
		  sub (OBJECT PTR [esi]).xtopleft,eax
		  sub (OBJECT PTR [esi]).xknee2,eax
		  sub (OBJECT PTR [esi]).xmid,eax
		  sub (OBJECT PTR [esi]).xknee3,eax
		  sub (OBJECT PTR [esi]).wwidth,eax
				mov eax,(OBJECT PTR [esi]).ytopleft
				sub eax,g_nmousey
				sub (OBJECT PTR [esi]).ytopleft,eax
				sub (OBJECT PTR [esi]).yknee2,eax
				sub (OBJECT PTR [esi]).ymid,eax
				sub (OBJECT PTR [esi]).yknee3,eax
				sub (OBJECT PTR [esi]).height,eax


		.ELSE
		  ret  ;error.
		.ENDIF

		invoke add2updatelist, pmoving

		.IF g_nstate==5
		.ELSEIF g_nstate==4
		.ELSE

		  ;*EVE* um, i think only should do this if dragging middle
		  ;of wire...
		  .IF g_nstate==8
				.IF g_nknee==1 ;middle
				  ;need to locate all slave objects (locked-to this object)
				  ;and add them to updatelist also
				  ;and update their coords...
				  ;(only likely is an attached comment)
				  invoke updateslaves, pmoving, xchange,ychange,0
				  ;invoke clrmovedbit	 ;.status/bit7 set if a wire moved.*EVE*
				.ENDIF
		  .ENDIF
		.ENDIF

out1:	ret
drag_arc ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szpens	 BYTE "Solid",0,0,0,0,0,"Invisible",0,"Dashes",0,0,0,0
		 BYTE "Dots",0,0,0,0,0,0
		 BYTE "Dashdot",0,0,0,"Dashdotdot"
		 BYTE 0
szbrushes BYTE "No fill",0,0,0,"Solid",0,0,0,0,0,"BDiagonal",0,"Cross",0,0,0,0,0
				  BYTE "DiagCross",0,"FDiagonal",0,"HHatch",0,0,0,0,"VHatch",0,0,0,0

.CODE
KENTER5proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on an ellipse
;brings up a dialog box.   "nodeproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG


		invoke comopen_closed_dlgbox,hdlg,message,wparam,lparam,edi


;display gap between rings...
				xor  edx,edx
				mov  eax,(OBJECT PTR [edi]).nringwidth
				  ;v2.13 make sure this is +ve...
				  .IF SDWORD PTR eax<0 ;a user had a bug, using a -ve ring-gap.
					neg eax
					mov (OBJECT PTR [edi]).nringwidth,eax
				  .ENDIF
				invoke bin2signedascii_upload,hdlg,eax,246,4

;display height of ellipse...
;display width of ellipse...
;exact width/height checkbox...
		invoke up_widthheight,hdlg
;				 xor  edx,edx
;				 mov  eax,(OBJECT PTR [edi]).height
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
; invoke SendDlgItemMessage,hdlg,245,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,245,EM_LIMITTEXT,4,0 ;set limit.
;
;;display width of ellipse...
;				 xor  edx,edx
;				 mov  eax,(OBJECT PTR [edi]).wwidth
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
; invoke SendDlgItemMessage,hdlg,244,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,244,EM_LIMITTEXT,4,0 ;set limit.
;
;;v1.27
;;exact width/height checkbox...
;			 mov eax,(OBJECT PTR [edi]).fconfig4
;			 and al,010000b ;bit4.
;			 .IF al==010000b
;				 invoke SendDlgItemMessage,hdlg,310,BM_SETCHECK,1,0
;			 .ENDIF

;display x offset for multiple rings...
				xor  edx,edx
				mov  eax,(OBJECT PTR [edi]).xdeltacentre ;x
				invoke bin2signedascii_upload,hdlg,eax,231,4

;display y offset for multiple rings...
				xor  edx,edx
				mov  eax,(OBJECT PTR [edi]).ydeltacentre
				invoke bin2signedascii_upload,hdlg,eax,232,4

;v1.84
;selectable only on boundary...
			mov eax,(OBJECT PTR [edi]).fconfig1
			and al,010b ;bit1.
			.IF al==010b
				invoke SendDlgItemMessage,hdlg,266,BM_SETCHECK,1,0
			.ENDIF
			
;v2.96
;partial ellipse...
    mov eax,(OBJECT PTR [edi]).fconfig1
    and al,110000b ;bits 5/4.
    .IF al==010000b ;chord.
      mov ecx,225
    .ELSEIF al==100000b ;pie.
      mov ecx,223
    .ELSEIF al==110000b ;arc.
      mov ecx,240
    .ELSE ;ellipse
      mov esi,1
      invoke SendDlgItemMessage,hdlg,256,EM_SETREADONLY,esi,0 ;xstart.
      invoke SendDlgItemMessage,hdlg,257,EM_SETREADONLY,esi,0 ;ystart.
      invoke SendDlgItemMessage,hdlg,258,EM_SETREADONLY,esi,0 ;xend.
      invoke SendDlgItemMessage,hdlg,259,EM_SETREADONLY,esi,0 ;yend.
      mov ecx,241 ;complete ellipse.
    .ENDIF
    invoke SendDlgItemMessage,hdlg,ecx,BM_SETCHECK,1,0
    ;upload radial intersection points...
    ;rxstartarc...
    mov eax,(OBJECT PTR [edi]).rxstartarc
;    imul (OBJECT PTR [edi]).wwidth
;    sar eax,16
    add eax,(OBJECT PTR [edi]).xtopleft
    invoke bin2signedascii_upload,hdlg,eax,256,6
    ;rystartarc...
    mov eax,(OBJECT PTR [edi]).rystartarc
;    imul (OBJECT PTR [edi]).height
;    sar eax,16
    add eax,(OBJECT PTR [edi]).ytopleft
    invoke bin2signedascii_upload,hdlg,eax,257,6
    ;rxendarc...
    mov eax,(OBJECT PTR [edi]).rxendarc
;    imul (OBJECT PTR [edi]).wwidth
;    sar eax,16
    add eax,(OBJECT PTR [edi]).xtopleft
    invoke bin2signedascii_upload,hdlg,eax,258,6
    ;ryendarc...
    mov eax,(OBJECT PTR [edi]).ryendarc
;    imul (OBJECT PTR [edi]).height
;    sar eax,16
    add eax,(OBJECT PTR [edi]).ytopleft
    invoke bin2signedascii_upload,hdlg,eax,259,6

      ;v3.19
      ;master invisibility flag...
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF

      ;upload color morphing...  v3.40
      invoke upload_morphing,hdlg


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;update the database...

;update exact width/height...
;update height of ellipse...
;update width of ellipse...
		invoke down_widthheight,hdlg
;;v1.27
;;update exact width/height...
;	invoke SendDlgItemMessage,hdlg,310,BM_GETCHECK,0,0
;	mov ebx,(OBJECT PTR [edi]).fconfig4
;	.IF ax==1
;	  or bl,010000b ;set bit4.
;	.ELSE
;	  and bl,011101111b ;clr bit4.
;	.ENDIF
;	mov (OBJECT PTR [edi]).fconfig4,ebx
;
;;update height of ellipse...
; invoke SendDlgItemMessage,hdlg,245,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;don't allow -ve number...
;				 .IF SDWORD PTR eax<0
;				   neg eax
;				   jmp SHORT e200
;				 .ELSE
;e200:	   mov	(OBJECT PTR [edi]).height,eax
;				   shr eax,1
;				   add eax,(OBJECT PTR [edi]).ytopleft
;				   mov (OBJECT PTR [edi]).ymid,eax
;				 .ENDIF
;
;;update width of ellipse...
; invoke SendDlgItemMessage,hdlg,244,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;no -ve...
;				 .IF SDWORD PTR eax<0
;				   neg eax
;				   jmp SHORT e201
;				 .ELSE
;e201:	   mov	(OBJECT PTR [edi]).wwidth,eax
;				   shr eax,1
;				   add eax,(OBJECT PTR [edi]).xtopleft
;				   mov (OBJECT PTR [edi]).xmid,eax
;				 .ENDIF


;update ring-gap...
 invoke SendDlgItemMessage,hdlg,246,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				  .IF SDWORD PTR eax<0 ;v2.13
					neg eax
				  .ENDIF
				mov  (OBJECT PTR [edi]).nringwidth,eax

;update x offset for multiple rings...
 invoke SendDlgItemMessage,hdlg,231,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				mov  (OBJECT PTR [edi]).xdeltacentre,eax

;update y offset for multiple rings...
 invoke SendDlgItemMessage,hdlg,232,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				mov  (OBJECT PTR [edi]).ydeltacentre,eax

;get "insert ring (after)"...
   invoke SendDlgItemMessage,hdlg,233,BM_GETCHECK,0,0
   .IF ax==1
		  mov ecx,(OBJECT PTR [edi]).rpowner1
		  mov ebx,(OBJECT PTR [edi]).nrings
		  .IF g_nring>ebx				   ;note, g_nring is the ring right-clicked on.
				;out of range...
jjo:	invoke myalertbox,ADDR szer009,4 ;invoke myerrorhandler,009
						jmp zoono1		;do not end dialog box.
		  .ELSEIF g_nring==0
				;error.
		  .ELSE
				invoke insertring, edi,g_nring
				;...inserts a ring after g_nring, in node edi. moves wires.
				;...returns eax=0 if fail.
		  .ENDIF
   .ENDIF

;get "delete ring#"...
   invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0
   cmp ax,1
   jne by1
; invoke SendDlgItemMessage,hdlg,416,WM_GETTEXT,3,ADDR szasciitbl
; invoke str2longint, ADDR szasciitbl	;-->integer in eax
  mov eax,g_nring
  .IF eax>0
		.IF eax==1
		  invoke myalertbox,ADDR szer010,4 ;invoke myerrorhandler,010
						jmp zoono1		;do not end dialog box.
		.ELSE
		  ;xor ebx,ebx
		  mov ebx,(OBJECT PTR [edi]).nrings
		  .IF eax>ebx
				;out of range...
						invoke myalertbox,ADDR szer009,4 ;invoke myerrorhandler,009
						jmp zoono1		;do not end dialog box.
		  .ELSE
				invoke deletering, edi,eax
				.IF eax==0				;failed.
						invoke myalertbox,ADDR szer008,4 ;invoke myerrorhandler,008
						jmp zoono1		;do not end dialog box.
				.ENDIF
		  .ENDIF
		.ENDIF
  .ENDIF
by1:

;v1.84
;update selectable only on boundary...
   invoke SendDlgItemMessage,hdlg,266,BM_GETCHECK,0,0
   mov ebx,(OBJECT PTR [edi]).fconfig1
   and bl,0FDh ;clr bit1.
   .IF ax==1
	 or bl,010b ;set bit1.
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig1,ebx

    ;v2.96
    ;partial ellipse...
    invoke SendDlgItemMessage,hdlg,241,BM_GETCHECK,0,0
    mov ebx,(OBJECT PTR [edi]).fconfig1
    and bl,11001111b ;clr bits5/4.
    .IF ax == 0 ;not complete ellipse.
      push ebx
      invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
      pop ebx
      .IF ax != 0
        or bl,100000b ;pie.
      .ELSE
        push ebx
        invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0
        pop ebx
        .IF ax != 0
          or bl,010000b ;chord.
        .ELSE
          or bl,110000b ;arc.
        .ENDIF
      .ENDIF
    .ENDIF
    mov (OBJECT PTR [edi]).fconfig1,ebx
    ;update radial intersection points...
    ;rxstartarc...
    invoke SendDlgItemMessage,hdlg,256,WM_GETTEXT,7,ADDR szasciitbl
    invoke str2longint, ADDR szasciitbl ;-->integer in eax
    sub eax,(OBJECT PTR [edi]).xtopleft
;    mov ecx,65536
;    imul ecx
;    idiv (OBJECT PTR [edi]).wwidth
    mov (OBJECT PTR [edi]).rxstartarc,eax
    ;rystartarc...
    invoke SendDlgItemMessage,hdlg,257,WM_GETTEXT,7,ADDR szasciitbl
    invoke str2longint, ADDR szasciitbl ;-->integer in eax
    sub eax,(OBJECT PTR [edi]).ytopleft
;    mov ecx,65536
;    imul ecx
;    idiv (OBJECT PTR [edi]).height
    mov (OBJECT PTR [edi]).rystartarc,eax
    ;rxendarc...
    invoke SendDlgItemMessage,hdlg,258,WM_GETTEXT,7,ADDR szasciitbl
    invoke str2longint, ADDR szasciitbl ;-->integer in eax
    sub eax,(OBJECT PTR [edi]).xtopleft
;    mov ecx,65536
;    imul ecx
;    idiv (OBJECT PTR [edi]).wwidth
    mov (OBJECT PTR [edi]).rxendarc,eax
    ;ryendarc...
    invoke SendDlgItemMessage,hdlg,259,WM_GETTEXT,7,ADDR szasciitbl
    invoke str2longint, ADDR szasciitbl ;-->integer in eax
    sub eax,(OBJECT PTR [edi]).ytopleft
;    mov ecx,65536
;    imul ecx
;    idiv (OBJECT PTR [edi]).height
    mov (OBJECT PTR [edi]).ryendarc,eax

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF

      ;get color morphing... v3.40
      invoke download_morphing,hdlg


;*WARNING* code in here that may invalidate edi, so this must be last...
		invoke comclose_closed_dlgbox,hdlg,message,wparam,lparam,edi
		.IF eax==1
		  jmp noexitdlg
		.ENDIF




		  invoke EndDialog, hdlg,TRUE
noexitdlg:
zoono1:
		  mov eax,TRUE
		.ELSEIF eax==IDCANCEL ;(lo-wparam)
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE



		.ELSEIF eax==233 ;insert a ring (after)
				invoke SendDlgItemMessage,hdlg,233,BM_GETCHECK,0,0 ;insert.
				.IF ax==1
				  invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,0,0 ;clr it.
				.ELSE
				  invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,1,0 ;check it.
				.ENDIF
				invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,0,0 ;clr delete.
				mov eax,TRUE

		.ELSEIF eax==234 ;delete ring.
				invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0 ;delete.
				.IF ax==1
				  invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,0,0 ;clr it.
				.ELSE
				  invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,1,0 ;check it.
				.ENDIF
				invoke SendDlgItemMessage,hdlg,233,BM_SETCHECK,0,0 ;clr insert.
				mov eax,TRUE

		.ELSEIF wparam==217 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,710 ;247 ;247=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==218 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,700 ;220 ;220=id of color-edit-box
		   mov eax,TRUE

    .ELSEIF wparam==241 ;ellipse radial button. v2.96
      ;make the radial intersection points readonly...
      mov esi,1
so1:  invoke SendDlgItemMessage,hdlg,256,EM_SETREADONLY,esi,0 ;xstart.
      invoke SendDlgItemMessage,hdlg,257,EM_SETREADONLY,esi,0 ;ystart.
      invoke SendDlgItemMessage,hdlg,258,EM_SETREADONLY,esi,0 ;xend.
      invoke SendDlgItemMessage,hdlg,259,EM_SETREADONLY,esi,0 ;yend.
      xor eax,eax ;do default processing.
    .ELSEIF wparam==223 ;pie.
      mov esi,0
      jmp so1 ;make not readonly.
    .ELSEIF wparam==225 ;chord.
      mov esi,0
      jmp so1 ;make not readonly.
    .ELSEIF wparam==240 ;arc.
      mov esi,0
      jmp so1 ;make not readonly.

		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE


  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
KENTER5proc ENDP   ;nodeproc --closed-elements.
;--------------------------------------------------------------------------
resproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on a rectangle
;brings up a dialog box.   "resproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG


		invoke comopen_closed_dlgbox,hdlg,message,wparam,lparam,edi

;display height of ellipse...
;display width of ellipse...
;exact width/height checkbox...
		invoke up_widthheight,hdlg
;;display height of ellipse...
;				 xor  edx,edx
;				 mov  eax,(OBJECT PTR [edi]).height
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
; invoke SendDlgItemMessage,hdlg,245,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,245,EM_LIMITTEXT,4,0 ;set limit.
;
;;display width of ellipse...
;				 xor  edx,edx
;				 mov  eax,(OBJECT PTR [edi]).wwidth
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
; invoke SendDlgItemMessage,hdlg,244,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,244,EM_LIMITTEXT,4,0 ;set limit.
;;v1.27
;;exact width/height checkbox...
;			 mov eax,(OBJECT PTR [edi]).fconfig4
;			 and al,010000b ;bit4.
;			 .IF al==010000b
;				 invoke SendDlgItemMessage,hdlg,310,BM_SETCHECK,1,0
;			 .ENDIF

;display corners for rounded rectangles...
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF ax==4  ;rectangle,rounded
				  xor  edx,edx
				  mov  eax,(OBJECT PTR [edi]).ncornerwidth
				  invoke bin2dec,10 			   ;-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  mov esi,eax
				  invoke SendDlgItemMessage,hdlg,211,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,211,EM_LIMITTEXT,4,0 ;set limit.
				  xor  edx,edx
				  mov  eax,(OBJECT PTR [edi]).ncornerheight
				  invoke bin2dec,10 			   ;-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  mov esi,eax
				  invoke SendDlgItemMessage,hdlg,213,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,213,EM_LIMITTEXT,4,0 ;set limit.
				  ;set "rounded rectangle" checkbox...
				  invoke SendDlgItemMessage,hdlg,311,BM_SETCHECK,1,0
				.ELSE
				  ;for normal rectangle, ellipse, grey these fields out...
				  invoke SendDlgItemMessage,hdlg,211,EM_SETREADONLY,1,0
				  invoke SendDlgItemMessage,hdlg,213,EM_SETREADONLY,1,0
				.ENDIF

;v1.84
;selectable only on boundary...
			mov eax,(OBJECT PTR [edi]).fconfig1
			and al,010b ;bit1.
			.IF al==010b
				invoke SendDlgItemMessage,hdlg,266,BM_SETCHECK,1,0
			.ENDIF

      ;v3.19
      ;master invisibility flag...
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF

      ;upload color morphing...  v3.40
      invoke upload_morphing,hdlg
      

		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;update the database...

;update exact width/height...
;update height of ellipse...
;update width of ellipse...
		invoke down_widthheight,hdlg
;;v1.27
;;update exact width/height...
;	invoke SendDlgItemMessage,hdlg,310,BM_GETCHECK,0,0
;	mov ebx,(OBJECT PTR [edi]).fconfig4
;	.IF ax==1
;	  or bl,010000b ;set bit4.
;	.ELSE
;	  and bl,011101111b ;clr bit4.
;	.ENDIF
;	mov (OBJECT PTR [edi]).fconfig4,ebx
;
;;update height of ellipse...
; invoke SendDlgItemMessage,hdlg,245,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;don't allow -ve number...
;				 .IF SDWORD PTR eax<0
;				   neg eax
;				   jmp SHORT e200
;				 .ELSE
;e200:	   mov	(OBJECT PTR [edi]).height,eax
;				   shr eax,1
;				   add eax,(OBJECT PTR [edi]).ytopleft
;				   mov (OBJECT PTR [edi]).ymid,eax
;				 .ENDIF
;
;;update width of ellipse...
; invoke SendDlgItemMessage,hdlg,244,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;no -ve...
;				 .IF SDWORD PTR eax<0
;				   neg eax
;				   jmp SHORT e201
;				 .ELSE
;e201:	   mov	(OBJECT PTR [edi]).wwidth,eax
;				   shr eax,1
;				   add eax,(OBJECT PTR [edi]).xtopleft
;				   mov (OBJECT PTR [edi]).xmid,eax
;				 .ENDIF

;rounded rectangle checkbox...
		  invoke SendDlgItemMessage,hdlg,311,BM_GETCHECK,0,0
		  .IF ax==1
			mov (OBJECT PTR [edi]).nexttype,4
		  .ELSE
			mov (OBJECT PTR [edi]).nexttype,3 ;normal rectangle.
		  .ENDIF
;corner width/height, for rounded rectangle...
		  mov eax,(OBJECT PTR [edi]).nexttype
		  .IF ax==4
				invoke SendDlgItemMessage,hdlg,211,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;no -ve...
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov (OBJECT PTR [edi]).ncornerwidth,eax
				invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;no -ve...
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov (OBJECT PTR [edi]).ncornerheight,eax
		  .ENDIF


;v1.84
;update selectable only on boundary...
   invoke SendDlgItemMessage,hdlg,266,BM_GETCHECK,0,0
   mov ebx,(OBJECT PTR [edi]).fconfig1
   and bl,0FDh ;clr bit1.
   .IF ax==1
	 or bl,010b ;set bit1.
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig1,ebx

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF

      ;get color morphing... v3.40
      invoke download_morphing,hdlg
      

;*WARNING* code in here that may invalidate edi, so this must be last...
		invoke comclose_closed_dlgbox,hdlg,message,wparam,lparam,edi
		.IF eax==1
		  jmp noexitdlg
		.ENDIF




		  invoke EndDialog, hdlg,TRUE
noexitdlg:
zoono1:
		  mov eax,TRUE
		.ELSEIF eax==IDCANCEL ;(lo-wparam)
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE


		.ELSEIF wparam==217 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,710 ;247 ;247=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==218 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,700 ;220 ;220=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==311 ;"rounded rectangle" checkbox.
		  invoke SendDlgItemMessage,hdlg,311,BM_GETCHECK,0,0
		  .IF ax==1
			invoke SendDlgItemMessage,hdlg,211,EM_SETREADONLY,0,0 ;enable.
			invoke SendDlgItemMessage,hdlg,213,EM_SETREADONLY,0,0
		  .ELSE
			;for normal rectangle, ellipse, grey these fields out...
			invoke SendDlgItemMessage,hdlg,211,EM_SETREADONLY,1,0
			invoke SendDlgItemMessage,hdlg,213,EM_SETREADONLY,1,0
		  .ENDIF


		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE


  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
resproc ENDP
;--------------------------------------------------------------------------
upload_morphing PROC STDCALL, hdlg:DWORD ;v3.40
; "upload_morphing"
;enter edi->element.

;morphing width...
				  mov  eax,(OBJECT PTR [edi]).morphingwidth
				  invoke bin2dec,10 			   ;-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  invoke SendDlgItemMessage,hdlg,501,WM_SETTEXT,0,eax
;morphing skew...
          mov eax,(OBJECT PTR [edi]).fconfig0
          and eax,0Fh ;bits 3/2/1/0.
          add eax,502 ;convert to radiobutton id.
				  invoke SendDlgItemMessage,hdlg,eax,BM_SETCHECK,1,0
;light source...     ;v3.39
          mov eax,(OBJECT PTR [edi]).fconfig0
          and eax,0F0h ;bits 7-4.
          shr eax,4
          add eax,511 ;convert to radiobutton id.
				  invoke SendDlgItemMessage,hdlg,eax,BM_SETCHECK,1,0
;light brightness...     ;v3.39
          mov eax,(OBJECT PTR [edi]).fconfig0
          and eax,0F00h ;bits 12-8.
          shr eax,8
          add eax,520 ;convert to radiobutton id. range 520-524.
				  invoke SendDlgItemMessage,hdlg,eax,BM_SETCHECK,1,0

    ret
upload_morphing ENDP
;--------------------------------------------------------------------------
download_morphing PROC STDCALL, hdlg:DWORD ;v3.40
; "download_morphing"
;enter edi->element.

;v3.38
;morphing width...
				invoke SendDlgItemMessage,hdlg,501,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint,ADDR szasciitbl ;-->integer in eax
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov (OBJECT PTR [edi]).morphingwidth,eax
;morphing skew...
        mov esi,502 ;uses id's 502 - 510.
        mov ecx,9
nxtm:   push ecx
        invoke SendDlgItemMessage,hdlg,esi,BM_GETCHECK,0,0
        pop ecx
        .IF ax != 0
          sub esi,502
          and esi,0Fh ;precaution.
          and (OBJECT PTR [edi]).fconfig0,0FFFFFFF0h ;clr bits3-0.
          or (OBJECT PTR [edi]).fconfig0,esi
        .ELSE
          inc esi
          loop nxtm
        .ENDIF
;light source...   v3.39
        mov esi,511 ;uses id's 511 - 515
        mov ecx,5
nxtz:   push ecx
        invoke SendDlgItemMessage,hdlg,esi,BM_GETCHECK,0,0
        pop ecx
        .IF ax != 0
          sub esi,511
          and esi,0Fh ;precaution.
          shl esi,4 ;bits 7-4.
          and (OBJECT PTR [edi]).fconfig0,0FFFFFF0Fh ;clr bits7-4.
          or (OBJECT PTR [edi]).fconfig0,esi
        .ELSE
          inc esi
          loop nxtz
        .ENDIF
;light brightness...   v3.39
        mov esi,520  ;uses id's 520 - 524. v3.40
        mov ecx,5 ;3 v3.40
nxtv:   push ecx
        invoke SendDlgItemMessage,hdlg,esi,BM_GETCHECK,0,0
        pop ecx
        .IF ax != 0
          sub esi,520
          and esi,0Fh ;precaution.
          shl esi,8 ;bits 12-8.
          and (OBJECT PTR [edi]).fconfig0,0FFFFF0FFh ;clr bits12-8.
          or (OBJECT PTR [edi]).fconfig0,esi
        .ELSE
          inc esi
          loop nxtv
        .ENDIF

    ret
download_morphing ENDP
;--------------------------------------------------------------------------
aniproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;WM_RBUTTONDOWN > wmrbuttondown() > on a animation activator.
;brings up a dialog box.   "aniproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

		;when an animation element is created, defaultnewres() calls add2anilist() to
		;enter a ptr into the list. If an animation element is duplicated, it also will
		;have to have its pointer put into the list. do it here, and as a precaution in
		;case its not there for any other reason (it doesn't matter if try to write same
		;ptr more than once)...
		;invoke add2anilist,edi v2.78 no, only do this in paint_ani()!
		;...i've got to be careful that the ptrs don't get invalid. zeroabsluteptrs,1 calls
		;add2anilist,0 to wipe all entries. each paint_ani() reloads list.
		;note, paint_ani()loads it also.

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg
;				 xor  edx,edx
;				 mov  eax,(OBJECT PTR [edi]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
;				invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi
;				invoke SendDlgItemMessage,hdlg,302,EM_LIMITTEXT,5,0 ;set limit.
;
;;display element# of owner...
;				 mov eax,(OBJECT PTR [edi]).rpowner1
;				 .IF eax==0
;				 .ELSE
;				   add eax,pTERSEDATA
;						 mov ebx,eax
;				 mov  eax,(OBJECT PTR [ebx]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
;				   invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,esi
;				 .ENDIF
;				 invoke SendDlgItemMessage,hdlg,399,EM_LIMITTEXT,5,0 ;set limit.
;
;;display lock state...
;				 mov eax,(OBJECT PTR [edi]).fconfig4
;				 and al,01000b
;				 .IF al==1000b	;bit3
;				   invoke SendDlgItemMessage,hdlg,251,BM_SETCHECK,1,0
;				 .ENDIF

;display ring# on parent that action is on...
				mov eax,(OBJECT PTR [edi]).nbeginvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;eax-->asciitbl (10 digits+0)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
 invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,229,EM_LIMITTEXT,2,0 ;set limit.


;jump/smooth back checkboxes...
			mov eax,(OBJECT PTR [edi]).fconfig2
			and eax,1000000000000000110b ;bits18/2/1. ;v3.08
			.IF al==010b ;jump
			  mov ecx,413
			.ELSEIF al==100b ;smooth back.
			  mov ecx,414
			.ELSEIF eax==1000000000000000000b ;no return (bit18 set)   v3.08
			  mov ecx,415
			.ELSE ;let default be smooth back...
			  mov ecx,414
			.ENDIF
			invoke SendDlgItemMessage,hdlg,ecx,BM_SETCHECK,1,0

;display animation time...
				mov  eax,(OBJECT PTR [edi]).anitime
				invoke bin2dec,10				   ;-->szasciitbl
				invoke SendDlgItemMessage,hdlg,410,WM_SETTEXT,0,eax
				invoke SendDlgItemMessage,hdlg,410,EM_LIMITTEXT,3,0 ;set limit.

;this is NOT for label display, it's the animation movements...
;display horizontal and vertical offset...
				mov  eax,(OBJECT PTR [edi]).xlabeloffset ;x
				invoke bin2signedascii_upload,hdlg,eax,408,5
				mov  eax,(OBJECT PTR [edi]).ylabeloffset ;y
				invoke bin2signedascii_upload,hdlg,eax,409,5

;start event checkboxes...
			mov eax,(OBJECT PTR [edi]).fconfig2
			and al,70h ;al,01110000b ;bits6/5/4.
			.IF al==0 ;continuous
			  mov ecx,416
			.ELSEIF al==010000b ;off
			  mov ecx,417
			.ELSEIF al==0100000b ;mouse-over.
			  mov ecx,418
			.ELSEIF al==40h ;mouseon --bits6/5/4 =100.
			  mov ecx,434
			.ELSE ;bits 6/5/4=011
			  mov ecx,419 ;left-button click.
			.ENDIF
			invoke SendDlgItemMessage,hdlg,ecx,BM_SETCHECK,1,0

;v2.71,v2.75 reverse-colors checkbox...
    mov eax,(OBJECT PTR [edi]).fconfig2
    and eax,0600h ;test bit9, flash colors. bit10 one-shot.
    .IF eax==0200h ;bit9
			invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0
		.ELSEIF eax==400h ;bit10
bo1:	invoke SendDlgItemMessage,hdlg,422,BM_SETCHECK,1,0
    .ELSEIF eax==600h ;both	
			invoke SendDlgItemMessage,hdlg,421,BM_SETCHECK,1,0
			jmp bo1
    .ENDIF

;v2.81 more color change options...
    mov eax,(OBJECT PTR [edi]).fconfig2
    and eax,6000h ;test bit13=1 make label visible, bit14=1 child stay inverted.
    .IF eax==2000h ;bit13
			invoke SendDlgItemMessage,hdlg,426,BM_SETCHECK,1,0
    .ELSEIF eax==4000h ;bit14.
bo2:	invoke SendDlgItemMessage,hdlg,427,BM_SETCHECK,1,0	
		.ELSEIF eax==6000h ;both	
			invoke SendDlgItemMessage,hdlg,426,BM_SETCHECK,1,0
			jmp bo2
    .ENDIF

;v2.82 mouseover finger cursor...
    mov eax,(OBJECT PTR [edi]).fconfig2
    and eax,10000h ;bit16
    .IF eax != 0
			invoke SendDlgItemMessage,hdlg,429,BM_SETCHECK,1,0
    .ENDIF

;v3.09 "animate boss" checkbox...
    mov eax,(OBJECT PTR [edi]).fconfig2
    and eax,80000h ;bit19
    .IF eax != 0
			invoke SendDlgItemMessage,hdlg,430,BM_SETCHECK,1,0
    .ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;update the database...

;update lock state...
		invoke down_lock,hdlg
;		   invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
;		   .IF ax==1
;				 or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
;		   .ELSE
;				 and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
;		   .ENDIF

;update number of object that owns this node ...
; invoke SendDlgItemMessage,hdlg,399,WM_GETTEXT,6,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;special case 0, none owns me...
;				 ;(there is an element #0, but can't be an owner).
;				 .IF eax==0
;				   mov (OBJECT PTR [edi]).nbeginvertice,0 ;which vertice attached to if poly.
;				   jmp e206
;				 .ENDIF
;				 mov ebx,pTERSEDATA
;				   ;validate...
;				   ;xor ecx,ecx
;				   mov ecx,(TERSEDATA PTR [ebx]).numrecords
;				   .IF eax>=ecx
;						 ;off end of database...
;e202:				 invoke myerrorhandler,11
;					 jmp noexitdlg
;				   .ENDIF
;				 ;xor ecx,ecx
;				 mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
;				 mul ecx
;				   mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   add eax,edx			  ;eax->owner.
;				   mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).fstatus
;						 and ecx,01
;						 .IF ecx==0
;						   ;invalid element...
;						   jmp e202
;						 .ELSE
;						   mov ecx,(OBJECT PTR [ebx]).nexttype
;						   .IF SWORD PTR cx<0 ;ecx==-1
;								 ;this is an invisible element.
;								 jmp e202
;						   .ENDIF
;						 .ENDIF
;				 sub eax,pTERSEDATA
;e206:
;				 mov  (OBJECT PTR [edi]).rpowner1,eax
		invoke down_owner,hdlg,399,0
		or eax,eax ;cmp eax,0
		je noexitdlg

		;update ring# on parent that label is set to...must be after get-owner.
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax==0
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginvertice,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,229,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				add ebx,pTERSEDATA				
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginvertice,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginvertice,0
byp1:     ;bypass.								
		  .ENDIF


;update jump/smooth back...
   invoke SendDlgItemMessage,hdlg,413,BM_GETCHECK,0,0
   mov ebx,(OBJECT PTR [edi]).fconfig2
   and ebx,0FFFBFFF9h ;clr bits18/2/1.
   .IF ax==1
	   or bl,010b ;set bit1. jump back.
   .ELSE
     invoke SendDlgItemMessage,hdlg,414,BM_GETCHECK,0,0
     .IF ax==1
	     or bl,0100b ;set bit2. smooth back.
	   .ELSE
	     or ebx,40000h ;set bit18. no return.  v3.08
	   .ENDIF
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig2,ebx

;update start event...
   invoke SendDlgItemMessage,hdlg,416,BM_GETCHECK,0,0 ;continuous.
   mov ebx,(OBJECT PTR [edi]).fconfig2
   and bx,0FE8Fh ;clr bits8/6/5/4.
   .IF ax==1
	   ;set no bit.
   .ELSE
	   or bx,0100h ;set bit8. disable animation (used by xtimer()).
	   push ebx
	   invoke SendDlgItemMessage,hdlg,417,BM_GETCHECK,0,0 ;off.
	   pop ebx
	   .IF ax==1
	     or bl,010000b ;set bit4.
	   .ELSE
	     push ebx
	     invoke SendDlgItemMessage,hdlg,418,BM_GETCHECK,0,0 ;mouse-over.
	     pop ebx
	     .IF ax==1
		     or bl,0100000b ;set bit5.
	     .ELSE
	       push ebx
	       invoke SendDlgItemMessage,hdlg,419,BM_GETCHECK,0,0 ;mouse-click.
	       pop ebx
	       .IF ax==1
		       or bl,0110000b ;set bits5/4. left button click.
		     .ELSE    ;id=434. mouseon checkbox.
		       or bl,40h ;set bit6. mouseon.  v3.16
		     .ENDIF
	     .ENDIF
	   .ENDIF
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig2,ebx


;this is NOT for label display, it's the animation movements...
;get move x/y offset...
 invoke SendDlgItemMessage,hdlg,408,WM_GETTEXT,6,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				mov  (OBJECT PTR [edi]).xlabeloffset,eax				;x offset
 invoke SendDlgItemMessage,hdlg,409,WM_GETTEXT,6,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				mov  (OBJECT PTR [edi]).ylabeloffset,eax ;y offset

;update animation time...
	 invoke SendDlgItemMessage,hdlg,410,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;don't allow -ve number...
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov (OBJECT PTR [edi]).anitime,eax

;calc x/y move per each second...  (must follow update anitime)
				mov ecx,(OBJECT PTR [edi]).anitime ;seconds.
				.IF ecx==0
				  ;v2.83 zero time now to mean jump instantly to other end...
					mov (OBJECT PTR [edi]).maxcntani,1 ;# moves in each direction.
				  mov eax,(OBJECT PTR [edi]).xlabeloffset 			   ;x offset
				  mov (OBJECT PTR [edi]).xdeltacentre,eax ;x distance of each move.
				  mov eax,(OBJECT PTR [edi]).ylabeloffset 			   ;x offset
				  mov (OBJECT PTR [edi]).ydeltacentre,eax ;y distance of each move.
				  jmp noani
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).fconfig2
				and bl,0110b ;bits2/1.
				.IF bl==0100b ;smooth back.
				  shr ecx,1 ;need to halve time, as increments backwards also.
				.ENDIF
				.IF ecx==0
				  mov ecx,1
				.ENDIF
				  ;v3.16 calc .maxcntani here...
				  mov eax,ecx
				  shl eax,1 ;*4 cos steps every 1/4 second.
				  shl eax,1 ;/
				  mov (OBJECT PTR [edi]).maxcntani,eax
				mov eax,(OBJECT PTR [edi]).xlabeloffset 			   ;x offset
				cdq ;sign-extend into edx.
				idiv ecx  ;x-change per second
				.IF SDWORD PTR eax>0
				  sar eax,1
				  sar eax,1 ;now have change per 1/4 sec.
				  .IF eax==0
					mov eax,1
				  .ENDIF
				.ELSEIF SDWORD PTR eax<0
				  sar eax,1
				  sar eax,1 ;now have change per 1/4 sec.
				  .IF eax==0
					mov eax,-1
				  .ENDIF
				.ENDIF
				mov (OBJECT PTR [edi]).xdeltacentre,eax ;save for xtimer() to access.
				  ;v3.16 let's base maxcntani purely on time...(see above)
				  ;;need # moves in each direction...
				  ;.IF eax==0
				  ;.ELSE
					;push ecx
					;mov ecx,eax
					;mov eax,(OBJECT PTR [edi]).xlabeloffset
					;cdq
					;idiv ecx ;should be +ve answer.
					;pop ecx
				  ;.ENDIF
				  ;mov (OBJECT PTR [edi]).maxcntani,eax
				mov eax,(OBJECT PTR [edi]).ylabeloffset 			   ;y offset
				cdq
				idiv ecx  ;y-change per second
				.IF SDWORD PTR eax>0
				  sar eax,1
				  sar eax,1 ;now have change per 1/4 sec.
				  .IF eax==0
					mov eax,1
				  .ENDIF
				.ELSEIF SDWORD PTR eax<0
				  sar eax,1
				  sar eax,1 ;now have change per 1/4 sec.
				  .IF eax==0
					mov eax,-1
				  .ENDIF
				.ENDIF
				mov (OBJECT PTR [edi]).ydeltacentre,eax ;save for xtimer() to access.
				  ;need # moves in each direction...verify above...
				  .IF eax==0
				  .ELSE
					mov ecx,eax
					mov eax,(OBJECT PTR [edi]).ylabeloffset
					cdq
					idiv ecx ;should be +ve answer.
				  .ENDIF
				  ;v3.16 now base maxcntani purely on time... (see above)
				  ;mov edx,(OBJECT PTR [edi]).maxcntani
				  ;.IF eax>edx  ;store biggest value...
					;mov (OBJECT PTR [edi]).maxcntani,eax
				  ;.ENDIF
				  				
				    ;v3.14 want to record error in destination, maybe correct it in xtimer()...
				    mov eax,(OBJECT PTR [edi]).maxcntani
				    push eax
				    mov ecx,(OBJECT PTR [edi]).xdeltacentre ;size of each step.
				    imul ecx ;*maxcntani -> total x change.
				    mov ecx,(OBJECT PTR [edi]).xlabeloffset ;total reqd x change.
				    sub ecx,eax ;x error.
				    mov (OBJECT PTR [edi]).xenderror,ecx
				    pop eax
				    mov ecx,(OBJECT PTR [edi]).ydeltacentre ;size of each step.
				    imul ecx ;*maxcntani -> total y change.
				    mov ecx,(OBJECT PTR [edi]).ylabeloffset ;total reqd y change.
				    sub ecx,eax ;y error.
				    mov (OBJECT PTR [edi]).yenderror,ecx
								
noani:    ;bypass

;v2.71 get reverse-colors flag...
    invoke SendDlgItemMessage,hdlg,421,BM_GETCHECK,0,0
    .IF ax==1
      or (OBJECT PTR [edi]).fconfig2,0200h ;set bit9.
    .ELSE
      and (OBJECT PTR [edi]).fconfig2,0FFFFFDFFh ;clr bit9.
    .ENDIF

;v2.75 get one-shot colors flag...
    invoke SendDlgItemMessage,hdlg,422,BM_GETCHECK,0,0
    .IF ax==1
      or (OBJECT PTR [edi]).fconfig2,0400h ;set bit10.
    .ELSE
      and (OBJECT PTR [edi]).fconfig2,0FFFFFBFFh ;clr bit10.
    .ENDIF

;v2.81 make label visible...
    invoke SendDlgItemMessage,hdlg,426,BM_GETCHECK,0,0
    .IF ax==1
      or (OBJECT PTR [edi]).fconfig2,02000h ;set bit13.
    .ELSE
      and (OBJECT PTR [edi]).fconfig2,0FFFFDFFFh ;clr bit13.
    .ENDIF
;v2.81 children stay inverted...
    invoke SendDlgItemMessage,hdlg,427,BM_GETCHECK,0,0
    .IF ax==1
      or (OBJECT PTR [edi]).fconfig2,04000h ;set bit14.
    .ELSE
      and (OBJECT PTR [edi]).fconfig2,0FFFFBFFFh ;clr bit14.
    .ENDIF

;v2.82 mouseover finger cursor...
    invoke SendDlgItemMessage,hdlg,429,BM_GETCHECK,0,0
    .IF ax==1
      or (OBJECT PTR [edi]).fconfig2,10000h ;set bit16.
    .ELSE
      and (OBJECT PTR [edi]).fconfig2,0FFFEFFFFh ;clr bit16.
    .ENDIF

    ;v3.08 "animate boss" checkbox...
    invoke SendDlgItemMessage,hdlg,430,BM_GETCHECK,0,0
    mov ebx,(OBJECT PTR [edi]).fconfig2
    and ebx,0FFF7FFFFh ;clr bit19.
    .IF ax==1
      or ebx,80000h ;set bit19.
    .ENDIF
    mov (OBJECT PTR [edi]).fconfig2,ebx

;*WARNING* these must be last, as can invalidate the ptr edi...
;;bring the element to the front...
;		   invoke SendDlgItemMessage,hdlg,214,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,1 ;relocate at end of database.
;				 jmp j66
;		   .ENDIF
;;send the element to the back...
;		   invoke SendDlgItemMessage,hdlg,207,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,2 ;0 ;relocate at start of database.
;		   .ENDIF
;j66:	   ;...move1object returns address new object location in eax.
		invoke down_sendbackfront,hdlg,214,207


		  invoke EndDialog, hdlg,TRUE
noexitdlg:
zoono1:
		  mov eax,TRUE
		.ELSEIF eax==IDCANCEL ;(lo-wparam)
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE

		.ELSEIF eax==429 ;hand cursor checkbox. (BS_CHECKBOX)
				invoke SendDlgItemMessage,hdlg,429,BM_GETCHECK,0,0
				.IF ax==1
				  invoke SendDlgItemMessage,hdlg,429,BM_SETCHECK,0,0 ;clr it.
				.ELSE
		      ;only allowed to tick if mouseover radiobutton selected...
			    invoke SendDlgItemMessage,hdlg,418,BM_GETCHECK,0,0 ;mouseover
			    .IF ax==1
				    jmp SHORT chk1 ;invoke SendDlgItemMessage,hdlg,429,BM_SETCHECK,1,0 ;check it.
		      .ENDIF
		      ;v3.16 also for mouseon...
			    invoke SendDlgItemMessage,hdlg,434,BM_GETCHECK,0,0 ;mouseon.
			    .IF ax==1
				    jmp SHORT chk1 ;check it.
		      .ENDIF
		      ;v3.08 also for mouse-click...
			    invoke SendDlgItemMessage,hdlg,419,BM_GETCHECK,0,0 ;mouseclick.
			    .IF ax==1
chk1:		    invoke SendDlgItemMessage,hdlg,429,BM_SETCHECK,1,0 ;check it.
		      .ENDIF
				.ENDIF
				mov eax,TRUE

    ;for any event selections other than mouseover/click/on, turn off hand-cursor checkbox...
		.ELSEIF eax==416 ;event: continuous
cl1:  invoke SendDlgItemMessage,hdlg,429,BM_SETCHECK,0,0 ;clr it.
		  xor eax,eax ;flag do default processing.
		.ELSEIF eax==417 ;event: off
		  jmp cl1


		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE


  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
aniproc ENDP
;--------------------------------------------------------------------------
bin2signedascii_upload PROC STDCALL USES ebx ecx edx esi edi, \
				hdlg:DWORD,nvalue:DWORD,box_id:DWORD,sizelimit:DWORD
				LOCAL dummy:DWORD
; "bin2signedascii_upload"
;converts a signed binary number to ascii with leading "-" if
;required, and uploads to an edit-box in a dialog-box.

				mov eax,nvalue
				;value to be displayed is in eax...
				.IF SDWORD PTR eax>=0	;+ve
				  invoke bin2dec,10 			   ;eax-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  mov esi,eax
				.ELSE					;-ve
				  neg eax
				  invoke bin2dec,10 			   ;eax-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  mov esi,eax
				  dec  esi
				  mov  [esi],BYTE PTR "-"
				.ENDIF
				;...esi now points to ascii string.

			  .IF hdlg != 0
				invoke SendDlgItemMessage,hdlg,box_id,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,box_id,EM_LIMITTEXT,sizelimit,0 ;set limit.
			  .ENDIF

		mov eax,esi ;return address of string.
		ret
bin2signedascii_upload ENDP
;--------------------------------------------------------------------------
uploadcorners PROC STDCALL USES ebx ecx edx esi edi,hdlg:DWORD,pobj:DWORD
		LOCAL dummy:DWORD
;v2.05
;NCORNERSMAX14 =14, applies to old pre-v2.01 poly elements.

		mov edi,pobj

				lea ebx,(OBJECT PTR [edi]).bez0x
				mov esi,600 ;vertice id's.
				mov ecx,NCORNERSMAX14*2 ;=14*2 ;9*2 v1.11, now have 14 corners.
g11:			mov eax,[ebx]
				invoke bin2signedascii_upload,hdlg,eax,esi,6
				add ebx,4
				inc esi
				loop g11

		mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		.IF eax==0 ;no more vertices.
		.ELSE
		  mov esi,eax
		  add esi,pTERSEDATA
		  lea ebx,(OBJECT PTR [esi]).sztext
		  mov esi,628 ;vertice id's.
		  mov ecx,28*2 ;28 extra vertices in the data-element.
xg11:			mov eax,[ebx]
				  ;vertices are stored relative to bez0x/y...
				  mov dl,cl
				  and dl,01 ;test bit0.
				  .IF dl==0
					add eax,(OBJECT PTR [edi]).bez0x
				  .ELSE
					add eax,(OBJECT PTR [edi]).bez0y
				  .ENDIF
				invoke bin2signedascii_upload,hdlg,eax,esi,6
				add ebx,4
				inc esi
				loop xg11
		.ENDIF

		ret
uploadcorners ENDP
;--------------------------------------------------------------------------
downloadcorners PROC STDCALL USES ebx ecx edx esi edi,hdlg:DWORD,pobj:DWORD
		LOCAL dummy:DWORD
		mov edi,pobj

				lea ebx,(OBJECT PTR [edi]).bez0x
				mov esi,600 ;vertice id's.
				mov ecx,NCORNERSMAX14*2
g11:			pushad
				invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl
				popad
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				mov [ebx],eax
				add ebx,4
				inc esi
				loop g11

		mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		.IF eax==0 ;no more vertices.
		.ELSE
		  mov esi,eax
		  add esi,pTERSEDATA
		  lea ebx,(OBJECT PTR [esi]).sztext
		  mov esi,628 ;vertice id's.
		  mov ecx,28*2 ;28 extra vertices in the data-element.
xg11:			  pushad
				  invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl
				  popad
				  invoke str2longint, ADDR szasciitbl ;-->integer in eax
				  ;vertices are stored relative to bez0x/y...
				  mov dl,cl
				  and dl,01 ;test bit0.
				  .IF dl==0
					sub eax,(OBJECT PTR [edi]).bez0x
				  .ELSE
					sub eax,(OBJECT PTR [edi]).bez0y
				  .ENDIF
				mov [ebx],eax
				add ebx,4
				inc esi
				loop xg11
		.ENDIF

		ret
downloadcorners ENDP
;--------------------------------------------------------------------------
.DATA
finsert BYTE 0
;fnoexit BYTE 0
;cornerids DWORD 219,222,224,225,229,230,232,233,235,237,241,242
;				   DWORD 244,245,248,249,256,257
;				   DWORD 262,263,265,266,268,269,271,272,274,275  ;extra vertices with v1.11.
  BYTE 0,0,0

.CODE
polyproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL temp1:DWORD,numinsert0:DWORD,numinsert:BYTE,freadonly:BYTE
		;LOCAL varray[84]:SDWORD
;WM_RBUTTONDOWN > wmrbuttondown() > on a polygon
;brings up a dialog box.   "polyproc"

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG

		invoke comopen_closed_dlgbox,hdlg,message,wparam,lparam,edi

;display corners (vertices)...
				invoke uploadcorners,hdlg,edi

;display # corners...(read only)
				mov  eax,(OBJECT PTR [edi]).ncorners
				invoke setcornersreadonly,hdlg,eax

;open or closed polygon...
		  mov eax,(OBJECT PTR [edi]).fconfig4
		  and al,011b ;bits1/0.
		  .IF al==01
			mov ebx,258  ;open segmented.
		  .ELSEIF al==11b
			mov ebx,276 ;open bezier segments polyline.
		  .ELSE
			mov ebx,223  ;polygon.
		  .ENDIF
		  invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0

;v3.03 selectable only on vertices...
			mov eax,(OBJECT PTR [edi]).fconfig1
			and al,010b ;bit1.
			.IF al == 0 ;bit1=0 if checkbox set!
				invoke SendDlgItemMessage,hdlg,267,BM_SETCHECK,1,0
			.ENDIF

      ;v3.19
      ;master invisibility flag...
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		mov eax,wparam
		.IF eax==IDOK
		  mov finsert,0
		  mov  g_fhaschanged,1

;update the database...

;get the corners...
				invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,3,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				mov (OBJECT PTR [edi]).ncorners,eax
;save them...
		  invoke downloadcorners,hdlg,edi

;open or closed...
		  invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0 ;closed polygon.
		  and (OBJECT PTR [edi]).fconfig4,0FFFFFFFCh ;clr bits1/0.
		  .IF ax==1 ;closed.
		  .ELSE
			invoke SendDlgItemMessage,hdlg,276,BM_GETCHECK,0,0 ;bezier polyline.
			.IF ax==1
				or (OBJECT PTR [edi]).fconfig4,011b ;set bits1/0.
			.ELSE
				or (OBJECT PTR [edi]).fconfig4,01 ;set bit0. segmented polyline.
			.ENDIF
		  .ENDIF

;v3.03 update selectable only on vertices...
   invoke SendDlgItemMessage,hdlg,267,BM_GETCHECK,0,0
   mov ebx,(OBJECT PTR [edi]).fconfig1
   or bl,010b ;set bit1.
   .IF ax==1
     and bl,0FDh ;clr bit1 if checkbox ticked!
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig1,ebx

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF


;*WARNING* code in here can invalidate ptr edi, so must be last...
		  invoke comclose_closed_dlgbox,hdlg,message,wparam,lparam,edi
		  .IF eax==1
				jmp noexitdlg
		  .ENDIF




		  invoke EndDialog, hdlg,TRUE
noexitdlg:
zoono1:
		  mov eax,TRUE
		.ELSEIF eax==IDCANCEL ;(lo-wparam)
		  mov finsert,0
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE


		.ELSEIF wparam==217 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,710 ;247 ;247=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==218 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,700 ;220 ;220=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==276 ;bezier polyline.
		  ;need to restrict #vertices to 4,7,10,13...
		  invoke SendDlgItemMessage,hdlg,276,BM_GETCHECK,0,0 ;bezier polyline.
		  .IF ax==1
			;get #vertices...
			invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,3,ADDR szasciitbl
			invoke str2longint, ADDR szasciitbl ;-->integer in eax
			invoke setcornersreadonly,hdlg,eax
		  .ENDIF
		  xor eax,eax ;false. normal processing for checkbox.

		.ELSEIF wparam==342 ;insert a vertice.
		  mov finsert,1 ;global.

		.ELSEIF wparam==343 ;delete a vertice.
		  mov finsert,2 ;global.

		.ELSEIF wparam<=542 ;vertice buttons.
		  .IF wparam>=502
			.IF finsert==0
			  mov eax,wparam
			  sub eax,500 ;convert to number of vertices selected.
yu2:		  mov finsert,0 ;v2.11.
			  invoke setcornersreadonly,hdlg,eax
			.ELSE
			  ;"insert" or "delete" button has just been pressed...
				;v2.11
				;bezier, must insert mult.3, plus 1, vertices...
				mov numinsert,1
				mov numinsert0,1
				mov eax,(OBJECT PTR [edi]).fconfig4
				and al,011b ;bits1/0.
				.IF al==11b ;bezier polyline.
				  mov numinsert,3
				  mov numinsert0,3
				.ENDIF
yu5:		  dec numinsert
			  mov eax,wparam
			  sub eax,500 ;#vertice.
			  dec eax
			  shl eax,1 ;*2.
			  add eax,600 ;id's start.
			  mov esi,eax ;this is the one to be inserted/deleted.
			  .IF finsert==1 ;insert.
				mov ecx,542 ;max #vertices+500.
				sub ecx,wparam
				inc ecx
				mov esi,683
xyu1:			push ecx
				invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl ;y
				mov eax,esi
				add eax,2
				.IF eax<=683
				  invoke SendDlgItemMessage,hdlg,eax,WM_SETTEXT,6,ADDR szasciitbl
				.ENDIF
				dec esi
				invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl ;x
				mov eax,esi
				add eax,2
				.IF eax<=683
				  invoke SendDlgItemMessage,hdlg,eax,WM_SETTEXT,6,ADDR szasciitbl
				.ENDIF
				dec esi
				pop ecx
				loop xyu1
					;i would like new vertice to be midway between its neighbours...
					invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl ;y
					invoke str2longint, ADDR szasciitbl ;-->integer in eax
					mov temp1,eax
					mov eax,esi
					add eax,2
					invoke SendDlgItemMessage,hdlg,eax,WM_GETTEXT,7,ADDR szasciitbl ;y
					invoke str2longint, ADDR szasciitbl ;-->integer in eax
					sub eax,temp1
					sar eax,1
					add temp1,eax
					mov eax,esi
					add eax,2
					invoke bin2signedascii_upload,hdlg,temp1,eax,6
					  ;ditto for x...
					  dec esi
					  invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,7,ADDR szasciitbl ;x
					  invoke str2longint, ADDR szasciitbl ;-->integer in eax
					  mov temp1,eax
					  mov eax,esi
					  add eax,2
					  invoke SendDlgItemMessage,hdlg,eax,WM_GETTEXT,7,ADDR szasciitbl ;x
					  invoke str2longint, ADDR szasciitbl ;-->integer in eax
					  sub eax,temp1
					  sar eax,1
					  add temp1,eax
					  mov eax,esi
					  add eax,2
					  invoke bin2signedascii_upload,hdlg,temp1,eax,6
						.IF numinsert>0 ;v2.11.
						  jmp yu5
						.ENDIF
				  ;increase # corners by 1...
				  invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,3,ADDR szasciitbl
				  invoke str2longint, ADDR szasciitbl ;-->integer in eax
				  add eax,numinsert0 ;inc eax
				  jmp yu2
			  .ELSE ;=2 delete.
				mov ecx,542 ;max #vertices+500.
				sub ecx,wparam
yu1:			push ecx
				mov eax,esi
				add eax,2
				invoke SendDlgItemMessage,hdlg,eax,WM_GETTEXT,7,ADDR szasciitbl ;x
				invoke SendDlgItemMessage,hdlg,esi,WM_SETTEXT,6,ADDR szasciitbl
				inc esi
				mov eax,esi
				add eax,2
				invoke SendDlgItemMessage,hdlg,eax,WM_GETTEXT,7,ADDR szasciitbl ;y
				invoke SendDlgItemMessage,hdlg,esi,WM_SETTEXT,6,ADDR szasciitbl
				inc esi
				pop ecx
				loop yu1
						.IF numinsert>0 ;v2.11.
						  jmp yu5
						.ENDIF
				  ;reduce # corners by 1...
				  invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,3,ADDR szasciitbl
				  invoke str2longint, ADDR szasciitbl ;-->integer in eax
				  sub eax,numinsert0 ;dec eax
				  jmp yu2
			  .ENDIF

			.ENDIF
			mov eax,TRUE
		  .ELSE
			mov eax,FALSE
		  .ENDIF



		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE


  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
polyproc				ENDP
;--------------------------------------------------------------------------
setcornersreadonly PROC STDCALL USES ebx ecx edx esi edi,hdlg:DWORD,numpts:DWORD
	LOCAL fnopts:BYTE
;v2.05 "setcornersreadonly"
;MUST ENTER with edi->poly element.

		;make sure can't go over 14 vertices limit for old polys...
		mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		.IF eax==0 ;no more vertices.
		  .IF numpts>14
			mov numpts,14
		  .ENDIF
		.ENDIF

		  invoke SendDlgItemMessage,hdlg,276,BM_GETCHECK,0,0 ;bezier polyline.
		  .IF ax==1
			;numpts must be a multiple of 3, plus 1, and minimum of 4...
			mov eax,numpts
			.IF eax<4
			  mov eax,4
			  mov numpts,eax
			.ENDIF
			dec eax
			mov ecx,3
			xor edx,edx
			div ecx
			;...remainder in edx. use to reduce #vertices...
			sub numpts,edx
		  .ENDIF

		  mov edx,numpts
		  shl edx,1
		  ;mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		  ;.IF eax==0 ;no more vertices.
		  ;  mov ecx,NCORNERSMAX14*2 ;=14*2
		  ;.ELSE
			mov ecx,42*2 ;42 vertices max.
		  ;.ENDIF
		  mov eax,600 ;vertice id's.
n10:	  .IF edx>0
			mov esi,0
			dec edx
		  .ELSE
			mov esi,1 ;=1 set readonly.
		  .ENDIF
		  pushad
		  invoke SendDlgItemMessage,hdlg,eax,EM_SETREADONLY,esi,0
		  popad
		  inc eax
		  loop n10

				;display # corners...(read only)
				mov  eax,numpts
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,213,WM_SETTEXT,0,esi

		ret
setcornersreadonly ENDP
;--------------------------------------------------------------------------

comopen_closed_dlgbox PROC STDCALL USES ebx ecx edx edi esi,hdlg:DWORD, \
				 message:DWORD,wparam:DWORD,lparam:DWORD,pobj:DWORD
		LOCAL dummy:DWORD
; "comopen_closed_dlgbox"
;nodeproc(),resproc(),polyproc() closed-element dlg box callbacks use
;this common code for displaying parameters.
		mov edi,pobj

;set the "display label" checkbox...
				;xor eax,eax
				mov eax,(OBJECT PTR [edi]).fstatus
				;bit5 = display label on diagram
				test  al,00100000b		  ;test bit5
				jz ke21
				invoke SendDlgItemMessage,hdlg,230,BM_SETCHECK,1,0
ke21:

;display fill color...
				mov  eax,(OBJECT PTR [edi]).nfillcolor
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
; invoke SendDlgItemMessage,hdlg,220,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,220,EM_LIMITTEXT,9,0 ;set limit.
      invoke upload_rgbcolor,hdlg,eax,700 ;700=id red.

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg
;				 mov  eax,(OBJECT PTR [edi]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,eax
; invoke SendDlgItemMessage,hdlg,302,EM_LIMITTEXT,5,0 ;set limit.
;
;;display element# of owner...
;				 mov eax,(OBJECT PTR [edi]).rpowner1
;				 .IF eax==0
;				 .ELSE
;				   add eax,pTERSEDATA
;						 mov ebx,eax
;				 mov  eax,(OBJECT PTR [ebx]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
;				   invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,esi
;				 .ENDIF
;				 invoke SendDlgItemMessage,hdlg,399,EM_LIMITTEXT,5,0 ;set limit.


;display pen style in listbox...
		mov ecx,6 ;v1.30 4
		lea esi,szpens
exxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 exximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,236,CB_ADDSTRING,0,esi
		pop ecx
		add esi,10
		loop exxhmmzz
exximmzz:
		mov eax,(OBJECT PTR [edi]).npenstyle
		invoke SendDlgItemMessage,hdlg,236,CB_SETCURSEL,eax,0

;display pen color...
				mov  eax,(OBJECT PTR [edi]).npencolor
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
; invoke SendDlgItemMessage,hdlg,247,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,247,EM_LIMITTEXT,9,0 ;set limit.
      invoke upload_rgbcolor,hdlg,eax,710 ;710=id red.


;display pen width...
				mov  eax,(OBJECT PTR [edi]).npenwidth
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,227,EM_LIMITTEXT,2,0 ;set limit.

;display brush style in listbox...
		mov ecx,8
		lea esi,szbrushes
kxxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 kxximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,252,CB_ADDSTRING,0,esi
		pop ecx
		add esi,10
		loop kxxhmmzz
kxximmzz:
		mov eax,(OBJECT PTR [edi]).nfillstyle
		invoke SendDlgItemMessage,hdlg,252,CB_SETCURSEL,eax,0


;display parent ring# that line attaches to...
				mov eax,(OBJECT PTR [edi]).nbeginvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi

;;display lock state...
;				 mov eax,(OBJECT PTR [edi]).fconfig4
;				 and al,01000b
;				 .IF al==1000b	;bit3
;				   invoke SendDlgItemMessage,hdlg,251,BM_SETCHECK,1,0
;				 .ENDIF

		ret
comopen_closed_dlgbox ENDP
;--------------------------------------------------------------------------
comclose_closed_dlgbox PROC STDCALL USES ebx ecx edx edi esi,hdlg:DWORD, \
				 message:DWORD,wparam:DWORD,lparam:DWORD,pobj:DWORD
		LOCAL dummy:DWORD
; "comclose_closed_dlgbox"
;nodeproc(),resproc(),polyproc() closed-element dlg box callbacks use
;this common code for getting parameters from the dlgbox.
;returns eax=0 ok, =1 don't exit dialog box.
		mov edi,pobj


 invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0
				mov ebx,(OBJECT PTR [edi]).fstatus
				.IF ax==1				;dispaly-label button is checked.
				  or  bl,00100000b
				.ELSE
				  and bl,11011111b
				.ENDIF
				mov (OBJECT PTR [edi]).fstatus,ebx ;bl

;update number of object that owns this node ...
; invoke SendDlgItemMessage,hdlg,399,WM_GETTEXT,6,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;special case 0, none owns me...
;				 ;(there is an element #0, but can't be an owner).
;				 .IF eax==0
;				   mov (OBJECT PTR [edi]).nbeginvertice,0 ;which vertice attached to if poly.
;				   jmp e206
;				 .ENDIF
;				 mov ebx,pTERSEDATA
;				   ;validate...
;				   ;xor ecx,ecx
;				   mov ecx,(TERSEDATA PTR [ebx]).numrecords
;				   .IF eax>=ecx
;						 ;off end of database...
;e202:
;					 invoke myerrorhandler,11
;					 jmp noexitdlg
;				   .ENDIF
;				 ;xor ecx,ecx
;				 mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
;				 mul ecx
;;				 lea edx,(TERSEDATA PTR [ebx]).OBJECTS
;				   mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   add eax,edx			  ;eax->owner.
;				   mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).fstatus
;						 and ecx,01
;						 .IF ecx==0
;						   ;invalid element...
;						   jmp e202
;						 .ELSE
;						   mov ecx,(OBJECT PTR [ebx]).nexttype
;						   .IF SWORD PTR cx<0 ;ecx==-1
;								 ;this is an invisible element.
;								 jmp e202
;						   .ENDIF
;						 .ENDIF
;				 sub eax,pTERSEDATA
;e206:
;;				  mov ecx,(OBJECT PTR [edi]).rpowner1
;;				  .IF eax != ecx
;;					invoke updaterpmaster,eax,edi
;;				  .ENDIF
;				 mov  (OBJECT PTR [edi]).rpowner1,eax
		invoke down_owner,hdlg,399,0
		or eax,eax ;cmp eax,0
		je noexitdlg

;update parent ring#... must be after down_owner()
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax==0
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginvertice,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,250,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				add ebx,pTERSEDATA				
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginvertice,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginvertice,0
byp1:     ;bypass.								
		  .ENDIF
				

;update the .nfillcolor field...
; invoke SendDlgItemMessage,hdlg,220,WM_GETTEXT,10,ADDR szasciitbl
;				invoke str2longint, ADDR szasciitbl ;-->eax
;				mov (OBJECT PTR [edi]).nfillcolor,eax
    lea eax,(OBJECT PTR [edi]).nfillcolor
    invoke download_rgbcolor,hdlg,eax,700

;update brush style from listbox...
		invoke SendDlgItemMessage,hdlg,252,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).nfillstyle,eax

;update pen style from listbox...
		invoke SendDlgItemMessage,hdlg,236,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).npenstyle,eax
		;if style is "dashes" or "dots", pen width must be 0 or 1 only...
		.IF eax==02 ;dashes
up1:	  mov eax,0 ;1	v1.30 must be 0 for these to print.
		  jmp dn1
		.ELSEIF eax==03 ;dots
		  jmp up1
		.ELSEIF eax==04 ;dashdot.
		  jmp up1
		.ELSEIF eax==05 ;dashdotdot.
		  jmp up1
		.ENDIF

;update pen width...
		invoke SendDlgItemMessage,hdlg,227,WM_GETTEXT,3,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->eax
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
dn1:	mov (OBJECT PTR [edi]).npenwidth,eax

;update pen color...
; invoke SendDlgItemMessage,hdlg,247,WM_GETTEXT,10,ADDR szasciitbl
;				invoke str2longint, ADDR szasciitbl ;-->eax
;				mov (OBJECT PTR [edi]).npencolor,eax
    lea eax,(OBJECT PTR [edi]).npencolor
    invoke download_rgbcolor,hdlg,eax,710

;update lock state...
		invoke down_lock,hdlg
;		   invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
;		   .IF ax==1
;				 or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
;		   .ELSE
;				 and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
;		   .ENDIF

;*WARNING* these must be last, as can invalidate the ptr edi...
;;bring the element to the front...
;		   invoke SendDlgItemMessage,hdlg,214,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,1 ;relocate at end of database.
;				 jmp j66
;		   .ENDIF
;;send the element to the back...
;		   invoke SendDlgItemMessage,hdlg,207,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,2 ;0 ;relocate at start of database.
;		   .ENDIF
;j66:	   ;...move1object returns address new object location in eax.
		invoke down_sendbackfront,hdlg,214,207

		xor eax,eax
		ret
noexitdlg:
		mov eax,1  ;don't exit dlgbox.
		ret
comclose_closed_dlgbox ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szarrows BYTE "Nothing",0,0,0,0,0,"Solid arrow",0,"Open arrow",0,0
		 BYTE "Bullet",0,0,0,0,0,0

.CODE
KENTER2proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL ntype:WORD
;wire dialog. id=206	"wireproc"
; *EVE* now for open-element configuration.

  mov edi,prbuttonobject ;global, set by wmrbuttondown().
  ;note that it is immediately cleared by wmrbuttondown() after the dialog.

  .IF message==WM_INITDIALOG


;display fill color...
				mov  eax,(OBJECT PTR [edi]).nfillcolor
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
; invoke SendDlgItemMessage,hdlg,214,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,214,EM_LIMITTEXT,9,0 ;set limit.
      invoke upload_rgbcolor,hdlg,eax,700 ;700=id red.

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg
;				 xor  edx,edx
;				 ;xor  eax,eax
;				 mov  eax,(OBJECT PTR [edi]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
; invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,302,EM_LIMITTEXT,4,0 ;set limit.
;
;;display element# of owner...
;				 mov eax,(OBJECT PTR [edi]).rpowner1
;				 .IF eax==0
;				 .ELSE
;				   add eax,pTERSEDATA
;						 mov ebx,eax
;				 mov  eax,(OBJECT PTR [ebx]).number
;				 invoke bin2dec,10					;-->szasciitbl
;				 ;...returns eax->start of string, past the leading blanks.
;				 mov esi,eax
;				   invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,esi
;				 .ENDIF
;				 invoke SendDlgItemMessage,hdlg,399,EM_LIMITTEXT,4,0 ;set limit.

;display element# of owner... 2nd end...
				mov eax,(OBJECT PTR [edi]).rpowner2
				.IF eax==0
				.ELSE
				  add eax,pTERSEDATA
						mov ebx,eax
				mov  eax,(OBJECT PTR [ebx]).number
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				  invoke SendDlgItemMessage,hdlg,232,WM_SETTEXT,0,esi
				.ENDIF
				invoke SendDlgItemMessage,hdlg,232,EM_LIMITTEXT,4,0 ;set limit.


;display pen style in listbox...
		mov ecx,6 ;v1.304
		lea esi,szpens
exxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 exximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,236,CB_ADDSTRING,0,esi
		pop ecx
		add esi,10
		loop exxhmmzz
exximmzz:
		mov eax,(OBJECT PTR [edi]).npenstyle
		invoke SendDlgItemMessage,hdlg,236,CB_SETCURSEL,eax,0

;display pen color...
				mov  eax,(OBJECT PTR [edi]).npencolor
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
; invoke SendDlgItemMessage,hdlg,247,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,247,EM_LIMITTEXT,9,0 ;set limit.
      invoke upload_rgbcolor,hdlg,eax,710 ;710=id red.


;display pen width...
				mov  eax,(OBJECT PTR [edi]).npenwidth
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,227,EM_LIMITTEXT,2,0 ;set limit.

;display brush style in listbox...
		mov ecx,8
		lea esi,szbrushes
kxxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 kxximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,252,CB_ADDSTRING,0,esi
		pop ecx
		add esi,10
		loop kxxhmmzz
kxximmzz:
		mov eax,(OBJECT PTR [edi]).nfillstyle
		invoke SendDlgItemMessage,hdlg,252,CB_SETCURSEL,eax,0


;display parent ring# that line attaches to...
				mov eax,(OBJECT PTR [edi]).nbeginvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,250,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,250,EM_LIMITTEXT,4,0 ;set limit.

;display parent ring# that line attaches to... 2nd end...
				mov eax,(OBJECT PTR [edi]).nendvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nendring
				.ENDIF
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,234,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,234,EM_LIMITTEXT,4,0 ;set limit.

;;display lock state...
;				 mov eax,(OBJECT PTR [edi]).fconfig4
;				 and al,01000b
;				 .IF al==1000b	;bit3
;				   invoke SendDlgItemMessage,hdlg,251,BM_SETCHECK,1,0
;				 .ENDIF

;display arrow style 1st end in listbox...
		mov ecx,4 ;v1.54 3
		lea esi,szarrows
xxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 xximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,235,CB_ADDSTRING,0,esi
		pop ecx
		add esi,12
		loop xxhmmzz
xximmzz:
		mov eax,(OBJECT PTR [edi]).narrow1st
		invoke SendDlgItemMessage,hdlg,235,CB_SETCURSEL,eax,0

;display arrow style 2nd end in listbox...
		mov ecx,4 ;3
		lea esi,szarrows
xhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 ximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,240,CB_ADDSTRING,0,esi
		pop ecx
		add esi,12
		loop xhmmzz
ximmzz:
		mov eax,(OBJECT PTR [edi]).narrow2nd
		invoke SendDlgItemMessage,hdlg,240,CB_SETCURSEL,eax,0

;display arrow scaling 1st end...
				xor edx,edx
				mov  eax,(OBJECT PTR [edi]).narrowscaling1st
				invoke bin2signedascii_upload,hdlg,eax,244,4

;display arrow scaling 2nd end...
				xor edx,edx
				mov  eax,(OBJECT PTR [edi]).narrowscaling2nd
				invoke bin2signedascii_upload,hdlg,eax,246,4

;set checkbox for shape of line...
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF ax==11 ;curved line.
				  mov ebx,211 ;id
				.ELSEIF ax==12 ;segmented.
				  mov ebx,213
				.ELSE ;=13 straight.
				  mov ebx,217
				.ENDIF
				invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0

; set checkbox if auto-stickiness disabled... v2.27
			test(OBJECT PTR [edi]).fconfig1,01000000b
			jz nodis1
			invoke SendDlgItemMessage,hdlg,219,BM_SETCHECK,1,0
nodis1:

;v3.04 don't-display-handle-if-locked checkbox...
        mov eax,(OBJECT PTR [edi]).fconfig1
        and ax,100h ;bit8.
        .IF ax != 0
				  invoke SendDlgItemMessage,hdlg,284,BM_SETCHECK,1,0
        .ENDIF

      ;v3.19
      ;master invisibility flag...
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;update the database...


;update number of object that owns this element, 1st end ...
; invoke SendDlgItemMessage,hdlg,399,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;special case 0, none owns me...
;				 ;(there is an element #0, but can't be an owner).
;				 .IF eax==0
;				   mov (OBJECT PTR [edi]).nbeginvertice,0 ;which vertice attached to if poly.
;				   jmp e206
;				 .ENDIF
;				 mov ebx,pTERSEDATA
;				   ;validate...
;				   ;xor ecx,ecx
;				   mov ecx,(TERSEDATA PTR [ebx]).numrecords
;				   .IF eax>=ecx
;						 ;off end of database...
;e202:				 invoke myerrorhandler,11
;					 jmp noexitdlg
;				   .ENDIF
;				 ;xor ecx,ecx
;				 mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
;				 mul ecx
;;				 lea edx,(TERSEDATA PTR [ebx]).OBJECTS
;				   mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   add eax,edx			  ;eax->owner.
;				   mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).fstatus
;						 and ecx,01
;						 .IF ecx==0
;						   ;invalid element...
;						   jmp e202
;						 .ELSE
;						   mov ecx,(OBJECT PTR [ebx]).nexttype
;						   .IF SWORD PTR cx<0 ;ecx==-1
;								 ;invisible element.
;								 jmp e202
;						   .ENDIF
;						 .ENDIF
;				 sub eax,pTERSEDATA
;e206:	 mov  (OBJECT PTR [edi]).rpowner1,eax
		invoke down_owner,hdlg,399,0
		or eax,eax ;cmp eax,0
		je noexitdlg

;update number of object that owns this element, 2nd end ...
; invoke SendDlgItemMessage,hdlg,232,WM_GETTEXT,5,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->integer in eax
;				 ;special case 0, none owns me...
;				 ;(there is an element #0, but can't be an owner).
;				 .IF eax==0
;				   mov (OBJECT PTR [edi]).nendvertice,0 ;which vertice attached to if poly.
;				   jmp ee206
;				 .ENDIF
;				 mov ebx,pTERSEDATA
;				   ;validate...
;				   ;xor ecx,ecx
;				   mov ecx,(TERSEDATA PTR [ebx]).numrecords
;				   .IF eax>=ecx
;						 ;off end of database...
;ee202: 			 invoke myerrorhandler,11
;					 jmp noexitdlg
;				   .ENDIF
;				 ;xor ecx,ecx
;				 mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
;				 mul ecx
;;				 lea edx,(TERSEDATA PTR [ebx]).OBJECTS
;				   mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   add eax,edx			  ;eax->owner.
;				   mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).fstatus
;						 and ecx,01
;						 .IF ecx==0
;						   ;invalid element...
;						   jmp ee202
;						 .ELSE
;						   mov ecx,(OBJECT PTR [ebx]).nexttype
;						   .IF SWORD PTR cx<0 ;ecx==-1
;								 ;invisible element...
;								 jmp ee202
;						   .ENDIF
;						 .ENDIF
;				 sub eax,pTERSEDATA
;ee206:  mov  (OBJECT PTR [edi]).rpowner2,eax
		invoke down_owner,hdlg,232,1
		or eax,eax ;cmp eax,0
		je noexitdlg

;update parent ring#... must be after down_owner()
 invoke SendDlgItemMessage,hdlg,250,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				.IF ebx != 0
				  add ebx,pTERSEDATA
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginvertice,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginvertice,0
byp1:     ;bypass.
        .ELSE
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginvertice,0
				.ENDIF
				

;update parent ring#... 2nd end...
 invoke SendDlgItemMessage,hdlg,234,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner2
				.IF ebx != 0
				  add ebx,pTERSEDATA
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nendvertice,eax
				      mov (OBJECT PTR [edi]).nendring,1 ;i think let this be default.
				      jmp SHORT byp1x
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nendring,eax
				  mov (OBJECT PTR [edi]).nendvertice,0
byp1x:     ;bypass.
        .ELSE
          mov (OBJECT PTR [edi]).nendring,1
          mov (OBJECT PTR [edi]).nendvertice,0
				.ENDIF
				


;update the .nfillcolor field...
; invoke SendDlgItemMessage,hdlg,214,WM_GETTEXT,10,ADDR szasciitbl
;				invoke str2longint, ADDR szasciitbl ;-->eax
;				mov (OBJECT PTR [edi]).nfillcolor,eax
    lea eax,(OBJECT PTR [edi]).nfillcolor
    invoke download_rgbcolor,hdlg,eax,700

;update brush style from listbox...
		invoke SendDlgItemMessage,hdlg,252,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).nfillstyle,eax


;update pen style from listbox...
		invoke SendDlgItemMessage,hdlg,236,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).npenstyle,eax
		;if style is "dashes" or "dots", pen width must be 0 or 1 only...
		.IF eax==02 ;dashes
up1:	  mov eax,0 ;1	v1.30 must be 0 to print.
		  jmp dn1
		.ELSEIF eax==03 ;dots
		  jmp up1
		.ELSEIF eax==4	;dashdot.
		  jmp up1
		.ELSEIF eax==5	;dashdotdot.
		  jmp up1
		.ENDIF

;update pen width... (must place this immediately after pen style)
		invoke SendDlgItemMessage,hdlg,227,WM_GETTEXT,3,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->eax
				.IF SDWORD PTR eax<0
				  neg eax
				.ENDIF
dn1:	mov (OBJECT PTR [edi]).npenwidth,eax

;update pen color...
; invoke SendDlgItemMessage,hdlg,247,WM_GETTEXT,10,ADDR szasciitbl
;				invoke str2longint, ADDR szasciitbl ;-->eax
;				mov (OBJECT PTR [edi]).npencolor,eax
    lea eax,(OBJECT PTR [edi]).npencolor
    invoke download_rgbcolor,hdlg,eax,710


;update lock state...
		invoke down_lock,hdlg
;		   invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
;		   .IF ax==1
;				 or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
;		   .ELSE
;				 and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
;		   .ENDIF

;update arrow style 1st end from listbox...
		invoke SendDlgItemMessage,hdlg,235,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).narrow1st,eax

;update arrow style 2nd end from listbox...
		invoke SendDlgItemMessage,hdlg,240,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).narrow2nd,eax

;update arrow scaling 1st end...
 invoke SendDlgItemMessage,hdlg,244,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->eax
				mov (OBJECT PTR [edi]).narrowscaling1st,eax

;update arrow scaling 2nd end...
 invoke SendDlgItemMessage,hdlg,246,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->eax
				mov (OBJECT PTR [edi]).narrowscaling2nd,eax

;update line shape...
		  invoke SendDlgItemMessage,hdlg,211,BM_GETCHECK,0,0
		  .IF ax==1
				mov eax,11 ;curved.
		  .ELSE
				invoke SendDlgItemMessage,hdlg,213,BM_GETCHECK,0,0
				.IF ax==1
				  mov eax,12 ;segmented.
				.ELSE
				  mov eax,13 ;straight.
				.ENDIF
		  .ENDIF
		  mov (OBJECT PTR [edi]).nexttype,eax

;update disable auto-stickiness... v2.27
		  invoke SendDlgItemMessage,hdlg,219,BM_GETCHECK,0,0
		  .IF ax==1
			or (OBJECT PTR [edi]).fconfig1,01000000b
		  .ELSE
			and (OBJECT PTR [edi]).fconfig1,0FFFFFFBFh
		  .ENDIF

;v3.04 checkbox for don't display handle if locked...
		  invoke SendDlgItemMessage,hdlg,284,BM_GETCHECK,0,0
		  .IF ax==1
		    or (OBJECT PTR [edi]).fconfig1,0100h ;set bit8.
		  .ELSE
		    and (OBJECT PTR [edi]).fconfig1,0FEFFh ;clr bit8.
		  .ENDIF

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF

;*WARNING* these must be last, as can invalidate the ptr edi...
;;bring the element to the front...
;		   invoke SendDlgItemMessage,hdlg,249,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,1 ;relocate at end of database.
;				 jmp j66
;		   .ENDIF
;;send the element to the back...
;		   invoke SendDlgItemMessage,hdlg,207,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,2 ;0 ;relocate at start of database.
;		   .ENDIF
;j66:	   ;...move1object returns address new object location in eax.
		invoke down_sendbackfront,hdlg,249,207




		  invoke EndDialog, hdlg,TRUE
noexitdlg:
zoono1:
		  mov eax,TRUE
		.ELSEIF eax==IDCANCEL ;(lo-wparam)
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE

		.ELSEIF wparam==209 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,710 ;247 ;247=id of color-edit-box
		   mov eax,TRUE

		.ELSEIF wparam==218 ;"choose a color" button pressed.
		   invoke chooseacolor,hdlg,700 ;214 ;214=id of color-edit-box
		   mov eax,TRUE

		.ELSE
		  mov eax,FALSE
		.ENDIF


  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE


  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
KENTER2proc ENDP		 ;wireproc --open-element
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
nfsize DWORD 0
;startup STARTUPINFO < > 		 ;needs all zeros in fields.
nbytesw DWORD 0,0

.CODE
;v3.01 moved...
sztemptxt BYTE "temp.txt",0
sztempgif BYTE "temp.gif",0
sztempbmp BYTE "temp.bmp",0
sztempwmf BYTE "temp.wmf",0
sztempjpg BYTE "temp.jpg",0
;szdoneyet BYTE "Finished using the external editor? If so, save the ""temp"" file, "
;          BYTE "exit from the editor, THEN hit this ""OK"" button...",0

openexternaleditor PROC STDCALL USES ebx ecx edx esi edi, pdest:DWORD, \
    infilesize:DWORD,filetype:DWORD
		LOCAL hfile:DWORD
		LOCAL eaxsave:DWORD
		LOCAL peditor:DWORD
;		LOCAL procinfo:PROCESS_INFORMATION
    LOCAL myshellinfo:SHELLEXECUTEINFOA
		LOCAL pszimg:DWORD ;,time00:DWORD,ndelay:DWORD,procde:DEBUG_EVENT
;		LOCAL nmillisecs:DWORD
    LOCAL lasttime0:FILETIME,lasttime1:FILETIME
    LOCAL nspaces:BYTE
; "openexternaleditor" *EVE*
;open editor specified in TERSEDATA.szeditor, open "temp.txt",
;write file to pdest.
;called from iconproc(), labelproc() and xdblclk().
;v2.92 filetype=0 txt, =1 gif, =2 jpg, =3 bmp, =4 wmf
;v2.92 returns filesize in nfsize global variable.
;v2.92 infilesize=0 uses 0 terminator, else =size of file.
;v2.94 ret eax=0 file not changed, eax=1 file changed.

		  .IF pdest==0
		    jmp ex1 ;exit.
		  .ENDIF
		  
		  ;v2.92 can also open images...
		  mov ebx,pTERSEDATA
		  .IF filetype != 0 ;a picture.
        lea ecx,szpainter1 ;(TERSEDATA PTR [ebx]).szpainter1  v3.01
		    mov peditor,ecx
				mov ebx,ecx
				mov al,[ebx]
				.IF al==0				;no editor.
				  jmp SHORT exi1
				.ELSE
				  .IF filetype==1 ;gif
				    mov ecx,OFFSET sztempgif
				  .ELSEIF filetype==2 ;jpg
				    mov ecx,OFFSET sztempjpg
				  .ELSEIF filetype==4 ;wmf
				    mov ecx,OFFSET sztempwmf
				  .ELSE ;bmp
				    mov ecx,OFFSET sztempbmp
				  .ENDIF
				  mov pszimg,ecx
				  jmp SHORT ok1x
				.ENDIF
		  .ENDIF

		  lea ecx,szeditor2 ;(TERSEDATA PTR [ebx]).szeditor2 v3.01
		  mov peditor,ecx
				mov ebx,ecx
				mov al,[ebx]
				.IF al==0				;no editor.
				  ;v2.31
				  ;for backwards compatibility, use other editor...
		      mov ebx,pTERSEDATA
		      lea ecx,szeditor1 ;(TERSEDATA PTR [ebx]).szeditor1 v3.01
		      mov peditor,ecx
				  mov ebx,ecx
				  mov al,[ebx]
				  .IF al==0				;no editor.
exi1:       invoke myalertbox,ADDR szer012,1 ;invoke myerrorhandler,012
		      .ELSE
		        jmp SHORT ok1
		      .ENDIF
				.ELSE
ok1:		  ;open file temp.txt...
          mov ecx,OFFSET sztemptxt
          mov pszimg,ecx
ok1x:
  ;mov g_errorapi,0B30h ;for crash outside EVE, error codes range Axxh. v3.23
		  invoke CreateFile, ecx,\
								GENERIC_READ+GENERIC_WRITE,\
								0,				;don't share! FILE_SHARE_READ+FILE_SHARE_WRITE,\
								0, CREATE_ALWAYS, \  ;was TRUNCATE_EXISTING
								FILE_FLAG_WRITE_THROUGH, 0
				  .IF eax==INVALID_HANDLE_VALUE ;-1
						;open failed ...
				    invoke myalertbox,ADDR szer105,4 ;invoke myerrorhandler,105
						jmp ex1
				  .ENDIF
						mov hfile,eax
						;write OBJECT-data-element.sztext to the file
						mov eax,pdest
						.IF infilesize==0 ;text-file, use zero terminator.
						  invoke lstrlen,eax
						.ELSE
						  mov eax,infilesize
						.ENDIF
						mov ebx,pdest
  ;mov g_errorapi,0B31h ;for crash outside EVE, error codes range Axxh. v3.23
						invoke WriteFile, hfile,ebx,eax,ADDR nbytesw,0
;						invoke FlushFileBuffers, hfile
;v2.93 read date/time of file...
            lea eax,lasttime0
            invoke GetFileTime,hfile,0,0,eax
						invoke CloseHandle,hfile
				  ;start editor...
				
;v2.93 let us not mess up szcommandline...				
;				  mov ebx,pTERSEDATA
;				  ;lea ecx,(TERSEDATA PTR [ebx]).szeditor1
;				  mov ecx,peditor ;v2.31.
;				  lea eax,szcommandline
;				  invoke lstrcpy, eax,ecx
;				  lea eax,szcommandline
;				  invoke lstrlen, eax
;				  add eax,OFFSET szcommandline
;				  mov ebx,eax
;				  mov [ebx],BYTE PTR " "
;				  inc ebx
;				  mov eax,pszimg ;lea eax,sztemptxt
;				  invoke lstrcpy, ebx,eax

;v2.92 sigh, attempts to use WinExec() and wait on the file being not in use
;have failed...				
				  ;v2.92 a problem, WaitForSingleObject() only works with some apps,
				  ;with Wordpad waits forever. so, let's go back to WinExec(),
				  ;and put some waiting code into CreateFile()...
				  ;invoke WinExec, ADDR szcommandline, SW_SHOW ;call editor.

;						mov startup.si_cb,STARTUPINFO_
;						mov startup.si_wShowWindow,SW_SHOW
;						mov startup.si_dwFlags,STARTF_USESHOWWINDOW
;						invoke CreateProcess, 0,ADDR szcommandline,0,0,0,DEBUG_PROCESS,0,0, \
;														ADDR startup, ADDR procinfo
;						;now wait until process has finished...
;						mov eax,procinfo.pi_hThread ;Process	;handle to the process.
;						;...doesn't seem to make any difference, .pi_hThread, .pi_hProcess.
;						invoke WaitForSingleObject, eax,INFINITE ;wait forever.
;						;this is a catch for premature return...
;						.IF eax==WAIT_ABANDONED
;          invoke MessageBox,g_hwnd,ADDR szdoneyet,ADDR szeve,MB_OK+MB_ICONQUESTION						
;						.ENDIF

; jmp test1 ;**TEST**
 
;v2.93 let's try shellexecute....
  ;mov g_errorapi,0B32h ;for crash outside EVE, error codes range Axxh. v3.23
          invoke CloseWindow,g_hwnd
          ;this is how to use it...
          ;invoke ShellExecute,g_hwnd,ADDR szopen,ADDR exefile,ADDR params,0,SW_SHOWNORMAL
          ;which return handle of the instance. however, ShellExecuteEx() will give
          ;handle of the process...
            lea ebx,myshellinfo
            mov ecx,(SIZEOF SHELLEXECUTEINFOA)
nxt1:       mov [ebx],BYTE PTR 0
            inc ebx
            loop nxt1
          mov myshellinfo.cbSize,(SIZEOF SHELLEXECUTEINFOA)
          mov myshellinfo.fMask,SEE_MASK_NOCLOSEPROCESS
          mov eax,g_hwnd
          mov myshellinfo.hwnd,eax
          mov myshellinfo.lpVerb,OFFSET szopen
          mov eax,peditor
          mov myshellinfo.lpFile,eax ;exe file.
          mov eax,pszimg
          mov myshellinfo.lpParameters,eax
          mov myshellinfo.nShow,SW_SHOWNORMAL
          lea eax,myshellinfo
  ;mov g_errorapi,0B33h ;for crash outside EVE, error codes range Axxh. v3.23
          invoke ShellExecuteEx,eax ;returns eax=0 if fail.
          ;returns myshellinfo.hProcess=handle of process.
          ;now wait for external editor to finish...
          .IF eax==0
            jmp SHORT fai1
          .ENDIF
          mov esi,myshellinfo.hProcess
          .IF esi == 0 ;failed.
fai1:       invoke myalertbox,ADDR szer024,4 ;invoke myerrorhandler,024 ;failed to open ext. ed.
            jmp ex1 ;get out.
          .ELSE
  ;mov g_errorapi,0B34h ;for crash outside EVE, error codes range Axxh. v3.23
					  invoke WaitForSingleObject,esi,INFINITE ;wait forever.
            invoke CloseHandle,esi
          .ENDIF
  ;mov g_errorapi,0B35h ;for crash outside EVE, error codes range Axxh. v3.23
          invoke ShowWindow,g_hwnd,SW_RESTORE
;          invoke SleepEx,3000,0 ;wait 3 secs.
					
;test1:					
;  xor eax,eax ;***TEST***
;  mov eax,[eax] ;/


 				  ;now open the file again...
				  mov ecx,pszimg
  ;mov g_errorapi,0B36h ;for crash outside EVE, error codes range Axxh. v3.23
				  invoke CreateFile, ecx,\
								GENERIC_READ,\
								0,\ 							;don't share!!!
								0, OPEN_EXISTING,\				;opens an existing file.
								FILE_FLAG_WRITE_THROUGH, 0
				  .IF eax==INVALID_HANDLE_VALUE ;-1
						;open failed ...
ti01:		    invoke myalertbox,ADDR szer105,4 ;invoke myerrorhandler,105
						jmp ex1
				  .ENDIF
				  mov hfile,eax
				    ;v2.93 see if it has changed...
            lea eax,lasttime1
            invoke GetFileTime,hfile,0,0,eax
            mov eax,lasttime0.ft_dwLowDateTime
            mov ecx,lasttime1.ft_dwLowDateTime
            .IF eax == ecx
					    invoke GetFileSize,hfile,0
				      mov nfsize,eax
				      invoke CloseHandle, hfile
              jmp ex1 ;rddone2
            .ENDIF
            mov g_fhaschanged,1 ;flag, eve diag has changed.
						;now read from the file...
						  ;v2.92
						  .IF filetype != 0 ;picture.
						    invoke GetFileSize,hfile,0
					      mov nfsize,eax
						    .IF eax>=(nBIGBLOCKSIZE-1)
						      invoke myalertbox,ADDR szerimgs,4 ;invoke myerrorhandler,023 ;pic too big.
						      jmp ex1
						    .ELSE
						      mov esi,pdest
						      invoke ReadFile, hfile,esi,eax,ADDR nbytesw,0 ;read entire file.
						      ;have to put the size of file somewhere....
						      ;nfsize global, so iconproc() can use this for block2chain().
						    .ENDIF
					      jmp rddone2
						  .ENDIF
						mov edi,prbuttonobject
						;lea esi,(OBJECT PTR [edi]).sztext2
						 mov esi,pdest
						mov nfsize,0
						mov nspaces,0
						dec esi
rdnxt:			inc esi
						invoke ReadFile, hfile,esi,1,ADDR nbytesw,0 ;read 1 char.
						.IF nbytesw==0
						  jmp rddone
						.ENDIF
						  mov BYTE PTR al,[esi] ;in case end is padded with spaces.
						  .IF al==" "
								inc nspaces
								.IF nspaces>=30 ;arbitrary
								  sub esi,29
								  mov [esi],BYTE PTR 0
								  jmp SHORT rddone2
								.ENDIF
						  .ELSE
								mov nspaces,0
						  .ENDIF
						inc nfsize
						cmp nfsize,(nBIGBLOCKSIZE - 1) ;1023
						jae rderr
						cmp [esi],BYTE PTR 01Ah ;ctrl-Z, end-of-file character.
						jne rdnxt
						jmp SHORT rddone
rderr:
						  ;error...
				    invoke myalertbox,ADDR szer106,4 ;invoke myerrorhandler,106
				    jmp SHORT ex1
rddone: 		mov [esi],BYTE PTR 0
rddone2:

				  invoke CloseHandle, hfile
				  mov eax,1 ;1=file has changed.
				  ret
				.ENDIF

ex1:
		mov eax,0 ;0=file not changed.
		ret
openexternaleditor ENDP
;--------------------------------------------------------------------------
.DATA ;BUG, made this .code, but must remain .data. v3.25
szfonttypes  BYTE "Times New Roman",0 ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
						 BYTE "Arial",0,0,0,0,0,0,0,0,0,0,0 ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
						 BYTE "Courier New",0,0,0,0,0 ,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
szfx			 BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

.CODE ;v3.25
szfontstyles BYTE "Normal",0,0,0,0,0,0,"Bold",0,0,0,0,0,0,0,0
						 BYTE "Italic",0,0,0,0,0,0
						 BYTE "Bold italic",0
szansi			 BYTE "Western",0,		  0,0,0,0		 ;0  12 bytes.	18 types.
szdefault		 BYTE "Default",0,		  0,0,0,0				   ;1
szsymbol		 BYTE "Symbol",0,		  0,0,0,0,0 	   ;2
szshiftjis		 BYTE "ShiftJIS",0,   0,0,0 			   ;128
szgb2312		 BYTE "GB2312",0,		  0,0,0,0,0 	   ;134
szhangeul		 BYTE "HangEUL",0,		  0,0,0,0				   ;129
szchinesebig5 BYTE "ChineseBig5", 0 					   ;
szoem			 BYTE "OEM",0,			  0,0,0,0,0,0,0,0
szjohab 		 BYTE "Johab",0,		  0,0,0,0,0,0
szhebrew		 BYTE "Hebrew",0,		  0,0,0,0,0
szarabic		 BYTE "Arabic",0,		  0,0,0,0,0
szgreek 		 BYTE "Greek",0,		  0,0,0,0,0,0
szturkish		 BYTE "Turkish",0,		  0,0,0,0
szthai			 BYTE "Thai",0, 		  0,0,0,0,0,0,0
szeasteurope BYTE "EastEurope",0, 0
szrussian		 BYTE "Russian",0,		  0,0,0,0
szmac			 BYTE "Mac",0,			  0,0,0,0,0,0,0,0
szbaltic		 BYTE "Baltic",0,		  0,0,0,0,0

csids BYTE 0,1,2,128,134,129,136,255,130,177,178,161,162,222,238,204,77,186

.CODE
;--------------------------------------------------------------------------
charsetname PROC STDCALL USES ebx ecx edx esi edi,charsetid:DWORD
		LOCAL dummy:DWORD
; "charsetname"
;converts char set id to address of name. returns in eax.

		mov eax,charsetid
		.IF al==0
		  lea eax,szansi
		.ELSEIF al==1
		  lea eax,szdefault
		.ELSEIF al==2
		  lea eax,szsymbol
		.ELSEIF al==128
		  lea eax,szshiftjis
		.ELSEIF al==134
		  lea eax,szgb2312
		.ELSEIF al==129
		  lea eax,szhangeul
		.ELSEIF al==136
		  lea eax,szchinesebig5
		.ELSEIF al==255
		  lea eax,szoem
		.ELSEIF al==130
		  lea eax,szjohab
		.ELSEIF al==177
		  lea eax,szhebrew
		.ELSEIF al==178
		  lea eax,szarabic
		.ELSEIF al==161
		  lea eax,szgreek
		.ELSEIF al==162
		  lea eax,szturkish
		.ELSEIF al==222
		  lea eax,szthai
		.ELSEIF al==238
		  lea eax,szeasteurope
		.ELSEIF al==204
		  lea eax,szrussian
		.ELSEIF al==77
		  lea eax,szmac
		.ELSEIF al==186
		  lea eax,szbaltic
		.ELSE
		  lea eax,szansi
		.ENDIF

		ret
charsetname ENDP
;--------------------------------------------------------------------------
lockproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;from wmrbuttondown()/state0/on-an-label-object "lockproc"
;any element, locked.

				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;display lock state...
				mov eax,(OBJECT PTR [edi]).fconfig4
				and al,01000b
				.IF al==1000b  ;bit3
				  invoke SendDlgItemMessage,hdlg,251,BM_SETCHECK,1,0
				.ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1

;update lock state...
		invoke down_lock,hdlg
;		   invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
;		   .IF ax==1
;				 or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
;		   .ELSE
;				 and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
;		   .ENDIF


		  invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE


		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
lockproc	ENDP		   ;derives from labelproc()
;--------------------------------------------------------------------------
textfieldproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;from wmrbuttondown()/state0/on-an-label-object "textfieldproc"
;this is the callback for label-element when it is child in a comp-obj and boss locked.
;(normal callback for label is labelproc()).

				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;display label...
				mov ebx,(OBJECT PTR [edi]).rpdata		;data-element.
				.IF ebx==0
				.ELSE
				  add ebx,pTERSEDATA
				  lea esi,(OBJECT PTR [ebx]).sztext ;start of data area.
				  invoke SendDlgItemMessage,hdlg,102,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,102,EM_LIMITTEXT,255,0
				.ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1

;update label...
;problem is, must wipeout previous text first...
						invoke add2wipeoutlist,edi
						;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						;...done in add2wipeoutlist()
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex
;now get new label...
						  mov ebx,(OBJECT PTR [edi]).rpdata
						  .IF ebx==0
						  .ELSE
								add ebx,pTERSEDATA
								lea  esi,(OBJECT PTR [ebx]).sztext ;zeroise it first.
								mov  ecx,256									  ;/
zoo1:							mov  [esi],BYTE PTR 0					  ;/
								inc  esi												  ;/
								loop zoo1												  ;/
								lea esi,(OBJECT PTR [ebx]).sztext
								invoke SendDlgItemMessage,hdlg,102,WM_GETTEXT,256,esi
						  .ENDIF


		  invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE


		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
textfieldproc	 ENDP			;derives from labelproc()
;--------------------------------------------------------------------------
.DATA?
ALIGN 4
;mylf LOGFONT <> ;v3.50
nfontsizesaved DWORD ?   ;v3.50
nfontcolorsaved DWORD ?
nfontstylesaved DWORD ?
nfonttypesaved  DWORD ?
ncharsetsaved   DWORD ?
ffonteffectssaved DWORD ?
nfontanglesaved   DWORD ?
xlabeloffsetsaved DWORD ?
ylabeloffsetsaved DWORD ?
fconfig4saved     DWORD ?
widthtextsaved    DWORD ?
g_pmem0 DWORD ? ;v3.52

.DATA
ALIGN 4 ;v3.24
charsettemp DWORD 0
g_hnewfontedit DWORD 0 ;v3.50
g_hfixedfontedit DWORD 0 ;/

.CODE
label_restore_font_params PROC
; "label_restore_font_params"
;called from labelproc(), iconproc().

;need to wipe existing label... v3.51
		    invoke add2wipeoutlist,edi
				mov g_fredrawdiag,WIPEOUTobjs
				push g_nmousex
				push g_nmousey
				invoke UpdateWindow,g_hwnd
				pop g_nmousey
				pop g_nmousex
				
		  mov eax,nfontsizesaved ;v3.50
		  mov (OBJECT PTR [edi]).nfontsize,eax
		  mov eax,nfontcolorsaved ;v3.50
		  mov (OBJECT PTR [edi]).nfontcolor,eax
		  mov eax,nfontstylesaved ;v3.50
		  mov (OBJECT PTR [edi]).nfontstyle,eax
		  mov eax,nfonttypesaved ;v3.50
		  mov (OBJECT PTR [edi]).nfonttype,eax
		  mov eax,ncharsetsaved ;v3.50
		  mov (OBJECT PTR [edi]).ncharset,eax
		  mov eax,ffonteffectssaved ;v3.50
		  mov (OBJECT PTR [edi]).ffonteffects,eax
		  mov eax,nfontanglesaved
		  mov (OBJECT PTR [edi]).nfontangle,eax
		  mov eax,xlabeloffsetsaved
		  mov (OBJECT PTR [edi]).xlabeloffset,eax
		  mov eax,ylabeloffsetsaved
		  mov (OBJECT PTR [edi]).ylabeloffset,eax
		  mov eax,fconfig4saved
		  mov (OBJECT PTR [edi]).fconfig4,eax
		  mov eax,widthtextsaved
		  mov (OBJECT PTR [edi]).widthtext,eax

  ret
label_restore_font_params ENDP
;--------------------------------------------------------------------------
label_download_fconfig4 PROC STDCALL,hdlg:DWORD
  LOCAL dummy:DWORD
;called from labelproc() (not iconproc()).

;update custom/auto width/height calc...
				invoke SendDlgItemMessage,hdlg,211,BM_GETCHECK,0,0
				mov ebx,(OBJECT PTR [edi]).fconfig4
				.IF ax==1 ;write 0 to bit7....(auto calc)
				  and bl,01111111b
				.ELSE
				  or  bl,0010000000b
				  push ebx
					;bit7=1, custom width/height...
					invoke SendDlgItemMessage,hdlg,217,WM_GETTEXT,10,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
					mov (OBJECT PTR [edi]).widthtext,eax
					;invoke SendDlgItemMessage,hdlg,218,WM_GETTEXT,10,ADDR szasciitbl
					;invoke str2longint, ADDR szasciitbl ;-->eax
					;mov (OBJECT PTR [edi]).heighttext,eax
				  pop ebx
				.ENDIF
				mov (OBJECT PTR [edi]).fconfig4,ebx ;bl

;v1.48 update text alignment...
		  invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
		  mov ebx,(OBJECT PTR [edi]).fconfig4
		  and bx,0F8FFh ;bits10/9/8.
		  .IF ax==1 				;automatic.
		  .ELSE
				push ebx
				invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
				pop ebx
				.IF ax==1
				  or bx,000100000000b ;left.
				.ELSE
				  push ebx
				  invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0
				  pop ebx
				  .IF ax==1
				    or bx,001000000000b ;right.
				  .ELSE
				    or bx,010000000000b ;justified.
				  .ENDIF
				.ENDIF
		  .ENDIF
		  mov (OBJECT PTR [edi]).fconfig4,ebx
		
;v2.38
;plain text or markup tags...
		  invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0
		  .IF ax==1 ;plain text.
		    and (OBJECT PTR [edi]).fconfig4,0FFFFF7FFh ;clr bit11.
		  .ELSE
		    or (OBJECT PTR [edi]).fconfig4,0800h ;set bit11.
		  .ENDIF

  ret
label_download_fconfig4 ENDP
;--------------------------------------------------------------------------
label_download_text PROC STDCALL,hdlg:DWORD ;v3.52
  LOCAL pmem:DWORD,nsize:DWORD
;called from labelproc().

       mov nsize,0
       ;v2.30
       ;want support chained data elements...
       ;wipeout previous data elements...
          mov ebx,(OBJECT PTR [edi]).rpdata
          .IF ebx==0
            jmp koo7 ;error.
          .ENDIF
          add ebx,pTERSEDATA ;1st data element.
          mov (OBJECT PTR [ebx]).xdata,0 ;size=0.
          mov (OBJECT PTR [ebx]).sztext,0 ;remove text.
k11:   mov eax,(OBJECT PTR [ebx]).rpdata ;next data element.
       mov (OBJECT PTR [ebx]).rpdata,0 ;nothing chained.
		   or eax,eax ;cmp eax,0
		   je kdone
		   add eax,pTERSEDATA
		   mov ebx,eax
		   mov (OBJECT PTR [ebx]).fstatus,0
		   jmp k11
kdone:
            invoke SendDlgItemMessage,hdlg,102,WM_GETTEXTLENGTH,0,0
              inc eax ;include trailing zero.
              mov nsize,eax
            .IF eax > 256
              ;create a memory block...
              add eax,512 ;256 ;safety margin.
              invoke GlobalAlloc, GMEM_FIXED,eax
              .IF eax != 0
                mov pmem,eax
                  ;zeroise it...
								  mov  ecx,nsize									  ;/
								  add ecx,255
								  mov ebx,pmem
koo6:					    mov  [ebx],BYTE PTR 0					  ;/
								  inc  ebx												  ;/
								  loop koo6												  ;/
                invoke SendDlgItemMessage,hdlg,102,WM_GETTEXT,nsize,pmem
                ;now have to copy it to the chained data elements...
                  mov eax,edi ;v2.60
                  sub eax,pTERSEDATA ;/
                  push eax
                invoke block2chain,pmem,edi,nsize,0
                  pop edi
                  add edi,pTERSEDATA
                ;...pmem->block, edi->label, nsize=size of block.
                ;destroy mem block...
                invoke GlobalHandle,pmem
                invoke GlobalFree,eax
              .ENDIF
            .ELSE
              ;code as before...
						  mov ebx,(OBJECT PTR [edi]).rpdata
						  .IF ebx==0
						  .ELSE
								add ebx,pTERSEDATA
								lea  esi,(OBJECT PTR [ebx]).sztext ;zeroise it first.
								mov  ecx,256									  ;/
zoo1:					  mov  [esi],BYTE PTR 0					  ;/
								inc  esi												  ;/
								loop zoo1												  ;/
								  ;record the size...
								  mov eax,nsize
								  mov (OBJECT PTR [ebx]).xdata,eax
								lea esi,(OBJECT PTR [ebx]).sztext
								invoke SendDlgItemMessage,hdlg,102,WM_GETTEXT,256,esi
						  .ENDIF
            .ENDIF
koo7:       ;bypass.

  mov eax,nsize ;return.
  ret
label_download_text ENDP
;--------------------------------------------------------------------------
label_repaint PROC STDCALL,hdlg:DWORD,wparam:DWORD
  LOCAL dummy:DWORD
;called from labelproc() and iconproc().
;updates dlg box label edit-box and label on diagram.

		    invoke add2wipeoutlist,edi
				mov g_fredrawdiag,WIPEOUTobjs
				push g_nmousex
				push g_nmousey
				invoke UpdateWindow,g_hwnd
				pop g_nmousey
				pop g_nmousex
        .IF wparam==DWORD PTR ((EN_KILLFOCUS*65536)+102) ;label text edit box. v3.51
          invoke label_download_text,hdlg ;text from dlgbox to element. v3.52
          jmp dn3
        .ENDIF
        invoke download_font,hdlg ;download font params to element.
        mov eax,(OBJECT PTR [edi]).nfontsize
				.IF eax<6
				  mov eax,6
				.ENDIF
				mov (OBJECT PTR [edi]).nfontsize,eax
				   mov eax,(OBJECT PTR [edi]).nexttype
				   cmp eax,33 ;33=label. picture icon doesn't have plain/html buttons.
				   jne by1
				  ;need these for paint of label on diagram...
          ;label-width, alignment, plain/html...
          invoke label_download_fconfig4,hdlg ;v3.51
          ;note, .fconfig4, .widthtext get restored if press cancel button.
        invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0 ;plain text.
		      .IF ax != 0 ;0=html text.
by1:        mov esi,edi
		        mov eax,(OBJECT PTR [edi]).nfontangle ;v3.51
		        push eax ;need to preserve angle, as diagram paints simultaneously. v3.51
		        mov (OBJECT PTR [edi]).nfontangle,0
		        invoke mycreatefont ;enter esi->element. CreateFontIndirect,ADDR mylf ;v3.50
		        pop ecx
		        mov (OBJECT PTR [edi]).nfontangle,ecx
            push eax ;handle of new font.
            invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,eax,TRUE ;upload font to editbox.
            invoke DeleteObject,g_hnewfontedit ;delete current temp font.
            pop eax
            mov g_hnewfontedit,eax ;global.
          .ENDIF
        ;note, must delete font when exit dialogbox.
				;note, if cancel button, restores .nfontsize to original value.
dn3:		invoke windowchanged,FALSE ;TRUE ;FALSE=don't wipe background.

  ret
label_repaint ENDP
;--------------------------------------------------------------------------
test_controls_repaint PROC  ;v3.52
;called from labelproc(), iconproc()
;enter with eax=wparam.
;return ebx non0 if must jump to "dn2:".

    ;editbox displays in black, so no need for these, however, diag updates also...
  cmp eax,DWORD PTR ((EN_CHANGE*65536)+720) ;font red color edit box changed. v3.50
      jne dn1
dn2:  mov ebx,1
      jmp SHORT out1
dn1: cmp eax,DWORD PTR ((EN_CHANGE*65536)+721) ;font green color edit box changed. v3.50
      je dn2
  cmp eax,DWORD PTR ((EN_CHANGE*65536)+722) ;font blue color edit box changed. v3.50
      je dn2
  cmp eax,DWORD PTR ((CBN_SELENDOK*65536)+256) ;font style from listbox changed. v3.50
		  je dn2
  cmp eax,DWORD PTR ((CBN_SELENDOK*65536)+255) ;font type from listbox changed. v3.50
		  je dn2
  cmp eax,243 ;underline/strikethru changed. v3.50
		  je dn2
  cmp eax,242 ;underline/strikethru changed. v3.50
		  je dn2
  cmp eax,DWORD PTR ((EN_CHANGE*65536)+240) ;.xlabeloffset. v3.51
      je dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.
  cmp eax,DWORD PTR ((EN_CHANGE*65536)+241) ;.ylabeloffset. v3.51
      je dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.
  cmp eax,DWORD PTR ((EN_CHANGE*65536)+263) ;.nfontangle. v3.51
      je dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.
    ;these aren't in iconproc(). part of .fconfig4... v3.51
    cmp eax,223   ;align check. (refer label_download_fconfig4())
      je dn2
    cmp eax,DWORD PTR ((EN_CHANGE*65536)+217)   ;custom width edit box.
      je dn2
    cmp eax,224   ;alignment checkbox.
      je dn2
    cmp eax,225   ;alignment checkbox.
      je dn2
  xor ebx,ebx
out1:
  ret
test_controls_repaint ENDP
;--------------------------------------------------------------------------
KENTER33proc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL mylf:LOGFONT
		LOCAL cntr1:DWORD,nsize:DWORD,pmem:DWORD
		LOCAL gifinfostruct:GIF_INFO
;from wmrbuttondown()/state0/on-an-label-object "labelproc"
; *EVE* this is now the callback for label-element.

				mov  edi,prbuttonobject
				;mov fhtml,2 ;v3.51

  .IF message==WM_INITDIALOG

;display label...
				mov ebx,(OBJECT PTR [edi]).rpdata		;data-element.
				.IF ebx==0
				  jmp out9 ;exit dlg box.
				.ELSE
    		  add ebx,pTERSEDATA
    		  ;v2.30
    		  mov eax,(OBJECT PTR [ebx]).xdata
    		  mov nsize,eax ;including trailing zero.
    		  ;.IF eax<256 ;means just one data element.  v3.52
    		  ;  ;note, prior to v2.30, .xdata of 1st data element was always zero.
		      ;  lea esi,(OBJECT PTR [ebx]).sztext ;start of data area.
				  ;  invoke SendDlgItemMessage,hdlg,102,WM_SETTEXT,0,esi
    		  ;.ELSE
    		    ;v2.30
     		    ;load chained data into a contiguous block...
    		    invoke chain2block,ebx,0 ;last param=ADDR g_bigblock else 0.
    		    ;...g_bigblock is destination block (param=0, create new block).
    		    ;...ebx->data element/s.
    		    ;returns eax->block, else 0.
    		    mov g_pmem0,eax ;newly created block.
    		    .IF eax != 0
    		      ;push eax
 				      invoke SendDlgItemMessage,hdlg,102,WM_SETTEXT,0,eax
 				      ;pop eax
 				      ;invoke GlobalHandle,eax
 				      ;invoke GlobalFree,eax
 				      ;...delete mem block when exit dlgbox. v3.52
 				      ;...(careful, exit is from two places -- EndDialog() called).
    		    .ENDIF
          ;.ENDIF
        .ENDIF

    invoke label_upload_common,hdlg ;v2.76.

      ;v3.19
      ;master invisibility flag...
      ;(note, bit5=label visibility, done in label_upload_common() above).
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF

;v2.38 plain text or markup tags...
				mov eax,(OBJECT PTR [edi]).fconfig4
				and ax,0800h ;bit11.
        .IF ax==0 ;plain text.
				  invoke SendDlgItemMessage,hdlg,230,BM_SETCHECK,1,0
        .ELSE
				  invoke SendDlgItemMessage,hdlg,231,BM_SETCHECK,1,0 ;markup.
				  invoke SendDlgItemMessage,hdlg,211,BM_SETCHECK,0,0 ;auto-width off.
				  ;must be left-aligned...
				  mov eax,(OBJECT PTR [edi]).fconfig4
				  and ax,0F8FFh ;zeroise bits 10/9/8.
				  or ax,0180h ;set bit8, left-align. and bit7, custom width.
				  mov (OBJECT PTR [edi]).fconfig4,eax
				  ;if width=0, set it to a non-zero value...
				  mov eax,(OBJECT PTR [edi]).widthtext
				  .IF eax==0
				    mov (OBJECT PTR [edi]).widthtext,200
				  .ENDIF				
        .ENDIF
				;auto-width and text-alignment code must be after this...
				
;display auto calc width/height checkbox...
			  mov  eax,(OBJECT PTR [edi]).widthtext
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  ;...returns eax->start of string, past the leading blanks.
			  invoke SendDlgItemMessage,hdlg,217,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,217,EM_LIMITTEXT,9,0 ;set limit.
			  ;mov	eax,(OBJECT PTR [edi]).heighttext
			  ;invoke bin2dec,10				  ;eax-->asciitbl+0 to +9 (10 digits)
			  ;;...returns eax->start of string, past the leading blanks.
			  ;invoke SendDlgItemMessage,hdlg,218,WM_SETTEXT,0,eax
			  ;invoke SendDlgItemMessage,hdlg,218,EM_LIMITTEXT,9,0 ;set limit.
				mov eax,(OBJECT PTR [edi]).fconfig4
				test  al,010000000b ;bit7=1 custom width/height calc.
				jnz q21 ;bit7=0 set checkbox...
				invoke SendDlgItemMessage,hdlg,211,BM_SETCHECK,1,0
				invoke SendDlgItemMessage,hdlg,217,EM_SETREADONLY,TRUE,0
				invoke SendDlgItemMessage,hdlg,218,EM_SETREADONLY,TRUE,0
q21:

;v1.48 set checkbox for text alignment...
				mov eax,(OBJECT PTR [edi]).fconfig4
				and ax,011100000000b ;bits10/9/8.
				.IF ax==0 ;automatic
				  mov ebx,223 ;id
				.ELSEIF ax==000100000000b ;left alignment.
		      mov ebx,224
				.ELSEIF ax==001000000000b ;right align.
				  mov ebx,225
				.ELSE
				  mov ebx,269 ;fully justified.
				.ENDIF
				invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0

;v3.04 don't-display-handle-if-locked checkbox...
        mov eax,(OBJECT PTR [edi]).fconfig1
        and ax,100h ;bit8.
        .IF ax != 0
				  invoke SendDlgItemMessage,hdlg,284,BM_SETCHECK,1,0
        .ENDIF


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;update label...
;problem is, must wipeout previous text first...
						invoke add2wipeoutlist,edi
						;invoke InvalidateRgn, g_hwnd,0,FALSE ;don't wipe background.
						;...done in add2wipeoutlist()
						mov g_fredrawdiag,WIPEOUTobjs
						push g_nmousex
						push g_nmousey
						invoke UpdateWindow, g_hwnd 	;wipe immediately.
						pop g_nmousey
						pop g_nmousex

;now get new label...
        invoke label_download_text,hdlg ;v3.52
        mov nsize,eax

      invoke label_download_common,hdlg ;v2.76.
      .IF eax != 0
        jmp noexitdlg
      .ENDIF
      invoke download_font,hdlg ;v3.50

      ;label-width, alignment, plain/html...
      invoke label_download_fconfig4,hdlg ;v3.51
      
;v3.04 checkbox for don't display handle if locked...
		  invoke SendDlgItemMessage,hdlg,284,BM_GETCHECK,0,0
		  .IF ax==1
		    or (OBJECT PTR [edi]).fconfig1,0100h ;set bit8.
		  .ELSE
		    and (OBJECT PTR [edi]).fconfig1,0FEFFh ;clr bit8.
		  .ENDIF

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF


;*WARNING* these must be last, as can invalidate the ptr edi...
;;bring the element to the front...
;		   invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,1 ;relocate at end of database.
;				 jmp j66
;		   .ENDIF
;;send the element to the back...
;		   invoke SendDlgItemMessage,hdlg,207,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,2 ;0 ;relocate at start of database.
;		   .ENDIF
;j66:
		invoke down_sendbackfront,hdlg,234,207



;      invoke DeleteObject,hnewfont ;v3.50
;		  invoke EndDialog, hdlg,TRUE
;noexitdlg:
;		  mov eax,TRUE
      jmp out0 ;exit from dlg. v3.50

		.ELSEIF eax==250  ;"external editor" button pressed
		  ;we want to launch the editor, spec'd in .szeditor2,
		  ;with a temp filename, say temp.txt, then on exit
		  ;read the file and zeroise it.
						mov edi,prbuttonobject
						mov eax,(OBJECT PTR [edi]).rpdata
						.IF eax==0
						.ELSE
						  add eax,pTERSEDATA
						  mov ebx,eax
							;lea eax,(OBJECT PTR [ebx]).sztext
							;v2.31
							;can have chained data...
							invoke chain2block,ebx,ADDR g_bigblock ;0 ;0=create a block.
							mov pmem,eax
							.IF eax != 0
								invoke openexternaleditor,eax,0,0
								.IF eax != 0 ;ret eax=0 if file not changed.
                  invoke DeleteObject,g_hnewfontedit ;v3.50
                  mov g_hnewfontedit,0
                  mov g_fkillfocus,0 ;v3.51
 				          invoke GlobalHandle,g_pmem0 ;v3.52
 				          invoke GlobalFree,eax
								  invoke EndDialog, hdlg,TRUE
								  invoke lstrlen,pmem
								  inc eax ;include terminating zero.
								          mov edx,edi  ;v2.60
								          sub edx,pTERSEDATA
								          push edx
                  invoke block2chain,pmem,edi,eax,0
                          pop edi
                          add edi,pTERSEDATA
                  ;...pmem->block, edi->label, eax=size of block.
								  ;invoke GlobalHandle,pmem
								  ;invoke GlobalFree,eax
								.ENDIF
							.ENDIF
						.ENDIF
		  mov eax,TRUE

		.ELSEIF eax==209 ;"choose a color" button pressed. font color.
		   invoke chooseacolor,hdlg,720 ;257 ;257=id of color-edit-box
		   ;mov eax,TRUE
		   jmp dn2 ;diag will repaint, immediately painting label. v3.51

		.ELSEIF eax==210 ;"choose a font" button pressed.
		  invoke chooseafont,hdlg,249,255,256,236 ;id's of font-size/type/style/charset edit boxs.
		  ;...now mylf LOGFONT structure is global. v3.50  *NO*
		  ;...writes font params to edit boxes in dlg box.
		  .IF eax != 0 ;0=cancelled.
		    ;need to download font params to element, as changing any param field will
		    ;(see cases below) call mycreatefont() which reads from the element...
;        invoke download_font,hdlg ;v3.50
;		      invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0 ;plain text.
;		      .IF ax != 0
;		        mov esi,edi
;		        ;mov (OBJECT PTR [edi]).nfontangle,0
;		        invoke mycreatefont ;enter esi->element. CreateFontIndirect,ADDR mylf ;v3.50
;            push eax ;handle of new font.
;            invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,eax,TRUE ;upload font to editbox.
;            invoke DeleteObject,g_hnewfontedit ;delete current temp font.
;            pop eax
;            mov g_hnewfontedit,eax
;          .ENDIF
;        ;note, must delete font when exit dialogbox.
;				;mov eax,TRUE ;erase previous.  v3.50
;				;jmp x11 ;redraw diagram.       /
;				jmp x11t
        jmp dn2
      .ENDIF
		  mov eax,TRUE

		.ELSEIF eax==211 ;"auto calc width/height text" checkbox.
		  invoke SendDlgItemMessage,hdlg,211,BM_GETCHECK,0,0
		  .IF ax==1
				invoke SendDlgItemMessage,hdlg,217,EM_SETREADONLY,TRUE,0
;				invoke SendDlgItemMessage,hdlg,218,EM_SETREADONLY,TRUE,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,217,EM_SETREADONLY,FALSE,0
;				invoke SendDlgItemMessage,hdlg,218,EM_SETREADONLY,FALSE,0
		  .ENDIF

		.ELSEIF eax==230 ;"Plain text" checkbox.
      ;invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,g_hnewfontedit,TRUE ;v3.50
      ;xor eax,eax ;not processed here.
      jmp dn2 ;v3.51
      
		.ELSEIF eax==231 ;"Markup tags text" checkbox.
      invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,g_hfixedfontedit,TRUE ;v3.50
			invoke SendDlgItemMessage,hdlg,211,BM_SETCHECK,0,0 ;choose customwidth.
			    ;make sure can edit custom-width box...
				  invoke SendDlgItemMessage,hdlg,217,EM_SETREADONLY,FALSE,0
				  ;if width=0, set it to a non-zero value...
					invoke SendDlgItemMessage,hdlg,217,WM_GETTEXT,10,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
				  .IF eax==0
				    mov eax,200
			      invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			      ;...returns eax->start of string, past the leading blanks.
			      invoke SendDlgItemMessage,hdlg,217,WM_SETTEXT,0,eax
				  .ENDIF				
			invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0 ;left justified.
			invoke SendDlgItemMessage,hdlg,223,BM_SETCHECK,0,0 ;auto justified.
			invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,0,0 ;right justified.
      ;xor eax,eax ;not processed here.
      jmp dn2 ;v3.51
      
;Note, code below is same as in iconproc() (can't really see how to extract as common)...
    .ELSEIF eax==DWORD PTR ((EN_KILLFOCUS*65536)+102) ;label text edit box. v3.51
      ;a bug, EN_CHANGE notification gets received with the control ids tested for
      ;below, before dlg box is fully setup.
      ;use a flag, set when main edit box gets kill-focus...
;      .IF g_fkillfocus != 0
;        jmp dn2 ;paint it on diagram.
;      .ENDIF
      inc g_fkillfocus ;must clr on exit from dlg box.
      jmp SHORT dn2 ;paint it on diagram. v3.52
nox1: xor eax,eax

    .ELSEIF eax==DWORD PTR ((EN_CHANGE*65536)+249) ;font size edit box changed. v3.50
dn2:  ;fix bug, wait until main edit box killfocus...
      .IF g_fkillfocus==0
        jmp nox1
      .ENDIF
      invoke label_repaint,hdlg,wparam ;v3.52
      xor eax,eax ;do default processing.
      ;...see call to test_controls_repaint() below, detects other controls.

		.ELSEIF eax==IDCANCEL
		  call label_restore_font_params ;v3.51
		  invoke SendDlgItemMessage,hdlg,102,WM_GETTEXTLENGTH,0,0
		  inc eax ;inc trailing 0.
		  mov nsize,eax
		  invoke block2chain,g_pmem0,edi,nsize,0 ;restore text. v3.52
out0: invoke DeleteObject,g_hnewfontedit ;v3.50
      mov g_hnewfontedit,0
      mov g_fkillfocus,0 ;v3.51
      invoke GlobalHandle,g_pmem0 ;v3.52
      invoke GlobalFree,eax
out9: invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE
		.ELSE ;eax has wparam.
      call test_controls_repaint ;enter eax=wparam, ret ebx. v3.52
      .IF ebx != 0
        jmp dn2
      .ENDIF
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
    mov eax,FALSE
x11: invoke windowchanged,eax ;eax=TRUE wipe background.
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

		ret
KENTER33proc	ENDP		   ;labelproc()
;--------------------------------------------------------------------------
;v2.30
block2chain PROC STDCALL USES ebx ecx edx esi edi,pmem:DWORD,plabel:DWORD, \
  nsize:DWORD,fimgdata2:DWORD
  LOCAL cntr1:DWORD,rpdata0:DWORD,plast0:DWORD
; "block2chain"  
;copy block of text to chained data elements attached to element plabel.
;if data elements don't exist, create them.
;v2.92 fimgdata2 =1 then destination is plabel.rpdata2 (for icons, pictures
;are attached here).

    mov rpdata0,0
    mov plast0,0
            ;pmem,plabel,nsize
            mov edi,plabel
                mov cntr1,0
                mov esi,edi ;edi->label element.
                .IF fimgdata2 != 0 ;v2.92
                  mov ebx,(OBJECT PTR [edi]).rpdata2
                  jmp SHORT koo2z
                .ENDIF
koo2:           mov ebx,(OBJECT PTR [esi]).rpdata
koo2z:
                .IF ebx==0
                  ;data element doesn't exist, so create it...
								  sub edi,pTERSEDATA ;ptr may get invalidated.
								  sub esi,pTERSEDATA ;/
								  mov ecx,prbuttonobject ;/
								  sub ecx,pTERSEDATA
								  push ecx
								  ;this func only works for g_nstate=0, but this may not always be
								  ;the case. a label may be highlighted (state2)....
								  .IF g_nstate==0
 								    invoke createnewobject,0
								  .ELSEIF g_nstate==2 ;highlighted object
								    .IF g_pselectedobject==0 ;precaution.
								      mov g_nstate,0 ;error.
 								      invoke createnewobject,0
								    .ELSE
								      mov edx,g_pselectedobject
								      sub edx,pTERSEDATA
								      push edx
								      mov g_nstate,0
								      invoke createnewobject,0
								      mov g_nstate,2
								      pop edx
								      add edx,pTERSEDATA
								      mov g_pselectedobject,edx
								    .ENDIF
								  .ELSE
								    ;don't allow creation of new object, as don't know
								    ;what state we're in.
								    xor eax,eax
								  .ENDIF
								  add edi,pTERSEDATA
								  add esi,pTERSEDATA
								  pop ecx
								  add ecx,pTERSEDATA
								  mov prbuttonobject,ecx
								  .IF eax==0
								    jmp koo4 ;failed, get out.
								  .ELSE
								    mov ebx,eax						 ;tell data-element
								    mov eax,esi						 ; /where parent
								    sub eax,pTERSEDATA				 ; /is
								    mov (OBJECT PTR [ebx]).rpowner1,eax ; /
								    xor eax,eax
								    mov (OBJECT PTR [ebx]).number,eax ;cos createnewobject setit.
								    mov (OBJECT PTR [ebx]).rpowner2,eax ;precaution.
								    mov (OBJECT PTR [ebx]).ximage,eax  ;/
								    mov (OBJECT PTR [ebx]).rpmethods,eax ;/ start of data area.
								    mov (OBJECT PTR [ebx]).nrings,eax ;=1 in instantiatedOBJECT.
								    mov (OBJECT PTR [ebx]).nbeginring,eax ;/
								    mov (OBJECT PTR [ebx]).nendring,eax ;/
								    mov (OBJECT PTR [ebx]).rpdata,eax ;v2.94 needed here.
								    mov (OBJECT PTR [ebx]).nexttype,-1 ;data-element.
								    ;  ;put size of data into first data element only...
								    ;  .IF fimgdata2==0
								    ;    mov eax,(OBJECT PTR [edi]).rpdata ;edi->label.
								    ;  .ELSE
								    ;    mov eax,(OBJECT PTR [edi]).rpdata2 ;attached picture.
								    ;  .ENDIF
								    ;  add eax,pTERSEDATA
								    ;  .IF eax==ebx  ;equal if 1st data element.
                    ;    mov eax,nsize
                    ;    mov (OBJECT PTR [ebx]).xdata,eax
                    ;    ;type of attached data. i'm not using this now...
                    ;    ;mov (OBJECT PTR [edi]).xdata,0 ;into label element.
                    ;    ;.IF fimgdata != 0 ;picture.
                    ;      ;i don't think will ever come here, as block2chain()
                    ;      ;gets called when edit a picture and chain already
                    ;      ;exits, in particular the 1st data element.
                    ;      ;icon.rpdata2->1st data element, don't have to set here.
                    ;    ;.ENDIF
                    ;  .ELSE
                    ;    mov (OBJECT PTR [ebx]).xdata,0
								    ;  .ENDIF
								    mov eax,ebx											 ;tell parent
								    sub eax,pTERSEDATA							 ; /where data-element
								    mov (OBJECT PTR [esi]).rpdata,eax  ; /is.
								    mov ebx,eax ;needed below.
								  .ENDIF
                .ENDIF
                
                ;v2.95 got a crash just below here. put in ok test...
                invoke ispointerok,ebx ;ebx is relative ptr.
                .IF eax==0 ;fail.
                  mov (OBJECT PTR [edi]).rpdata2,0 ;detach the picture.
                  mov (OBJECT PTR [esi]).rpdata,0 ;chop chain here.
                  invoke myalertbox,ADDR szer026,4 ;invoke myerrorhandler,026
                  jmp koo4 ;get out.
                .ENDIF
                
								  add ebx,pTERSEDATA
koo3:						  lea  esi,(OBJECT PTR [ebx]).sztext ;zeroise it first.
								  mov  ecx,256									  ;/
koo1:					    mov  [esi],BYTE PTR 0					  ;/
								  inc  esi												  ;/
								  loop koo1												  ;/
								  lea esi,(OBJECT PTR [ebx]).sztext
                  ;now copy from pmem...
                  mov eax,pmem
                  add eax,cntr1
                  push ebx
                  ;invoke lstrcpyn,esi,eax,256 ;note, will stop on 1st zero.
                    mov ebx,eax
		                mov ecx,256
j11:                mov al,[ebx]
		                mov [esi],al
		                inc esi
		                inc ebx
		                loop j11
                  pop ebx
                  add cntr1,256
                  ;finished?...
                  ;mark this as last data element in chain...
                  ;mov eax,(OBJECT PTR [ebx]).rpdata
                  ;mov rpdata0,eax  ;v2.94 save. if new obj, already zeroed above.
                  ;mov plast0,ebx   ;/
                  ;mov (OBJECT PTR [ebx]).rpdata,0 ;must do this.
								      ;put size of data into first data element only...
								      .IF fimgdata2==0
								        mov eax,(OBJECT PTR [edi]).rpdata ;edi->label.
								      .ELSE
								        mov eax,(OBJECT PTR [edi]).rpdata2
								      .ENDIF
								      add eax,pTERSEDATA
								      .IF eax==ebx  ;equal if 1st data element.
                        mov eax,nsize
                        mov (OBJECT PTR [ebx]).xdata,eax
                        ;type of attached data. i'm not using this now...
                        ;mov (OBJECT PTR [edi]).xdata,0 ;into label element.
                      .ELSE
                        mov (OBJECT PTR [ebx]).xdata,0
								      .ENDIF
                  mov eax,nsize
                  .IF cntr1<eax
                    ;get next 256-byte segment...
                    mov esi,ebx ;ebx->current data element.
                  ;  mov ebx,rpdata0 ;if next data element already exits, use it. v2.94
                  ;    ;v2.94 quick little precaution here...
                  ;    .IF ebx != 0
                  ;      add ebx,pTERSEDATA
                  ;      mov eax,(OBJECT PTR [ebx]).rpowner1 ;check owner.
                  ;      add eax,pTERSEDATA
                  ;      .IF eax != esi
                          jmp koo2 ;need a new data element.
                  ;      .ENDIF
                  ;      sub ebx,pTERSEDATA
                  ;    .ENDIF
                  ;  jmp koo2z
                  .ENDIF
                  mov plast0,ebx
                  mov eax,(OBJECT PTR [ebx]).rpdata
                  mov rpdata0,eax
                  mov (OBJECT PTR [ebx]).rpdata,0 ;last in chain

;v2.94 if shorter chain, chop extra off end...
    .IF rpdata0 != 0
      .IF plast0 != 0
        mov ebx,plast0
        mov esi,rpdata0
nxtd:   add esi,pTERSEDATA
        mov eax,(OBJECT PTR [esi]).rpowner1 ;is child attached to ebx?
        add eax,pTERSEDATA
        .IF eax==ebx
;          mov eax,(OBJECT PTR [esi]).fstatus
;          and eax,01
;          .IF eax==0
;            jmp SHORT by9 ;precaution.
;          .ENDIF
;...no, leave precaution out, as code will cleanup orphan chains.
          mov (OBJECT PTR [esi]).fstatus,0
          mov ebx,esi
          mov esi,(OBJECT PTR [ebx]).rpdata
          .IF esi != 0
            jmp nxtd
          .ENDIF
        .ENDIF
      .ENDIF
    .ENDIF
;by9: ;bypass
koo4:
  ret
block2chain ENDP
;--------------------------------------------------------------------------
chain2block PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,pblock:DWORD
		LOCAL nsize:DWORD,pmem:DWORD,cnt1:DWORD
; "chain2block"
;pobj->1st data element of a chain.
;pblock->destination block, =0 create a block.
;load from chain to a contiguous block, return ptr to block in eax, else 0.
		  mov ebx,pobj
		  .IF ebx==0
		    xor eax,eax
		    jmp t44 ;get out.
		  .ENDIF
		  mov eax,(OBJECT PTR [ebx]).xdata ;size of data.
		  mov nsize,eax
;now a memory block...
    .IF pblock==0
		  add eax,512 ;256 ;precaution, make block a bit bigger.
  ;mov g_errorapi,0B37h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke GlobalAlloc,GMEM_FIXED,eax
		  .IF eax==0
		    jmp t44 ;get out.
		  .ENDIF
		  mov pmem,eax
		.ELSE
		  mov eax,pblock
		  mov pmem,eax
		.ENDIF

;now copy the data across...
    mov cnt1,0
		mov ebx,pobj ;pts to 1st data-element.
		mov edi,pmem
k11:
		 lea esi,(OBJECT PTR [ebx]).sztext ;where data starts inside dataelement.
		 push ebx
		   ;invoke lstrcpyn,edi,esi,256  ---agh! seems to terminate on first zero.
		   mov ecx,256
j11:   mov al,[esi]
		   mov [edi],al
		   inc esi
		   inc edi
		   loop j11
		 pop ebx
		 add cnt1,256 ;#bytes copied.
		 .IF pblock != 0
		   ;using pre-existing block, of fixed size nBIGBLOCKSIZE.
		   .IF cnt1>=nBIGBLOCKSIZE
		     lea ebx,g_bigblock
		     add ebx,(nBIGBLOCKSIZE - 1)
		     mov [ebx],BYTE PTR 0 ;trailing zero.
         jmp SHORT kdone
		   .ENDIF
		 .ENDIF
		 mov eax,(OBJECT PTR [ebx]).rpdata ;next data element.
		 or eax,eax ;cmp eax,0
		 je kdone
		 add eax,pTERSEDATA
		 mov ebx,eax
		 jmp k11
kdone:

		mov eax,pmem
t44:
		ret
chain2block ENDP
;--------------------------------------------------------------------------



gridproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;from wmrbuttondown()/state0/on-an-grid-element "gridproc" id=300 in eve.rc.

				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

		invoke grid_common_upload,hdlg

		;display division calibration on screen...
			mov eax,(OBJECT PTR [edi]).fconfig3
			and al,0111000b ;bits3/4/5.
			.IF al==0  ;normal zoom.
			  mov ebx,312
			.ELSEIF al==01000b ;out1.
			  mov ebx,313
			.ELSEIF al==010000b ;out2.
			  mov ebx,314
			.ELSEIF al==011000b ;in1.
			  mov ebx,311
			.ELSEIF al==0100000b ;in2.
			  mov ebx,310
			.ENDIF
			invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0



		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1

		;update zoom-factor division calibration...
		  and (OBJECT PTR [edi]).fconfig3,0FFFFFFC7h ;clr bits 3/4/5.
		  invoke SendDlgItemMessage,hdlg,310,BM_GETCHECK,0,0 ;in2.
		  .IF ax==1
			mov ebx,0100000b
		  .ELSE
			invoke SendDlgItemMessage,hdlg,311,BM_GETCHECK,0,0 ;in1.
			.IF ax==1
			  mov ebx,011000b
			.ELSE
			  invoke SendDlgItemMessage,hdlg,312,BM_GETCHECK,0,0 ;normal.
			  .IF ax==1
				mov ebx,0
			  .ELSE
				invoke SendDlgItemMessage,hdlg,313,BM_GETCHECK,0,0 ;out1.
				.IF ax==1
				  mov ebx,001000b
				.ELSE ;out2.
				  mov ebx,010000b
				.ENDIF
			  .ENDIF
			.ENDIF
		  .ENDIF
		  or (OBJECT PTR [edi]).fconfig3,ebx

;*WARNING* must be last as can invalidate ptr edi...
		  invoke grid_common_download,hdlg
		  .IF eax==0
		  .ELSE
			jmp noexitdlg
		  .ENDIF




		  invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE




		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE				 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
gridproc	ENDP
;--------------------------------------------------------------------------
grid_common_upload PROC STDCALL, hdlg:DWORD
; "grid_common_upload"
;called from gridproc() and svgproc().
;uses edi passed in here unchanged.

		;display ring# on parent that label is on...
				;xor eax,eax
				mov eax,(OBJECT PTR [edi]).nbeginvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;eax-->asciitbl (10 digits+0)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,229,EM_LIMITTEXT,2,0 ;set limit.

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg

		;display hide grid checkbox...
			mov eax,(OBJECT PTR [edi]).fconfig3
			and ax,100h ;bit8.
			.IF ax==100h
			  invoke SendDlgItemMessage,hdlg,315,BM_SETCHECK,1,0
			.ENDIF

		;display show inter-division lines checkbox...
			mov eax,(OBJECT PTR [edi]).fconfig3
			and ax,200h ;bit9.
			.IF ax==200h
			  invoke SendDlgItemMessage,hdlg,316,BM_SETCHECK,1,0
			.ENDIF

		;display show division lines checkbox...
			mov eax,(OBJECT PTR [edi]).fconfig3
			and ax,400h ;bit10.
			.IF ax==400h
			.ELSE ;tick if bit10=0...
			  invoke SendDlgItemMessage,hdlg,319,BM_SETCHECK,1,0
			.ENDIF

		;display finetune of print-size... (similar to prefsproc())
				mov  eax,(OBJECT PTR [edi]).bez2x ;xfineprn ;x
				mov ebx,10 ;v1.38 stored as 0.1%, but now display in %.
				cdq 	   ; / extend sign into edx.
				idiv ebx   ; /
				neg eax ;v1.38 decided -ve to bring margins in.
				add eax,100 ;v1.52 display 0-scaling as 100% size.
				invoke bin2signedascii_upload,hdlg,eax,250,5
				mov  eax,(OBJECT PTR [edi]).bez2y ;yfineprn ;y
				mov ebx,10 ;v1.38 stored as 0.1%, but now display in %.
				cdq 	   ; / extend sign into edx.
				idiv ebx   ; /
				neg eax ;v1.38 decided -ve to bring margins in.
				add eax,100 ;v1.52 display 0-scaling as 100% size.
				invoke bin2signedascii_upload,hdlg,eax,317,5
				invoke SendDlgItemMessage,hdlg,250,EM_LIMITTEXT,4,0
				invoke SendDlgItemMessage,hdlg,317,EM_LIMITTEXT,4,0

		;display inches or centimetres... or pixels ...
				mov eax,(OBJECT PTR [edi]).fconfig3
				and al,011000000b ;bits6 and 7.
				.IF al==0		  ;inches.
				  mov ebx,303
				.ELSEIF al==001000000b ;bits7/6 =0/1 centimetres.
				  mov ebx,304
				.ELSEIF al==010000000b ;bits7/6 =1/0. pixels.
				  mov ebx,305
				.ELSE
				  mov ebx,303
				.ENDIF
				invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0


	ret
grid_common_upload ENDP
;--------------------------------------------------------------------------
grid_common_download PROC STDCALL, hdlg:DWORD
; "grid_common_download"
;called from gridproc() and svgproc().
;uses edi passed in here unchanged.

	;update number of object that owns this node ...
;	 invoke SendDlgItemMessage,hdlg,399,WM_GETTEXT,5,ADDR szasciitbl
;		  invoke str2longint, ADDR szasciitbl ;-->integer in eax
;		  ;special case 0, none owns me...
;		  ;(there is an element #0, but can't be an owner).
;		  .IF eax==0
;			mov (OBJECT PTR [edi]).nbeginverticex,0 ;which vertice attached to if poly.
;				   ;...note, exttype<30 uses .nbeginvertice field for this.
;			jmp e206
;		  .ENDIF
;		  mov ebx,pTERSEDATA
;		  ;validate...
;		  ;xor ecx,ecx
;		  mov ecx,(TERSEDATA PTR [ebx]).numrecords
;		  .IF eax>=ecx
;			;off end of database...
;e202:		invoke myerrorhandler,11
;			mov eax,1 ;return this flag.
;			jmp noexitdlg
;		  .ENDIF
;				 ;xor ecx,ecx
;				 mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
;				 mul ecx
;;				 lea edx,(TERSEDATA PTR [ebx]).OBJECTS
;				   mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
;				   add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
;				   add eax,edx			  ;eax->owner.
;				   mov ebx,eax
;						 mov ecx,(OBJECT PTR [ebx]).fstatus
;						 and ecx,01
;						 .IF ecx==0
;						   ;invalid element...
;						   jmp e202
;						 .ELSE
;						   mov ecx,(OBJECT PTR [ebx]).nexttype
;						   .IF SWORD PTR cx<0 ;ecx==-1
;								 ;invisible element...
;								 jmp e202
;						   .ENDIF
;						 .ENDIF
;				 sub eax,pTERSEDATA
;e206:	 mov  (OBJECT PTR [edi]).rpowner1,eax
		invoke down_owner,hdlg,399,0
		or eax,eax ;cmp eax,0
		je noexitdlg

		;update ring# on parent that label is set to...must be after get-owner.
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax==0
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginvertice,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,229,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				add ebx,pTERSEDATA				
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginvertice,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginvertice,0
byp1:     ;bypass.								
		  .ENDIF

;update lock state...
		invoke down_lock,hdlg
;		   invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
;		   .IF ax==1
;				 or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
;		   .ELSE
;				 and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
;		   .ENDIF

		;update hide grid ...
		  and (OBJECT PTR [edi]).fconfig3,0FFFFFEFFh ;clr bit8
		  invoke SendDlgItemMessage,hdlg,315,BM_GETCHECK,0,0
		  .IF ax==1
			or (OBJECT PTR [edi]).fconfig3,0100h ;set bit8.
		  .ENDIF

		;update show inter-division lines ...
		  and (OBJECT PTR [edi]).fconfig3,0FFFFFDFFh ;clr bit9
		  invoke SendDlgItemMessage,hdlg,316,BM_GETCHECK,0,0
		  .IF ax==1
			or (OBJECT PTR [edi]).fconfig3,0200h ;set bit9.
		  .ENDIF

		;update show division lines ...
		  and (OBJECT PTR [edi]).fconfig3,0FFFFFBFFh ;clr bit10
		  invoke SendDlgItemMessage,hdlg,319,BM_GETCHECK,0,0
		  .IF ax==1
		  .ELSE ;not ticked, set bit10...
			or (OBJECT PTR [edi]).fconfig3,0400h ;set bit10.
		  .ENDIF

		;update finetune of print-size...
				invoke SendDlgItemMessage,hdlg,250,WM_GETTEXT,5,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				sub eax,100 ;v1.52 100% stored as 0-relative signed#.
				;finetune is in %, limit range -50 to +50%...
				;...no, svgproc() needs bigger range...
				.IF SDWORD PTR eax>500
				  mov eax,500 ;50
				.ELSEIF SDWORD PTR eax<-90
				  mov eax,-90 ;-50
				.ENDIF
				neg eax ;v1.38 decided -ve to bring margins in.
				;v1.38 displayed in % but stored as 0.1%...
				mov ebx,10
				imul ebx
				mov  (OBJECT PTR [edi]).bez2x,eax			 ;x
				invoke SendDlgItemMessage,hdlg,317,WM_GETTEXT,5,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				sub eax,100 ;v1.52 100% stored as 0-relative signed#.
				.IF SDWORD PTR eax>500 ;50 ;zoom in.
				  mov eax,500 ;50
				.ELSEIF SDWORD PTR eax<-90 ;-50 ;zoom out.
				  mov eax,-90 ;-50
				.ENDIF
				neg eax ;v1.38 decided -ve to bring margins in.
				;v1.38 displayed in % but stored as 0.1%...
				mov ebx,10
				imul ebx
				mov  (OBJECT PTR [edi]).bez2y,eax			 ;x

		;update inches or centimetres... or pixels ...
		  and (OBJECT PTR [edi]).fconfig3,0FFFFFF3Fh ;clr bits6/7.
		  invoke SendDlgItemMessage,hdlg,303,BM_GETCHECK,0,0 ;inches.
		  .IF ax==1
		  .ELSE   ;centimetres.
			invoke SendDlgItemMessage,hdlg,304,BM_GETCHECK,0,0 ;cm.
			.IF ax==1
				or (OBJECT PTR [edi]).fconfig3,01000000b ;set bit6.
			.ELSE
				or (OBJECT PTR [edi]).fconfig3,010000000b ;set bit7, pixels.
			.ENDIF
		  .ENDIF

;*WARNING* these must be last, as can invalidate the ptr edi...
;		 ;bring the element to the front...
;		   invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,1 ;relocate at end of database.
;				 jmp j66
;		   .ENDIF
;		 ;send the element to the back...
;		   invoke SendDlgItemMessage,hdlg,207,BM_GETCHECK,0,0
;		   .IF ax==1
;				 invoke move1object,edi,2 ;0 ;relocate at start of database.
;		   .ENDIF
;j66:	   ;...move1object returns address new object location in eax.
		invoke down_sendbackfront,hdlg,234,207



	xor eax,eax ;normal exit.
noexitdlg:		;returns with eax=1
	ret
grid_common_download ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
;szwebsite BYTE "c:\Program Files\Internet Explorer\iexplore.exe http://myeve.org",0
sz9xwebsite   BYTE "start.exe " 		;http://goosee.com",0
szwebsite	  BYTE "http://goosee.com",0   ;/ must be together.
sz9xwewebsite BYTE "start.exe " 				;http://goosee.com/evewe/",0
szwewebsite   BYTE "http://goosee.com/evewe/",0 ;/ must be together.
szeveversion BYTE sEVEVERSION   ;defined in eve.inc.
             BYTE 0

.CODE
aboutproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL dummy:DWORD
		;LOCAL szeveversion[8]:BYTE
; "aboutproc"		
;from Control/About... -> idm_about

				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

    ;v3.07 upload version #:
    ;mov DWORD PTR szeveversion,sEVEVERSION   ;string, version # (see eve.inc).
    ;mov szeveversion+4,0
	  invoke SendDlgItemMessage,hdlg,103,WM_SETTEXT,0,ADDR szeveversion

		  mov eax,TRUE

  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
out2:	  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE

		.ELSEIF wparam==113 ;go to www.goosee.com website...
		  .IF fNT==0 ;win9x.
			invoke WinExec, ADDR sz9xwebsite,SW_SHOW
		  .ELSE ;winNT+
			invoke ShellExecute,g_hwnd,ADDR szopen,ADDR szwebsite,0,0,0
		  .ENDIF
		  ;lea eax,szwebsite						   ;v2.14.
		  ;mov myshell.lpFile,eax
		  ;invoke ShellExecuteEx,ADDR myshell
		  mov eax,TRUE
		  ;jmp out2
		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
aboutproc				ENDP
;--------------------------------------------------------------------------
aboutweproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL dummy:BYTE
;from Control/About... -> idm_aboutwe
				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG
		  mov eax,TRUE

  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
out2:	  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE

		.ELSEIF wparam==113 ;go to website...
		  .IF fNT==0 ;win9x.
			invoke WinExec, ADDR sz9xwewebsite,SW_SHOW
		  .ELSE
			invoke ShellExecute,g_hwnd,ADDR szopen,ADDR szwewebsite,0,0,0
		  .ENDIF
		  mov eax,TRUE
		  ;jmp out2
		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

	ret
aboutweproc ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
mycolor CHOOSECOLOR <0,0,0,0,0,0,0,0,0>
;note, arraycolors is in TERSEDATA.

.CODE
chooseacolor PROC STDCALL USES ebx ecx edx edi esi,hdlg:DWORD,nboxid:DWORD
		LOCAL nrgb:DWORD
;		 LOCAL mycolor:CHOOSECOLOR
; "chooseacolor"
;from "choose a color" button on dialog boxes.
;nboxid is id of color-edit-box.
;v2.94 nboxid =red, +1 =green, +2 =blue.
;nboxid=0, no edit box, input color is in eax, return color in eax only. v3.40
;return eax=-1 if cancelled. v3.40
    .IF nboxid==0 ;v3.40
      mov nrgb,eax
    .ENDIF

		mov mycolor.lStructSize,SIZEOF CHOOSECOLOR
		mov eax,g_hwnd
		mov mycolor.hwndOwner,eax
		mov mycolor.hInstance,0
		.IF nboxid != 0 ;v3.40
      lea ecx,nrgb
      invoke download_rgbcolor,hdlg,ecx,nboxid ;v2.94.
    .ENDIF
      mov eax,nrgb
		  mov mycolor.rgbResult,eax
		mov ebx,pTERSEDATA
		lea eax,(TERSEDATA PTR [ebx]).arraycolors
		mov mycolor.lpCustColors,eax
		mov mycolor.Flags,CC_FULLOPEN+CC_RGBINIT
		mov mycolor.lCustData,0
		mov mycolor.lpfnHook,0
		mov mycolor.lpTemplateName,0
		lea eax,mycolor
    ;mov g_errorapi,0B38h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		invoke ChooseColor,eax
		.IF eax==0 ;cancelled
		  mov eax,-1
		.ELSE
				mov eax,mycolor.rgbResult
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
;				invoke SendDlgItemMessage,hdlg,nboxid,WM_SETTEXT,0,esi
;				;...ALL dlg boxes must have color-edit-box same id number!!!
      .IF nboxid != 0 ;v3.40
        invoke upload_rgbcolor,hdlg,eax,nboxid ;nboxid=id red. v2.94.
      .ENDIF
			mov eax,mycolor.rgbResult ;v3.40
		.ENDIF
		ret
chooseacolor ENDP
;--------------------------------------------------------------------------
chooseafont PROC STDCALL USES ebx ecx edx edi esi,hdlg:DWORD, \
														sizeid:DWORD,typeid:DWORD,styleid:DWORD,charsetid:DWORD
		LOCAL mycf:CHOOSEFONT
		LOCAL mylf:LOGFONT
		LOCAL fontstyle:DWORD
; "chooseafont"
;ret eax=0 cancelled. v3.50

		mov mycf.lStructSize,SIZEOF CHOOSEFONT
		mov eax,g_hwnd
		mov mycf.hWndOwner,eax
		lea eax,mylf
		mov mycf.lpLogFont,eax
		mov mycf.lCustData,0
		mov mycf.nFontType,0
		mov mycf.Flags,CF_SCREENFONTS+CF_NOFACESEL+CF_TTONLY ;+CF_NOSTYLESEL+CF_NOSIZESEL
  ;mov g_errorapi,0B39h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		invoke ChooseFontA,ADDR mycf
		or eax,eax ;cmp eax,0 ;fail.
		je out1

		  ;should have all selected info in LOGFONT structure...
		  ;CHOOSEFONT gets set with selected point size after return from ChooseFont()...
		  xor edx,edx
		  mov eax,mycf.iPointSize
		  mov ecx,10
		  div ecx ;size is in 1/10ths point.
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,sizeid,WM_SETTEXT,0,eax

				;now get selected bold/italic style...
				mov eax,mylf.lfWeight
				.IF eax<=500 ;normal
				  mov fontstyle,0
				.ELSE ;bold
				  mov fontstyle,1
				.ENDIF
				mov al,mylf.lfItalic
				.IF al==TRUE
				  add fontstyle,2
				.ENDIF
				mov eax,fontstyle
				invoke SendDlgItemMessage,hdlg,styleid,CB_SETCURSEL,eax,0

				;now get name of font...
				lea eax,mylf.lfFaceName ;32 bytes.
				;append to drop-down list...
				invoke lstrcpy,ADDR szfx,eax
				lea eax,szfx
				;insert at 4th entry...
				invoke SendDlgItemMessage,hdlg,typeid,CB_INSERTSTRING,3,eax
				;if there is a 5th entry, delete it...
				invoke SendDlgItemMessage,hdlg,typeid,CB_DELETESTRING,4,0
				;4th entry in listbox will be the new font...
				invoke SendDlgItemMessage,hdlg,typeid,CB_SETCURSEL,3,0

				;now get character set...
				xor eax,eax
				mov al,mylf.lfCharSet
				mov charsettemp,eax ;read after "ok" dlg box.
				invoke charsetname,eax ;returns eax ptg to szname of char set.
;				 invoke bin2dec,10						;eax-->asciitbl+0 to +9 (10 digits)
;				 ;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,charsetid,WM_SETTEXT,0,eax

    mov eax,1 ;v3.50 ok.
out1:
		ret
chooseafont ENDP
;--------------------------------------------------------------------------
label_upload_common PROC STDCALL,hdlg:DWORD
; "label_upload_common"
;common upload code for labelproc(), iconproc().

;set checkbox display label...
				mov eax,(OBJECT PTR [edi]).fstatus
				;bit5 = display label on diagram
				test  al,00100000b
				jz ke21
				invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0
ke21:

;NOTE: for label and icon,
; .nbeginvertice, clashes with .szfontname. same for icon. so, we
;use a different field, .nbeginverticex instead of .nbeginvertice if attached
;to a poly...
;display ring# on parent that action is on...
				mov eax,(OBJECT PTR [edi]).nbeginverticex
				.IF eax==0
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;eax-->asciitbl (10 digits+0)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
 invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,229,EM_LIMITTEXT,2,0 ;set limit.

;display label x/y offset...
				mov  eax,(OBJECT PTR [edi]).xlabeloffset ;x
				invoke bin2signedascii_upload,hdlg,eax,240,3
				mov  eax,(OBJECT PTR [edi]).ylabeloffset ;y
				invoke bin2signedascii_upload,hdlg,eax,241,3

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg

;display angle of text...
				mov  eax,(OBJECT PTR [edi]).nfontangle
				cdq ;sign-extend into edx.
				mov ecx,10
				idiv ecx ;stored as 1/10 degree.
				invoke bin2signedascii_upload,hdlg,eax,263,5

;display font style in listbox...
		mov ecx,4
		lea esi,szfontstyles
exxhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 exximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,256,CB_ADDSTRING,0,esi
		pop ecx
		add esi,12
		loop exxhmmzz
exximmzz:
		mov eax,(OBJECT PTR [edi]).nfontstyle
		invoke SendDlgItemMessage,hdlg,256,CB_SETCURSEL,eax,0

;display font color...
				mov  eax,(OBJECT PTR [edi]).nfontcolor
;				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
;				;...returns eax->start of string, past the leading blanks.
;				mov esi,eax
; invoke SendDlgItemMessage,hdlg,257,WM_SETTEXT,0,esi
; invoke SendDlgItemMessage,hdlg,257,EM_LIMITTEXT,9,0 ;set limit.
    invoke upload_rgbcolor,hdlg,eax,720 ;v2.94.

;display font type in listbox...
		mov eax,(OBJECT PTR [edi]).nfonttype
		.IF eax>=3 ;custom font currently selected.
		  lea eax,(OBJECT PTR [edi]).szfontname
		  invoke lstrcpy,ADDR szfx,eax
		.ENDIF
		mov ecx,4 ;3
		lea esi,szfonttypes
xhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 ximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,255,CB_ADDSTRING,0,esi
		pop ecx
		add esi,32 ;16
		loop xhmmzz
ximmzz:
		mov eax,(OBJECT PTR [edi]).nfonttype
		invoke SendDlgItemMessage,hdlg,255,CB_SETCURSEL,eax,0

;display font size...
				mov  eax,(OBJECT PTR [edi]).nfontsize
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,249,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,249,EM_LIMITTEXT,3,0 ;set limit.

;display current character set...
				mov eax,(OBJECT PTR [edi]).ncharset
				mov charsettemp,eax
				invoke charsetname,eax ;returns eax ptg to szname of char set.
				invoke SendDlgItemMessage,hdlg,236,WM_SETTEXT,0,eax

;display underline/strikethru checkboxes...
				mov eax,(OBJECT PTR [edi]).ffonteffects
				test al,01 ;bit0=1 strikethru.
				jz c01
				  push eax
				  invoke SendDlgItemMessage,hdlg,242,BM_SETCHECK,1,0
				  pop eax
c01:	  test al,010b ;bit1=1 underline.
				jz c02
				  invoke SendDlgItemMessage,hdlg,243,BM_SETCHECK,1,0
c02:

    mov eax,(OBJECT PTR [edi]).nfontsize ;v3.50
    mov nfontsizesaved,eax
    mov eax,(OBJECT PTR [edi]).nfontcolor ;v3.50
    mov nfontcolorsaved,eax
    mov eax,(OBJECT PTR [edi]).nfontstyle ;v3.50
    mov nfontstylesaved,eax
    mov eax,(OBJECT PTR [edi]).nfonttype ;v3.50
    mov nfonttypesaved,eax
    mov eax,(OBJECT PTR [edi]).ncharset ;v3.50
    mov ncharsetsaved,eax
    mov eax,(OBJECT PTR [edi]).ffonteffects ;v3.50
    mov ffonteffectssaved,eax
    mov eax,(OBJECT PTR [edi]).nfontangle
    mov nfontanglesaved,eax
    mov eax,(OBJECT PTR [edi]).xlabeloffset
    mov xlabeloffsetsaved,eax
    mov eax,(OBJECT PTR [edi]).ylabeloffset
    mov ylabeloffsetsaved,eax
    mov eax,(OBJECT PTR [edi]).fconfig4
    mov fconfig4saved,eax
    mov eax,(OBJECT PTR [edi]).widthtext
    mov widthtextsaved,eax

;this must be after saving fields, and uploading .nfontangle...
;v3.50 label editbox to show correct font...
    invoke GetStockObject,ANSI_FIXED_FONT ;note, doesn't need to be deleted.
    mov g_hfixedfontedit,eax ;global.
    mov esi,edi
    mov (OBJECT PTR [edi]).nfontangle,0 ;note, already uploaded.
    invoke mycreatefont ;requires esi->element. ret eax=hnewfont.
    mov g_hnewfontedit,eax ;global.
		mov eax,(OBJECT PTR [edi]).fconfig4
		and ax,0800h ;bit11.
    .IF ax==0 ;plain text.
      mov eax,g_hnewfontedit
    .ELSE ;html text.
      mov eax,g_hfixedfontedit
    .ENDIF
    invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,eax,TRUE
    ;note, must delete g_hnewfontedit when exit dialogbox.
      ;must restore .nfontangle now, as diagram gets painted while dlg box open... v3.51
      mov eax,nfontanglesaved
      mov (OBJECT PTR [edi]).nfontangle,eax

  ret
label_upload_common ENDP
;--------------------------------------------------------------------------
label_download_common PROC STDCALL,hdlg:DWORD
; "label_download_common"
;common download code for labelproc(), iconproc().
;enter edi->element.
;return eax=TRUE if not exit dlg.

				invoke SendDlgItemMessage,hdlg,228,BM_GETCHECK,0,0
				mov ebx,(OBJECT PTR [edi]).fstatus
				.IF ax==1				;display-label button is checked.
				  or  bl,00100000b
				.ELSE
				  and bl,11011111b
				.ENDIF
				mov (OBJECT PTR [edi]).fstatus,ebx ;bl


		invoke down_owner,hdlg,399,0
		or eax,eax ;cmp eax,0
		je noexitdlg

;update ring# on parent that label is set to...must be after get-owner.
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax==0
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginverticex,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,229,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				add ebx,pTERSEDATA				
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  ;NOTE: label/icon use .nbeginverticex instead of .nbeginvertice...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginverticex,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginverticex,0
byp1:     ;bypass.								
		  .ENDIF

;update lock state...
		invoke down_lock,hdlg

  xor eax,eax
out1:
  ret
noexitdlg:
  mov eax,TRUE
  jmp out1
label_download_common ENDP
;--------------------------------------------------------------------------
download_font PROC STDCALL USES ebx ecx edx esi edi,hdlg:DWORD
; "download_font"
;enter edi->element

;update font style from listbox...
		invoke SendDlgItemMessage,hdlg,256,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).nfontstyle,eax

;update font type from listbox...
		invoke SendDlgItemMessage,hdlg,255,CB_GETCURSEL,0,0
		and eax,0Fh
		mov  (OBJECT PTR [edi]).nfonttype,eax
		.IF eax>=3 ;custom font selected.
		  lea eax,(OBJECT PTR [edi]).szfontname
		  invoke lstrcpy,eax,ADDR szfx
		.ENDIF

;update the .nfontsize field...
 invoke SendDlgItemMessage,hdlg,249,WM_GETTEXT,4,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->eax
				mov (OBJECT PTR [edi]).nfontsize,eax

;update character set...
;		   invoke SendDlgItemMessage,hdlg,236,WM_GETTEXT,10,ADDR szasciitbl
;				 invoke str2longint, ADDR szasciitbl ;-->eax
				mov eax,charsettemp
				mov (OBJECT PTR [edi]).ncharset,eax

;update underline/strikethru...
		  invoke SendDlgItemMessage,hdlg,243,BM_GETCHECK,0,0 ;underline.
		  .IF ax==1
				or (OBJECT PTR [edi]).ffonteffects,010b
		  .ELSE
				and (OBJECT PTR [edi]).ffonteffects,0FFFFFFFDh ;clr bit1.
		  .ENDIF
		  invoke SendDlgItemMessage,hdlg,242,BM_GETCHECK,0,0 ;strikethru.
		  .IF ax==1
				or (OBJECT PTR [edi]).ffonteffects,01
		  .ELSE
				and (OBJECT PTR [edi]).ffonteffects,0FFFFFFFEh ;clr bit0.
		  .ENDIF

;update the .nfontcolor field...
; invoke SendDlgItemMessage,hdlg,257,WM_GETTEXT,10,ADDR szasciitbl
;				invoke str2longint, ADDR szasciitbl ;-->eax
;				mov (OBJECT PTR [edi]).nfontcolor,eax
    lea eax,(OBJECT PTR [edi]).nfontcolor
    invoke download_rgbcolor,hdlg,eax,720 ;ids=720,721,722. rgb.

;get label x/y offset...
 invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,4,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				mov  (OBJECT PTR [edi]).xlabeloffset,eax				;x offset
 invoke SendDlgItemMessage,hdlg,241,WM_GETTEXT,4,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				mov  (OBJECT PTR [edi]).ylabeloffset,eax ;y offset

;get text angle...
 invoke SendDlgItemMessage,hdlg,263,WM_GETTEXT,6,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				mov ecx,10
				imul ecx ;stored as 1/10 degree value.
				mov  (OBJECT PTR [edi]).nfontangle,eax ;y offset

  xor eax,eax
  ret
download_font ENDP
;--------------------------------------------------------------------------
upload_rgbcolor PROC STDCALL USES esi edi, hdlg:DWORD,nrgbcolor:DWORD,id7xx:DWORD ;v2.94.
  LOCAL dummy:DWORD
; "upload_rgbcolor"
;id7xx = id for red, +1 =green, +2 =blue.
    mov eax,nrgbcolor
    mov edi,id7xx
      and eax,0FFh ;get red.
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  invoke SendDlgItemMessage,hdlg,edi,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,edi,EM_LIMITTEXT,3,0 ;set limit.
    mov eax,nrgbcolor
    inc edi
      and eax,0FF00h
      shr eax,8 ;get green.
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  invoke SendDlgItemMessage,hdlg,edi,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,edi,EM_LIMITTEXT,3,0 ;set limit.
    mov eax,nrgbcolor
    inc edi
      and eax,0FF0000h
      shr eax,16 ;get blue.
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  invoke SendDlgItemMessage,hdlg,edi,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,edi,EM_LIMITTEXT,3,0 ;set limit.
  ret
upload_rgbcolor ENDP
;--------------------------------------------------------------------------
download_rgbcolor PROC STDCALL USES esi edi, hdlg:DWORD,pdestfield:DWORD,id7xx:DWORD
  LOCAL dummy:DWORD
; "download_rgbcolor"
;id7xx = 3 contiguous ids, for red,green,blue.

  mov edi,pdestfield
  mov esi,id7xx
   invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,4,ADDR szasciitbl ;red.
   invoke str2longint, ADDR szasciitbl ;-->eax
   and eax,0FFh ;precaution.
   mov [edi],eax
   inc esi
   invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,4,ADDR szasciitbl ;green.
   invoke str2longint, ADDR szasciitbl ;-->eax
   and eax,0FFh ;precaution.
   shl eax,8
   or [edi],eax
   inc esi
   invoke SendDlgItemMessage,hdlg,esi,WM_GETTEXT,4,ADDR szasciitbl ;blue.
   invoke str2longint, ADDR szasciitbl ;-->eax
   and eax,0FFh ;precaution.
   shl eax,16
   or [edi],eax

  ret
download_rgbcolor ENDP
;--------------------------------------------------------------------------
.DATA
g_fkillfocus DWORD 0 ;v3.51

.CODE ;.DATA v3.01
sztexticonaction   BYTE "OPEN A TEXT-FILE WITH EXTERNAL EDITOR",0
sztexticonfilespec BYTE "[path]filename of text-file:",0
szexeciconaction   BYTE "EXECUTE AN MSWINDOWS APPLICATION",0
szexeciconfilespec BYTE "Execution commandline:",0
szeveiconaction    BYTE "OPEN ANOTHER .EVE DIAGRAM",0
szeveiconfilespec  BYTE "[path]filename of .EVE file:",0
;v2.78 generic icon is the only icon type supported now...
szgenericiconaction BYTE "DISPLAY A BITMAP/RASTER PICTURE",0 ;"NO DOUBLECLICK ACTION",0
szgenericiconfilespec BYTE "Title of picture (255 chars max.):",0
szsoundiconaction BYTE "PLAY A SOUND FILE",0
szsoundiconfilespec BYTE "[path]filename of a sound file:",0
szwwwiconaction BYTE "OPEN WEB BROWSER AT URL",0
szwwwiconfilespec BYTE "Full internet URL (include http:// or ftp://):",0
;v3.04...
szgotoaction  BYTE "SCROLL DIAGRAM TO DESTINATION COORD",0
szgotofilespec BYTE "Format: [x=sn|h=sn] [y=sn|v=sn] [t=un]",0
szobsolete BYTE "OBSOLETE: SUPERCEDED BY LINK ACTIVATOR",0

.CODE
iconproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
    LOCAL picfiletype:DWORD
		LOCAL flocked:BYTE
;from wmrbuttondown()/state0/on-an-action-object "iconproc"
; *EVE* this is the callback for icons, based on label-element callback.
;goosee had infoproc id=223 for text-file icon, and commandproc id=222
;for execution icon, now replaced with this.

;  mov eax,message
;  mov test_message,eax
;  mov eax,wparam
;  mov test_wparam,eax
;  mov eax,lparam
;  mov test_lparam,eax
  
				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;display label...
				mov ebx,(OBJECT PTR [edi]).rpdata		;data-element.
				.IF ebx != 0
				  add ebx,pTERSEDATA
				  lea esi,(OBJECT PTR [ebx]).sztext ;start of data area.
				  invoke SendDlgItemMessage,hdlg,102,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,102,EM_LIMITTEXT,255,0
				.ENDIF


    invoke label_upload_common,hdlg ;v2.76.

      ;v3.19
      ;master invisibility flag...
      ;(note, bit5=label visibility, done in label_upload_common() above).
      mov eax,(OBJECT PTR [edi]).fstatus
      and eax,400h ;bit10=1 element is invisible.
      .IF eax != 0
				invoke SendDlgItemMessage,hdlg,500,BM_SETCHECK,1,0
      .ENDIF

      ;upload color morphing...  v3.40
      invoke upload_morphing,hdlg

;now need to upload some read-only text strings...
		mov eax,(OBJECT PTR [edi]).nexttype
		.IF ax==61		;text-file icon
				  lea esi,sztexticonaction
				  lea ebx,szobsolete ;v2.78 sztexticonfilespec
		.ELSEIF ax==60 ;execution icon.
				  lea esi,szexeciconaction
				  lea ebx,szobsolete ;v2.78 szexeciconfilespec
		.ELSEIF ax==62 ;eve icon.
				  lea esi,szeveiconaction
				  lea ebx,szobsolete ;v2.78 szeveiconfilespec
		.ELSEIF ax==63 ;generic icon.
do1:	  lea esi,szgenericiconaction
				  lea ebx,szgenericiconfilespec
		.ELSEIF ax==64 ;sound icon.
				  lea esi,szsoundiconaction
				  lea ebx,szobsolete ;v2.78 szsoundiconfilespec
		.ELSEIF ax==65 ;WWW icon.
				  lea esi,szwwwiconaction
				  lea ebx,szobsolete ;v2.78 szwwwiconfilespec
		.ELSE
		  jmp do1
		.ENDIF
		invoke SendDlgItemMessage,hdlg,203,WM_SETTEXT,0,esi
		invoke SendDlgItemMessage,hdlg,204,WM_SETTEXT,0,ebx

;display which graphic/text file attached... (0=nothing)
				mov  eax,(OBJECT PTR [edi]).nlibrary
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,213,WM_SETTEXT,0,esi
				invoke SendDlgItemMessage,hdlg,213,EM_LIMITTEXT,3,0 ;set limit.

;;display which type of icon...
;				mov eax,(OBJECT PTR [edi]).nexttype
;				.IF ax==60 ;execution icon
;				  mov ecx,222
;				.ELSEIF ax==61 ;text-file icon
;				  mov ecx,223
;				.ELSEIF ax==62 ;eve icon
;				  mov ecx,224
;				.ELSEIF ax==64 ;sound
;				  mov ecx,230
;				.ELSEIF ax==65 ;WWW icon.
;				  mov ecx,231
;				.ELSE ;generic icon
;				  mov ecx,225
;				.ENDIF
;				invoke SendDlgItemMessage,hdlg,ecx,BM_SETCHECK,1,0

;display how many pictures in library...
				mov ebx,pTERSEDATA
				mov  eax,(TERSEDATA PTR [ebx]).numbitmaps
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,245,WM_SETTEXT,0,eax

;v1.45 display width/height...
			  mov  eax,(OBJECT PTR [edi]).wwidth
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  ;...returns eax->start of string, past the leading blanks.
			  invoke SendDlgItemMessage,hdlg,252,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,252,EM_LIMITTEXT,4,0 ;set limit.
			  mov  eax,(OBJECT PTR [edi]).height
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  ;...returns eax->start of string, past the leading blanks.
			  invoke SendDlgItemMessage,hdlg,253,WM_SETTEXT,0,eax
			  invoke SendDlgItemMessage,hdlg,253,EM_LIMITTEXT,4,0 ;set limit.
				mov eax,(OBJECT PTR [edi]).fconfig4
				test  al,01000b ;bit3=1 locked.
				jnz q21
				invoke SendDlgItemMessage,hdlg,252,EM_SETREADONLY,TRUE,0
				invoke SendDlgItemMessage,hdlg,253,EM_SETREADONLY,TRUE,0
q21:

;v1.85 display original width/height (readonly)...
			  mov  eax,(OBJECT PTR [edi]).origwidth
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  ;...returns eax->start of string, past the leading blanks.
			  invoke SendDlgItemMessage,hdlg,270,WM_SETTEXT,0,eax
			  mov  eax,(OBJECT PTR [edi]).origheight
			  invoke bin2dec,10 				 ;eax-->asciitbl+0 to +9 (10 digits)
			  ;...returns eax->start of string, past the leading blanks.
			  invoke SendDlgItemMessage,hdlg,271,WM_SETTEXT,0,eax


;v1.84
;selectable only on boundary...
			mov eax,(OBJECT PTR [edi]).fconfig1
			and al,010b ;bit1.
			.IF al != 0 ;==010b
				invoke SendDlgItemMessage,hdlg,266,BM_SETCHECK,1,0
			.ENDIF
			
;v2.90 use transparent color...			
      mov eax,(OBJECT PTR [edi]).fconfig1
      and al,80h ;bit7=1 use transparent color.
      .IF al != 0
				invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
      .ENDIF
;and upload the transparent color...
      mov eax,(OBJECT PTR [edi]).rgbtransparent
      invoke upload_rgbcolor,hdlg,eax,700 ;700=id red.
      


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
    mov eax,wparam
		.IF eax==IDOK
		  mov  g_fhaschanged,1

;all of below is same as label-element, callback labelproc.***NOTE***

;update label...
;						  mov ebx,(OBJECT PTR [edi]).rpdata
;						  .IF ebx==0
;						  .ELSE
;								add ebx,pTERSEDATA
;								lea  esi,(OBJECT PTR [ebx]).sztext ;zeroise it first.
;								mov  ecx,256									  ;/
;zoo1:					mov  [esi],BYTE PTR 0					  ;/
;								inc  esi												  ;/
;								loop zoo1												  ;/
;								lea esi,(OBJECT PTR [ebx]).sztext
;								invoke SendDlgItemMessage,hdlg,102,WM_GETTEXT,256,esi
;						  .ENDIF
        invoke label_download_text,hdlg ;v3.52
        ;...note, same func used in labelproc(). can download to chained data if >256.
        ;mov nsize,eax

      invoke label_download_common,hdlg ;v2.76.
      .IF eax != 0
        jmp noexitdlg
      .ENDIF
      invoke download_font,hdlg ;v3.50

    ;commented out, as don't have these in picture icon (labelproc() does)...
    ;;label-width, alignment, plain/html...
    ;invoke label_download_fconfig4,hdlg ;v3.51

      ;v3.19
      ;master invisiblity flag...
      invoke SendDlgItemMessage,hdlg,500,BM_GETCHECK,0,0
      .IF ax==0
        and (OBJECT PTR [edi]).fstatus,0FFFFFBFFh ;clr bit10.
      .ELSE
        or (OBJECT PTR [edi]).fstatus,400h ;set bit10.
      .ENDIF

      ;get color morphing... v3.40
      invoke download_morphing,hdlg

;;get the type of icon...
;		  invoke SendDlgItemMessage,hdlg,222,BM_GETCHECK,0,0
;		  .IF ax==1
;				mov (OBJECT PTR [edi]).nexttype,60		;execution icon.
;				mov (OBJECT PTR [edi]).nfillcolor,0FFh	;red.
;		  .ELSE
;				invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
;				.IF ax==1
;				  mov (OBJECT PTR [edi]).nexttype,61 ;text-file icon.
;				  mov (OBJECT PTR [edi]).nfillcolor,0FF00FFh
;				.ELSE
;				  invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
;				  .IF ax==1
;						mov (OBJECT PTR [edi]).nexttype,62 ;eve icon.
;						mov (OBJECT PTR [edi]).nfillcolor,08080FFh
;				  .ELSE
;						invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0
;						.IF ax==1
;						  mov (OBJECT PTR [edi]).nexttype,64 ;sound icon.
;						  mov (OBJECT PTR [edi]).nfillcolor,0FFFF00h ;aquablue.
;						.ELSE
;						  invoke SendDlgItemMessage,hdlg,231,BM_GETCHECK,0,0
;						  .IF ax==1
;								mov (OBJECT PTR [edi]).nexttype,65 ;WWW icon.
;								mov (OBJECT PTR [edi]).nfillcolor,0FFFFh ;yellow.
;						  .ELSE
;								mov (OBJECT PTR [edi]).nexttype,63 ;generic icon.
;								mov (OBJECT PTR [edi]).nfillcolor,0FF00h ;green.
;						  .ENDIF
;						.ENDIF
;				  .ENDIF
;				.ENDIF
;		  .ENDIF

;v1.45 update width/height...but only if locked...
				mov eax,(OBJECT PTR [edi]).fconfig4
				test al,01000b ;bit3=1 locked.
				jz q01
					invoke SendDlgItemMessage,hdlg,252,WM_GETTEXT,5,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
					.IF SDWORD PTR eax<4
					  mov eax,4
					.ENDIF
					mov (OBJECT PTR [edi]).wwidth,eax
					invoke SendDlgItemMessage,hdlg,253,WM_GETTEXT,5,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
					.IF SDWORD PTR eax<4
					  mov eax,4
					.ENDIF
					mov (OBJECT PTR [edi]).height,eax
q01:

;v1.84
;update selectable only on boundary...
      invoke SendDlgItemMessage,hdlg,266,BM_GETCHECK,0,0
      mov ebx,(OBJECT PTR [edi]).fconfig1
      and bl,0FDh ;clr bit1.
      .IF ax==1
	      or bl,010b ;set bit1.
      .ENDIF
      mov (OBJECT PTR [edi]).fconfig1,ebx

;v2.90 transparent color...
    invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
    .IF ax==0
      and (OBJECT PTR [edi]).fconfig1,0FFFFFF7Fh ;clt bit7.
    .ELSE
      or (OBJECT PTR [edi]).fconfig1,80h ;set bit7.
    .ENDIF
    ;and get rgb color...
    lea eax,(OBJECT PTR [edi]).rgbtransparent
    invoke download_rgbcolor,hdlg,eax,700
   

;*WARNING* these must be last, as can invalidate the ptr edi...
		invoke down_sendbackfront,hdlg,234,207



;      invoke DeleteObject,hnewfont ;v3.50
;		  invoke EndDialog, hdlg,TRUE
;noexitdlg:
;		  mov eax,TRUE
      jmp out0
      
    ;note, BN_CLICKED EQU 0, no need for "DWORD PTR ((BN_CLICKED*65536)+"
		.ELSEIF eax==210 ;custom bitmap.  "Apply" button.
				;bitmaps are already loaded, into data-elements. choose one...
				  ;v1.45 update width/height...but only if locked...
				  ;mov eax,(OBJECT PTR [edi]).fconfig4
				  ;and al,01000b ;bit3=1 locked.
				  ;.IF al==01000b
				  mov flocked,0
				  invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
				  .IF ax==1
					mov flocked,1
					invoke SendDlgItemMessage,hdlg,252,WM_GETTEXT,5,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
					.IF SDWORD PTR eax<4
					  mov eax,4
					.ENDIF
					mov (OBJECT PTR [edi]).wwidth,eax
					invoke SendDlgItemMessage,hdlg,253,WM_GETTEXT,5,ADDR szasciitbl
					invoke str2longint, ADDR szasciitbl ;-->eax
					.IF SDWORD PTR eax<4
					  mov eax,4
					.ENDIF
					mov (OBJECT PTR [edi]).height,eax
				  .ELSE
				  .ENDIF
				  ;a checkbox in dlgbox to delete picture from library...
				  xor esi,esi
				  invoke SendDlgItemMessage,hdlg,218,BM_GETCHECK,0,0
				  .IF ax==1
						;clear the checkbox immediately...
						invoke SendDlgItemMessage,hdlg,218,BM_SETCHECK,0,0
						mov esi,1 ;flag to delete image.
				  .ENDIF
				;currently have choice in an edit-box on dlgbox. saved in
				;.nlibrary...
				invoke SendDlgItemMessage,hdlg,213,WM_GETTEXT,6,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				push eax
				invoke choosebitmap,hdlg,edi,eax,esi
				;...sets .rpdata2->dataelement, else =0 no attached bitmap.
				pop ebx
				.IF eax==0
				  xor ebx,ebx
				.ENDIF
				mov (OBJECT PTR [edi]).nlibrary,ebx
				  ;update the "Pict#" field in icon dlg box immediately...
				  mov eax,ebx
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,213,WM_SETTEXT,0,esi
				  ;display how many pictures in library...
				  mov ebx,pTERSEDATA
				  mov  eax,(TERSEDATA PTR [ebx]).numbitmaps
				  invoke bin2dec,10 			 ;eax-->asciitbl+0 to +9 (10 digits)
				  ;...returns eax->start of string, past the leading blanks.
				  invoke SendDlgItemMessage,hdlg,245,WM_SETTEXT,0,eax

					;v1.85 display original width/height (readonly)...
					mov  eax,(OBJECT PTR [edi]).origwidth
					invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
					;...returns eax->start of string, past the leading blanks.
					push eax
					invoke SendDlgItemMessage,hdlg,270,WM_SETTEXT,0,eax
					pop eax
					  ;also if not locked, display at 100%...
					  .IF flocked==0
						invoke SendDlgItemMessage,hdlg,252,WM_SETTEXT,0,eax ;.wwidth.
					  .ENDIF
					mov  eax,(OBJECT PTR [edi]).origheight
					invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
					;...returns eax->start of string, past the leading blanks.
					push eax
					invoke SendDlgItemMessage,hdlg,271,WM_SETTEXT,0,eax
					pop eax
					  ;also if not locked, display at 100%...
					  .IF flocked==0
						invoke SendDlgItemMessage,hdlg,253,WM_SETTEXT,0,eax ;.height
					  .ENDIF
				mov eax,TRUE ;erase previous.
				jmp x11 ;redraw diagram.

    ;note, BN_CLICKED EQU 0, no need for "DWORD PTR ((BN_CLICKED*65536)+"
		.ELSEIF eax==209 ;"choose a color" button pressed. font color.
		   invoke chooseacolor,hdlg,720 ;257 ;257=id of color-edit-box
		   ;mov eax,TRUE
		   jmp dn2 ;diag will repaint, immediately painting label. v3.51
		   ;...note, will ret eax=0, so windows does default processing.

		.ELSEIF eax==279 ;"choose outer color" button pressed. outer color for border. v3.40
		   mov eax,(OBJECT PTR [edi]).npencolor
		   invoke chooseacolor,hdlg,0 ;=id of color-edit-box,=0 used eax.
		   .IF eax != -1 ;-1 if cancelled.
		     mov (OBJECT PTR [edi]).npencolor,eax
		   .ENDIF
		   mov eax,TRUE

		.ELSEIF eax==280 ;"choose inner color" button pressed.  v3.40
		   mov eax,(OBJECT PTR [edi]).nfillcolor
		   invoke chooseacolor,hdlg,0 ;=id of color-edit-box
		   .IF eax != -1 ;-1 if cancelled.
		     mov (OBJECT PTR [edi]).nfillcolor,eax
		   .ENDIF
		   mov eax,TRUE


;		.ELSEIF wparam==222 ;execution icon
;				  lea esi,szexeciconaction
;				  lea ebx,szexeciconfilespec
;				  jmp SHORT c12
;		.ELSEIF wparam==223  ;text-file icon
;				  lea esi,sztexticonaction
;				  lea ebx,sztexticonfilespec
;c12:	  invoke SendDlgItemMessage,hdlg,203,WM_SETTEXT,0,esi
;				  invoke SendDlgItemMessage,hdlg,204,WM_SETTEXT,0,ebx
;				  mov eax,TRUE
;		.ELSEIF wparam==224 ;eve icon.
;				  lea esi,szeveiconaction
;				  lea ebx,szeveiconfilespec
;				  jmp c12
;		.ELSEIF wparam==225 ;generic icon.
;				  lea esi,szgenericiconaction
;				  lea ebx,szgenericiconfilespec
;				  jmp c12
;		.ELSEIF wparam==230 ;sound icon.
;				  lea esi,szsoundiconaction
;				  lea ebx,szsoundiconfilespec
;				  jmp c12
;		.ELSEIF wparam==231 ;WWW icon.
;				  lea esi,szwwwiconaction
;				  lea ebx,szwwwiconfilespec
;				  jmp c12

    ;note, BN_CLICKED EQU 0, no need for "DWORD PTR ((BN_CLICKED*65536)+"
		.ELSEIF eax==235 ;"choose a font" button pressed.
		  invoke chooseafont,hdlg,249,255,256,236 ;id's of font-size/type/style/charset edit boxs.
		  ;...now mylf LOGFONT structure is global. v3.50
		  .IF eax != 0 ;0=cancelled. v3.50
		    ;need to download font params to element, as changing any param field will
		    ;(see cases below) call mycreatefont() which reads from the element...
;        invoke download_font,hdlg ;v3.50
;		      ;labelproc() has plain/html text, not icon label, but leave comments here...
;		      ;invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0 ;plain text.
;		      ;.IF ax != 0
;		        mov esi,edi
;		        ;mov (OBJECT PTR [edi]).nfontangle,0
;		        invoke mycreatefont ;enter esi->element. CreateFontIndirect,ADDR mylf ;v3.50
;            push eax ;handle of new font.
;            invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,eax,TRUE ;upload font to editbox.
;            invoke DeleteObject,g_hnewfontedit ;delete current temp font.
;            pop eax
;            mov g_hnewfontedit,eax
;          ;.ENDIF
;        ;note, must delete font when exit dialogbox.
;				mov eax,TRUE ;erase previous.  v3.50
;				jmp x11 ;redraw diagram.
        jmp dn2
      .ENDIF
		  ;mov eax,TRUE
		  xor eax,eax
		  ;...for consistency, dn2 exits with eax=0, windows to process the message.

    ;note, BN_CLICKED EQU 0, no need for "DWORD PTR ((BN_CLICKED*65536)+"
		.ELSEIF eax==251 ;lock checkbox.
		  ;can only have custom width/height if icon is locked.
		  invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
		  .IF ax==1
			mov ebx,FALSE
		  .ELSE
			;make the width/height unchangeable...
			mov ebx,TRUE
		  .ENDIF
		  invoke SendDlgItemMessage,hdlg,252,EM_SETREADONLY,ebx,0
		  invoke SendDlgItemMessage,hdlg,253,EM_SETREADONLY,ebx,0

		.ELSEIF eax==273  ;"external paint editor" button pressed v2.92
		  ;*DON'T* forget, xdblclk() has same code as here.
		  ;we want to launch the editor, spec'd in tersedata.szpainter1,
		  ;with a temp filename, say temp.gif/bmp/jpg, then on exit
		  ;read the file.
		  ;i got this code out of labelproc(), but here we need to find out
		  ;if data is gif/bmp/jpg. also, data is attached to icon.rpdata2...
						mov edi,prbuttonobject
						mov eax,(OBJECT PTR [edi]).rpdata2
						.IF eax==0
						.ELSE
						  add eax,pTERSEDATA
						  mov ebx,eax ;1st data element.
						  mov eax,(OBJECT PTR [ebx]).fstatus ;find out gif/jpg/bmp/wmf.
						  and eax,0342h ;test bits 9/8/6/1
						  .IF eax==02 ;bit1=1 jpg.
						    mov picfiletype,2
						  .ELSEIF eax==40h ;bit6=1 wmf.
						    mov picfiletype,4
						  .ELSEIF eax==200h ;bit9=1 gif.
						    mov picfiletype,1
						  .ELSEIF eax==100h ;bit8=1 bmp.
						    mov picfiletype,3 ;bmp.
						  .ELSE
						    ;error or some other file type.
						    ;early versions of EVE imported bitmap without setting .fstatus
						    ;image type bits, ie only set bits 4/3....
						    invoke myalertbox,ADDR szer025,4 ;invoke myerrorhandler,025
						    jmp by8
						  .ENDIF
							invoke chain2block,ebx,ADDR g_bigblock ;0 ;0=create a block.
							.IF eax != 0
							  ;labelproc() calls openexternaleditor() here.
							  mov ecx,(OBJECT PTR [ebx]).xdata ;size of picture.
								invoke openexternaleditor,eax,ecx,picfiletype
								;...returns global nfsize =size of image file returned in g_bigblock.
								.IF eax != 0 ;ret eax=0 if file not changed.
								  ;mygifload() calls getgiftransparent() to extract transparent
								  ;color info from contiguous block and write to 1stdata.end01.
								  ;need to do it here also...
								  .IF picfiletype==1 ;gif.
							      mov eax,edi
no1:					      mov ecx,(OBJECT PTR [ebx]).xdata ;size of picture.
						        invoke getgiftransparent,ADDR g_bigblock,ecx,ebx,eax
								    ;...ebx->1stdata, edi->icon.
		                ;...lastparam!=0, reads trans color from gif to 1stdata.end01
		                ;...lastparam>1, ->icon to write r/g/b to.
		              .ELSE
		                xor eax,eax ;flag not a gif.
		                jmp no1
								  .ENDIF
								          mov edx,edi  ;v2.60
								          sub edx,pTERSEDATA
								          push edx
                  invoke block2chain,ADDR g_bigblock,edi,nfsize,1 ;eax
                  ;...what happens if chain gets longer and ptrs become invalid?
                  ;...well, we are not changing the start of the chain, only maybe
                  ;extending the end, so all relative ptrs to the graphic should be ok.
                          pop edi
                          add edi,pTERSEDATA ;edi=ptr to this icon.
                  ;...pmem->block, edi->icon, eax=size of block.
                  invoke DeleteObject,g_hnewfontedit ;v3.50
                  mov g_hnewfontedit,0
                  mov g_fkillfocus,0 ;v3.51
								  invoke EndDialog, hdlg,TRUE
								  ;...this calls wndproc() and iconproc(), so recursion.
                  ;to do, need to delete the ipicture object, cos it is for the
                  ;older image...
                  ;this scans current database and wipes out any bitmap handles and DCs...
                  invoke deletebitmaphandles   ;(they are used for drawing pictures)
				          mov eax,TRUE ;erase previous.
				          jmp x11 ;redraw diagram.
				        .ENDIF
							.ENDIF
						.ENDIF
by8:  mov eax,TRUE


    .ELSEIF eax==DWORD PTR ((EN_KILLFOCUS*65536)+102) ;label text edit box. v3.51
      ;a bug, EN_CHANGE notification gets received with the control ids tested for
      ;below, before dlg box is fully setup.
      ;use a flag, set when main edit box gets kill-focus...
      inc g_fkillfocus ;must clr on exit from dlg box.
      jmp SHORT dn2 ;v3.52
nox1: xor eax,eax
    
    .ELSEIF eax==DWORD PTR ((EN_CHANGE*65536)+249) ;font size edit box changed. v3.50
dn2:  ;see above. wait until killfocus has happened...
      .IF g_fkillfocus==0
        jmp nox1
      .ENDIF
      invoke label_repaint,hdlg,wparam ;v3.52
      xor eax,eax ;do default processing.
      ;...see test_controls_repaint() below, picks up other controls need repaint.
      
;		    invoke add2wipeoutlist,edi
;				mov g_fredrawdiag,WIPEOUTobjs
;				push g_nmousex
;				push g_nmousey
;				invoke UpdateWindow,g_hwnd
;				pop g_nmousey
;				pop g_nmousex
;        .IF wparam==DWORD PTR ((EN_KILLFOCUS*65536)+102) ;label text edit box. v3.51
;          invoke label_download_text,hdlg ;text from dlgbox to element. v3.52
;          jmp dn3
;        .ENDIF
;        invoke download_font,hdlg ;downloads font params to element. v3.50
;        mov eax,(OBJECT PTR [edi]).nfontsize
;				.IF eax<6
;				  mov eax,6
;				.ENDIF
;				mov (OBJECT PTR [edi]).nfontsize,eax
;				;commented out, as icon doesn't yet have html text...
;        ;invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0 ;plain text.
;		    ;  .IF ax != 0 ;0=html text.
;		        mov esi,edi
;		        mov eax,(OBJECT PTR [edi]).nfontangle ;v3.51
;		        push eax ;need to preserve angle, as diagram paints simultaneously. v3.51
;		        mov (OBJECT PTR [edi]).nfontangle,0
;		        invoke mycreatefont ;enter esi->element. CreateFontIndirect,ADDR mylf ;v3.50
;		        pop ecx
;		        mov (OBJECT PTR [edi]).nfontangle,ecx
;            push eax ;handle of new font.
;            invoke SendDlgItemMessage,hdlg,102,WM_SETFONT,eax,TRUE ;upload font to editbox.
;            invoke DeleteObject,g_hnewfontedit ;delete current temp font.
;            pop eax
;            mov g_hnewfontedit,eax ;global.
;        ;  .ENDIF
;        ;note, must delete font when exit dialogbox.
;				;note, if cancel button, restores .nfontsize to original value.
;dn3:		invoke windowchanged,FALSE ;TRUE ;FALSE=don't wipe background.
;        xor eax,eax ;do default processing.

;;editbox only displays text in black, so no need for this...
;;yes there is, as immediately paint on diagram also...
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+720) ;font red color edit box changed. v3.50
;      jmp dn2
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+721) ;font green color edit box changed. v3.50
;      jmp dn2
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+722) ;font blue color edit box changed. v3.50
;      jmp dn2
;    .ELSEIF wparam==DWORD PTR ((CBN_SELENDOK*65536)+256) ;font style from listbox changed. v3.50
;		    jmp dn2
;    .ELSEIF wparam==DWORD PTR ((CBN_SELENDOK*65536)+255) ;font type from listbox changed. v3.50
;		    jmp dn2
;    .ELSEIF wparam==243 ;underline/strikethru changed. v3.50
;		  jmp dn2
;    .ELSEIF wparam==242 ;underline/strikethru changed. v3.50
;		  jmp dn2
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+240) ;.xlabeloffset. v3.51
;      jmp dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+241) ;.ylabeloffset. v3.51
;      jmp dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.
;    .ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+263) ;.nfontangle. v3.51
;      jmp dn2 ;well, doesn't change font in editbox, but need to repaint on diagram.


		.ELSEIF eax==IDCANCEL
		  call label_restore_font_params ;v3.51
out0: invoke DeleteObject,g_hnewfontedit ;v3.50
      mov g_fkillfocus,0 ;v3.51
		  invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE
		.ELSE ;eax has wparam.
      call test_controls_repaint ;enter eax=wparam, ret ebx. v3.52
      .IF ebx != 0
        jmp dn2
      .ENDIF
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
;				invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
    mov eax,FALSE
x11:
;	  mov g_fredrawdiag,ENTIRE								  ;redraw entire window.
;				  push g_nmousex
;				  push g_nmousey
;				  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
;				  pop  g_nmousey
;				  pop  g_nmousex
;				mov  eax,TRUE
    invoke windowchanged,eax ;v3.50
  .ELSE
	  ;have not processed a message...
	  mov  eax,FALSE
  .ENDIF

		ret
iconproc				ENDP
;--------------------------------------------------------------------------
;v2.76
linkproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL flocked:BYTE
		LOCAL szexebuf[256]:BYTE,exefilenamestruct:OPENFILENAME
;from wmrbuttondown()/state0/on a link-activator. "linkproc"   id=219.
; *EVE* this is the callback for link activator, based on iconproc() callback.

				mov  edi,prbuttonobject

  .IF message==WM_INITDIALOG

;set checkbox display label...      v3.25
				mov eax,(OBJECT PTR [edi]).fstatus
				;bit5 = display label on diagram
				test  al,00100000b
				jz ke21
				invoke SendDlgItemMessage,hdlg,228,BM_SETCHECK,1,0
ke21:

;upload label...
				mov ebx,(OBJECT PTR [edi]).rpdata		;data-element.
				.IF ebx==0
				.ELSE
				  add ebx,pTERSEDATA
				  lea esi,(OBJECT PTR [ebx]).sztext ;start of data area.
				  invoke SendDlgItemMessage,hdlg,102,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,102,EM_LIMITTEXT,255,0
				.ENDIF

;display ring# on parent that attached to...
				mov eax,(OBJECT PTR [edi]).nbeginvertice ;vertice# if owner is poly.
				.IF eax==0 ;vertice#=0 not attached to poly.
				  mov  eax,(OBJECT PTR [edi]).nbeginring
				.ENDIF
				invoke bin2dec,10				   ;eax-->asciitbl (10 digits+0)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
 invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,esi
 invoke SendDlgItemMessage,hdlg,229,EM_LIMITTEXT,2,0 ;set limit.

;display number of this object/element...
;display element# of owner...
;display lock state...
		invoke displaynumthis,hdlg


;now need to upload some read-only text strings...
		mov eax,(OBJECT PTR [edi]).flinks ;based on icon.nexttype.
		.IF ax==61		;text-file link.
				  lea esi,sztexticonaction
				  lea ebx,sztexticonfilespec
		.ELSEIF ax==60 ;execution link.
				  lea esi,szexeciconaction
				  lea ebx,szexeciconfilespec
		.ELSEIF ax==62 ;eve link.
				  lea esi,szeveiconaction
				  lea ebx,szeveiconfilespec
		.ELSEIF ax==63 ;generic icon.
 	        lea esi,szgenericiconaction
				  lea ebx,szgenericiconfilespec
		.ELSEIF ax==64 ;sound link.
				  lea esi,szsoundiconaction
				  lea ebx,szsoundiconfilespec
		.ELSEIF ax==65 ;WWW link.
do1:		  lea esi,szwwwiconaction
				  lea ebx,szwwwiconfilespec
		.ELSEIF ax==66 ;go to link.
				  lea esi,szgotoaction
				  lea ebx,szgotofilespec
		.ELSE
		  jmp do1
		.ENDIF
		invoke SendDlgItemMessage,hdlg,203,WM_SETTEXT,0,esi
		invoke SendDlgItemMessage,hdlg,204,WM_SETTEXT,0,ebx

;display which type of link...
				mov eax,(OBJECT PTR [edi]).flinks ;based on icon.nexttype.
				.IF ax==60 ;execution icon
				  mov ecx,222
				.ELSEIF ax==61 ;text-file link.
				  mov ecx,223
				.ELSEIF ax==62 ;eve link.
				  mov ecx,224
				.ELSEIF ax==64 ;sound
				  mov ecx,230
				.ELSEIF ax==65 ;WWW link.
				  mov ecx,231
				.ELSEIF ax==66 ;goto link.
				  mov ecx,246
				.ELSE ;generic icon
				  mov ecx,225
				.ENDIF
				invoke SendDlgItemMessage,hdlg,ecx,BM_SETCHECK,1,0

;display single-click... (read only)
    mov ebx,pTERSEDATA
    mov eax,(TERSEDATA PTR [ebx]).feveprefs
    test al,80h ;test bit7
    jz dbl1
		invoke SendDlgItemMessage,hdlg,247,BM_SETCHECK,1,0
dbl1:


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1

				invoke SendDlgItemMessage,hdlg,228,BM_GETCHECK,0,0 ;v3.25
				mov ebx,(OBJECT PTR [edi]).fstatus
				.IF ax==1				;display-label button is checked.
				  or  bl,00100000b
				.ELSE
				  and bl,11011111b
				.ENDIF
				mov (OBJECT PTR [edi]).fstatus,ebx ;bl

;update label...
						  mov ebx,(OBJECT PTR [edi]).rpdata
						  .IF ebx==0
						  .ELSE
								add ebx,pTERSEDATA
								lea  esi,(OBJECT PTR [ebx]).sztext ;zeroise it first.
								mov  ecx,256									  ;/
zoo1:					mov  [esi],BYTE PTR 0					  ;/
								inc  esi												  ;/
								loop zoo1												  ;/
								lea esi,(OBJECT PTR [ebx]).sztext
								invoke SendDlgItemMessage,hdlg,102,WM_GETTEXT,256,esi
						  .ENDIF

		  invoke down_owner,hdlg,399,0
		  or eax,eax ;cmp eax,0
		  je noexitdlg

;update ring# on parent that label is set to...must be after down_owner().
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax==0
          mov (OBJECT PTR [edi]).nbeginring,1
          mov (OBJECT PTR [edi]).nbeginvertice,0
		  .ELSE
				invoke SendDlgItemMessage,hdlg,229,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF eax==0
				  mov eax,1
				.ELSEIF SDWORD PTR eax<0
				  neg eax
				.ENDIF
				mov ebx,(OBJECT PTR [edi]).rpowner1
				add ebx,pTERSEDATA				
				  ;v2.78 could be attached to a poly (vertices) or anything else (rings)...
				  mov ecx,(OBJECT PTR [ebx]).nexttype
				  .IF ecx>=5
				    .IF ecx<=7
				      ;attached to a poly...
				      mov ecx,(OBJECT PTR [ebx]).ncorners
				      .IF eax>ecx
				        mov eax,ecx
				      .ENDIF
				      mov (OBJECT PTR [edi]).nbeginvertice,eax
				      mov (OBJECT PTR [edi]).nbeginring,1 ;i think let this be default.
				      jmp SHORT byp1
				    .ENDIF
				  .ENDIF
				  mov ecx,(OBJECT PTR [ebx]).nrings
				  .IF eax>ecx
				    mov eax,ecx
				  .ENDIF
				  mov  (OBJECT PTR [edi]).nbeginring,eax
				  mov (OBJECT PTR [edi]).nbeginvertice,0
byp1:     ;bypass.								
		  .ENDIF

;update lock state...
		  invoke down_lock,hdlg



;get the type of icon...
		  invoke SendDlgItemMessage,hdlg,222,BM_GETCHECK,0,0
		  .IF ax==1
				mov (OBJECT PTR [edi]).flinks,60		;execution icon.
				mov (OBJECT PTR [edi]).nfillcolor,0080FFh ;orange v2.79 0FFh	;red.
				;...avoid red, as animation activator uses it <<<<NOTE<<<<<<
		  .ELSE
				invoke SendDlgItemMessage,hdlg,223,BM_GETCHECK,0,0
				.IF ax==1
				  mov (OBJECT PTR [edi]).flinks,61 ;text-file icon.
				  mov (OBJECT PTR [edi]).nfillcolor,0FF00FFh ;violet.
				.ELSE
				  invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
				  .IF ax==1
						mov (OBJECT PTR [edi]).flinks,62 ;eve icon.
						mov (OBJECT PTR [edi]).nfillcolor,08080FFh  ;pale brown.
				  .ELSE
						invoke SendDlgItemMessage,hdlg,230,BM_GETCHECK,0,0
						.IF ax==1
						  mov (OBJECT PTR [edi]).flinks,64 ;sound icon.
						  mov (OBJECT PTR [edi]).nfillcolor,0FFFF00h ;aquablue.
						.ELSE
						  invoke SendDlgItemMessage,hdlg,231,BM_GETCHECK,0,0
						  .IF ax==1
								mov (OBJECT PTR [edi]).flinks,65 ;WWW icon.
								mov (OBJECT PTR [edi]).nfillcolor,0FFFFh ;yellow.
						  .ELSE
						    invoke SendDlgItemMessage,hdlg,246,BM_GETCHECK,0,0
						    .IF ax==1
								  mov (OBJECT PTR [edi]).flinks,66 ;goto link.
								  mov (OBJECT PTR [edi]).nfillcolor,0E0E0FFh ;very pale brown.
						    .ELSE
						      ;note, not using this one, as icon.nexttype=63 is the only
						      ;type of icon now supported (has no dblclk action, just
						      ;displays a picture and title)...
						      ;so, can use green color for some other link option.
								  mov (OBJECT PTR [edi]).flinks,63 ;generic icon.
								  mov (OBJECT PTR [edi]).nfillcolor,0FF00h ;green.
								.ENDIF
						  .ENDIF
						.ENDIF
				  .ENDIF
				.ENDIF
		  .ENDIF


;*WARNING* these must be last, as can invalidate the ptr edi...
		  invoke down_sendbackfront,hdlg,234,207



		  invoke EndDialog, hdlg,TRUE
noexitdlg:
		  mov eax,TRUE

		.ELSEIF wparam==222 ;execution icon
				  lea esi,szexeciconaction
				  lea ebx,szexeciconfilespec
				  jmp SHORT c12
		.ELSEIF wparam==223  ;text-file link.
				  lea esi,sztexticonaction
				  lea ebx,sztexticonfilespec
c12:	  invoke SendDlgItemMessage,hdlg,203,WM_SETTEXT,0,esi
				  invoke SendDlgItemMessage,hdlg,204,WM_SETTEXT,0,ebx
				  mov eax,TRUE
		.ELSEIF wparam==224 ;eve link.
				  lea esi,szeveiconaction
				  lea ebx,szeveiconfilespec
				  jmp c12
		.ELSEIF wparam==225 ;generic icon.
				  lea esi,szgenericiconaction
				  lea ebx,szgenericiconfilespec
				  jmp c12
		.ELSEIF wparam==230 ;sound link.
				  lea esi,szsoundiconaction
				  lea ebx,szsoundiconfilespec
				  jmp c12
		.ELSEIF wparam==231 ;WWW link.
				  lea esi,szwwwiconaction
				  lea ebx,szwwwiconfilespec
				  jmp c12
		.ELSEIF wparam==246 ;goto link.
				  lea esi,szgotoaction
				  lea ebx,szgotofilespec
				  jmp c12

    .ELSEIF wparam==275 ;"Find" button
      ;find a file and copy path/filename to database...
        ;first, copy default structure...
				lea edi,exefilenamestruct
				lea ebx,defaulttemplate
				mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1
			lea edi,exefilenamestruct
      mov (OPENFILENAME PTR [edi]).on_lpstrFilter,0 ;OFFSET szexefilter
      lea ebx,szexebuf
      mov [ebx],BYTE PTR 0
      mov (OPENFILENAME PTR [edi]).on_lpstrFile,ebx
      mov (OPENFILENAME PTR [edi]).on_Flags,OFN_FILEMUSTEXIST OR OFN_HIDEREADONLY OR \
        OFN_READONLY OR OFN_EXPLORER
      mov (OPENFILENAME PTR [edi]).on_lpstrDefExt,0 ;OFFSET szembeddedextension
      invoke GetOpenFileName,edi  ;<<<DIALOG BOX<<<<
      .IF eax==0					;0=error/cancel
      .ELSE
        ;filespec is in szexebuf...
        mov eax,102
        lea ecx,szexebuf
			  invoke SendDlgItemMessage,hdlg,eax,WM_SETTEXT,0,ecx
      .ENDIF
      mov eax,TRUE

		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
;				invoke InvalidateRgn, g_hwnd,0,FALSE	;invalidate entire window.
    mov eax,FALSE
x11:
;	  mov g_fredrawdiag,ENTIRE								  ;redraw entire window.
;				  push g_nmousex
;				  push g_nmousey
;				  invoke UpdateWindow, g_hwnd  ;send WM_PAINT immediately.
;				  pop  g_nmousey
;				  pop  g_nmousex
;				mov  eax,TRUE
    invoke windowchanged,eax
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
linkproc				ENDP
;--------------------------------------------------------------------------
.DATA
fhidehandles BYTE 0
fhidehighlighting BYTE 0
  BYTE 0,0

.CODE ;v3.01 moved from .DATA
szexefilter BYTE "EXE files",0,"*.exe",0,0
        BYTE 20 DUP(0)
szfields DB "fstatus",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nexttype",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "xdata",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "rpdata",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "ximage",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "rpowner1",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "rpowner2/rpdata2/nshape",0,0,0
				DB "rpmethods/sztext",0,0,0,0,0,0,0,0,0,0
				DB "number",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "fconfig0",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "fconfig1",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "fconfig2",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "fconfig3",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "fconfig4",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "flinks",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "spare11",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "morphingwidth",0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "xtopleft/bez0x",0,0,0,0,0,0,0,0,0,0,0,0
				DB "ytopleft/bez0y",0,0,0,0,0,0,0,0,0,0,0,0
				DB "bez1x/ncornerwidth",0,0,0,0,0,0,0,0
				DB "bez1y/ncornerheight",0,0,0,0,0,0,0
				DB "bez2x/xfineprn/origwidth",0,0
				DB "bez2y/yfineprn/origheight",0
				DB "xknee2/xdeltacentre/bez3x",0
				DB "yknee2/ydeltacentre/bez3y",0
				DB "xmid/bez4x",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "ymid/bez4y",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "xknee3/bez5x/charascent/#",0
				DB "yknee3/bez5y/charheight/#",0
				DB "bez6x/widthtext",0,0,0,0,0,0,0,0,0,0,0
				DB "bez6y/heighttext",0,0,0,0,0,0,0,0,0,0
				DB "bez7x/widthhimetric",0,0,0,0,0,0,0
				DB "bez7y/heighthimetric",0,0,0,0,0,0
				DB "wwidth/bez8x",0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "height/bez8y",0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "xdiffnorm1st/bex9x",0,0,0,0,0,0,0,0
				DB "ydiffnorm1st/bez9y",0,0,0,0,0,0,0,0
				DB "xdiffnorm2nd/bez10x/cnta#",0
				DB "ydiffnorm2nd/bez10y/maxc#",0
				DB "narrowscaling1st/bez11x/#",0
				DB "narrowscaling2nd/bez11y/#",0
				DB "xlabeloffset/bez12x",0,0,0,0,0,0,0
				DB "ylabeloffset/bez12y",0,0,0,0,0,0,0
				DB "xdeltacentre/bez13x",0,0,0,0,0,0,0
				DB "ydeltacentre/bez13y",0,0,0,0,0,0,0
				DB "nrings",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nringwidth",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nbeginring",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nendring",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "spare30",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "ffonteffects",0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nfillcolor",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nfillstyle",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "npencolor",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "npenwidth",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "npenstyle",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nfontcolor",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nfontstyle/arrow2ndx2",0,0,0,0,0
				DB "nfontsize/arrow2ndy2",0,0,0,0,0,0
				DB "nfonttype/arrow2ndx3",0,0,0,0,0,0
				DB "nfontangle/arrow2ndy3",0,0,0,0,0
				DB "narrow1st/ncorners/nbegi#",0
				DB "narrow2nd/ncharset",0,0,0,0,0,0,0,0
				DB "nlibrary",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "nbeginvertice/szfont#[32]",0
				DB "nendvertice",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "arrow1stx2",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "arrow1sty2",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "arrow1stx3",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "arrow1sty3",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "spare50",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB "end01",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
				DB 0

.CODE
PREFSproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL offfield:DWORD,ncontent:DWORD
		LOCAL ffchange:DWORD
		LOCAL idedit:DWORD
		LOCAL szexebuf[256]:BYTE,exefilenamestruct:OPENFILENAME
;menu Control/EVE preferences... > IDM_PREFS  "prefsproc"

  .IF message==WM_INITDIALOG

	  ;arrow-key scrolling...
		mov edi,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).feveprefs
		and al,010b ;bit1=0 incremental scrolling.
		.IF al==0
				invoke SendDlgItemMessage,hdlg,215,BM_SETCHECK,1,0
		.ELSE					;jump a window.
				invoke SendDlgItemMessage,hdlg,216,BM_SETCHECK,1,0
		.ENDIF

;v3.53...
;	  ;disable mouse (except dbl-clk)...
;		mov eax,(TERSEDATA PTR [edi]).feveprefs
;		and al,010000b ;bit4
;		.IF al==010000b
;				invoke SendDlgItemMessage,hdlg,232,BM_SETCHECK,1,0
;		.ENDIF

;v1.40 snap to even coords...
		mov eax,(TERSEDATA PTR [edi]).feveprefs
		and al,01100000b ;bit5/6
		.IF al==0100000b ;bit5 coarseness 2 units.
		  mov ebx,266
		.ELSEIF al==01000000b ;bit6 coarseness 4 units.
		  mov ebx,267
		.ELSE
		  mov ebx,264 ;default, 1 unit.
		.ENDIF
		invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0

;v2.77 single-click equiv to double-click...
    mov eax,(TERSEDATA PTR [edi]).feveprefs
    and al,80h ;bit7.
    .IF al != 0
		  invoke SendDlgItemMessage,hdlg,270,BM_SETCHECK,1,0
    .ENDIF

;v3.01 save .eve file uncompressed...
    mov eax,(TERSEDATA PTR [edi]).feveprefs
    and ax,200h ;bit9.
    .IF ax != 0
		  invoke SendDlgItemMessage,hdlg,283,BM_SETCHECK,1,0
    .ENDIF

;show page margins...
		mov edi,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).fviewprefs
		and al,01				;bit0=1 show page margins
		.IF al==01
				invoke SendDlgItemMessage,hdlg,226,BM_SETCHECK,1,0
		.ENDIF

;v3.53... v3.54 bring hide-handles back...
;hide non-printing graphics (line to owner, circle mid-wire)...
		mov eax,(TERSEDATA PTR [edi]).fviewprefs
		and al,010b ;bit1=1 hide non-printing graphics.
		.IF al==010b
				invoke SendDlgItemMessage,hdlg,227,BM_SETCHECK,1,0
		.ENDIF
;;hide highlighting...
;		mov eax,(TERSEDATA PTR [edi]).fviewprefs
;		and al,01000b ;bit3=1 hide highlighting.
;		.IF al != 0
;				invoke SendDlgItemMessage,hdlg,234,BM_SETCHECK,1,0
;		.ENDIF
;disable all editing...  v3.53
		mov eax,(TERSEDATA PTR [edi]).fviewprefs
		and al,010000b ;bit4=1 disable all editing.
		.IF al != 0
				invoke SendDlgItemMessage,hdlg,287,BM_SETCHECK,1,0
		.ENDIF

;external editor for text-file links...
				  ;lea eax,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1 v3.01
				  invoke SendDlgItemMessage,hdlg,218,WM_SETTEXT,0,ADDR szeditor1 ;eax v3.01
				  invoke SendDlgItemMessage,hdlg,218,EM_LIMITTEXT,255,0

;v2.31 external editor for labels...
				  ;lea eax,(TERSEDATA PTR [edi]).szeditor2  v3.01
				  invoke SendDlgItemMessage,hdlg,269,WM_SETTEXT,0,ADDR szeditor2 ;eax v3.01
				  invoke SendDlgItemMessage,hdlg,269,EM_LIMITTEXT,255,0

;v2.89 alternative web browser...
				  ;lea eax,(TERSEDATA PTR [edi]).szbrowser2  v3.01
				  invoke SendDlgItemMessage,hdlg,274,WM_SETTEXT,0,ADDR szbrowser2 ;eax v3.01
				  invoke SendDlgItemMessage,hdlg,274,EM_LIMITTEXT,255,0
;has a checkbox to select it...
		      mov eax,(TERSEDATA PTR [edi]).feveprefs
				  and eax,100h ;bit8=1 use alternative browser.
				  .IF eax != 0
				    invoke SendDlgItemMessage,hdlg,273,BM_SETCHECK,1,0
		      .ELSE
		        invoke SendDlgItemMessage,hdlg,274,EM_SETREADONLY,TRUE,0
				  .ENDIF

;v2.92 external paint editor...
ptr1:				  ;lea eax,(TERSEDATA PTR [edi]).szpainter1 v3.01
				  invoke SendDlgItemMessage,hdlg,281,WM_SETTEXT,0,ADDR szpainter1 ;eax v3.01
				  invoke SendDlgItemMessage,hdlg,281,EM_LIMITTEXT,255,0
				  
;display default character set...
		mov ecx,18
		lea esi,szansi
mzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 exx
		push ecx
		invoke SendDlgItemMessage,hdlg,219,CB_ADDSTRING,0,esi
		pop ecx
		add esi,12
		loop mzz
exx:
		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).charsetdefault
		  ;"csids" has a byte array of the char set id's. need to find entry#...
		  lea ebx,csids
		  mov ecx,18 ;# id's.
m01:  mov dl,[ebx]
		  cmp dl,al
		  jne m02
				sub ebx,OFFSET csids
				mov eax,ebx
				jmp SHORT m03
m02:  add ebx,1
		  loop m01
		  xor eax,eax
m03:  invoke SendDlgItemMessage,hdlg,219,CB_SETCURSEL,eax,0

;display finetune of display-size...
				mov  eax,(TERSEDATA PTR [edi]).xfinescrn ;x
				invoke bin2signedascii_upload,hdlg,eax,240,4
				mov  eax,(TERSEDATA PTR [edi]).yfinescrn ;y
				invoke bin2signedascii_upload,hdlg,eax,241,4
				invoke SendDlgItemMessage,hdlg,240,EM_LIMITTEXT,3,0
				invoke SendDlgItemMessage,hdlg,241,EM_LIMITTEXT,3,0

;display finetune of print-size...
;v1.38 stored as 0.1%, but now display in %...
				mov eax,(TERSEDATA PTR [edi]).xfineprn ;signed #.
				mov ebx,10 ;v1.38 stored as 0.1%, but now display in %.
				cdq 	   ; / extend sign into edx.
				idiv ebx   ; /
				neg eax ;v1.38 decided -ve to bring margins in.
				invoke bin2signedascii_upload,hdlg,eax,250,5
				mov  eax,(TERSEDATA PTR [edi]).yfineprn ;y
				mov ebx,10 ;v1.38 stored as 0.1%, but now display in %.
				cdq 	   ; / extend sign into edx.
				idiv ebx   ; /
				neg eax ;v1.38 decided -ve to bring margins in.
				invoke bin2signedascii_upload,hdlg,eax,251,5
				invoke SendDlgItemMessage,hdlg,250,EM_LIMITTEXT,4,0
				invoke SendDlgItemMessage,hdlg,251,EM_LIMITTEXT,4,0

;display background color (radiobuttons)...
		mov eax,(TERSEDATA PTR [edi]).nbackground
		.IF al==0
		  mov ebx,255 ;white.
		.ELSEIF al==1
		  mov ebx,256 ;black.
		.ELSEIF al==2
		  mov ebx,257 ;grey.
		.ELSE
		  mov ebx,258 ;standard window.
		.ENDIF
		invoke SendDlgItemMessage,hdlg,ebx,BM_SETCHECK,1,0

;display handle radius... v3.31
    mov eax,(TERSEDATA PTR [edi]).nhandleradius
			  .IF eax==0 ;not allowed.
			    mov eax,2
			  .ENDIF
    invoke bin2dec,10				   ;-->szasciitbl
    ;...returns eax->start of string, past the leading blanks.
    invoke SendDlgItemMessage,hdlg,284,WM_SETTEXT,0,eax
    invoke SendDlgItemMessage,hdlg,284,EM_LIMITTEXT,1,0


		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1


		  ;arrow key scrolling...
		  invoke SendDlgItemMessage,hdlg,216,BM_GETCHECK,0,0
				 mov edi,pTERSEDATA
		  .IF ax==1 			;jump a window.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 or al,010b 	;set bit1.
		  .ELSE 								;incremental scrolling.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 and al,11111101b		;clr bit1.
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).feveprefs,eax ;al

;v3.53...
;		  ;disable mouse (except dbl-clk)...
;		  invoke SendDlgItemMessage,hdlg,232,BM_GETCHECK,0,0
;		  .IF ax==1
;				 mov eax,(TERSEDATA PTR [edi]).feveprefs
;				 or al,010000b	   ;set bit4.
;		  .ELSE 								
;				 mov eax,(TERSEDATA PTR [edi]).feveprefs
;				 and al,11101111b		;clr bit4.
;		  .ENDIF
;		  mov (TERSEDATA PTR [edi]).feveprefs,eax ;al

		  ;v1.40 update snap to even coords...
		  invoke SendDlgItemMessage,hdlg,266,BM_GETCHECK,0,0 ;coarseness 2 units.
		  mov ebx,(TERSEDATA PTR [edi]).feveprefs
		  and bl,10011111b		 ;clr bits5 and 6. fine coarseness, 1 unit. default.
		  mov fdragmask,0FFh	 ;fine coarseness.(see drag_ methods).
		  .IF ax==1
			or bl,0100000b	   ;set bit5.
			mov fdragmask,0FEh ;mask to truncate bit0 in x/ychange in drag_() methods.
		  .ELSE 								;incremental scrolling.
			push ebx
			invoke SendDlgItemMessage,hdlg,267,BM_GETCHECK,0,0 ;coarseness 4 units.
			pop ebx
			;mov ebx,(TERSEDATA PTR [edi]).feveprefs
			.IF ax==1
			  or bl,01000000b	  ;set bit6.
			  mov fdragmask,0FCh ;mask to truncate bits1/0 in x/ychange in drag_() methods.
			.ENDIF
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).feveprefs,ebx

;v2.77 single-click...
		  invoke SendDlgItemMessage,hdlg,270,BM_GETCHECK,0,0
      .IF ax==1
        or (TERSEDATA PTR [edi]).feveprefs,080h ;set bit7
      .ELSE
        and (TERSEDATA PTR [edi]).feveprefs,0FFFFFF7Fh ;clr bit7.
      .ENDIF

;v3.01 save uncompressed...
		  invoke SendDlgItemMessage,hdlg,283,BM_GETCHECK,0,0
      .IF ax==1
        or (TERSEDATA PTR [edi]).feveprefs,0200h ;set bit9
      .ELSE
        and (TERSEDATA PTR [edi]).feveprefs,0FFFFFDFFh ;clr bit9.
      .ENDIF

;show page margins...
		  invoke SendDlgItemMessage,hdlg,226,BM_GETCHECK,0,0
				 mov edi,pTERSEDATA
		  .IF ax==1 			;enable.
				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
				 or al,01b						;set bit0.
		  .ELSE 								;enable.
				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
				 and al,11111110b		;clr bit0.
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).fviewprefs,eax ;al

;v3.53...
;;update hide non-printing graphics...
;		  invoke SendDlgItemMessage,hdlg,227,BM_GETCHECK,0,0
;				 mov edi,pTERSEDATA
;		  .IF ax==1 			;enable.
;				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
;				 or al,010b 	;set bit1.
;				 mov fhidehandles,1
;		  .ELSE 								;enable.
;				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
;				 and al,11111101b		;clr bit1.
;				 mov fhidehandles,0
;		  .ENDIF
;		  mov (TERSEDATA PTR [edi]).fviewprefs,eax ;al
;;update hide highlighting...
;		  invoke SendDlgItemMessage,hdlg,234,BM_GETCHECK,0,0
;				 mov edi,pTERSEDATA
;		  .IF ax==1 			;enable.
;				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
;				 or al,01000b	  ;set bit3.
;				 mov fhidehighlighting,1
;		  .ELSE 								;enable.
;				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
;				 and al,11110111b		;clr bit3.
;				 mov fhidehighlighting,0
;		  .ENDIF
;		  mov (TERSEDATA PTR [edi]).fviewprefs,eax ;al
;update disable all editing...
;(have removed separate hide highlighting, hide handles, disable right button).
		  invoke SendDlgItemMessage,hdlg,287,BM_GETCHECK,0,0
      .IF ax != 0
        or (TERSEDATA PTR [edi]).fviewprefs,11010b ;set bits 1,3,4.
        ;bit1=hide all handles, bit3=hide highlighting, bit4=overall disable editing.
        or (TERSEDATA PTR [edi]).feveprefs,10000b ;set bit4=disable right button&dragging.
        ;we need to remove the Elements menu...
        invoke disableelementsmenu
				mov fhidehandles,1
				mov fhidehighlighting,1
      .ELSE
        ;v3.54 i have brought back hide-handles checkbox...
        ;i'm thinking though, if have just reenabled editing, want hide-handles=0...
        mov eax,(TERSEDATA PTR [edi]).fviewprefs
        and eax,10000b ;extract bit4.
        .IF eax==0
		      invoke SendDlgItemMessage,hdlg,227,BM_GETCHECK,0,0
		      .IF ax==1 			;enable.
				    mov eax,(TERSEDATA PTR [edi]).fviewprefs
				    or al,010b 	;set bit1.
				    mov fhidehandles,1
		      .ELSE 								;enable.
				    mov eax,(TERSEDATA PTR [edi]).fviewprefs
				    and al,11111101b		;clr bit1.
				    mov fhidehandles,0
		      .ENDIF
          and eax,0FFFFFFE7h ;clr bits 3,4.
          mov (TERSEDATA PTR [edi]).fviewprefs,eax
        .ELSE ;just now reenabling editing...
			    mov fhidehandles,0
          and (TERSEDATA PTR [edi]).fviewprefs,0FFFFFFE5h ;clr bits 1,3,4.
        .ENDIF
				mov fhidehighlighting,0
        and (TERSEDATA PTR [edi]).feveprefs,0FFFFFFEFh ;clr bit4.
        ;reconstruct the entire menu, incl Elements menu...
        invoke addcomposites2menu,0
      .ENDIF

;external editor for text icons...
		;lea eax,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1 v3.01
		invoke SendDlgItemMessage,hdlg,218,WM_GETTEXT,256,ADDR szeditor1 ;eax

;external editor for labels...
		;lea eax,(TERSEDATA PTR [edi]).szeditor2  v3.01
		invoke SendDlgItemMessage,hdlg,269,WM_GETTEXT,256,ADDR szeditor2 ;eax v3.01

;alternative web browser...
		  ;lea eax,(TERSEDATA PTR [edi]).szbrowser2
		  invoke SendDlgItemMessage,hdlg,274,WM_GETTEXT,256,ADDR szbrowser2 ;eax v3.01
;checkbox to select it...		
		  invoke SendDlgItemMessage,hdlg,273,BM_GETCHECK,0,0
      .IF ax==1
        or (TERSEDATA PTR [edi]).feveprefs,100h ;set bit8.
      .ELSE
        and (TERSEDATA PTR [edi]).feveprefs,0FFFFFEFFh ;clr bit8.
      .ENDIF

;v2.92 external editor for pictures...
		  ;lea eax,(TERSEDATA PTR [edi]).szpainter1  v3.01
		  invoke SendDlgItemMessage,hdlg,281,WM_GETTEXT,256,ADDR szpainter1 ;eax v3.01

;update default char set...
		  invoke SendDlgItemMessage,hdlg,219,CB_GETCURSEL,0,0
		  lea ebx,csids ;id's for each char set.
		  add ebx,eax
		  xor eax,eax
		  mov al,[ebx]	;get char set id.
		  mov ebx,pTERSEDATA
		  mov (TERSEDATA PTR [ebx]).charsetdefault,eax

;update finetune of display-size...
		  invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,4,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				;finetune is in %, limit range -49 to +100%...
				.IF SDWORD PTR eax>99 ;zoom in.
				  mov eax,99
				.ELSEIF SDWORD PTR eax<-49 ;zoom out.
				  mov eax,-49
				.ENDIF
				mov ebx,(TERSEDATA PTR [edi]).xfinescrn
				.IF eax != ebx
				  push eax
				  invoke InvalidateRgn, g_hwnd,0,TRUE	 ;need to wipe background.
				  pop eax
				.ENDIF
				mov  (TERSEDATA PTR [edi]).xfinescrn,eax				;x
		  invoke SendDlgItemMessage,hdlg,241,WM_GETTEXT,4,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				.IF SDWORD PTR eax>99 ;zoom in.
				  mov eax,99
				.ELSEIF SDWORD PTR eax<-49 ;zoom out.
				  mov eax,-49
				.ENDIF
				mov ebx,(TERSEDATA PTR [edi]).yfinescrn
				.IF eax != ebx
				  push eax
				  invoke InvalidateRgn, g_hwnd,0,TRUE	 ;need to wipe background.
				  pop eax
				.ENDIF
				mov  (TERSEDATA PTR [edi]).yfinescrn,eax				;x

;update finetune of print-size...
				mov ffchange,0
		  invoke SendDlgItemMessage,hdlg,250,WM_GETTEXT,5,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				neg eax ;v1.38 decided -ve to bring margins in.
				;finetune is in %, limit range -50 to +50%...
				.IF SDWORD PTR eax>50 ;zoom in. (%)
				  mov eax,50
				.ELSEIF SDWORD PTR eax<-50 ;zoom out.
				  mov eax,-50
				.ENDIF
				;v1.38 displayed in % but stored as 0.1%...
				mov ebx,10
				imul ebx
				  ;v1.2...
				  mov  ecx,(TERSEDATA PTR [edi]).xfineprn
				  .IF ecx != eax ;a change has occurred.
					mov ffchange,1
				  .ENDIF
				mov  (TERSEDATA PTR [edi]).xfineprn,eax 		   ;x
		  invoke SendDlgItemMessage,hdlg,251,WM_GETTEXT,5,ADDR szascii1
				invoke str2longint, ADDR szascii1				;-->eax
				neg eax ;v1.38 decided -ve to bring margins in.
				.IF SDWORD PTR eax>50 ;zoom in.
				  mov eax,50
				.ELSEIF SDWORD PTR eax<-50 ;zoom out.
				  mov eax,-50
				.ENDIF
				;v1.38 displayed in % but stored as 0.1%...
				mov ebx,10
				imul ebx
				  ;v1.2...
				  mov  ecx,(TERSEDATA PTR [edi]).yfineprn
				  .IF ecx != eax ;a change has occurred.
					mov ffchange,1
				  .ENDIF
				mov  (TERSEDATA PTR [edi]).yfineprn,eax 		   ;x

;v1.2 if .x/yfineprn !=0 then force "show page margins", .fviewprefs/bit0...
			   mov eax,(TERSEDATA PTR [edi]).xfineprn
			   mov ecx,(TERSEDATA PTR [edi]).yfineprn
			   .IF eax != 0
z90:			 .IF ffchange==1
;					mov eax,(TERSEDATA PTR [edi]).fviewprefs
;					and al,11111110b	   ;clr bit0.
;					mov (TERSEDATA PTR [edi]).fviewprefs,eax ;hide page margins, temp.
;v1.2 fix old margins getting left on screen...
				   invoke InvalidateRgn, g_hwnd,0,TRUE	  ;invalidate entire window.
				   mov g_fredrawdiag,ENTIRE 							   ;redraw entire window.
				 .ENDIF
				 mov eax,(TERSEDATA PTR [edi]).fviewprefs
				 or al,01b						;set bit0.
				 mov (TERSEDATA PTR [edi]).fviewprefs,eax
			   .ELSEIF ecx != 0
				 jmp z90
			   .ENDIF

;v1.27 update background color...
		  invoke SendDlgItemMessage,hdlg,255,BM_GETCHECK,0,0 ;white.
		  .IF ax==1
			mov ebx,0
		  .ELSE
			invoke SendDlgItemMessage,hdlg,256,BM_GETCHECK,0,0 ;black.
			.IF ax==1
			  mov ebx,1
			.ELSE
			  invoke SendDlgItemMessage,hdlg,257,BM_GETCHECK,0,0 ;grey.
			  .IF ax==1
				mov ebx,2
			  .ELSE 	;standard window background...
				;mov ebx,3
				;there is a problem here...
				;not allowed to use a brush for a systems color to register
				;a window class, but can use the color-index, ex COLOR_WINDOW.
				;i've got the brushes in order in .DATA, but treat special case here...
				mov eax,COLOR_WINDOW
				inc eax ;need COLOR_WINDOW+1.
				;note, back in WinMain() I saved g_hstandardbrush and g_cstandardbrush (RGB).
				mov (TERSEDATA PTR [edi]).nbackground,3
				jmp go1
			  .ENDIF
			.ENDIF
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).nbackground,ebx
		  ;also have to tell the window class about this...
		  mov eax,ebx
		  shl eax,1 ;dword
		  shl eax,1 ;/
		  lea ebx,g_hwhitebrush
		  add ebx,eax ;address of brush.
		  mov eax,[ebx] ;get brush.
go1:	  invoke SetClassLongA,g_hwnd,GCL_HBRBACKGROUND,eax

;handle radius...   v3.31
    invoke SendDlgItemMessage,hdlg,284,WM_GETTEXT,2,ADDR szasciitbl
    invoke str2longint, ADDR szasciitbl ;-->integer in eax
			  .IF eax==0 ;not allowed.
			    mov eax,2
			  .ENDIF
    mov (TERSEDATA PTR [edi]).nhandleradius,eax

;THIS ONE MUST BE LAST!
;save settings to eve.ini...
		  invoke SendDlgItemMessage,hdlg,260,BM_GETCHECK,0,0
		  mov edi,pTERSEDATA
		  .IF ax==1 			;enable.
			  ;the fields of TERSEDATA that we need to save are .feveprefs,
			  ; .fviewprefs, .x/yfinescrn, .x/yfineprn, .nbackground, .szeditor1,
			  ; .charsetdefault.
			  mov eax,(TERSEDATA PTR [edi]).feveprefs
			  invoke bin2dec,10
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryfeveprefs,eax,ADDR szpathspeceveini
			  mov eax,(TERSEDATA PTR [edi]).fviewprefs
			  invoke bin2dec,10
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryfviewprefs,eax,ADDR szpathspeceveini
			  mov eax,(TERSEDATA PTR [edi]).xfineprn
			  invoke bin2signedascii_upload,0,eax,0,0 ;returns eax ptg to string.
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryxfineprn,eax,ADDR szpathspeceveini
			  mov eax,(TERSEDATA PTR [edi]).yfineprn
			  invoke bin2signedascii_upload,0,eax,0,0 ;returns eax ptg to string.
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryyfineprn,eax,ADDR szpathspeceveini
			  mov eax,(TERSEDATA PTR [edi]).nbackground
			  invoke bin2dec,10
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentrynbackground,eax,ADDR szpathspeceveini
			  mov eax,(TERSEDATA PTR [edi]).charsetdefault
			  invoke bin2dec,10
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentrycharsetdefault,eax,ADDR szpathspeceveini
			  ;lea eax,szeditor1 ;(TERSEDATA PTR [edi]).szeditor1 v3.01
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryszeditor,ADDR szeditor1,ADDR szpathspeceveini ;v3.01
			  ;v2.31			
			  ;lea eax,(TERSEDATA PTR [edi]).szeditor2   v3.01
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentry2szeditor,ADDR szeditor2,ADDR szpathspeceveini  ;v3.01
			  ;v2.89
			  ;lea eax,(TERSEDATA PTR [edi]).szbrowser2 v3.01
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryszbrowser2,ADDR szbrowser2,ADDR szpathspeceveini  ;v3.01
			  ;v2.92
			  ;lea eax,(TERSEDATA PTR [edi]).szpainter1  v3.01
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentryszpainter,ADDR szpainter1,ADDR szpathspeceveini ;v3.01
				;v3.31		
			  mov eax,(TERSEDATA PTR [edi]).nhandleradius
			  invoke bin2dec,10
			  invoke WritePrivateProfileString,ADDR szsectionpreferences, \
						 ADDR szentrynhandleradius,eax,ADDR szpathspeceveini
		  .ENDIF


		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE


		.ELSEIF wparam==225 ;apply new default character set to all existing.
		  ;update default char set...
		  invoke SendDlgItemMessage,hdlg,219,CB_GETCURSEL,0,0
		  lea ebx,csids ;id's for each char set.
		  add ebx,eax
		  xor eax,eax
		  mov al,[ebx]	;get char set id.
		  mov ebx,pTERSEDATA
		  mov (TERSEDATA PTR [ebx]).charsetdefault,eax
		  ;now go thru database and set object.ncharset in all labels/icons...
		  invoke applycharset

    .ELSEIF WORD PTR wparam==273 ;checkbox use alternative browser v2.89.
		  invoke SendDlgItemMessage,hdlg,273,BM_GETCHECK,0,0
		  .IF ax==1 ;ticked.
		    xor eax,eax
		  .ELSE
		    mov eax,1
		  .ENDIF
		  invoke SendDlgItemMessage,hdlg,274,EM_SETREADONLY,eax,0
      xor eax,eax ;so will do default processing.

    .ELSEIF wparam==277 ;first external editor v2.89
      mov idedit,218
ff1:  ;find an .exe file and copy path/filename to database...
        ;first, copy default structure...
				lea edi,exefilenamestruct
				lea ebx,defaulttemplate
				mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1
			lea edi,exefilenamestruct
      mov (OPENFILENAME PTR [edi]).on_lpstrFilter,OFFSET szexefilter
      lea ebx,szexebuf
      mov [ebx],BYTE PTR 0
      mov (OPENFILENAME PTR [edi]).on_lpstrFile,ebx
      mov (OPENFILENAME PTR [edi]).on_Flags,OFN_FILEMUSTEXIST OR OFN_HIDEREADONLY OR \
        OFN_READONLY OR OFN_EXPLORER
      mov (OPENFILENAME PTR [edi]).on_lpstrDefExt,OFFSET szembeddedextension
      invoke GetOpenFileName,edi  ;<<<DIALOG BOX<<<<
      .IF eax==0					;0=error/cancel
      .ELSE
        ;filespec is in szexebuf...
        mov eax,idedit
        lea ecx,szexebuf
			  invoke SendDlgItemMessage,hdlg,eax,WM_SETTEXT,0,ecx
      .ENDIF
      mov eax,TRUE
    .ELSEIF wparam==276 ;2nd external editor v2.89
      mov idedit,269
      jmp ff1
    .ELSEIF wparam==275 ;alternative browser v2.89
      mov idedit,274
      jmp ff1
    .ELSEIF wparam==282 ;external paint editor v2.92
      mov idedit,281
      jmp ff1

    .ELSEIF wparam==287 ;disable all editing checkbox. v3.53
      IFE fDEVELOPER ;standard eve...
		    invoke SendDlgItemMessage,hdlg,287,BM_SETCHECK,1,0 ;cannot uncheck!
        mov eax,TRUE ;do not do default processing.
      ELSE ;web ed...
        xor eax,eax ;do default processing.
      ENDIF

		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF

  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
PREFSproc				 ENDP
;--------------------------------------------------------------------------
applycharset PROC STDCALL USES ebx ecx edx esi edi
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
; "applycharset"
;called from prefsproc(). apply tersedata.charsetdefault to all existing
;labels and icons (i.e. into their object.ncharset).
;-- exception, only apply change if label/icon is set to one of the 3 default
;fonts, Arial, Times new Roman, Courier New. Not to a custom font.

;scan through all objects...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp j03
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==-1				;data object
						.ELSE
						  ;note, want to include library-objects in this, which have bits 15-31 of
						  ;.nexttype set (bits 0-14 as before)...
						  and eax,07FFFh ;mask off bits 15-31.
						  ;(note, data elements in lib-objs have bits 14-31 set).
						  .IF eax==33 ;label
w01:							mov eax,(OBJECT PTR [esi]).nfonttype
								.IF al<3 ;only change charset if one of the 3 default fonts.
								  mov eax,(TERSEDATA PTR [edi]).charsetdefault
								  mov (OBJECT PTR [esi]).ncharset,eax
								.ENDIF
						  .ELSEIF eax>=60 ;icon
								.IF eax<=69
								  jmp w01
								.ENDIF
						  .ENDIF
						.ENDIF
				  .ENDIF
x1: mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  j02 ;nextobj
		  jmp SHORT j03
j02:  jmp nextobj
j03:


		ret
applycharset ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
pfield DWORD 0
rpcategory DWORD 0

.CODE
sznewobj BYTE "New library object",0 ;v3.01 moved
szerbmptoobig BYTE "Max file size allowed 214 bytes",0
MENUDESCRIPTIONSIZE EQU 40 ;v3.47

toolboxproc PROC STDCALL USES ebx edi esi,hdlg:DWORD,message:DWORD,wparam:DWORD,lparam:DWORD
		LOCAL offfield:DWORD,ncontent:DWORD,pobjects:DWORD
		LOCAL ebxsave:DWORD,pboss:DWORD,rpboss:DWORD,pdata:DWORD
		LOCAL nlib:DWORD,freplace:DWORD
		LOCAL pbmpfile:DWORD,hfilebitmap:DWORD,plibdata:DWORD ;v3.45
		LOCAL bmpfilename[64]:BYTE                            ;v3.45
; "toolboxproc"
;menu Control/Toolbox... > IDM_TOOLBOX

	mov pdata,0
	mov nlib,0
	mov freplace,0
  .IF message==WM_INITDIALOG

		mov pfield,0
		mov rpcategory,0

;eve emergency-fix disable scrolling by mouse...
		mov edi,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).feveprefs
		and al,0100b					;bit2=0 mouse scrolling enabled (default).
		.IF al==0
				invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,0,0
		.ELSE					;disable mouse scrolling.
				invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
		.ENDIF

;eve emergency-fix disable intelligent window paint...
		mov edi,pTERSEDATA
		mov eax,(TERSEDATA PTR [edi]).feveprefs
		and al,01000b					;bit3=0 intelligent paint enabled (default).
		.IF al==0
				invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,0,0
		.ELSE					;disable intelligent paint.
				invoke SendDlgItemMessage,hdlg,225,BM_SETCHECK,1,0
		.ENDIF

;display listbox for element fields...
		mov ecx,14+50+2+4+2 ;70
		lea esi,szfields
xhmmzz:
		mov  al,[esi]
		cmp  al,0						;ignore null strings.
		je		 ximmzz
		push ecx
		invoke SendDlgItemMessage,hdlg,230,CB_ADDSTRING,0,esi
		pop ecx
		add esi,26
		loop xhmmzz
ximmzz:
		invoke SendDlgItemMessage,hdlg,229,EM_LIMITTEXT,4,0  ;element#
		invoke SendDlgItemMessage,hdlg,233,EM_LIMITTEXT,10,0 ;field content, decimal.
;		 invoke SendDlgItemMessage,hdlg,233,EM_SETREADONLY,TRUE,0
;		 invoke SendDlgItemMessage,hdlg,235,EM_LIMITTEXT,9,0 ;field content, hex.
		invoke SendDlgItemMessage,hdlg,235,EM_SETREADONLY,TRUE,0
		invoke SendDlgItemMessage,hdlg,226,EM_SETREADONLY,TRUE,0

;display starting address of OBJECTS...
				  mov eax,(TERSEDATA PTR [edi]).noffsetobjs
				  add eax,edi ;pTERSEDATA ;starting address of OBJECTS.
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
;				   lea	esi,szasciitbl
;						 mov  al,[esi]			 ;ignore leading blanks.
;						 .WHILE al==" " 		 ;/
;						   inc	esi 	 ;/
;						   mov	al,[esi]		 ;/
;						 .ENDW							 ;/
				  invoke SendDlgItemMessage,hdlg,214,WM_SETTEXT,0,esi
		invoke SendDlgItemMessage,hdlg,214,EM_SETREADONLY,TRUE,0

;display starting address of TERSEDATA...
				  mov eax,pTERSEDATA
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
;				   lea	esi,szasciitbl
;						 mov  al,[esi]			 ;ignore leading blanks.
;						 .WHILE al==" " 		 ;/
;						   inc	esi 	 ;/
;						   mov	al,[esi]		 ;/
;						 .ENDW							 ;/
				  invoke SendDlgItemMessage,hdlg,216,WM_SETTEXT,0,esi
		invoke SendDlgItemMessage,hdlg,216,EM_SETREADONLY,TRUE,0

;display total # elements...
				  mov eax,(TERSEDATA PTR [edi]).numrecords
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
;				   lea	esi,szasciitbl
;						 mov  al,[esi]			 ;ignore leading blanks.
;						 .WHILE al==" " 		 ;/
;						   inc	esi 	 ;/
;						   mov	al,[esi]		 ;/
;						 .ENDW							 ;/
				  invoke SendDlgItemMessage,hdlg,227,WM_SETTEXT,0,esi
		invoke SendDlgItemMessage,hdlg,227,EM_SETREADONLY,TRUE,0

;library managemnt edit boxes...
		invoke SendDlgItemMessage,hdlg,240,EM_LIMITTEXT,2,0 ;library#.
		invoke SendDlgItemMessage,hdlg,246,EM_LIMITTEXT,255,0 ;descrip.

;upload total number of objects in library...
		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).numlibrary
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,255,WM_SETTEXT,0,eax

;library categories...
		invoke SendDlgItemMessage,hdlg,261,EM_LIMITTEXT,255,0 ;descrip.

;v2.91 readonly checkbox, can video driver support transparent color...
      .IF fdrivertransparent != 0 ;loaded in wmcreate().
				invoke SendDlgItemMessage,hdlg,222,BM_SETCHECK,1,0
      .ENDIF
      
;v3.45 need a limit on length of menu item descriptions, as using library-data-element
;to also hold a bitmap file... 41 chars... v3.47
		invoke SendDlgItemMessage,hdlg,246,EM_LIMITTEXT,MENUDESCRIPTIONSIZE-1, 0 ;127,0 ;127 chars max. v3.47
		;also on bmp filename editbox...
		invoke SendDlgItemMessage,hdlg,272,EM_LIMITTEXT,63,0 ;63 chars max.

		  mov eax,TRUE
  .ELSEIF message==WM_COMMAND
		.IF wparam==IDOK
		  mov  g_fhaschanged,1



;eve emergency-fix disable scrolling by mouse...
		  invoke SendDlgItemMessage,hdlg,224,BM_GETCHECK,0,0
				 mov edi,pTERSEDATA
		  .IF ax==1 			;disable mouse scrolling.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 or al,0100b			;set bit2.
		  .ELSE 								;enable.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 and al,11111011b		;clr bit2.
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).feveprefs,eax ;al

;eve emergency-fix disable intelligent paint...
		  invoke SendDlgItemMessage,hdlg,225,BM_GETCHECK,0,0
				 mov edi,pTERSEDATA
		  .IF ax==1 			;disable intelligent paint.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 or al,01000b			;set bit3.
		  .ELSE 								;enable.
				 mov eax,(TERSEDATA PTR [edi]).feveprefs
				 and al,11110111b		;clr bit3.
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).feveprefs,eax ;al


		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE


		.ELSEIF wparam==DWORD PTR ((CBN_SELENDOK*65536)+230) ;an element-field selected.
		  ;IFE fDEVELOPER ;if fDEVELOPER=0
		  ; 	 jmp x59x		  ;bypass code for this section.
		  ;ENDIF
		  invoke SendDlgItemMessage,hdlg,230,CB_GETCURSEL,0,0
		  and eax,07Fh
		  shl eax,1
		  shl eax,1
		  mov offfield,eax ;offset of field from start of object.
				invoke SendDlgItemMessage,hdlg,229,WM_GETTEXT,5,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=element#.
				mov ebx,pTERSEDATA
				  .IF SDWORD PTR eax<0
						xor eax,eax
						jmp SHORT ci1
				  .ENDIF
				  mov ecx,(TERSEDATA PTR [ebx]).numrecords
				  .IF eax>=ecx	;end of database.
						mov eax,ecx
						dec eax
ci1:					  push eax
						  invoke bin2dec,10
						  ;...returns eax->start of string, past the leading blanks.
						  invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,eax
						  pop eax
				  .ENDIF
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
				mul ecx
				  mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
				  add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
				  mov pobjects,edx
				  add eax,edx			 ;eax->element we are to look at.
				add eax,offfield ;addr of field.
				mov pfield,eax
				mov ebx,eax
				mov eax,[ebx]
				mov ncontent,eax
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
				invoke SendDlgItemMessage,hdlg,233,WM_SETTEXT,0,esi
				;do it again, for hex display of field content...
				mov eax,ncontent
				invoke bin2dec,16				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
;				 lea  esi,szasciitbl
;						 mov  al,[esi]			 ;ignore leading blanks.
;						 .WHILE al==" " 		 ;/
;						   inc	esi 	 ;/
;						   mov	al,[esi]		 ;/
;						 .ENDW							 ;/
				invoke SendDlgItemMessage,hdlg,235,WM_SETTEXT,0,esi
				;".rp" fields point to another element...(.rpowner1,.rpowner2,.rpdata)...
				.IF offfield==12		 ;.rpdata
r01:	  mov eax,ncontent
				  .IF eax != 0
						add eax,pTERSEDATA ;convert to absolute address.
						sub eax,pobjects   ;now relative to OBJECTS.
						xor edx,edx
						mov edi,pTERSEDATA
						mov ecx,(TERSEDATA PTR [edi]).nsizeobject
						div ecx
				  .ENDIF
				.ELSEIF offfield==20 ;.rpowner1
				  jmp r01
				.ELSEIF offfield==24 ;.rpowner2
				  jmp r01
				.ELSE
				  xor eax,eax
				.ENDIF
				invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
				;...returns eax->start of string, past the leading blanks.
				mov esi,eax
;				 lea  esi,szasciitbl
;						 mov  al,[esi]			 ;ignore leading blanks.
;						 .WHILE al==" " 		 ;/
;						   inc	esi 	 ;/
;						   mov	al,[esi]		 ;/
;						 .ENDW							 ;/
				invoke SendDlgItemMessage,hdlg,226,WM_SETTEXT,0,esi
x59:	mov eax,TRUE

		.ELSEIF wparam==233 ;change made to field content.
		  ;IFE fDEVELOPER ;if fDEVELOPER=0
		  ; 	 jmp x59x		  ;bypass code for this section.
		  ;ENDIF
		  .IF pfield != 0
				invoke SendDlgItemMessage,hdlg,233,WM_GETTEXT,11,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=field content.
				mov ebx,pfield
				mov [ebx],eax
		  .ENDIF
		  mov eax,TRUE

		.ELSEIF wparam==DWORD PTR ((EN_CHANGE*65536)+266) ;change made to header addr. v3.28
		  ;addr relative to start of database, decimal. read content, display.
			invoke SendDlgItemMessage,hdlg,266,WM_GETTEXT,11,ADDR szascii1
			invoke str2longint, ADDR szascii1				;return eax=content.
			mov ebx,eax
			.IF ebx>4479 ;4480=size of header section of database.
			  mov ebx,4479
			  mov eax,ebx
			  push ebx
			  invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits) dec.
			  invoke SendDlgItemMessage,hdlg,266,WM_SETTEXT,0,eax
			  pop ebx
		  .ENDIF
		  add ebx,pTERSEDATA
		  mov eax,[ebx]
			invoke bin2dec,16				   ;eax-->asciitbl+0 to +9 (10 digits) hex.
			;...returns eax->start of string, past the leading blanks.
			invoke SendDlgItemMessage,hdlg,269,WM_SETTEXT,0,eax
			mov eax,TRUE
		
		.ELSEIF wparam==248 ;insert highlighted composite-element
			  ;"Append" at end of menu...
;		   mov pdata,0 ;see "Replace" button below.
;		   mov nlib,0  ;/
		  ;into library...
re1:	.IF g_pselectedobject != 0
				 mov eax,g_pselectedobject
				 mov g_pselectedobject,0
		  .ELSE
				.IF highlightedindex==0 ;empty
				  jmp x44
				.ELSE
				  mov eax,highlightedlist ;1st element in list.
				.ENDIF
		  .ENDIF
		  mov pboss,eax ;note, not necessarily the boss, can be any element in compobj.
		  mov highlightedindex,0 ;empty the list.

        ;3.05 moved up from "replace" button...(see comment below)
        .IF freplace != 0		
				  invoke findcomposite,nlib,1 ;=1 deletes comp-obj and library dataelem.
				  ;...eax->attached dataelement, else eax=0 not fnd.
				  .IF eax != 0 ;pts to it, even though it is deleted.
				    ;what we want to do is use this data element for our new comp-obj...
				    mov pdata,eax
				    mov ebx,eax
				    mov (OBJECT PTR [ebx]).fstatus,01 ;as it got erased.
				  .ELSE
				    jmp x44 ;get out.
				  .ENDIF
		    .ENDIF
		  
		  invoke addlocked2highlighted,pboss
		  ;...pboss->any element in comp.obj, func finds boss element, returns
		  ;ptr to boss in eax. all of comp.obj is now in highlighted list.
		  
		  ;v3.05 pboss is actually->any element in compobj, not necessarily boss.
		  ;v3.05 we have boss in eax, so don't really need the code below that
		  ;finds boss, but best to leave it here...

						;go thru highlightedlist and find a suitable element
						;to attach menu-description to...
						;v1.41 i would like to attach library-dataelement to the "boss"
						; element in the composite-object (.rpowner1=0).
						mov ebx,0
fend2:	    lea esi,highlightedlist ;start of highlightedlist.
						mov ebxsave,ebx
						mov eax,highlightedindex		;end of list.
						shl eax,1
						shl eax,1
						cmp ebx,eax
						je fend1				;get out.
						mov edi,[esi+ebx]
						or edi,edi ;cmp edi,0								;precaution.
						je fend3
						;drop here, edi->element from highlighted list...
						  mov eax,(OBJECT PTR [edi]).fconfig1
						  mov ecx,(OBJECT PTR [edi]).nexttype
						  and al,01 ;bit0=1 wire type.
						  .IF al==01
								jmp SHORT fend3
						  .ELSEIF cx>=60
								.IF cx<=69
								  ;icon...
								  jmp SHORT fend3
								.ENDIF
						 .ENDIF
						   ;v1.41  find boss...
						   mov eax,(OBJECT PTR [edi]).rpowner1
						   .IF eax != 0
							   jmp fend3
						   .ENDIF
						 jmp fnd2 ;has no owner, so is boss.
fend3:			mov ebx,ebxsave ;look at next element.
						add ebx,4
						jmp fend2
fend1:			;fail...
				  invoke myalertbox,ADDR szer018,4 ;invoke myerrorhandler,018 ;no elements are correct type.
				  mov highlightedindex,0
				  .IF pdata != 0  ;came from "Replace" button.
					  mov ebx,pdata
					  mov (OBJECT PTR [ebx]).fstatus,0 ;remove data element.
				  .ENDIF
				  jmp x44 ;get out.
fnd2:			mov pboss,edi
							 push eax						  ;save previous value of state.
							 mov al,g_nstate		  ;/
							 mov g_nstateprev,al  ;/
							 pop eax						  ;/
				  mov g_nstate,0
;i've got all elements of composite-object in highlightedlist.
;now go thru list and negate all .nexttype fields...
				mov ebx,0
xfend2:  lea esi,highlightedlist ;start of highlightedlist.
				mov ebxsave,ebx
				mov eax,highlightedindex		;end of list.
				shl eax,1
				shl eax,1
				cmp ebx,eax
				je xfend1				 ;get out.
				mov edi,[esi+ebx]
				or edi,edi ;cmp edi,0								;precaution.
				je xfend3
				;drop here, edi->element from highlighted list...
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF SWORD PTR ax>=0
				  ;make them into "undefined" data elements...
				  ;(bits15-31 =1)...
				  or (OBJECT PTR [edi]).nexttype,0FFFF8000h
				.ENDIF
xfend3:  mov ebx,ebxsave
				add ebx,4
				jmp xfend2
xfend1:  mov highlightedindex,0 ;empty it.
		 mov highlightedindexnewlist, 0 ;precaution
		 ;...note, createnewobject() below will clr all other pointers.
				mov g_fclrhighlighted,1  ;superfluous, as elements have vanished.

;need a dataelement to hold label for menu...
			.IF pdata != 0 ;came from "Replace" button.
			  mov ebx,pdata
			  jmp SHORT re2
			.ENDIF
				  ;v1.23 ptrs may get invalidated...
				  mov eax,pboss
				  sub eax,pTERSEDATA
				  mov rpboss,eax
				invoke createnewobject,1 ;v1.21 0
				  mov ebx,rpboss
				  add ebx,pTERSEDATA
				  mov pboss,ebx
				mov ebx,eax
re2:			mov eax,pboss
				sub eax,pTERSEDATA
				mov (OBJECT PTR [ebx]).rpowner1,eax
				mov (OBJECT PTR [ebx]).nexttype,0FFFFC000h ;bit14-31 =1.
				lea ecx,(OBJECT PTR [ebx]).sztext ;data area.
				sub ebx,pTERSEDATA
				mov eax,ebx
				mov ebx,pboss
				mov (OBJECT PTR [ebx]).rpdata2,eax
				invoke lstrcpy,ecx,ADDR sznewobj

x45:	;need to scan thru entire database and reload all the
				;library objects to the Elements menu...
				invoke addcomposites2menu,0  ;also updates tersedata.numlibrary.
x46:	  ;update total# objects display...
				  mov ebx,pTERSEDATA
				  mov eax,(TERSEDATA PTR [ebx]).numlibrary
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				  ;...returns eax->start of string, past the leading blanks.
				  push eax
				  invoke SendDlgItemMessage,hdlg,255,WM_SETTEXT,0,eax
				  pop eax
		  ;v1.21 also set "library#:" edit box to this value...
				.IF nlib != 0 ;came from "Replace" button.
				  mov eax,nlib
				  invoke bin2dec,10 	 ;eax-->asciitbl+0 to +9 (10 digits)
				.ENDIF
				  invoke SendDlgItemMessage,hdlg,240,WM_SETTEXT,0,eax
				  ;and activate as-if pushed "View" button (id=244)...
				  jmp z09
x44:	  mov eax,TRUE

		.ELSEIF wparam==244 ;"view" button.
z09:			invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				invoke findcomposite,eax,0
				;...eax->attached dataelement, else eax=0 not fnd.
				.IF eax != 0
				  mov ebx,eax
				  push eax
				  lea eax,(OBJECT PTR [ebx]).sztext
				  invoke SendDlgItemMessage,hdlg,246,WM_SETTEXT,0,eax ;menu description
				  pop eax
					;v1.24
					;lets write element# to low-level tools element# edit box, so
					;will be able to look at element fields, for troubleshooting...
					push eax
						;convert element-address to element#...
						mov edi,pTERSEDATA
						mov edx,(TERSEDATA PTR [edi]).noffsetobjs
						add edx,edi ;pTERSEDATA ;starting address of OBJECTS.
						mov pobjects,edx
						sub eax,pobjects   ;now relative to OBJECTS.
						xor edx,edx
						mov ecx,(TERSEDATA PTR [edi]).nsizeobject
						div ecx ;...now have element# in eax.
					invoke bin2dec,10
					;...returns eax->start of string, past the leading blanks.
					invoke SendDlgItemMessage,hdlg,229,WM_SETTEXT,0,eax
					pop eax
					  ;v1.31
					  ;let's write category text to categories description box,
					  ;if there is a category...
					  mov ebx,eax	  ;library-dataelement.
					  mov eax,(OBJECT PTR [ebx]).rpdata
					  .IF eax != 0
						;there is a category...
						mov esi,eax
						add esi,pTERSEDATA
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF eax==0FFFFE000h ;category-dataelement. precaution.
						  mov eax,(OBJECT PTR [esi]).fstatus
						  and al,01
						  .IF al==01
							mov ebx,esi
							sub esi,pTERSEDATA
							mov rpcategory,esi
							jmp nx6 ;view its description.
						  .ELSE
							jmp SHORT zx1
						  .ENDIF
						.ELSE
						  jmp SHORT zx1
						.ENDIF
					  .ELSE
zx1:					mov (OBJECT PTR [ebx]).rpdata,0 ;precaution.
						jmp nx4 ;no category, display no description.
					  .ENDIF
				.ENDIF
				mov eax,TRUE

		.ELSEIF wparam==249 ;"delete" library member button.
		  ;IFE fDEVELOPER ;if fDEVELOPER=0
		  ; 	 jmp x59x		  ;bypass code for this section.
		  ;ENDIF
		  
		  ;v3.05 a problem is that findcomposite() uses the highlight list,
		  ;and will delete everything in it. so, empty it first...
		  ;mov highlightedindex,0 ...no, put this instr into findcomposite().
		  
				invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				invoke findcomposite,eax,1
				;...eax->attached library-dataelement, else eax=0 not fnd.
				.IF eax != 0
				  ;v1.24
				  ;a bug, library-dataelement didn't get deleted(normally does), so do it here...
				  ;(cos it's attached to boss via boss.rpdata2. v3.45)
				  mov ebx,eax
						      mov eax,(OBJECT PTR [ebx]).ximage  ;bitmap handle. ;v3.45
						      .IF eax != 0 ;holds gppicturecheckmark. v3.46
								    mov   edx,eax	   ;gppicturecheckmark->Release();
								    push  edx						   ;/  "this" has to be passed, which is a ptr
								    mov   ecx,dword ptr [edx]		  ;/  to the interface.
								    call  dword ptr [ecx+8] 		  ;/
						        mov (OBJECT PTR [ebx]).ximage,0
						      .ENDIF
				  mov (OBJECT PTR [ebx]).fstatus,0
					lea eax,sznull
					invoke SendDlgItemMessage,hdlg,246,WM_SETTEXT,0,eax ;menu description.
					lea eax,sznull
					invoke SendDlgItemMessage,hdlg,240,WM_SETTEXT,0,eax
				  jmp x45
				.ENDIF
				mov eax,TRUE

		.ELSEIF wparam==252 ;"Replace" library member button.
			;highlighted obj to be placed into menu, replacing current entry in element#
			;edit box...
			  ;firstly, delete current entry...
				invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				mov nlib,eax ;save for later.
				
				;v3.05 a bug here, as findcomposite,eax,1 will find and delete the
				;comp-obj ptd to by library data element. (note library data elements
				;each have a library#, stored in .xdata).
				;the problem is, this func uses the highlightedlist and erases everything
				;in it. so, if have our comp-obj in the list, need to get one element
				;off it and empty the highlightedlist...
				;already have code for this in "append" code, so use this flag...
				mov freplace,1
				jmp re1
				;and this code move up...
;				invoke findcomposite,eax,1
;				;...eax->attached dataelement, else eax=0 not fnd.
;				.IF eax != 0
;				  ;what we want to do is use this data element for our new comp-obj...
;				  mov pdata,eax
;				  mov ebx,eax
;				  mov (OBJECT PTR [ebx]).fstatus,01 ;as it probably got erased.
;				  jmp re1
;				.ENDIF
;				mov eax,TRUE


		.ELSEIF wparam==247 ;"change" button.
				invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				mov nlib,eax ;save for later. (after x45:)
				invoke findcomposite,eax,0
				;...eax->attached dataelement, else eax=0 not fnd.
				.IF eax != 0
				  mov ebx,eax
				  lea eax,(OBJECT PTR [ebx]).sztext ;MENUDESCRIPTIONSIZE=42 v3.47
				  invoke SendDlgItemMessage,hdlg,246,WM_GETTEXT,MENUDESCRIPTIONSIZE,eax ;128,eax ;256,eax menu description v3.45
				  ;...2nd part of data-element being used for bmp file. v3.45
				  jmp x45
				.ENDIF
				mov eax,TRUE

		.ELSEIF wparam==253 ;"delete" entire library button.
				invoke addcomposites2menu,1 ;1=delete entire menu and objects.
				jmp x46

		.ELSEIF wparam==250 ;"Move to start of menu" button.
				mov esi,2 ;0
v09:			invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1 ;library#.
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				invoke findcomposite,eax,0
				;...eax->attached dataelement, else eax=0 not fnd.
				.IF eax != 0
				  invoke move1object,eax,esi ;esi=1 end of database, =0 closer to beginning.
						   ;=2 right at element #1 (shifts entire database 1 record).
				  ;...returns eax=address of new location.
				  .IF eax != 0
					push eax
					invoke addcomposites2menu,0
					;...also updates all .xdata (library#) fields.
					;...note, i'm going to call this inside "move1object,pobj,2" case,
					;as all records get shifted, invalidating elements menu entries
					;-- and move1object() is called from other places.
					pop eax
					push eax
					mov ebx,eax
					lea eax,(OBJECT PTR [ebx]).sztext
					invoke SendDlgItemMessage,hdlg,246,WM_SETTEXT,0,eax ;menu description.
					pop eax
					;also set "library#:" edit box to this value...
					mov ebx,eax
					mov eax,(OBJECT PTR [ebx]).xdata
					invoke bin2dec,10	   ;eax-->asciitbl+0 to +9 (10 digits)
					;...returns eax->start of string, past the leading blanks.
					invoke SendDlgItemMessage,hdlg,240,WM_SETTEXT,0,eax
				  .ENDIF
				.ENDIF
				mov eax,TRUE

		.ELSEIF wparam==242 ;"Move to end of menu" button.
				mov esi,1
				jmp v09

;v1.31 library categories...

		.ELSEIF wparam==263 ;"append new" button, library categories.
			;need to create a new dataelement...
			invoke createnewobject,1
			.IF eax != 0
			  mov ebx,eax
			  sub eax,pTERSEDATA
			  mov rpcategory,eax
			  xor eax,eax
			  mov (OBJECT PTR [ebx]).nexttype,0FFFFE000h ;category dataelement.
			  mov (OBJECT PTR [ebx]).number,eax ;0
			  mov (OBJECT PTR [ebx]).sztext,eax ;0	;precaution.
			  mov (OBJECT PTR [ebx]).ximage,eax ;0	;/
			  mov (OBJECT PTR [ebx]).rpowner1,eax ;0 ;/
			  mov (OBJECT PTR [ebx]).rpowner2,eax ;0 ;/
			  mov (OBJECT PTR [ebx]).rpdata,eax ;0	;/
				  mov (OBJECT PTR [ebx]).nrings,eax ;0
				  mov (OBJECT PTR [ebx]).nbeginring,eax ;0
				  mov (OBJECT PTR [ebx]).nendring,eax ;0
			  ;save any text description...
			  jmp nx3
			.ELSE
			  jmp nx4
			.ENDIF
			mov eax,TRUE

		.ELSEIF wparam==264 ;"delete" button, library categories.
			;delete current category data element...
			.IF rpcategory != 0
			  mov ebx,rpcategory
			  add ebx,pTERSEDATA
			  mov (OBJECT PTR [ebx]).fstatus,0
			  ;also, .ximage may have handle of a popup submenu...
			  mov eax,(OBJECT PTR [ebx]).ximage
			  .IF eax != 0
				;invoke DestroyMenu,eax
				;...no, popup is appended to Elements menu, and I destroy and rebuild
				;Elements menu below, in addcomposites2menu().
				;(DestroyMenu() won't work here anyway; will destroy entire menu).
			  .ENDIF
			  mov rpcategory,0
				  ;need to scan thru entire database and reload all the
				  ;library objects to the Elements menu...
				  invoke addcomposites2menu,0  ;also updates tersedata.numlibrary.
			.ENDIF
			;i think we need to find next category...
			jmp nx1

		.ELSEIF wparam==262 ;"change" button, library categories.
			;updates the text description of the category...
nx3:		.IF rpcategory != 0
			  mov ebx,rpcategory
			  add ebx,pTERSEDATA
				  lea eax,(OBJECT PTR [ebx]).sztext
				  invoke SendDlgItemMessage,hdlg,261,WM_GETTEXT,256,eax
				  ;need to scan thru entire database and reload all the
				  ;library objects to the Elements menu...
				  invoke addcomposites2menu,0  ;also updates tersedata.numlibrary.
			.ENDIF
			mov eax,TRUE

		.ELSEIF wparam==260 ;"view next" button, library categories.
			;find the next category dataelement in database...
			.IF rpcategory != 0
			  mov eax,rpcategory
			  add eax,pTERSEDATA
			  invoke findnextcategory,eax
			  .IF eax==0 ;not found.
				jmp nx1
			  .ENDIF
			.ELSE
nx1:		  xor eax,eax
			  invoke findnextcategory,eax ;look from start of database.
			.ENDIF
			.IF eax != 0 ;found.
			  mov ebx,eax
			  sub eax,pTERSEDATA
			  mov rpcategory,eax
			  ;upload text description...
nx6:			  lea eax,(OBJECT PTR [ebx]).sztext
nx2:			  invoke SendDlgItemMessage,hdlg,261,WM_SETTEXT,0,eax
			.ELSE
nx4:		  mov rpcategory,0
			  lea eax,sznull
			  jmp nx2
			.ENDIF
			mov eax,TRUE

		.ELSEIF wparam==258 ;"place in category" button, library categories.
		  ;rpcategory non-0, pts to current category-dataelement.
		  ;put this value into current composite-object library dataelement.rpdata.
			;read library# editbox, find library-dataelement...
			invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
			invoke str2longint, ADDR szascii1				;return eax=library#.
			invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
			invoke findcomposite,eax,0
			;...eax->attached library-dataelement, else eax=0 not fnd.
			.IF eax != 0
			  mov ebx,eax
			  mov eax,rpcategory
				mov (OBJECT PTR [ebx]).rpdata,eax
				;...library-dataelement now pts to category-dataelement.
				;...or =0 if no current category.
				  ;need to scan thru entire database and reload all the
				  ;library objects to the Elements menu...
				  invoke addcomposites2menu,0  ;also updates tersedata.numlibrary.
			.ENDIF
			mov eax,TRUE

    .ELSEIF wparam==273 ;"Load" bitmap file to menu. v3.45
      ;filename should be in editbox id=272. no path.
      ;boss-element.rpdata2->library-data-element, which has the text for the menuitem.
      ;why can't we use 2nd half of data-element to hold bmp file?
      ;ok, have limited menu descriptions to 39 chars +0 terminator -> 40 bytes.
      ;so, bitmap is at data-element.sztext+40 (214 bytes max).
      ;note, "SetCurrentDirectory(),ADDR szhomefolder" called prior, at IDM_TOOLBOX. v3.48
        ;find library-data-element...
				invoke SendDlgItemMessage,hdlg,240,WM_GETTEXT,3,ADDR szascii1
				invoke str2longint, ADDR szascii1				;return eax=library#.
				invoke nliblimits,hdlg ;truncates library# (in eax) to limits.
				mov nlib,eax ;save for later. (after jump to x45:)
				invoke findcomposite,eax,0
				;...eax->attached dataelement, else eax=0 not fnd.
				.IF eax != 0
				  mov plibdata,eax
				  mov ebx,eax
				    ;there may already be a loaded bmp file, and addcomposites2menu() may have
				    ;created a bitmap handle for the image, which will be in .ximage...
				    mov eax,(OBJECT PTR [ebx]).ximage ;holds gppicturecheckmark.
				    .IF eax != 0
								mov   edx,eax	   ;gppicturecheckmark->Release();
								push  edx						   ;/  "this" has to be passed, which is a ptr
								mov   ecx,dword ptr [edx]		  ;/  to the interface.
								call  dword ptr [ecx+8] 		  ;/
				      mov (OBJECT PTR [ebx]).ximage,0
				    .ENDIF
				  lea eax,(OBJECT PTR [ebx]).sztext
				  add eax,MENUDESCRIPTIONSIZE-1 ;41 v3.47 127 ;2nd half for bmp file.
				  mov ebx,eax
				  mov [ebx],BYTE PTR 0 ;precaution to keep menuitem description separate.
				  inc ebx ;.sztext+42 v3.47 .sztext+128.
				  mov pbmpfile,ebx
				  ;get bmp filename...
				  invoke SendDlgItemMessage,hdlg,272,WM_GETTEXT,64,ADDR bmpfilename
          ;load bitmap...
          invoke CreateFile, ADDR bmpfilename,GENERIC_READ,FILE_SHARE_READ,\
								0,OPEN_EXISTING,FILE_ATTRIBUTE_READONLY+FILE_FLAG_SEQUENTIAL_SCAN,0
          .IF eax==INVALID_HANDLE_VALUE ;-1
	          ;open failed ...
	          invoke myalertbox,ADDR szer100,4  ;invoke myerrorhandler,100
	          mov ebx,plibdata  ;also a method of getting rid of an existing bmp file...
	          and (OBJECT PTR [ebx]).fstatus,0FFFFF7FFh ;clr bit11.
		      .ELSE
            mov hfilebitmap,eax	   ;handle of newly-opened file.
            invoke GetFileSize,eax,0
              mov ebx,plibdata
              mov (OBJECT PTR [ebx]).nshape,eax ;save filesize in the library data element.
            .IF eax>214 ;v3.47 128 ;max allowed.
	            invoke myalertbox,ADDR szerbmptoobig,4  ;invoke myerrorhandler,100
              invoke CloseHandle,hfilebitmap
            .ELSE
		          invoke ReadFile,hfilebitmap,pbmpfile,eax,ADDR nbyteswrote,0
              invoke CloseHandle,hfilebitmap
				      ;also set a flag in library-dataelement.fstatus that bitmap is loaded...
				      mov ebx,plibdata
				      or (OBJECT PTR [ebx]).fstatus,800h ;set bit11.
              ;load file into menu item...
				      jmp x45 ;calls addcomposites2menu(), which reloads menu.
		        .ENDIF
          .ENDIF
        .ENDIF
			mov eax,TRUE

		.ELSEIF wparam==IDCANCEL
		  invoke EndDialog, hdlg,TRUE
		  mov eax,TRUE
		.ELSE
		  mov eax,FALSE
		.ENDIF
  .ELSEIF message==WM_WINDOWPOSCHANGED
		invoke windowchanged,FALSE
;				 invoke InvalidateRgn, g_hwnd,0,FALSE	 ;invalidate entire window.
;				 mov g_fredrawdiag,ENTIRE								 ;redraw entire window.
;				   push g_nmousex
;				   push g_nmousey
;				   invoke UpdateWindow, g_hwnd	;send WM_PAINT immediately.
;				   pop	g_nmousey
;				   pop	g_nmousex
;				 mov  eax,TRUE
  .ELSE
				  ;have not processed a message...
				  mov  eax,FALSE
  .ENDIF

		ret
x59x:
		invoke MessageBeep,-1 ;unregistered user.
		invoke MessageBeep,-1 ;/
		mov eax,TRUE
		ret
toolboxproc    ENDP
;------------------------------------------------------------------------
findnextcategory PROC STDCALL USES ebx ecx edx esi edi,pcurrent
	LOCAL ecxsave:DWORD,pobjs:DWORD
; "findnextcategory"
;called from toolboxproc(). find next category data element. return in eax, else 0.
;if pcurrent non-0, it is current category dataelement, and look for next,
;otherwise look from start of database.

;scan through all objects...
			  mov edi,pTERSEDATA
			  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
			  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
			  mov pobjs,esi
			  mov ecx,(TERSEDATA PTR [edi]).numrecords
			  .IF cx==0  ;precaution.
				jmp xj03
			  .ENDIF
			  ;as we loop around, edi->start of TERSEDATA, esi->current object...
			  .IF pcurrent != 0
				mov esi,pcurrent
				add esi,(TERSEDATA PTR [edi]).nsizeobject ;next record.
				  ;as we are part-way into the database, have to reduce the count...
				  mov eax,esi
				  sub eax,pobjs
				  mov ebx,(TERSEDATA PTR [edi]).nsizeobject
				  xor edx,edx
				  div ebx ;gives eax=number of records before esi.
					.IF eax>=ecx ;have gone over end of database.
					  jmp xj03
					.ENDIF
				  sub ecx,eax ;# records still to be searched!
			  .ENDIF
xnextobj:
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				.IF al==01	  ;bit0=1, valid object.
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF eax==0FFFFE000h ;category data element.
					mov eax,esi
					jmp xf1 ;found.
				  .ENDIF
				.ENDIF
				mov ecx,ecxsave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
				loop  xnextobj
xj03:		  xor eax,eax ;no categories found.
xf1:
	ret
findnextcategory ENDP
;------------------------------------------------------------------------
deleteallcategorypopups PROC STDCALL USES ebx ecx edx esi edi
	LOCAL helementsmenu:DWORD
; "deleteallcategories"
;call from addcomposites2menu(), to wipe out all popup submenus attached to
;elements menu.  note, does not delete the actual category-dataelements.

  ;mov g_errorapi,0B3Ah ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		invoke GetMenu,g_hwnd
		invoke GetSubMenu,eax,1 ;elements menu.
		mov helementsmenu,eax

		  xor esi,esi
x01:	  invoke findnextcategory,esi ;look from current position in database.

			;delete current category data element...
			.IF eax != 0
			  mov esi,eax
			  ;.ximage may have handle of a popup submenu...
			  mov eax,(OBJECT PTR [esi]).ximage
			  .IF eax != 0
				;invoke DestroyMenu,eax
				;...not so good, deletes the entire window menu structure.
				  ;;i don't know if this will work... try to remove item...
				  ;invoke DeleteMenu,helementsmenu,eax,MF_BYCOMMAND
				  ;.IF eax==0 ;fail
				  ;  invoke myerrorhandler,999
				  ;.ENDIF
				  ;...no, i don't think it is necessary to delete the popup menu,
				  ;as it is appended to the Elements menu which is owned by the window,
				  ;so should be deleted by Windows when the Elements menu is destroyed.
				mov (OBJECT PTR [esi]).ximage,0
			  .ENDIF
			  jmp x01
			.ENDIF

x00:
	mov rpcategory,0
	ret
deleteallcategorypopups ENDP
;------------------------------------------------------------------------
attachallcategorypopups PROC STDCALL USES ebx ecx edx esi edi,helementsmenu:DWORD
	LOCAL hpopup:DWORD
; "attachallcategories"
;call from addcomposites2menu(), to create and attach all popup submenus attached to
;elements menu.

		  xor esi,esi
x01:	  invoke findnextcategory,esi ;look from current position in database.

			;delete current category data element...
			.IF eax != 0
				.IF esi==0 ;first loop thru here.
				  push eax
  ;mov g_errorapi,0B3Bh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				  invoke AppendMenuA,helementsmenu,MF_SEPARATOR,0,0
				  pop eax
				.ENDIF
			  mov esi,eax
			  ;.ximage has to have handle of a popup submenu...
			  mov eax,(OBJECT PTR [esi]).ximage
			  .IF eax == 0 ;precaution (deleteallcategorypopups() should have clrd it).
  ;mov g_errorapi,0B3Ch ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				invoke CreatePopupMenu
				mov hpopup,eax
				mov (OBJECT PTR [esi]).ximage,eax ;handle of popup menu.
				.IF eax != 0 ;precaution.
				  lea ebx,(OBJECT PTR [esi]).sztext
				  invoke AppendMenuA,helementsmenu,MF_POPUP+MF_STRING,eax,ebx
				.ENDIF
			  .ENDIF
			  jmp x01
			.ENDIF

x00:
	mov rpcategory,0
	ret

attachallcategorypopups ENDP
;------------------------------------------------------------------------
nliblimits PROC STDCALL USES ebx ecx edx esi edi,hdlg:DWORD
	LOCAL dummy:DWORD
; "nliblimits"
;enter with eax=library#, truncates to within limits, exit with eax.
;called from toolboxproc().

				  mov ebx,pTERSEDATA
				  mov ecx,(TERSEDATA PTR [ebx]).numlibrary
				  .IF SDWORD PTR eax>ecx
					mov eax,ecx
v09:				push eax
					invoke bin2dec,10
					invoke SendDlgItemMessage,hdlg,240,WM_SETTEXT,0,eax
					pop eax
				  .ELSEIF SDWORD PTR eax<1
					mov eax,1
					jmp v09
				  .ENDIF

	ret
nliblimits ENDP
;------------------------------------------------------------------------
addcomposites2menu PROC STDCALL USES ebx ecx edx esi edi,fdelete:DWORD
				LOCAL hmenu:DWORD,helementsmenu:DWORD,hmenu0:DWORD
				LOCAL ecxsave:DWORD,edisave:DWORD,esisave:DWORD
				LOCAL ncnt:DWORD,nentry:DWORD
				LOCAL menuitemid:DWORD ;,htempfile:DWORD ;v3.45
				LOCAL gppicturecheckmark:DWORD,hbitmap:DWORD,pstm:DWORD ;v3.46
				LOCAL pmem:DWORD,hglobal:DWORD ;v3.46
; "addcomposites2menu"
;scans database, finds all composite-object library members, writes
;their descriptions to the Elements menu.
;if fdelete=1, delete entire library.
;also adds checkmark bitmaps if loaded. v3.45

;this func completely rebuilds the menu. called from many places, including
;opendatafile(). however, if new diagram is read-only, need to disable the
;elements menu...
  mov ebx,pTERSEDATA
  mov eax,(TERSEDATA PTR [ebx]).fviewprefs
  and al,10000b ;bit4=1 overall disable editing flag.
  .IF al != 0
    invoke disableelementsmenu
    jmp out1
  .ENDIF

;as this is a complete scan thru the database, first need to delete
;any existing descriptions appended to the Elements menu...
				;v1.31
				;delete all the category popup submenus (if any)...
				invoke deleteallcategorypopups
	;...no, can't delete the popups as they're appended to Elements menu, and will
	;get destroyed when Elements menu is destroyed (in addcomposites2menu()).
	;but this routine does clr all category-dataelement.ximage (handle of popup menu).

  ;mov g_errorapi,0B3Dh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				invoke GetMenu,g_hwnd
				mov hmenu0,eax
				invoke LoadMenuA,g_hinst,ADDR szeve ;original menu.
				mov hmenu,eax
				invoke SetMenu,g_hwnd,eax
				invoke DestroyMenu,hmenu0

				invoke GetSubMenu,hmenu,1 ;Elements menu
				mov helementsmenu,eax
				
				;v3.44
				;attach "checkmark" bitmaps to menu items...
        ;wmcreate loaded bitmaps from resources, by LoadBitmap(). (note destroyed in wmdestroy())
        invoke loadcheckmarks,helementsmenu
        ;...these are my own checkmarks. custom-shape checkmarks are loaded below.
        

				;v1.31
				;create and attach popup categories to elements menu...
			  .IF fdelete==0
				  invoke attachallcategorypopups,helementsmenu
			  .ENDIF

;;open a temp file for loading of the bmp checkmarks...  v3.45
;	      invoke CreateFile,ADDR sztempbmp,GENERIC_READ OR GENERIC_WRITE, \
;					        FILE_SHARE_READ OR FILE_SHARE_WRITE,0,CREATE_ALWAYS, \
;					        FILE_ATTRIBUTE_NORMAL,0
;	      mov htempfile,eax

;now scan thru database...
				mov edi,pTERSEDATA
				mov ncnt,0
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				mov nentry,0
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF eax==0FFFFC000h ;dataelement attached to library obj.
						  .IF fdelete==0
								inc ncnt
								mov eax,ncnt
								mov (OBJECT PTR [esi]).xdata,eax ;library#.
								;append description to menu...
								lea eax,(OBJECT PTR [esi]).sztext
								mov ecx,(OBJECT PTR [esi]).rpowner1		 ;use as identifier.
								  ;no, menu identifiers are limited to 16-bit.
								  ;use element#+4000 as identifier...
								  add ecx,pTERSEDATA
								  mov ebx,ecx
								  mov ecx,(OBJECT PTR [ebx]).number ;use as menu identifier.
								  add ecx,4000
								  mov menuitemid,ecx ;v3.45

									;v1.31
									;now have popup categories in elements menu...
									pushad
									mov ebx,(OBJECT PTR [esi]).rpdata
									.IF ebx != 0 ;pts to category-dataelement.
									  ;add ebx,pTERSEDATA

										;there seems to be a possibility that the category
										;-dataelement got deleted and the database got
										;compacted, so this ptr may be beyond end of
										;database...
										;pushad
										;mov edi,pTERSEDATA																;start of mem block.
										;mov esi,(TERSEDATA PTR [edi]).noffsetobjs
										;add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
										;mov eax,(TERSEDATA PTR [edi]).nsizeobject
										;mov ecx,(TERSEDATA PTR [edi]).numrecords
										;mul ecx 	;eax=size of OBJECTS database.
										;add esi,eax ;esi=address beyond end of database.
										;.IF ebx>=esi ;beyond end database
										;  popad
										;  jmp xx1
										;.ENDIF
										;popad
										invoke ispointerok,ebx ;v3.46
										.IF eax==0 ;fail
										  jmp xx1
										.ENDIF
										add ebx,pTERSEDATA

									  mov eax,(OBJECT PTR [ebx]).fstatus
									  and al,01
									  .IF al==01 ;valid element.
										mov eax,(OBJECT PTR [ebx]).nexttype
										.IF eax==0FFFFE000h ;category dataelement.
										  mov eax,(OBJECT PTR [ebx]).ximage ;handle of popup.
										  .IF eax==0 ;precaution.
											  jmp SHORT xx1
										  .ELSE
											  lea edx,(OBJECT PTR [esi]).sztext
											  ;menuitemid=ecx=menu identifier.
											  invoke AppendMenuA,eax,MF_STRING,menuitemid,edx
											  ;...ah, but in this case, what about the checkmark bitmap?...
											  ;instead of jumping to kf1, jump to chk1...
											  popad
											  jmp chk1 ;kf1 v3.46
										  .ENDIF
										.ELSE
										  ;invalid ptr...
xx1:								  mov (OBJECT PTR [esi]).rpdata,0
										.ENDIF
									  .ELSE
										jmp xx1
									  .ENDIF
									.ENDIF
									popad

								inc nentry ;# entries appended to Elements menu.
								.IF nentry==1
								  mov edx,MF_STRING+MF_MENUBARBREAK
								.ELSEIF nentry==31 ;32
								  mov edx,MF_STRING+MF_MENUBARBREAK
								.ELSEIF nentry==61
								  mov edx,MF_STRING+MF_MENUBARBREAK
								.ELSE
								  mov edx,MF_STRING
								.ENDIF
								;eax->menu description, menuitemid=ecx=menu item identifier...
								invoke AppendMenuA,helementsmenu,edx,menuitemid,eax ;v3.45
								
chk1:						  ;now insert a checkmark bitmap, if any... v3.45
								  mov eax,(OBJECT PTR [esi]).fstatus
								  and ax,800h ;bit11=1 if there is a checkmark bitmap.
								  .IF ax != 0
								    mov eax,(OBJECT PTR [esi]).ximage ;holds gppicturecheckmark.
								    .IF eax==0 ;bmp not loaded.
								      ;we have bmp file in library-data-element.sztext+42 ;128.
		                  mov gppicturecheckmark,0
                      ;need to convert the mem-block into a "stream"...
							        mov eax,(OBJECT PTR [esi]).nshape ;size of file.
		                  invoke GlobalAlloc,GMEM_FIXED,eax
		                  .IF eax != 0 ;ok
		                    mov edi,eax ;address of mem block.
		                    mov pmem,eax
								        lea ebx,(OBJECT PTR [esi]).sztext
								        add ebx,MENUDESCRIPTIONSIZE ;42 v3.47 128 ;address of file in memory.
							          mov ecx,(OBJECT PTR [esi]).nshape ;size of file.
cpy1:                   mov al,[ebx]
		                    mov [edi],al
		                    inc ebx
		                    inc edi
		                    loop cpy1
		                    invoke GlobalHandle,pmem
		                    mov hglobal,eax
		                    invoke CreateStreamOnHGlobal,hglobal,TRUE,ADDR pstm
		                    ;...returns pstm =ptr to stream.
		                    .IF eax != 0  ;eax=0 ok.
		                      xor eax,eax
                        .ELSE
								          mov ecx,(OBJECT PTR [esi]).nshape ;size of file.
		                      invoke OleLoadPicture,pstm,ecx,0,ADDR IID_IPicture,ADDR gppicturecheckmark
		                      ;..."IID_IPicture" is the type of interface pointer to return
		                      ;...The requested interface pointer is returned in "gpPicturecheckmark".
		                      ;returns eax=0 if ok
                          ;note, need to release the iPicture in deletebitmaphandles() etc.
		                      .IF eax != 0  ;S_OK=0
		                        xor eax,eax
		                      .ELSE
                            mov eax,gppicturecheckmark
                          .ENDIF
                          push eax
		                      mov eax,pstm ;pstm->Release(); release the stream.
		                      push eax ;/
		                      mov edx,[eax]  ;/
		                      call dword ptr [edx+8]		 ;/
		                      pop eax
                        .ENDIF
                        push eax
                        invoke GlobalFree,hglobal ;destroy temp mem block.
                        pop eax
                      .ENDIF
								      mov (OBJECT PTR [esi]).ximage,eax ;gppicturecheckmark.
								    .ENDIF
								    .IF eax != 0
		                  ;now get a GDI handle for the bitmap...
		                  mov edx,eax ;gppicturecheckmark
		                  lea eax,hbitmap ;gpPicture->get_Handle(&hbitmap)
		                  push eax			 ;/
		                  push edx											 ;/
		                  mov ecx,[edx]			 ;/
		                  call dword ptr [ecx+GPget_Handle]			 ;/
                      mov eax,hbitmap ;returns hbitmap=0 if failed.								
								      ;now load the checkmark to the menuitem...
								      .IF eax != 0
				                invoke SetMenuItemBitmaps,helementsmenu,menuitemid,MF_BYCOMMAND,eax,eax
				              .ENDIF
				            .ENDIF
								  .ENDIF
								  
						  .ELSE
						      ;library data element may have a checkmark bitmap handle, need to delete...
						      mov eax,(OBJECT PTR [esi]).ximage  ;bitmap handle. v3.45
						      .IF eax != 0
								    mov   edx,eax	   ;gppicturecheckmark->Release();
								    push  edx						   ;/  "this" has to be passed, which is a ptr
								    mov   ecx,dword ptr [edx]		  ;/  to the interface.
								    call  dword ptr [ecx+8] 		  ;/
						        mov (OBJECT PTR [esi]).ximage,0
						      .ENDIF
								;delete entire composite-object...								
								mov ebx,(OBJECT PTR [esi]).rpowner1
								add ebx,pTERSEDATA
								mov highlightedindex,0 ;empty list.
								invoke add2highlightedlist,ebx
								;...also gets all elements locked together.
;								 invoke addlocked2highlighted,ebx ;get all elements locked to obj.
								invoke deleteelements ;delete highlighted elements
								;mov highlightedindex,0 ;precaution.
						  .ENDIF
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4:
;    invoke CloseHandle,htempfile ;close temp bmp file. v3.45
;    invoke DeleteFile,ADDR sztempbmp

		invoke DrawMenuBar,g_hwnd ;updates the menu.
		mov ebx,pTERSEDATA
		mov eax,ncnt
		mov (TERSEDATA PTR [ebx]).numlibrary,eax

out1:
		ret
addcomposites2menu ENDP
;--------------------------------------------------------------------------
controlmenuids DWORD IDM_RECT,IDM_SELALL,IDM_DUP,IDM_MOVE,IDM_RESIZESEL,IDM_STRETCHSEL
               DWORD IDM_FLIPH,IDM_FLIPV,IDM_ROT90,IDM_DELS,IDM_ERASEDIA,IDM_INTEGRITY
               DWORD IDM_TOOLBOX
filemenuids    DWORD IDM_TEMPLATE,IDM_MERGE,IDM_BITMAP,IDM_SAVEASS,IDM_EMBEDDED
               DWORD IDM_SAVEASS_EMF

disableelementsmenu PROC STDCALL USES ebx ecx edx esi edi
  LOCAL hmenu:DWORD,hcontrolmenu:DWORD,hfilemenu:DWORD ;,mymenuiteminfo:MENUITEMINFO
; "disableelementsmenu"
;called from prefsproc() and opendatafile().
;removes the Elements menu.

  invoke deleteallcategorypopups
  invoke GetMenu,g_hwnd
  mov hmenu,eax
  ;DeleteMenu,eax,1,MF_BYPOSITION ;1=Elements popup menu.
  ;...totally deleting the popup menu is a problem, as my recall this func, which
  ;will then delete the Control menu! So, use RemoveMenu()...
  ;RemoveMenu,eax,1,MF_BYPOSITION ;1=Elements popup menu.
  ;no, i don't think this will work either, because won't destroy the popup menu but
  ;does remove it from the menubar. use...
    ;invoke GetMenuItemInfoA,hmenu,1,TRUE,ADDR mymenuiteminfo
    ;mov mymenuiteminfo.fState,MFS_GRAYED
    ;invoke SetMenuItemInfoA,hmenu,1,TRUE,ADDR mymenuiteminfo
    ;no, try this...
    invoke EnableMenuItem,hmenu,1,MF_BYPOSITION OR MF_GRAYED
  ;disable items in Control menu...
  invoke GetSubMenu,hmenu,2 ;1=Elements menu, 2=Control menu.
  mov hcontrolmenu,eax
  invoke EnableMenuItem,hcontrolmenu,0,MF_BYPOSITION OR MF_GRAYED ;Bind interface.
  mov ecx,13
  lea esi,controlmenuids
nxt1: mov edi,ecx
  mov eax,[esi]
  invoke EnableMenuItem,hcontrolmenu,eax,MF_BYCOMMAND OR MF_GRAYED ;Bind interface.
  add esi,4
  mov ecx,edi
  loop nxt1
  
  ;disable items in File menu...
  invoke GetSubMenu,hmenu,0 ;0=File menu, 1=Elements menu, 2=Control menu.
  mov hfilemenu,eax
  mov ecx,6
  lea esi,filemenuids
nxt2: mov edi,ecx
  mov eax,[esi]
  invoke EnableMenuItem,hfilemenu,eax,MF_BYCOMMAND OR MF_GRAYED ;Bind interface.
  add esi,4
  mov ecx,edi
  loop nxt2

  invoke DrawMenuBar,g_hwnd
  ret
disableelementsmenu ENDP
;--------------------------------------------------------------------------
findcomposite PROC STDCALL USES ebx ecx edx esi edi,nlib:DWORD,fdel:DWORD
				LOCAL ecxsave:DWORD,edisave:DWORD,esisave:DWORD
; "findcomposite"
;scans database, finds composite-object library member.
;ret eax->dataelement attached to library obj, else =0 not found.
;if fdel=1, composite-obj library member is deleted, ret eax->
;deleted dataelement, eax=0 if not deleted.

;v3.05 a bug if fdel=1, anything already in highlighted list also gets deleted.
;so, empty it first...
  .IF fdel != 0
    mov highlightedindex,0
  .ENDIF

;scan thru database...
				mov edi,pTERSEDATA
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF eax==0FFFFC000h ;dataelement attached to library obj.
						  mov eax,(OBJECT PTR [esi]).xdata
						  .IF eax==nlib
								;found...
								.IF fdel==1
								  mov eax,(OBJECT PTR [esi]).rpowner1
								  .IF eax==0  ;error.
								  .ELSE
										add eax,pTERSEDATA
										mov ebx,eax
										invoke add2highlightedlist,eax
;										 invoke addlocked2highlighted,ebx
										;deletes elements in highlightedlist...
										invoke deleteelements
										;..also deletes all elments locked to the one
									  ;in highlighted list, including the dataelement (esi).
									  ;note, doesn't delete library-data-element, as it is attached to
									  ;boss element via boss.rpdata2, whereas deleteelments() only
									  ;looks at .rpdata. so have done it after return fron this func
									  ;in case of call from toolboxproc(). v3.45
								  .ENDIF
								.ENDIF
								jmp fnd1
						  .ENDIF
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4:
		xor esi,esi ;not found. return eax=0.
fnd1:
		mov eax,esi
		ret
findcomposite ENDP
;--------------------------------------------------------------------------
on_node PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		LOCAL ysqd:DWORD, xsqd:DWORD
		LOCAL hypot:DWORD, radius:DWORD
		LOCAL xcentre:SDWORD,ycentre:SDWORD
		LOCAL xtmp:SDWORD,ytmp:SDWORD,z:DWORD
		LOCAL xr1:DWORD,yr1:DWORD,tmpvar:DWORD,tmpvar2:DWORD,ring:DWORD
		LOCAL nsmallerzone:DWORD
		LOCAL zoom:SBYTE,pobj0:DWORD
; "on_node" *EVE*
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

;return g_nring = which ring mousex/y is on. else =0.
;return g_nknee =1 mouse on right handle, =2 left handle, =0 no handle
; (=0 used by drag_node() to drag entire element)

		mov esi,pobj
		mov pobj0,esi
				mov nsmallerzone,2 ;for initial highlighting of ellipse.
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				;xor eax,eax
				;mov al,8 ;10
				.IF SBYTE PTR cl<0
				;  neg cl
				;  shr al,cl
				;  .IF al==0
				;		mov al,1
				;  .ENDIF
				  mov nsmallerzone,1 ;for initial highlighting of ellipse.
				.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.

		mov eax,(OBJECT PTR [esi]).xmid
		mov xcentre,eax
		mov eax,(OBJECT PTR [esi]).ymid
		mov ycentre,eax

;newonnode:
		mov eax,(OBJECT PTR [esi]).wwidth
		shr eax,1				;want x radius.
		mov xr1,eax
		mov eax,(OBJECT PTR [esi]).height
		shr eax,1
		mov yr1,eax

		mov ring,1		;start from innermost ring.

		mov ecx,(OBJECT PTR [esi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax ;prevents jump when drag node.
		mov ecx,(OBJECT PTR [esi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax ;prevents jump when drag node.


jju:	;new loop-back, for rings with different centres 101200
		;xtmp=(xcentre+(xdeltacentre*(ring-1))...
		mov eax,(OBJECT PTR [esi]).xdeltacentre ;offset from previous ring.
		mov ecx,ring
		dec ecx
		imul ecx
		add eax,xcentre
		mov ecx,nmousex
		sub ecx,eax
		mov xtmp,ecx
		;ytmp=(ycentre+(ydeltacentre*(ring-1))...
		mov eax,(OBJECT PTR [esi]).ydeltacentre ;offset from previous ring.
		mov ecx,ring
		dec ecx
		imul ecx
		add eax,ycentre
		mov ecx,nmousey
		sub ecx,eax
		mov ytmp,ecx

		mov eax,ring			;z=(ring-1)*NRINGWIDTH
		dec eax
		xor edx,edx
		mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
		mul ecx
		add eax,nsmallerzone ;(NEXTRAWIDTH/4) ;z=((ring-1)*NRINGWIDTH)+(NEXTRAWIDTH/4)
		;...to detect slightly off node as being on the node, needed
		;when dragging a wire-end. ...well, when have selected a wire,
		;then press mouse-button at wire-end, mousex/y must be on-node.
		;NEXTRAWIDTH=8, so our capture zone here is 8/4 =2.
		mov z,eax


			;v1.84 see if selectable only on boundary...
			mov ecx,(OBJECT PTR [esi]).fconfig1
			and cl,010b ;bit1.
			.IF cl==010b
			  .IF ring==1
				;grabbed code from below, but subtract z....
				xor edx,edx 		  ;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
				mov eax,xtmp
				imul xtmp
				mov ebx,100
				imul ebx
				mov tmpvar,eax
				xor edx,edx
				mov eax,xr1
				sub eax,z ;add eax,z
				  sub eax,z ;need to select a bit more inside ring.
				mov ebx,eax
				mul ebx
				mov ebx,eax
				;xor edx,edx ;v1.37 be careful, as signed-devision follows.(ok, as +ve in eax)
				mov eax,tmpvar
				cdq ;sign-extend eax to edx:eax .v2.25.
				idiv ebx
				mov tmpvar,eax
				xor edx,edx
				mov eax,ytmp
				imul ytmp
				mov ebx,100
				imul ebx
				mov tmpvar2,eax
				xor edx,edx
				mov eax,yr1
				sub eax,z ;add eax,z
				  sub eax,z
				mov ebx,eax
				mul ebx
				mov ebx,eax
				;xor edx,edx ;v1.37 ditto above note.
				mov eax,tmpvar2
				cdq ;sign-extend eax into edx.
				idiv ebx
				mov tmpvar2,eax
				mov eax,tmpvar
				add eax,tmpvar2
				;...zz
				  .IF eax<100 ;too far inside ring1.
				      ;v3.03
				      ;if already selected, disregard .fconfig1/bit1...
				      .IF esi==g_pselectedobject
				        mov g_nring,1
				        jmp yes8 ;yes, drag me!
				      .ENDIF
					  jmp fai1
				  .ENDIF
			  .ENDIF
			.ENDIF

		  xor edx,edx			;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
		  mov eax,xtmp
		  imul xtmp
		  mov ebx,100
		  imul ebx
		  mov tmpvar,eax
		  xor edx,edx
		  mov eax,xr1
		  add eax,z
		  mov ebx,eax
		  mul ebx
		  mov ebx,eax
		  ;xor edx,edx ;v1.37 be careful, as signed-devision follows.(ok, as +ve in eax)
		  mov eax,tmpvar
		  cdq ;sign-extend eax into edx. v2.25.
		  idiv ebx
		  mov tmpvar,eax
				xor edx,edx
				mov eax,ytmp
				imul ytmp
				mov ebx,100
				imul ebx
				mov tmpvar2,eax
				xor edx,edx
				mov eax,yr1
				add eax,z
				mov ebx,eax
				mul ebx
				mov ebx,eax
				;xor edx,edx ;v1.37 ditto above note.
				mov eax,tmpvar2
				cdq ;sign-extend eax into edx. v2.25.
				idiv ebx
				mov tmpvar2,eax
		  mov eax,tmpvar
		  add eax,tmpvar2
		  ;...zz

		.IF eax>100
		  ;xor eax,eax
		  mov eax,(OBJECT PTR [esi]).nrings
		  .IF eax==ring
				;mov eax,0		   ;mousex/mousey outside of node.
fai1:			mov pobj,0
				mov g_nring,0
		  .ELSE
				inc ring				  ;try next-outer ring.
				jmp jju
		  .ENDIF
		.ELSE
		  mov eax,ring
		  mov g_nring,eax		;which ring mousex/y is on.
		  mov eax,pobj	;success, mousex/y is on node.
		.ENDIF

;now test if mouse on a handle...
  mov eax,g_pselectedobject
  .IF eax==esi ;is this object already highlighted?
		;yes, then can use g_nknee for dragging a corner.
				mov eax,(OBJECT PTR [esi]).xtopleft
				add eax,(OBJECT PTR [esi]).wwidth
				mov ebx,(OBJECT PTR [esi]).ymid
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on a knee (handle)...right
				  mov g_nknee,1
				  jmp o11
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae tst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst2:	cmp ebx,edx
;				jae tst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst4:	;yes, it's on a knee (handle)...right
;				mov g_nknee,1
;				jmp o11

	      mov eax,(OBJECT PTR [esi]).xmid
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add ebx,(OBJECT PTR [esi]).height
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on a knee (handle)...bottom
				  mov g_nknee,2
				  jmp o11
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae xtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst2:	cmp ebx,edx
;				jae xtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst4:	;yes, it's on a knee (handle)...bottom
;				mov g_nknee,2
;				jmp o11

;try3b:

    ;v2.96
    ;partial ellipse has 2 extra handles...
    mov eax,(OBJECT PTR [esi]).rxstartarc
    add eax,(OBJECT PTR [esi]).xtopleft
		mov ebx,(OBJECT PTR [esi]).rystartarc
		add ebx,(OBJECT PTR [esi]).ytopleft
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on a knee (handle)...start arc.
				  mov g_nknee,4
				  jmp o11
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae otst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe otst2
;				jmp SHORT ory3b
;otst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe otst2
;				jmp SHORT ory3b
;otst2:	cmp ebx,edx
;				jae otst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe otst4
;				jmp SHORT ory3b
;otst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe otst4
;				jmp SHORT ory3b
;otst4:	;yes, it's on a knee (handle)...start arc.
;				mov g_nknee,4
;				jmp o11
;ory3b:

    mov eax,(OBJECT PTR [esi]).rxendarc
    add eax,(OBJECT PTR [esi]).xtopleft
		mov ebx,(OBJECT PTR [esi]).ryendarc
		add ebx,(OBJECT PTR [esi]).ytopleft
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on a knee (handle)...end arc.
				  mov g_nknee,5
				  jmp o11
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae ptst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe ptst2
;				jmp SHORT pry3b
;ptst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe ptst2
;				jmp SHORT pry3b
;ptst2:	cmp ebx,edx
;				jae ptst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe ptst4
;				jmp SHORT pry3b
;ptst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe ptst4
;				jmp SHORT pry3b
;ptst4:	;yes, it's on a knee (handle)...end arc.
;				mov g_nknee,5
;				jmp o11
;pry3b:
;

		;v1.44
		;i want another handle for moving the rectangle entirely, not resizing...
		;top/left corner to be handle location...
		  ;v1.47
		  ;no, i want the "handle" to be entire node area...
		  .IF g_nring==1 ;computed above, =1 if in node.
yes8:		mov g_nknee,3
			  jmp o11
		  .ENDIF

	  mov g_nknee,0 ;fail.

  .ELSE
		mov g_nknee,0 ;future drag will move entire object(see drag_poly)
  .ENDIF

  mov eax,pobj	 ;=0 if fail.
out2:
  ret
o11: ;on a handle.
  mov eax,pobj0
  mov g_nring,1 ;???need this???
  jmp out2

on_node ENDP
;--------------------------------------------------------------------------
on_any PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		LOCAL ysqd:DWORD, xsqd:DWORD
		LOCAL hypot:DWORD, radius:DWORD,nsmallerzone:DWORD
; "on_any" *EVE*
;derived from on_node().
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

;*NOTE* elements using this method cannot be resized -- no handles
; -- returns g_nknee=0. (or =3)

		mov esi,pobj
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				xor eax,eax
				mov al,4
				.IF SBYTE PTR cl<0
				  neg cl
				  shr al,cl
				.ENDIF
				mov nsmallerzone,eax ;for initial highlighting of rectangle(allow zero).


		;y coords...
		mov ecx,(OBJECT PTR [esi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.

		;x coords...
		mov ecx,(OBJECT PTR [esi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.

;v1.84 see if selectable only on boundary...
			mov ecx,(OBJECT PTR [esi]).fconfig1
			and cl,010b ;bit1.
			.IF cl==010b
			  ;grab code from below, except subtract nsmallerzone...
			  ;now to calc if mouse inside resource rectangle...
			  mov eax,(OBJECT PTR [esi]).xtopleft
			  mov ecx,eax
			  add eax,nsmallerzone
			  .IF SDWORD PTR nmousex>=eax
				add ecx,(OBJECT PTR [esi]).wwidth
				sub ecx,nsmallerzone ;4 	   ;2 pixels outside right-side still in.
				.IF SDWORD PTR nmousex<=ecx
				  mov eax,(OBJECT PTR [esi]).ytopleft
				  mov ecx,eax
				  add eax,nsmallerzone
				  .IF SDWORD PTR nmousey>=eax
					add ecx,(OBJECT PTR [esi]).height
					sub ecx,nsmallerzone ;4 			  ;2 pixels outside bottom.
					.IF SDWORD PTR nmousey<=ecx
						;mouse is too far inside rectangle...
				      ;v3.03
				      ;if already selected, disregard .fconfig1/bit1...
				      .IF esi==g_pselectedobject
				        mov g_nring,1
				        mov eax,pobj
				        jmp yes8 ;yes, drag me!
				      .ENDIF
						xor eax,eax
						jmp fai1
					.ENDIF
				  .ENDIF
				.ENDIF
			  .ENDIF
			.ENDIF


;now to calc if mouse inside resource rectangle...
		mov eax,(OBJECT PTR [esi]).xtopleft
		mov ecx,eax
		sub eax,nsmallerzone
		;dec eax												 ;2 pixels outside left-side still in.
		;dec eax
		.IF SDWORD PTR nmousex>=eax
		  add ecx,(OBJECT PTR [esi]).wwidth
		  add ecx,nsmallerzone ;4						 ;2 pixels outside right-side still in.
		  .IF SDWORD PTR nmousex<=ecx
				mov eax,(OBJECT PTR [esi]).ytopleft
				mov ecx,eax
				sub eax,nsmallerzone
				;dec eax									;2 pixels outside top.
				;dec eax
				.IF SDWORD PTR nmousey>=eax
				  add ecx,(OBJECT PTR [esi]).height
				  add ecx,nsmallerzone ;4				 ;2 pixels outside bottom.
				  .IF SDWORD PTR nmousey<=ecx
						;yes!...
						mov eax,esi ;return with eax ptg to resource.
				  .ELSE
						;fail...
						xor eax,eax
				  .ENDIF
				.ELSE
				  ;fail...
				  xor eax,eax
				.ENDIF
		  .ELSE
				;fail...
				xor eax,eax
		  .ENDIF
		.ELSE
		  ;fail...
		  xor eax,eax
		.ENDIF
fai1:	mov pobj,eax
		;preserve eax, as it gets returned...

  mov g_nring,1 ;which ring mouse has clicked on.
  mov g_nknee,0

;now test if mouse on a handle...
  mov ebx,g_pselectedobject
  .IF ebx==esi ;is this object already highlighted?
	.IF pobj==0
	.ELSE
	  ;on the element, so want to drag entire element...
yes8:	
	  mov g_nknee,3
	.ENDIF
  .ENDIF

  ret
on_any ENDP
;--------------------------------------------------------------------------
on_cmt PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		LOCAL ysqd:DWORD, xsqd:DWORD
		LOCAL hypot:DWORD, radius:DWORD,plock:DWORD
		;LOCAL ncaptureradius:DWORD
		LOCAL zoom:SBYTE,fleftbox:BYTE
; "on_cmt" "on_label"
;used for label-element.
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).
;returns g_nknee=0 -- drag_ method cannot resize this element, as
;g_nknee=0 drags entire element, non-0 required for handle.

;v1.22 now have a resize handle. if on handle, return g_nknee=1..

		mov esi,pobj
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				;xor eax,eax
				;mov al,8 ;10
				;.IF SBYTE PTR cl<0
				;  neg cl
				;  shr al,cl
				;  .IF al==0
				;		mov al,1
				;  .ENDIF
				;.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.


;;compute formula hypotenuse=sqrt((nmousey-ymid)^2+((nmousex-xmid)^2)...
;		;y coords...
		mov ecx,(OBJECT PTR [esi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.
;		mov ebx,eax
;		imul ebx										;(nmousey-ymid)^2 -->eax
;		mov ysqd,eax							;/ save.
;		;x coords...
		mov ecx,(OBJECT PTR [esi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.
;		mov ebx,eax
;		imul ebx										;(nmousex-xmid)^2 -->eax
;		mov xsqd,eax							;/ save.
;		;node radius...
;		mov eax,(OBJECT PTR [esi]).wwidth
;		shr eax,1
;		mov radius,eax
;		;xor eax,eax
;		mov eax,(OBJECT PTR [esi]).nrings
;;		 dec al  <<< PROBLEM is that Comment/Action/Cond elements have
;;such tiny circles, (and only 1 ring) hard to select. but now i'm
;;making radius bigger...
;		mov ebx,ncaptureradius ;8
;		mul ebx
;		add radius,eax			;total radius to outer ring
;		;now add...
;		mov eax,ysqd
;		add eax,xsqd
;		mov hypot,eax
;		;now square-root...
;		fild hypot
;		fsqrt
;		fistp hypot 	;will always be +ve.


;  mov g_nknee,0
;v1.22 now have resize handle...
;now test if mouse on a handle...
  mov eax,g_pselectedobject
  .IF eax==esi ;is this object already highlighted?
		;yes, then can use g_nknee for dragging a corner.
		;nmousex/nmousey has mouse coord, ncaptureradius has capture radius.

		  ;need to know if text is left of the xmid/ymid...
		  ;if label on left-side of node, text on left...
		  mov eax,(OBJECT PTR [esi]).rpowner1
									  .IF eax==0
									  .ELSE
										add eax,pTERSEDATA
									  .ENDIF
		  mov plock,eax
		  .IF plock==0	  ;label not attached to anything (precaution).
			mov fleftbox,0
		  .ELSE
			mov edi,plock
			;edi-->parent, esi-->cond.
				mov eax,(OBJECT PTR [edi]).nringwidth ;normally 0 for totempoles.
				mov ecx,(OBJECT PTR [esi]).nbeginring  ;ring cond is attached to.
				dec ecx
				mul ecx
				mov edx,(OBJECT PTR [edi]).xtopleft
				sub edx,eax
				mov eax,edx
			mov ecx,(OBJECT PTR [esi]).xtopleft
			add ecx,(OBJECT PTR [esi]).wwidth
			.IF SDWORD PTR eax>ecx
				;label is to left of parent...
				mov fleftbox,1
			.ELSE
				mov fleftbox,0
			.ENDIF
		  .ENDIF
		;v1.48
		;can override text alignment...
		mov eax,(OBJECT PTR [esi]).fconfig4
		and ax,0700h ;bits10/9/8.
		.IF ax==0 ;automatic.
		  ;alignment as calc'd above.
		.ELSEIF ax==0100h ;left
		  mov fleftbox,0 ;text is actually left-aligned.
		.ELSE
		  mov fleftbox,1 ;text is right-aligned.
		.ENDIF

		  ;now need to locate position of resize handle...
		  mov eax,(OBJECT PTR [esi]).xmid
		  mov ebx,(OBJECT PTR [esi]).ymid
		  add eax,(OBJECT PTR [esi]).xlabeloffset
		  add eax,6
		  add eax,(OBJECT PTR [esi]).widthtext ;now has resize handle x.
		  add ebx,(OBJECT PTR [esi]).ylabeloffset
		  sub ebx,6 ;7
		  mov ecx,(OBJECT PTR [esi]).heighttext
		  shr ecx,1
		  add ebx,ecx ;now have resize handle y.
		  .IF fleftbox==0
		  .ELSE
			  sub eax,(OBJECT PTR [esi]).widthtext
			  sub eax,12
			  sub eax,(OBJECT PTR [esi]).widthtext
		  .ENDIF

;v2.61 remove...
;      ;v2.55 HTML label has resize handle located differently...
;      test (OBJECT PTR [esi]).fconfig4,0800h ;bit11=1 html label.
;        sub ebx,(OBJECT PTR [esi]).charheight
;      jz no1
;no1:
      
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx ;v3.31
				.IF eax != 0
	        ;yes, it's on a knee (handle)...
				  mov g_nknee,1
				  mov eax,pobj ;yes, on object.
				  jmp o19
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae tst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst2:	cmp ebx,edx
;				jae tst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst4:	;yes, it's on a knee (handle)...
;				mov g_nknee,1
;				mov eax,pobj ;yes, on object.
;				jmp o19
;try3:

		;v1.47
		;as element is highlighted, not on the handle, but elsewhere on the element,
		;want to be able to drag entire element...
		;we have the hypotenuse, the distance between mouse and centre of node...
;		mov eax,radius			;always +ve value.
;		.IF hypot<=eax
;		  mov g_nknee,3
;		  mov eax,pobj
;		  jmp o19
;		.ENDIF
    mov eax,(OBJECT PTR [esi]).xmid
    mov ebx,(OBJECT PTR [esi]).ymid
    mov ecx,nmousex
    mov edx,nmousey
    invoke onhandle,eax,ebx,ecx,edx  ;v3.31
    .IF eax != 0
		  mov g_nknee,3
		  mov eax,pobj
		  jmp o19
    .ENDIF


	  mov g_nknee,0 ;fail.
  .ELSE
		mov g_nknee,0 ;future drag will move entire object(see drag_poly)
  .ENDIF
o11:


;we have the hypotenuse, the distance between mouse and centre of node...
;		mov eax,radius			;always +ve value.
;		.IF hypot<=eax
;		  mov eax,pobj
;		.ELSE
;		  mov eax,0
;		.ENDIF
    mov eax,(OBJECT PTR [esi]).xmid
    mov ebx,(OBJECT PTR [esi]).ymid
    mov ecx,nmousex
    mov edx,nmousey
    invoke onhandle,eax,ebx,ecx,edx  ;v3.31
    .IF eax != 0
      mov eax,pobj ;mouse is on label handle.
    .ENDIF

o19:
  ret
on_cmt ENDP
;--------------------------------------------------------------------------
on_res PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		;LOCAL ncaptureradius:DWORD,
    LOCAL nsmallerzone:DWORD,pobj0:DWORD
		LOCAL zoom:SBYTE
; "on_res" *EVE*
;called from wmlbuttondown/state0 > onanobject() > via method-table
;returns eax=0 if fail, else eax pts to object
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

		mov esi,pobj
		mov pobj0,esi
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				xor eax,eax
				mov al,4 ;8 ;10
				.IF SBYTE PTR cl<0
				  neg cl
				  shr al,cl
				  .IF al==0
						mov al,1
				  .ENDIF
				.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.
				;shr eax,1
				mov nsmallerzone,eax ;for initial highlighting of rectangle(allow zero).


		;y coords...
		mov ecx,(OBJECT PTR [esi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.

		;x coords...
		mov ecx,(OBJECT PTR [esi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.


;v1.84 see if selectable only on boundary...
			mov ecx,(OBJECT PTR [esi]).fconfig1
			and cl,010b ;bit1.
			.IF cl==010b
			  ;grab code from below, except subtract nsmallerzone...
			  ;now to calc if mouse inside resource rectangle...
			  mov eax,(OBJECT PTR [esi]).xtopleft
			  mov ecx,eax
			  add eax,nsmallerzone
			  .IF SDWORD PTR nmousex>=eax
				add ecx,(OBJECT PTR [esi]).wwidth
				sub ecx,nsmallerzone ;4 	   ;2 pixels outside right-side still in.
				.IF SDWORD PTR nmousex<=ecx
				  mov eax,(OBJECT PTR [esi]).ytopleft
				  mov ecx,eax
				  add eax,nsmallerzone
				  .IF SDWORD PTR nmousey>=eax
					add ecx,(OBJECT PTR [esi]).height
					sub ecx,nsmallerzone ;4 			  ;2 pixels outside bottom.
					.IF SDWORD PTR nmousey<=ecx
						;mouse is too far inside rectangle...
						  ;v3.03
						  ;if already selected, don't care about .fconfib/bit1...
						  .IF esi==g_pselectedobject
						    mov g_nring,1
						    jmp yes8 ;yes, drag me!
						  .ENDIF
						xor eax,eax
						jmp fai1
					.ENDIF
				  .ENDIF
				.ENDIF
			  .ENDIF
			.ENDIF


;now to calc if mouse inside resource rectangle...
		mov eax,(OBJECT PTR [esi]).xtopleft
		mov ecx,eax
		sub eax,nsmallerzone
		.IF SDWORD PTR nmousex>=eax
		  add ecx,(OBJECT PTR [esi]).wwidth
		  add ecx,nsmallerzone ;4		 ;2 pixels outside right-side still in.
		  .IF SDWORD PTR nmousex<=ecx
				mov eax,(OBJECT PTR [esi]).ytopleft
				mov ecx,eax
				sub eax,nsmallerzone
				.IF SDWORD PTR nmousey>=eax
				  add ecx,(OBJECT PTR [esi]).height
				  add ecx,nsmallerzone ;4				;2 pixels outside bottom.
				  .IF SDWORD PTR nmousey<=ecx
						;yes!...
						mov eax,esi ;return with eax ptg to resource.
				  .ELSE
						;fail...
						xor eax,eax
				  .ENDIF
				.ELSE
				  ;fail...
				  xor eax,eax
				.ENDIF
		  .ELSE
				;fail...
				xor eax,eax
		  .ENDIF
		.ELSE
		  ;fail...
		  xor eax,eax
		.ENDIF
fai1:	mov pobj,eax

  mov g_nring,1 ;which ring mouse has clicked on.
								; *NOTE* need to include code for multiple rings,
								;like on_node().  *NO*

;now test if mouse on a handle...
  mov eax,g_pselectedobject
  .IF eax==esi ;is this object already highlighted?
		;yes, then can use g_nknee for dragging a corner.
				mov eax,(OBJECT PTR [esi]).xtopleft
				add eax,(OBJECT PTR [esi]).wwidth
				mov ebx,(OBJECT PTR [esi]).ymid
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
        invoke onhandle,eax,ebx,ecx,edx  ;v3.31
        .IF eax != 0
	        ;yes, it's on a knee (handle)...right
				  mov g_nknee,1
				  jmp o11
        .ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae tst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst2:	cmp ebx,edx
;				jae tst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst4:	;yes, it's on a knee (handle)...right
;				mov g_nknee,1
;				jmp o11

	      mov eax,(OBJECT PTR [esi]).xmid
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add ebx,(OBJECT PTR [esi]).height
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
        invoke onhandle,eax,ebx,ecx,edx  ;v3.31
        .IF eax != 0
	        ;yes, it's on a knee (handle)...bottom
				  mov g_nknee,2
				  jmp o11
        .ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae xtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst2:	cmp ebx,edx
;				jae xtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst4:	;yes, it's on a knee (handle)...bottom
;				mov g_nknee,2
;				jmp o11
;try3b:

		  ;v1.47
		  ;i want another handle for moving the rectangle entirely, not resizing...
		  ;no, i want the "handle" to be entire rect area...
		  .IF pobj==0 ;computed above, <>0 if in rect.
		  .ELSE
yes8:	  mov g_nknee,3 ;future drag highlighted obj, moves entire obj.
			  jmp o11
		  .ENDIF

		mov g_nknee,0 ;fail.
  .ELSE
		mov g_nknee,0 ;future drag will move entire object(see drag_poly)
  .ENDIF

  mov eax,pobj ;0=fail.
out2:
  ret
o11:
  mov eax,pobj0 ;on a handle.
  jmp out2

on_res ENDP
;--------------------------------------------------------------------------
on_axes PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		;LOCAL ncaptureradius:DWORD,
    LOCAL nsmallerzone:DWORD,pobj0:DWORD
		LOCAL zoom:SBYTE
; "on_axes" v1.97. alignment axes element.
;called from wmlbuttondown/state0 > onanobject() > via method-table
;returns eax=0 if fail, else eax pts to object
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

		mov esi,pobj
		mov pobj0,esi
				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				xor eax,eax
				mov al,4 ;8 ;10
				.IF SBYTE PTR cl<0
				  neg cl
				  shr al,cl
				  .IF al==0
						mov al,1
				  .ENDIF
				.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.
				;shr eax,1
				mov nsmallerzone,eax ;for initial highlighting of rectangle(allow zero).


		;y coords...
		mov ecx,(OBJECT PTR [esi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.

		;x coords...
		mov ecx,(OBJECT PTR [esi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.


;now to calc if mouse inside origin rectangle...(wwidth=6,height=6 always)...
		mov eax,(OBJECT PTR [esi]).xtopleft
		mov ecx,eax
		sub eax,nsmallerzone
		.IF SDWORD PTR nmousex>=eax
		  add ecx,(OBJECT PTR [esi]).wwidth
		  add ecx,nsmallerzone ;4		 ;2 pixels outside right-side still in.
		  .IF SDWORD PTR nmousex<=ecx
				mov eax,(OBJECT PTR [esi]).ytopleft
				mov ecx,eax
				sub eax,nsmallerzone
				.IF SDWORD PTR nmousey>=eax
				  add ecx,(OBJECT PTR [esi]).height
				  add ecx,nsmallerzone ;4				;2 pixels outside bottom.
				  .IF SDWORD PTR nmousey<=ecx
						;yes!...
						mov eax,esi ;return with eax ptg to resource.
				  .ELSE
						;fail...
						xor eax,eax
				  .ENDIF
				.ELSE
				  ;fail...
				  xor eax,eax
				.ENDIF
		  .ELSE
				;fail...
				xor eax,eax
		  .ENDIF
		.ELSE
		  ;fail...
		  xor eax,eax
		.ENDIF
fai1:	mov pobj,eax

  mov g_nring,1 ;which ring mouse has clicked on.
								; *NOTE* need to include code for multiple rings,
								;like on_node().  *NO*

;now test if mouse on a handle...
  mov eax,g_pselectedobject
  .IF eax==esi ;is this object already highlighted?
		;yes, then can use g_nknee for dragging a corner.
				mov eax,(OBJECT PTR [esi]).xtopleft
				add eax,102 ;(OBJECT PTR [esi]).wwidth
				mov ebx,(OBJECT PTR [esi]).ymid
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
        invoke onhandle,eax,ebx,ecx,edx  ;v3.31
        .IF eax != 0
	        ;yes, it's on a knee (handle)...right
				  mov g_nknee,1
				  jmp o11
        .ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae tst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe tst2
;				jmp SHORT try3
;tst2:	cmp ebx,edx
;				jae tst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe tst4
;				jmp SHORT try3
;tst4:	;yes, it's on a knee (handle)...right
;				mov g_nknee,1
;				jmp o11

	      mov eax,(OBJECT PTR [esi]).xmid
				mov ebx,(OBJECT PTR [esi]).ytopleft
				add ebx,102 ;(OBJECT PTR [esi]).height
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
        invoke onhandle,eax,ebx,ecx,edx  ;v3.31
        .IF eax != 0
	        ;yes, it's on a knee (handle)...bottom
				  mov g_nknee,2
				  jmp o11
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae xtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst2:	cmp ebx,edx
;				jae xtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst4:	;yes, it's on a knee (handle)...bottom
;				mov g_nknee,2
;				jmp o11
;try3b:

		  ;v1.47
		  ;i want another handle for moving the rectangle entirely, not resizing...
		  ;no, i want the "handle" to be entire rect area...
		  .IF pobj==0 ;computed above, <>0 if in rect.
		  .ELSE
			  mov g_nknee,3
			  jmp o11
		  .ENDIF

		mov g_nknee,0 ;fail.
  .ELSE
		mov g_nknee,0 ;future drag will move entire object(see drag_poly)
  .ENDIF

  mov eax,pobj ;0=fail.
out2:
  ret
o11:
  mov eax,pobj0 ;on a handle.
  jmp out2

on_axes ENDP
;--------------------------------------------------------------------------
on_poly PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		LOCAL xend:SDWORD,yend:SDWORD
		LOCAL ecxsave:DWORD,nhandle:DWORD
		;LOCAL ncaptureradius:DWORD
		LOCAL varray[84]:SDWORD
		LOCAL zoom:SBYTE
; "on_poly" *EVE*
;called from wmlbuttondown/state0 > onanobject() > via method-table
;returns eax=0 if fail, else eax pts to object
;entered pobj is object to test.
;returns eax=0 if fail, else eax pts to object.
;also sets g_xdiff & g_ydiff to difference between mouse & xmid/ymid
; -- used for dragging (see drag_node for example).

		mov esi,pobj

				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				;xor eax,eax
				;mov al,8 ;10
				;.IF SBYTE PTR cl<0
				;  neg cl
				;  shr al,cl
				;  .IF al==0
				;		mov al,1
				;  .ENDIF
				;.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.

;v2.23 <2.23, had a jump if poly is boss of a multi-element comp-obj, so i have changed
;wmlbuttondown() to calc g_xdiff/g_ydiff as mouse relative to xmid/ymid of poly. fixed.
;however, now must fix jump when drag a poly alone... x/ymid is bez4...
		;y coords...
		mov ecx,(OBJECT PTR [esi]).ymid ;2.23 bez0y ;drag_poly must use this also to
		mov eax,nmousey 								 ;prevent a jump when drag.
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.

		;x coords...
		mov ecx,(OBJECT PTR [esi]).xmid ;2.23 bez0x ;ditto.
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.

;now to calc if mouse inside polygon...
;.bez0 -- .bez8 are up to 9 corners, .ncorners=how many corners.

;		 mov eax,nmousex
;		 mov xend,eax
;		 mov eax,nmousey
;		 mov yend,eax
;		 invoke snap_topoly,pobj,ADDR xend,ADDR yend,0,0
;		 ;...this will return snapped xend/yend, but i don't need that here.
;		 ;...also returns eax=1 if on polygon (ring 1) =0 if not.
;		 .IF eax==0
;		   ;mov g_nring,0 ;????
;		   ;ret
;		 .ENDIF

;v2.05 more vertices...
			  lea edx,varray ;needed in... registers eax, esi used in...
			  ;func uses esi->poly, edx->varray...
			  invoke combinepolyarrays
			  mov ecx,(OBJECT PTR [esi]).ncorners
			  lea edi,varray

;need to know if mouse on a knee (handle)...
				mov nhandle,1
				mov g_nknee,0
;				 mov ecx,(OBJECT PTR [esi]).ncorners
;				 lea edi,(OBJECT PTR [esi]).bez0x
E22:	mov ecxsave,ecx
				mov eax,[edi]
				mov ebx,[edi+4]
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
        invoke onhandle,eax,ebx,ecx,edx  ;v3.31
        .IF eax != 0
	        ;yes, it's on a knee (handle)...
				  mov eax,nhandle
				  mov g_nknee,al ;handles are numbered from 1 up.
				  jmp yes1 ;tst6
        .ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae xtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe xtst2
;				jmp SHORT try3b
;xtst2:	cmp ebx,edx
;				jae xtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe xtst4
;				jmp SHORT try3b
;xtst4:	;yes, it's on a knee (handle)...
;				mov eax,nhandle
;				mov g_nknee,al ;handles are numbered from 1 up.
;				jmp yes1 ;tst6
				
	      ;failed...
				add edi,8
				inc nhandle
				mov ecx,ecxsave
				loop E22

no1: ;fail.
		
		;v3.03
		;find out if mouse ptr is anywhere inside the polygon, if yes then goto yes2:
		  ;i think if poly is selected (highlighted), want to always test if mouse
		  ;inside somewhere...
		  .IF esi==g_pselectedobject
		    ;on_res() and on_node() return g_nknee=3 if element highlighted and
		    ;mouse inside element (not on a handle), so here choose -1...
		    mov g_nknee,-1 ;(gets zeroised below if fail).
		    ;(...see wmlbuttondown() state2 for handling of this for dragging.
		    jmp SHORT yes9
		  .ENDIF
		mov eax,(OBJECT PTR [esi]).fconfig1
		and al,010b ;bit1.
		.IF al != 0 ;bit1=1 selectable anywhere inside polygon.
yes9: mov ecx,(OBJECT PTR [esi]).ncorners
		  lea edi,varray
  ;mov g_errorapi,0B3Eh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke CreatePolygonRgn,edi,ecx,WINDING
		  push eax
  ;mov g_errorapi,0B3Fh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke PtInRegion,eax,nmousex,nmousey ;ret eax=0 fail.
		  pop ecx
		  push eax
		  invoke DeleteObject,ecx
		  pop eax
		  .IF eax != 0
		    jmp SHORT yes2
		  .ENDIF
		.ENDIF

    mov g_nknee,0 ;fail.		
		mov g_nring,0  ;fail.
		xor eax,eax ;fail.
		ret

yes1:
  mov eax,g_pselectedobject
  .IF eax==esi ;is this object already highlighted?
		;yes, then can use g_nknee for dragging a corner.
  .ELSE
		mov g_nknee,0 ;future drag will move entire object(see drag_poly)
  .ENDIF
yes2:
  mov g_nring,1 ;which ring mouse has clicked on. ?????
								; *NOTE* need to include code for multiple rings,
								;like on_node().  *NO*
  mov eax,pobj
  ret
on_poly ENDP
;--------------------------------------------------------------------------
on_arc PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD,nmousex:DWORD,nmousey:DWORD
		;LOCAL ncaptureradius:DWORD
		LOCAL zoom:SBYTE
; "on_arc" "on_wire"
;called from wmlbuttondown/state0 > onanobject() > via method-table
;entered pobj is object to test.
;returns g_nknee =which handle, =0 no handle --
;g_nknee =0 used to drag entire object, non-0 drag a handle, by drag_arc().
;returns eax=0 if fail, else eax pts to object.

				mov edi,pobj
				mov g_nknee,0	;used to show which knee selected. 0=none.

				mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				;xor eax,eax
				;mov al,8 ;10
				;.IF SBYTE PTR cl<0
				;  neg cl
				;  shr al,cl
				;  .IF al==0
				;		mov al,1
				;  .ENDIF
				;.ENDIF
				;mov ncaptureradius,eax ;narrow capture zone when zoomed in.

;*EVE*... stops element jumping when drag...
		;y coords...
		mov ecx,(OBJECT PTR [edi]).ymid
		mov eax,nmousey
		sub eax,ecx 					;nmousey-ymid
		mov g_ydiff,eax 						;save.
		;x coords...
		mov ecx,(OBJECT PTR [edi]).xmid
		mov eax,nmousex
		sub eax,ecx 					;nmousex-xmid
		mov g_xdiff,eax 						;save.


;test if mouse on mid-point of wire...
				mov  eax,(OBJECT PTR [edi]).xmid
				mov  ebx,(OBJECT PTR [edi]).ymid
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on mid-point...
				  mov g_nknee,1
				  jmp tst6
				.ENDIF
								
;				cmp eax,ecx 	  ;test if on-top.
;				jae tst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10
;				jbe tst2
;				jmp SHORT try2
;tst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10
;				jbe tst2
;				jmp SHORT try2
;tst2:	cmp ebx,edx
;				jae tst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10
;				jbe tst4
;				jmp SHORT try2
;tst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10
;				jbe tst4
;				jmp SHORT try2
;tst4:	;yes, it's on mid-point...
;				mov g_nknee,1
;				jmp tst6

try2:
;only allowed to test if on knees2/3/4/5 if wire is highlighted.
;reason is, highlight at mid-point first, sets g_phighlighted,
;then paint_arc will display the knees, then this routine can
;allow them to be selected, and drag_arc will allow them to drag!
		.IF edi==g_pselectedobject
		.ELSE
		  ;fail, get out
		  mov g_nknee,0 ;precaution.
		  jmp znoobject
		.ENDIF

;now test if mouse on knee2...
				mov  eax,(OBJECT PTR [edi]).xknee2
				mov  ebx,(OBJECT PTR [edi]).yknee2
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on 1st half-point (knee2)...
				  mov g_nknee,2
				  jmp tst6
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae xtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10
;				jbe xtst2
;				jmp SHORT try3b
;xtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10
;				jbe xtst2
;				jmp SHORT try3b
;xtst2:	cmp ebx,edx
;				jae xtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10
;				jbe xtst4
;				jmp SHORT try3b
;xtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10
;				jbe xtst4
;				jmp SHORT try3b
;xtst4:	;yes, it's on 1st half-point (knee2)...
;				mov g_nknee,2
;				jmp tst6

;try3b:
;we can also test if mouse is on start of wire (knee4)...
;note, i've narrowed the area to select the wire-end, as if the
;node to which the wire is attached is a master of a clone-chain,
;drag_arc() calls snapclonewires() which finds matching wires on
;clones and drags them also -- their ends have to be +/-4 of the
;master-wires end. so, needto make this slightly smaller or = (otherwise
;mouse coord outside this area will drag master wire but miss
;child wire)...    *NO*, i think can compensate for this in drag_arc()
;-- detect mouse too far from wire-end, truncate difference. but, leave
;this initial capture area small anyway...
				mov  eax,(OBJECT PTR [edi]).xtopleft
				mov  ebx,(OBJECT PTR [edi]).ytopleft
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes...
				  mov g_nknee,4
				  jmp tst6
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae qtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;4 ;10  ;15
;				jbe qtst2
;				jmp SHORT try3c
;qtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;4 ;10  ;15
;				jbe qtst2
;				jmp SHORT try3c
;qtst2:	cmp ebx,edx
;				jae qtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;4 ;10  ;15
;				jbe qtst4
;				jmp SHORT try3c
;qtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;4 ;10  ;15
;				jbe qtst4
;				jmp SHORT try3c
;qtst4:	;yes...
;				mov g_nknee,4
;				jmp tst6

;try3c:
;we can also test if mouse is on destination-end of wire (knee5)...
				mov  eax,(OBJECT PTR [edi]).wwidth
				mov  ebx,(OBJECT PTR [edi]).height
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes...
				  mov g_nknee,5
				  jmp tst6
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae rtst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;4 ;10  ;15
;				jbe rtst2
;				jmp SHORT try3
;rtst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;4 ;10  ;15
;				jbe rtst2
;				jmp SHORT try3
;rtst2:	cmp ebx,edx
;				jae rtst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;4 ;10  ;15
;				jbe rtst4
;				jmp SHORT try3
;rtst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;4 ;10  ;15
;				jbe rtst4
;				jmp SHORT try3
;rtst4:	;yes...
;				mov g_nknee,5
;				jmp tst6

;now test if mouse on knee3...
	      mov  eax,(OBJECT PTR [edi]).xknee3
				mov  ebx,(OBJECT PTR [edi]).yknee3
				mov ecx,nmousex 								;mouse x-coord
				mov edx,nmousey 								;mouse y-coord
				invoke onhandle,eax,ebx,ecx,edx  ;v3.31
				.IF eax != 0
	        ;yes, it's on second half (knee3)...
				  mov g_nknee,3
				  jmp tst6
				.ENDIF
				
;				cmp eax,ecx 	  ;test if on-top.
;				jae ytst1
;				sub ecx,eax
;				cmp ecx,ncaptureradius ;10		;15
;				jbe ytst2
;				jmp SHORT znoobject
;ytst1:	sub eax,ecx
;				cmp eax,ncaptureradius ;10		;15
;				jbe ytst2
;				jmp SHORT znoobject
;ytst2:	cmp ebx,edx
;				jae ytst3
;				sub edx,ebx
;				cmp edx,ncaptureradius ;10		;15
;				jbe ytst4
;				jmp SHORT znoobject
;ytst3:	sub ebx,edx
;				cmp ebx,ncaptureradius ;10		;15
;				jbe ytst4
;				jmp SHORT znoobject
;ytst4:	;yes, it's on second half (knee3)...
;				mov g_nknee,3
;				jmp tst6


tst6:	;success!... mouse is on wire...
				mov eax,pobj									 ;flag success.
out1:		ret 									   ;success.
znoobject:
				mov eax,0										   ;flag failure.
				jmp out1 ;ret
on_arc ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
wipeslaves_node PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
		LOCAL dummy:WORD
;called from wmmousemove()/state2/pmovingobject
;pobj is the moving object. this routine is to detect all objects
;locked to pobj and add them to wipeout list...

  invoke wipeoutslaves, pobj

  ret
wipeslaves_node ENDP
;--------------------------------------------------------------------------
wipeslaves_gen PROC STDCALL USES ebx ecx edx esi edi,pobj:DWORD
		LOCAL dummy:WORD
;called from wmmousemove()/state2/pmovingobject
;pobj is the moving object. this routine is to detect all objects
;locked to pobj and add them to wipeout list...

  invoke wipeoutslaves, pobj

  ret
wipeslaves_gen ENDP
;--------------------------------------------------------------------------

snap_tonode PROC STDCALL USES ecx edx esi edi,pobj:DWORD, \
		pxend:DWORD,pyend:DWORD,xorient:DWORD,yorient:DWORD,ncurrentvertice:DWORD
		LOCAL xend:SDWORD, yend:SDWORD
		LOCAL mousex:SDWORD, mousey:SDWORD
		LOCAL xcentre:SDWORD, ycentre:SDWORD
		LOCAL ytmp:SDWORD, xtmp:SDWORD
		LOCAL deltaytmp:DWORD
		LOCAL hypot:DWORD, xradring1:DWORD
		LOCAL exactradius:DWORD
		LOCAL ring:DWORD
		LOCAL xr1:DWORD,yr1:DWORD,z:DWORD,zz:DWORD
		LOCAL tmpvar:SDWORD,tmpvar2:SDWORD
		LOCAL xcentre2:SDWORD,ycentre2:SDWORD,ferror:BYTE
; "snap_tonode"
;*EVE*
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pobj and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;note, snap_ methods are not to make the actual changes to coords
;in an OBJECT. the snapped xend/yend is calculated, and on return
;to paint_, it is paint_'s responsibility to update coords in OBJECT.

;a problem with action/condition elements, as they are node-type, not
;wire-type objects. i need to make them snap to a particular ring.
;wmlbuttondown()/state4 (placing new object) should set
;newobject.nbeginring, and paint_label() and paint_cond() can write it
;to global variable "g_nsnapring". if snap_tonode() sees this non-0,
;then calc xend/yend snapped to this ring.
;Note that comment objects will have a line drawn from the object to
;outermost boundary of node, which is ok, leave alone.

;NEW xorient/yorient. use to calc arrow orientation. if a wire attached
;to this object, these params are a coord further back on wire. *NEW*
;see snap_topoly() for example.

;ncurrentvertice currently only used in snap_popoly().
;return ebx=0. note, for snap_topoly() returns ebx=vertice snapped to (>0).

		mov esi,pxend
		mov eax,[esi]
		mov xend,eax
		mov esi,pyend
		mov eax,[esi]
		mov yend,eax

;NOTE got this code from goofee WHICH0...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
		mov eax,xend
		mov mousex,eax
		mov eax,yend
		mov mousey,eax

		mov esi,pobj			;node.
		mov eax,(OBJECT PTR [esi]).xmid
		mov xcentre,eax
		mov eax,(OBJECT PTR [esi]).ymid
		mov ycentre,eax

;newsnaptonode:
;new code for ellipses...
		mov ferror,0

		mov eax,(OBJECT PTR [esi]).wwidth
		shr eax,1				;want x radius.
		mov xr1,eax
		mov eax,(OBJECT PTR [esi]).height
		shr eax,1				;want y radius.
		mov yr1,eax

		  ;if g_nsnapring non-0, must snap to that ring...
		  .IF g_nsnapring==0
				mov eax,1		;start at ring1.
		  .ELSE
				mov ecx,g_nsnapring
				;precaution...
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).nrings
				.IF ecx>eax
				.ELSE
				  mov eax,ecx
				.ENDIF
		  .ENDIF
		mov ring,eax

jju:	;new loop-back, for rings with different centres 101200
		;xtmp=(xcentre+(xdeltacentre*(ring-1))...
		mov eax,(OBJECT PTR [esi]).xdeltacentre ;offset from previous ring.
		mov ecx,ring
		dec ecx
		imul ecx
		add eax,xcentre
		mov xcentre2,eax		;save for later.
		mov ecx,mousex
		sub ecx,eax
		mov xtmp,ecx
		;ytmp=(ycentre+(ydeltacentre*(ring-1))...
		mov eax,(OBJECT PTR [esi]).ydeltacentre ;offset from previous ring.
		mov ecx,ring
		dec ecx
		imul ecx
		add eax,ycentre
		mov ycentre2,eax		;save for later.
		mov ecx,mousey
		sub ecx,eax
		mov ytmp,ecx

;still need hypotenuse and normalised g_xdiffnorm/g_ydiffnorm...
				xor edx,edx
				mov eax,ytmp	;/ hypot=sqrt((mousey-centrey)^2
				mov ebx,eax 			;/				 +((mousex-centrex)^2)
				imul ebx								;/ -->edx:eax
				mov deltaytmp,eax				 ;/ temp save
				xor edx,edx
				mov eax,xtmp
				mov ebx,eax 			;/
				imul ebx								;/ -->edx:eax
				add  eax,deltaytmp				;/
				;now square-root...
				mov hypot,eax
				fild hypot
				fsqrt
				fistp hypot 			;will always be +ve.
				  .IF hypot==0			   ;prevent divide-by-0.
						mov  hypot,1
				  .ENDIF
				;now to normalise xtmp/ytmp (as per explanation above)...
				mov eax,xtmp
				xor edx,edx
				mov ebx,100 ;determines final arrow-size.
				imul ebx
				mov ebx,hypot
				idiv ebx
				mov g_xdiffnorm,eax
				  ;ditto for ytmp...
				  mov eax,ytmp
				  xor edx,edx
				  mov ebx,100	;determines final arrow-size.
				  imul ebx
				  mov ebx,hypot
				  idiv ebx
				  mov g_ydiffnorm,eax
				;...note, g_xdiffnorm/g_ydiffnorm are global variables.

;...............
;this block of code will snap mousex/mousey to nearest ring...
;jju: <<101200 label moved up.
		mov eax,ring			;z=(ring-1)*NRINGWIDTH
		dec eax
		xor edx,edx
		mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
		mul ecx
		add eax,(NEXTRAWIDTH/2) ;z=((ring-1)*NRINGWIDTH)+(NEXTRAWIDTH/2)
		;...allow +/- either side of ring to snap to centre.
		;(stops wires from jumping out the rings).
		mov z,eax
		  xor edx,edx			;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
		  mov eax,xtmp
		  imul xtmp
		  mov ebx,256 ;100
		  imul ebx
		  mov tmpvar,eax
		  xor edx,edx
		  mov eax,xr1
		  add eax,z
		  mov ebx,eax
		  mul ebx
		  mov ebx,eax
		  ;xor edx,edx ;careful as signed-div below. ok as +ve in eax.
		  mov eax,tmpvar
		  cdq ;sign-extend eax into edx. .v2.25.
		  idiv ebx
		  mov tmpvar,eax
				xor edx,edx
				mov eax,ytmp
				imul ytmp
				mov ebx,256 ;100
				imul ebx
				mov tmpvar2,eax
				xor edx,edx
				mov eax,yr1
				add eax,z
				mov ebx,eax
				mul ebx
				mov ebx,eax
				;xor edx,edx ;see above note.
				mov eax,tmpvar2
				cdq ;sign-extend eax into edx. v2.25.
				idiv ebx
				mov tmpvar2,eax
		  mov eax,tmpvar
		  add eax,tmpvar2
;		   mov ecx,zz
;		   mov zzprev,ecx
		  mov zz,eax

		;one problem is if g_nsnapring non-0, need to snap mousex/mousey
		;to that specific ring (not to nearest ring)...
		;note that g_nsnapring is a global variable.
		.IF g_nsnapring==0
		.ELSE
		  mov g_nsnapring,0
		  jmp jje
		.ENDIF

		.IF zz>256 ;100 		 ;note, zz will be 256 if exactly on ring.
		  ;mousex/y outside current ring.
		  ;xor eax,eax
		  mov eax,(OBJECT PTR [esi]).nrings
		  .IF eax==ring
				mov ferror,1
		  .ELSE
				inc ring
				jmp jju 		;try next-outer ring.
		  .ENDIF
		.ENDIF

jje:
		  ;recalculate zz, based on snapping to exact ring...
		  mov eax,ring			;z=(ring-1)*NRINGWIDTH
		  dec eax
		  xor edx,edx
		  mov ecx,(OBJECT PTR [esi]).nringwidth ;NRINGWIDTH
		  mul ecx
		  mov z,eax
		  xor edx,edx			;zz=((x^2)/((xr1+z)^2))+((y^2)/((yr1+z)^2))
		  mov eax,xtmp
		  imul xtmp
		  mov ebx,256 ;100
		  imul ebx
		  mov tmpvar,eax
		  xor edx,edx
		  mov eax,xr1
		  add eax,z
		  mov ebx,eax
		  mul ebx
		  mov ebx,eax
		  ;xor edx,edx	;ok as eax +ve.
		  mov eax,tmpvar
		  cdq ;sign-extend eax into edx. v2.25.
		  idiv ebx
		  mov tmpvar,eax
				xor edx,edx
				mov eax,ytmp
				imul ytmp
				mov ebx,256 ;100
				imul ebx
				mov tmpvar2,eax
				xor edx,edx
				mov eax,yr1
				add eax,z
				mov ebx,eax
				mul ebx
				mov ebx,eax
				;xor edx,edx  ;ok as eax +ve.
				mov eax,tmpvar2
				cdq ;sign-extend eax into edx. v2.25.
				idiv ebx
				mov tmpvar2,eax
		  mov eax,tmpvar
		  add eax,tmpvar2
		  .IF eax==0			  ;note, limits range of zz 0 to +2.3G.
				mov eax,1				   ;/precaution.
		  .ELSEIF SDWORD PTR eax<0 ;/
				mov eax,7FFFFFFFh  ;/(because of signed calcs below).
		  .ENDIF						   ;/
		  mov zz,eax

		fild zz
		fsqrt
		fistp zz						;will always be +ve.
		  mov eax,xtmp			;((x*10)/zz)+xcentre2
		  mov ebx,16 ;10
		  imul ebx
		  idiv zz
		  add eax,xcentre2
		  mov xend,eax
				mov eax,ytmp	;((y*10)/zz)+ycentre2
				mov ebx,16 ;10
				imul ebx
				idiv zz
				add eax,ycentre2
				mov yend,eax

;............
		mov eax,xend	;return snapped coords.
		mov esi,pxend
		mov [esi],eax
		mov eax,yend
		mov esi,pyend
		mov [esi],eax
		.IF ferror==1
		  mov eax,0
		.ELSE
		  mov eax,ring	  ;ring=0 if orig xend/yend outside node, else ring#.
		.ENDIF
  xor ebx,ebx ;return ebx=0.
  ret

snap_tonode ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
snap_tores PROC STDCALL USES ecx edx esi edi,pobj:DWORD, \
		pxend:DWORD,pyend:DWORD,xorient:DWORD,yorient:DWORD,ncurrentvertice:DWORD
		LOCAL xend:SDWORD, yend:SDWORD
		LOCAL mousex:SDWORD, mousey:SDWORD
		LOCAL xcentre:SDWORD, ycentre:SDWORD
;		 LOCAL ytmp:SDWORD, xtmp:SDWORD
;		 LOCAL deltaytmp:DWORD
;		 LOCAL hypot:DWORD
		LOCAL xradring1:DWORD
		LOCAL exactradius:DWORD
		LOCAL ring:DWORD
		LOCAL xradius:DWORD, yradius:DWORD
				LOCAL xxi:SDWORD,zzi:SDWORD,yyi:SDWORD,wwi:SDWORD
		LOCAL nside:DWORD
; "snap_tores"
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pnode and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;NEW xorient/yorient. use to calc arrow orientation. if a wire attached
;to this object, these params are a coord further back on wire. *NEW*
;see snap_topoly() for example.

;ncurrentvertice currently only used in snap_popoly().
;return ebx=0. note, for snap_topoly() returns ebx=vertice snapped to (>0).

		mov esi,pxend
		mov eax,[esi]
		mov xend,eax
		mov esi,pyend
		mov eax,[esi]
		mov yend,eax

;NOTE got this code from goofee WHICH0/WHICH3...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
		mov eax,xend
		mov mousex,eax
		mov eax,yend
		mov mousey,eax

		mov esi,pobj			;res.
		mov eax,(OBJECT PTR [esi]).xmid
		mov xcentre,eax
		mov eax,(OBJECT PTR [esi]).ymid
		mov ycentre,eax
		mov eax,(OBJECT PTR [esi]).wwidth
		shr eax,1
		mov xradius,eax 		;x-radius of res.
		mov eax,(OBJECT PTR [esi]).height
		shr eax,1
		mov yradius,eax 		;y-radius of res.


;it's complicated calculating exactly where on the rectangle boundary
;to place xend/yend.
;i don't think we'll use hypot at all.
;just snap xend/yend to one of the corners...
;*EVE* No, use old goofee WHICH3, snaps more accurately...

				mov  eax,ycentre				;ycentre+yradius+1
				add  eax,yradius				;/
				mov  yyi,eax					;/bottom of rectangle.
				  mov  eax,ycentre				;ycentre-yradius-1
				  sub  eax,yradius				;/
				  mov  wwi,eax					;/top of rectangle.
						mov  eax,xcentre		;xcentre-xradius-1
						sub  eax,xradius		;/
						mov  zzi,eax			;/left of rectangle.
						  mov  eax,xcentre		;xcentre+xradius+1
						  add  eax,xradius		;/
						  mov  xxi,eax			;/right of rectangle.

				mov  eax,xxi
				sub  eax,mousex
				.IF  SDWORD PTR eax>4 ;is x-end further than 4 pixels in from right side?
				  mov  eax,mousex
				  sub  eax,zzi
				  .IF  SDWORD PTR eax>4 ;is x-end more than 4 pixels in from left side?
						mov  eax,yyi
						sub  eax,mousey
						.IF SDWORD PTR eax>=yradius ;closer to top side of rectangle?
								mov  eax,mousex
								mov  xend,eax
								mov  eax,wwi
								mov  yend,eax
								mov nside,1 ;top.
						.ELSE					 ;closer to bottom side.
						  mov  eax,mousex
						  mov  xend,eax
						  mov  eax,yyi
						  mov  yend,eax
						  mov nside,3 ;bottom.
						.ENDIF
				  .ELSE
						mov  eax,zzi   ;snap to left side.
						mov  xend,eax
						mov  eax,mousey
						mov  yend,eax
						mov nside,0 ;left.
				  .ENDIF
				.ELSE
				  mov  eax,mousey  ;snap to right side.
				  mov yend,eax
				  mov  eax,xxi
				  mov xend,eax
				  mov nside,2 ;right.
				.ENDIF

;problem, can drag wire above and below sides 0 (left) and 2 (right)...
				.IF nside==0
p50:	  mov eax,yyi
				  mov ecx,(OBJECT PTR [esi]).ncornerheight ;for rounded rectangle.
				  shr ecx,1
				  sub eax,ecx
				  .IF SDWORD PTR eax<yend
						mov yend,eax
				  .ELSE
						mov eax,wwi
						add eax,ecx ;(OBJECT PTR [esi]).ncornerheight
						.IF SDWORD PTR eax>yend
						  mov yend,eax
						.ENDIF
				  .ENDIF
				.ELSEIF nside==2
				  jmp p50
				.ELSEIF nside==1
p51:	  mov eax,xxi
				  mov ecx,(OBJECT PTR [esi]).ncornerwidth ;for rounded rectangle.
				  shr ecx,1
				  sub eax,ecx
				  .IF SDWORD PTR eax<xend
						mov xend,eax
				  .ELSE
						mov eax,zzi
						add eax,ecx ;(OBJECT PTR [esi]).ncornerwidth
						.IF SDWORD PTR eax>xend
						  mov xend,eax
						.ENDIF
				  .ENDIF
				.ELSE ;nside=3
				  jmp p51
				.ENDIF

;code to calc angle for arrow...
				 ;code to straighten the arrows...
				 .IF nside==3
				   mov eax,mousex
				   mov ebx,wwi
				 .ELSEIF nside==2
				   mov eax,zzi
				   mov ebx,mousey
				 .ELSEIF nside==1
				   mov eax,mousex
				   mov ebx,yyi
				 .ELSE
				   mov eax,xxi
				   mov ebx,mousey
				 .ENDIF
				 mov xcentre,eax		;relocates "centre" directly opposite side
				 mov ycentre,ebx		;/		 of rectangle to mousex/y.

				invoke calcxydiffnorm,mousex,xcentre,mousey,ycentre
;				 mov  eax,mousey				 ;compute formula
;				 sub  eax,ycentre				 ;/ hypot=sqrt((mousey-centrey)^2
;				 mov  ebx,eax					 ;/   +((mousex-centrex)^2)
;				 mov  ytmp,eax					 ;/
;				 imul  ebx								 ;/ -->edx:eax
;				 mov  deltaytmp,eax   ;/ temp save
;				 mov  eax,mousex				 ;/
;				 sub  eax,xcentre				 ;/
;				 mov  ebx,eax					 ;/
;				 mov  xtmp,eax					 ;/
;				 imul  ebx								 ;/ -->edx:eax
;				 add  eax,deltaytmp  ;/
;		 ;now square-root...
;		 mov hypot,eax
;		 fild hypot
;		 fsqrt
;		 fistp hypot			 ;will always be +ve.
;				   .IF hypot==0 				;prevent divide-by-0.
;						 mov  hypot,1
;				   .ENDIF
;;now to normalise xtmp/ytmp (as per explanation above)...
;				 xor edx,edx
;				 mov eax,xtmp
;				 mov ebx,100	 ;determines final arrow-size.
;				 imul ebx
;				 mov ebx,hypot
;				 idiv ebx
;				 mov g_xdiffnorm,eax
;				   ;ditto for ytmp...
;				   xor edx,edx
;				   mov eax,ytmp
;				   mov ebx,100	 ;determines final arrow-size.
;				   imul ebx
;				   mov ebx,hypot
;				   idiv ebx
;				   mov g_ydiffnorm,eax

				mov ebx,pxend	;return snapped xend/yend
				mov eax,xend
				mov [ebx],eax
				mov ebx,pyend
				mov eax,yend
				mov [ebx],eax

		mov eax,1				;supposed to return ring#, but really for nodes.
		xor ebx,ebx ;return ebx=0.
  ret
snap_tores ENDP
;--------------------------------------------------------------------------
;.DATA
;lastsnappedx SDWORD 0
;lastsnappedy SDWORD 0

.CODE
snap_topoly PROC STDCALL USES ecx edx esi edi,pobj:DWORD, \
		pxend:DWORD,pyend:DWORD,xorient:DWORD,yorient:DWORD,ncurrentvertice:DWORD
		LOCAL xend:SDWORD, yend:SDWORD
		LOCAL mousex:SDWORD, mousey:SDWORD
		LOCAL xcentre:SDWORD, ycentre:SDWORD
		LOCAL fon:DWORD,nring:DWORD
		LOCAL nvertice:DWORD,ncaptureradius:DWORD
		LOCAL varray[84]:SDWORD
		LOCAL zoom:BYTE
;		 LOCAL xtmp:SDWORD,ytmp:SDWORD,deltaytmp:SDWORD,hypot:DWORD

; "snap_topoly"
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pnode and snap xend/yend to it.
;if xend/yend not on node at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of node.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;;a problem is, when dragging a wire-end, can pull it away from the
;;polygon. want it to always snap to closest corner. so, have global
;;variables, lastsnappedx/lastsnappedy, being the last valid snapped coords.

;NEW xorient/yorient. use to calc arrow orientation. if a wire attached
;to this object, these params are a coord further back on wire. *NEW*
;see snap_topoly() for example.

;return ebx=vertice snapped to.

		mov esi,pxend
		mov eax,[esi]
		mov xend,eax
		mov esi,pyend
		mov eax,[esi]
		mov yend,eax

;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names... (see code in snap_tores).
		mov eax,xend
		mov mousex,eax
		mov eax,yend
		mov mousey,eax
		mov edi,pobj

		mov xend,0
		mov yend,0
		mov fon,0
		mov nvertice,1 ;1st vertice is number 1.
		mov ncaptureradius,6

;v2.03 control-points...
			  lea edx,varray ;needed in... registers eax, esi used in...
			  mov esi,edi
			  ;func uses esi->poly, edx->varray...
			  invoke combinepolyarrays


;if ncurrentvertice=0 then have to look if on a vertice...
		cmp ncurrentvertice,0
		je z17

;i only want to recalc the snap when dragging a wire end. it is possible this snap_
;func can get called at other times. ...
		.IF g_nstate==8 ;moving an element.
		  .IF g_nknee==4 ;moving a wire end.
z15:			mov ebx,pTERSEDATA
				mov ecx,(TERSEDATA PTR [ebx]).nzoom
				mov zoom,cl
				xor eax,eax
				mov al,6 ;8
				.IF SBYTE PTR cl<0
				  neg cl
				  shr al,cl
				  .IF al==0
						mov al,1
				  .ENDIF
				.ENDIF
				mov ncaptureradius,eax ;narrow capture zone when zoomed in.
				jmp SHORT z17
		  .ELSEIF g_nknee==5 ;moving a wire end.
				jmp SHORT z15
		  .ENDIF
		.ELSEIF g_nstate==4 ;placing 1st end of a new element. v2.24.
		  ;when press lbutton on a poly and drag, thus placing 1st end of a wire, it isn't
		  ;snapping to poly, so add this condition...
		  jmp z15
		.ELSEIF g_nstate==5 ;v2.24
		  ;ditto
		  jmp z15
		.ENDIF
		jmp z19

;it's complicated calculating exactly where on the rectangle boundary
;to place xend/yend....
;i'll snap to closest corner...
z17:	lea ebx,varray ;x
		mov esi,ebx
		add esi,4	   ;y
		mov ecx,(OBJECT PTR [edi]).ncorners
j10:	 mov eax,[ebx]
		 sub eax,mousex
		 .IF SDWORD PTR eax<0
		   neg eax
		 .ENDIF
				 .IF eax<ncaptureradius ;5
				   ;x-difference is close enough, what about y-difference?...
				   mov eax,[esi]
				   sub eax,mousey
				   .IF SDWORD PTR eax<0
						 neg eax
				   .ENDIF
				   .IF eax<ncaptureradius ;5
						 ;success!...
						 mov eax,[ebx] ;bezx
						 mov xend,eax
;						  mov lastsnappedx,eax
						 mov eax,[esi] ;bezy
						 mov yend,eax
;						  mov lastsnappedy,eax
						 mov fon,1
						 jmp g44
				   .ENDIF
				 .ENDIF
		 add ebx,8
		 add esi,8
		 inc nvertice
		 loop j10
g44:

;now snap xend/yend to a corner of polygon...
		  .IF fon==1
				;mousex/mousey is on the polygon...
z22:			mov ebx,pxend	;return snapped xend/yend
				mov eax,xend
				mov [ebx],eax
				mov ebx,pyend
				mov eax,yend
				mov [ebx],eax
				mov nring,1  ;ring#
		  .ELSE 				 ;prevents wire being dragged away from polygon.
z19:			.IF ncurrentvertice != 0 ;was already on a vertice.
				  lea ebx,varray
				  mov eax,ncurrentvertice
				  mov nvertice,eax
				  dec eax
				  shl eax,1
				  shl eax,1
				  shl eax,1
				  add ebx,eax ;x-coord of current vertice.
				  mov eax,[ebx]
				  mov xend,eax
				  add ebx,4
				  mov eax,[ebx]
				  mov yend,eax
				  jmp z22
				.ELSE
				  mov nvertice,0 ;not on any vertice.
				  mov nring,0
				.ENDIF
		  .ENDIF

;calc. orientation for an arrow, if wire-end attached to polygon...
;note, xorient/yorient are a point knee2/3 on wire, so can calc
;an arrow oriented with wire...
;(refer paint_arc() which calls this func)
				invoke calcxydiffnorm,xorient,xend,yorient,yend

get1:
		mov eax,nring
		mov ebx,nvertice
		ret
snap_topoly ENDP
;--------------------------------------------------------------------------
snap_toarc PROC STDCALL USES ecx edx esi edi,pobj:DWORD, \
		pxend:DWORD,pyend:DWORD,xorient:DWORD,yorient:DWORD,ncurrentvertice:DWORD
		LOCAL xend:SDWORD, yend:SDWORD
		LOCAL mousex:SDWORD, mousey:SDWORD
		LOCAL xcentre:SDWORD, ycentre:SDWORD
		LOCAL ytmp:SDWORD, xtmp:SDWORD
		LOCAL deltaytmp:DWORD
		LOCAL hypot:DWORD, xradring1:DWORD
		LOCAL exactradius:DWORD
		LOCAL ring:DWORD
; "snap_toarc" *EVE*
;a method for psnap polymorphic function.
;for placing or adjusting an end of a wire, pxend/pyend.
;(don't need to refer to g_nmousex/y here, as have xend/yend).
;determine nearest point on boundary of pobj and snap xend/yend to it.
;if xend/yend not on pobj at all, return eax=0 -- but still set xend/yend
;to nearest point on outer boundary of pobj.
;else return eax=ring that snapped to.
;also returns adjusted xend/yend.

;note, this function is for attaching a child-object to a wire. the parent
;wire will have a line to the child. The child can be any type of
;object, and the line is to the middle point of the parent wire.

;it's a bit weird attaching another wire to middle of a wire, but
;just in case, the child wire needs this...
;in the case of wires, immediately after calling this method (from
;paint_arc, via psnap method table), an arrowhead is drawn by calling
;draw1starrow() and draw2ndarrow(). these latter funcs use xend/yend
;but to calc other points, also need g_xdiffnorm/g_ydiffnorm, being
;normalised difference between middle of parent node and wire-end.
;xtmp/ytmp are un-normalised, so (xtmp*100)/hypot performs normalisation.
;i'm going to cheat a bit and make g_xdiffnorm/g_ydiffnorm global.

;NEW xorient/yorient. use to calc arrow orientation. if a wire attached
;to this object, these params are a coord further back on wire. *NEW*
;see snap_topoly() for example.

;ncurrentvertice currently only used in snap_popoly().
;return ebx=0. note, for snap_topoly() returns ebx=vertice snapped to (>0).

		mov esi,pxend
		mov eax,[esi]
		mov xend,eax
		mov esi,pyend
		mov eax,[esi]
		mov yend,eax

;NOTE got this code from goofee WHICH0...
;WHICH0 uses incoming coords-to-be-snapped as mousex/mousey, so let's
;keep these names...
		mov eax,xend
		mov mousex,eax
		mov eax,yend
		mov mousey,eax

		mov esi,pobj
		mov eax,(OBJECT PTR [esi]).xmid
		mov xcentre,eax
		mov eax,(OBJECT PTR [esi]).ymid
		mov ycentre,eax

;		   invoke calcxydiffnorm,mousex,xcentre,mousey,ycentre
;...this func does what following code does, but need some params further on...
				mov  eax,mousey 				;compute formula
				sub  eax,ycentre				;/ hypot=sqrt((mousey-centrey)^2
				mov  ebx,eax					;/				 +((mousex-centrex)^2)
				mov  ytmp,eax					;/
				imul  ebx								;/ -->edx:eax
				mov  deltaytmp,eax				 ;/ temp save
				mov  eax,mousex 				;/
				sub  eax,xcentre				;/
				mov  ebx,eax					;/
				mov  xtmp,eax					;/
				imul  ebx								;/ -->edx:eax
				add  eax,deltaytmp				;/
		;now square-root...
		mov hypot,eax
		fild hypot
		fsqrt
		fistp hypot 	;will always be +ve.
				  .IF hypot==0			   ;prevent divide-by-0.
						mov  hypot,1
				  .ENDIF
;now to normalise xtmp/ytmp (as per explanation above)...
				xor edx,edx
				mov eax,xtmp
				mov ebx,100 ;determines final arrow-size.
				imul ebx
				mov ebx,hypot
				idiv ebx
				mov g_xdiffnorm,eax
				  ;ditto for ytmp...
				  xor edx,edx
				  mov eax,ytmp
				  mov ebx,100	;determines final arrow-size.
				  imul ebx
				  mov ebx,hypot
				  idiv ebx
				  mov g_ydiffnorm,eax

;let's say mid-point of wire is a small circle of radius 4 pixels.
		mov exactradius,4
		mov ring,0

;now to snap xend/yend...
				xor edx,edx
				mov  eax,exactradius					;compute formula
				imul xtmp												;/ x=x*(xradius/hypot)
				idiv  hypot 							;/
				mov  xtmp,eax									;/
				xor edx,edx
				mov  eax,exactradius					;compute formula
				imul ytmp												;/ y=y*(xradius/hypot)
				idiv  hypot 							;/
				mov  ytmp,eax									;/
				mov  eax,xcentre								;compute formula
				add  eax,xtmp									;/ xend=centrex+x
				mov  xend,eax					;/
				mov  eax,ycentre								;compute formula
				add  eax,ytmp					;/
				mov  yend,eax					;/


		mov eax,xend	;return snapped coords.
		mov esi,pxend
		mov [esi],eax
		mov eax,yend
		mov esi,pyend
		mov [esi],eax
		mov eax,ring
		xor ebx,ebx
  ret
snap_toarc ENDP
;--------------------------------------------------------------------------
draw1starrow PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD, \
				pparent:DWORD, xendpoint:DWORD,yendpoint:DWORD,ringnum:DWORD, \
				pwire:DWORD,state:DWORD
				LOCAL xx2:DWORD, yy2:DWORD, xx3:DWORD, yy3:DWORD
				LOCAL x2:DWORD, y2:DWORD, x3:DWORD, y3:DWORD
				LOCAL xenddiv16:DWORD, yenddiv16:DWORD
				LOCAL xenddiv8:DWORD, yenddiv8:DWORD
				LOCAL xenddiv4:DWORD, yenddiv4:DWORD
				LOCAL xx4:DWORD, yy4:DWORD, x4:DWORD, y4:DWORD
				LOCAL xenddiv32:DWORD, yenddiv32:DWORD
				LOCAL hpenyellow:DWORD,hpenoldblack:DWORD
				LOCAL x5:DWORD, y5:DWORD,exttype:DWORD
				LOCAL pts3:POINT,pts2:POINT,pts1:POINT
				LOCAL xmidb:DWORD,ymidb:DWORD,nradius:DWORD
; "draw1starrow"
;draw arrow at 1st end of wire pwire, locked to node pparent.
;point of contact between wire and node is xendpoint/yendpoint, on ring.
;after drawing the arrow, the last line is to end at middle-back
;of arrowhead, so can draw wire to xknee2/yknee2 upon return.
;also refer draw2ndarrow().

		mov esi,pwire
		mov eax,(OBJECT PTR [esi]).nexttype
		mov exttype,eax
		mov edi,pparent

;*EVE* want to make redrawing more efficient. for certain values of
;g_nstate, paint_arc() won't call snap_tonode() before comes here,
;so won't have recalc'd end coord and arrow orientation, so use
;current values stored inside the wire element...
		.IF state==0
		  jmp p10
		.ENDIF

;*EVE* a problem if wire-end not attached to anything...
;paint_arc->snap_tonode computes g_xdiffnorm/g_ydiffnorm, for correct
;orientation of arrow away from attached-to object, but causes
;wire-end to display at funny angle if not attached...
				;note, temporary use of x2/y2/x3/y3/xx2...
				mov eax,(OBJECT PTR [esi]).rpowner1
				.IF eax==0
				  ;i could set g_xdiffnorm/ydiffnorm to zero, but arrows
				  ;won't display. or, could recalc...get code from snap_tonode...
				  ;we want arrow to align from x/yendpoint to x/yknee2 of wire...
				  invoke calcxydiffnorm,(OBJECT PTR [esi]).xknee2,xendpoint, \
				  (OBJECT PTR [esi]).yknee2,yendpoint
				.ENDIF
				;save arrow orientation...
				mov eax,g_xdiffnorm
				mov (OBJECT PTR [esi]).xdiffnorm1st,eax
				mov eax,g_ydiffnorm
				mov (OBJECT PTR [esi]).ydiffnorm1st,eax

p10:
;compute a lot of points, for our various options...
				 ;*EVE* arrow size to suit width of pen...
;				  mov ecx,(OBJECT PTR [esi]).rpowner1
				 mov eax,(OBJECT PTR [esi]).narrowscaling1st
;						.IF ecx==0 ;wire-end not attached to anything.
;						  dec eax ;reduce size of 90degree trajectory.
;						.ENDIF
				 mov ecx,(OBJECT PTR [esi]).npenwidth
				 add ecx,eax
				 .IF SDWORD PTR ecx<=0
				   mov ecx,1 ;reduces size of 90degree trajectory below default.
				 .ENDIF

				 mov  eax,(OBJECT PTR [esi]).xdiffnorm1st ;g_xdiffnorm;(see snap_ methods).
				 imul ecx  ;affects length of line out of end of wire.
				 sar  eax,1
				 sar  eax,1
				 mov  xenddiv4,eax
				 sar  eax,1
				 mov  xenddiv8,eax
				 sar  eax,1
				 mov  xenddiv16,eax ;save
				 sar  eax,1
				 mov  xenddiv32,eax
				 mov  eax,(OBJECT PTR [esi]).ydiffnorm1st ;g_ydiffnorm
				 imul ecx
				 sar  eax,1
				 sar  eax,1
				 mov  yenddiv4,eax
				 sar  eax,1
				 mov  yenddiv8,eax
				 sar  eax,1
				 mov  yenddiv16,eax
				 sar  eax,1
				 mov  yenddiv32,eax

				 ;compute next coords for arrowhead....
				 mov  eax,xendpoint  ;x-tip of arrow.
				 sub  eax,yenddiv32
				 add  eax,xenddiv16
				 mov  x2,eax			;1st side-tip of arrow.
				 mov  eax,yendpoint
				 add  eax,yenddiv16
				 add  eax,xenddiv32
				 mov  y2,eax
				 mov  eax,xendpoint
				 add  eax,yenddiv32
				 add  eax,xenddiv16
				 mov  x3,eax			;other-side-tip of arrow.
				 mov  eax,yendpoint
				 add  eax,yenddiv16
				 sub  eax,xenddiv32
				 mov  y3,eax
				   ;same thing again, for xx2,yy2,xx3,yy3...
				   mov	eax,xendpoint
				   sub	eax,yenddiv16
				   add	eax,xenddiv8
				   mov	xx2,eax
				   mov	eax,yendpoint
				   add	eax,yenddiv8
				   add	eax,xenddiv16
				   mov	yy2,eax
				   mov	eax,xendpoint
				   add	eax,yenddiv16
				   add	eax,xenddiv8
				   mov	xx3,eax
				   mov	eax,yendpoint
				   add	eax,yenddiv8
				   sub	eax,xenddiv16
				   mov	yy3,eax
								;and coords perpendicular from node...
								mov  eax,xendpoint
								add  eax,xenddiv4
								mov  x4,eax
								mov  eax,yendpoint
								add  eax,yenddiv4
								mov  y4,eax
								mov  eax,xendpoint
								add  eax,xenddiv8
								mov  xx4,eax
								mov  eax,yendpoint
								add  eax,yenddiv8
								mov  yy4,eax
								mov  eax,xendpoint
								add  eax,xenddiv16
								mov  x5,eax
								mov  eax,yendpoint
								add  eax,yenddiv16
								mov  y5,eax


;fall down here, we want an arrow, but what type?...
; *EVE* now using .narrow1st =0 no arrow, =1 solid, =2 open...
		mov eax,(OBJECT PTR [esi]).narrow1st
		.IF al==0					   ;no arrow.
		  ;might as well start at point of arrow...
  ;mov g_errorapi,0B40h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke MoveToEx,hdc,xendpoint,yendpoint,0
		  .IF exttype==13 ;straight line ...draws straight between end points.
		  .ELSE
			invoke LineTo, hdc, x5,y5
		  .ENDIF
		.ELSEIF al==1		   ;solid arrow.
		  mov eax,xendpoint
		  mov pts1.pt_x,eax
		  mov eax,yendpoint
		  mov pts1.pt_y,eax
		  mov eax,x3
		  mov pts2.pt_x,eax
		  mov eax,y3
		  mov pts2.pt_y,eax
		  mov eax,x2
		  mov pts3.pt_x,eax
		  mov eax,y2
		  mov pts3.pt_y,eax
  ;mov g_errorapi,0B41h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke Polygon,hdc,ADDR pts1,3
		  invoke MoveToEx, hdc,x5,y5,0 ;just behind arrow.needed by paint_arc.
		  .IF exttype==12
				invoke LineTo,hdc,xx4,yy4
				;...x5/y5 is just behind arrow, xx4/yy4 is further behind.
		  .ENDIF
		.ELSEIF al==2		   ;open arrow.
		  ;might as well start at point of arrow...
  ;mov g_errorapi,0B42h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke MoveToEx, hdc, xendpoint,yendpoint, 0
		  invoke LineTo, hdc, x3,y3
		  invoke MoveToEx, hdc, x2,y2,0
		  invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
		  invoke LineTo, hdc, x5,y5  ;just behind arrow.
		  .IF exttype==12
				invoke LineTo,hdc,xx4,yy4
				;...x5/y5 is just behind arrow, xx4/yy4 is further behind.
		  .ENDIF
		.ELSEIF al==3 ;bullet.
					  mov eax,x5
					  sub eax,xendpoint
					  sar eax,1
					  mov ecx,x5
					  sub ecx,eax
					  mov xmidb,ecx
					  mov eax,y5
					  sub eax,yendpoint
					  sar eax,1
					  mov ecx,y5
					  sub ecx,eax
					  mov ymidb,ecx

						;to get radius, need to calc hypotenuse...
						mov eax,yendpoint
						sub  eax,y5   ;/ hypot=sqrt((delta-y)^2+((delta-x)^2)
						mov  ebx,eax					;/
						imul  ebx								;/ -->edx:eax
						push eax
						mov  eax,xendpoint
						sub  eax,x5   ;/
						mov  ebx,eax					;/
						imul  ebx								;/ -->edx:eax
						pop ebx ;eax saved above.
						add  eax,ebx
						;now square-root...
						mov nradius,eax
						fild nradius
						fsqrt
						fistp nradius					;will always be +ve.
						shr nradius,1
						;.IF nradius==0 			;prevent divide-by-0.
						;  mov	nradius,1
						;.ENDIF

		  mov eax,xmidb
		  mov ebx,eax
		  sub eax,nradius
		  add ebx,nradius
		  mov ecx,ymidb
		  mov edx,ecx
		  sub ecx,nradius
		  add edx,nradius
  ;mov g_errorapi,0B43h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke Ellipse,hdc,eax,ecx,ebx,edx
		  invoke MoveToEx, hdc,x5,y5,0 ;just behind arrow.needed by paint_arc.
		.ELSE
  ;mov g_errorapi,0B44h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke LineTo,hdc,x5,y5
		.ENDIF

;bezier...
  mov eax,x5			   ;start-point of bezier curve (start of wire)
  mov bez1.pt_x,eax
  mov (OBJECT PTR [esi]).bez1x,eax ;save point in wire(future quick redraw).
  mov eax,y5
  mov bez1.pt_y,eax
  mov (OBJECT PTR [esi]).bez1y,eax ;save point in wire(future quick redraw).
  mov eax,x4			  ;first control-point.
  mov bez2.pt_x,eax
  mov (OBJECT PTR [esi]).bez2x,eax ;save point in wire(future quick redraw).
  mov eax,y4
  mov bez2.pt_y,eax
  mov (OBJECT PTR [esi]).bez2y,eax ;save point in wire(future quick redraw).

;v1.54 save arrowhead vertices...
	mov eax,x2
	mov (OBJECT PTR [esi]).arrow1stx2,eax
	mov eax,y2
	mov (OBJECT PTR [esi]).arrow1sty2,eax
	mov eax,x3
	mov (OBJECT PTR [esi]).arrow1stx3,eax
	mov eax,y3
	mov (OBJECT PTR [esi]).arrow1sty3,eax

  ret
draw1starrow ENDP
;--------------------------------------------------------------------------
draw2ndarrow PROC STDCALL USES ebx ecx edx esi edi, hdc:DWORD, \
				pparent:DWORD, xendpoint:DWORD,yendpoint:DWORD,ringnum:DWORD, \
				pwire:DWORD, state:DWORD
				LOCAL xx2:DWORD, yy2:DWORD, xx3:DWORD, yy3:DWORD
				LOCAL x2:DWORD, y2:DWORD, x3:DWORD, y3:DWORD
				LOCAL xenddiv16:DWORD, yenddiv16:DWORD
				LOCAL xenddiv8:DWORD, yenddiv8:DWORD
				LOCAL xenddiv4:DWORD, yenddiv4:DWORD
				LOCAL xx4:DWORD, yy4:DWORD, x4:DWORD, y4:DWORD
				LOCAL xenddiv32:DWORD, yenddiv32:DWORD
				LOCAL hpenyellow:DWORD,hpenoldblack:DWORD
				LOCAL x5:DWORD, y5:DWORD,exttype:DWORD
				LOCAL pts3:POINT,pts2:POINT,pts1:POINT
				LOCAL xmidb:DWORD,ymidb:DWORD,nradius:DWORD
;draw arrow at 2nd end of wire pwire, locked to node pparent.
;point of contact between wire and node is xendpoint/yendpoint, on ring.
;after drawing the arrow, the last line is to end at middle-back
;of arrowhead, so can draw wire to xknee2/yknee2 upon return.
;see draw1starrow() for drawing arrow at 1st-end of wire.
;snap_ method is called by paint_ method just prior ro calling
;draw1starrow() and draw2nd arrow(). the snap_ methods set global
;variables g_xdiffnorm/g_ydiffnorm that are used in here to draw arrows.

;;might as well start at point of arrow...
;		 invoke MoveToEx, hdc, xendpoint,yendpoint, 0

		mov esi,pwire
		mov eax,(OBJECT PTR [esi]).nexttype
		mov exttype,eax
		mov edi,pparent

;*EVE* want to make redrawing more efficient. for certain values of
;g_nstate, paint_arc() won't call snap_tonode() before comes here,
;so won't have recalc'd end coord and arrow orientation, so use
;current values stored inside the wire element...
		.IF state==0
		  jmp p10
		.ENDIF

;*EVE* a problem if wire-end not attached to anything...
;paint_arc->snap_tonode computes g_xdiffnorm/g_ydiffnorm, for correct
;orientation of arrow away from attached-to object, but causes
;wire-end to display at funny angle if not attached...
				;note, temporary use of x2/y2/x3/y3/xx2...
				mov eax,(OBJECT PTR [esi]).rpowner2
				.IF eax==0
				  ;i could set g_xdiffnorm/ydiffnorm to zero, but arrows
				  ;won't display. or, could recalc...get code from snap_tonode...
				  ;we want arrow to align from x/yendpoint to x/yknee3 of wire...
				  invoke calcxydiffnorm,(OBJECT PTR [esi]).xknee3,xendpoint, \
				  (OBJECT PTR [esi]).yknee3,yendpoint
				.ENDIF
				;save arrow orientation...
				mov eax,g_xdiffnorm
				mov (OBJECT PTR [esi]).xdiffnorm2nd,eax
				mov eax,g_ydiffnorm
				mov (OBJECT PTR [esi]).ydiffnorm2nd,eax

p10:
;compute a lot of points, for our various options...

				 ;*EVE* arrow size to suit width of pen...
;				  mov ecx,(OBJECT PTR [esi]).rpowner2
				 mov eax,(OBJECT PTR [esi]).narrowscaling2nd
;						.IF ecx==0 ;arrow-end not attached to anything.
;						  dec eax ;reduce size of 90degree trajectory of wire-end.
;						.ENDIF
				 mov ecx,(OBJECT PTR [esi]).npenwidth
				 add ecx,eax
				 .IF SDWORD PTR ecx<=0
				   mov ecx,1
				 .ENDIF

				 mov  eax,(OBJECT PTR [esi]).xdiffnorm2nd ;g_xdiffnorm;(see snap_ methods)
;				  mov edx,(OBJECT PTR [esi]).narrow1st ;=0 no arrow.
;				  .IF edx != 0
						imul ecx  ;affects length of line out of end of wire.
;				  .ENDIF		  ; don't want it if no arrow.
				 sar  eax,1
				 sar  eax,1
				 mov  xenddiv4,eax
				 sar  eax,1
				 mov  xenddiv8,eax
				 sar  eax,1
				 mov  xenddiv16,eax ;save
				 sar  eax,1
				 mov  xenddiv32,eax
				 mov  eax,(OBJECT PTR [esi]).ydiffnorm2nd ;g_ydiffnorm
				  imul ecx
				 sar  eax,1
				 sar  eax,1
				 mov  yenddiv4,eax
				 sar  eax,1
				 mov  yenddiv8,eax
				 sar  eax,1
				 mov  yenddiv16,eax
				 sar  eax,1
				 mov  yenddiv32,eax

				 ;compute next coords for arrowhead....
				 mov  eax,xendpoint  ;x-tip of arrow.
				 sub  eax,yenddiv32
				 add  eax,xenddiv16
				 mov  x2,eax			;1st side-tip of arrow.
				 mov  eax,yendpoint
				 add  eax,yenddiv16
				 add  eax,xenddiv32
				 mov  y2,eax
				 mov  eax,xendpoint
				 add  eax,yenddiv32
				 add  eax,xenddiv16
				 mov  x3,eax			;other-side-tip of arrow.
				 mov  eax,yendpoint
				 add  eax,yenddiv16
				 sub  eax,xenddiv32
				 mov  y3,eax
				   ;same thing again, for xx2,yy2,xx3,yy3...
				   mov	eax,xendpoint
				   sub	eax,yenddiv16
				   add	eax,xenddiv8
				   mov	xx2,eax
				   mov	eax,yendpoint
				   add	eax,yenddiv8
				   add	eax,xenddiv16
				   mov	yy2,eax
				   mov	eax,xendpoint
				   add	eax,yenddiv16
				   add	eax,xenddiv8
				   mov	xx3,eax
				   mov	eax,yendpoint
				   add	eax,yenddiv8
				   sub	eax,xenddiv16
				   mov	yy3,eax
								;and coords perpendicular from node...
								mov  eax,xendpoint
								add  eax,xenddiv4
								mov  x4,eax
								mov  eax,yendpoint
								add  eax,yenddiv4
								mov  y4,eax
								mov  eax,xendpoint
								add  eax,xenddiv8
								mov  xx4,eax
								mov  eax,yendpoint
								add  eax,yenddiv8
								mov  yy4,eax
								mov  eax,xendpoint
								add  eax,xenddiv16
								mov  x5,eax
								mov  eax,yendpoint
								add  eax,yenddiv16
								mov  y5,eax

;fall down here, we want an arrow, but what type?...
; *EVE* now using .narrow2nd =0 no arrow, =1 solid, =2 open...
		mov eax,(OBJECT PTR [esi]).narrow2nd
		.IF al==0					   ;no arrow.
		  ;might as well start at point of arrow...
  ;mov g_errorapi,0B45h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke MoveToEx,hdc,xendpoint,yendpoint,0
		  .IF exttype==13 ;straight line ...draws straight between end points.
		  .ELSE
			invoke LineTo,hdc,x5,y5
		  .ENDIF
		.ELSEIF al==1		   ;solid arrow.
;		   invoke MoveToEx, hdc, xendpoint,yendpoint, 0
;		   invoke LineTo, hdc, x3,y3			  ;one side-point of arrow.
;		   invoke LineTo, hdc, x2,y2	 ;other side.
;		   invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
		  mov eax,xendpoint
		  mov pts1.pt_x,eax
		  mov eax,yendpoint
		  mov pts1.pt_y,eax
		  mov eax,x3
		  mov pts2.pt_x,eax
		  mov eax,y3
		  mov pts2.pt_y,eax
		  mov eax,x2
		  mov pts3.pt_x,eax
		  mov eax,y2
		  mov pts3.pt_y,eax
  ;mov g_errorapi,0B46h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke Polygon,hdc,ADDR pts1,3
		  invoke MoveToEx, hdc,x5,y5,0 ;just behind arrow.needed by paint_arc.
		  .IF exttype==12
				invoke LineTo,hdc,xx4,yy4
				;...x5/y5 is just behind arrow, xx4/yy4 is further behind.
		  .ENDIF
		.ELSEIF al==2		   ;open arrow.
		  ;might as well start at point of arrow...
  ;mov g_errorapi,0B47h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke MoveToEx, hdc, xendpoint,yendpoint, 0
		  invoke LineTo, hdc, x3,y3
		  invoke MoveToEx, hdc, x2,y2,0
		  invoke LineTo, hdc, xendpoint,yendpoint ;tip of arrow.
		  invoke LineTo, hdc, x5,y5  ;just behind arrow.
		  .IF exttype==12
				invoke LineTo,hdc,xx4,yy4
				;...x5/y5 is just behind arrow, xx4/yy4 is further behind.
		  .ENDIF
		.ELSEIF al==3 ;bullet.
					  mov eax,x5
					  sub eax,xendpoint
					  sar eax,1
					  mov ecx,x5
					  sub ecx,eax
					  mov xmidb,ecx
					  mov eax,y5
					  sub eax,yendpoint
					  sar eax,1
					  mov ecx,y5
					  sub ecx,eax
					  mov ymidb,ecx

						;to get radius, need to calc hypotenuse...
						mov eax,yendpoint
						sub  eax,y5   ;/ hypot=sqrt((delta_y)^2+((delta_x)^2)
						mov  ebx,eax					;/
						imul  ebx								;/ -->edx:eax
						push eax
						mov  eax,xendpoint
						sub  eax,x5   ;/
						mov  ebx,eax					;/
						imul  ebx								;/ -->edx:eax
						pop ebx ;eax saved above.
						add  eax,ebx
						;now square-root...
						mov nradius,eax
						fild nradius
						fsqrt
						fistp nradius					;will always be +ve.
						shr nradius,1
						;.IF nradius==0 			;prevent divide-by-0.
						;  mov	nradius,1
						;.ENDIF

		  mov eax,xmidb
		  mov ebx,eax
		  sub eax,nradius
		  add ebx,nradius
		  mov ecx,ymidb
		  mov edx,ecx
		  sub ecx,nradius
		  add edx,nradius
  ;mov g_errorapi,0B48h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke Ellipse,hdc,eax,ecx,ebx,edx
		  invoke MoveToEx, hdc,x5,y5,0 ;just behind arrow.needed by paint_arc.
		.ELSE
  ;mov g_errorapi,0B49h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke LineTo, hdc, x5,y5
		.ENDIF


;bezier...
  mov eax,x4
  mov bez6.pt_x,eax ;last control-point of beziercurve.
  mov (OBJECT PTR [esi]).bez6x,eax ;save point in wire(future quick redraw).
  mov eax,y4
  mov bez6.pt_y,eax
  mov (OBJECT PTR [esi]).bez6y,eax ;save point in wire(future quick redraw).
  mov eax,x5					;end-point of bezier curve.
  mov bez7.pt_x,eax
  mov (OBJECT PTR [esi]).bez7x,eax ;save point in wire(future quick redraw).
  mov eax,y5
  mov bez7.pt_y,eax
  mov (OBJECT PTR [esi]).bez7y,eax ;DWORD PTR (OBJECT PTR [esi]).nfunctype,eax
   ;... .nfunctype--.spare88-->.bez7y save point wire(future quick redraw).*NO*

;v1.54 save arrowhead vertices...
	mov eax,x2
	mov (OBJECT PTR [esi]).arrow2ndx2,eax
	mov eax,y2
	mov (OBJECT PTR [esi]).arrow2ndy2,eax
	mov eax,x3
	mov (OBJECT PTR [esi]).arrow2ndx3,eax
	mov eax,y3
	mov (OBJECT PTR [esi]).arrow2ndy3,eax


  ret
draw2ndarrow ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
insertring PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,nring:DWORD
		LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
		LOCAL nnewring:DWORD
;		 LOCAL exactradius:DWORD,xradring1:DWORD
;		 LOCAL xcentre:SDWORD,ycentre:SDWORD,hypot:DWORD,xtmp:SDWORD,ytmp:SDWORD
;		 LOCAL deltaxtmp:SDWORD,deltaytmp:SDWORD,xend:SDWORD,yend:SDWORD
; "insertring"
;called from KENTER5proc, node dialog box callback, to insert a ring.
;pobj is the node, nring is the ring# that the ring is to be inserted
;after.
;any wires on outer rings are adjusted. -- their .beginring or .endring
;value is incremented, and end coords adjusted to snap to correct ring.

		mov ebx,pobj											  ;node.
		inc (OBJECT PTR [ebx]).nrings

;scan through all objects...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;extreme precaution.
						jmp j03
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						  .IF esi==pobj ;don't test itself.
						  .ELSE
								mov eax,(OBJECT PTR [esi]).fconfig1
								and al,01				;bit0=1 if wire type.
								.IF al==01
								  mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pobj
										;1st end of wire is connected to node.
										;xor eax,eax
										mov eax,(OBJECT PTR [esi]).nbeginring
										mov ecx,nring
										.IF al>cl		 ;is wire at a ring outer from insertion?
										  ;update wire's .beginring...
										  inc eax
										  mov nnewring,eax		  ;new ring# wire is to snapto.
										  inc (OBJECT PTR [esi]).nbeginring
										  ;...though this gets auto-set by snap_tonode anyway.
												;modify .xtopleft/.ytopleft so will autosnap
												;to next-outer ring when next call WM_PAINT>wmpaint>
												; paint_arc>snap_tonode...
										  ;esi-->wire, ebx-->node


												;new routine for ellipse...
												push g_nsnapring				;precaution.
												push g_xdiffnorm				;/
												push g_ydiffnorm				;/
												mov eax,nnewring
												mov g_nsnapring,eax ;global, used by snap_tonode().
												mov ebx,pobj			;node.
												 ;offset wire-end for nonconcentric rings...
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 add (OBJECT PTR [esi]).xtopleft,eax ;wire.
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 add (OBJECT PTR [esi]).ytopleft,eax
												mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
												mov ebx,eax
												lea ecx,(OBJECT PTR [esi]).xtopleft ;wire.
												lea edx,(OBJECT PTR [esi]).ytopleft
												;calls snap_tonode()...
												invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx,0,0,0
												;...will return nearest point on nnewring, in
												;				.xtopleft/.ytopleft of wire.
												pop g_ydiffnorm
												pop g_xdiffnorm
												pop g_nsnapring


										.ENDIF
										  jmp SHORT tst1		;in case other end wire on same node.
								  .ELSE
tst1:							mov eax,(OBJECT PTR [esi]).rpowner2
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
										.IF eax==pobj
										  ;2nd end of wire is connected to node.
										  xor eax,eax
										  mov eax,(OBJECT PTR [esi]).nendring
										  mov ecx,nring
										  .IF al>cl  ;is wire at a ring outer from insertion?
												inc eax
												mov nnewring,eax ;new ring# wire must snap to.
												;update wire's .nendring...
												inc (OBJECT PTR [esi]).nendring
												;...though this gets auto-set by snap_tonode anyway.
												;modify .wwidth/.height(end coords)so will autosnap
												;to next-outer ring when next call WM_PAINT>wmpaint>
												; paint_arc...

												;091200 new routine for ellipse...
												push g_nsnapring				;precaution.
												push g_xdiffnorm				;/
												push g_ydiffnorm				;/
												mov eax,nnewring
												mov g_nsnapring,eax ;global, used by snap_tonode().
												mov ebx,pobj	  ;node.
												 ;offset wire-end for nonconcentric rings...
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 add (OBJECT PTR [esi]).wwidth,eax ;wire.
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 add (OBJECT PTR [esi]).height,eax
												mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
												mov ebx,eax
												lea ecx,(OBJECT PTR [esi]).wwidth				;wire.
												lea edx,(OBJECT PTR [esi]).height
												;calls snap_tonode()...
												invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx,0,0,0
												;...will return nearest point on nnewring, in
												;				.wwidth/height of wire.
												pop g_ydiffnorm
												pop g_xdiffnorm
												pop g_nsnapring

										  .ENDIF
										.ENDIF
								  .ENDIF
								.ELSE
								  ;it's a node-type.
								  ;an action or condition object will have .rpowner1
								  ;set to its parent, and .nbeginring set to the ring
								  ;it's connected to on the parent...
								  mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pobj
										;it is connected to pobj parent.
										mov eax,(OBJECT PTR [esi]).nexttype
										.IF ax==32		;condition element.
kk1:							  mov eax,(OBJECT PTR [esi]).nbeginring
										  mov ecx,nring
										  .IF al>cl  ;is action at a ring outer from insertion?
												inc (OBJECT PTR [esi]).nbeginring
												 ;offset cond/action for nonconcentric rings...
												 mov ebx,pobj	;node.
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 add (OBJECT PTR [esi]).xtopleft,eax
												 add (OBJECT PTR [esi]).xmid,eax
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 add (OBJECT PTR [esi]).ytopleft,eax
												 add (OBJECT PTR [esi]).ymid,eax
										  .ENDIF
										.ELSEIF ax==33 ;action element.
										  jmp kk1
										.ENDIF
								  .ENDIF
								.ENDIF
						  .ENDIF
				  .ENDIF
x1: mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  j02 ;nextobj
		  jmp SHORT j03
j02:  jmp nextobj
j03:


  ret
insertring ENDP
;--------------------------------------------------------------------------
deletering PROC STDCALL USES ebx ecx edx esi edi, pobj:DWORD,nring:DWORD
		LOCAL esisave:DWORD, edisave:DWORD, ecxsave:DWORD
		LOCAL nnewring:DWORD
; "deletering"
;called from KENTER5proc, node dialog box callback, to delete	a ring.
;pobj is the node, nring is the ring#.
;any wires on outer rings are adjusted. -- their .beginring or .endring
;value is decremented, and coords adjusted to snap to correct ring.

;a ring will not be deleted if it has any wires attached.
;returns eax=0 if fail.

		mov ebx,pobj									;node.

;scan through all objects...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;extreme precaution.
						jmp delfail
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						  .IF esi==pobj ;don't test itself.
						  .ELSE
								mov eax,(OBJECT PTR [esi]).fconfig1
								and al,01				;bit0=1 if wire type.
								.IF al==01
								  mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pobj
										;1st end of wire is connected to node.
										;xor eax,eax
										mov eax,(OBJECT PTR [esi]).nbeginring
										.IF eax==nring
										  ;fail. cannot delete ring...
										  jmp delfail
										.ENDIF
								  .ELSE
										mov eax,(OBJECT PTR [esi]).rpowner2
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
										.IF eax==pobj
										  ;2nd end of wire is connected to node.
										  ;xor eax,eax
										  mov eax,(OBJECT PTR [esi]).nendring
										  .IF eax==nring
												;fail. cannot delete ring...
												jmp delfail
										  .ENDIF
										.ENDIF
								  .ENDIF
								.ENDIF
						  .ENDIF
				  .ENDIF
x1: mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  j02 ;nextobj
		  jmp SHORT j03
j02:  jmp nextobj
j03:

;fall down here, then found no wires on ring, so delete it...
;have to go through database AGAIN, moving wires on outer rings
;in one ring...
;scan through all objects...
				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				;as we loop around, edi->start of TERSEDATA, esi->current object...
xnextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						  .IF esi==pobj ;don't test itself.
						  .ELSE
								mov eax,(OBJECT PTR [esi]).fconfig1
								and al,01				;bit0=1 if wire type.
								.IF al==01
								  mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pobj
										;1st end of wire is connected to node.
										;xor eax,eax
										mov eax,(OBJECT PTR [esi]).nbeginring
										mov ecx,nring
										.IF al>cl		 ;is wire at a ring outer from deletion?
										  ;update wire's .beginring...
										  dec eax
										  mov nnewring,eax ;ring# that wire must now snapto.
										  dec (OBJECT PTR [esi]).nbeginring
										  ;...though this gets auto-set by snap_tonode anyway.
												;modify .xtopleft/.ytopleft so will autosnap
												;to next-inner ring when next call WM_PAINT>wmpaint>
												; paint_arc>snap_tonode...


												;091200 new routine for ellipse...
												push g_nsnapring				;precaution.
												push g_xdiffnorm				;/
												push g_ydiffnorm				;/
												mov eax,nnewring
												mov g_nsnapring,eax ;global, used by snap_tonode().
												mov ebx,pobj
												 ;offset wire-end for nonconcentric rings...
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 sub (OBJECT PTR [esi]).xtopleft,eax ;wire.
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 sub (OBJECT PTR [esi]).ytopleft,eax
												mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
												mov ebx,eax
												lea ecx,(OBJECT PTR [esi]).xtopleft ;wire.
												lea edx,(OBJECT PTR [esi]).ytopleft
												;calls snap_tonode()...
												invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx,0,0,0
												;...will return nearest point on nnewring, in
												;				.xtopleft/.ytopleft of wire.
												pop g_ydiffnorm
												pop g_xdiffnorm
												pop g_nsnapring

										.ENDIF
										  jmp SHORT xtst1		;in case other end wire on same node.
								  .ELSE
xtst1:							mov eax,(OBJECT PTR [esi]).rpowner2
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA
														;assuming eax has value to be written...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
										.IF eax==pobj
										  ;2nd end of wire is connected to node.
										  ;xor eax,eax
										  mov eax,(OBJECT PTR [esi]).nendring
										  mov ecx,nring
										  .IF al>cl  ;is wire at a ring outer from deletion?
												;update wire's .nendring...
										  dec eax
										  mov nnewring,eax ;ring# that wire must now snapto.
												dec (OBJECT PTR [esi]).nendring
												;...though this gets auto-set by snap_tonode anyway.
												;modify .xtopleft/.ytopleft so will autosnap
												;to next-inner ring when next call WM_PAINT>wmpaint>
												; paint_arc...

												;new routine for ellipse...
												push g_nsnapring				;precaution.
												push g_xdiffnorm				;/
												push g_ydiffnorm				;/
												mov eax,nnewring
												mov g_nsnapring,eax ;global, used by snap_tonode().
												mov ebx,pobj	  ;node.
												 ;offset wire-end for nonconcentric rings...
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 sub (OBJECT PTR [esi]).wwidth,eax ;wire.
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 sub (OBJECT PTR [esi]).height,eax
												mov eax,(OBJECT PTR [ebx]).rpmethods ;rel.ptr to methods.
												mov ebx,eax
												lea ecx,(OBJECT PTR [esi]).wwidth				;wire.
												lea edx,(OBJECT PTR [esi]).height
												;calls snap_tonode()...
												invoke snapPTR PTR [ebx+ptrs+psnap], pobj,ecx,edx,0,0,0
												;...will return nearest point on nnewring, in
												;				.xtopleft/.ytopleft of wire.
												pop g_ydiffnorm
												pop g_xdiffnorm
												pop g_nsnapring

										  .ENDIF
										.ENDIF
								  .ENDIF

								.ELSE
								  ;it's a node-type.
								  ;an action or condition object will have .rpowner1
								  ;set to its parent, and .nbeginring set to the ring
								  ;it's connected to on the parent...
								  mov eax,(OBJECT PTR [esi]).rpowner1
														;ALL OBJECT PTRS RELATIVE TO TERSEDATA...
														.IF eax==0
														.ELSE
														  add eax,pTERSEDATA
														.ENDIF
								  .IF eax==pobj
										;it is connected to pobj parent.
										mov eax,(OBJECT PTR [esi]).nexttype
										.IF ax==32		;condition element.
kk1:							  mov eax,(OBJECT PTR [esi]).nbeginring
										  mov ecx,nring
										  .IF al>cl  ;is action at a ring outer from deletion?
												dec (OBJECT PTR [esi]).nbeginring
												 ;offset cond/action for nonconcentric rings...
												 mov ebx,pobj	;node.
												 mov eax,(OBJECT PTR [ebx]).xdeltacentre
												 sub (OBJECT PTR [esi]).xtopleft,eax
												 sub (OBJECT PTR [esi]).xmid,eax
												 mov eax,(OBJECT PTR [ebx]).ydeltacentre
												 sub (OBJECT PTR [esi]).ytopleft,eax
												 sub (OBJECT PTR [esi]).ymid,eax
										  .ELSEIF al==cl ;is action on ring to be deleted?
												mov (OBJECT PTR [esi]).fstatus,0 ;delete action.
										  .ENDIF
										.ELSEIF ax==33 ;label element.
										  jmp kk1
										.ENDIF
								  .ENDIF
								.ENDIF

						  .ENDIF
				  .ENDIF
xx1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop  xj02 ;nextobj
		  jmp SHORT xj03
xj02:  jmp xnextobj
xj03:

		mov ebx,pobj
		dec (OBJECT PTR [ebx]).nrings
		;xor eax,eax
		mov eax,(OBJECT PTR [ebx]).nrings
		ret

delfail:
		xor eax,eax
		ret
deletering ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;findmaster PROC STDCALL USES ebx ecx edx esi edi, plock:DWORD
;		 LOCAL dummy:BYTE
;; "findmaster" *EVE*
;;a child has it's .rpowner1/2 pointing to a parent (wires use .rpowner1
;;for 1st end, .rpowner2 for 2nd end, node-types only use .rpowner1).
;;the address of the parent is supplied to this function, and it must
;;be traced to find the master, at the head of any possible owner-chain.
;;addr of master returned in eax.
;
;;note that this func is intended for use by clone-nodes, and the master
;;addr will be stored in .rpmaster (not by this func though).
;
;		 mov esi,plock
;x1: mov edi,(OBJECT PTR [esi]).rpowner1
;		 .IF edi==0
;		   ;esi has addr of master...
;		   mov eax,esi
;		   ret
;		 .ENDIF
;		 add edi,pTERSEDATA  ;make addr absolute.
;		 mov esi,edi
;		 jmp x1
;
;		 ret
;findmaster ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
NUMHIGHLIGHTED	EQU 4096 ;v1.27 512 ;128 ;32
.DATA?
ALIGN 4 ;v3.24
highlightedlist DWORD NUMHIGHLIGHTED DUP(?)
highlightednewlist DWORD NUMHIGHLIGHTED DUP(?) ;used in duplicatehighlighted()

.DATA
ALIGN 4 ;v3.24
highlightedindex DWORD 0						;index of next free entry.
highlightedindexnewlist DWORD 0 		;index of next free entry.

.CODE
add2highlightedlist0 PROC STDCALL USES eax ebx ecx edx edi esi, pobj:DWORD
		LOCAL dummy:BYTE
; "add2highlightedlist0"
;list of multiple highlighted elements. (hold <shift> key while selecting).

		mov eax,pobj
		.IF eax==0
		  jmp SHORT out1 ;ret
		.ELSEIF eax==pTERSEDATA ;v1.87 precaution, this is invalid ptr.
		  jmp SHORT out1
		.ENDIF

		   ;eax used here...
		   mov ebx,highlightedindex 			   ;index to next free entry.
		   .IF DWORD PTR ebx<NUMHIGHLIGHTED  ;max size of highlighted-list buffer.
				 shl ebx,1								;convert to relative offset.
				 shl ebx,1						;(based on 4 bytes per entry)
				 lea esi,highlightedlist	 ;/
				 or ebx,ebx ;cmp ebx,0								;empty list.
				 je  nadd3						   ;/
nadd2:			   dec ebx								   ;find out if it is already in list.
				   dec ebx										 ;/
				   dec ebx										 ;/
				   dec ebx										   ;/
						mov edx,[ebx+esi]	;/
						cmp edx,eax 					;/
						je		nadd									;/jmp if yes it is.
						or ebx,ebx ;cmp ebx,0					  ;/
						jne nadd2										;/
						  ;fall down here if it isn't already in list.
;add object to list...
						  mov ebx,highlightedindex		;append it to end of list.
						  shl ebx,1 			  ;/
						  shl ebx,1 								 ;/
nadd3:			 mov [ebx+esi],eax				  ;/
				 inc highlightedindex	;/
nadd:
		   .ENDIF

out1:	   ret
add2highlightedlist0 ENDP
;--------------------------------------------------------------------------
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
sz17300    BYTE "Integrity check of currently open .EVE file completed.",0Dh,0Ah
				   BYTE "Note that this check is done automatically every time a file is "
				   BYTE "saved.",0

.CODE
checkintegrity PROC STDCALL USES ebx ecx edx esi edi,fsuppress:DWORD
		LOCAL esisave:DWORD,edisave:DWORD,ecxsave:DWORD
		LOCAL fnumber:DWORD,sizeobject:DWORD,nobjects:DWORD,fpointer:DWORD
		LOCAL floosedata:DWORD
		LOCAL floosedata2:DWORD,pparent:DWORD
		LOCAL fgeneralerror:DWORD ;v3.15
; "checkintegrity"
;called via "Control/Check database integrity" > IDM_INTEGRITY
;also from opendatafile(), openmerge(), savedatafile(), saveasdatafile(),
;saveasembedded(), selectedsaveasdatafile() and move1object().
;go thru all elements of database, check integrity.
;fsuppress=1 suppress messages. =0 display msgs. =2 display msgs,not final

		mov fnumber,0	   ;cnt of # elements with incorrect .number field.
		mov fpointer,0	   ;cnt of # incorrect pointers found.
		mov floosedata,0   ;cnt of # loose data elements.
		mov floosedata2,0  ;cnt # complete embedded files deleted.
		mov fgeneralerror,0 ;v3.15

				mov edi,pTERSEDATA
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				mov sizeobject,eax
				mov eax,(TERSEDATA PTR [edi]).numrecords
				mov nobjects,eax
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp kj3
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				  .IF al==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==-1				;data object (SEE .ELSE CASE BELOW)

						  ;in wmcreate() i create a dummy data object in position #0
						  ;-- had some problems with attaching any object to object#0.
						  ;so, bypass that one...
;						  lea eax,(TERSEDATA PTR [edi]).OBJECTS
								mov eax,(TERSEDATA PTR [edi]).noffsetobjs
								add eax,edi ;pTERSEDATA ;starting address of OBJECTS.
						  ;cmp eax,esi
						  ;je kk1
						  ;v3.15 "Selected elements save as..." was overwriting rec1 onto rec0,
						  ;now fixed, but need to detect rec#0 not a data element for older
						  ;diagrams...
						  .IF eax==esi ;rec#0
						    mov eax,(OBJECT PTR [esi]).fstatus
						    .IF eax != 1
						      mov (OBJECT PTR [esi]).fstatus,1
						      inc fgeneralerror
						    .ENDIF
						    mov eax,(OBJECT PTR [esi]).nexttype
						    .IF eax != -1
						      mov (OBJECT PTR [esi]).nexttype,-1
						      inc fgeneralerror
						    .ENDIF
						    ;...note ispointerok() will detect any ptr to rec#0, flag an error.						
						    jmp kk1 ;bypass.
						  .ENDIF

						  ;embedded file is a chain of data-elements.
						  ;those in the chain have .rpowner1->next-higher, but
						  ;1st in chain has .rpowner1=0, meaning it isn't owned
						  ;by anything...
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  .IF eax==0
								mov eax,(OBJECT PTR [esi]).fstatus
								and al,010000b ;bit4=1 embedded file.
								.IF al==010000b
								  ;have a bug where checkintegrity() finds .rpowner2 of a dataelement
								  ;in middle of a chain is wrong, so gets deleted...follow chain...
								  mov pparent,esi
								  mov ebx,(OBJECT PTR [esi]).rpdata ;pts to next in chain.
								  .IF ebx==0  ;last in chain, ok.
								  .ELSE
t11:							add ebx,pTERSEDATA
										  ;should also be a valid embedded dataelement...
										  mov eax,(OBJECT PTR [ebx]).fstatus
										  and al,010001b ;bit4=embedded file.
										  .IF al==010001b ;ok.
										  .ELSE
												;kill entire chain...
												jmp t13
										  .ENDIF
										mov eax,(OBJECT PTR [ebx]).rpowner1 ;should pt to parent dataelement.
										add eax,pTERSEDATA
										.IF eax==pparent ;ok
										  mov eax,(OBJECT PTR [ebx]).rpdata
										  mov pparent,ebx
										  .IF eax==0 ;end of chain, ok.
										  .ELSE
												mov ebx,eax
												jmp t11
										  .ENDIF
										.ELSE
										  ;dataelement in chain has a fault. shit. delete entire chain...
t13:							  mov ebx,esi
t12:							  mov (OBJECT PTR [ebx]).fstatus,0
										  mov eax,(OBJECT PTR [ebx]).rpdata
										  .IF eax==0 ;end.
										  .ELSE
												add eax,pTERSEDATA
												mov ebx,eax
												jmp t12
										  .ENDIF
										  inc floosedata2
										.ENDIF
								  .ENDIF
								  jmp kk1 ;ok.
								.ENDIF
						  .ENDIF

						  ;check that it points to a valid owner...
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  or eax,eax ;cmp eax,0
						  je e55
						  invoke ispointerok,eax
						  .IF eax==0 ;fail
e55:					;mov (OBJECT PTR [esi]).rpowner1,0
								inc floosedata
								;i should get rid of unattached data element entirely...
								mov (OBJECT PTR [esi]).fstatus,0
						  .ENDIF

						.ELSE
						  ;check for menu-description data element...(exttype=FFFFC000h)...
						  .IF ax==0C000h ;but not -1 as screened out above.
								jmp kk1 ;don't do any checking.
						  .ENDIF

						  ;v1.31
						  ;have defined *all* data elements must have bits14-31 set
						  ;(and can have more set, such as FFFFE000h)
						  ;so a more general exclusion test...
						  shl ax,1 ;bit14 now msb.
						  .IF SWORD PTR ax<0
							jmp kk1 ;don't do any checking.
						  .ENDIF

						  ;do need to have correct .number for elements of library objects
						  ;(code that scans menu-description dataelements (.nexttype=FFFFC000)
						  ; gets owner-element .number and uses it as menu-identifier -- seems
						  ;complicated, but end of story is .number must be correct).
						  ;(library-object-elements have the exttype=exttype OR FFFF8000h).

						  ;check for .number correct...
						  mov ebx,pTERSEDATA
;						  lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
								mov ecx,(TERSEDATA PTR [ebx]).noffsetobjs
								add ecx,ebx ;pTERSEDATA ;starting address of OBJECTS.
						  mov eax,esi
						  sub eax,ecx
						  xor edx,edx
						  ;xor ecx,ecx
						  mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
						  div ecx
						  ;eax now has correct number of element...
						  mov ebx,(OBJECT PTR [esi]).number
						  .IF ebx==eax
						  .ELSE
								inc fnumber
								mov (OBJECT PTR [esi]).number,eax		 ;correct it.
						  .ENDIF

						  ;check that all pointers point to valid objects...
						  ;.rpdata, .rpowner1, .rpowner2
						  mov eax,(OBJECT PTR [esi]).rpdata
						  invoke ispointerok,eax
						  .IF eax==0 ;fail.
f23:						mov (OBJECT PTR [esi]).rpdata,0 ;remove it.
							inc fpointer
						  .ELSE
								mov ebx,(OBJECT PTR [esi]).rpdata
								.IF ebx != 0
								  add ebx,pTERSEDATA
								  mov eax,(OBJECT PTR [ebx]).nexttype
								  .IF ax==-1 ;data-element.
								  .ELSE 		  ;fail.
										jmp f23
								  .ENDIF
								.ENDIF
						  .ENDIF
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  invoke ispointerok,eax
						  .IF eax==0 ;fail.
								mov (OBJECT PTR [esi]).rpowner1,0
								inc fpointer
						  .ENDIF
						  mov eax,(OBJECT PTR [esi]).rpowner2
						  invoke ispointerok,eax
						  .IF eax==0 ;fail.
								mov (OBJECT PTR [esi]).rpowner2,0
								inc fpointer
						  .ENDIF
;						   mov eax,(OBJECT PTR [esi]).rpmaster
;						   invoke ispointerok,eax
;						   .IF eax==0 ;fail.
;								 mov (OBJECT PTR [esi]).rpmaster,0
;								 inc fpointer
;						   .ENDIF



						.ENDIF
				  .ENDIF
kk1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				;xor eax,eax
				mov eax,sizeobject ;(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
				loop kj2  ;nextobj
kj1:	jmp SHORT kj3
kj2:	jmp nextobj
kj3:

  .IF fsuppress==0
		.IF fnumber != 0		;display all msgs.
		  invoke myalertbox,ADDR szer013,4  ;invoke myerrorhandler,013
		.ENDIF
		.IF fpointer != 0
		  invoke myalertbox,ADDR szer108,724h ;eax  ;invoke myerrorhandler,108
		.ENDIF
		.IF floosedata != 0
		  invoke myalertbox,ADDR szer107,725h ;eax  ;invoke myerrorhandler,107
		.ENDIF
		.IF floosedata2 != 0
		  invoke myalertbox,ADDR szer112,826h ;eax  ;invoke myerrorhandler,112
		.ENDIF
		.IF fgeneralerror != 0 ;v3.15
		  invoke myalertbox,ADDR szer305,4
		.ENDIF
		invoke myalertbox,ADDR sz17300,0 ;general msg, check completed.
  .ELSEIF fsuppress==1 ;suppress all msgs.
  .ELSEIF fsuppress==2 ;suppress final msg, allow error msgs.
		.IF fnumber==0
		.ELSE
		  invoke myalertbox,ADDR szer013,4  ;invoke myerrorhandler,013
		.ENDIF
		.IF fpointer==0
		.ELSE
		  invoke myalertbox,ADDR szer108,727h ;eax  ;invoke myerrorhandler,108
		.ENDIF
		.IF floosedata != 0
		  invoke myalertbox,ADDR szer107,728h ;eax  ;invoke myerrorhandler,107
		.ENDIF
		.IF floosedata2 != 0
		  invoke myalertbox,ADDR szer112,829h ;eax  ;invoke myerrorhandler,112
		.ENDIF
		.IF fgeneralerror != 0 ;v3.15
		  invoke myalertbox,ADDR szer305,4
		.ENDIF
  .ENDIF

		ret
checkintegrity ENDP
;--------------------------------------------------------------------------
ispointerok PROC STDCALL USES ebx ecx edx edi esi,rptr1:DWORD
  LOCAL nobjects:DWORD,sizeobject:DWORD,ptr1:DWORD
; "ispointerok"
;return eax=0 if fail, else =1 ok.
;called from checkintegrity() and wmcommand()/ax>4000 (library obj in Elements menu).
;note, rpptr1=0 returns ok.
						  mov edi,pTERSEDATA
						  mov eax,(TERSEDATA PTR [edi]).numrecords
						  mov nobjects,eax
						  mov eax,(TERSEDATA PTR [edi]).nsizeobject
						  mov sizeobject,eax
						  mov eax,rptr1 		 ;relative pointer.
						  .IF eax != 0
								add eax,pTERSEDATA
								mov ptr1,eax
								  mov ebx,(TERSEDATA PTR [edi]).noffsetobjs
								  add ebx,edi ;pTERSEDATA ;starting address of OBJECTS.
									;test if ptr1 below OBJECTS...
									.IF eax<=ebx ;element #0 also not allowed.
									  xor eax,eax
									  jmp SHORT out1
									.ENDIF
								sub eax,ebx
								xor edx,edx
								div sizeobject ;should get a number less than .numrecords.
								.IF eax>=nobjects	 ;note, .numrecords starts from 0.
								  xor eax,eax ;fail.
								  jmp SHORT out1 ;ret
								.ELSE
								    ;dividing (ptr1-noffsetobjs) by nobjects should also leave no
                    ;remainder. above div leaves remainder in edx... v3.29
								    .IF edx != 0
								      xor eax,eax ;fail
								      jmp SHORT out1
								    .ENDIF
								  mov ebx,ptr1
								  mov eax,(OBJECT PTR [ebx]).fstatus
								  and al,01
								  .IF al==01 ;valid element.
								  .ELSE
										xor eax,eax ;fail
										jmp SHORT out1 ;ret
								  .ENDIF
								.ENDIF
						  .ENDIF
						mov eax,1
out1:
		ret
ispointerok ENDP
;--------------------------------------------------------------------------
.DATA
g_fnoresize DWORD 0 ;v3.55

.CODE
duplicatehighlighted PROC STDCALL USES ebx ecx edx esi edi,fyespics:DWORD
		LOCAL ebxsave:DWORD,ebxsave2:DWORD
		LOCAL nsizeobjectssave:DWORD,nsizeactualsave:DWORD
		LOCAL nsizeobjectsold:DWORD,pendactualold:DWORD
		LOCAL nsizeactualold:DWORD
		LOCAL rporiginal:DWORD,pnew:DWORD,plock1:DWORD,plock2:DWORD
		LOCAL pmaster:DWORD
		LOCAL numobjectsprev:DWORD
		LOCAL rpnewowner:DWORD,rpdatae:DWORD
		LOCAL numpics:DWORD,rpold1stdata:DWORD ;,rpdatasave0:DWORD ;v3.15
		LOCAL rpendactualold:DWORD,pnewowner:DWORD ;rpprevowner:DWORD,;v3.15
; "duplicatehighlighted"
;from File/Duplicate > IDM_DUP
;duplicate elements stored in "highlightedlist" list.
;v3.15 fyespics=1 also duplicate any pictures attached to highlighted picture icons.

;have to go thru "highlightedlist" and copy the elements onto the
;end of the database.
;place new element-pointers in "highlightednewlist"
;problem, everytime call GlobalReAlloc(), all absolute pointers
;become invalid... so, convert pointers in highlighted lists to relative.

;return numobjectsprev -- number of objects prior to duplication. 0 if err.

    mov numpics,0 ;v3.15
    
;check if anything highlighted...
		.IF highlightedindex==0
		  invoke myalertbox,ADDR szerhi1,004 ;invoke myerrorhandler,14
		  xor eax,eax		
		  jmp exit1 ;ret
		.ENDIF

;find out size current database...
		  mov esi,pTERSEDATA
		  ;xor eax,eax
		  ;xor ecx,ecx
		  xor edx,edx
		  mov eax,(TERSEDATA PTR [esi]).numrecords
				mov numobjectsprev,eax ;this will be returned from func.
		  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		  mul ecx				;eax=size of OBJECTS database.
		  mov nsizeobjectssave,eax		;save size of old OBJECTS database.
;		   lea ebx,(TERSEDATA PTR [esi]).OBJECTS
				  mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
				  add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
		  add ebx,eax					;ACTUAL end of total database.
		  sub ebx,pTERSEDATA
		  mov nsizeactualsave,ebx		;ACTUAL size of total database.

;new elements will be placed in highlightednewlist...
		  mov eax,highlightedindex				  ;set size of new list the same.
		  mov highlightedindexnewlist,eax

;convert all entries in highlighted list to relative pointers...
		mov ebx,0
send2:
		lea esi,highlightedlist 	;start of highlighted list.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je send1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je send3
		  ;drop here, edi->element from highlighted list...
		  sub edi,pTERSEDATA
		  mov [esi+ebx],edi ;now pointer is relative.
send3:
		mov ebx,ebxsave
		add ebx,4
		jmp send2
send1:

;.......
;v3.55...
;we are calling globalrealloc() repeatedly, increasing by 1 record each time,
;but I want to increase it in one hit...
      invoke calcrealsizehighlighted ;returns eax=total# records to be exported.
      mov esi,pTERSEDATA
      mov ecx,(TERSEDATA PTR [esi]).nsizeobject
      mul ecx ;gives eax=total size exported.
      mov ebx,eax
      mov eax,(TERSEDATA PTR [esi]).numrecords
      mul ecx
      add eax,ebx ;total size of dbase when exported records copied to end dbase.
      add eax,28000 ;safety margin.
      push eax
      invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
			pop ebx	
      invoke GlobalReAlloc,eax,ebx,GMEM_MOVEABLE
      ;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
      ;here doesn't change that. this func will return eax=new address of block.
      .IF eax==0
        ;fail...
f77:    invoke DestroyWindow, g_hwnd	 ;exit.
        mov g_ndatabasesize,0
        invoke myalertbox,ADDR szer204,82Ah ;eax  ;invoke myerrorhandler,204
        xor eax,eax
        jmp exit1 ;ret
      .ENDIF
      mov pTERSEDATA,eax			;new pointer.
      mov g_fnoresize,1 ;tell createnewobject() not to resize dbase.
      ;...note, must clear before exit this func.
      ;all absolute pointers are invalid...
      invoke zeroabsoluteptrs,0
      mov wipeoutsindex,0
      mov updatesindex,0

;.......
;go thru every element in highlighted list, copy to end database...
		mov ebx,0
xend2:
		lea esi,highlightedlist 	;start of highlighted list.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je xend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je xend3
		;drop here, edi->element from highlighted list...
		mov rporiginal,edi

		  ;find out size current database...
		  mov esi,pTERSEDATA
		  xor edx,edx
		  mov eax,(TERSEDATA PTR [esi]).numrecords
		  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		  mul ecx				;eax=size of OBJECTS database.
		  mov nsizeobjectsold,eax		;save size of old OBJECTS database.
;		   lea ebx,(TERSEDATA PTR [esi]).OBJECTS
				  mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
				  add ebx,esi ;pTERSEDATA ;starting address of OBJECTS.
		  add ebx,eax					;ACTUAL end of total database.
		  mov pendactualold,ebx 		 ;save.
		  sub ebx,pTERSEDATA
		  mov nsizeactualold,ebx		;ACTUAL size of total database.

;v3.55 have done it in one hit above...
;		  ;increase memory block...
;		  mov eax,nsizeactualold
;		  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
;		  add eax,ecx
;				push eax
;				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
;				pop ebx
;				invoke GlobalReAlloc,eax,ebx,GMEM_MOVEABLE
;				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
;				;here doesn't change that. this func will return eax=new address of block.
;								  .IF eax==0
;										;fail...
;f77:							invoke DestroyWindow, g_hwnd	 ;exit.
;										mov g_ndatabasesize,0
;						invoke myalertbox,ADDR szer204,82Ah ;eax  ;invoke myerrorhandler,204
;										ret
;								  .ENDIF
;		  mov pTERSEDATA,eax			;new pointer.
;		  ;ah-ha! pendactualold (pointer to total end of old database) is
;		  ;now invalid. recalculate it...
;		  add eax,nsizeactualold
;		  mov pendactualold,eax

		  ;copy element to end of database...
		  mov edi,rporiginal			   ;(relative pointer)
		  add edi,pTERSEDATA
		  ;edi->element to be copied...
		  mov esi,pTERSEDATA
		  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		  mov esi,pendactualold 		;where copying to.
qq1:  mov al,[edi]
		  mov [esi],al
		  inc edi
		  inc esi
		  loop qq1

		  ;update...
		  mov esi,pTERSEDATA
		  inc (TERSEDATA PTR [esi]).numrecords
		  mov eax,g_ndatabasesize
		  mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		  add eax,ecx
		  mov g_ndatabasesize,eax
		  ;put an entry in highlightednewlist for new element...
		  mov ebx,ebxsave
		  lea esi,highlightednewlist
		  mov eax,pendactualold
		  sub eax,pTERSEDATA			;convert to relative pointer.
		  mov [esi+ebx],eax


        ;v2.32
        ;labels can have chained data elements, so need to have a loop...
		  ;okay, i'm going to try to fix problem of copying an attached
		  ;data element (previously did it below, but EVE crashed -- need
		  ;to do it here where the pointers in highlightedlist are relative.
		  ;they will also be created in highlightednewlist as relative.
				mov esi,pendactualold
				mov eax,esi
				sub eax,pTERSEDATA
				mov rpendactualold,eax ;save for below.
				mov rpnewowner,eax
nxt1:		mov eax,(OBJECT PTR [esi]).rpdata
				mov rpdatae,eax
				.IF eax==0 ;no attached data-element.
				.ELSE
				  mov esi,rpnewowner  ;parent.
				  add esi,pTERSEDATA
				  add eax,pTERSEDATA ;abs addr of the data.
				  invoke duplicatedataelement,esi,eax,1 ;pnewowner,polddata,1=end ofdbase
				  ;...creates a data-element, copies contents from olddata,
				  ; changes .rpdata to new data-element.
				  ;(note, this does not go into highlightednewlist).
				  ;returns ptr to new element.
				  ;...note, g_ndatabasesize and .numrecords get updated inside createnewobject(),
				  ; which is called by duplicatedataelement().
				  or eax,eax ;cmp eax,0 ;fail
				  je f77
				    ;v2.32
				    sub eax,pTERSEDATA ;new element.
				    mov rpnewowner,eax
				    mov esi,rpdatae
            add esi,pTERSEDATA ;old data element.
            jmp nxt1
				.ENDIF
				
			;v3.15 may need to copy a picture also...
			;having some trouble with doing this. an icon has a single data element
			;attached via icon.rpdata, and icon.rpdata2 pts to a picture, which is a
			;chain of data elements. the data element.rpdata pts to child data element etc.
			;let's do it in two parts...
			.IF fyespics != 0 ;=1 copy picture also.
			  mov esi,rpendactualold ;->element just copied to end of dbase.
			  add esi,pTERSEDATA
			  mov eax,(OBJECT PTR [esi]).nexttype
			  .IF eax>=60 ;icon has range 60-69, pic icon is 63.
			  .IF eax<=69
			    mov eax,(OBJECT PTR [esi]).rpdata2
			    .IF eax != 0 ;precaution
			      mov rpold1stdata,eax
			      add eax,pTERSEDATA ;->original 1st data element.			
				      inc numpics
				      mov ecx,numpics
				      mov (OBJECT PTR [esi]).nlibrary,ecx ;pic# in library.			
			      mov ecx,(OBJECT PTR [esi]).rpdata ;save
			      mov edx,esi
			      sub edx,pTERSEDATA
		        invoke duplicatedataelement,esi,eax,1 ;pnewicon,polddata,1=end ofdbase
				      or eax,eax ;cmp eax,0 ;fail
				      je f77
		        mov pnewowner,eax ;newly created data element.(careful, has .rpdata=0)
		        ;problem this func makes pnewicon.rpdata->new data, newdata.rpowner1
		        ;->pnewicon. fix...
		        mov esi,edx
		        add esi,pTERSEDATA ;pnewicon.
		        mov eax,(OBJECT PTR [esi]).rpdata
		        mov (OBJECT PTR [esi]).rpdata2,eax ;this must pt to picture.
		        mov (OBJECT PTR [esi]).rpdata,ecx  ;pts to text.
		        ;new 1st data element must have no owner...
		        mov ebx,pnewowner
		        mov (OBJECT PTR [ebx]).rpowner1,0
            mov (OBJECT PTR [ebx]).ximage,0 ;handle of bitmap.
              ;now we can duplicate the data element chain...
				      mov ebx,rpold1stdata ;this has the data chain.
				      add ebx,pTERSEDATA
				      mov eax,(OBJECT PTR [ebx]).rpdata ;pts to subsequent old dataelements.
xnxt1:	      mov rpdatae,eax
				      .IF eax==0 ;no attached data-element.
				      .ELSE
				        mov esi,pnewowner  ;parent.
				        add eax,pTERSEDATA ;abs addr of the data.
				        invoke duplicatedataelement,esi,eax,1 ;pnewowner,polddata,1=end ofdbase
				        ;...note, g_ndatabasesize and .numrecords get updated inside createnewobject(),
				        ; which is called by duplicatedataelement().
				        or eax,eax ;cmp eax,0 ;fail
				        je f77
				        mov pnewowner,eax ;newly created data element.
				        mov esi,rpdatae ;follows old data chain.
                add esi,pTERSEDATA ;old data element.
		            mov eax,(OBJECT PTR [esi]).rpdata  ;pts to old data element.
                jmp xnxt1
				      .ENDIF			
			    .ENDIF
        .ENDIF
        .ENDIF
			  mov ecx,numpics
			  mov ebx,pTERSEDATA
        mov (TERSEDATA PTR [ebx]).numbitmaps,ecx
			.ENDIF
			
;			mov f1stdataelement,0
;			.IF fyespics != 0
;			  ;use same code basically as above...
;			  mov esi,rpendactualold ;pendactualold may have got invalidated.
;			  mov rpnewowner,esi
;			  add esi,pTERSEDATA
;			  mov eax,(OBJECT PTR [esi]).nexttype
;			  .IF eax>=60 ;icon has range 60-69, pic icon is 63.
;			  .IF eax<=69
;			    mov eax,(OBJECT PTR [esi]).rpdata2
;				  .IF eax==0 ;no attached data element.
;				    mov (OBJECT PTR [esi]).nlibrary,0 ;precaution.
;				  .ELSE
;				    inc numpics
;				    mov ecx,numpics
;				    mov (OBJECT PTR [esi]).nlibrary,ecx ;pic# in library.
;				    mov f1stdataelement,1
;				    jmp SHORT nxz1
;nxt1z:		  mov eax,(OBJECT PTR [esi]).rpdata ;chained data elements.
;				    mov rpdatae,eax
;				    .IF eax==0 ;no attached data-element.
;				    .ELSE
;nxz1:		      mov esi,rpnewowner  ;parent.
;              mov rpprevowner,esi ;save relative ptr for below.
;				      add esi,pTERSEDATA
;				      add eax,pTERSEDATA ;abs addr of the old data.
;				        mov ecx,(OBJECT PTR [esi]).rpdata ;parent ptr to data.
;				        mov rpdatasave0,ecx
;				      invoke duplicatedataelement,esi,eax,1 ;pnewowner,polddata,1=end ofdbase
;				      ;...creates a data-element, copies contents from olddata,
;				      ; changes .rpdata to new data-element.
;				      ;(note, this does not go into highlightednewlist).
;				      ;returns ptr to new element.
;				      or eax,eax ;cmp eax,0 ;fail
;				      je f77
;				      sub eax,pTERSEDATA ;new element.
;				      mov rpnewowner,eax
;				        mov esi,rpprevowner
;				        add esi,pTERSEDATA
;				        mov ecx,(OBJECT PTR [esi]).rpdata
;				        .IF f1stdataelement != 0 ;icon.rpdata2 ->1st pic data element.
;				          mov (OBJECT PTR [esi]).rpdata2,ecx
;				          mov ecx,rpdatasave0
;				          mov (OBJECT PTR [esi]).rpdata,ecx ;restore previous.
;				          ;also, the 1st pic data element must have no owner...
;				          mov ebx,rpnewowner
;				          add ebx,pTERSEDATA
;				          mov (OBJECT PTR [ebx]).rpowner1,0
;				          mov (OBJECT PTR [ebx]).ximage,0 ;handle of bitmap.
;				          mov f1stdataelement,0
;				        .ENDIF
;				      mov esi,rpdatae
;              add esi,pTERSEDATA ;old data element.
;              jmp nxt1z ;copy next data element in chain.
;				    .ENDIF
;				  .ENDIF
;				.ENDIF
;				.ENDIF
;				mov ecx,numpics
;				mov ebx,pTERSEDATA
;        mov (TERSEDATA PTR [ebx]).numbitmaps,ecx
;			.ENDIF


xend3:
		mov ebx,ebxsave
		add ebx,4
		jmp xend2
xend1:


;convert all entries in highlighted list back to absolute pointers...
		mov ebx,0
dend2:
		lea esi,highlightedlist 	;start of highlighted list.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je dend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je dend3
		  ;drop here, edi->element from highlighted list...
		  add edi,pTERSEDATA
		  mov [esi+ebx],edi ;now pointer is absolute.
dend3:
		mov ebx,ebxsave
		add ebx,4
		jmp dend2
dend1:

;convert all entries in highlightednewlist back to absolute pointers...
		mov ebx,0
fend2:
		lea esi,highlightednewlist		;start of highlightednewlist.
		mov ebxsave,ebx
		mov eax,highlightedindexnewlist 		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je fend3
		  ;drop here, edi->element from highlighted list...
		  add edi,pTERSEDATA
		  mov [esi+ebx],edi ;now pointer is absolute.

				;this func also used for duplicating a library object, which
				;has .nexttype bits15-31 =1. clr these, so can see object...
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF SWORD PTR ax<0 ;bit15=1
					;v1.41
					;err, this catches *all* invisible elements. more specifically,
					;library-obj elements have bit14=0, so test that...
					test ax,4000h ;bit14
					jnz fend3
					;(...worked without this extra check, cos dataelements never got
					; into the list anyway).
				  and (OBJECT PTR [edi]).nexttype,00007FFFh ;
				  ;place library obj in middle of window...
				  mov eax,(OBJECT PTR [edi]).fconfig1
				  and al,01
				  .IF al==0 ;non-wire-type.
						mov eax,(OBJECT PTR [edi]).nexttype
						.IF ax==5 ;polygon
								;v1.11 has 5 more vertices...
								mov eax,g_xdiagdelta
								mov ebx,g_ydiagdelta
								add (OBJECT PTR [edi]).bez9x,eax
								add (OBJECT PTR [edi]).bez10x,eax
								add (OBJECT PTR [edi]).bez11x,eax
								add (OBJECT PTR [edi]).bez12x,eax
								add (OBJECT PTR [edi]).bez13x,eax
								add (OBJECT PTR [edi]).bez9y,ebx
								add (OBJECT PTR [edi]).bez10y,ebx
								add (OBJECT PTR [edi]).bez11y,ebx
								add (OBJECT PTR [edi]).bez12y,ebx
								add (OBJECT PTR [edi]).bez13y,ebx
s11:			  mov eax,g_xdiagdelta
						  mov ebx,g_ydiagdelta
						  add (OBJECT PTR [edi]).bez0x,eax
						  add (OBJECT PTR [edi]).bez0y,ebx
						  add (OBJECT PTR [edi]).bez1x,eax
						  add (OBJECT PTR [edi]).bez1y,ebx
						  add (OBJECT PTR [edi]).bez2x,eax
						  add (OBJECT PTR [edi]).bez2y,ebx
						  add (OBJECT PTR [edi]).bez3x,eax
						  add (OBJECT PTR [edi]).bez3y,ebx
						  add (OBJECT PTR [edi]).bez4x,eax
						  add (OBJECT PTR [edi]).bez4y,ebx
						  add (OBJECT PTR [edi]).bez5x,eax
						  add (OBJECT PTR [edi]).bez5y,ebx
						  add (OBJECT PTR [edi]).bez6x,eax
						  add (OBJECT PTR [edi]).bez6y,ebx
						  add (OBJECT PTR [edi]).bez7x,eax
						  add (OBJECT PTR [edi]).bez7y,ebx
						  add (OBJECT PTR [edi]).bez8x,eax
						  add (OBJECT PTR [edi]).bez8y,ebx
						.ELSE
						  mov eax,g_xdiagdelta
						  add (OBJECT PTR [edi]).xtopleft,eax
						  add (OBJECT PTR [edi]).xmid,eax
						  mov eax,g_ydiagdelta
						  add (OBJECT PTR [edi]).ytopleft,eax
						  add (OBJECT PTR [edi]).ymid,eax
						.ENDIF
				  .ELSE
						jmp s11
				  .ENDIF
				.ENDIF

fend3:
		mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:


;........
;updating pointers inside each duplicated element is a problem.
;we have the old list in "highlightedlist" and the duplicated list
;in "highlightednewlist".
;for each pointer-field in a duplicated element, see if it points
;to an element in "highlightedlist" -- if not, erase new element.
;--if yes, lookup matching entry in "highlightednewlist" and load
;new value into pointer-field.

;outer loop, go thru highlightednewlist...
		mov ebx,0
zend2:
		lea esi,highlightednewlist		;start of highlightednewlist.
		mov ebxsave,ebx
		mov eax,highlightedindexnewlist 		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je zend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je zend3
		;drop here, edi->element from highlightednewlist...
		mov pnew,edi

		  ;inner loop, for each pointer-field of duplicated element, search
		  ;old highlighted list...


		  ;**CRASH!!!**
		  ;CANNOT CREATE A DATA-ELEMENT HERE, AS ReAlloc() may invalidate
		  ;the pointers!!! (do it above)
		  ;WARNING, ZEROISING THIS...

		  ;update .rpowner1...
		  mov edi,pnew
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax != 0
				add eax,pTERSEDATA
				mov plock1,eax
				mov ebx,0
vend2:	lea esi,highlightedlist ;start of highlighted list.
				mov ebxsave2,ebx
				mov eax,highlightedindex				;end of list.
				shl eax,1
				shl eax,1
				cmp ebx,eax
				je vend1						;get out.
				mov edi,[esi+ebx]
				or edi,edi ;cmp edi,0										;precaution.
				je vend3
				;drop here, edi->element from highlighted list...
				  .IF edi==plock1
						;now get matching element from highlightednewlist...
						lea esi,highlightednewlist
						mov eax,[esi+ebx]
						sub eax,pTERSEDATA
						mov esi,pnew
						mov (OBJECT PTR [esi]).rpowner1,eax
						jmp vend7
				  .ENDIF
vend3:	mov ebx,ebxsave2
				add ebx,4
				jmp vend2
vend1:	;failed to find parent element in highlighted list, so delete...

				;if we are trying to duplicate an element that is attached to
				;something outside group being duplicated, i don't think we
				;have to delete it... just remove the attachment...
				mov edi,pnew
				mov (OBJECT PTR [edi]).rpowner1 ,0

vend7:
		  .ENDIF

		  ;update .rpowner2...
		  mov edi,pnew
		  mov eax,(OBJECT PTR [edi]).rpowner2  ;(used by wires, 2nd end).
		  .IF eax != 0
				add eax,pTERSEDATA
				mov plock2,eax
				  ;icons use rpowner2 (rpdata2) to point to an embedded bitmap.
				  ;leave alone...
				  mov eax,(OBJECT PTR [edi]).nexttype
				  .IF ax>=60
						.IF ax<=69
						  jmp x00
						.ENDIF
				  .ENDIF
				mov ebx,0
wend2:	lea esi,highlightedlist ;start of highlighted list.
				mov ebxsave2,ebx
				mov eax,highlightedindex				;end of list.
				shl eax,1
				shl eax,1
				cmp ebx,eax
				je wend1						;get out.
				mov edi,[esi+ebx]
				or edi,edi ;cmp edi,0										;precaution.
				je wend3
				;drop here, edi->element from highlighted list...
				  .IF edi==plock2
						;now get matching element from highlightednewlist...
						lea esi,highlightednewlist
						mov eax,[esi+ebx]
						sub eax,pTERSEDATA
						mov esi,pnew
						mov (OBJECT PTR [esi]).rpowner2,eax
						jmp wend7
				  .ENDIF
wend3:	mov ebx,ebxsave2
				add ebx,4
				jmp wend2
wend1:	;failed to find parent element in highlighted list, so delete...
				mov edi,pnew
;				 mov (OBJECT PTR [edi]).fstatus,0
				;if we are trying to duplicate an element that is attached to
				;something outside group being duplicated, i don't think we
				;have to delete it... just remove the attachment...
				mov (OBJECT PTR [edi]).rpowner2,0
wend7:
		  .ENDIF
x00:

				;update .number...
				mov esi,pnew
						mov ebx,pTERSEDATA
;						lea ecx,(TERSEDATA PTR [ebx]).OBJECTS ;start of objects database.
						  mov ecx,(TERSEDATA PTR [ebx]).noffsetobjs
						  add ecx,ebx ;pTERSEDATA ;starting address of OBJECTS.
						mov eax,esi
						sub eax,ecx
						xor edx,edx
						;xor ecx,ecx
						mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
						div ecx
						;eax now has correct number of element...
						mov (OBJECT PTR [esi]).number,eax

zend3:
		mov ebx,ebxsave
		add ebx,4
		jmp zend2
zend1:


;.......
;clear any invalid pointers...
			invoke zeroabsoluteptrs,0
			mov wipeoutsindex,0
			mov updatesindex,0

;don't need highlighted list anymore...
			mov g_fclrhighlighted,1
			mov highlightedindex,0
			;...the flag set will cause paint_*() to clr .fconfig2/bit7,
			;removing any highlighting. the index removes list of
			;highlighted objects.
;										 push eax						  ;save previous value of state.
;										 mov al,g_nstate		  ;/
;										 mov g_nstateprev,al  ;/
;										 pop eax						  ;/
;		 mov g_nstate,0


;exit from this routine with highlightednewlist pointing to
;all of the duplicated elements.
;suggest that their coords track the mouse until a left-click.
;wmmousemove() will perform the tracking...
		mov nmxold,0			;used in wmmousemove()
		mov nmyold,0			;/


		mov eax,numobjectsprev
exit1:
    mov g_fnoresize,0		;v3.55
		ret
duplicatehighlighted ENDP
;--------------------------------------------------------------------------
duplicatedataelement PROC STDCALL USES ebx ecx edx edi esi, \
		pnewowner:DWORD,polddataelement:DWORD,fend:DWORD
		LOCAL pnew:DWORD, esizeobject:DWORD
; "duplicatedataelement" *EVE*
;called from duplicatehighlighted().
;polddataelement is an existing data element,pnewowner is the new owner.
;fend=1 new data element to be at end of database.
;copy the element, return ptr to new element in eax
;else 0 if fail. leave original data element intact.

		;a problem...
		;when create a new object, it may be appended at end of database,
		;which may invalidate the pointers.
		;createnewobject() corrects pTERSEDATA.
		;so, beforehand, convert pointers to relative...
		mov eax,pTERSEDATA
		sub pnewowner,eax
		sub polddataelement,eax

		invoke createnewobject,fend ;fend=1 new object at end of database.
		;...note, v3.55, duplicatehighlighted() now sets g_fnoresize=1 and createnewobject()
		;won't resize the database.
		mov pnew,eax
		.IF eax==0		;failed.
		  mov eax,pTERSEDATA
		  add pnewowner,eax
		  mov edi,pnewowner
		  mov (OBJECT PTR [edi]).rpdata,0
		  xor eax,eax	 ;note, on return, we exit EVE, above code not necessary.
		  ret
		.ENDIF

		;now restore the pointers...
		mov eax,pTERSEDATA
		add pnewowner,eax
		add polddataelement,eax

		  ;copy element to new position....
		  mov esi,polddataelement
		  mov edi,pnew
		  mov ebx,pTERSEDATA
		  ;xor ecx,ecx
		  mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
p11:  mov al,[esi]
		  mov [edi],al
		  inc esi
		  inc edi
		  loop p11

		mov edi,pnew
		mov eax,pnewowner
		sub eax,pTERSEDATA
		mov (OBJECT PTR [edi]).rpowner1,eax
		mov (OBJECT PTR [edi]).rpowner2,0
;		 mov (OBJECT PTR [edi]).ximage,0
		mov edi,pnewowner
		mov eax,pnew
		sub eax,pTERSEDATA
		mov (OBJECT PTR [edi]).rpdata,eax
		mov eax,pnew
		ret
duplicatedataelement ENDP
;--------------------------------------------------------------------------
calcrealsizehighlighted PROC STDCALL USES ebx ecx edx esi edi
  LOCAL ebxsave:DWORD
  LOCAL rporiginal:DWORD
  LOCAL cntrecords:DWORD
; "calcrealsizehighlighted"
;the elements in highlighted list can have attached data elements. find total.
;note that the entries are relative pointers (temporarily, in duplicatehighlighted())
;returns eax=total number of records that will be duplicated/copied.

  mov cntrecords,0
;go thru every element in highlighted list, copy to end database...
  mov ebx,0
xend2:
  lea esi,highlightedlist 	;start of highlighted list.
  mov ebxsave,ebx
  mov eax,highlightedindex		;end of list.
  shl eax,1
  shl eax,1
  cmp ebx,eax
  je xend1				;get out.
  mov edi,[esi+ebx]
  or edi,edi ;cmp edi,0								;precaution.
  je xend3
    ;drop here, edi->element from highlighted list...
    mov rporiginal,edi
    add edi,pTERSEDATA
    inc cntrecords

    mov ebx,(OBJECT PTR [edi]).rpdata
    .if ebx != 0
fnd1: inc cntrecords
      add ebx,pTERSEDATA
      ;need to find out how many records are in the data-element chain...
      mov eax,(OBJECT PTR [ebx]).rpdata
      .IF eax != 0
        mov ebx,eax
        jmp fnd1
      .ENDIF
    .ENDIF

    ;some elements can have a picture attached to .rpdata2...
    mov eax,(OBJECT PTR [edi]).nexttype
    .IF eax>=60 ;icon has range 60-69, pic icon is 63.
      .IF eax<=69
        mov ebx,(OBJECT PTR [edi]).rpdata2
        .IF ebx != 0
fnd2:     inc cntrecords
          add ebx,pTERSEDATA
          ;need to find out how many records are in the data-element chain...
          mov eax,(OBJECT PTR [ebx]).rpdata
          .IF eax != 0
            mov ebx,eax
            jmp fnd2
          .ENDIF
        .ENDIF
      .ENDIF
    .ENDIF


xend3:
  mov ebx,ebxsave
  add ebx,4
  jmp xend2
xend1:

  mov eax,cntrecords
  ret
calcrealsizehighlighted ENDP
;--------------------------------------------------------------------------
updateduplicates PROC STDCALL USES ebx ecx edx esi edi
		LOCAL ebxsave:DWORD
		LOCAL deltaxt:SDWORD,deltayt:SDWORD
; "updateduplicates"
;from wmmousemove() if highlightedindexnewlist non-0.
;new duplicated elements were created by duplicatehighlighted().
;we have global deltax/deltay, change in mouse position, to
;allow new elements to track the mouse...

		;v1.40 (see also updatemove() below).
		;deltax/y are mouse change. optional need to get "snap" action in drag...
		;(most important that no bits get lost, so elements don't fall behind mouse)
		mov eax,deltax	;global variable.
		add xaccum,eax	;accumulate the changes.
		mov eax,xaccum	;global variable. clrd at start.
		.IF SDWORD PTR eax>=0
		  mov ebx,eax
		  and al,fdragmask ;bits to chop off bottom of change.
		  mov deltaxt,eax  ;actual change to occur.
		  sub ebx,eax	   ;these are the bits that got dropped.
		  mov xaccum,ebx   ;save them for next time.
		.ELSE
		  neg eax
		  mov ebx,eax
		  and al,fdragmask
		  sub ebx,eax
		  neg ebx
		  mov xaccum,ebx
		  neg eax
		  mov deltaxt,eax
		.ENDIF
		;ditto for y-change...
		mov eax,deltay	;global variable.
		add yaccum,eax	;accumulate the changes.
		mov eax,yaccum	;global variable. clrd at start.
		.IF SDWORD PTR eax>=0
		  mov ebx,eax
		  and al,fdragmask ;bits to chop off bottom of change.
		  mov deltayt,eax  ;actual change to occur.
		  sub ebx,eax	   ;these are the bits that got dropped.
		  mov yaccum,ebx   ;save them for next time.
		.ELSE
		  neg eax
		  mov ebx,eax
		  and al,fdragmask
		  sub ebx,eax
		  neg ebx
		  mov yaccum,ebx
		  neg eax
		  mov deltayt,eax
		.ENDIF

		mov ebx,0
fend2:
		lea esi,highlightednewlist		;start of highlightednewlist.
		mov ebxsave,ebx
		mov eax,highlightedindexnewlist 		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je fend3
		  ;drop here, edi->element from highlighted list...
		  mov eax,(OBJECT PTR [edi]).fconfig1
		  and al,01
		  .IF al==01			;wire-type.

d11:	  mov eax,deltaxt
				  mov ebx,deltayt
				  add (OBJECT PTR [edi]).bez0x,eax
				  add (OBJECT PTR [edi]).bez0y,ebx
				  add (OBJECT PTR [edi]).bez1x,eax
				  add (OBJECT PTR [edi]).bez1y,ebx
				  add (OBJECT PTR [edi]).bez2x,eax
				  add (OBJECT PTR [edi]).bez2y,ebx
				  add (OBJECT PTR [edi]).bez3x,eax
				  add (OBJECT PTR [edi]).bez3y,ebx
				  add (OBJECT PTR [edi]).bez4x,eax
				  add (OBJECT PTR [edi]).bez4y,ebx
				  add (OBJECT PTR [edi]).bez5x,eax
				  add (OBJECT PTR [edi]).bez5y,ebx
				  add (OBJECT PTR [edi]).bez6x,eax
				  add (OBJECT PTR [edi]).bez6y,ebx
				  add (OBJECT PTR [edi]).bez7x,eax
				  add (OBJECT PTR [edi]).bez7y,ebx
				  add (OBJECT PTR [edi]).bez8x,eax
				  add (OBJECT PTR [edi]).bez8y,ebx
		  .ELSE
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF ax==5 ;polygon
								;v1.11 has 5 more vertices...
								mov eax,deltaxt
								mov ebx,deltayt
								add (OBJECT PTR [edi]).bez9x,eax
								add (OBJECT PTR [edi]).bez10x,eax
								add (OBJECT PTR [edi]).bez11x,eax
								add (OBJECT PTR [edi]).bez12x,eax
								add (OBJECT PTR [edi]).bez13x,eax
								add (OBJECT PTR [edi]).bez9y,ebx
								add (OBJECT PTR [edi]).bez10y,ebx
								add (OBJECT PTR [edi]).bez11y,ebx
								add (OBJECT PTR [edi]).bez12y,ebx
								add (OBJECT PTR [edi]).bez13y,ebx
				  jmp d11
				.ELSE
				  mov eax,deltaxt
				  add (OBJECT PTR [edi]).xtopleft,eax
				  add (OBJECT PTR [edi]).xmid,eax
				  mov eax,deltayt
				  add (OBJECT PTR [edi]).ytopleft,eax
				  add (OBJECT PTR [edi]).ymid,eax
				.ENDIF
		  .ENDIF
fend3:
		mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:


		ret
updateduplicates ENDP
;--------------------------------------------------------------------------
updatemove PROC STDCALL USES ebx ecx edx esi edi
		LOCAL ebxsave:DWORD
		LOCAL deltaxt:SDWORD,deltayt:SDWORD
; "updatemove"
;from wmmousemove() if fmovinghighlighted non-0.
;we have global deltax/deltay, change in mouse position, to
;allow elements to track the mouse...

;a problem. don't change wire-end coords if attached to a element
;not in highlighted list.

		;v1.40 (see also updateduplicates() above).
		;deltax/y are mouse change. optional need to get "snap" action in drag...
		;(most important that no bits get lost, so elements don't fall behind mouse)
		mov eax,deltax
		add xaccum,eax	;accumulate the changes.
		mov eax,xaccum	;xaccum is global variable. clrd at start.
		.IF SDWORD PTR eax>=0
		  mov ebx,eax
		  and al,fdragmask ;bits to chop off bottom of change.
		  mov deltaxt,eax  ;actual change to occur.
		  sub ebx,eax	   ;these are the bits that got dropped.
		  mov xaccum,ebx   ;save them for next time.
		.ELSE
		  neg eax
		  mov ebx,eax
		  and al,fdragmask
		  sub ebx,eax
		  neg ebx
		  mov xaccum,ebx
		  neg eax
		  mov deltaxt,eax
		.ENDIF
		;ditto for y-change...
		mov eax,deltay	;global variable.
		add yaccum,eax	;accumulate the changes.
		mov eax,yaccum	;global variable. clrd at start.
		.IF SDWORD PTR eax>=0
		  mov ebx,eax
		  and al,fdragmask ;bits to chop off bottom of change.
		  mov deltayt,eax  ;actual change to occur.
		  sub ebx,eax	   ;these are the bits that got dropped.
		  mov yaccum,ebx   ;save them for next time.
		.ELSE
		  neg eax
		  mov ebx,eax
		  and al,fdragmask
		  sub ebx,eax
		  neg ebx
		  mov yaccum,ebx
		  neg eax
		  mov deltayt,eax
		.ENDIF

		mov ebx,0
fend2:
		lea esi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je fend3
		;another precaution, have a data-element in the list (which shouldn't
		;happen)...
		mov eax,(OBJECT PTR [edi]).nexttype
;		 cmp ax,-1
;		 je fend3
		.IF SWORD PTR ax<0
		  ;invisible element.
		  jmp fend3
		.ENDIF
		  ;drop here, edi->element from highlighted list...
		  mov eax,(OBJECT PTR [edi]).fconfig1
		  and al,01
		  .IF al==0 ;non-wire-type.
				mov eax,(OBJECT PTR [edi]).nexttype
				.IF ax==5 ;polygon
				  mov eax,deltaxt
				  mov ebx,deltayt
				  add (OBJECT PTR [edi]).bez0x,eax
				  add (OBJECT PTR [edi]).bez0y,ebx
				  add (OBJECT PTR [edi]).bez1x,eax
				  add (OBJECT PTR [edi]).bez1y,ebx
				  add (OBJECT PTR [edi]).bez2x,eax
				  add (OBJECT PTR [edi]).bez2y,ebx
				  add (OBJECT PTR [edi]).bez3x,eax
				  add (OBJECT PTR [edi]).bez3y,ebx
				  add (OBJECT PTR [edi]).bez4x,eax
				  add (OBJECT PTR [edi]).bez4y,ebx
				  add (OBJECT PTR [edi]).bez5x,eax
				  add (OBJECT PTR [edi]).bez5y,ebx
				  add (OBJECT PTR [edi]).bez6x,eax
				  add (OBJECT PTR [edi]).bez6y,ebx
				  add (OBJECT PTR [edi]).bez7x,eax
				  add (OBJECT PTR [edi]).bez7y,ebx
				  add (OBJECT PTR [edi]).bez8x,eax
				  add (OBJECT PTR [edi]).bez8y,ebx
								;v1.11 has 5 more vertices...
								add (OBJECT PTR [edi]).bez9x,eax
								add (OBJECT PTR [edi]).bez10x,eax
								add (OBJECT PTR [edi]).bez11x,eax
								add (OBJECT PTR [edi]).bez12x,eax
								add (OBJECT PTR [edi]).bez13x,eax
								add (OBJECT PTR [edi]).bez9y,ebx
								add (OBJECT PTR [edi]).bez10y,ebx
								add (OBJECT PTR [edi]).bez11y,ebx
								add (OBJECT PTR [edi]).bez12y,ebx
								add (OBJECT PTR [edi]).bez13y,ebx
				.ELSE
				  mov eax,deltaxt
				  add (OBJECT PTR [edi]).xtopleft,eax
				  add (OBJECT PTR [edi]).xmid,eax
				  mov eax,deltayt
				  add (OBJECT PTR [edi]).ytopleft,eax
				  add (OBJECT PTR [edi]).ymid,eax
				.ENDIF
		  .ELSE
				;for wires, have to consider if ends are attached outside...
				mov eax,(OBJECT PTR [edi]).rpowner1
				  ;if not attched to anything, ok to move...
				  or eax,eax ;cmp eax,0
				  je t33
				add eax,pTERSEDATA
				invoke ishighlighted, eax ;return eax=TRUE if begin-end inside.
				.IF eax==TRUE
				  mov eax,(OBJECT PTR [edi]).rpowner2
t33:			;if not attched, ok to move...
						or eax,eax ;cmp eax,0
						je p11 ;move it!
				  add eax,pTERSEDATA
				  invoke ishighlighted, eax ;return eax=TRUE if dest-end inside.
				  .IF eax==TRUE
						;both ends inside...
p11:			mov eax,deltaxt
						add (OBJECT PTR [edi]).xtopleft,eax
						add (OBJECT PTR [edi]).xmid,eax
						add (OBJECT PTR [edi]).wwidth,eax
						add (OBJECT PTR [edi]).xknee2,eax
						add (OBJECT PTR [edi]).xknee3,eax
						mov eax,deltayt
						add (OBJECT PTR [edi]).ytopleft,eax
						add (OBJECT PTR [edi]).ymid,eax
						add (OBJECT PTR [edi]).height,eax
						add (OBJECT PTR [edi]).yknee2,eax
						add (OBJECT PTR [edi]).yknee3,eax
				  .ELSE
						;begin-end only inside...
						mov eax,deltaxt
						add (OBJECT PTR [edi]).xtopleft,eax
						add (OBJECT PTR [edi]).xknee2,eax
						mov eax,deltayt
						add (OBJECT PTR [edi]).ytopleft,eax
						add (OBJECT PTR [edi]).yknee2,eax
				  .ENDIF
				.ELSE
				  mov eax,(OBJECT PTR [edi]).rpowner2
						or eax,eax ;cmp eax,0 ;free end?
						je p44
				  add eax,pTERSEDATA
				  invoke ishighlighted, eax ;return eax=TRUE if begin-end inside.
				  .IF eax==TRUE
						;dest-end only inside...
p44:			mov eax,deltaxt
						add (OBJECT PTR [edi]).wwidth,eax
						add (OBJECT PTR [edi]).xknee3,eax
						mov eax,deltayt
						add (OBJECT PTR [edi]).height,eax
						add (OBJECT PTR [edi]).yknee3,eax
				  .ELSE
						;nothing inside...
				  .ENDIF
				.ENDIF
		  .ENDIF
fend3:
		mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:


		ret
updatemove ENDP
;--------------------------------------------------------------------------
deleteelements PROC STDCALL USES ebx ecx edx esi edi
		LOCAL ebxsave:DWORD
; "deleteelements"
;control/delete elements -> idm_dels.
;also findcomposite() calls here.

		mov ebx,0
fend2:
		lea esi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je fend3
		  ;drop here, edi->element from highlighted list...
		  ;mov (OBJECT PTR [edi]).fstatus,0 *NO*...
				;what if it has an attached data-element?
				;what about child elements? do this...
						  mov  ebx,(OBJECT PTR [edi]).rpmethods
						  invoke deletePTR PTR [ebx+ptrs+pdelete], edi ;delete the object.

fend3:
		mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:

  mov highlightedindex,0 ;v3.05 bug fix.
  
		ret
deleteelements ENDP
;--------------------------------------------------------------------------
ishighlighted PROC STDCALL USES ebx ecx edx esi edi, pelement
		LOCAL ebxsave:DWORD
; "ishighlighted"
;called from updatemove()
;return TRUE if pelement is in highlighted list.

		mov ebx,0
fend2:
		lea esi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov edi,[esi+ebx]
		or edi,edi ;cmp edi,0								;precaution.
		je fend3
		  ;drop here, edi->element from highlighted list...
		  .IF edi==pelement
				mov eax,TRUE
				ret
		  .ENDIF
fend3:
		mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
		mov eax,FALSE
		ret
ishighlighted ENDP
;--------------------------------------------------------------------------
;***MOVED TO EVE_C.C*** <<<BROUGHT IT BACK AGAIN!
highlightinsiderect PROC STDCALL USES ebx ecx edx esi edi
		LOCAL xadiff:DWORD,yadiff:DWORD
		LOCAL ecxsave:DWORD,esisave:DWORD,edisave:DWORD
		LOCAL xleft:DWORD,xright:DWORD,ytop:DWORD,ybot:DWORD
; "highlightinsiderect"
;"control/selection rectangle" -->IDM_RECT-->g_nstate=20
; -->wmlbuttondown, set 1st corner, g_nstate=21
; -->wmmousemove,track 2nd corner,g_nstate=22
; -->wmlbuttonup, set 2nd corner, call highlightinsiderect().
; n1stx,n1sty=1st corner, n2ndx,n2ndy=2nd corner.

		;find which corner is top-left, which bot-right...
		mov eax,n1stx
		mov ebx,n2ndx
		.IF SDWORD PTR eax<ebx
		  mov xleft,eax
		  mov eax,n2ndx
		  mov xright,eax
		.ELSE
		  mov xright,eax
		  mov eax,n2ndx
		  mov xleft,eax
		.ENDIF
		mov eax,n1sty
		mov ebx,n2ndy
		.IF SDWORD PTR eax<ebx
		  mov ytop,eax
		  mov eax,n2ndy
		  mov ybot,eax
		.ELSE
		  mov ybot,eax
		  mov eax,n2ndy
		  mov ytop,eax
		.ENDIF
		mov eax,xright
		sub eax,xleft
		mov xadiff,eax	 ;always +ve.
		mov eax,ybot
		sub eax,ytop
		mov yadiff,eax	 ;always +ve.

				mov edi,pTERSEDATA
;				lea esi,(TERSEDATA PTR [edi]).OBJECTS	;starting addr of OBJECTS
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				;xor eax,eax
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF SWORD PTR ax<0 ;ax==-1
						  ;invisible element.
						.ELSE							;not a data object.
						  ;is it inside rectangle?...

						  .IF ax==5 ;polygon or polyline.
								mov eax,(OBJECT PTR [esi]).bez0x   ;1st vertice.
								mov edx,(OBJECT PTR [esi]).bez0y
						  .ELSE
								mov eax,(OBJECT PTR [esi]).xmid
								mov edx,(OBJECT PTR [esi]).ymid
						  .ENDIF
						  mov ecx,xleft
						  .IF SDWORD PTR eax>ecx		;in left side?
								mov ecx,xright
								.IF SDWORD PTR eax<ecx ;in right side?
								  mov ecx,ytop
								  .IF SDWORD PTR edx>ecx				;in top side?
										mov ecx,ybot
										.IF SDWORD PTR edx<ecx
										  ;success! object is inside rectangle.
										  or (OBJECT PTR [esi]).fconfig2,10000000b ;set bit7.
										  invoke add2highlightedlist,esi
										.ENDIF
								  .ENDIF
								.ENDIF
						  .ENDIF

						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
;				xor eax,eax
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		  loop kf3 ;nextobj
		  jmp SHORT kf4
kf3:  jmp nextobj
kf4:

		mov n1stx,0
		mov n1sty,0
		mov n2ndx,0
		mov n2ndy,0
		ret
highlightinsiderect ENDP
;------------------------------------------------------------------------
move1object PROC STDCALL USES ebx ecx edx edi esi,pelement:DWORD,fwhere:DWORD
		LOCAL pnew:DWORD, esizeobject:DWORD,pfirst:DWORD,plast:DWORD
		LOCAL fwhereactual:DWORD
; "move1object"
;element dialog box -> bring to front (end of database), or send to back (beginning).
;relocate the element to beginning or end of database.
;fwhere=0 find closest empty record to start of database,
;	   =1 move to end of database,
;	   =2 move to record #1 (leave #0 reserved data element), shift entire database.
;return pnew.

		;v1.60
		mov fsaving,18 ;non0 prevent xtimer() from animating.
		invoke add2anilist,0 ;wipeout ptrs in list.


		;v1.25
		;when move element to start of database, I want it to really be at start.
		;remember, element# 0 is a dummy data element and mustn't be touched.
		.IF fwhere==2 ;move to start, record #1.
		  mov esi,pelement
		  sub esi,pTERSEDATA
		  invoke createnewobject,1 ;at end
		  add esi,pTERSEDATA
		  mov pelement,esi
		  .IF eax != 0 ;success.
			mov edi,eax
			mov plast,eax
			mov (OBJECT PTR [edi]).fstatus,0 ;invalidate it.
				;now, copy every element one record toward end...
				mov ebx,pTERSEDATA
				mov esi,(TERSEDATA PTR [ebx]).noffsetobjs
				add esi,ebx ;pTERSEDATA ;starting address of OBJECTS.
				mov pfirst,esi
				mov ecx,(TERSEDATA PTR [ebx]).numrecords
				dec ecx ;cos we use last record to copy into.
				dec ecx ;v1.60 i think we are copying record#0 also. leave it out.
				mov eax,(TERSEDATA PTR [ebx]).nsizeobject
				mov esizeobject,eax
				mov esi,plast
m01:			  mov edi,esi	  ;addr of element to be copied into from previous.
				  mov ebx,esi
				  sub ebx,esizeobject ;addr of previous element.
				  push ecx
					mov ecx,esizeobject
					  ;update all pointers in the element...
						mov eax,(OBJECT PTR [ebx]).rpdata
						.IF eax != 0
						  add (OBJECT PTR [ebx]).rpdata,ecx
						.ENDIF
						mov eax,(OBJECT PTR [ebx]).rpowner1
						.IF eax != 0
						  add (OBJECT PTR [ebx]).rpowner1,ecx
						.ENDIF
						  mov eax,(OBJECT PTR [ebx]).nexttype
						  and eax,0FFFFC000h ;dataelements.
						  .IF eax==0FFFFC000h
							;data elements do NOT use .rpowner2 as a pointer.
							;also, .number is part of the text string.
							;note .nextype of dataelements guaranteed to have bits14-31
							;set, and can have more. ex: FFFFE000h, or -1, so
							;above test gets them all
						  .ELSE
							mov eax,(OBJECT PTR [ebx]).rpowner2
							.IF eax != 0
							  add (OBJECT PTR [ebx]).rpowner2,ecx
							.ENDIF
							;inc (OBJECT PTR [ebx]).number
							;...not necessary, cos checkintegrity() below will set it.
						  .ENDIF
m02:				  mov al,[ebx]	;copy record 1-record further.
					  mov [edi],al
					  inc edi
					  inc ebx
					  loop m02
				  pop ecx
				  sub esi,esizeobject
				  loop m01
			;invalidate the *second* record.... (element #1)...
				mov esi,pfirst
				add esi,esizeobject
				;mov (OBJECT PTR [esi]).number,1 ;cos 1st element# got incremented above.  v1.60
				mov (OBJECT PTR [esi]).fstatus,0
			;pelement is now wrong, as have shifted all elements by 1 record...
			mov eax,esizeobject
			add pelement,eax
		  .ENDIF
		.ENDIF

		mov eax,fwhere
		mov fwhereactual,eax
		.IF eax==2
		  mov fwhere,0 ;below code is as per v1.24-
		.ENDIF
		;...if fwhere=2, then have shifted entire database, to free record#1.
		;pelement can now be moved into it...

		  ;v1.23 ptrs may get invalidated...
		  mov esi,pelement
		  sub esi,pTERSEDATA
		invoke createnewobject,fwhere ;fwhere=1 new object at end of database.
		  ;=0 closest to start of database.
		  add esi,pTERSEDATA
		  mov pelement,esi
		mov pnew,eax
		.IF eax==0		;failed.
		.ELSE

		  ;v1.24
		  ;if tried to move to beginning but no space, createnewobject() creates
		  ;a new element at end of database. in that case, leave element where it is...
		  .IF fwhere==0 ;at beginning.
			  mov ebx,pnew
			  .IF ebx>pelement
			    mov (OBJECT PTR [ebx]).fstatus,0 ;delete new record.
			    mov eax,pelement
			    jmp out9
			  .ENDIF
		  .ENDIF

		  ;copy element to new position....
		  mov esi,pelement
		  mov edi,pnew
		  mov ebx,pTERSEDATA
		  ;xor ecx,ecx
		  mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
p11:  mov al,[esi]
		  mov [edi],al
		  inc esi
		  inc edi
		  loop p11

		  ;delete old element...
		  mov esi,pelement
		  mov (OBJECT PTR [esi]).fstatus,0


		  ;update any other element in database that points to this element...
				mov ebx,pTERSEDATA
				  mov esi,(TERSEDATA PTR [ebx]).noffsetobjs
				  add esi,ebx ;pTERSEDATA ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [ebx]).numrecords
				mov eax,(TERSEDATA PTR [ebx]).nsizeobject
				mov esizeobject,eax
				mov edi,pelement
				sub edi,pTERSEDATA ;make it relative ptr.
				mov ebx,pnew
				sub ebx,pTERSEDATA ;make relative.
zz:
				  mov eax,(OBJECT PTR [esi]).fstatus
				  and eax,01
				  .IF eax==0 ;invalid
				  .ELSE
						;esi->object being examined, edi->rel.old obj that was moved,
						;ebx->rel. newly located object...
						mov eax,(OBJECT PTR [esi]).rpdata
						.IF eax==edi
						  mov (OBJECT PTR [esi]).rpdata,ebx
						.ENDIF
						mov eax,(OBJECT PTR [esi]).rpowner1
						.IF eax==edi
						  mov (OBJECT PTR [esi]).rpowner1,ebx
						.ENDIF
						  ;exclude dataelements here, as .rpowner2 not a pointer...
						  mov eax,(OBJECT PTR [esi]).nexttype
						  and eax,0FFFFC000h ;dataelements can be this or -1.
						  .IF eax==0FFFFC000h
							;note .nextype of dataelements guaranteed to have bits14-31
							;set, and can have more. ex: FFFFE000h, or -1, so
							;above test gets them all
							;Note: .rpowner2 EQU .nshape EQU .rpdata2.
						  .ELSE
							  mov eax,(OBJECT PTR [esi]).rpowner2
							  .IF eax==edi
							    mov (OBJECT PTR [esi]).rpowner2,ebx
							  .ENDIF
						  .ENDIF
				  .ENDIF
				add  esi,esizeobject
				loop zz

;also clear all pointers...
			invoke zeroabsoluteptrs,1

		  invoke checkintegrity,1  ;suppress messages.
		  ;...will also fix .number of this new element's position in database.

		.ENDIF

		;v1.25
		;fwhereactual=2, have shifted all records by 1.
		.IF fwhereactual==2
		  ;got a bug... library-objects in the Elements menu have menu-id = .number+4000
		  ;of the dataelement attached to the object. however, .numbers have changed.
		  ;need to re-do the menu whenever database is shuffled....
		  ;like now: "move1object,pobj,2" shifts entire database by 1 record).
		  invoke addcomposites2menu,0
		.ENDIF


		mov eax,pnew ;new address.
out9:	mov fsaving,0
		ret
move1object ENDP
;--------------------------------------------------------------------------
;.DATA
;szerrormsg BYTE "Error number "
;szerrormsg2 BYTE "		  ",0Dh,0Ah
;				BYTE "Refer to the EVE User Manual "
;						BYTE "for a description. Note that numbers above "
;						BYTE "200 are of a very serious nature. Numbers below "
;						BYTE "100 are warnings only and you may keep working.",0
;szerrnogoo DB "The file you have tried to open does not have the correct "
;				DB "extension.",0				;error code =002
;szerhi1 		BYTE "You have got to highlight some elements first. "
;				BYTE "You highlight elements "
;				BYTE "from the menu ""Control/Selection rectangle"" or "
;				BYTE "manually by holding down the <shift> key and left-clicking "
;				BYTE "on elements, or simply press the left button on a blank spot "
;				BYTE "on the diagram and drag a selection rectangle.",0 ;error code =003, 004, 014
;szerrget DB "WARNING ONLY. You haven't opened a file. Keeping "
;				DB "previously-opened file. "
;        DB "(If extended error non-zero then this is a real error condition: "
;        DB "report to author and send file if possible)",0Dh,0Ah
;        DB "Extended error code: "
;szer005 DB "0           ",0         ;005
;szerrsave DB "WARNING ONLY. You haven't saved-as the file. Keeping "
;				DB "previously-opened file.",0	  ;006
;szerremf BYTE "WARNING ONLY. Selected save-as to .EMF/.WMF/.SVG file operation "
;				DB "not completed. "
;        DB "(If extended error non-zero then this is a real error condition: "
;        DB "report to author and send file if possible)",0Dh,0Ah
;        DB "Extended error code: "
;szer007 DB "0           ",0         ;007
;sznfinderr BYTE "Invalid or out-of-range element number.",0  ;015
;szer9501 BYTE "The current version of EVE treats an EVE diagram "
;				 BYTE "embedded inside an .EVE.EXE file as read-only. So, "
;				 BYTE "you cannot save. You will have to choose ""Save as..."" "
;				 BYTE "to save as a separate .EVE file, or ""Export as "
;				 BYTE "EMBEDDED..."" to create a new .EVE.EXE embedded file.",0
;szeriex  BYTE "EVE cannot find Microsoft Internet Explorer",0
;szerprn  BYTE "The printer is not working. Exit EVE, fix the printer or the "
;				 BYTE "printer driver, then restart EVE.",0
;szerstretch BYTE "Sorry, you will have to perform the operation again, starting "
;			 BYTE "with selection of elements to be manipulated.",0
;szerbezier	 BYTE "The total number of points for a Bezier polyline must be a "
;			 BYTE "multiple of 3, plus 1, including control-points.",0
;szer207 BYTE "The .EVE data file you have just opened has failed EVE's "
;        BYTE "integrity check. [1] Try reopening the file, or [2] Save-as to a "
;        BYTE "different name (EVE will run an integrity check and fixup when "
;        BYTE "saving). [3] If still gives this error message, kindly email the offending file to me "
;        BYTE "for examination.",0
;szerimgs BYTE "Sorry, the picture is too big. Reduce it to under 64K",0
;szer012  BYTE "You have not yet specified an external editor. Go to menu "
;         BYTE """Control/EVE preferences..."" to choose the editor.",0
;szer024  BYTE "Could not open external editor",0
;szer025  BYTE "Picture imported early version of EVE, cannot open external paint editor.",0
;szer026  BYTE "Bug when transferring file to EVE database. Please delete it (label/picture/etc).",0

;.CODE
;myerrorhandler PROC STDCALL USES eax ebx ecx edx esi edi,nerror:DWORD
;		LOCAL dummy:DWORD
;; "myerrorhandler"
;				mov eax,nerror
;		.IF eax==002
;		  lea ebx,szerrnogoo
;		.ELSEIF eax==003
;		  lea ebx,szerhi1
;		.ELSEIF eax==004
;		  lea ebx,szerhi1
;		.ELSEIF eax==005
;		  lea ebx,szerrget
;		.ELSEIF eax==006
;		  lea ebx,szerrsave
;		.ELSEIF eax==007
;		  lea ebx,szerremf
;		.ELSEIF eax==012
;		  lea ebx,szer012
;		.ELSEIF eax==014		  ;was szer21300
;		  lea ebx,szerhi1
;		.ELSEIF eax==015
;		  lea ebx,sznfinderr
;		.ELSEIF eax==016
;		  lea ebx,szer9501
;		.ELSEIF eax==017
;		  lea ebx,szeriex
;		.ELSEIF eax==020
;		  lea ebx,szerprn
;;		 .ELSEIF eax==021
;;		   lea ebx,szerstretch
;		.ELSEIF eax==022
;		  lea ebx,szerbezier
;		.ELSEIF eax==023
;		  lea ebx,szerimgs
;		.ELSEIF eax==024
;		  lea ebx,szer024
;		.ELSEIF eax==025
;		  lea ebx,szer025
;		.ELSEIF eax==026
;		  lea ebx,szer026
;		.ELSEIF eax==207
;		  lea ebx,szer207
;		.ELSE
;		  lea ebx,szerrormsg2
;				  invoke binto3dec,ebx					;eax-->asccii string in szerrormsg2
;		  lea ebx,szerrormsg
;		.ENDIF
;		invoke MessageBox,g_hwnd,ebx,0,MB_OK+MB_ICONEXCLAMATION
;
;		ret
;myerrorhandler ENDP
;--------------------------------------------------------------------------
;v2.99.
.CODE ;.DATA v3.01
szsaveerrorfile BYTE "error.eve",0
szemailback    BYTE "mailto:evebug@goosee.com?subject=",0
szemailbody    BYTE "&body=Type%20description%20of%20fault%20here.%20"
    BYTE "Attach%20ERROR.EVE%20file.",0
szer7xx BYTE "This may be a minor problem, but if it persists, please use talkback.",0Dh,0Ah
szerxxx BYTE 0Dh,0Ah
    BYTE "EVE is ""talkback enabled"", meaning that if you hit the ""YES"" button, "
    BYTE "a bug report will be emailed to me, and I can immediately "
    BYTE "investigate your problem. "
    BYTE "If you press ""YES"", your default email client will open and you "
    BYTE "can view and add comments to the talkback report in your email "
    BYTE "client before posting it.",0Dh,0Ah
    BYTE "NOTE1: EVE has taken a snapshot of the database and saved it as ERROR.EVE "
    BYTE "(in the same folder as the last-opened .EVE or the EVE.EXE executable). You may attach this to the email, if you "
    BYTE "think that might be a factor in the problem.", 0Dh,0Ah
    BYTE "NOTE2: EVE has taken a snapshot (picture) of the diagram-window and placed it on "
    BYTE "the clipboard. You may save this as a GIF file and attach to the email, "
    BYTE "if you think that will help to explain the fault.",0Dh,0Ah
    BYTE "If you don't want to report this bug, press the ""NO"" button.",0

.CODE
myalertbox PROC STDCALL USES ebx ecx edx esi edi,permsg:DWORD,fmode:DWORD
  LOCAL eaxin:DWORD,ebxin:DWORD,ecxin:DWORD,edxin:DWORD,esiin:DWORD,ediin:DWORD
  LOCAL pszer:DWORD,herrorfile:DWORD
  LOCAL szerrmsgbuf[1024]:BYTE
; "myalertbox"
;fmode =0 generic info, i icon, ok button
;=1 alert ! icon, ok button, no error.
;=2 question ? icon, yes/no buttons.
;=3 question ? icon, ok button.
;=4 error ! icon, error in titlebar, ok button.
;=6 choice, i icon, cancel/ok buttons.
;=7
;else error, ! icon, error in titlebar, yes/no buttons, email talkback option.
; (=7xxh use "szer7xx". =8xxh,Exxh use "szer8xx").
;(7xxh =talkback, but minor error. 8xxh =talkback, more serious EVE error.
; A00-BFFh =crash in win32 api func, outside EVE. xx=which api call in EVE. v3.23
; Cxxh =serious error, xx=last-api-error-code.
; E00h-FFFh =program crash CPU exception, xx-1xx is the exception code.)
;returns eax=button chosen.
  mov ebxin,ebx
  mov esiin,esi
  mov ediin,edi
  lea ebx,szeve ;"EVE"
  
  mov eax,fmode
  .IF eax==0 ;generic.
    mov ecx,MB_OK OR MB_ICONINFORMATION
  .ELSEIF eax==1
    mov ecx,MB_OK OR MB_ICONEXCLAMATION
  .ELSEIF eax==2
    mov ecx,MB_YESNO OR MB_ICONQUESTION
  .ELSEIF eax==3
    mov ecx,MB_OK OR MB_ICONQUESTION
  .ELSEIF eax==4
    mov ebx,0 ;"error" in titlebar.
    mov ecx,MB_OK OR MB_ICONEXCLAMATION
  .ELSEIF eax==6
    mov ecx,MB_OKCANCEL OR MB_ICONINFORMATION
  .ELSEIF eax==7
    mov ecx,MB_YESNO OR MB_ICONEXCLAMATION
  .ELSEIF eax<=7FFh
    ;minor bug, if persists recommend use talkback...
    mov eax,OFFSET szer7xx
    mov pszer,eax
    jmp SHORT ov1
  .ELSE ;fmode=error-code, error with talkback...
    mov eax,OFFSET szerxxx
    mov pszer,eax
ov1:
        ;save database to "error.eve"...
        pushad
        mov esi,pTERSEDATA
        lea edi,szerrmsgbuf
        invoke deletebitmaphandles
        invoke calcsig
        mov (TERSEDATA PTR [esi]).nsignature,eax
        invoke lstrcpy,edi,ADDR szhomefolder ;same folder as eve.exe. ...no, as open .EVE
        invoke lstrlen,edi
        add edi,eax
        invoke lstrcpy,edi,ADDR szsaveerrorfile
        lea edi,szerrmsgbuf
          invoke CreateFile,edi,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
          .IF eax != INVALID_HANDLE_VALUE
            mov herrorfile,eax
            mov eax,(TERSEDATA PTR [esi]).numrecords
            mov ecx,(TERSEDATA PTR [esi]).nsizeobject
            mul ecx 				;eax=size of OBJECTS database.
            add eax,(TERSEDATA PTR [esi]).noffsetobjs ;size of total database.
            invoke WriteFile,herrorfile,esi,eax,ADDR nbytesw,0
            invoke FlushFileBuffers,herrorfile
            invoke CloseHandle,herrorfile
          .ENDIF
        popad
      
        invoke shoot ;copy diagram window to clipboard.

    lea esi,szerrmsgbuf
    invoke lstrcpy,esi,permsg
    invoke lstrlen,esi
    mov edi,esi
    add edi,eax
    mov [edi],BYTE PTR 0Dh
    inc edi
    mov [edi],BYTE PTR 0Ah
    inc edi
    mov [edi],BYTE PTR 0
    invoke lstrcpy,edi,pszer ;ADDR szertalkback
    invoke MessageBox,g_hwnd,esi,0,MB_YESNO+MB_ICONEXCLAMATION    ;v3.23
    ;...interesting! I had 1st param =0, but sometimes don't get the email app
    ;launching. v3.23
    .IF ax==IDYES
    
      lea esi,szerrmsgbuf
      invoke lstrcpy,esi,ADDR szemailback
      invoke lstrlen,esi
      mov edi,esi
      add edi,eax
      ;now for the subject line...
        mov eax,fmode ;=error code.
        invoke bin2dec,16
        invoke lstrcpy,edi,eax
        invoke lstrlen,edi
        add edi,eax
        mov [edi],WORD PTR "-"
        inc edi
            ;v3.08 eve version#...
            invoke lstrcpy,edi,ADDR szeveversion
            add edi,4
            IF fDEVELOPER ;=1 web edition.
              mov [edi],WORD PTR "EW"  ;WE
              inc edi
              inc edi
            ENDIF
            mov [edi],WORD PTR "-"
            inc edi
              ;OS major version#... v3.23
              xor eax,eax
              mov al,fNT
              invoke bin2dec,10
              mov ebx,eax
              dec ebx
              mov [ebx],BYTE PTR "S"
              dec ebx
              mov [ebx],BYTE PTR "O"
              invoke lstrcpy,edi,ebx
              add edi,3 ;OSn only 3 digits.
              mov [edi],WORD PTR "-"
              inc edi
          mov eax,eipsg ;global.
          invoke bin2dec,16
          invoke lstrcpy,edi,eax
          invoke lstrlen,edi
          add edi,eax
          mov [edi],WORD PTR "-"
          inc edi
        mov eax,eaxin
        invoke bin2dec,16
        invoke lstrcpy,edi,eax
        invoke lstrlen,edi
        add edi,eax
        mov [edi],WORD PTR "-"
        inc edi
        mov eax,ebxin
        invoke bin2dec,16
        invoke lstrcpy,edi,eax
        invoke lstrlen,edi
        add edi,eax
        mov [edi],WORD PTR "-"
        inc edi
          mov eax,ecxin
          invoke bin2dec,16
          invoke lstrcpy,edi,eax
          invoke lstrlen,edi
          add edi,eax
          mov [edi],WORD PTR "-"
          inc edi
          mov eax,edxin
          invoke bin2dec,16
          invoke lstrcpy,edi,eax
          invoke lstrlen,edi
          add edi,eax
          mov [edi],WORD PTR "-"
          inc edi
        mov eax,esiin
        invoke bin2dec,16
        invoke lstrcpy,edi,eax
        invoke lstrlen,edi
        add edi,eax
        mov [edi],WORD PTR "-"
        inc edi
        mov eax,ediin
        invoke bin2dec,16
        invoke lstrcpy,edi,eax
        invoke lstrlen,edi
        add edi,eax
          ;now for the body...
          invoke lstrcpy,edi,ADDR szemailbody
          invoke lstrlen,edi
          add edi,eax
      ;v2.99 1st param should be g_hwnd...
			invoke ShellExecute,0,ADDR szopen,esi,0,0,SW_SHOWNORMAL ;0 v3.23
			;...see note above, re 1st param in MessageBox(). it doesn't seem to matter
			;here, so i'm leaving it at zero. while it runs async, return here, EVE will die.v3.23
    .ENDIF
		xor eax,eax
    jmp SHORT exi1
  .ENDIF
	invoke MessageBox,g_hwnd,permsg,ebx,ecx ;MB_OK+MB_ICONEXCLAMATION

exi1:
  ret
myalertbox ENDP
;--------------------------------------------------------------------------
binto3dec PROC STDCALL USES ebx ecx edx esi edi, pszdest:DWORD
; "binto3dec"
;enter with value in ax, convert to 3-digit decimal ascii, retaining
;leading zeros...
  mov  edi,pszdest
				xor edx,edx
				mov ecx,10
				div cx
				add dl,30h		;ascii
				mov BYTE PTR [edi+2],dl
				xor edx,edx
				div cx
				add dl,30h
				mov BYTE PTR [edi+1],dl
				xor edx,edx
				div cx
				add dl,30h
				mov BYTE PTR [edi],dl

  ret
binto3dec ENDP
;--------------------------------------------------------------------------
updateobjptrs PROC STDCALL USES eax ebx ecx edx esi edi, \
				 pstart:DWORD,nobjs:DWORD,nchange:DWORD,nchangelib:DWORD
		LOCAL dummy:DWORD
; "updateobjptrs"
;nchangelib is amount to add to icon.nlibrary. used when importing a diagram,
;so that icon will continue to index the correct picture#.
		mov esi,pTERSEDATA
		mov edi,pstart			 ;start of objects to be updated.
		mov ecx,nobjs			 ;number objects.
		mov ebx,nchange
		.IF ecx==0
		  ret
		.ENDIF
nxt1:
		  ;now update all the pointers in the object...
		  mov eax,(OBJECT PTR [edi]).rpdata
		  .IF eax != 0
				add (OBJECT PTR [edi]).rpdata,ebx
		  .ENDIF
;		   mov eax,(OBJECT PTR [edi]).rpmaster
;		   .IF eax != 0
;				 add (OBJECT PTR [edi]).rpmaster,ebx
;		   .ENDIF
		  mov eax,(OBJECT PTR [edi]).rpowner1
		  .IF eax != 0
				add (OBJECT PTR [edi]).rpowner1,ebx
		  .ENDIF
		  mov eax,(OBJECT PTR [edi]).rpowner2
		  .IF eax != 0
				;data element holding embedded bitmap file, top of chain, uses
				;.rpowner2(.nshape) to hold width/height of graphic image...
				;v1.26 LET'S SAY THAT .rpowner2 IS NEVER USED AS A PTR IN DATAELEMENTS...
				mov eax,(OBJECT PTR [edi]).nexttype
				and eax,0FFFFC000h ;dataelements guaranteed these bits set. v1.26
;				 .IF eax != -1 ;normal data element.
							;note .nextype of dataelements guaranteed to have bits14-31
							;set, and can have more. ex: FFFFE000h, or -1, so
							;above test gets them all
				  .IF eax != 0FFFFC000h
					add (OBJECT PTR [edi]).rpowner2,ebx
				  .ENDIF
;				 .ENDIF
		  .ENDIF
		mov eax,(OBJECT PTR [edi]).nexttype
		.IF ax>=60 ;icons in range 60-69.
		  .IF ax<=69
				mov eax,nchangelib										;so icon will continue to refer to
				add (OBJECT PTR [edi]).nlibrary,eax ;the correct picture# in database.
		  .ENDIF																;(used by openmerge() only).
		.ENDIF
		mov eax,(TERSEDATA PTR [esi]).nsizeobject
		add edi,eax
		loop nxt1

		ret
updateobjptrs ENDP
;--------------------------------------------------------------------------
.CODE ;.DATA v3.01
szfilterbitmap DB "BMP/GIF/JPG picture files ",0,"*.gif;*.jpg;*.bmp",0,0
				 DB 20 DUP(0)
;szdeffilebitmap DB "*.gif", sizeszfile-4 DUP(0)
szextensionbitmap DB "gif",0
szextensionjpg	  DB "jpg",0
szextensionbmp	  DB "bmp",0
szextensionwmf	  DB "wmf",0

;.DATA  ;v3.36
;ALIGN 4 ;v3.24 v3.36
defaultbitmap OPENFILENAME <, 0, 0, (OFFSET szfilterbitmap) ,0,\
								0, 1, 0, sizeszfile,\
								0, 0, 0, 0,\
								OFN_FILEMUSTEXIST+OFN_HIDEREADONLY+OFN_EXPLORER,\
								0, 0, (OFFSET szextensionbitmap), 0 ,0, 0>
								DB 0,0,0,0
ALIGN 4								
szertoobig BYTE "Picture is too big",0

.CODE
insertbitmap PROC STDCALL USES ebx ecx edx esi edi
		LOCAL openfilebitmap:OPENFILENAME, hfilebitmap:DWORD
		LOCAL szfilebitmap[sizeszfile]:BYTE,sizepic:DWORD
		LOCAL nbytesread[2]:DWORD,cntdataobjs:DWORD
		LOCAL ecxsave:DWORD,pprev:DWORD
		LOCAL pfirst:DWORD,fimgtype:DWORD
		LOCAL pmem:DWORD,pmem2:DWORD
		LOCAL rpfirst:DWORD,rpprev:DWORD
		LOCAL newsize:DWORD
; "insertbitmap"
;call from menu, File/Import bitmap..., to load a bitmap into the database.
;there will be a mini library of loaded bitmaps, that an icon can choose.

;how to manage this library?
;load as a linked-string of data-elements, each holding 256 bytes.
;.nexttype=-1, .rpdata->next data-element,
;if a child data-element, .rpowner1->owner.
;let's say that the graphic is not owned by any one element, and first
;data-element will have .rpowner1=0.

;choose a bitmap file...

;first, copy default structure...
				lea edi,openfilebitmap
				lea ebx,defaultbitmap
				mov ecx,OPENFILENAME_
oo1:	  mov al,[ebx]
				mov [edi],al
				inc ebx
				inc edi
				dec ecx
				jnz oo1
				lea eax,szfilebitmap
				mov openfilebitmap.on_lpstrFile,eax

;do same for szfilebitmap...
				lea edi,szfilebitmap
;				 lea ebx,szdeffilebitmap
				mov ecx,sizeszfile
oo2:	;mov al,[ebx]
				mov [edi],BYTE PTR 0 ;al
				;inc ebx
				inc edi
				loop oo2

  ;mov g_errorapi,0B4Bh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
  invoke GetOpenFileName, ADDR openfilebitmap  ;<<<DIALOG BOX<<<<
  .IF eax==0					;0=error/cancel
		mov eax,1
		jmp exx
  .ENDIF

;open existing file, read-only...
  ;mov g_errorapi,0B4Ch ;for crash outside EVE, error codes range A00h-BFFh. v3.23
  invoke CreateFile, ADDR szfilebitmap,\
								GENERIC_READ,\
								FILE_SHARE_READ,\
								0, OPEN_EXISTING,\				;only opens an existing file.
								FILE_ATTRIBUTE_READONLY+FILE_FLAG_SEQUENTIAL_SCAN, 0
  .IF eax==INVALID_HANDLE_VALUE ;-1
	  ;open failed ...
	  invoke myalertbox,ADDR szer100,4  ;invoke myerrorhandler,100
		jmp ex1
  .ENDIF
  mov hfilebitmap,eax	   ;handle of newly-opened file.

;Before we go ahead and read the file, is it .gif?
;openfiletemplate, type OPENFILENAME structure, has .on_nFileExtension
;that is an offset into szfilebitmap, where is datafile extension ...
				mov fimgtype,0
				xor eax,eax
				mov ax,openfilebitmap.on_nFileExtension
				lea edi,szfilebitmap
				add edi,eax
				;now compare this with content of szextension...
				invoke lstrcmpi, edi,ADDR szextensionbitmap
				.IF eax==0
				  mov fimgtype,1 ;gif.
				.ELSE
						invoke lstrcmpi,edi,ADDR szextensionjpg
						.IF eax==0
						  mov fimgtype,2 ;v1.55 1
						.ELSE
						  invoke lstrcmpi,edi,ADDR szextensionbmp
						  .IF eax==0
								mov fimgtype,3 ;v1.55 1
						  .ELSE
								invoke lstrcmpi,edi,ADDR szextensionwmf
								.IF eax==0
								  mov fimgtype,4 ;v1.55 3 ;1
								.ELSE
								  ;compare failed...
								  invoke myalertbox,ADDR szerrnogoo,4 ;invoke myerrorhandler,002
								  jmp ex1x								 ;error msg and return.
								.ENDIF
						  .ENDIF
						.ENDIF
				.ENDIF

;now to copy it into the database...

;										push eax						 ;save previous value of state. v3.36
;										mov al,g_nstate 		 ;/
;										mov g_nstateprev,al  ;/
;										pop eax 						 ;/
;				mov g_nstate,0 ;createnewobject() needs this.
;				  ;v1.23
;				  ;createnewobject() clears all pointers, except in these lists,
;				  ;so do it here as precaution...
;				  mov highlightedindex,0
;				  mov highlightedindexnewlist,0
				  
				mov cntdataobjs,0
        ;mov g_errorapi,0B4Dh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				invoke GetFileSize,hfilebitmap,0
				mov sizepic,eax
				
				;v3.36
				;allocate all the memory in one go...
				;each record is 288 bytes, holding 256 bytes, so size req'd to hold the
				;graphic is sizepic*(288/256). 288/256 =1.125 so 1/8 bigger...
				mov eax,sizepic
				mov newsize,eax
				shr eax,3
				add newsize,eax
				add newsize,1024 ;margin.
				mov edi,pTERSEDATA
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				mul ecx 				;eax=size of OBJECTS.
				add eax,(TERSEDATA PTR [edi]).noffsetobjs ;total size of current database.
				add newsize,eax
				  mov esi,eax ;use below.
				invoke zeroabsoluteptrs,1 ;clrs everything.
				invoke GlobalHandle,pTERSEDATA
				invoke GlobalReAlloc,eax,newsize,GMEM_MOVEABLE
				.IF eax==0 ;fail
				  invoke myalertbox,ADDR szertoobig,4 ;"Picture is too big".
				  jmp ex1x ;error exit. msg after return.
				.ELSE
				  mov pTERSEDATA,eax
				  mov edi,eax
				  add esi,eax ;address beyond end of current database.
				  mov eax,newsize
				  mov g_ndatabasesize,eax
				.ENDIF
				
				mov eax,sizepic
				mov ecx,256  ;#bytes stored in each data-element.
				xor edx,edx
				div ecx
				mov ecx,eax ;number of data-elements required.
				inc ecx 		;/
b20:	  mov ecxsave,ecx
        ;have esi->next record to be written to...
        ;edi->start of database...
        
;					;v1.23 these ptrs may get invalidated...    v3.36
;					mov eax,pprev
;					sub eax,pTERSEDATA
;					mov rpprev,eax
;					mov eax,pfirst
;					sub eax,pTERSEDATA
;					mov rpfirst,eax
;				  invoke createnewobject,1 ;at end of database(keeps them contiguous).
;					mov ebx,rpprev
;					add ebx,pTERSEDATA
;					mov pprev,ebx
;					mov ebx,rpfirst
;					add ebx,pTERSEDATA
;					mov pfirst,ebx
;				  .IF eax==0
;						jmp ex1x		 ;fail.
;				  .ENDIF				
;				  mov esi,eax ;-->new object
				  inc (TERSEDATA PTR [edi]).numrecords
          mov (OBJECT PTR [esi]).fstatus,01 ;make it valid    ;v3.36
          mov (OBJECT PTR [esi]).xdata,0
          mov (OBJECT PTR [esi]).rpdata,0
          mov (OBJECT PTR [esi]).ximage,0
          mov (OBJECT PTR [esi]).rpowner1,0
          mov (OBJECT PTR [esi]).rpowner2,0				
				  mov (OBJECT PTR [esi]).nexttype,-1
				  
				  lea ebx,(OBJECT PTR [esi]).sztext ;start of data-area of data-element.
          ;mov g_errorapi,0B4Eh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				  invoke ReadFile,hfilebitmap,ebx,256,ADDR nbytesread,0
				  
				  ;set various fields of data-element...
				  ;(note, .rpowner1 will be pointing up the chain, .rpdata pointing down)
				  .IF cntdataobjs==0
						mov (OBJECT PTR [esi]).rpowner1,0 ;marks as first data-element.
						;also want to store the filesize...  use .xdata...
						mov eax,sizepic
						mov (OBJECT PTR [esi]).xdata,eax
						mov pfirst,esi ;first data-element in chain.
				  .ELSE
						mov ebx,pprev
						mov eax,ebx
						sub eax,pTERSEDATA
						mov (OBJECT PTR [esi]).rpowner1,eax ;data-element owned by prior data-element.
						mov (OBJECT PTR [esi]).xdata,0
						mov eax,esi
						sub eax,pTERSEDATA
						mov (OBJECT PTR [ebx]).rpdata,eax  ;owner pts to child
				  .ENDIF

				  ;need to record type of data somewhere else...use .fstatus/bit4...
				  ;v1.55 .fstatus bit4=1 embedded file, bit3=1 it is a picture...
				  and (OBJECT PTR [esi]).fstatus,0FFFFFCA5h ;clr bits9/8/6/4/3/1.
				  .IF fimgtype==1 ;gif
					  or (OBJECT PTR [esi]).fstatus,1000011000b ;set bits9/4/3 =data is embeddedfile/GIF.
				  .ELSEIF fimgtype==2 ;jpg
					  or (OBJECT PTR [esi]).fstatus,0000011010b ;set bits4/3/1 =data is embeddedfile/JPG.
				  .ELSEIF fimgtype==3 ;bmp
					  or (OBJECT PTR [esi]).fstatus,0100011000b ;set bit8/4/3 =data is embeddedfile/BMP.
				  .ELSEIF fimgtype==4 ;wmf picture.
					  or (OBJECT PTR [esi]).fstatus,0001011000b ;set bit6/4/3 =data is embeddedfile/WMF.
				  .ENDIF
				  mov (OBJECT PTR [esi]).rpdata,0  ;in case this is last in chain.
				  mov pprev,esi  ;cos it's a linked chain.
				  inc cntdataobjs

        mov eax,(TERSEDATA PTR [edi]).nsizeobject
        add esi,eax
				mov ecx,ecxsave
				loop b20x
				jmp short b20z
b20x:	jmp b20
b20z:
;...GIF file has been copied to a linked chain of data-elements.
;...1st has .rpowner1=0, and .xdata=size of graphic file.
;....rpdata points to child in linked list, =0 last in chain.
;....fstatus/bit3 =1 picture file.
;so, when we want to browse library, look for data-elements in database
;with .rpowner1=0, and check .fstatus/bit3 to see if it is a picture (gif/jpg/bmp)
;and bit4=1 embedded file.


;v1.23
;(NOTE think i've fixed this, as ptrs getting invalidated by createnewobject() above.)
;with NT5.0 the imported bitmaps are corrupted sometimes. so, let's do a verify here,
;reconstitute the stored file (it's in 256 byte pieces) and compare with the file...
		;mygifload() reads gif from database to contiguous block...
		;  mygifload,ADDR mygifinfo,pobj,fdelete
		;  mygifinfo is a global structure, file size and ptr to loaded block saved in it.
		;  pobj pts to icon that has the attached data-element-chain (picture).
		;  fdelete=1 deletes the picture.
		;  returns eax=address of contiguous block.
		;  ...need to modify, fdelete=-1 then pobj pts direct to first data element...
		invoke mygifload,ADDR mygifinfo,pfirst,-1
		;...returns eax=addr of contiguous block (don't forget to remove block after).
		mov pmem,eax
		  ;hfilebitmap is handle of picture file on disk, sizepic=size of file...
		  mov eax,sizepic
		  add eax,256
      ;mov g_errorapi,0B4Fh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke GlobalAlloc,GMEM_FIXED,eax
		  mov pmem2,eax
		  invoke SetFilePointer,hfilebitmap,0,0,FILE_BEGIN
		  mov ebx,pmem2
		  invoke ReadFile,hfilebitmap,ebx,sizepic,ADDR nbytesread,0
		  ;...now we have read all of file into pmem2.
			;now compare the two blocks...
			mov ecx,sizepic
			mov edi,pmem
			mov esi,pmem2
lp0:	mov al,[edi]
			mov bl,[esi]
			cmp al,bl
			jne f00
			inc edi
			inc esi
			loop lp0
			jmp p00 ;...pass.
f00:		;fail.
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
			invoke myalertbox,ADDR szer116,82Ah ;eax  ;invoke myerrorhandler,116
p00:	;now remove the memory blocks...
      ;mov g_errorapi,0B50h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		  invoke GlobalHandle,pmem
		  invoke GlobalFree,eax
		  invoke GlobalHandle,pmem2
		  invoke GlobalFree,eax



		invoke CloseHandle, hfilebitmap ;close file.
		;eax=0 if fail.

		mov ebx,pTERSEDATA
		inc (TERSEDATA PTR [ebx]).numbitmaps
exx: ;xor esi,esi ;*TEST* breakpoint
		ret
ex1x:	;error exit.
		invoke CloseHandle, hfilebitmap ;close file.
ex1:   ;error exit.
		xor eax,eax
		 ret
insertbitmap ENDP
;--------------------------------------------------------------------------
.DATA
ALIGN 4 ;v3.24
hbitmapdefault DWORD 0 ;used in code hack.

.CODE
choosebitmap PROC STDCALL USES ebx ecx edx esi edi, hdlg:DWORD, \
		pobj:DWORD,nlib:DWORD,fdelete:DWORD
		LOCAL ofn:OPENFILENAME,pfirst:DWORD
		LOCAL ecxsave:DWORD,esisave:DWORD,edisave:DWORD
		LOCAL pdata2:DWORD,pmem:DWORD,p1stdataelement:DWORD
		LOCAL nlibcnt:DWORD
		LOCAL hdctemp:DWORD,hbitmapcurrent:DWORD
		LOCAL fimgtype:DWORD
		LOCAL widthold:DWORD,heightold:DWORD,pdata1st:DWORD
; "choosebitmap"
;called from "custom bitmap" icon in icon dlg box, via iconproc().
;choose from the loaded bitmaps (loaded via insertbitmap()).
;refer to insertbitmap() above, which loads bitmaps into the database.
;fdelete=1 to delete picture from library, =0 otherwise.
;return eax=0 if chose no graphic file, else eax->1st data element.
;note, also refer common_paint_icon(), which paints the image.

;first need some code to view the bitmaps and choose one....
;dlg box has an edit box, passed in here as "nlib".
;nlib=0 no picture.
		mov edi,pobj
		.IF nlib==0
		  ;restore icon to default shape...
e55:  mov (OBJECT PTR [edi]).rpdata2,0 ;no attached graphic.
		  mov (OBJECT PTR [edi]).wwidth,36 ;48
		  mov eax,18 ;24
		  add eax,(OBJECT PTR [edi]).xtopleft
		  mov (OBJECT PTR [edi]).xmid,eax
		  mov (OBJECT PTR [edi]).height,36 ;48
		  mov eax,18 ;24
		  add eax,(OBJECT PTR [edi]).ytopleft
		  mov (OBJECT PTR [edi]).ymid,eax
		  mov (OBJECT PTR [edi]).widthhimetric,0
		  mov (OBJECT PTR [edi]).heighthimetric,0
		  xor eax,eax
		  ret
		.ENDIF
		mov nlibcnt,0


;nlib is the entry# of the picture we want...
				mov edi,pTERSEDATA
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==-1
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  .IF eax==0 ;1st data-element in chain.
								mov eax,(OBJECT PTR [esi]).fstatus
								and al,011000b ;bits4/3.
								.IF al==011000b ;embedded picture data.
								  ;so have esi-->picture file (1st data-element).
								  ;esi.xdata has the filesize.
								  mov fimgtype,1 ;gif. aug.29 --all picture types.
c45:							  inc nlibcnt
										;a fix for old eve file, and a precaution...
										mov eax,(TERSEDATA PTR [edi]).numbitmaps
										.IF nlibcnt>eax
										  mov eax,nlibcnt												   ;in case .numbitmaps
										  mov (TERSEDATA PTR [edi]).numbitmaps,eax ;is 0 or too low.
										.ENDIF
								  mov eax,nlib
								  .IF eax==nlibcnt
										;found it...
										;but, if going to delete it, need to dec cnt...
										.IF fdelete==1
										  ;dec (TERSEDATA PTR [edi]).numbitmaps
										  ;...*NOTE* *WARNING* with current version of EVE, we don't
										  ;actually delete any bitmaps, just replace with an "EVE" logo.
										  ;so, don't decrement .numbitmaps.
										  ;in future, when import new bitmap, get it to replace any
										  ;earlier "EVE" logo, rather than tacking on at end of library.
										.ENDIF
										jmp found1
								  .ENDIF
								;.ELSEIF al==010010b ;bits4/1, JPG. 	   ;*NOTE* v0.95 now redundant.
								;  mov fimgtype,2 ;jpg.
								;  jmp c45
								.ENDIF
						  .ENDIF
						.ELSE							;not a data object.
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4: ;fail...
		xor eax,eax
		mov p1stdataelement,eax
		jmp SHORT kf9

found1:
		mov eax,esi
		mov p1stdataelement,eax
		sub eax,pTERSEDATA
kf9:
		mov edi,pobj
		mov (OBJECT PTR [edi]).rpdata2,eax ;icon will point to bitmap.
		 ;....rpdata2 =0 if no attached bitmap.


;now, want to read the chained-data-elements to a contiguous block,
;then prepare it for use by BitBlt() in paint_ methods.
;only do this conversion once, however...
    mov pdata1st,0
		mov edi,pobj
		mov ebx,(OBJECT PTR [edi]).rpdata2		 ;(alias for rpowner2)
		.IF ebx == 0  ;no graphic file attached.
		  jmp e55 ;ret
		.ELSE
		  add ebx,pTERSEDATA
		  mov pdata1st,ebx
		  mov eax,(OBJECT PTR [ebx]).ximage
		  .IF eax != 0
				;conversion/expansion already done...
				cmp fdelete,1
				je f11	 ;need to delete picture.
				;bug... attached image already has the expanded image, so don't
				;have to go through the process below, but still need to
				;update the icon's wwidth/height...
				;and the xmid/ymid...
				  ;v1.45
				  mov eax,(OBJECT PTR [edi]).wwidth
				  mov widthold,eax
				  mov eax,(OBJECT PTR [edi]).height
				  mov heightold,eax
				xor eax,eax
				mov ax,WORD PTR (OBJECT PTR [ebx]).nshape ;(alias for rpowner2).
				mov (OBJECT PTR [edi]).origwidth,eax ;v1.85
				mov (OBJECT PTR [edi]).wwidth,eax
				shr eax,1
				add eax,(OBJECT PTR [edi]).xtopleft
				mov (OBJECT PTR [edi]).xmid,eax
				xor eax,eax
				mov ax,WORD PTR (OBJECT PTR [ebx]).nshape+2
				mov (OBJECT PTR [edi]).origheight,eax
				mov (OBJECT PTR [edi]).height,eax
				shr eax,1
				add eax,(OBJECT PTR [edi]).ytopleft
				mov (OBJECT PTR [edi]).ymid,eax
				  ;also need to update the himetric width/height stored in the icon...
				  mov eax,(OBJECT PTR [edi]).wwidth ;width in pixels.
				  mov ecx,2540
				  mul ecx
				  div xscreenpixels ;calc'd in printeranalysis().
				  mov (OBJECT PTR [edi]).widthhimetric,eax
				  mov eax,(OBJECT PTR [edi]).height ;height in pixels.
				  mov ecx,2540
				  mul ecx
				  div yscreenpixels ;calc'd in printeranalysis().
				  mov (OBJECT PTR [edi]).heighthimetric,eax

				  ;v1.45
				  ;if icon is locked, i don't want to be able to modify the width/height,
				  ;cos it may have been stretched, so undo above...
				  ;(see also creategifhdc() below).
				  ;mov eax,(OBJECT PTR [edi]).fconfig4
				  ;and al,01000b ;bit3=1 locked.
				  ;.IF al==01000b
				  ;get it direct from checkbox...
				  invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
				  .IF ax==1
					mov eax,widthold
					mov (OBJECT PTR [edi]).wwidth,eax
					sar eax,1
					add eax,(OBJECT PTR [edi]).xtopleft
					mov (OBJECT PTR [edi]).xmid,eax
					mov eax,heightold
					mov (OBJECT PTR [edi]).height,eax
					sar eax,1
					add eax,(OBJECT PTR [edi]).ytopleft
					mov (OBJECT PTR [edi]).ymid,eax
					;% scaling can still be applied...
				  .ENDIF


					;v1.45
					;write width/height back into editboxes...
					mov  eax,(OBJECT PTR [edi]).wwidth
					invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
					;...returns eax->start of string, past the leading blanks.
					invoke SendDlgItemMessage,hdlg,252,WM_SETTEXT,0,eax
					mov  eax,(OBJECT PTR [edi]).height
					invoke bin2dec,10				   ;eax-->asciitbl+0 to +9 (10 digits)
					;...returns eax->start of string, past the leading blanks.
					invoke SendDlgItemMessage,hdlg,253,WM_SETTEXT,0,eax
					
				jmp ex1
		  .ENDIF
		.ENDIF

f11:
;need to consider fdelete=1, delete the picture. need to delete
;all chained data-elements except the 1st. I want to have a default
;gif image <256 bytes to load into it.
;have to pass it into mygifload() to find all chained elements
;(and return eax=0)...
		;firstly however, delete handle of expanded image...
		.IF fdelete==1
		  mov ebx,(OBJECT PTR [edi]).rpdata2   ;(alias for rpowner2)
		  add ebx,pTERSEDATA ;note, already saved as p1stdataelement.
		  mov eax,(OBJECT PTR [ebx]).ximage    ;has gpPicture.
		  .IF eax != 0
				;.ximage has "hDCBitmap" created by CreateCompatibleDC() below.
				;this has "hBitmap" (created by CreateDIBSection()) selected
				;into it.
				;problem, seems we need to delete hBitmap first...
				;invoke DeleteObject,hBitmap...

;				 mov hdctemp,eax
;				   invoke GetCurrentObject,eax,OBJ_BITMAP		;hBitmap.
;				   mov hbitmapcurrent,eax
;				   ;problem, must "unselect" from DC, before deleting hbitmap...
;				   invoke SelectObject,hdctemp,hbitmapdefault ;code hack!!!!
;				   ;...this is not necessarily the correct previous handle!!!
;				   invoke DeleteObject,hbitmapcurrent	 ;
;				 invoke DeleteDC,hdctemp ;delete handle of bitmap DC.

				 mov	   edx,eax		;gpPicture ;gpPicture->Release();
				 push	   edx									   ;/  "this" has to be passed, which is a ptr
				 mov	   ecx,dword ptr [edx]	   ;/  to the interface.
				 call	   dword ptr [ecx+8]	   ;/

				mov ebx,p1stdataelement
				mov (OBJECT PTR [ebx]).ximage,0
		  .ENDIF
		.ENDIF

;read the chained-data-elements to a contiguous block...
		invoke mygifload,ADDR mygifinfo,pobj,fdelete
		;...returns eax->block, else=0.
		;...writes file size and start address of block into mygifinfo.
		.IF eax==0		 ;fail.
		  jmp e55 ;ret
		.ENDIF
		mov pmem,eax

		invoke creategifhdc,pobj,pmem,p1stdataelement
		mov pmem,0 ;finished using it.
		.IF eax != 0
		  jmp er0 ;error.
		.ENDIF

ex1:
			  ;v2.91
				;get the transparent color info from 1stdataelement.end01
				;(loaded in mygifload()) and put transparent color into
				;dlg box fields...
				mov ebx,pdata1st
				.IF ebx != 0
					mov eax,(OBJECT PTR [ebx]).end01
					;...has offsets into the contiguous memory block.
					;we don't have a memory block right now. have .ximage->
					;a ipicture object. so, have to temporarily create one!...
					.IF eax != 0
					  invoke chain2block,ebx,ADDR g_bigblock
					  ;...g_bigblock mostly used with labels, so okay use here.
					  mov eax,(OBJECT PTR [ebx]).end01
					  and eax,0FFFFh ;low half has ptr to graphic control
					  ;extension packed field...
					  mov ebx,OFFSET g_bigblock
					  add ebx,eax
					  mov al,[ebx] ;packed field. bit0=1 has transparent color.
					  and al,01
					  .IF al != 0
              invoke SendDlgItemMessage,hdlg,224,BM_SETCHECK,1,0
              mov ebx,pdata1st
              mov eax,(OBJECT PTR [ebx]).end01
              shr eax,16 ;hi-half has ptr to transparent color.
              mov ebx,OFFSET g_bigblock
              add ebx,eax
              mov al,[ebx] ;red.
              invoke bin2dec,10 ;eax-->asciitbl+0 to +9 (10 digits)
              invoke SendDlgItemMessage,hdlg,700,WM_SETTEXT,0,eax
              inc ebx
              mov al,[ebx] ;green.
              invoke bin2dec,10 ;eax-->asciitbl+0 to +9 (10 digits)
              invoke SendDlgItemMessage,hdlg,701,WM_SETTEXT,0,eax
              inc ebx
              mov al,[ebx] ;blue.
              invoke bin2dec,10 ;eax-->asciitbl+0 to +9 (10 digits)
              invoke SendDlgItemMessage,hdlg,702,WM_SETTEXT,0,eax
					  .ENDIF
					.ENDIF
        .ENDIF

     ;normal exit, eax->1st data element.
		 mov eax,p1stdataelement
		 ret
;er1: ;error
;		 mov eax,219
er0:
;						  call nxtinstr
;nxtinstr:     pop eax ;return eip.						
 invoke myalertbox,ADDR szer219,82Bh ;eax  ;invoke myerrorhandler,eax
		mov ebx,pobj
		mov (OBJECT PTR [ebx]).rpdata2,0
		xor eax,eax    ;eax=0 error, or no picture attached to icon.
		ret
choosebitmap ENDP
;------------------------------------------------------------------------
creategifhdc PROC STDCALL USES ebx ecx edx esi edi, \
		pobj:DWORD,pmem:DWORD,p1stdataelement:DWORD
;		 LOCAL hcompatdc:DWORD,bitptr:DWORD
		LOCAL hglobal:DWORD,pstm:DWORD,hr:DWORD
		LOCAL widthpixels:DWORD,heightpixels:DWORD
		LOCAL hmwidth:DWORD,hmheight:DWORD
		LOCAL widthold:DWORD,heightold:DWORD
; "creategifhdc"
;called from choosebitmap() and common_paint_bitmap().
;ret eax=0 ok, else error#.

;we enter func with pmem->bitmap-file-in-memory.
;prior to calling this func, called mygifload(), which copied the file from the
;data-elemnents to a contiguous mem block ptd to by pmem. mygifload() also
;wrote the file size and start address of block into mygifinfo.

		mov gpPicture,0
;now need to convert the mem-block into a "stream"...
  ;mov g_errorapi,0B51h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		 invoke GlobalHandle,pmem
		 mov hglobal,eax
		 invoke CreateStreamOnHGlobal,hglobal,TRUE,ADDR pstm
		 ;...returns pstm =ptr to stream (i.e. copy of the mem block).
		 ;returns eax=0 if ok
		 .IF eax != 0
		   mov eax,220
		   jmp er0
		 .ENDIF

;		 cmp gpPicture,0
;		 je    short @16
;		 mov	   edx,dword ptr gpPicture ;gpPicture->Release();
;		 push	   edx									   ;/  "this" has to be passed, which is a ptr
;		 mov	   ecx,dword ptr [edx]	   ;/  to the interface.
;		 call	   dword ptr [ecx+8]	   ;/
;@16:

		 mov eax,mygifinfo.dwGIFDataSize ;size of mem block.
  ;mov g_errorapi,0B52h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		 invoke OleLoadPicture,pstm,eax,0,ADDR IID_IPicture,ADDR gpPicture
		 ;..."IID_IPicture" is the type of interface pointer to return
		 ;(defined in OCIDL.H, UUID.C, BASETYPS.H),
		 ;...The requested interface pointer is returned in "gpPicture".
		 ;returns eax=0 if ok
		 .IF eax != 0  ;S_OK=0
		   .IF eax==E_POINTER
				 mov eax,222
		   .ELSEIF eax==E_NOINTERFACE
				 mov eax,223
		   .ELSEIF eax==E_OUTOFMEMORY
				 mov eax,224
		   .ELSE
				 .IF SDWORD PTR eax<0
				   mov eax,221 ;E_UNEXPECTED
				 .ELSE
				   jmp ok9
				 .ENDIF
		   .ENDIF
		   jmp er0
		 .ENDIF
ok9:

		  mov			eax,pstm						 ;pstm->Release();
		  push			eax 					 ;/
		  mov			edx,dword ptr [eax]  ;/
		  call			dword ptr [edx+8]		 ;/
		  ;umm, presume can release original mem block?...
		  invoke GlobalFree,hglobal

;  pushad
;  invoke MessageBeep,-1
;  popad
		 ;the picture is now ready to be painted... gppicture points to it...

		 ;let's test it...
  ;mov g_errorapi,0B53h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		 lea	   eax,hmwidth							 ;gpPicture->get_Width(&hmWidth)
		 push	   eax											 ;/
		 mov	   edx,dword ptr gpPicture		 ;/
		 push	   edx											 ;/
		 mov	   ecx,dword ptr [edx]			 ;/   (hmwidth is in himetric units)
		 call	   dword ptr [ecx+GPget_Width]			 ;/ 24 v2.90

  ;mov g_errorapi,0B54h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		 lea	   eax,hmheight 						 ;gpPicture->get_Height(&hmHeight)
		 push	   eax											 ;/
		 mov	   edx,dword ptr gpPicture		 ;/
		 push	   edx											 ;/
		 mov	   ecx,dword ptr [edx]			 ;/
		 call	   dword ptr [ecx+GPget_Height]	;/28 v2.90 (hmheight is in himetric units)

		;the wwidth and height are in HIMETRIC units. for output to screen, need
		;the width/height in pixels...
		mov eax,hmwidth
		mul xscreenpixels ;calc'd in printeranalysis().
		mov ecx,2540
		div ecx
		mov widthpixels,eax
		mov eax,hmheight
		mul yscreenpixels ;calc'd in printeranalysis().
		mov ecx,2540
		div ecx
		mov heightpixels,eax

		 ;the picture is going to be painted in common_paint_bitmap(), and need to
		 ;setup the icon now and pass stuff...
		 mov eax,gpPicture
		 mov ebx,p1stdataelement
		 mov (OBJECT PTR [ebx]).ximage,eax
		 ;also, save width/height of bitmap into icon...
		 ;and update xmid/ymid...
		 mov edi,pobj
		   ;v1.45
		   mov eax,(OBJECT PTR [edi]).wwidth
		   mov widthold,eax
		   mov eax,(OBJECT PTR [edi]).height
		   mov heightold,eax
		 mov eax,widthpixels
		 mov (OBJECT PTR [edi]).wwidth,eax
		 mov (OBJECT PTR [edi]).origwidth,eax
		 shr eax,1
		 add eax,(OBJECT PTR [edi]).xtopleft
		 mov (OBJECT PTR [edi]).xmid,eax
		 mov eax,heightpixels
		 mov (OBJECT PTR [edi]).height,eax
		 mov (OBJECT PTR [edi]).origheight,eax
		 shr eax,1
		 add eax,(OBJECT PTR [edi]).ytopleft
		 mov (OBJECT PTR [edi]).ymid,eax
		 ;also need to save wwidth/height of image in 1st data-element...
		 mov eax,(OBJECT PTR [edi]).wwidth
		 mov WORD PTR (OBJECT PTR [ebx]).nshape,ax ;(alias for rpowner2).
		 mov eax,(OBJECT PTR [edi]).height
		 mov WORD PTR (OBJECT PTR [ebx]).nshape+2,ax

		 ;save the width/height in himetric units in the icon (common_paint_bitmap())...
		 mov eax,hmwidth
		 mov (OBJECT PTR [edi]).widthhimetric,eax
		 mov eax,hmheight
		 mov (OBJECT PTR [edi]).heighthimetric,eax

				  ;v1.45
				  ;if icon is locked, i don't want to be able to modify the width/height,
				  ;cos it may have been stretched, so undo above...
				  mov eax,(OBJECT PTR [edi]).fconfig4
				  and al,01000b ;bit3=1 locked.
				  .IF al==01000b
					mov eax,widthold
					mov (OBJECT PTR [edi]).wwidth,eax
					sar eax,1
					add eax,(OBJECT PTR [edi]).xtopleft
					mov (OBJECT PTR [edi]).xmid,eax
					mov eax,heightold
					mov (OBJECT PTR [edi]).height,eax
					sar eax,1
					add eax,(OBJECT PTR [edi]).ytopleft
					mov (OBJECT PTR [edi]).ymid,eax
					;% scaling can still be applied...
				  .ENDIF


ok1:
		xor eax,eax ;ok.
		ret
er1: mov eax,219 ;error.
er0: ret
creategifhdc ENDP
;------------------------------------------------------------------------
deletebitmaphandles PROC STDCALL USES ebx ecx edx esi edi
		LOCAL edisave:DWORD,esisave:DWORD,ecxsave:DWORD
		LOCAL hdctemp:DWORD,hbitmapcurrent:DWORD
; "deletebitmaphandles"
;in opendatafile() and wmdestroy(), need to erase the bitmap handles
;and DCs created for the bitmaps of the current diagram...
;this func does not destroy the embedded gifs --the chained dataelements
;are still there, except 1stdataelement.ximage=0 meaning no hdcbitmap.
;i will also call this func from savedatafile() and saveasdatafile(),
;as want .ximage to be zeroed.

;also delete checkmark bitmap handles loaded to custom-shape menuitems in Elements menu.
;the handle is in library-data-element.ximage.

				mov edi,pTERSEDATA
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						.IF ax==-1
						  mov eax,(OBJECT PTR [esi]).rpowner1
						  .IF eax==0 ;1st data-element in chain.
								mov eax,(OBJECT PTR [esi]).fstatus
								and al,011000b ;bits4/3.
								.IF al==011000b ;embedded picture data.
								  ;so have esi-->picture file (1st data-element).
								  ;esi.xdata has the filesize.
								  ;esi.ximage has the hDCBitmap.
c56:							  mov eax,(OBJECT PTR [esi]).ximage
								  .IF eax != 0

;										 mov hdctemp,eax
;										 invoke GetCurrentObject,eax,OBJ_BITMAP   ;hBitmap.
;										 mov hbitmapcurrent,eax
;										 ;problem, must "unselect" from DC, before deleting hbitmap...
;										 invoke SelectObject,hdctemp,hbitmapdefault ;code hack!!!!
;										 ;...this is not necessarily the correct previous handle!!!
;										 invoke DeleteObject,hbitmapcurrent
;										 invoke DeleteDC,hdctemp ;delete handle of bitmap DC.

  ;mov g_errorapi,0B55h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
										mov   edx,eax	   ;gpPicture ;gpPicture->Release();
										push  edx						   ;/  "this" has to be passed, which is a ptr
										mov   ecx,dword ptr [edx]		  ;/  to the interface.
										call  dword ptr [ecx+8] 		  ;/

										mov (OBJECT PTR [esi]).ximage,0

								  .ENDIF
								;.ELSEIF al==010010b ;jpg.
								;  jmp c56
								.ENDIF
						  .ENDIF
						.ELSEIF eax==0FFFFC000h ;library data element. v3.45
						  mov eax,(OBJECT PTR [esi]).ximage  ;holds gppicturecheckmark.
						  .IF eax != 0
								mov   edx,eax	   ;gppicturecheckmark->Release();
								push  edx						   ;/  "this" has to be passed, which is a ptr
								mov   ecx,dword ptr [edx]		  ;/  to the interface.
								call  dword ptr [ecx+8] 		  ;/
						    mov (OBJECT PTR [esi]).ximage,0
						  .ENDIF						
						.ELSE							;not a data object.
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4: ;fail...


		ret
deletebitmaphandles ENDP
;------------------------------------------------------------------------
calcxydiffnorm PROC USES ebx ecx edx esi edi, \
				xendk:DWORD,xende:DWORD,yendk:DWORD,yende:DWORD
				LOCAL xtmp:DWORD,ytmp:DWORD,deltaytmp:DWORD,hypot:DWORD
; "calcxydiffnorm"
;"e" suffix means extreme end of wire, "k" is a knee further-in on wire.
;writes to g_xdiffnorm, g_ydiffnorm.
				mov eax,yendk	;(OBJECT PTR [esi]).yknee2								;compute formula
				sub  eax,yende	 ;/ hypot=sqrt((mousey-centrey)^2
				mov  ebx,eax					;/				 +((mousex-centrex)^2)
				mov  ytmp,eax					;/
				imul  ebx								;/ -->edx:eax
				mov  deltaytmp,eax				 ;/ temp save
				mov  eax,xendk	;(OBJECT PTR [esi]).xknee2								;/
				sub  eax,xende	 ;/
				mov  ebx,eax					;/
				mov  xtmp,eax					;/
				imul  ebx								;/ -->edx:eax
				add  eax,deltaytmp				;/
				  ;now square-root...
				    ;v3.07 someone gets a crash at fsqrt/fistp...
				    ;let's limit the hypotenuse...
				    .IF eax>40000 ;unsigned compare.
				      mov eax,40000 ;limits hypot to +200.
				    .ENDIF
				  mov hypot,eax
				  fild hypot
				  fsqrt
				  fistp hypot					;will always be +ve.
				  .IF hypot==0			   ;prevent divide-by-0.
						mov  hypot,1
				  .ENDIF
				;now to normalise xtmp/ytmp...
				xor edx,edx
				mov eax,xtmp
				mov ebx,100 ;determines final arrow-size.
				imul ebx
				mov ebx,hypot
				idiv ebx
				mov g_xdiffnorm,eax
				  ;ditto for ytmp...
				  xor edx,edx
				  mov eax,ytmp
				  mov ebx,100	;determines final arrow-size.
				  imul ebx
				  mov ebx,hypot
				  idiv ebx
				  mov g_ydiffnorm,eax

		ret
calcxydiffnorm ENDP
;------------------------------------------------------------------------
add2highlightedlist PROC STDCALL USES ebx ecx edx edi esi, pobj:DWORD
		LOCAL dummy:BYTE
; "add2highlightedlist"

		mov esi,pobj
;		 invoke add2highlightedlist0,esi
;...commented out, cos addlocked2highlighted() calls it, and finds
;elements in correct order in database.
		;checks for other elements in composite-object...
		invoke addlocked2highlighted,esi
		;...returns eax-->top element.

		;return eax-->top element.
		ret
add2highlightedlist ENDP
;------------------------------------------------------------------------
addlocked2highlighted PROC STDCALL USES ebx ecx edx esi edi, \
		pobj:DWORD
		LOCAL edisave:DWORD,esisave:DWORD,ecxsave:DWORD
		LOCAL ptop:DWORD
; "addlocked2highlighted"
;when an element is added to highlighted list, it may be part of a
;composite-object. all elements of the composite must stick together.
;we need to find the parent-element of the composite, then go thru
;database and find all elements locked to it.

;must also work for library objects, that have .nextype bits15-31 set.
;note, description dataelement attached to a library obj has
;.nexttype=0FFFFC000h ie bits14-31 set -- exclude it.
							;note .nextype of dataelements guaranteed to have bits14-31
							;set, and can have more. ex: FFFFE000h, or -1.
;v1.41 return eax->top element in composite-obj (ptop).

		mov edi,pTERSEDATA
		mov esi,pobj
		mov ptop,esi

;		 .IF esi==pTERSEDATA
;		   invoke myerrorhandler,esi
;		 .ENDIF

		mov ebx,(OBJECT PTR [esi]).rpowner1
		or ebx,ebx ;cmp ebx,0
		je		x33 ;out1
		mov eax,(OBJECT PTR [esi]).fconfig4
		test eax,1000b ;bit3=1 if locked.
		jz		x33 ;out1

tstnxt:
		  add ebx,edi
		  mov eax,(OBJECT PTR [ebx]).fconfig4 ;parent.
		  test eax,1000b ;lock.
		  jz  fndtop
		  mov eax,(OBJECT PTR [ebx]).rpowner1
		  or eax,eax ;cmp eax,0
		  jz  fndtop
		  mov ebx,eax
		  jmp tstnxt
fndtop:
		;arrive here with ebx->top-element of composite-object.
		mov ptop,ebx

;		 invoke add2highlightedlist0,ebx
;		 or (OBJECT PTR [ebx]).fconfig2,10000000b ;set bit7.

x33:
;now scan database and find all elements locked to composite-obj...
				  mov esi,(TERSEDATA PTR [edi]).noffsetobjs
				  add esi,edi ;starting address of OBJECTS.
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0 ;empty.
						jmp kf4
				  .ENDIF
				;as we loop around, edi->start of TERSEDATA, esi->current object...
nextobj:
				mov esisave,esi
				mov edisave,edi
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				  .IF ax==01	;bit0=1, valid object.
						mov eax,(OBJECT PTR [esi]).nexttype
						and eax,0FFFFC000h
						.IF eax==0FFFFC000h ;gets all data elements. v1.31.
						;.IF ax==-1 ;SWORD PTR ax<0 ;ax==-1 	 data object.
						;.ELSEIF ax==0C000h ;menu description dataelement for library obj.
						.ELSE
						  .IF esi!= pobj ;exclude pobj.
						  ;...no, don't exclude pobj! see below...
								.IF esi==ptop
								  jmp t39 ;add top element also.
								.ELSE
								  ;follow the rpowner1 chain, see if reaches ptop...
								  mov ebx,esi
t33:							  mov eax,(OBJECT PTR [ebx]).fconfig4
								  and al,01000b ;bit3=1 if locked.
								  .IF al==01000b
										mov eax,(OBJECT PTR [ebx]).rpowner1
										.IF eax != 0
										  add eax,edi ;pTERSEDATA
										  .IF eax==ptop
											;yes, locked to ptop...
t39:
											.IF esi==pTERSEDATA ;v1.87 bug if this occurs.
											.ELSE
											  invoke add2highlightedlist0,esi
											  or (OBJECT PTR [esi]).fconfig2,10000000b ;set bit7.
											.ENDIF

										  .ELSE
											mov ebx,eax
											jmp t33
										  .ENDIF
										.ENDIF
								  .ENDIF
								.ENDIF
						  .ELSE
								jmp t39 ;add pobj also.
						  .ENDIF
						.ENDIF
				  .ENDIF
kf1:	mov ecx,ecxsave
				mov edi,edisave
				mov esi,esisave
				mov eax,(TERSEDATA PTR [edi]).nsizeobject
				add esi,eax 			;addr of next object.
		loop kf3 ;nextobj
		jmp SHORT kf4
kf3: jmp nextobj
kf4:


out1:	mov eax,ptop ;top element.
		ret
addlocked2highlighted ENDP
;------------------------------------------------------------------------

compactdatabase PROC  STDCALL USES edi esi ebx ecx edx
		LOCAL ecxsave:DWORD, rpelement:DWORD
		LOCAL sizeobj:DWORD,nempty:DWORD,pnewend:DWORD,newsize:DWORD
; "compactdatabase"
; code similar to onanobject().

;have decided it's best to search *forward* thru database, so all elements stay in
;same order for overlapping painting.
;for each element, call move1object().

				mov nempty,0
				mov edi,pTERSEDATA
				  mov eax,(TERSEDATA PTR [edi]).noffsetobjs
				  mov rpelement,eax
				  mov eax,(TERSEDATA PTR [edi]).nsizeobject
				  mov sizeobj,eax
				mov ecx,(TERSEDATA PTR [edi]).numrecords
				  .IF cx==0
						jmp out1
				  .ENDIF

nextobj:
				;move1object() can resize database, which invalidates ptrs...
				mov esi,rpelement
				add esi,pTERSEDATA
				mov edi,pTERSEDATA
				;as we loop around, edi->start of TERSEDATA, esi->current object...
				mov ecxsave,ecx
				mov eax,(OBJECT PTR [esi]).fstatus
				and ax,01
				.IF ax==01				;bit0=1, valid object.
				  mov nempty,0
				  mov eax,(OBJECT PTR [esi]).nexttype
				  .IF SWORD PTR ax<0 ;ax==-1
					  ;why not move everything?...
					  jmp SHORT all1
				  .ELSE 				;not a data object.

all1:				invoke move1object,esi,0 ;try to move it to earlier in database.
					  ;...leaves element in same place if failed.(=2 will move to record#1).
					  mov esi,rpelement
					  add esi,pTERSEDATA
					  .IF eax==esi ;fail.
					    ;no need to do anything here.
					  .ENDIF

				  .ENDIF
				.ELSE
				  inc nempty
				.ENDIF
				mov ecx,ecxsave
				mov eax,sizeobj
				add rpelement,eax
		loop nextobj

;now we have to chop the empty records off the end...
	;nempty=# empty elements on end of database...
	.IF nempty != 0
	  mov esi,rpelement
	  add esi,pTERSEDATA ;address 1-past end of database.
		mov eax,nempty
		mov ecx,sizeobj
		mul ecx ;eax=total size empty records.
		sub esi,eax ;new required end of database.
		mov pnewend,esi
		sub esi,pTERSEDATA
		mov newsize,esi ;new required size of database.
		  ;change number of elements...
		  mov edi,pTERSEDATA
		  mov ecx,(TERSEDATA PTR [edi]).numrecords
		  sub ecx,nempty
		  .IF SDWORD PTR ecx<NUMINITOBJS ;precaution.
			  ;v1.29 fix a bug corrupted file <10 elements...
			  mov eax,(SIZEOF TERSEDATA) ;minimum size of TERSEDATA.
			  mov newsize,eax
			  mov ecx,NUMINITOBJS
		  .ENDIF
		  mov (TERSEDATA PTR [edi]).numrecords,ecx
			;now resize database...

        ;mov g_errorapi,0B56h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
				invoke GlobalHandle,pTERSEDATA ;v1.23 converts ptr to handle.
				mov ecx,newsize
				add ecx,128
				invoke GlobalReAlloc,eax,ecx,GMEM_MOVEABLE
				;...note, we are resizing a fixed memory block, and the GMEM_MOVEABLE flag
				;here doesn't change that. this func will return eax=new address of block.
				.IF eax==0
				  ;fail...
				  invoke myalertbox,ADDR szer226,82Ch ;eax  ;invoke myerrorhandler,226
;				   ;error message and exit EVE...
;				   invoke DestroyWindow, g_hwnd
				  jmp out1
				.ELSE
				  mov pTERSEDATA,eax	;new pointer.
				  ;all absolute pointers are invalid...
				  invoke zeroabsoluteptrs,1
				  mov ecx,newsize
				  mov g_ndatabasesize,ecx
				.ENDIF

	.ENDIF

;v3.46 got another bug, as addcomposites2menu() writes to the database,
;to library-data-element.ximage, which is a problem as only call compactdatabase()
;from savedatafile(), just after latter has called deletebitmaphandles().
;so, have relocated this call to savedatafile() after it has saved to file...
;got a bug... library-objects in the Elements menu have menu-id = .number+4000
;of the dataelement attached to the object. however, .numbers have changed.
;need to re-do the menu whenever database is shuffled.... like now (also
;in "move1object,pobj,2" which shifts entire database by 1 record).
;	invoke addcomposites2menu,0

out1:
  ret
compactdatabase ENDP
;--------------------------------------------------------------------------
zeroabsoluteptrs PROC STDCALL USES eax ebx ecx edx esi edi,nwhich:DWORD
	LOCAL dummy:DWORD

; "zeroabsoluteptrs"
;always do these...
									;all absolute pointers are invalid...
									mov g_pmovingobject,0
									mov poldmovingobject,0
									mov g_pselectedobjnew,0
									mov g_pselectedobject,0
									mov g_perrorobject,0
										mov al,g_nstate 		 ;/
										mov g_nstateprev,al  ;/
									mov g_nstate,0
	.IF nwhich==1
		mov wipeoutsindex,0
		mov fptrsinvalid_wipeoutslaves,1 ;to speedup wipeoutslaves() v2.74
		mov updatesindex,0
		mov fptrsinvalid_nearobjects,1 ;to speedup nearobjects().
		mov highlightedindex,0
		mov highlightedindexnewlist,0
		invoke add2anilist,0 ;0=wipe all entries.
	.ENDIF
	ret

zeroabsoluteptrs ENDP
;------------------------------------------------------------------------
down_sendbackfront PROC STDCALL, hdlg:DWORD,idfront:DWORD,idback:DWORD
;callback code.  edi passed in.

;*WARNING* these must be last in callback download, as can invalidate the ptr edi...
;bring the element to the front...
		  invoke SendDlgItemMessage,hdlg,idfront,BM_GETCHECK,0,0
		  .IF ax==1
				invoke move1object,edi,1 ;relocate at end of database.
				jmp j66
		  .ENDIF
;send the element to the back...
		  invoke SendDlgItemMessage,hdlg,idback,BM_GETCHECK,0,0
		  .IF ax==1
				invoke move1object,edi,2 ;0 ;relocate at start of database.
		  .ENDIF
j66:	  ;...move1object returns address new object location in eax.

	ret
down_sendbackfront ENDP
;------------------------------------------------------------------------

down_owner PROC STDCALL, hdlg:DWORD,idowner:DWORD,fend:DWORD
;callback code. edi passed in.
;fend=0 1st end of wire, all other elements. fend=1 2nd end wire.

;update number of object that owns this node ...
 invoke SendDlgItemMessage,hdlg,idowner,WM_GETTEXT,6,ADDR szasciitbl   ;399
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;special case 0, none owns me...
				;(there is an element #0, but can't be an owner).
				.IF eax==0
				  mov (OBJECT PTR [edi]).nbeginvertice,0 ;which vertice attached to if poly.
				  jmp e206
				.ENDIF
				mov ebx,pTERSEDATA
				  ;validate...
				  ;xor ecx,ecx
				  mov ecx,(TERSEDATA PTR [ebx]).numrecords
				  .IF eax>=ecx
						;off end of database...
e202:				invoke myalertbox,ADDR szer011,4  ;invoke myerrorhandler,011
					xor eax,eax ;return error flag.
					jmp noexitdlg
				  .ENDIF
				;xor ecx,ecx
				mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
				mul ecx
				  mov edx,(TERSEDATA PTR [ebx]).noffsetobjs
				  add edx,ebx ;pTERSEDATA ;starting address of OBJECTS.
				  add eax,edx			 ;eax->owner.
				  mov ebx,eax
						mov ecx,(OBJECT PTR [ebx]).fstatus
						and ecx,01
						.IF ecx==0
						  ;invalid element...
						  jmp e202
						.ELSE
						  mov ecx,(OBJECT PTR [ebx]).nexttype
						  .IF SWORD PTR cx<0 ;ecx==-1
								;this is an invisible element.
								jmp e202
						  .ENDIF
						.ENDIF
				sub eax,pTERSEDATA
e206:		  .IF fend==0
				mov  (OBJECT PTR [edi]).rpowner1,eax
			  .ELSE
				mov  (OBJECT PTR [edi]).rpowner2,eax
			  .ENDIF
				mov eax,1 ;flag no error.
noexitdlg:
	ret
down_owner ENDP
;------------------------------------------------------------------------
down_lock PROC STDCALL, hdlg:DWORD
; "down_lock"
;common callback code.
;update lock state...
		  invoke SendDlgItemMessage,hdlg,251,BM_GETCHECK,0,0
		  .IF ax==1
				or (OBJECT PTR [edi]).fconfig4,01000b ;set bit3
		  .ELSE
				and (OBJECT PTR [edi]).fconfig4,0FFFFFFF7h
		  .ENDIF


	ret
down_lock ENDP
;------------------------------------------------------------------------
displaynumthis PROC STDCALL, hdlg:DWORD
; "displaynumthis"
;common callback code.
;display number of this object/element...
				mov  eax,(OBJECT PTR [edi]).number
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,302,WM_SETTEXT,0,eax
; invoke SendDlgItemMessage,hdlg,302,EM_LIMITTEXT,5,0 ;set limit.

;display element# of owner...
				mov eax,(OBJECT PTR [edi]).rpowner1
				.IF eax==0
				.ELSE
				  add eax,pTERSEDATA
				  mov ebx,eax
				  mov  eax,(OBJECT PTR [ebx]).number
				  invoke bin2dec,10 				 ;-->szasciitbl
				  ;...returns eax->start of string, past the leading blanks.
				  invoke SendDlgItemMessage,hdlg,399,WM_SETTEXT,0,eax
				.ENDIF
				invoke SendDlgItemMessage,hdlg,399,EM_LIMITTEXT,5,0 ;set limit.

;display lock state...
				mov eax,(OBJECT PTR [edi]).fconfig4
				and al,01000b
				.IF al==1000b  ;bit3
				  invoke SendDlgItemMessage,hdlg,251,BM_SETCHECK,1,0
				.ENDIF


	ret
displaynumthis ENDP
;------------------------------------------------------------------------
up_widthheight PROC STDCALL, hdlg:DWORD
; "displaywidthheight"
;common callback code.

;display height of ellipse...
				mov  eax,(OBJECT PTR [edi]).height
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,245,WM_SETTEXT,0,eax
				invoke SendDlgItemMessage,hdlg,245,EM_LIMITTEXT,4,0 ;set limit.

;display width of ellipse...
				mov  eax,(OBJECT PTR [edi]).wwidth
				invoke bin2dec,10				   ;-->szasciitbl
				;...returns eax->start of string, past the leading blanks.
				invoke SendDlgItemMessage,hdlg,244,WM_SETTEXT,0,eax
				invoke SendDlgItemMessage,hdlg,244,EM_LIMITTEXT,4,0 ;set limit.

;v1.27
;exact width/height checkbox...
			mov eax,(OBJECT PTR [edi]).fconfig4
			and al,010000b ;bit4.
			.IF al==010000b
				invoke SendDlgItemMessage,hdlg,310,BM_SETCHECK,1,0
			.ENDIF

	ret
up_widthheight ENDP
;------------------------------------------------------------------------
down_widthheight PROC STDCALL, hdlg:DWORD
; "down_widthheight"
;common callback code.

;v1.27
;update exact width/height...
   invoke SendDlgItemMessage,hdlg,310,BM_GETCHECK,0,0
   mov ebx,(OBJECT PTR [edi]).fconfig4
   .IF ax==1
	 or bl,010000b ;set bit4.
   .ELSE
	 and bl,011101111b ;clr bit4.
   .ENDIF
   mov (OBJECT PTR [edi]).fconfig4,ebx

;update height...
 invoke SendDlgItemMessage,hdlg,245,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;don't allow -ve number...
				.IF SDWORD PTR eax<0
				  neg eax
				  jmp SHORT e200
				.ELSE
e200:			  mov  (OBJECT PTR [edi]).height,eax
				  shr eax,1
				  add eax,(OBJECT PTR [edi]).ytopleft
				  mov (OBJECT PTR [edi]).ymid,eax
				.ENDIF

;update width...
 invoke SendDlgItemMessage,hdlg,244,WM_GETTEXT,5,ADDR szasciitbl
				invoke str2longint, ADDR szasciitbl ;-->integer in eax
				;no -ve...
				.IF SDWORD PTR eax<0
				  neg eax
				  jmp SHORT e201
				.ELSE
e201:			  mov  (OBJECT PTR [edi]).wwidth,eax
				  shr eax,1
				  add eax,(OBJECT PTR [edi]).xtopleft
				  mov (OBJECT PTR [edi]).xmid,eax
				.ENDIF

	ret
down_widthheight ENDP
;------------------------------------------------------------------------
displaynumber PROC STDCALL USES ebx ecx edx esi edi, nmx:DWORD
				LOCAL htmpwinx:DWORD
				LOCAL htextfont:DWORD
				LOCAL holdtextfont:DWORD,colorold:DWORD
;entered with value to display --usually element#.	"displaynumber"
;based on code in displaymouse().
;called from wmlbuttonup()/entering state2.

				invoke GetWindowDC, g_hwnd
				mov  htmpwinx,eax

;select font...
  mov  eax,12  ;12 points size
  neg  eax
 ;times new roman...
  ;mov g_errorapi,0B57h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
 invoke CreateFont,eax,0,0,0,0,0,0,0,0,OUT_TT_ONLY_PRECIS,0,0,VARIABLE_PITCH,ADDR sztimesnewroman
  mov  htextfont,eax
;assign font to display context...
  invoke SelectObject, htmpwinx,htextfont
  mov  holdtextfont,eax
  invoke SetTextColor, htmpwinx,00FF0000h ;blue
  mov colorold,eax

;  invoke SetBkMode, htmpwinx,TRANSPARENT

;i've got a problem as win95 is only 16bit coords. so, -ve coord
;will have bit15=1, but can i be sure there is sign extension?
;i'm testing just bit15 here... ***NOTE***
				 mov  eax,nmx
				 invoke bin2dec,10 ;eax-->szasciitbl(convert to ascii)
				 mov edi,eax
				 ;v1.21 wmcreate() computes g_cycaption, height of caption, and g_cyframe, height
						   ;of frame...
						   mov eax,g_cycaption
						   add eax,g_cyframe
						   mov ebx,g_windowright ;see wmsize() and wmcreate().
						   sub ebx,g_cyframe
						   sub ebx,160 ;xcoord is -120, ycoord is -63.
						   push eax
						   push ebx
						 invoke TextOut, htmpwinx,ebx,eax,ADDR szblanks,11 ;10 ;18
						   pop ebx
						   pop eax
						   inc ebx
						 invoke TEXTOUTx, htmpwinx,ebx,eax,edi,5 ;9
						 ;...display 5 chars or up to first zero.

				invoke SetTextColor, htmpwinx,colorold
;***NOTE*** found must delete object AFTER selecting old one back to DC...
;(otherwise, fonts go funny)
				invoke SelectObject, htmpwinx,holdtextfont
				invoke DeleteObject, htextfont

				invoke ReleaseDC, g_hwnd,htmpwinx

  ret
displaynumber ENDP
;--------------------------------------------------------------------------
calcboundingrecthi PROC STDCALL USES ebx ecx edx esi edi
	LOCAL ebxsave:DWORD,ffirst:DWORD,exttype:DWORD
	LOCAL varray[84]:SDWORD
	;LOCAL xleft:DWORD,ytop:DWORD,xright:DWORD,ybottom:DWORD
;v1.92 "calcboundingrecthi"
;calc the bounding rectangle around all highlighted elements, in highlightedlist.
;if g_pselectedobject non-0, use code as in IDM_DUP, to place it and all slaves
;into highlightedlist -- do this prior to calling this func.
; -- so will get a bounding rect for a composite-obj for example.
		mov ffirst,0
;go thru highlightedlist...
		mov ebx,0
fend2:
		lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...
			mov eax,(OBJECT PTR [esi]).fstatus
			and ax,01
			.IF ax==01	  ;bit0=1, valid object.
			  mov eax,(OBJECT PTR [esi]).nexttype
			  mov exttype,eax
			  .IF SWORD PTR ax<0 ;ax==-1
				;precaution. these shouldn't be in highlightedlist anyway.
			  .ELSE 						  ;not a data object.
				;v1.86 need to bypass if certain element types...
				.IF ax>=20 ;page grid
				  .IF ax<=29 ;range set aside for grids.
					jmp fend3 ;get next element.
				  .ENDIF
				.ENDIF
				.IF ax>=40 ;animation activator.
				  .IF ax<=49 ;range set aside for activators.
					jmp fend3 ;get next element.
				  .ENDIF
				.ENDIF

					;initial values for bounding rectangle...
					.IF ffirst==0 ;1st time thru.
					  mov eax,(OBJECT PTR [esi]).xtopleft
					  mov n1stx,eax
					  mov ebx,(OBJECT PTR [esi]).ytopleft
					  mov n1sty,ebx
					  mov ecx,(OBJECT PTR [esi]).fconfig1
					  and cl,01
					  .IF cl==0 ;non-wire type element.
						.IF exttype==5 ;polygon/polyline. v1.94.
						  jmp SHORT fas9
						.ENDIF
						add eax,(OBJECT PTR [esi]).wwidth
						mov n2ndx,eax
						add ebx,(OBJECT PTR [esi]).height
						mov n2ndy,ebx
					  .ELSE
fas9:					;i don't think it will do any harm to use same coords...
						mov n2ndx,eax
						mov n2ndy,ebx
					  .ENDIF
					.ENDIF
					mov ffirst,1

				mov eax,exttype
				.IF ax==0 ;ellipse.
bnd1:				  ;update bounding rectangle...
					  mov eax,(OBJECT PTR [esi]).xtopleft
					  .IF SDWORD PTR eax<n1stx ;xleft
						mov n1stx,eax
					  .ENDIF
					  add eax,(OBJECT PTR [esi]).wwidth
					  .IF SDWORD PTR eax>n2ndx ;xright
						mov n2ndx,eax
					  .ENDIF
					  mov eax,(OBJECT PTR [esi]).ytopleft
					  .IF SDWORD PTR eax<n1sty ;ytop
						mov n1sty,eax
					  .ENDIF
					  add eax,(OBJECT PTR [esi]).height
					  .IF SDWORD PTR eax>n2ndy ;ybottom
						mov n2ndy,eax
					  .ENDIF

				.ELSEIF ax==3  ;rectangle
				  jmp bnd1
				.ELSEIF ax==4  ;rounded rectangle.
				  jmp bnd1

				.ELSEIF ax==5  ;polygon or polyline.
ww1:			  ;have to look at all vertices to update bounding rectangle...
				  mov ecx,(OBJECT PTR [esi]).ncorners
					;need to consider extra pts >14...	v2.18
					.IF ecx>14
					  push ecx
					  lea edx,varray
					  invoke combinepolyarrays ;uses esi,edx.
					  lea ebx,varray ;x
					  mov edi,ebx
					  add edi,4 	 ;y
					  pop ecx
					  jmp E11
					.ENDIF
ww1b:			  lea ebx,(OBJECT PTR [esi]).bez0x
				  lea edi,(OBJECT PTR [esi]).bez0y
E11:				mov eax,[ebx]
					  .IF SDWORD PTR eax<n1stx ;xleft
						mov n1stx,eax
					  .ENDIF
					  .IF SDWORD PTR eax>n2ndx ;xright
						mov n2ndx,eax
					  .ENDIF
					mov eax,[edi]
					  .IF SDWORD PTR eax<n1sty ;ytop
						mov n1sty,eax
					  .ENDIF
					  .IF SDWORD PTR eax>n2ndy ;ybottom
						mov n2ndy,eax
					  .ENDIF
				  add ebx,8
				  add edi,8
				  loop E11

				.ELSEIF ax==11 ;sticky line, bezier.
				  mov ecx,9 ;#vertices in a sticky line.
				  jmp ww1b
				.ELSEIF ax==12 ; /			 segmented.
				  mov ecx,9
				  jmp ww1b
				.ELSEIF ax==13 ; /			 straight.
				  mov ecx,9
				  jmp ww1b

				.ELSEIF ax==33 ;label.
				  ;selectedsaveassvg() calcs entire bndg rect of text (calls
				  ;paint_label() to calc the textrect), however, i think here
				  ;we will just use the handle itself...
				  jmp bnd1

				.ELSEIF ax>=60
				  .IF ax<=69   ;icon.
					jmp bnd1
				  .ENDIF

				.ELSE
				  ;generic handling, in case any other type of element in future...
					  mov ecx,(OBJECT PTR [esi]).fconfig1
					  and cl,01
					  .IF cl==0 ;non-wire type element.
						jmp bnd1
					  .ELSE
						mov ecx,9
						jmp ww1b
					  .ENDIF

				.ENDIF


			  .ENDIF
			.ENDIF
fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
		mov eax,FALSE
		ret


calcboundingrecthi ENDP
;--------------------------------------------------------------------------
resizehighlighted PROC STDCALL USES ebx ecx edx esi edi,xchange:DWORD,ychange:DWORD
		LOCAL pmem:DWORD,sizeobj:DWORD,ebxsave:DWORD
		LOCAL fbuff:DWORD,nsizeratio:DWORD
		;LOCAL varray[84]:DWORD
;v1.92 "resizehighlighted"
;based on stretchcompobj() code.
;g_pshadowmem pts to a copy of the highlighted elements. this has all the
;original coords.
;xchange/ychange are change from original size.


		mov eax,g_pshadowmem
		.IF eax==0	;precaution.
		  jmp fend1
		.ENDIF
		mov pmem,eax ;pt to next element in shadow mem block.
		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,eax

;go thru highlightedlist...
		mov ebx,0
fend2:
		lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...
		  mov edi,pmem ;edi pts to same element in shadow memblock, original coords.
		  mov eax,sizeobj
		  add pmem,eax ;set pmem ptg to next element.

				mov eax,(OBJECT PTR [esi]).fstatus
				and al,01
				  .IF al==01	;bit0=1, valid object. precaution.
					mov eax,(OBJECT PTR [esi]).nexttype
					.IF SWORD PTR ax<0 ;data object precaution.
					.ELSE

									  .IF ax>=60 ;icon.
										.IF ax<=69	 ;/
										  ;if has bitmap attached, need to set "Lock"...
										  ;to prevent going back to orig size...
										  mov eax,(OBJECT PTR [esi]).rpdata2 ;bitmap.
										  .IF eax != 0
											or (OBJECT PTR [esi]).fconfig4,01000b ;bit3.
										  .ENDIF
										.ENDIF
									  .ENDIF

										  mov eax,n2ndx  ;right side.
										  sub eax,n1stx
										    ;v2.29 precaution...
										    .IF eax==0
										      inc n2ndx
										      inc eax
 				                            .ELSEIF SDWORD PTR eax<0
				                              mov eax,n1stx
	    		       	                      inc eax
				                              mov n2ndx,eax
				                              mov eax,1
										    .ENDIF
										  mov fbuff,eax
										  fild fbuff
										  mov eax,n2ndx0 ;original right side.
										  sub eax,n1stx  ;orig width.
										    ;v2.29 precaution...
										    .IF eax==0
										      inc n2ndx0
										      inc eax
 				                            .ELSEIF SDWORD PTR eax<0
				                              mov eax,n1stx
	    		       	                      inc eax
				                              mov n2ndx0,eax
				                              mov eax,1
										    .ENDIF
										  mov fbuff,eax
										  fidiv fbuff	 ;x size-change ratio.
										  fstp nsizeratio ;f/p.

								  mov al,g_nknee
								  .IF xchange != 0 ;right handle.
									mov edx,xchange
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
nz2:								  mov ebx,0
nz3:									push ecx
										mov eax,(OBJECT PTR [edi+ebx]).bez0x ;x_original.
										;now calc the amount of change to apply...
										;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										sub eax,n1stx
										imul xchange
										mov ecx,n2ndx0
										sub ecx,n1stx
										idiv ecx
										mov ecx,(OBJECT PTR [edi+ebx]).bez0x ;x_original.
										sub ecx,eax
										mov (OBJECT PTR [esi+ebx]).bez0x,ecx
										pop ecx
									  add ebx,8 ;next x bezier point.
									  loop nz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										  jmp nz2
									  .ELSEIF ax==33 ;label.
										  ;if xchange,ychange both non0, need to resize text, as this is
										  ;x/y keep-proportions resizing...
										  .IF ychange != 0
										    fld nsizeratio ;f/p.
										    fimul (OBJECT PTR [edi]).nfontsize
										    fistp (OBJECT PTR [esi]).nfontsize
											  ;adjust y label offset. i've decided only do this when
											  ;resizing font-size (SHIFT down)...
											  mov eax,(OBJECT PTR [edi]).ylabeloffset
											  sub eax,7 ;fixed y-offset.
											  mov fbuff,eax
											  fild fbuff
											  fmul nsizeratio
											  fistp fbuff
											  mov eax,fbuff
											  add eax,7
											  sar eax,1 ;seems have to halve it.
											  mov (OBJECT PTR [esi]).ylabeloffset,eax
										  .ENDIF
										  ;this needs to be done regardless if SHIFT down or not...
											;adj label offset...
											mov eax,(OBJECT PTR [edi]).xlabeloffset
											add eax,6
											mov fbuff,eax ;fixed x-offset.
											fild fbuff
											fmul nsizeratio
											fistp fbuff
											mov eax,fbuff
											sub eax,6	  ;correction factor for xlabeloffset.
											mov (OBJECT PTR [esi]).xlabeloffset,eax
										  jmp SHORT aa1
									  .ELSE
aa1:									;all other types...
										  mov eax,(OBJECT PTR [edi]).xtopleft
										  ;now calc the amount of change to apply...
										  ;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										  sub eax,n1stx
										  imul xchange
										  mov ecx,n2ndx0
										  sub ecx,n1stx
										  idiv ecx
										  mov ecx,(OBJECT PTR [edi]).xtopleft
										  sub ecx,eax
										  mov (OBJECT PTR [esi]).xtopleft,ecx
										  mov eax,(OBJECT PTR [edi]).xmid
										  sub eax,n1stx
										  imul xchange
										  mov ecx,n2ndx0
										  sub ecx,n1stx
										  idiv ecx
										  mov ecx,(OBJECT PTR [edi]).xmid
										  sub ecx,eax
										  mov (OBJECT PTR [esi]).xmid,ecx
										  sub ecx,(OBJECT PTR [esi]).xtopleft
										  shl ecx,1
										  mov (OBJECT PTR [esi]).wwidth,ecx
										  ;v2.29 precaution...
										  .IF ecx==0
										    mov (OBJECT PTR [esi]).wwidth,2
										    mov eax,(OBJECT PTR [esi]).xtopleft
										    add eax,1
										    mov (OBJECT PTR [esi]).xmid,eax
										  .ENDIF
										  
										  ;v2.97 partial ellipse...
										  mov eax,(OBJECT PTR [esi]).nexttype
										  .IF eax==0 ;ellipse, all types.
										    ;start handle, x...
										    mov eax,(OBJECT PTR [edi]).rxstartarc
										    add eax,(OBJECT PTR [edi]).xtopleft ;make absolute.
										    ;now calc the amount of change to apply...
										    ;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										    sub eax,n1stx
										    imul xchange
										    mov ecx,n2ndx0
										    sub ecx,n1stx
										    idiv ecx
										    mov ecx,(OBJECT PTR [edi]).rxstartarc
										    add ecx,(OBJECT PTR [edi]).xtopleft ;make absolute.
										    sub ecx,eax
										    sub ecx,(OBJECT PTR [esi]).xtopleft ;make relative.
										    mov (OBJECT PTR [esi]).rxstartarc,ecx
										    ;end handle, x...
										    mov eax,(OBJECT PTR [edi]).rxendarc
										    add eax,(OBJECT PTR [edi]).xtopleft ;make absolute.
										    ;now calc the amount of change to apply...
										    ;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										    sub eax,n1stx
										    imul xchange
										    mov ecx,n2ndx0
										    sub ecx,n1stx
										    idiv ecx
										    mov ecx,(OBJECT PTR [edi]).rxendarc
										    add ecx,(OBJECT PTR [edi]).xtopleft ;make absolute.
										    sub ecx,eax
										    sub ecx,(OBJECT PTR [esi]).xtopleft ;make relative.
										    mov (OBJECT PTR [esi]).rxendarc,ecx
										  .ENDIF
										  
									  .ENDIF
									.ENDIF
								  .ENDIF

										  mov eax,n2ndy  ;bottom side.
										  sub eax,n1sty
										    ;v2.29 precaution...
										    .IF eax==0
										      inc n2ndy
										      inc eax
 				                            .ELSEIF SDWORD PTR eax<0
				                              mov eax,n1sty
	    		       	                      inc eax
				                              mov n2ndy,eax
				                              mov eax,1
										    .ENDIF
										  mov fbuff,eax
										  fild fbuff
										  mov eax,n2ndy0 ;original bottom side.
										  sub eax,n1sty  ;orig height.
										    ;v2.29 precaution...
										    .IF eax==0
										      inc n2ndy0
										      inc eax
 				                            .ELSEIF SDWORD PTR eax<0
				                              mov eax,n1sty
	    		       	                      inc eax
				                              mov n2ndy0,eax
				                              mov eax,1
										    .ENDIF
										  mov fbuff,eax
										  fidiv fbuff	 ;y size-change ratio.
										  fstp nsizeratio ;f/p.

								  .IF ychange != 0 ;bottom handle.
									mov edx,ychange
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
xnz2:								  mov ebx,0
xnz3:									push ecx
										mov eax,(OBJECT PTR [edi+ebx]).bez0y ;y_original.
										;now calc the amount of change to apply...
										;((y_original-n1sty)/(n2ndy0-n1sty))*ychange
										sub eax,n1sty
										imul ychange
										mov ecx,n2ndy0
										sub ecx,n1sty
										idiv ecx
										mov ecx,(OBJECT PTR [edi+ebx]).bez0y ;y_original.
										sub ecx,eax
										mov (OBJECT PTR [esi+ebx]).bez0y,ecx
										pop ecx
									  add ebx,8 ;next y bezier point.
									  loop xnz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										  jmp xnz2
									  .ELSEIF ax==33 ;label
											;not here, see above...
											;mov eax,(OBJECT PTR [edi]).ylabeloffset
											;sub eax,7 ;fixed y-offset.
											;mov fbuff,eax
											;fild fbuff
											;fmul nsizeratio
											;fistp fbuff
											;mov eax,fbuff
											;add eax,7
											;mov (OBJECT PTR [esi]).ylabeloffset,eax
										  jmp SHORT aa4
									  .ELSE
aa4:									;all other types...
										  mov eax,(OBJECT PTR [edi]).ytopleft
										  ;now calc the amount of change to apply...
										  ;((y_original-n1sty)/(n2ndy0-n1sty))*ychange
										  sub eax,n1sty
										  imul ychange
										  mov ecx,n2ndy0
										  sub ecx,n1sty
										  idiv ecx
										  mov ecx,(OBJECT PTR [edi]).ytopleft
										  sub ecx,eax
										  mov (OBJECT PTR [esi]).ytopleft,ecx
										  mov eax,(OBJECT PTR [edi]).ymid
										  sub eax,n1sty
										  imul ychange
										  mov ecx,n2ndy0
										  sub ecx,n1sty
										  idiv ecx
										  mov ecx,(OBJECT PTR [edi]).ymid
										  sub ecx,eax
										  mov (OBJECT PTR [esi]).ymid,ecx
										  sub ecx,(OBJECT PTR [esi]).ytopleft
										  shl ecx,1
										  mov (OBJECT PTR [esi]).height,ecx
										  ;v2.29 precaution...
										  .IF ecx==0
										    mov (OBJECT PTR [esi]).height,2
										    mov eax,(OBJECT PTR [esi]).ytopleft
										    add eax,1
										    mov (OBJECT PTR [esi]).ymid,eax
										  .ENDIF
										  
										  ;v2.97 partial ellipse...
										  mov eax,(OBJECT PTR [esi]).nexttype
										  .IF eax==0 ;ellipse, all types.
										    ;start handle, y...
										    mov eax,(OBJECT PTR [edi]).rystartarc
										    add eax,(OBJECT PTR [edi]).ytopleft ;make absolute.
										    ;now calc the amount of change to apply...
										    ;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										    sub eax,n1sty
										    imul ychange
										    mov ecx,n2ndy0
										    sub ecx,n1sty
										    idiv ecx
										    mov ecx,(OBJECT PTR [edi]).rystartarc
										    add ecx,(OBJECT PTR [edi]).ytopleft ;make absolute.
										    sub ecx,eax
										    sub ecx,(OBJECT PTR [esi]).ytopleft ;make relative.
										    mov (OBJECT PTR [esi]).rystartarc,ecx
										    ;end handle, y...
										    mov eax,(OBJECT PTR [edi]).ryendarc
										    add eax,(OBJECT PTR [edi]).ytopleft ;make absolute.
										    ;now calc the amount of change to apply...
										    ;((x_original-n1stx)/(n2ndx0-n1stx))*xchange
										    sub eax,n1sty
										    imul ychange
										    mov ecx,n2ndy0
										    sub ecx,n1sty
										    idiv ecx
										    mov ecx,(OBJECT PTR [edi]).ryendarc
										    add ecx,(OBJECT PTR [edi]).ytopleft ;make absolute.
										    sub ecx,eax
										    sub ecx,(OBJECT PTR [esi]).ytopleft ;make relative.
										    mov (OBJECT PTR [esi]).ryendarc,ecx										
										  .ENDIF
										  
									  .ENDIF
									.ENDIF
								  .ENDIF

					.ENDIF
				  .ENDIF

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
  ret
resizehighlighted ENDP
;--------------------------------------------------------------------------
shadowhighlighted PROC STDCALL USES ebx ecx edx esi edi
	LOCAL ebxsave:DWORD
	LOCAL pshadowmem:DWORD,pmem:DWORD,sizeobj:DWORD
;v1.93
;idm_resizesel --> resizehighlighted() draws a rect around the highlighted
;elements, with drag handles. can drag the handles, in state30.
;however, need to keep original copies of the highlighted elements, so
;have the original coords.
;this func creates a mem. block and copies highlighted elements to it.
;return eax=0 if failed to copy anything, else eax=addr of shadow mem block.

;create a mem block...
		mov eax,highlightedindex
		.IF eax==0
		  jmp out1
		.ENDIF
		mov ebx,pTERSEDATA
		mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,ecx
		mul ecx ;eax now has required size for mem block.
  ;mov g_errorapi,0B58h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
		invoke GlobalAlloc,GMEM_FIXED,eax
		mov pshadowmem,eax
		mov pmem,eax

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...
		  ;copy element to shadow mem block...
		  mov ecx,sizeobj
		  mov edi,pmem
fas7:	  mov al,[esi]
		  mov [edi],al
		  inc esi
		  inc edi
		  loop fas7
		  mov pmem,edi ;pt to next free addr in shadow mem block.

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:	mov eax,pshadowmem ;return.
out1:
	ret
shadowhighlighted ENDP
;--------------------------------------------------------------------------
copyshadow2hi PROC STDCALL USES ebx ecx edx esi edi
	LOCAL ebxsave:DWORD
	LOCAL pmem:DWORD,sizeobj:DWORD
;v2.20 "copyshadow2hi"
;restores shadow memory back to highlighted list.
;opposite to shadowhighlighted().

		mov eax,highlightedindex
		mov ebx,pTERSEDATA
		mov ecx,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,ecx
		mov eax,g_pshadowmem
		mov pmem,eax

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...
		  ;copy element to shadow mem block...
		  mov ecx,sizeobj
		  mov edi,pmem
fas7:	  mov al,[edi]
		  mov [esi],al
		  inc esi
		  inc edi
		  loop fas7
		  mov pmem,edi ;pt to next free addr in shadow mem block.

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
out1:
	ret
copyshadow2hi ENDP
;--------------------------------------------------------------------------
copyhi2wipe PROC STDCALL USES eax ebx ecx edx esi edi
	LOCAL ebxsave:DWORD
;v1.95 "copyhi2wipe"
;copy contents of highlightedlist to wipeoutlist.

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3

		  ;drop here, esi->element from highlighted list...
		  invoke add2wipeoutlist,esi
		  invoke wipeoutslaves,esi ;adds attached to wipeout list also.

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:

	ret
copyhi2wipe ENDP
;--------------------------------------------------------------------------
copyhi2update PROC STDCALL USES eax ebx ecx edx esi edi
	LOCAL ebxsave:DWORD
;v1.99 "copyhi2update"
;copy contents of highlightedlist to updatelist.

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3

		  ;drop here, esi->element from highlighted list...
		  invoke add2updatelist,esi
		  invoke updateslaves,esi,0,0,0 ;xchange,ychange,finclude_esi

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:

	ret
copyhi2update ENDP
;--------------------------------------------------------------------------
stretchhighlighted PROC STDCALL USES ebx ecx edx esi edi,pmoving:DWORD,xchange:DWORD,ychange:DWORD
		LOCAL xcentre:SDWORD,ycentre:SDWORD
		LOCAL sizeobj:DWORD,ebxsave:DWORD
		LOCAL tempelement:OBJECT,ncornersignore:DWORD,nleft:BYTE,nright:BYTE
;v1.97 "stretchhighlighted"
;based on stretchcompobj() and resizehighlighted() code.
;Control/Align-stretch selected elements -> IDM_STRETCHSEL --> new stretch-axes-element
; -> wmmousemove()/state8 -> here.

;v1.99 i want an element to stop moving if any vertice touches an axis. so, for
;each element, copy it to tempelement, apply vertice changes, see if any vertice
;close to an axis, yes, then calc another small change so that the vertice will be
;exactly on

		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,eax

		mov ebx,pmoving
		mov eax,(OBJECT PTR [ebx]).xtopleft
		add eax,3 ;xmid. (using .xmid doesn't work, dunno why)
		mov xcentre,eax
		mov eax,(OBJECT PTR [ebx]).ytopleft
		add eax,3 ;ymid.
		mov ycentre,eax

;go thru highlightedlist...
		mov ebx,0
fend2:
		lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...

		  mov eax,(OBJECT PTR [esi]).fstatus
		  and al,01
		  .IF al==01	;bit0=1, valid object. precaution.
			mov eax,(OBJECT PTR [esi]).nexttype
			.IF SWORD PTR ax<0 ;data/invisible object precaution.
			.ELSE

			  invoke add2updatelist,esi
			  mov eax,(OBJECT PTR [esi]).fconfig1 ;v1.99.
			  and al,01000b ;bit3 = stopped flag.
			  .IF al==0
						  .IF esi==pmoving		;don't test itself.
							;...well, not required, as pmoving is the alignment-axes-element,
							;which isn't in highlighted list.
						  .ELSE

							;v1.99 copy to tempelement...
							push esi
							mov ecx,sizeobj
							lea ebx,tempelement
yup1:						mov al,[esi]
							mov [ebx],al
							inc ebx
							inc esi
							loop yup1
							pop esi
							mov nleft,0 ;#vertices to left of axis.
							mov nright,0 ; / to right.

								  mov al,g_nknee
								  .IF al==1 ;right handle.
									mov edx,xchange
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
									  mov ncornersignore,0
nz2:								  mov ebx,0
nz3:								  mov eax,(OBJECT PTR [esi+ebx]).bez0x
									  .IF SDWORD PTR eax>=xcentre
										.IF SDWORD PTR ecx>ncornersignore
										  inc nright
										.ENDIF
										sub (OBJECT PTR [esi+ebx]).bez0x,edx
									  .ELSE
										.IF SDWORD PTR ecx>ncornersignore
										  inc nleft
										.ENDIF
										add (OBJECT PTR [esi+ebx]).bez0x,edx
									  .ENDIF
									  add ebx,8 ;next bezier point.
									  loop nz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										  mov eax,ecx
										  sub eax,(OBJECT PTR [esi]).ncorners ;actual #crnrs.
										  mov ncornersignore,eax ;#vertices to ignore for
										  ;alignment purposes.
										  jmp nz2
									  .ELSE
										  ;all other types...
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  .IF SDWORD PTR eax>=xcentre
										    inc nright
										    sub (OBJECT PTR [esi]).xtopleft,edx
										  .ELSE
										    inc nleft
										    
										    ;v2.97 partial ellipse handles...
										    mov eax,(OBJECT PTR [esi]).nexttype
										    .IF eax==0 ;ellipse, all types.
										      ;start handle, x...
										      mov eax,(OBJECT PTR [esi]).xtopleft
										      add eax,(OBJECT PTR [esi]).rxstartarc ;make absolute.
										      .IF SDWORD PTR eax>=xcentre
											      inc nright
											      sub (OBJECT PTR [esi]).rxstartarc,edx
											      sub (OBJECT PTR [esi]).rxstartarc,edx
										      .ELSE
											      inc nleft
										      .ENDIF
										      ;end handle, x...
										      mov eax,(OBJECT PTR [esi]).xtopleft
										      add eax,(OBJECT PTR [esi]).rxendarc ;make absolute.
										      .IF SDWORD PTR eax>=xcentre
											      inc nright
											      sub (OBJECT PTR [esi]).rxendarc,edx
											      sub (OBJECT PTR [esi]).rxendarc,edx
										      .ELSE
											      inc nleft
										      .ENDIF
										    .ENDIF
										    
										    mov eax,(OBJECT PTR [esi]).xtopleft
										    add eax,(OBJECT PTR [esi]).wwidth
										    .IF SDWORD PTR eax>=xcentre
											    inc nright
											    sub (OBJECT PTR [esi]).wwidth,edx
											    sub (OBJECT PTR [esi]).wwidth,edx
										    .ELSE
											    inc nleft
										    .ENDIF
										    add (OBJECT PTR [esi]).xtopleft,edx
										  .ENDIF
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  mov ecx,(OBJECT PTR [esi]).wwidth
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).xmid,eax
									  .ENDIF
									.ENDIF

								  .ELSEIF al==2 ;bottom handle.
									mov edx,ychange
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
									  mov ncornersignore,0
xnz2:								  mov ebx,0
xnz3:								  mov eax,(OBJECT PTR [esi+ebx]).bez0y
									  .IF SDWORD PTR eax>=ycentre
										.IF SDWORD PTR ecx>ncornersignore
										  inc nright
										.ENDIF
										sub (OBJECT PTR [esi+ebx]).bez0y,edx
									  .ELSE
										.IF SDWORD PTR ecx>ncornersignore
										  inc nleft
										.ENDIF
										add (OBJECT PTR [esi+ebx]).bez0y,edx
									  .ENDIF
									  add ebx,8 ;next bezier point.
									  loop xnz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										mov eax,ecx
										sub eax,(OBJECT PTR [esi]).ncorners ;actual #crnrs.
										mov ncornersignore,eax ;#vertices to ignore for
										;alignment purposes.
										jmp xnz2
									  .ELSE
										;all other types...
										mov eax,(OBJECT PTR [esi]).ytopleft
										.IF SDWORD PTR eax>=ycentre
										  inc nright
										  sub (OBJECT PTR [esi]).ytopleft,edx
										.ELSE
										  inc nleft
										  
										    ;v2.97 partial ellipse handles...
										    mov eax,(OBJECT PTR [esi]).nexttype
										    .IF eax==0 ;ellipse, all types.
										      ;start handle, y...
										      mov eax,(OBJECT PTR [esi]).ytopleft
										      add eax,(OBJECT PTR [esi]).rystartarc ;make absolute.
										      .IF SDWORD PTR eax>=ycentre
											      inc nright
											      sub (OBJECT PTR [esi]).rystartarc,edx
											      sub (OBJECT PTR [esi]).rystartarc,edx
										      .ELSE
											      inc nleft
										      .ENDIF
										      ;end handle, y...
										      mov eax,(OBJECT PTR [esi]).ytopleft
										      add eax,(OBJECT PTR [esi]).ryendarc ;make absolute.
										      .IF SDWORD PTR eax>=ycentre
											      inc nright
											      sub (OBJECT PTR [esi]).ryendarc,edx
											      sub (OBJECT PTR [esi]).ryendarc,edx
										      .ELSE
											      inc nleft
										      .ENDIF
										    .ENDIF
										
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  add eax,(OBJECT PTR [esi]).height
										  .IF SDWORD PTR eax>=ycentre
											inc nright
											sub (OBJECT PTR [esi]).height,edx
											sub (OBJECT PTR [esi]).height,edx
										  .ELSE
											inc nleft
										  .ENDIF
										  add (OBJECT PTR [esi]).ytopleft,edx
										.ENDIF
										mov eax,(OBJECT PTR [esi]).ytopleft
										mov ecx,(OBJECT PTR [esi]).height
										shr ecx,1
										add eax,ecx
										mov (OBJECT PTR [esi]).ymid,eax
									  .ENDIF
									.ENDIF
								  .ENDIF

								  ;v1.99 if nleft and nright both non-0, it straddles
								  ;the axis. if VK_SHIFT key down, allow this, else
								  ;don't move (restore from tempelement)...
  ;mov g_errorapi,0B59h ;for crash outside EVE, error codes range A00h-BFFh. v3.23
								  invoke GetAsyncKeyState,VK_SHIFT
								  .IF SWORD PTR ax<0	  ;bit15=1 if key down.
									;element will stretch even when straddling axis.
								  .ELSE
									;for element alignment, when reach axis it will stop...
									.IF nleft != 0
									  .IF nright != 0
										  ;copy tempelement back...
										  push esi
										  mov ecx,sizeobj
										  lea ebx,tempelement
xyup1:									  mov al,[ebx]
										  mov [esi],al
										  inc ebx
										  inc esi
										  loop xyup1
										  pop esi
										;set "stopped" flag for this element, and all
										;elements of comp-obj if this is part of a comp-obj...
										invoke stoppedbit2hi,esi
										;note, stopped flags get clrd by this same func,
										;called from wmlbuttondown()/state2 and
										;wmrbuttondown()/state2.
									  .ENDIF
									.ENDIF
								  .ENDIF

						  .ENDIF
			  .ENDIF
			.ENDIF
		  .ENDIF

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
  ret
stretchhighlighted ENDP
;--------------------------------------------------------------------------
fixhighlightedlistptrs PROC STDCALL USES eax ebx ecx edx esi edi,noffset:DWORD
	LOCAL ebxsave:DWORD
;v1.98 "fixhighlightedlistptrs"
;add amount noffset to entries in highlighted list.
;this is done when database moves, such as when createnewobject().
;noffset = pTERSEDATA_new - pTERSEDATA_old.

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3

		  ;drop here, esi->element from highlighted list...
		  add esi,noffset
		  mov [edi+ebx],esi ;put it back in.

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
	ret
fixhighlightedlistptrs ENDP
;--------------------------------------------------------------------------
stoppedbit2hi PROC STDCALL USES eax ebx ecx edx esi edi,pelement:DWORD
	LOCAL ebxsave:DWORD,proot:DWORD
;v1.99 "stoppedbit2hi"
;used by stretchhighlighted() when aligning highlighted elements.
;finds the boss of pelement, then sets "stopped" flag of all elements of comp-obj,
;i.e. children of the boss. this ensures that entire comp-obj will stop moving.
;stopped flag is element.fconfig1/bit3. =1 stopped.
;if pelement==0, clear all stopped bits in highlightedlist.

;find the root owner...
	  mov proot,0
	  ;..flag to clr all stopped bits.
	  mov ebx,pelement
	  .IF ebx==0
	  .ELSE
mnz1:	mov eax,(OBJECT PTR [ebx]).rpowner1
		.IF eax == 0
		.ELSE
		  add eax,pTERSEDATA
		  .IF eax==ebx
			;it's ptg to itself...
			mov (OBJECT PTR [ebx]).rpowner1,0
			jmp SHORT mn2
		  .ENDIF
		  mov ebx,eax
		  jmp mnz1
		.ENDIF
mn2:	mov proot,ebx ;root owner.
	  .ENDIF

;go thru highlightedlist...
		mov ebx,0
fend2:	lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		;drop here, esi->element from highlighted list...

		  .IF proot==0
			;clr stopped bit...
			and (OBJECT PTR [esi]).fconfig1,0FFFFFFF7h ;clr bit3.
		  .ELSE
					;find root owner of this element...
					mov ebx,esi
nnz1:				mov eax,(OBJECT PTR [ebx]).rpowner1
					.IF eax == 0
					.ELSE
					  add eax,pTERSEDATA
						.IF eax==ebx
						  ;it's ptg to itself...
						  mov (OBJECT PTR [ebx]).rpowner1,0 ;fix.
						  jmp SHORT xmn2
						.ENDIF
					  mov ebx,eax
					  jmp nnz1
					.ENDIF
xmn2:				;...root owner in ebx
				  .IF ebx==proot
					;element has common boss to pelement...
					;i'll put a restriction in here, will only stop this element
					;if it's "Locked" flag is set (it's part of a comp.obj) or it
					;is a boss-element...
					mov eax,(OBJECT PTR [esi]).rpowner1
					.IF eax==0 ;this is a boss, or freestanding element.
goo1:				  or (OBJECT PTR [esi]).fconfig1,01000b ;set stopped bit, bit3.
					.ELSE
					  mov eax,(OBJECT PTR [esi]).fconfig4
					  and al,01000b ;bit3 =1 locked.
					  .IF al==01000b
						jmp goo1
					  .ENDIF
					.ENDIF
				  .ENDIF
		  .ENDIF

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:
	ret
stoppedbit2hi ENDP
;--------------------------------------------------------------------------
calcdatabasesize PROC STDCALL USES ebx ecx edx esi edi
	LOCAL nsizerecords:DWORD
; "calcdatabasesize"	
;calcs size of database and return in eax.

		mov esi,pTERSEDATA
		mov eax,(TERSEDATA PTR [esi]).numrecords
		mov ecx,(TERSEDATA PTR [esi]).nsizeobject
		mul ecx ;eax=size of all records.
		mov nsizerecords,eax
		  mov ebx,(TERSEDATA PTR [esi]).noffsetobjs
		  add ebx,esi ;starting address of records.
		  add ebx,eax ;end of database.
		  sub ebx,pTERSEDATA ;size of total database.
		mov eax,ebx

	ret
calcdatabasesize ENDP
;--------------------------------------------------------------------------
fliphighlighted PROC STDCALL USES ebx ecx edx esi edi,fhoriz:DWORD
	LOCAL sizeobj:DWORD,ebxsave:DWORD,exttype:DWORD
	LOCAL xcentre:DWORD,ycentre:DWORD,xchange:DWORD,ychange:DWORD
	LOCAL displacev:SDWORD,nbez:DWORD,displaceh:SDWORD
;v2.17 "fliphighlighted"
;code derived from stretchhighlighted().
;if fhoriz=1 flip all selected elements horizontally.
;if fhoriz=0 " vertically.
;bounding rectangle is in n1stx,n1sty,n2ndx,n2ndy.

		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,eax

;need to calc xcentre/ycentre, about which flipping will occur...
		mov eax,n2ndx
		sub eax,n1stx
		sar eax,1	 ;should be +ve i think.
		add eax,n1stx
		mov xcentre,eax
		mov eax,n2ndy
		sub eax,n1sty
		sar eax,1
		add eax,n1sty
		mov ycentre,eax


;go thru highlightedlist...
		mov ebx,0
fend2:
		lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...

		  mov eax,(OBJECT PTR [esi]).fstatus
		  and al,01
		  .IF al==01	;bit0=1, valid object. precaution.
			mov eax,(OBJECT PTR [esi]).nexttype
			.IF SWORD PTR ax<0 ;data/invisible object precaution.
			.ELSE

			  invoke add2updatelist,esi
			  mov eax,(OBJECT PTR [esi]).nexttype
			  mov exttype,eax

								  .IF fhoriz==1 ;flip horizontally.
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
										;we need to flip the arrow-orientations...
										neg (OBJECT PTR [esi]).xdiffnorm1st
										neg (OBJECT PTR [esi]).xdiffnorm2nd
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
nz2:								  mov eax,(OBJECT PTR [esi]).bez0x ;original x-coord.
									  mov nbez,eax
									  mov ebx,0
nz3:								  .IF ebx<(14*8) ;1st 14 points.
										mov eax,(OBJECT PTR [esi+ebx]).bez0x
										  mov edx,eax		   ;calc xchange.
										  sub edx,xcentre	   ;/
										  sal edx,1 ;double it. /
										sub (OBJECT PTR [esi+ebx]).bez0x,edx
									  .ELSE ;only polys will come here...
										mov eax,[edi+ebx-(14*8)]
										add eax,nbez ;make it absolute.
										  mov edx,eax		   ;calc xchange.
										  sub edx,xcentre	   ;/
										  sal edx,1 ;double it. /
										sub eax,edx ;apply the change.
										sub eax,(OBJECT PTR [esi]).bez0x ;make rel.to new bez0.
										mov [edi+ebx-(14*8)],eax
									  .ENDIF
									  ;...coord will jump to other side of xcentre.
									  add ebx,8 ;next bezier point.
									  loop nz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  ;mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										  mov ecx,(OBJECT PTR [esi]).ncorners
										  mov edi,(OBJECT PTR [esi]).rpdata ;attached data-element.
										  .IF edi != 0
										    add edi,pTERSEDATA ;make absolute.
										    lea eax,(OBJECT PTR [edi]).sztext
										    mov edi,eax ;start of the extra pts.
										  .ENDIF
										  jmp nz2
									  .ELSEIF exttype==33 ;text label.
										  ;angle will also require a displacement correction-factor...
										  ;mov eax,(OBJECT PTR [esi]).nfontangle ;degrees*10.
										  ;...equals radians*573.
										  mov displacev,573 ;temp usage.
										  fild (OBJECT PTR [esi]).nfontangle ;gets converted to f/p.
										  fwait
										  fidiv displacev ;convert to radians.
										  fwait
										  fsin
										  fwait
										  fimul (OBJECT PTR [esi]).widthtext
										  fwait
										  fistp displacev
										  fwait
											;also find horiz displacement... v2.22
											mov displaceh,573 ;temp usage.
											fild (OBJECT PTR [esi]).nfontangle ;gets converted to f/p.
											fwait
											fidiv displaceh ;convert to radians.
											fwait
											fcos
											fwait
											fimul (OBJECT PTR [esi]).widthtext
											fwait
											fistp displaceh
											fwait
											;  ;BUG...this seems to have bit31 set.
											;  ;mov eax,(OBJECT PTR [esi]).nfontangle
											;  mov eax,displaceh
											;  ;.IF SDWORD PTR eax>=0
											;	 and eax,0FFFFh
											;  ;.ENDIF
											;  ;also a precaution, want it always +ve...
											;  .IF SWORD PTR ax<0
											;	 neg ax
											;  .ENDIF
											;  mov displaceh,eax

										  ;flip angle of text...
										  neg (OBJECT PTR [esi]).nfontangle
										  mov eax,(OBJECT PTR [esi]).xmid ;xtopleft
										  add eax,(OBJECT PTR [esi]).xlabeloffset ;see paint_label().
										  add eax,6								;/
										  mov edx,eax		   ;calc xchange.
										  sub edx,xcentre	   ;/
										  sal edx,1 ;double it. /
										  sub (OBJECT PTR [esi]).xtopleft,edx
										  mov eax,displaceh ;v2.22 mov eax,(OBJECT PTR [esi]).widthtext
										  sub (OBJECT PTR [esi]).xtopleft,eax
										  ;...so entire rect/ellipse jumps across xcentre.
										  ;now correct for vertical position if text on an angle...
										  mov eax,displacev
										  sub (OBJECT PTR [esi]).ytopleft,eax
										  ;fix xmid/ymid of handle...
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  mov ecx,(OBJECT PTR [esi]).wwidth
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).xmid,eax
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  mov ecx,(OBJECT PTR [esi]).height
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).ymid,eax
									  .ELSE
										  ;all other types...
										  ;flip ring-offset. ellipse can have this, maybe rect. etc
										  ;in future...
										  neg (OBJECT PTR [esi]).xdeltacentre
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  mov edx,eax		   ;calc xchange.
										  sub edx,xcentre	   ;/
										  sal edx,1 ;double it. /
										  sub (OBJECT PTR [esi]).xtopleft,edx
										  mov eax,(OBJECT PTR [esi]).wwidth
										  sub (OBJECT PTR [esi]).xtopleft,eax
										  ;...so entire rect/ellipse jumps across xcentre.
										  
										    ;v2.97
										    ;problem with partial ellipse, is it must flip also...
										    mov eax,(OBJECT PTR [esi]).nexttype
										    .IF eax==0 ;ellipse, all types.
										      mov eax,(OBJECT PTR [esi]).wwidth
										      mov ecx,eax
										      sub eax,(OBJECT PTR [esi]).rxstartarc
										      sub ecx,(OBJECT PTR [esi]).rxendarc
										      mov (OBJECT PTR [esi]).rxstartarc,ecx ;swap over.
										      mov (OBJECT PTR [esi]).rxendarc,eax   ;/
										      ;and swap the y...
										      mov eax,(OBJECT PTR [esi]).rystartarc
										      mov ecx,(OBJECT PTR [esi]).ryendarc
										      mov (OBJECT PTR [esi]).rystartarc,ecx
										      mov (OBJECT PTR [esi]).ryendarc,eax
										    .ENDIF
										    
										  ;fix xmid...
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  mov ecx,(OBJECT PTR [esi]).wwidth
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).xmid,eax
									  .ENDIF
									.ENDIF

								  .ELSEIF fhoriz==0 ;flip vertically.
									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
										;we need to flip the arrow-orientations...
										neg (OBJECT PTR [esi]).ydiffnorm1st
										neg (OBJECT PTR [esi]).ydiffnorm2nd
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
xnz2:								  mov eax,(OBJECT PTR [esi]).bez0y ;original y-coord.
									  mov nbez,eax
									  mov ebx,0
xnz3:								   .IF ebx<(14*8) ;1st 14 points.
										mov eax,(OBJECT PTR [esi+ebx]).bez0y
										  mov edx,eax		   ;calc xchange.
										  sub edx,ycentre	   ;/
										  sal edx,1 ;double it. /
										sub (OBJECT PTR [esi+ebx]).bez0y,edx
									  .ELSE ;only big polys will come here...
										mov eax,[edi+ebx-(14*8)]
										add eax,nbez ;make it absolute.
										  mov edx,eax		   ;calc xchange.
										  sub edx,ycentre	   ;/
										  sal edx,1 ;double it. /
										sub eax,edx ;apply the change.
										sub eax,(OBJECT PTR [esi]).bez0y ;make rel.to new bez0.
										mov [edi+ebx-(14*8)],eax
									  .ENDIF
									  ;...coord will jump to other side of xcentre.
									  add ebx,8 ;next bezier point.
									  loop xnz3
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  ;mov ecx,NCORNERSMAX14 ;# vertices =14 for polygon.
										  mov ecx,(OBJECT PTR [esi]).ncorners
										  mov edi,(OBJECT PTR [esi]).rpdata ;attached data-element.
										  .IF edi != 0
										    add edi,pTERSEDATA ;make absolute.
										    lea eax,(OBJECT PTR [edi]).sztext
										    mov edi,eax ;start of the extra pts.
										    add edi,4   ;/ y.
										  .ENDIF
										  jmp xnz2

									  .ELSEIF exttype==33 ;text label.
											;v2.22
											mov displacev,573 ;temp usage.
											fild (OBJECT PTR [esi]).nfontangle ;gets converted to f/p.
											fwait
											fidiv displacev ;convert to radians.
											fwait
											fcos
											fwait
											fimul (OBJECT PTR [esi]).heighttext
											fwait
											fistp displacev
											fwait
											mov displaceh,573 ;temp usage.
											fild (OBJECT PTR [esi]).nfontangle ;gets converted to f/p.
											fwait
											fidiv displaceh ;convert to radians.
											fwait
											fsin
											fwait
											fimul (OBJECT PTR [esi]).heighttext
											fwait
											fistp displaceh
											fwait

										  ;flip angle of text...
										  neg (OBJECT PTR [esi]).nfontangle
										mov eax,(OBJECT PTR [esi]).ymid ;ytopleft
										add eax,(OBJECT PTR [esi]).ylabeloffset ;see paint_label().
										sub eax,7								;/
										  mov edx,eax		   ;calc ychange.
										  sub edx,ycentre	   ;/
										  sal edx,1 ;double it. /
										sub (OBJECT PTR [esi]).ytopleft,edx
										  mov eax,displacev ;2.22 mov eax,(OBJECT PTR [esi]).heighttext
										  sub (OBJECT PTR [esi]).ytopleft,eax
										  ;...so entire rect/ellipse jumps across ycentre.
										  mov eax,displaceh
										  add (OBJECT PTR [esi]).xtopleft,eax

										  ;fix ymid of handle...
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  mov ecx,(OBJECT PTR [esi]).height
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).ymid,eax
									  .ELSE
										;all other types...
										  ;flip ring-offset. ellipse can have this, maybe rect. etc
										  ;in future...
										  neg (OBJECT PTR [esi]).ydeltacentre
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  mov edx,eax		   ;calc ychange.
										  sub edx,ycentre	   ;/
										  sal edx,1 ;double it. /
										  sub (OBJECT PTR [esi]).ytopleft,edx
										  ;.IF SDWORD PTR eax>=ycentre
										  mov eax,(OBJECT PTR [esi]).height
										  sub (OBJECT PTR [esi]).ytopleft,eax
										  ;...so entire rect/ellipse jumps across ycentre.
										  ;.ENDIF
										  
										    ;v2.97
										    ;problem with partial ellipse, is it must flip also...
										    mov eax,(OBJECT PTR [esi]).nexttype
										    .IF eax==0 ;ellipse, all types.
										      mov eax,(OBJECT PTR [esi]).height
										      mov ecx,eax
										      sub eax,(OBJECT PTR [esi]).rystartarc
										      sub ecx,(OBJECT PTR [esi]).ryendarc
										      mov (OBJECT PTR [esi]).rystartarc,ecx ;swap over.
										      mov (OBJECT PTR [esi]).ryendarc,eax   ;/
										      ;and swap the x...
										      mov eax,(OBJECT PTR [esi]).rxstartarc
										      mov ecx,(OBJECT PTR [esi]).rxendarc
										      mov (OBJECT PTR [esi]).rxstartarc,ecx
										      mov (OBJECT PTR [esi]).rxendarc,eax
										    .ENDIF
										
										  ;fix ymid...
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  mov ecx,(OBJECT PTR [esi]).height
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).ymid,eax
									  .ENDIF
									.ENDIF
								  .ENDIF

			.ENDIF
		  .ENDIF

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:

	ret
fliphighlighted ENDP
;--------------------------------------------------------------------------

rot90hi PROC STDCALL USES ebx ecx edx esi edi
	LOCAL sizeobj:DWORD,ebxsave:DWORD,exttype:DWORD
	LOCAL xcentre:DWORD,ycentre:DWORD,xchange:DWORD,ychange:DWORD
	LOCAL varray[84]:DWORD
	LOCAL wwidth0:DWORD
;v2.21 "rot90hi"
;comes from IDM_ROT90. code derived from fliphighlighted().
;bounding rectangle is in n1stx,n1sty,n2ndx,n2ndy.

		mov ebx,pTERSEDATA
		mov eax,(TERSEDATA PTR [ebx]).nsizeobject
		mov sizeobj,eax

;need to calc xcentre/ycentre, about which rotating will occur...
		mov eax,n2ndx
		sub eax,n1stx
		sar eax,1	 ;should be +ve i think.
		add eax,n1stx
		mov xcentre,eax
		mov eax,n2ndy
		sub eax,n1sty
		sar eax,1
		add eax,n1sty
		mov ycentre,eax


;go thru highlightedlist...
		mov ebx,0
fend2:
		lea edi,highlightedlist ;start of highlightedlist.
		mov ebxsave,ebx
		mov eax,highlightedindex		;end of list.
		shl eax,1
		shl eax,1
		cmp ebx,eax
		je fend1				;get out.
		mov esi,[edi+ebx]
		or esi,esi ;cmp esi,0								;precaution.
		je fend3
		  ;drop here, esi->element from highlighted list...

		  mov eax,(OBJECT PTR [esi]).fstatus
		  and al,01
		  .IF al==01	;bit0=1, valid object. precaution.
			mov eax,(OBJECT PTR [esi]).nexttype
			.IF SWORD PTR ax<0 ;data/invisible object precaution.
			.ELSE

			  invoke add2updatelist,esi
			  mov eax,(OBJECT PTR [esi]).nexttype
			  mov exttype,eax

									mov eax,(OBJECT PTR [esi]).fconfig1
									and al,01
									.IF al==01 ;wire.
										;we need to rotate the arrow-orientations...
										mov eax,(OBJECT PTR [esi]).xdiffnorm1st
										neg eax
										mov ecx,(OBJECT PTR [esi]).ydiffnorm1st
										mov (OBJECT PTR [esi]).ydiffnorm1st,eax
										mov (OBJECT PTR [esi]).xdiffnorm1st,ecx
										mov eax,(OBJECT PTR [esi]).xdiffnorm2nd
										neg eax
										mov ecx,(OBJECT PTR [esi]).ydiffnorm2nd
										mov (OBJECT PTR [esi]).ydiffnorm2nd,eax
										mov (OBJECT PTR [esi]).xdiffnorm2nd,ecx
									  ;we want to update all the bezier points...
									  mov ecx,9 ;# bezier pts for wire.
									  lea ebx,(OBJECT PTR [esi]).bez0x ;original x-coord.
xat2:									mov eax,[ebx] ;x.
										sub eax,xcentre
										neg eax ;need this to get rotation.
										mov edx,[ebx+4] ;y
										add eax,ycentre
										mov [ebx+4],eax ;new y.
										sub edx,ycentre
										add edx,xcentre
										mov [ebx],edx	;new x.
									  add ebx,8 ;next bezier point.
									  loop xat2
									.ELSE
									  mov eax,(OBJECT PTR [esi]).nexttype
									  .IF ax==5 ;polygon/line.
										  ;all points need to have their x/y values swapped...
										  lea edx,varray
										  invoke combinepolyarrays ;get points into one array.
										  ;...uses esi-->poly element, edx-->varray.
										  mov ecx,(OBJECT PTR [esi]).ncorners
										  lea ebx,varray
at2:									mov eax,[ebx] ;x.
										  sub eax,xcentre
										  neg eax ;need this to get rotation.
										  mov edx,[ebx+4] ;y
										  add eax,ycentre
										  mov [ebx+4],eax ;new y.
										  sub edx,ycentre
										  add edx,xcentre
										  mov [ebx],edx	;new x.
										  add ebx,8
										  loop at2
										  lea edx,varray
										  invoke uncombinepolyarrays ;points back to the elements.
										  ;...uses esi-->poly element, edx-->varray.

									  .ELSEIF exttype==33 ;text label.
										  ;rotate angle...
										  mov eax,(OBJECT PTR [esi]).nfontangle
										  add eax,900 ;90 degrees*10.
										  .IF eax>=3600
										    sub eax,3600
										  .ENDIF

										  mov (OBJECT PTR [esi]).nfontangle,eax
										  ;rotate label offset...
										  mov eax,(OBJECT PTR [esi]).xlabeloffset
										  neg eax
										  mov ecx,(OBJECT PTR [esi]).ylabeloffset
										  ;mov dl,nrotquad
										  ;.IF dl==0
										  ;  sub ecx,12
										  ;.ELSEIF dl==1
										  ;  ;add eax,24
										  ;  sub ecx,12
										  ;.ELSEIF dl==2
										  ;  ;add eax,24
										  sub ecx,12
										  ;v2.63 try to fix HTML labels...
										  test (OBJECT PTR [esi]).fconfig4,800h ;bit11=1 HTML label.
										  jz nothtml
										  add ecx,(OBJECT PTR [esi]).charascent
										  sub eax,(OBJECT PTR [esi]).charascent
nothtml:										
										  ;.ELSEIF dl==3
										  ;  sub ecx,12
										  ;.ENDIF
										  mov (OBJECT PTR [esi]).ylabeloffset,eax
										  mov (OBJECT PTR [esi]).xlabeloffset,ecx
										  ;inc nrotquad
										  ;and nrotquad,011b ;use only 1st 2 bits.

										  jmp SHORT at4

									  .ELSE
										  ;all other types...
										  ;rotate ring-offset. ellipse can have this, maybe rect. etc
										  ;in future...
										  mov eax,(OBJECT PTR [esi]).xdeltacentre
										  neg eax
										  mov ecx,(OBJECT PTR [esi]).ydeltacentre
										  mov (OBJECT PTR [esi]).ydeltacentre,eax
										  mov (OBJECT PTR [esi]).xdeltacentre,ecx
at4:									;rotate top/left corner...
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  sub eax,xcentre
										  neg eax
										  add eax,ycentre
										  mov ecx,(OBJECT PTR [esi]).ytopleft
										  sub ecx,ycentre
										  add ecx,xcentre
										  mov (OBJECT PTR [esi]).ytopleft,eax
										  mov (OBJECT PTR [esi]).xtopleft,ecx
										  ;rotate shape...
										  mov eax,(OBJECT PTR [esi]).wwidth
										  mov wwidth0,eax ;save.
										  ;neg eax
										  ;...needs this to work, however my EVE code is not happy
										  ;with a -ve width or height. try this fix...
										  ;.IF SDWORD PTR eax<0
										  ;  add (OBJECT PTR [esi]).ytopleft,eax
										  ;  neg eax
										  ;.ENDIF
										  sub (OBJECT PTR [esi]).ytopleft,eax
										  ;...this works!
										  mov ecx,(OBJECT PTR [esi]).height
										  mov (OBJECT PTR [esi]).height,eax
										  mov (OBJECT PTR [esi]).wwidth,ecx
										  
										    ;v2.97
										    ;problem with partial ellipse, is it must flip also...
										    mov eax,(OBJECT PTR [esi]).nexttype
										    .IF eax==0 ;ellipse, all types.
										      mov ebx,(OBJECT PTR [esi]).rystartarc
										      mov edx,(OBJECT PTR [esi]).ryendarc
										      mov eax,wwidth0 ;(OBJECT PTR [esi]).wwidth
										      mov ecx,eax
										      sub eax,(OBJECT PTR [esi]).rxstartarc
										      sub ecx,(OBJECT PTR [esi]).rxendarc
										      mov (OBJECT PTR [esi]).ryendarc,ecx ;swap over.
										      mov (OBJECT PTR [esi]).rystartarc,eax   ;/
										      ;and swap the y...
										      mov (OBJECT PTR [esi]).rxendarc,edx
										      mov (OBJECT PTR [esi]).rxstartarc,ebx
										      ;mov eax,(OBJECT PTR [esi]).height
										      ;mov ecx,eax
										      ;sub eax,(OBJECT PTR [esi]).rystartarc
										      ;sub ecx,(OBJECT PTR [esi]).ryendarc
										      ;mov (OBJECT PTR [esi]).ryendarc,ecx ;swap over.
										      ;mov (OBJECT PTR [esi]).rystartarc,eax   ;/
										    .ENDIF
										
										  ;fix xmid/ymid...
										  mov eax,(OBJECT PTR [esi]).xtopleft
										  mov ecx,(OBJECT PTR [esi]).wwidth
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).xmid,eax
										  mov eax,(OBJECT PTR [esi]).ytopleft
										  mov ecx,(OBJECT PTR [esi]).height
										  shr ecx,1
										  add eax,ecx
										  mov (OBJECT PTR [esi]).ymid,eax
									  .ENDIF
									.ENDIF

			.ENDIF
		  .ENDIF

fend3:	mov ebx,ebxsave
		add ebx,4
		jmp fend2
fend1:

	ret
rot90hi ENDP
;--------------------------------------------------------------------------
uncombinepolyarrays PROC STDCALL
	LOCAL dummy:DWORD
	;LOCAL xvertice:SDWORD,yvertice:SDWORD
	;LOCAL psourceref:DWORD,psource:DWORD
;v2.03 "uncombinepolyarrays"
;opposite functionality to combinepolyarrays().
;uses all regs from caller. esi->element.
;enter with esi->polygon element, edx=address varray (varray[84]:SDWORD).

	push esi
	push edi
	mov edi,esi

				lea ebx,(OBJECT PTR [edi]).bez0x
				mov esi,edx
				mov ecx,NCORNERSMAX14*2 ;old polys have 14 vertices max.
g11:			mov eax,[esi]
				mov [ebx],eax
				add ebx,4
				add esi,4
				loop g11

		mov eax,(OBJECT PTR [edi]).rpdata ;rel-ptr to attached data-element (has more vertices).
		.IF eax==0 ;no more vertices.
		.ELSE
		  mov ebx,eax
		  add ebx,pTERSEDATA
		  lea eax,(OBJECT PTR [ebx]).sztext
		  mov ebx,eax
		  mov ecx,28*2 ;28 extra vertices in the data-element.
xg11:			  mov eax,[esi]
				  ;vertices are stored relative to bez0x/y...
				  mov dl,cl
				  and dl,01 ;test bit0.
				  .IF dl==0
					sub eax,(OBJECT PTR [edi]).bez0x
				  .ELSE
					sub eax,(OBJECT PTR [edi]).bez0y
				  .ENDIF
				mov [ebx],eax
				add ebx,4
				add esi,4
				loop xg11
		.ENDIF

	pop edi
	pop esi
	ret
uncombinepolyarrays ENDP
;--------------------------------------------------------------------------
hexstr2longint  PROC STDCALL USES ebx ecx edx esi edi, lpstr2:DWORD
        LOCAL nradix:BYTE
; "hexstr2longint"
;enter with address of hex ascii-string. returns binary value in eax.
                mov nradix,16
                mov  esi,lpstr2
                xor  eax,eax
p1_loop:        xor ecx,ecx
                xor ebx,ebx
                mov cl,nradix
                mov bl,[esi]                     ;Load char
                inc esi
             .IF bl>="0"
               .IF bl<="9"
                 sub bl,"0" ;convert to numeric.
                 jmp SHORT ok1
               .ELSE
                 .IF bl>="A"
                   .IF bl<="F"
                     sub bl,55 ;convert to numeric.
                     jmp SHORT ok1
                   .ELSE
                     .IF bl>="a"
                       .IF bl<="f"
                         sub bl,87 ;convert to numeric.
                         jmp SHORT ok1
                       .ENDIF
                     .ENDIF
                   .ENDIF
                 .ENDIF
               .ENDIF
             .ENDIF
             jmp SHORT p1_finish
ok1:
               mul ecx                                  ;Multiply by 16
               add eax,ebx                               ;Add in digit...
               jmp p1_loop
p1_finish:
               ret
hexstr2longint ENDP
;--------------------------------------------------------------------------
;v3.30
;new .eve file compression...
.DATA?
ALIGN 4
controlp DWORD ?
mp       DWORD ?
phashtable DWORD ?
controld BYTE  ?
controlb BYTE  ?

.CODE
lzp_compress PROC STDCALL USES ebx ecx edx esi edi,pifile:DWORD,nsizeb:DWORD,pofile:DWORD
    LOCAL endpointer:DWORD
    LOCAL literal:BYTE
; "lzp_compress"
; Method 0: LZP compression algorithm
;pifile->uncompressed source data. pofile->compressed data o/p buffer.
;nsizeb=number of bytes in source data.
;return eax=size of compressed data in "ofile" (including 5 byte header).

    invoke GlobalAlloc,GMEM_FIXED,65536*4 ;temp buffer.
    mov phashtable,eax
    
;  mov ax,ds
;  mov es,ax ;used by stos instr.

 cld                     ; clear direction flag
 mov esi,pifile           ; init pointers
 mov edi,pofile
 mov eax,nsizeb
 
 mov mp,0
 mov literal,0

 push eax                ; write header: ID0+4bfilesize => total 5 bytes
 xor eax,eax
 stosb       ;1st byte =0.
 pop eax
 stosd       ;next 4 bytes =uncompressed size of database.
             ;(note, I also save this at end of file, -24 offset, in 28-byte appendage)
             
 pushad                   ; fill hash table
 mov eax,pifile           ;*HUH?* filling hashtable with addr of data!!!
 mov edi,phashtable
 mov ecx,65536
 rep stosd
 popad

 add eax,esi              ; calculate endpointer
 mov endpointer,eax       ;end of ifile (uncompressed source data).

 movsw                    ; copy three bytes
 movsb

 mov controlp,edi
 inc edi
 mov controld,0 ;byte
 mov controlb,0 ;byte

c_loop:
 cmp endpointer,esi  ; check end of uncompressed data.
 ja  c_loop_ok
 jmp finish_c_loop

c_loop_ok:
 call chash
 call compare
 jz   two_match_c

 lodsb
 mov literal,al
 call chash
 call compare
 jz   lit_match_c

 mov  al,0
 call putbit
 mov  al,literal
 stosb
 movsb
 jmp  end_c_loop

lit_match_c:
 mov al,1
 call putbit
 mov al,0
 call putbit
 mov al,literal
 stosb
 jmp encode_match

two_match_c:
 mov al,1
 call putbit
 call putbit

encode_match:
 call incpos
 call compare
 jz one_c
 mov al,0
 call putbit
 jmp end_c_loop

one_c:

 call incpos
 mov  al,1
 call putbit

 call compare
 jnz ec1
 call incpos
 call compare
 jnz ec2
 call incpos
 call compare
 jnz ec3
 call incpos
 mov al,1
 call putbit
 call putbit
 call compare
 jnz ec4
 call incpos
 call compare
 jnz ec5
 call incpos
 call compare
 jnz ec6
 call incpos
 call compare
 jnz ec7
 call incpos
 call compare
 jnz ec8
 call incpos
 call compare
 jnz ec9
 call incpos
 call compare
 jnz ec10
 call incpos

 mov al,1
 call putbit
 call putbit
 call putbit
 xor  ecx,ecx

match_loop_c:
 cmp  esi,endpointer
 jae   out_match_loop_c
 call compare
 jnz  out_match_loop_c
 inc  ecx
 call incpos
 jmp  match_loop_c

out_match_loop_c:

 mov al,0FFh
out_lg:
 cmp ecx,255
 jb  out_lg_out
 stosb
 sub ecx,255
 jmp out_lg
 out_lg_out:
 mov al,cl
 stosb
 jmp end_c_loop

ec10:
 mov al,1
 call putbit
 call putbit
 mov al,0
 call putbit
 jmp end_c_loop

ec9:
 mov al,1
 call putbit
 mov al,0
 call putbit
 mov al,1
 call putbit
 jmp end_c_loop

ec8:
 mov al,1
 call putbit
 mov al,0
 call putbit
 call putbit
 jmp end_c_loop

ec7:
 mov al,0
 call putbit
 mov al,1
 call putbit
 call putbit
 jmp end_c_loop

ec6:
 mov al,0
 call putbit
 mov al,1
 call putbit
 mov al,0
 call putbit
 jmp end_c_loop

ec5:
 mov al,0
 call putbit
 call putbit
 mov al,1
 call putbit
 jmp end_c_loop

ec4:
 mov al,0
 call putbit
 call putbit
 call putbit
 jmp end_c_loop

ec3:
 mov al,1
 call putbit
 mov al,0
 call putbit
 jmp end_c_loop

ec2:
 mov al,0
 call putbit
 mov al,1
 call putbit
 jmp end_c_loop

ec1:
 mov al,0
 call putbit
 call putbit

end_c_loop:
 jmp c_loop

finish_c_loop:

 mov eax,controlp ; store last tagbyte
 mov bl,controld
 mov [eax],bl

    ;destroy temp buffer...
		invoke GlobalHandle,phashtable
		invoke GlobalFree,eax
		
 sub edi,pofile ; calculate dump size
 mov eax,edi ;mov edx,edi
    ret
lzp_compress ENDP
;--------------------------------------------------------------------------
chash PROC
;calculate hash -> mp -> fill position
;called by lzp_compress().
 pushad
 xor  eax,eax
 mov  al,[esi-1]
 mov  ah,[esi-2]
 shl  eax,2
 add  eax,phashtable
 mov  edx,[eax]
 mov  mp,edx
 mov  [eax],esi
 popad
 ret
chash ENDP
;--------------------------------------------------------------------------
compare PROC
;compare:                      ; compare [mp] with [cpos]
;called by lzp_compress().
 push edi
 push esi
 mov  edi,mp
 cmpsb
 pop  esi
 pop  edi
 ret
compare ENDP
;--------------------------------------------------------------------------
putbit PROC
;putbit:                  ; bit -> byte tag, AL holds bit for output
;called by lzp_compress().
 pushad
 mov cl,controlb ;byte [controlb]
 shl al,cl
 mov bl,controld ;byte [controld]
 or  bl,al
 mov controld,bl ;byte [controld],bl
 inc cl
 cmp cl,8
 jnz just_increment
 mov controlb,0 ;byte [controlb],0
 mov controld,0 ;byte [controld],0
 push edi
 mov  edi,controlp ; dword [controlp]
 mov  al,bl
 stosb
 pop  edi
 mov controlp,edi ;dword [controlp],edi
 popad
 inc edi
 ret
just_increment:
 mov controlb,cl ;byte [controlb],cl
 popad
 ret
putbit ENDP
;--------------------------------------------------------------------------
incpos PROC
;called from lzp_compress().
 inc  mp
 inc  esi
 ret
incpos ENDP
;--------------------------------------------------------------------------
lzp_decompress PROC STDCALL USES ebx ecx edx esi edi,pifile:DWORD,pofile:DWORD
    LOCAL endpointer:DWORD
; LZP decompression algorithm
;pifile->destination uncompressed data !!!
;pofile->source compressed data !!!
;returns eax=size of uncompressed data.

    invoke GlobalAlloc,GMEM_FIXED,65536*4 ;temp buffer.
    mov phashtable,eax

;    mov ax,ds
;    mov es,ax ;used by stos instr.
    
 cld

 mov edi,pifile
 ;mov esi,ofile+1
 mov esi,pofile ;first byte in source file is zero, next 4 bytes=uncompressed size.
 inc esi

 pushad                   ; fill hash table
 mov eax,pifile ;note, it is filled with same address --this is correct!
 mov edi,phashtable ;lea edi,hashtable
 mov ecx,65536
 rep stosd
 popad

 lodsd ;reads uncompressed size of database to eax. (4 bytes)

 mov ebx,edi
 add ebx,eax
 mov endpointer,ebx

 movsw
 movsb

 lodsb
 mov controld,al
 mov controlb,0

d_loop:
 cmp endpointer,edi
 ja d_loop_ok
 jmp finish_d_loop
d_loop_ok:

 call getbit
 cmp  al,0
 jnz  match_d
 call dhash
 movsb
 call dhash
 movsb
 jmp end_d_loop

match_d:

 call getbit
 cmp  al,0
 jnz  no_literal_before_match
 call dhash
 movsb
no_literal_before_match:

 call dhash
 mov ecx,1
 call copymatch

 call getbit
 cmp  al,0
 jz   end_d_loop
 mov  ecx,1
 call copymatch
 call getbit
 cmp  al,0
 jz   dc2
 mov  ecx,2
 call copymatch
 call getbit
 cmp  al,0
 jz   end_d_loop
 mov  ecx,1
 call copymatch
 call getbit
 cmp  al,0
 jz   dc4
 mov  ecx,4
 call copymatch
 call getbit
 cmp  al,0
 jz   dc5
 call getbit
 cmp  al,0
 jz   dc6
 mov  ecx,3
 call copymatch

do:
 lodsb
 xor  ecx,ecx
 mov  cl,al
 call copymatch
 cmp  al,0FFh
 jnz  end_do
 jmp do
end_do:
 jmp end_d_loop

dc6:
 mov ecx,2
 call copymatch
 jmp  end_d_loop

dc5:
 call getbit
 cmp  al,0
 jz   ndc5
 mov  ecx,1
 call copymatch
ndc5:
 jmp  end_d_loop

dc4:
 call getbit
 cmp  al,0
 jz   ndc4
 call getbit
 mov  ecx,3
 cmp  al,1
 jz   ndcc4
 dec  ecx
ndcc4:
 call copymatch
 jmp  end_d_loop
ndc4:
 call getbit
 cmp  al,0
 jz   ndccc4
 mov  ecx,1
 call copymatch
ndccc4:
 jmp  end_d_loop

dc2:
 call getbit
 cmp al,0
 jz  ndc2
 mov ecx,1
 call copymatch
ndc2:

end_d_loop:
 jmp d_loop
finish_d_loop:

    ;destroy temp buffer...
		invoke GlobalHandle,phashtable
		invoke GlobalFree,eax
		
 ;mov edx, dword [ofile+1]
 mov esi,pofile
 inc esi
 mov eax,[esi]
 
   ret
lzp_decompress ENDP
;--------------------------------------------------------------------------
getbit PROC                       ; tag byte -> bit, AL holds input
;called by lzp_uncompress().
 push ecx
 mov al,controld
 mov cl,controlb
 shr al,cl
 and al,1
 inc cl
 cmp cl,8
 jnz just_increment_d
 mov controlb,0
 push eax
 lodsb
 mov controld,al
 pop  eax
 pop  ecx
 ret
just_increment_d:
 mov controlb,cl
 pop ecx
 ret
getbit ENDP
;--------------------------------------------------------------------------
dhash PROC                        ; calculate hash -> mp -> fill position
 pusha
 xor  eax,eax
 mov  al,[edi-1]
 mov  ah,[edi-2]
 shl  eax,2
 add  eax,phashtable
 mov  edx,[eax]
 mov  mp,edx
 mov  [eax],edi
 popa
 ret
dhash ENDP
;--------------------------------------------------------------------------
copymatch PROC                    ; ECX bytes from [mp] to [rp]
 push esi
 mov  esi,mp
 rep  movsb
 mov  mp,esi
 pop  esi
 ret
copymatch ENDP
;--------------------------------------------------------------------------
;v3.31...
painthandle PROC STDCALL USES eax ebx ecx edx esi edi,hdc:DWORD,xmiddle:DWORD,ymiddle:DWORD,fmode:DWORD
    LOCAL hbrushold:DWORD,hpenold:DWORD
    LOCAL radiusdiag:DWORD
; "painthandle"
;reads tersedata.nhandleradius, which is radius of handle in pixels (if =0, change
;to 2).
;fmode =1 red fill g_hbrushred, black pen 1-pixel wide g_hpendefault.
;fmode =2 light purple fill g_hbrushpurple, black pen g_hpendefault.
;if g_fredrawdiag==WIPEOUTobjs don't select any fill/pen.

    mov edi,pTERSEDATA
    mov eax,(TERSEDATA PTR [edi]).nhandleradius
      .IF eax==0 ;for old diagrams.
        mov eax,2
        mov (TERSEDATA PTR [edi]).nhandleradius,eax
      .ENDIF
    mov ecx,(TERSEDATA PTR [edi]).nzoom
        .IF SBYTE PTR cl<0  ;zoomed in.
				  neg cl
				  shr eax,cl ;make radius smaller if zoomed in.
				  inc eax ;make it slightly bigger (also avoids zero).
				.ELSEIF SBYTE PTR cl>0 ;zoomed out.
				  shl eax,1 ;limit how big handle allowed to grow.
				.ENDIF
				mov radiusdiag,eax
				
    .IF g_fredrawdiag==WIPEOUTobjs
    .ELSE
		  invoke SelectObject,hdc,g_hpendefault ;1-pixel thick, black.
		  mov hpenold,eax
      .IF fmode==2 ;handles of polys when dragging wire end near.
			  invoke SelectObject,hdc,g_hbrushpurple
			  mov hbrushold,eax
      .ELSE
			  invoke SelectObject,hdc,g_hbrushred
			  mov hbrushold,eax
      .ENDIF
    .ENDIF
    
    mov eax,xmiddle
    mov ebx,ymiddle
    mov ecx,eax
    mov edx,ebx
    sub eax,radiusdiag
    sub ebx,radiusdiag
    add ecx,radiusdiag
    add edx,radiusdiag
    invoke Ellipse,hdc,eax,ebx,ecx,edx

    .IF g_fredrawdiag==WIPEOUTobjs
    .ELSE
		  invoke SelectObject,hdc,hbrushold
		  invoke SelectObject,hdc,hpenold
    .ENDIF

    ret
painthandle ENDP
;--------------------------------------------------------------------------
;v3.31..
onhandle PROC STDCALL USES ebx ecx edx esi edi,xmiddle:DWORD,ymiddle:DWORD,nmousex:DWORD,nmousey:DWORD
    LOCAL radiusdiag:DWORD
; "onhandle"
;called by on_() methods.
;test if mouse ptr on a handle, return eax=0 no, =1 yes.

    mov edi,pTERSEDATA
    mov eax,(TERSEDATA PTR [edi]).nhandleradius
      .IF eax==0 ;for old diagrams.
        mov eax,2
        mov (TERSEDATA PTR [edi]).nhandleradius,eax
      .ENDIF
		  inc eax ;need a slightly bigger capture zone.
		  inc eax ;/
        mov ecx,(TERSEDATA PTR [edi]).nzoom
        .IF SBYTE PTR cl<0  ;zoomed in.
				  neg cl
				  shr eax,cl ;make radius smaller if zoomed in.
				  inc eax ;make it slightly bigger (also avoids zero).
				.ELSEIF SBYTE PTR cl>0 ;zoomed out.
				  shl eax,1 ;limit how big handle allowed to grow.
				.ENDIF
				mov radiusdiag,eax

    mov eax,xmiddle
    mov ecx,eax
    sub eax,radiusdiag
    add ecx,radiusdiag
    .IF SDWORD PTR nmousex>=eax
      .IF SDWORD PTR nmousex<=ecx
        mov eax,ymiddle
        mov ecx,eax
        sub eax,radiusdiag
        add ecx,radiusdiag
        .IF SDWORD PTR nmousey>=eax
          .IF SDWORD PTR nmousey<=ecx
            ;mouse inside handle!
            mov eax,1
            jmp SHORT out1
          .ENDIF
        .ENDIF
      .ENDIF
    .ENDIF
    ;fail...
    xor eax,eax				
out1:
    ret
onhandle ENDP
;--------------------------------------------------------------------------
;v1.51 more code in here...
IFE fDEVELOPER
ELSE
  ;mov g_errorapi,0BFFh ;for crash outside EVE, error codes range A00h-BFFh. v3.23
  ;...normally placed just before an api call. BFF means anywhere in eve2.asm
INCLUDE eve2.asm
ENDIF
;------------------------------------------------------------------------


end start

